c --------------------------------------------------------------------
      real*8 function LQ_GGB(s,t1,ms1)

      implicit none 

      real*8 Pi,Nc,Co,Ck,alphas,fac 
      real*8 s,t1,u1,ms1 

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Co = 24.D0
      Ck = 8.D0/3.D0
      alphas = 1.D0

      u1 = - s - t1 

      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)
      
      LQ_GGB =
     +  + Co*Pi**2*alphas**2 * ( 128*ms1**2*s**(-3) - 64*ms1**2*s**(-1)
     +    *t1**(-1)*u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 
     +    64*ms1**4*t1**(-2)*u1**(-2) - 64*s**(-4)*t1*u1 + 32*s**(-2) )
      LQ_GGB = LQ_GGB + Ck*Pi**2*alphas**2 *(64*ms1**2*s**(-1)*t1**(-1)
     +    *u1**(-1) - 64*ms1**4*t1**(-2)*u1**(-2) - 32*s**(-2) )

      LQ_GGB = fac * LQ_GGB 

      end

c --------------------------------------------------------------------
      real*8 function LQ_GG1(s,t1,ms1,mu)

      implicit none 

      real*8 Pi,Nc,Nf,alphas 
      real*8 s,t1,u1,ms1,sca,mu 
      real*8 conalp,consof,LQ_GGB
      real*8 P1,P2

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Nf = 6.D0
      alphas = 1.D0
      
      sca = (mu/ms1)**2

      u1 = - s - t1 

      P1 = -2.D0 * Nc * log(-t1/ms1**2)
     &     + ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0) )/2.D0
      P2 = -2.D0 * Nc * log(-u1/ms1**2)
     &     + ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0) )/2.D0

      consof = -alphas/2.D0/Pi * LQ_GGB(s,t1,ms1)
     &         * ( P1 + P2 ) * log(sca) 

      conalp = alphas/2.D0/Pi * LQ_GGB(s,t1,ms1)
     &       * ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0)) * log(sca)

      LQ_GG1 = conalp + consof 

      end


c --------------------------------------------------------------------
      real*8 function LQ_GG2(s,t1,s4,ms1,del,s4max,mu)

      implicit none 

      real*8 Pi,Nc,alphas
      real*8 s,t1,s4,del,s4max,ms1,sca,mu
      real*8 dldel1,LQ_GGB
      real*8 P1

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      alphas = 1.D0

      sca = (mu/ms1)**2

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 

      P1 = 2.D0*Nc*dldel1 

      LQ_GG2 = -alphas/Pi*LQ_GGB(s,t1,ms1)*P1 * log(sca)

      end

c --------------------------------------------------------------------
      real*8 function LQ_GG3(s,t1,s4,ms1,mu)

      implicit none 

      real*8 Pi,Nc,Co,Ck,alphas,fac 
      real*8 s,t1,u1,s4,ms1,sca,mu 
      real*8 COLO1(9)

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      alphas = 1.D0

      sca = (mu/ms1)**2

      u1 = s4 - s - t1 

      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /(Nc**2-1.D0)**2
      
      COLO1(9) = -log(sca)

      LQ_GG3 = 0.D0
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-4)*t1**(-2)*u1**2 - 4096*ms1**2*s**(-4)*t1*s4**(-1) + 
     +    2048*ms1**2*s**(-4)*t1**2*u1**(-2) + 4096*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 6144*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 2048*ms1**2*s**(-3)*t1**(-2)*u1 - 14336*
     +    ms1**2*s**(-3)*t1**(-1) - 2048*ms1**2*s**(-3)*t1*u1**(-2) + 
     +    4096*ms1**2*s**(-3)*t1*s4**(-2) - 4096*ms1**2*s**(-3)*t1**2*
     +    u1**(-3) - 14336*ms1**2*s**(-3)*u1**(-1) + 6144*ms1**2*
     +    s**(-3)*s4**(-1) - 8192*ms1**2*s**(-2)*t1**(-3)*u1 - 4096*
     +    ms1**2*s**(-2)*t1**(-2)*s4*(s+u1)**(-1) + 1024*ms1**2*s**(-2)
     +    *t1**(-2)*s4**2*(s+u1)**(-2) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 16384*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1) + 8192*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 8192*
     +    ms1**2*s**(-2)*t1*u1**(-3) - 4096*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*u1**(-2)*s4**2*(s+t1)**(-2) + 8192*ms1**2*s**(-2)*
     +    u1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*s4**(-2) - 6144*
     +    ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**2*(s+t1)**(-2) + 4096*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 6144*ms1**2*s**(-1)*u1**(-3) - 2048*
     +    ms1**2*t1**(-3)*u1**(-1) - 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    4096*ms1**4*s**(-3)*t1**(-3)*u1 - 12288*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*t1*u1**(-3) - 12288*
     +    ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 8192*ms1**4*s**(-3)*
     +    s4**(-2) + 4096*ms1**4*s**(-2)*t1**(-4)*u1 + 2048*ms1**4*
     +    s**(-2)*t1**(-3)*s4*(s+u1)**(-1) - 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 8192*ms1**4*s**(-2)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 4096*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2) - 16384*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 
     +    4096*ms1**4*s**(-2)*t1*u1**(-4) + 2048*ms1**4*s**(-2)*
     +    u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*s**(-2)*u1**(-3) + 
     +    2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 8192*ms1**4*s**(-1)*t1**(-4) + 6144*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1) + 4096*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-2) - 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*
     +    s4**(-1) + 6144*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3) - 2048*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*
     +    ms1**4*s*t1**(-2)*u1**(-4) + 6144*ms1**4*t1**(-4)*u1**(-1) - 
     +    2048*ms1**4*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 2048*ms1**4*
     +    t1**(-3)*u1**(-2)*s4**2*(s+u1)**(-2) + 2048*ms1**4*t1**(-3)*
     +    u1**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 
     +    2048*ms1**4*t1**(-2)*u1**(-3)*s4**2*(s+t1)**(-2) + 2048*
     +    ms1**4*t1**(-2)*u1**(-3) + 6144*ms1**4*t1**(-1)*u1**(-4) - 
     +    4096*ms1**6*s**(-2)*t1**(-4)*s4*(s+u1)**(-1) + 2048*ms1**6*
     +    s**(-2)*t1**(-4)*s4**2*(s+u1)**(-2) + 6144*ms1**6*s**(-2)*
     +    t1**(-4) + 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1) + 4096*
     +    ms1**6*s**(-2)*t1**(-2)*u1**(-2) - 8192*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( -4096*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-3) - 8192*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2)*s4**(-1) - 4096*ms1**6*s**(-2)*u1**(-4)*s4*
     +    (s+t1)**(-1) + 2048*ms1**6*s**(-2)*u1**(-4)*s4**2*
     +    (s+t1)**(-2) + 6144*ms1**6*s**(-2)*u1**(-4) + 4096*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*t1**(-4)*
     +    u1**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2) + 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*
     +    u1**(-4) + 2048*ms1**6*t1**(-4)*u1**(-2) + 2048*ms1**6*
     +    t1**(-2)*u1**(-4) + 2048*s**(-4)*t1**(-2)*u1**3 + 2048*
     +    s**(-4)*t1**(-1)*u1**2 + 2048*s**(-4)*t1 + 2048*s**(-4)*t1**2
     +    *u1**(-1) + 4096*s**(-4)*t1**2*s4**(-1) + 2048*s**(-4)*t1**3*
     +    u1**(-2) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * (6144*s**(-4)*
     +    u1 + 4096*s**(-3)*t1**(-2)*u1**2 + 4096*s**(-3)*t1*s4**(-1)
     +     + 4096*s**(-3)*t1**2*u1**(-2) + 3072*s**(-2)*t1**(-2)*u1 + 
     +    2048*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) - 1024*s**(-2)*t1**(-1)
     +    *s4*(s+u1)**(-1) + 1024*s**(-2)*t1**(-1)*s4**2*(s+u1)**(-2)
     +     - 1024*s**(-2)*t1**(-1) + 3072*s**(-2)*t1*u1**(-2) - 1024*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 2048*s**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 
     +    1024*s**(-2)*u1**(-1) + 2048*s**(-2)*s4**(-1) + 1024*s**(-1)*
     +    t1**(-2) + 1024*s**(-1)*u1**(-2) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-2)*t1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*s**(-2)*
     +    t1**(-2)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-2)*t1**(-2) + 
     +    4096*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 4096*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 1024*ms1**2*s**(-2)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**2*s**(-2)*u1**(-2) - 4096*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 2048*ms1**2*s**(-2)*s4**(-2) + 
     +    2048*ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1) - 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2) + 2048*
     +    ms1**2*s**(-1)*u1**(-3) + 2048*ms1**2*t1**(-3)*u1**(-1) + 
     +    2048*ms1**2*t1**(-1)*u1**(-3) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**4
     +    *s**(-2)*t1**(-3)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) - 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-2) - 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    2048*ms1**4*s**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-2)*u1**(-3) - 2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 
     +    4096*ms1**4*s**(-2)*u1**(-1)*s4**(-2) - 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) + 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1) - 4096*ms1**4*s**(-1)*t1**(-2)*u1**(-2) + 
     +    2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) - 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4**2*(s+t1)**(-2) + 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3) + 2048*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**(-1) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**4
     +    *s*t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048
     +    *ms1**4*t1**(-4)*u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2)*s4**2*
     +    (s+u1)**(-2) - 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*t1**(-2)*
     +    u1**(-3)*s4**2*(s+t1)**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)
     +     - 2048*ms1**4*t1**(-1)*u1**(-4) + 4096*ms1**6*s**(-2)*
     +    t1**(-4)*s4*(s+u1)**(-1) - 2048*ms1**6*s**(-2)*t1**(-4)*s4**2
     +    *(s+u1)**(-2) - 2048*ms1**6*s**(-2)*t1**(-4) - 4096*ms1**6*
     +    s**(-2)*t1**(-2)*u1**(-2) + 12288*ms1**6*s**(-2)*t1**(-2)*
     +    u1**(-1)*s4**(-1) - 4096*ms1**6*s**(-2)*t1**(-2)*s4**(-2) + 
     +    12288*ms1**6*s**(-2)*t1**(-1)*u1**(-2)*s4**(-1) - 8192*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 4096*ms1**6*s**(-2)*
     +    u1**(-4)*s4*(s+t1)**(-1) - 2048*ms1**6*s**(-2)*u1**(-4)*s4**2
     +    *(s+t1)**(-2) )
      LQ_GG3 = LQ_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**6
     +    *s**(-2)*u1**(-4) - 4096*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 
     +    4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 4096*
     +    ms1**6*s**(-1)*t1**(-3)*u1**(-2) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3) + 4096*ms1**6*s**(-1)*t1**(-2)*u1**(-2)*
     +    s4**(-1) - 2048*ms1**6*t1**(-4)*u1**(-2) - 2048*ms1**6*
     +    t1**(-2)*u1**(-4) - 1024*s**(-2)*t1**(-2)*u1 + 1024*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) - 1024*s**(-2)*t1**(-1)*s4**2*
     +    (s+u1)**(-2) - 1024*s**(-2)*t1**(-1) - 1024*s**(-2)*t1*
     +    u1**(-2) + 1024*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 1024*
     +    s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 1024*s**(-2)*u1**(-1)
     +     - 2048*s**(-2)*s4**(-1) - 1024*s**(-1)*t1**(-2) - 1024*
     +    s**(-1)*u1**(-2) )

      LQ_GG3 = fac * LQ_GG3

      end

c --------------------------------------------------------------------
      real*8 function LQ_GGD(s,t1,s4,ms1,del,s4max)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,alphas,fac 
      real*8 s,t1,u1,ms1,s4,del,s4max,t,u
      real*8 xw,COLO1(9),dldel1,dldel2 
      real*8 m2(5)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      alphas = 1.D0

      u1 = - s - t1 
      t = t1 + ms1**2 
      u = u1 + ms1**2 
      xw = sqrt(1.D0-4.D0*ms1**2/s)

      m2(1) = s 
      m2(2) = t1 
      m2(3) = u1 
      m2(4) = s4
      m2(5) = ms1**2 

      call LOGAS_LQ(m2,COLO1)

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 
      dldel2 = log(s4max/ms1**2)**2 
     &       - 2.D0* ( s4max - del )/s4 * log(s4/ms1**2)

      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)
      
      LQ_GGD =
     +  + Nc*Co*Pi*alphas**3*dldel1 * ( 40*ms1**2*s**(-3)*t**(-1)*t1 - 
     +    40*ms1**2*s**(-3)*u**(-1)*t1 - 180*ms1**2*s**(-3) + 100*
     +    ms1**2*s**(-2)*t**(-1) + 60*ms1**2*s**(-2)*u**(-1) - 130*
     +    ms1**2*s**(-2)*t1**(-1) - 130*ms1**2*s**(-2)*u1**(-1) + 32*
     +    ms1**2*s**(-1)*t**(-1)*t1**(-1) + 32*ms1**2*s**(-1)*u**(-1)*
     +    u1**(-1) - 22*ms1**2*s**(-1)*t1**(-2) - 22*ms1**2*s**(-1)*
     +    u1**(-2) + 34*ms1**4*s**(-3)*t**(-1) + 34*ms1**4*s**(-3)*
     +    u**(-1) - 8*ms1**4*s**(-3)*t1**(-1) - 8*ms1**4*s**(-3)*
     +    u1**(-1) + 98*ms1**4*s**(-2)*t**(-1)*t1**(-1) + 98*ms1**4*
     +    s**(-2)*u**(-1)*u1**(-1) - 96*ms1**4*s**(-2)*t1**(-2) - 96*
     +    ms1**4*s**(-2)*u1**(-2) + 34*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     +     + 34*ms1**4*s**(-1)*u**(-1)*u1**(-2) - 12*ms1**4*s**(-1)*
     +    t1**(-3) - 12*ms1**4*s**(-1)*u1**(-3) + 8*ms1**6*s**(-3)*
     +    t**(-1)*t1**(-1) + 8*ms1**6*s**(-3)*u**(-1)*u1**(-1) + 32*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-2) + 32*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) )
      LQ_GGD = LQ_GGD + Nc*Co*Pi*alphas**3*dldel1 * (12*ms1**6*s**(-1)*
     +    t**(-1)*t1**(-3) + 12*ms1**6*s**(-1)*u**(-1)*u1**(-3) - 64*
     +    s**(-4)*t1**2 + 14*s**(-3)*t**(-1)*t1**2 + 14*s**(-3)*u**(-1)
     +    *t1**2 - 64*s**(-3)*t1 + 34*s**(-2)*t**(-1)*t1 - 6*s**(-2)*
     +    u**(-1)*t1 - 86*s**(-2) + 10*s**(-1)*t**(-1) - 10*s**(-1)*
     +    u**(-1) - 10*s**(-1)*t1**(-1) - 10*s**(-1)*u1**(-1) )
      LQ_GGD = LQ_GGD + Nc*Co*Pi*alphas**3*dldel2 * (256*ms1**2*s**(-3)
     +     + 128*ms1**2*s**(-2)*t1**(-1) + 128*ms1**2*s**(-2)*u1**(-1)
     +     + 128*ms1**4*s**(-2)*t1**(-2) + 128*ms1**4*s**(-2)*u1**(-2)
     +     + 128*s**(-4)*t1**2 + 128*s**(-3)*t1 + 64*s**(-2) )
      LQ_GGD = LQ_GGD + Nc*Ck*Pi*alphas**3*dldel1 * (112*ms1**2*s**(-3)
     +     + 88*ms1**2*s**(-2)*t**(-1) + 88*ms1**2*s**(-2)*u**(-1) - 52
     +    *ms1**2*s**(-2)*t1**(-1) - 52*ms1**2*s**(-2)*u1**(-1) - 64*
     +    ms1**2*s**(-1)*t**(-1)*t1**(-1) - 96*ms1**2*s**(-1)*t**(-1)*
     +    u1**(-1) - 96*ms1**2*s**(-1)*u**(-1)*t1**(-1) - 64*ms1**2*
     +    s**(-1)*u**(-1)*u1**(-1) + 40*ms1**2*s**(-1)*t1**(-2) + 40*
     +    ms1**2*s**(-1)*u1**(-2) + 40*ms1**4*s**(-3)*t**(-1) + 40*
     +    ms1**4*s**(-3)*u**(-1) - 32*ms1**4*s**(-3)*t1**(-1) - 32*
     +    ms1**4*s**(-3)*u1**(-1) + 436*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     +     + 192*ms1**4*s**(-2)*t**(-1)*u1**(-1) + 192*ms1**4*s**(-2)*
     +    u**(-1)*t1**(-1) + 436*ms1**4*s**(-2)*u**(-1)*u1**(-1) - 80*
     +    ms1**4*s**(-2)*t1**(-2) + 32*ms1**4*s**(-2)*t1**(-1)*u1**(-1)
     +     - 80*ms1**4*s**(-2)*u1**(-2) - 56*ms1**4*s**(-1)*t**(-1)*
     +    t1**(-2) - 56*ms1**4*s**(-1)*u**(-1)*u1**(-2) + 16*ms1**4*
     +    s**(-1)*t1**(-3) + 16*ms1**4*s**(-1)*u1**(-3) + 32*ms1**6*
     +    s**(-3)*t**(-1)*t1**(-1) )
      LQ_GGD = LQ_GGD + Nc*Ck*Pi*alphas**3*dldel1 * (32*ms1**6*s**(-3)*
     +    u**(-1)*u1**(-1) + 400*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 176*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) + 176*ms1**6*s**(-2)
     +    *u**(-1)*t1**(-1)*u1**(-1) + 400*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) - 128*ms1**6*s**(-2)*t1**(-3) - 64*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1) - 64*ms1**6*s**(-2)*t1**(-1)*u1**(-2) - 128
     +    *ms1**6*s**(-2)*u1**(-3) - 16*ms1**6*s**(-1)*t**(-1)*t1**(-3)
     +     - 16*ms1**6*s**(-1)*u**(-1)*u1**(-3) + 128*ms1**8*s**(-2)*
     +    t**(-1)*t1**(-3) + 64*ms1**8*s**(-2)*t**(-1)*t1**(-2)*
     +    u1**(-1) + 64*ms1**8*s**(-2)*u**(-1)*t1**(-1)*u1**(-2) + 128*
     +    ms1**8*s**(-2)*u**(-1)*u1**(-3) + 64*s**(-4)*t1**2 - 8*
     +    s**(-3)*t**(-1)*t1**2 - 8*s**(-3)*u**(-1)*t1**2 + 64*s**(-3)*
     +    t1 + 4*s**(-2)*t**(-1)*t1 - 20*s**(-2)*u**(-1)*t1 + 80*
     +    s**(-2) - 8*s**(-1)*t**(-1) - 20*s**(-1)*u**(-1) + 40*s**(-1)
     +    *t1**(-1) + 40*s**(-1)*u1**(-1) + 16*t**(-1)*u1**(-1) + 16*
     +    u**(-1)*t1**(-1) )
      LQ_GGD = LQ_GGD + Nc*Ck*Pi*alphas**3*dldel2 * (  - 128*ms1**2*
     +    s**(-2)*t1**(-1) - 128*ms1**2*s**(-2)*u1**(-1) - 128*ms1**4*
     +    s**(-2)*t1**(-2) - 256*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 128
     +    *ms1**4*s**(-2)*u1**(-2) - 64*s**(-2) )
      LQ_GGD = LQ_GGD + Cqed*Pi*alphas**3*dldel1 * ( 24*ms1**2*s**(-2)*
     +    t1**(-1) + 24*ms1**2*s**(-2)*u1**(-1) + 16*ms1**2*s**(-1)*
     +    t**(-1)*t1**(-1) + 48*ms1**2*s**(-1)*t**(-1)*u1**(-1) + 48*
     +    ms1**2*s**(-1)*u**(-1)*t1**(-1) + 16*ms1**2*s**(-1)*u**(-1)*
     +    u1**(-1) - 8*ms1**2*s**(-1)*t1**(-2) - 8*ms1**2*s**(-1)*
     +    u1**(-2) - 160*ms1**4*s**(-2)*t**(-1)*t1**(-1) - 120*ms1**4*
     +    s**(-2)*t**(-1)*u1**(-1) - 120*ms1**4*s**(-2)*u**(-1)*
     +    t1**(-1) - 160*ms1**4*s**(-2)*u**(-1)*u1**(-1) + 48*ms1**4*
     +    s**(-2)*t1**(-2) + 32*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 48*
     +    ms1**4*s**(-2)*u1**(-2) + 8*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     +     + 8*ms1**4*s**(-1)*u**(-1)*u1**(-2) - 176*ms1**6*s**(-2)*
     +    t**(-1)*t1**(-2) - 144*ms1**6*s**(-2)*t**(-1)*t1**(-1)*
     +    u1**(-1) - 144*ms1**6*s**(-2)*u**(-1)*t1**(-1)*u1**(-1) - 176
     +    *ms1**6*s**(-2)*u**(-1)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3)
     +     + 64*ms1**6*s**(-2)*t1**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-2) )
      LQ_GGD = LQ_GGD + Cqed*Pi*alphas**3*dldel1 * ( 64*ms1**6*s**(-2)*
     +    u1**(-3) - 64*ms1**8*s**(-2)*t**(-1)*t1**(-3) - 64*ms1**8*
     +    s**(-2)*t**(-1)*t1**(-2)*u1**(-1) - 64*ms1**8*s**(-2)*u**(-1)
     +    *t1**(-1)*u1**(-2) - 64*ms1**8*s**(-2)*u**(-1)*u1**(-3) + 8*
     +    s**(-2)*t**(-1)*t1 - 8*s**(-2)*u**(-1)*t1 - 48*s**(-2) - 8*
     +    s**(-1)*u**(-1) - 16*s**(-1)*t1**(-1) - 16*s**(-1)*u1**(-1)
     +     - 8*t**(-1)*u1**(-1) - 8*u**(-1)*t1**(-1) )
      LQ_GGD = LQ_GGD + COLO1(1)*Nc*Ck*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-5)*t1**2*xw**(-1) - 128*ms1**2*s**(-4)*t1*
     +    xw**(-1) + 64*ms1**2*s**(-3)*xw**(-1) + 64*ms1**2*s**(-2)*
     +    t1**(-1)*xw**(-1) + 64*ms1**2*s**(-2)*u1**(-1)*xw**(-1) - 256
     +    *ms1**4*s**(-4)*xw**(-1) - 128*ms1**4*s**(-3)*t1**(-1)*
     +    xw**(-1) - 128*ms1**4*s**(-3)*u1**(-1)*xw**(-1) + 64*ms1**4*
     +    s**(-2)*t1**(-2)*xw**(-1) + 64*ms1**4*s**(-2)*u1**(-2)*
     +    xw**(-1) - 128*ms1**6*s**(-3)*t1**(-2)*xw**(-1) - 128*ms1**6*
     +    s**(-3)*u1**(-2)*xw**(-1) + 64*s**(-4)*t1**2*xw**(-1) + 64*
     +    s**(-3)*t1*xw**(-1) + 32*s**(-2)*xw**(-1) )
      LQ_GGD = LQ_GGD + COLO1(1)*Cqed*Pi*alphas**3*dldel1 * (64*ms1**2*
     +    s**(-3)*xw**(-1) - 64*ms1**2*s**(-2)*t1**(-1)*xw**(-1) - 64*
     +    ms1**2*s**(-2)*u1**(-1)*xw**(-1) - 128*ms1**4*s**(-3)*
     +    t1**(-1)*xw**(-1) - 128*ms1**4*s**(-3)*u1**(-1)*xw**(-1) - 64
     +    *ms1**4*s**(-2)*t1**(-2)*xw**(-1) - 384*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-1)*xw**(-1) - 64*ms1**4*s**(-2)*u1**(-2)*
     +    xw**(-1) + 128*ms1**6*s**(-3)*t1**(-2)*xw**(-1) + 256*ms1**6*
     +    s**(-3)*t1**(-1)*u1**(-1)*xw**(-1) + 128*ms1**6*s**(-3)*
     +    u1**(-2)*xw**(-1) - 32*s**(-2)*xw**(-1) )
      LQ_GGD = LQ_GGD + COLO1(3)*Nc*Co*Pi*alphas**3*dldel1 *(128*ms1**2
     +    *s**(-3) + 64*ms1**2*s**(-2)*t1**(-1) + 64*ms1**2*s**(-2)*
     +    u1**(-1) + 64*ms1**4*s**(-2)*t1**(-2) + 64*ms1**4*s**(-2)*
     +    u1**(-2) + 64*s**(-4)*t1**2 + 64*s**(-3)*t1 + 32*s**(-2) )
      LQ_GGD = LQ_GGD + COLO1(4)*Nc*Co*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-3) - 128*ms1**2*s**(-2)*u1**(-1) - 128*ms1**4*
     +    s**(-2)*u1**(-2) - 64*s**(-4)*t1**2 )
      LQ_GGD = LQ_GGD + COLO1(8)*Nc*Co*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-3) - 128*ms1**2*s**(-2)*t1**(-1) - 128*ms1**4*
     +    s**(-2)*t1**(-2) - 64*s**(-4)*t1**2 - 128*s**(-3)*t1 - 64*
     +    s**(-2) )

      LQ_GGD = fac * LQ_GGD 

      end 



c --------------------------------------------------------------------
      real*8 function LQ_GGV(s,t1,ms1,mt)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,Nf,Nl,alphas,fac 
      real*8 s,t1,u1,ms1,mt,t,u,ms12
      real*8 m2(2,6),softin(4)
      real*8 SK3B0A(5),SK3B0B(6),SK3B0C(2),SK3B0D(2,2),SK3BP(3) 
      real*8 SK3C0A(8),SK3C0B(4),SK3C0C(5,2),SK3D0(7,2)
      real*8 SOF1(8)
      real*8 mur,dec,LQ_GGB

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      alphas = 1.D0

      Nf = 6.D0
      Nl = 1.D0

      u1 = - s - t1 
      t = t1 + ms1**2 
      u = u1 + ms1**2 
      ms12 = ms1**2 
      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)

      m2(1,1) = s 
      m2(1,2) = t1 + ms1**2  
      m2(1,3) = u1 + ms1**2 
      m2(1,4) = t1
      m2(1,5) = u1
      m2(2,1) = ms1**2 
      m2(2,2) = 1.D0 
      m2(2,3) = 1.D0 
      m2(2,4) = 1.D0 
      m2(2,5) = mt**2 
      m2(2,6) = ms1**2 

      call SCALAR_ARRAY_LQ_B(m2,SK3B0A,SK3B0B,SK3B0C,SK3B0D,SK3BP)
      call SCALAR_ARRAY_LQ_C(m2,SK3C0A,SK3C0B,SK3C0C,SK3D0)

      softin(1) = s
      softin(2) = t1 
      softin(3) = u1 
      softin(4) = ms1**2 

      call SOFT_ARRAY_LQ(softin,SOF1)

      mur = ms1
      
      dec = 2.D0*alphas/Pi * LQ_GGB(s,t1,ms1)*
     &      (  Nl/24.D0      * log(mur**2/ms1**2)
     &       + 1.D0/6.D0       * log(mur**2/mt**2)  )


      LQ_GGV =
     +  + Nc*Co*Pi*alphas**3 * ( ms1**2*s**(-3)*t**(-1)*t1 - ms1**2*
     +    s**(-3)*u**(-1)*t1 - 38./3.*ms1**2*s**(-3) + 3*ms1**2*s**(-2)
     +    *t**(-1) + 2*ms1**2*s**(-2)*u**(-1) - 41./3.*ms1**2*s**(-2)*
     +    t1**(-1) - 41./3.*ms1**2*s**(-2)*u1**(-1) + 5*ms1**2*s**(-1)*
     +    t**(-1)*t1**(-1) + 5*ms1**2*s**(-1)*u**(-1)*u1**(-1) - 5*
     +    ms1**2*s**(-1)*t1**(-2) - 5*ms1**2*s**(-1)*u1**(-2) + 5*
     +    ms1**4*s**(-3)*t**(-1) + 5*ms1**4*s**(-3)*u**(-1) - 4*ms1**4*
     +    s**(-3)*t1**(-1) - 4*ms1**4*s**(-3)*u1**(-1) + 3*ms1**4*
     +    s**(-2)*t**(-1)*t1**(-1) + 3*ms1**4*s**(-2)*u**(-1)*u1**(-1)
     +     + 11*ms1**4*s**(-1)*t**(-1)*t1**(-2) + 11*ms1**4*s**(-1)*
     +    u**(-1)*u1**(-2) - 6*ms1**4*s**(-1)*t1**(-3) - 6*ms1**4*
     +    s**(-1)*u1**(-3) + 4*ms1**6*s**(-3)*t**(-1)*t1**(-1) + 4*
     +    ms1**6*s**(-3)*u**(-1)*u1**(-1) + 6*ms1**6*s**(-1)*t**(-1)*
     +    t1**(-3) + 6*ms1**6*s**(-1)*u**(-1)*u1**(-3) )
      LQ_GGV = LQ_GGV + Nc*Ck*Pi*alphas**3 * (  - 4*ms1**2*s**(-3)*
     +    t**(-1)*t1 + 4*ms1**2*s**(-3)*u**(-1)*t1 + 8*ms1**2*s**(-3)
     +     + 6*ms1**2*s**(-2)*t**(-1) + 10*ms1**2*s**(-2)*u**(-1) - 34*
     +    ms1**2*s**(-2)*t1**(-1) - 34*ms1**2*s**(-2)*u1**(-1) - 12*
     +    ms1**2*s**(-1)*t**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*t**(-1)*
     +    u1**(-1) - 16*ms1**2*s**(-1)*u**(-1)*t1**(-1) - 12*ms1**2*
     +    s**(-1)*u**(-1)*u1**(-1) + 12*ms1**2*s**(-1)*t1**(-2) + 12*
     +    ms1**2*s**(-1)*u1**(-2) - 20*ms1**4*s**(-3)*t**(-1) - 20*
     +    ms1**4*s**(-3)*u**(-1) + 16*ms1**4*s**(-3)*t1**(-1) + 16*
     +    ms1**4*s**(-3)*u1**(-1) - 18*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     +     + 24*ms1**4*s**(-2)*t**(-1)*u1**(-1) + 24*ms1**4*s**(-2)*
     +    u**(-1)*t1**(-1) - 18*ms1**4*s**(-2)*u**(-1)*u1**(-1) + 40*
     +    ms1**4*s**(-2)*t1**(-2) - 16*ms1**4*s**(-2)*t1**(-1)*u1**(-1)
     +     + 40*ms1**4*s**(-2)*u1**(-2) - 20*ms1**4*s**(-1)*t**(-1)*
     +    t1**(-2) - 20*ms1**4*s**(-1)*u**(-1)*u1**(-2) + 8*ms1**4*
     +    s**(-1)*t1**(-3) )
      LQ_GGV = LQ_GGV + Nc*Ck*Pi*alphas**3 * (8*ms1**4*s**(-1)*u1**(-3)
     +     - 16*ms1**6*s**(-3)*t**(-1)*t1**(-1) - 16*ms1**6*s**(-3)*
     +    u**(-1)*u1**(-1) - 104*ms1**6*s**(-2)*t**(-1)*t1**(-2) - 24*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) - 24*ms1**6*s**(-2)*
     +    u**(-1)*t1**(-1)*u1**(-1) - 104*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3) + 32*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1) + 32*ms1**6*s**(-2)*t1**(-1)*u1**(-2) + 64*
     +    ms1**6*s**(-2)*u1**(-3) - 8*ms1**6*s**(-1)*t**(-1)*t1**(-3)
     +     - 8*ms1**6*s**(-1)*u**(-1)*u1**(-3) - 64*ms1**8*s**(-2)*
     +    t**(-1)*t1**(-3) - 32*ms1**8*s**(-2)*t**(-1)*t1**(-2)*
     +    u1**(-1) - 32*ms1**8*s**(-2)*u**(-1)*t1**(-1)*u1**(-2) - 64*
     +    ms1**8*s**(-2)*u**(-1)*u1**(-3) )
      LQ_GGV = LQ_GGV + Co*Pi*alphas**3 * (32./3.*Nf*ms1**2*s**(-3)+8./
     +    3.*Nf*ms1**2*s**(-2)*t1**(-1) + 8./3.*Nf*ms1**2*s**(-2)*
     +    u1**(-1) - 16./3.*Nl*ms1**2*s**(-3) - 4./3.*Nl*ms1**2*s**(-2)
     +    *t1**(-1) - 4./3.*Nl*ms1**2*s**(-2)*u1**(-1) )
      LQ_GGV = LQ_GGV + Cqed*Pi*alphas**3 *(4*ms1**2*s**(-2)*t**(-1) + 
     +    4*ms1**2*s**(-2)*u**(-1) - 4*ms1**2*s**(-2)*t1**(-1) - 4*
     +    ms1**2*s**(-2)*u1**(-1) + 4*ms1**2*s**(-1)*t**(-1)*t1**(-1)
     +     + 4*ms1**2*s**(-1)*t**(-1)*u1**(-1) + 4*ms1**2*s**(-1)*
     +    u**(-1)*t1**(-1) + 4*ms1**2*s**(-1)*u**(-1)*u1**(-1) - 4*
     +    ms1**2*s**(-1)*t1**(-2) - 4*ms1**2*s**(-1)*u1**(-2) + 40*
     +    ms1**4*s**(-2)*t**(-1)*t1**(-1) + 20*ms1**4*s**(-2)*t**(-1)*
     +    u1**(-1) + 20*ms1**4*s**(-2)*u**(-1)*t1**(-1) + 40*ms1**4*
     +    s**(-2)*u**(-1)*u1**(-1) - 40*ms1**4*s**(-2)*t1**(-2) - 48*
     +    ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 40*ms1**4*s**(-2)*u1**(-2)
     +     + 4*ms1**4*s**(-1)*t**(-1)*t1**(-2) + 4*ms1**4*s**(-1)*
     +    u**(-1)*u1**(-2) + 72*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 56*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) + 56*ms1**6*s**(-2)*
     +    u**(-1)*t1**(-1)*u1**(-1) + 72*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) - 32*ms1**6*s**(-2)*t1**(-3) - 32*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1) )
      LQ_GGV = LQ_GGV + Cqed*Pi*alphas**3 * (  - 32*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-2) - 32*ms1**6*s**(-2)*u1**(-3) + 32*ms1**8*
     +    s**(-2)*t**(-1)*t1**(-3) + 32*ms1**8*s**(-2)*t**(-1)*t1**(-2)
     +    *u1**(-1) + 32*ms1**8*s**(-2)*u**(-1)*t1**(-1)*u1**(-2) + 32*
     +    ms1**8*s**(-2)*u**(-1)*u1**(-3) )
      LQ_GGV = LQ_GGV + SK3B0A(2)*Co*Pi*alphas**3 * ( -128*mt**2*ms1**2
     +    *s**(-4) - 128./3.*mt**2*ms1**2*s**(-3)*t1**(-1) - 128./3.*
     +    mt**2*ms1**2*s**(-3)*u1**(-1) - 32./3.*mt**2*ms1**2*s**(-2)*
     +    t1**(-1)*u1**(-1) - 128./3.*ms1**2*s**(-3) - 64./3.*ms1**2*
     +    s**(-2)*t1**(-1) - 64./3.*ms1**2*s**(-2)*u1**(-1) - 64./3.*
     +    ms1**4*s**(-2)*t1**(-2) - 64./3.*ms1**4*s**(-2)*u1**(-2) -64.
     +    /3.*s**(-4)*t1**2 - 64./3.*s**(-3)*t1 - 32./3.*s**(-2) )
      LQ_GGV = LQ_GGV + SK3B0A(2)*Ck*Pi*alphas**3 * ( 64./3.*ms1**2*
     +    s**(-2)*t1**(-1) + 64./3.*ms1**2*s**(-2)*u1**(-1) + 64./3.*
     +    ms1**4*s**(-2)*t1**(-2) + 128./3.*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1) + 64./3.*ms1**4*s**(-2)*u1**(-2) + 32./3.*s**(-2) )
      LQ_GGV = LQ_GGV + SK3B0B(1)*Nc*Co*Pi*alphas**3 * (  - 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 2*(s-4*ms12)**(-1)*
     +    t1**(-1) - 2*(s-4*ms12)**(-1)*u1**(-1) - 32*ms1**2*s**(-3) - 
     +    8*ms1**2*s**(-2)*t1**(-1) - 8*ms1**2*s**(-2)*u1**(-1) - 32*
     +    s**(-4)*t1**2 - 32*s**(-3)*t1 + 2*s**(-1)*t1**(-1) + 2*
     +    s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0B(2)*Nc*Ck*Pi*alphas**3 * ( 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 2*(s-4*ms12)**(-1)*
     +    t1**(-1) + 2*(s-4*ms12)**(-1)*u1**(-1) + 32*ms1**2*s**(-3) + 
     +    8*ms1**2*s**(-2)*t1**(-1) + 8*ms1**2*s**(-2)*u1**(-1) + 32*
     +    s**(-4)*t1**2 + 32*s**(-3)*t1 - 2*s**(-1)*t1**(-1) - 2*
     +    s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0B(2)*Co*Pi*alphas**3 * (  - 64*Nl*ms1**4*
     +    s**(-4) - 64./3.*Nl*ms1**4*s**(-3)*t1**(-1) - 64./3.*Nl*
     +    ms1**4*s**(-3)*u1**(-1) - 16./3.*Nl*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0B(4)*Co*Pi*alphas**3 * ( 128*mt**2*ms1**2*
     +    s**(-4) + 128./3.*mt**2*ms1**2*s**(-3)*t1**(-1) + 128./3.*
     +    mt**2*ms1**2*s**(-3)*u1**(-1) + 32./3.*mt**2*ms1**2*s**(-2)*
     +    t1**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0C(1)*Nc*Co*Pi*alphas**3 * ( 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 2*(s-4*ms12)**(-1)*
     +    t1**(-1) + 2*(s-4*ms12)**(-1)*u1**(-1) + 96*ms1**2*s**(-3) + 
     +    56*ms1**2*s**(-2)*t1**(-1) + 56*ms1**2*s**(-2)*u1**(-1) + 32*
     +    ms1**4*s**(-3)*t1**(-1) + 32*ms1**4*s**(-3)*u1**(-1) + 96*
     +    ms1**4*s**(-2)*t1**(-2) + 96*ms1**4*s**(-2)*u1**(-2) + 64*
     +    ms1**6*s**(-2)*t1**(-3) + 64*ms1**6*s**(-2)*u1**(-3) + 32*
     +    s**(-4)*t1**2 + 32*s**(-3)*t1 + 16*s**(-2) - 2*s**(-1)*
     +    t1**(-1) - 2*s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0C(1)*Nc*Ck*Pi*alphas**3 * (  - 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 2*(s-4*ms12)**(-1)*
     +    t1**(-1) - 2*(s-4*ms12)**(-1)*u1**(-1) - 96*ms1**2*s**(-3) - 
     +    184*ms1**2*s**(-2)*t1**(-1) - 184*ms1**2*s**(-2)*u1**(-1) - 
     +    32*ms1**4*s**(-3)*t1**(-1) - 32*ms1**4*s**(-3)*u1**(-1) - 288
     +    *ms1**4*s**(-2)*t1**(-2) - 256*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1) - 288*ms1**4*s**(-2)*u1**(-2) - 192*ms1**6*s**(-2)*
     +    t1**(-3) - 128*ms1**6*s**(-2)*t1**(-2)*u1**(-1) - 128*ms1**6*
     +    s**(-2)*t1**(-1)*u1**(-2) - 192*ms1**6*s**(-2)*u1**(-3) - 32*
     +    s**(-4)*t1**2 - 32*s**(-3)*t1 - 80*s**(-2) + 2*s**(-1)*
     +    t1**(-1) + 2*s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0C(1)*Cqed*Pi*alphas**3 *(64*ms1**2*s**(-2)
     +    *t1**(-1) + 64*ms1**2*s**(-2)*u1**(-1) + 96*ms1**4*s**(-2)*
     +    t1**(-2) + 128*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 96*ms1**4*
     +    s**(-2)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3) + 64*ms1**6*
     +    s**(-2)*t1**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2) + 64*ms1**6*s**(-2)*u1**(-3) + 32*s**(-2) )
      LQ_GGV = LQ_GGV + SK3B0D(1,1)*Nc*Co*Pi*alphas**3 * ( 19*ms1**2*
     +    s**(-3)*t**(-1)*t1 - 44*ms1**2*s**(-3) + 47*ms1**2*s**(-2)*
     +    t**(-1) - 78*ms1**2*s**(-2)*t1**(-1) + 11*ms1**2*s**(-1)*
     +    t**(-1)*t1**(-1) - 6*ms1**2*s**(-1)*t1**(-2) + 12*ms1**4*
     +    s**(-3)*t**(-1) - 32*ms1**4*s**(-3)*t1**(-1) + 46*ms1**4*
     +    s**(-2)*t**(-1)*t1**(-1) - 112*ms1**4*s**(-2)*t1**(-2) + 6*
     +    ms1**4*s**(-1)*t**(-1)*t1**(-2) + 16*ms1**6*s**(-2)*t**(-1)*
     +    t1**(-2) - 64*ms1**6*s**(-2)*t1**(-3) + 7*s**(-3)*t**(-1)*
     +    t1**2 - 23*s**(-3)*t1 + 17*s**(-2)*t**(-1)*t1 - 33*s**(-2) + 
     +    5*s**(-1)*t**(-1) - 5*s**(-1)*t1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,1)*Nc*Ck*Pi*alphas**3 * ( 4*ms1**2*
     +    s**(-3)*t**(-1)*t1 + 24*ms1**2*s**(-3) + 38*ms1**2*s**(-2)*
     +    t**(-1) + 84*ms1**2*s**(-2)*t1**(-1) + 8*ms1**2*s**(-2)*
     +    u1**(-1) - 20*ms1**2*s**(-1)*t**(-1)*t1**(-1) - 32*ms1**2*
     +    s**(-1)*t**(-1)*u1**(-1) + 8*ms1**2*s**(-1)*t1**(-2) + 40*
     +    ms1**4*s**(-3)*t**(-1) + 236*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     +     + 72*ms1**4*s**(-2)*t**(-1)*u1**(-1) + 112*ms1**4*s**(-2)*
     +    t1**(-2) + 80*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 8*ms1**4*
     +    s**(-1)*t**(-1)*t1**(-2) + 32*ms1**6*s**(-3)*t**(-1)*t1**(-1)
     +     + 304*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 112*ms1**6*s**(-2)*
     +    t**(-1)*t1**(-1)*u1**(-1) + 64*ms1**6*s**(-2)*t1**(-3) + 64*
     +    ms1**6*s**(-2)*t1**(-2)*u1**(-1) + 128*ms1**8*s**(-2)*t**(-1)
     +    *t1**(-3) + 64*ms1**8*s**(-2)*t**(-1)*t1**(-2)*u1**(-1) - 4*
     +    s**(-3)*t**(-1)*t1**2 + 20*s**(-3)*t1 + 2*s**(-2)*t**(-1)*t1
     +     + 46*s**(-2) - 4*s**(-1)*t**(-1) + 12*s**(-1)*t1**(-1) + 8*
     +    s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,1)*Nc*Ck*Pi*alphas**3 * ( 8*t**(-1)*
     +    u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,1)*Cqed*Pi*alphas**3 * (  - 4*ms1**2*
     +    s**(-2)*t**(-1) - 24*ms1**2*s**(-2)*t1**(-1) + 4*ms1**2*
     +    s**(-1)*t**(-1)*t1**(-1) + 20*ms1**2*s**(-1)*t**(-1)*u1**(-1)
     +     - 120*ms1**4*s**(-2)*t**(-1)*t1**(-1) - 80*ms1**4*s**(-2)*
     +    t**(-1)*u1**(-1) - 160*ms1**6*s**(-2)*t**(-1)*t1**(-2) - 128*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) - 64*ms1**8*s**(-2)*
     +    t**(-1)*t1**(-3) - 64*ms1**8*s**(-2)*t**(-1)*t1**(-2)*
     +    u1**(-1) + 4*s**(-2)*t**(-1)*t1 - 20*s**(-2) - 4*s**(-1)*
     +    t1**(-1) - 4*s**(-1)*u1**(-1) - 4*t**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,2)*Nc*Co*Pi*alphas**3 * ( -19*ms1**2*
     +    s**(-3)*u**(-1)*t1 - 44*ms1**2*s**(-3) + 28*ms1**2*s**(-2)*
     +    u**(-1) - 78*ms1**2*s**(-2)*u1**(-1) + 11*ms1**2*s**(-1)*
     +    u**(-1)*u1**(-1) - 6*ms1**2*s**(-1)*u1**(-2) + 12*ms1**4*
     +    s**(-3)*u**(-1) - 32*ms1**4*s**(-3)*u1**(-1) + 46*ms1**4*
     +    s**(-2)*u**(-1)*u1**(-1) - 112*ms1**4*s**(-2)*u1**(-2) + 6*
     +    ms1**4*s**(-1)*u**(-1)*u1**(-2) + 16*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) - 64*ms1**6*s**(-2)*u1**(-3) + 7*s**(-3)*u**(-1)*
     +    t1**2 + 23*s**(-3)*t1 - 3*s**(-2)*u**(-1)*t1 - 10*s**(-2) - 5
     +    *s**(-1)*u**(-1) - 5*s**(-1)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,2)*Nc*Ck*Pi*alphas**3 * (  - 4*ms1**2*
     +    s**(-3)*u**(-1)*t1 + 24*ms1**2*s**(-3) + 34*ms1**2*s**(-2)*
     +    u**(-1) + 8*ms1**2*s**(-2)*t1**(-1) + 84*ms1**2*s**(-2)*
     +    u1**(-1) - 32*ms1**2*s**(-1)*u**(-1)*t1**(-1) - 20*ms1**2*
     +    s**(-1)*u**(-1)*u1**(-1) + 8*ms1**2*s**(-1)*u1**(-2) + 40*
     +    ms1**4*s**(-3)*u**(-1) + 72*ms1**4*s**(-2)*u**(-1)*t1**(-1)
     +     + 236*ms1**4*s**(-2)*u**(-1)*u1**(-1) + 80*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-1) + 112*ms1**4*s**(-2)*u1**(-2) - 8*ms1**4*
     +    s**(-1)*u**(-1)*u1**(-2) + 32*ms1**6*s**(-3)*u**(-1)*u1**(-1)
     +     + 112*ms1**6*s**(-2)*u**(-1)*t1**(-1)*u1**(-1) + 304*ms1**6*
     +    s**(-2)*u**(-1)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2) + 64*ms1**6*s**(-2)*u1**(-3) + 64*ms1**8*s**(-2)*
     +    u**(-1)*t1**(-1)*u1**(-2) + 128*ms1**8*s**(-2)*u**(-1)*
     +    u1**(-3) - 4*s**(-3)*u**(-1)*t1**2 - 20*s**(-3)*t1 - 10*
     +    s**(-2)*u**(-1)*t1 + 26*s**(-2) - 10*s**(-1)*u**(-1) + 8*
     +    s**(-1)*t1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,2)*Nc*Ck*Pi*alphas**3 * ( 12*s**(-1)*
     +    u1**(-1) + 8*u**(-1)*t1**(-1) )
      LQ_GGV = LQ_GGV + SK3B0D(1,2)*Cqed*Pi*alphas**3 * (  - 4*ms1**2*
     +    s**(-2)*u**(-1) - 24*ms1**2*s**(-2)*u1**(-1) + 20*ms1**2*
     +    s**(-1)*u**(-1)*t1**(-1) + 4*ms1**2*s**(-1)*u**(-1)*u1**(-1)
     +     - 80*ms1**4*s**(-2)*u**(-1)*t1**(-1) - 120*ms1**4*s**(-2)*
     +    u**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u**(-1)*t1**(-1)*
     +    u1**(-1) - 160*ms1**6*s**(-2)*u**(-1)*u1**(-2) - 64*ms1**8*
     +    s**(-2)*u**(-1)*t1**(-1)*u1**(-2) - 64*ms1**8*s**(-2)*u**(-1)
     +    *u1**(-3) - 4*s**(-2)*u**(-1)*t1 - 20*s**(-2) - 4*s**(-1)*
     +    u**(-1) - 4*s**(-1)*t1**(-1) - 4*s**(-1)*u1**(-1) - 4*u**(-1)
     +    *t1**(-1) )
      LQ_GGV = LQ_GGV + SK3BP(1)*Nc*Co*Pi*alphas**3 *(64*ms1**2*s**(-4)
     +    *t1**2 + 64*ms1**2*s**(-3)*t1 + 32*ms1**2*s**(-2) + 128*
     +    ms1**4*s**(-3) + 64*ms1**4*s**(-2)*t1**(-1) + 64*ms1**4*
     +    s**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*t1**(-2) + 64*ms1**6*
     +    s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SK3BP(1)*Nc*Ck*Pi*alphas**3 * (  - 64*ms1**2*
     +    s**(-4)*t1**2 - 64*ms1**2*s**(-3)*t1 - 96*ms1**2*s**(-2) - 
     +    128*ms1**4*s**(-3) - 192*ms1**4*s**(-2)*t1**(-1) - 192*ms1**4
     +    *s**(-2)*u1**(-1) - 192*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*
     +    s**(-2)*t1**(-1)*u1**(-1) - 192*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SK3BP(1)*Cqed*Pi*alphas**3 *(32*ms1**2*s**(-2)
     +     + 64*ms1**4*s**(-2)*t1**(-1) + 64*ms1**4*s**(-2)*u1**(-1) + 
     +    64*ms1**6*s**(-2)*t1**(-2) + 128*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-1) + 64*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SK3C0A(1)*Nc*Co*Pi*alphas**3 * (  - 32*ms1**2*
     +    s**(-2) - 16*ms1**2*s**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*
     +    u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0A(2)*Nc*Ck*Pi*alphas**3 * ( 32*ms1**2*
     +    s**(-2) - 16*ms1**2*s**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*
     +    u1**(-1) + 40*ms1**4*s**(-2)*t1**(-1) + 40*ms1**4*s**(-2)*
     +    u1**(-1) - 16*s**(-1) )
      LQ_GGV = LQ_GGV + SK3C0A(2)*Co*Pi*alphas**3 * (  - 32*Nl*ms1**4*
     +    s**(-3) - 8*Nl*ms1**4*s**(-2)*t1**(-1) - 8*Nl*ms1**4*s**(-2)*
     +    u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0A(2)*Cqed*Pi*alphas**3 *(48*ms1**2*s**(-1)
     +    *t1**(-1) + 48*ms1**2*s**(-1)*u1**(-1) - 80*ms1**4*s**(-2)*
     +    t1**(-1) - 80*ms1**4*s**(-2)*u1**(-1) - 8*t1**(-1) - 8*
     +    u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0A(4)*Co*Pi*alphas**3 * ( 64*mt**2*ms1**2*
     +    s**(-3) + 16*mt**2*ms1**2*s**(-2)*t1**(-1) + 16*mt**2*ms1**2*
     +    s**(-2)*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0B(1)*Nc*Ck*Pi*alphas**3 * (  - 64*ms1**2*
     +    s**(-4)*t1**2 - 64*ms1**2*s**(-3)*t1 + 96*ms1**2*s**(-2) + 16
     +    *ms1**2*s**(-1)*t1**(-1) + 16*ms1**2*s**(-1)*u1**(-1) - 192*
     +    ms1**4*s**(-3) - 32*ms1**4*s**(-2)*t1**(-1) - 32*ms1**4*
     +    s**(-2)*u1**(-1) + 32*s**(-3)*t1**2 + 32*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SK3C0B(1)*Cqed*Pi*alphas**3 *(32*ms1**2*s**(-2)
     +     + 32*ms1**2*s**(-1)*t1**(-1) + 32*ms1**2*s**(-1)*u1**(-1) - 
     +    32*ms1**4*s**(-2)*t1**(-1) - 32*ms1**4*s**(-2)*u1**(-1) - 16*
     +    s**(-1) - 8*t1**(-1) - 8*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0B(2)*Nc*Co*Pi*alphas**3 * (  - 16*
     +    (s-4*ms12)**(-1)*s**(-2)*t1**2 - 16*(s-4*ms12)**(-1)*s**(-1)*
     +    t1 + (s-4*ms12)**(-1)*t1**(-1)*u1 + (s-4*ms12)**(-1)*t1*
     +    u1**(-1) - 6*(s-4*ms12)**(-1) + 32*ms1**2*s**(-2) + 20*ms1**2
     +    *s**(-1)*t1**(-1) + 20*ms1**2*s**(-1)*u1**(-1) - 16*ms1**4*
     +    s**(-2)*t1**(-1) - 16*ms1**4*s**(-2)*u1**(-1) + 48*s**(-3)*
     +    t1**2 + 48*s**(-2)*t1 + 24*s**(-1) + t1**(-1) + u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0C(1,1)*Nc*Co*Pi*alphas**3 * (  -32*ms1**2*
     +    s**(-3)*t1 - 32*ms1**2*s**(-2) - 32*s**(-3)*t1**2 - 16*
     +    s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SK3C0C(1,1)*Nc*Ck*Pi*alphas**3 * (  -32*ms1**2*
     +    s**(-1)*u1**(-1) + 64*ms1**4*s**(-2)*u1**(-1) + 16*s**(-2)*t1
     +     )
      LQ_GGV = LQ_GGV + SK3C0C(1,2)*Nc*Co*Pi*alphas**3 * ( 32*ms1**2*
     +    s**(-3)*t1 - 32*s**(-3)*t1**2 - 48*s**(-2)*t1 - 16*s**(-1) )
      LQ_GGV = LQ_GGV + SK3C0C(1,2)*Nc*Ck*Pi*alphas**3 * (  -32*ms1**2*
     +    s**(-1)*t1**(-1) + 64*ms1**4*s**(-2)*t1**(-1) - 16*s**(-2)*t1
     +     - 16*s**(-1) )
      LQ_GGV = LQ_GGV + SK3C0C(3,1)*Nc*Ck*Pi*alphas**3 * ( 32*ms1**2*
     +    s**(-3)*t1 - 32*ms1**2*s**(-2) + 32*ms1**2*s**(-1)*u1**(-1)
     +     + 64*ms1**4*s**(-3) - 32*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SK3C0C(3,1)*Cqed*Pi*alphas**3 * (  - 32*ms1**2*
     +    s**(-2) - 64*ms1**2*s**(-1)*u1**(-1) + 64*ms1**4*s**(-2)*
     +    u1**(-1) + 16*s**(-1) + 16*u1**(-1) )
      LQ_GGV = LQ_GGV + SK3C0C(3,2)*Nc*Ck*Pi*alphas**3 * (  -32*ms1**2*
     +    s**(-3)*t1 - 64*ms1**2*s**(-2) + 32*ms1**2*s**(-1)*t1**(-1)
     +     + 64*ms1**4*s**(-3) + 32*s**(-2)*t1 + 32*s**(-1) )
      LQ_GGV = LQ_GGV + SK3C0C(3,2)*Cqed*Pi*alphas**3 * (  - 32*ms1**2*
     +    s**(-2) - 64*ms1**2*s**(-1)*t1**(-1) + 64*ms1**4*s**(-2)*
     +    t1**(-1) + 16*s**(-1) + 16*t1**(-1) )
      LQ_GGV = LQ_GGV + SK3D0(1,1)*Nc*Co*Pi*alphas**3 * (  - 16*ms1**2*
     +    s**(-2)*t1 - 16*ms1**2*s**(-1) - 32*ms1**4*s**(-1)*t1**(-1)
     +     - 16*s**(-3)*t1**3 - 16*s**(-2)*t1**2 - 8*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SK3D0(1,2)*Nc*Co*Pi*alphas**3 * ( 8 +16*ms1**2*
     +    s**(-2)*t1 - 32*ms1**4*s**(-1)*u1**(-1) + 16*s**(-3)*t1**3 + 
     +    32*s**(-2)*t1**2 + 24*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SK3D0(2,1)*Nc*Ck*Pi*alphas**3 * (  - 32*ms1**2*
     +    s**(-2)*t1 + 16*ms1**2*s**(-1) + 32*ms1**4*s**(-3)*t1 - 32*
     +    ms1**4*s**(-2) + 32*ms1**4*s**(-1)*t1**(-1) - 64*ms1**6*
     +    s**(-2)*t1**(-1) + 8*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SK3D0(2,1)*Cqed*Pi*alphas**3 * ( 32*ms1**2*
     +    s**(-1) + 48*ms1**2*u1**(-1) - 32*ms1**4*s**(-2) - 32*ms1**4*
     +    s**(-1)*t1**(-1) - 96*ms1**4*s**(-1)*u1**(-1) + 64*ms1**6*
     +    s**(-2)*t1**(-1) + 64*ms1**6*s**(-2)*u1**(-1) + 8*t1*u1**(-1)
     +     )
      LQ_GGV = LQ_GGV + SK3D0(2,2)*Nc*Ck*Pi*alphas**3 * (  - 8 + 32*
     +    ms1**2*s**(-2)*t1 + 48*ms1**2*s**(-1) - 32*ms1**4*s**(-3)*t1
     +     - 64*ms1**4*s**(-2) + 32*ms1**4*s**(-1)*u1**(-1) - 64*ms1**6
     +    *s**(-2)*u1**(-1) - 8*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SK3D0(2,2)*Cqed*Pi*alphas**3 * ( 32*ms1**2*
     +    s**(-1) + 48*ms1**2*t1**(-1) - 32*ms1**4*s**(-2) - 96*ms1**4*
     +    s**(-1)*t1**(-1) - 32*ms1**4*s**(-1)*u1**(-1) + 64*ms1**6*
     +    s**(-2)*t1**(-1) + 64*ms1**6*s**(-2)*u1**(-1) + 8*t1**(-1)*u1
     +     )
      LQ_GGV = LQ_GGV + SK3D0(3,1)*Nc*Ck*Pi*alphas**3 * (  - 16*ms1**2*
     +    s**(-1) - 32*ms1**4*s**(-2) - 32*ms1**4*s**(-1)*t1**(-1) - 32
     +    *ms1**4*s**(-1)*u1**(-1) - 8*s**(-2)*t1**2 - 8*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SK3D0(3,2)*Nc*Ck*Pi*alphas**3 * (  - 16*ms1**2*
     +    s**(-1) - 32*ms1**4*s**(-2) - 32*ms1**4*s**(-1)*t1**(-1) - 32
     +    *ms1**4*s**(-1)*u1**(-1) - 8*s**(-2)*t1**2 - 8*s**(-1)*t1 )
      LQ_GGV = LQ_GGV + SOF1(1)*Nc*Ck*Pi*alphas**3 *(256*ms1**2*s**(-4)
     +    *t1**2 + 256*ms1**2*s**(-3)*t1 - 128*ms1**2*s**(-2) - 128*
     +    ms1**2*s**(-1)*t1**(-1) - 128*ms1**2*s**(-1)*u1**(-1) + 512*
     +    ms1**4*s**(-3) + 256*ms1**4*s**(-2)*t1**(-1) + 256*ms1**4*
     +    s**(-2)*u1**(-1) - 128*ms1**4*s**(-1)*t1**(-2) - 128*ms1**4*
     +    s**(-1)*u1**(-2) + 256*ms1**6*s**(-2)*t1**(-2) + 256*ms1**6*
     +    s**(-2)*u1**(-2) - 128*s**(-3)*t1**2 - 128*s**(-2)*t1 - 64*
     +    s**(-1) )
      LQ_GGV = LQ_GGV + SOF1(1)*Cqed*Pi*alphas**3 * (  - 128*ms1**2*
     +    s**(-2) + 128*ms1**2*s**(-1)*t1**(-1) + 128*ms1**2*s**(-1)*
     +    u1**(-1) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-1) + 128*ms1**4*s**(-1)*t1**(-2) + 128*ms1**4*s**(-1)*
     +    u1**(-2) - 256*ms1**6*s**(-2)*t1**(-2) - 512*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-1) - 256*ms1**6*s**(-2)*u1**(-2) + 64*s**(-1)
     +     )
      LQ_GGV = LQ_GGV + SOF1(2)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     +    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) - 
     +    256*ms1**4*s**(-3) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4
     +    *s**(-2)*u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 128*ms1**6*
     +    s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(2)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-4)
     +    *t1**2 + 128*ms1**2*s**(-3)*t1 + 192*ms1**2*s**(-2) + 256*
     +    ms1**4*s**(-3) + 384*ms1**4*s**(-2)*t1**(-1) + 384*ms1**4*
     +    s**(-2)*u1**(-1) + 384*ms1**6*s**(-2)*t1**(-2) + 512*ms1**6*
     +    s**(-2)*t1**(-1)*u1**(-1) + 384*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(2)*Cqed*Pi*alphas**3 * (  - 64*ms1**2*
     +    s**(-2) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(3)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     +    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) - 
     +    256*ms1**4*s**(-3) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4
     +    *s**(-2)*u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 128*ms1**6*
     +    s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(3)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-4)
     +    *t1**2 + 128*ms1**2*s**(-3)*t1 + 192*ms1**2*s**(-2) + 256*
     +    ms1**4*s**(-3) + 384*ms1**4*s**(-2)*t1**(-1) + 384*ms1**4*
     +    s**(-2)*u1**(-1) + 384*ms1**6*s**(-2)*t1**(-2) + 512*ms1**6*
     +    s**(-2)*t1**(-1)*u1**(-1) + 384*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(3)*Cqed*Pi*alphas**3 * (  - 64*ms1**2*
     +    s**(-2) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u1**(-2) )
      LQ_GGV = LQ_GGV + SOF1(4)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     +    s**(-3)*t1 + 128*ms1**4*s**(-2)*u1**(-1) - 64*s**(-4)*t1**3
     +     - 64*s**(-3)*t1**2 )
      LQ_GGV = LQ_GGV + SOF1(4)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-1)
     +    *t1**(-1) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) + 128*ms1**4*s**(-1)*t1**(-2) + 64*s**(-2)*t1 + 64*
     +    s**(-1) )
      LQ_GGV = LQ_GGV + SOF1(5)*Nc*Co*Pi*alphas**3 *(128*ms1**2*s**(-3)
     +    *t1 + 128*ms1**2*s**(-2) + 128*ms1**4*s**(-2)*t1**(-1) + 64*
     +    s**(-4)*t1**3 + 128*s**(-3)*t1**2 + 64*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SOF1(5)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-1)
     +    *u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) + 128*ms1**4*s**(-1)*u1**(-2) - 64*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SOF1(6)*Nc*Co*Pi*alphas**3 *(128*ms1**2*s**(-3)
     +    *t1 + 128*ms1**2*s**(-2) + 128*ms1**4*s**(-2)*t1**(-1) + 64*
     +    s**(-4)*t1**3 + 128*s**(-3)*t1**2 + 64*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SOF1(6)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-1)
     +    *u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) + 128*ms1**4*s**(-1)*u1**(-2) - 64*s**(-2)*t1 )
      LQ_GGV = LQ_GGV + SOF1(7)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     +    s**(-3)*t1 + 128*ms1**4*s**(-2)*u1**(-1) - 64*s**(-4)*t1**3
     +     - 64*s**(-3)*t1**2 )
      LQ_GGV = LQ_GGV + SOF1(7)*Nc*Ck*Pi*alphas**3 *(128*ms1**2*s**(-1)
     +    *t1**(-1) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     +    u1**(-1) + 128*ms1**4*s**(-1)*t1**(-2) + 64*s**(-2)*t1 + 64*
     +    s**(-1) )
      LQ_GGV = LQ_GGV + SOF1(8)*Nc*Co*Pi*alphas**3 *(256*ms1**2*s**(-2)
     +     + 128*ms1**2*s**(-1)*t1**(-1) + 128*ms1**2*s**(-1)*u1**(-1)
     +     + 128*ms1**4*s**(-1)*t1**(-2) + 128*ms1**4*s**(-1)*u1**(-2)
     +     + 128*s**(-3)*t1**2 + 128*s**(-2)*t1 + 64*s**(-1) )

      LQ_GGV = fac * LQ_GGV  + dec

      end




c --------------------------------------------------------------------
      real*8 function LQ_GGH(s,t1,s4,ms1)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,alphas,fac 
      real*8 s,t1,u1,ms1,s4
      real*8 hardin(5)
      real*8 ANG4(71),COLO1(9)

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      alphas = 1.D0

      u1 = s4 - s - t1 
      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /(Nc**2-1.D0)**2

      hardin(1) = s
      hardin(2) = t1 
      hardin(3) = u1 
      hardin(4) = s4 
      hardin(5) = ms1**2 

      call LOGAS_LQ(hardin,COLO1)
      call ANGULAR_ARRAY_LQ(hardin,ANG4)

      LQ_GGH =
     +  + Nc*Co*Pi**4*alphas**3 * ( 4608*ms1**2*s**(-4)*t1*s4**(-1) - 
     +    2560*ms1**2*s**(-4)*t1*(t1+u1)**(-1) - 2048*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 1024*ms1**2*s**(-4)*t1**2*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 4608*ms1**2*s**(-3)*t1**(-2)*u1 + 512*ms1**2
     +    *s**(-3)*t1**(-1)*s4*(s+t1)**(-1) - 4096*ms1**2*s**(-3)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 8192*ms1**2*s**(-3)*t1**(-1) - 
     +    4608*ms1**2*s**(-3)*t1*u1**(-2) - 3584*ms1**2*s**(-3)*t1*
     +    s4**(-2) + 5120*ms1**2*s**(-3)*t1*s4**(-1)*(t1+u1)**(-1) - 
     +    4096*ms1**2*s**(-3)*t1**2*u1**(-3) - 1024*ms1**2*s**(-3)*
     +    t1**2*s4**(-2)*(t1+u1)**(-1) - 4096*ms1**2*s**(-3)*u1**(-1)*
     +    s4*(s+t1)**(-1) + 512*ms1**2*s**(-3)*u1**(-1)*s4*(s+u1)**(-1)
     +     + 8704*ms1**2*s**(-3)*u1**(-1) + 2560*ms1**2*s**(-3)*
     +    s4**(-1) - 3584*ms1**2*s**(-3)*(t1+u1)**(-1) - 8192*ms1**2*
     +    s**(-2)*t1**(-3)*u1 + 512*ms1**2*s**(-2)*t1**(-2)*s4*
     +    (s+t1)**(-1) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 * ( 5632*ms1**2*s**(-2)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 10240*ms1**2*s**(-2)*t1**(-2) - 
     +    4608*ms1**2*s**(-2)*t1**(-1)*u1**(-1)*s4*(s+t1)**(-1) - 4608*
     +    ms1**2*s**(-2)*t1**(-1)*u1**(-1)*s4*(s+u1)**(-1) + 9216*
     +    ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 9728*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) - 1536*ms1**2*s**(-2)*t1**(-1)*
     +    (t1+u1)**(-1) - 8192*ms1**2*s**(-2)*t1*u1**(-3) - 2560*ms1**2
     +    *s**(-2)*t1*s4**(-2)*(t1+u1)**(-1) + 5632*ms1**2*s**(-2)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 10240*ms1**2*s**(-2)*u1**(-2) - 12288*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 3072*ms1**2*s**(-2)*s4**(-2) + 
     +    6144*ms1**2*s**(-2)*s4**(-1)*(t1+u1)**(-1) - 1024*ms1**2*
     +    s**(-1)*t1**(-3)*s4*(s+u1)**(-1) - 5120*ms1**2*s**(-1)*
     +    t1**(-3) - 512*ms1**2*s**(-1)*t1**(-2)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 6144*ms1**2*s**(-1)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 * ( -7680*ms1**2*s**(-1)*
     +    t1**(-2)*u1**(-1) + 512*ms1**2*s**(-1)*t1**(-2)*s4**(-1) + 
     +    6144*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*
     +    ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*(s+u1)**(-1) - 7680*
     +    ms1**2*s**(-1)*t1**(-1)*u1**(-2) - 12288*ms1**2*s**(-1)*
     +    t1**(-1)*u1**(-1)*s4**(-1) + 1024*ms1**2*s**(-1)*t1**(-1)*
     +    s4**(-2) + 2560*ms1**2*s**(-1)*t1**(-1)*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*ms1**2*s**(-1)*u1**(-3)*s4*(s+t1)**(-1)
     +     - 5120*ms1**2*s**(-1)*u1**(-3) + 512*ms1**2*s**(-1)*u1**(-2)
     +    *s4**(-1) + 2048*ms1**2*s**(-1)*u1**(-1)*s4**(-2) - 2560*
     +    ms1**2*s**(-1)*s4**(-2)*(t1+u1)**(-1) - 1024*ms1**2*t1**(-3)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 1024*ms1**2*t1**(-3)*u1**(-1) + 
     +    512*ms1**2*t1**(-2)*u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**2*
     +    t1**(-2)*u1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*t1**(-2)*
     +    u1**(-2) + 512*ms1**2*t1**(-2)*u1**(-1)*s4**(-1) - 1024*
     +    ms1**2*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2*t1**(-1)
     +    *u1**(-3) + 512*ms1**2*t1**(-1)*u1**(-2)*s4**(-1) + 2048*
     +    ms1**2*t1**(-1)*u1**(-1)*s4**(-2) - 1024*ms1**2*t1**(-1)*
     +    s4**(-2)*(t1+u1)**(-1) - 4096*ms1**4*s**(-3)*t1**(-3)*u1 - 
     +    4096*ms1**4*s**(-3)*t1*u1**(-3) + 1024*ms1**4*s**(-3)*
     +    u1**(-1)*s4**(-1) - 2048*ms1**4*s**(-3)*s4**(-2) + 4096*
     +    ms1**4*s**(-2)*t1**(-4)*u1 - 1024*ms1**4*s**(-2)*t1**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 4096*
     +    ms1**4*s**(-2)*t1*u1**(-4) - 1024*ms1**4*s**(-2)*u1**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-2)*u1**(-1)*s4**(-2) + 8192*
     +    ms1**4*s**(-1)*t1**(-4) + 2048*ms1**4*s**(-1)*t1**(-3)*
     +    s4**(-1) + 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) + 
     +    2048*ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) + 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s**(-1)*u1**(-3)*s4**(-1) + 
     +    2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*ms1**4*s*t1**(-2)*
     +    u1**(-4) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 * ( 6144*ms1**4*t1**(-4)*
     +    u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-3)*u1**(-1)*s4**(-1) + 2048*ms1**4*t1**(-2)*u1**(-3) + 
     +    6144*ms1**4*t1**(-1)*u1**(-4) + 2048*ms1**4*t1**(-1)*u1**(-3)
     +    *s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-4) - 1024*ms1**6*
     +    s**(-2)*t1**(-2)*s4**(-2) + 4096*ms1**6*s**(-2)*u1**(-4) - 
     +    1024*ms1**6*s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*
     +    t1**(-4)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-1)*
     +    s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*u1**(-3)*s4**(-1) + 
     +    4096*ms1**6*s**(-1)*u1**(-4)*s4**(-1) + 2048*ms1**6*t1**(-4)*
     +    u1**(-2) + 4096*ms1**6*t1**(-4)*u1**(-1)*s4**(-1) + 2048*
     +    ms1**6*t1**(-2)*u1**(-4) + 4096*ms1**6*t1**(-1)*u1**(-4)*
     +    s4**(-1) - 1024*s**(-4)*t1**2*s4**(-1) + 1024*s**(-4)*t1**2*
     +    (t1+u1)**(-1) - 512*s**(-3)*t1**(-2)*u1**2 + 512*s**(-3)*
     +    t1**(-1)*u1*s4*(s+t1)**(-1) + 3328*s**(-3)*t1**(-1)*u1 + 512*
     +    s**(-3)*t1*u1**(-1)*s4*(s+u1)**(-1) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 * ( 3584*s**(-3)*t1*
     +    u1**(-1) - 3072*s**(-3)*t1*s4**(-1) + 2560*s**(-3)*t1*
     +    (t1+u1)**(-1) - 512*s**(-3)*t1**2*u1**(-2) - 1024*s**(-3)*
     +    t1**2*s4**(-1)*(t1+u1)**(-1) - 3584*s**(-3)*s4*(s+t1)**(-1)
     +     - 3584*s**(-3)*s4*(s+u1)**(-1) + 7680*s**(-3) + 512*s**(-2)*
     +    t1**(-2)*u1*s4*(s+t1)**(-1) - 512*s**(-2)*t1**(-2)*u1 - 3584*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 1024*s**(-2)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 1792*s**(-2)*t1**(-1) + 512*s**(-2)*t1*
     +    u1**(-2)*s4*(s+u1)**(-1) - 512*s**(-2)*t1*u1**(-2) - 2560*
     +    s**(-2)*t1*s4**(-1)*(t1+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4*
     +    (s+t1)**(-1) - 3584*s**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 1536*
     +    s**(-2)*u1**(-1) - 2304*s**(-2)*s4**(-1) + 2560*s**(-2)*
     +    (t1+u1)**(-1) - 1024*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) + 1024*
     +    s**(-1)*t1**(-2) + 1024*s**(-1)*t1**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 1024*s**(-1)*t1**(-1)*u1**(-1)*s4*(s+u1)**(-1)
     +     - 2048*s**(-1)*t1**(-1)*u1**(-1) )
      LQ_GGH = LQ_GGH + Nc*Co*Pi**4*alphas**3 *(1024*s**(-1)*t1**(-1)*
     +    s4**(-1) + 1024*s**(-1)*t1**(-1)*(t1+u1)**(-1) - 1024*s**(-1)
     +    *u1**(-2)*s4*(s+t1)**(-1) + 1024*s**(-1)*u1**(-2) + 2304*
     +    s**(-1)*u1**(-1)*s4**(-1) - 2560*s**(-1)*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*t1**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 1024
     +    *t1**(-2)*u1**(-1) - 1024*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1)
     +     + 1024*t1**(-1)*u1**(-2) + 2048*t1**(-1)*u1**(-1)*s4**(-1)
     +     - 1024*t1**(-1)*s4**(-1)*(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**2*s**(-4)*
     +    t1*s4**(-1) + 1024*ms1**2*s**(-4)*t1**2*s4**(-2) + 1024*
     +    ms1**2*s**(-4) - 512*ms1**2*s**(-3)*t1**(-1) + 1024*ms1**2*
     +    s**(-3)*t1*s4**(-2) - 1024*ms1**2*s**(-3)*u1**(-1) + 1024*
     +    ms1**2*s**(-3)*s4**(-1) + 1536*ms1**2*s**(-2)*t1**(-2) + 3072
     +    *ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 1536*ms1**2*s**(-2)*
     +    u1**(-2) + 1024*ms1**2*s**(-2)*u1**(-1)*s4**(-1) + 1536*
     +    ms1**2*s**(-2)*s4**(-2) + 2048*ms1**2*s**(-1)*t1**(-3) + 2048
     +    *ms1**2*s**(-1)*t1**(-2)*u1**(-1) + 2048*ms1**2*s**(-1)*
     +    t1**(-1)*u1**(-2) + 2048*ms1**2*s**(-1)*u1**(-3) + 2048*
     +    ms1**2*t1**(-3)*u1**(-1) + 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    1024*ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 2048*ms1**4*s**(-3)*
     +    s4**(-2) + 3072*ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*
     +    ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) + 3072*ms1**4*
     +    s**(-2)*t1**(-1)*s4**(-2) + 3072*ms1**4*s**(-2)*u1**(-2)*
     +    s4**(-1) )
      LQ_GGH = LQ_GGH + Nc*Ck*Pi**4*alphas**3 * ( 3072*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 4096*ms1**4*s**(-1)*t1**(-3)*u1**(-1) - 
     +    2048*ms1**4*s**(-1)*t1**(-3)*s4**(-1) - 2048*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-3) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) - 
     +    2048*ms1**4*s**(-1)*u1**(-3)*s4**(-1) - 2048*ms1**4*s*
     +    t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048*
     +    ms1**4*t1**(-4)*u1**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2) - 
     +    2048*ms1**4*t1**(-3)*u1**(-1)*s4**(-1) - 2048*ms1**4*t1**(-2)
     +    *u1**(-3) - 2048*ms1**4*t1**(-1)*u1**(-4) - 2048*ms1**4*
     +    t1**(-1)*u1**(-3)*s4**(-1) + 3072*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 
     +    3072*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 2048*ms1**6*t1**(-4)*
     +    u1**(-2) - 2048*ms1**6*t1**(-2)*u1**(-4) - 256*s**(-3)*
     +    t1**(-1)*u1 - 512*s**(-3)*t1*u1**(-1) + 512*s**(-3)*t1*
     +    s4**(-1) )
      LQ_GGH = LQ_GGH + Nc*Ck*Pi**4*alphas**3 * (  - 512*s**(-3) + 768*
     +    s**(-2)*t1**(-1) + 1024*s**(-2)*u1**(-1) - 256*s**(-2)*
     +    s4**(-1) + 1024*s**(-1)*t1**(-1)*u1**(-1) - 256*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + Cqed*Pi**4*alphas**3 * (  - 512*ms1**2*s**(-2)*
     +    t1**(-2) - 1536*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 512*ms1**2
     +    *s**(-2)*u1**(-2) - 512*ms1**2*s**(-2)*s4**(-2) - 1024*ms1**4
     +    *s**(-2)*t1**(-2)*s4**(-1) - 2048*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    1024*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 1024*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) - 1024*ms1**6*s**(-2)*t1**(-2)*s4**(-2) - 
     +    2048*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) - 1024*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) - 512*s**(-2)*t1**(-1) - 512*
     +    s**(-2)*u1**(-1) - 512*s**(-1)*t1**(-1)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(1)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(1)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(1)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(2)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**4*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(2)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) + 2048*ms1**6*s**(-2)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(2)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) - 1024*ms1**6*s**(-2)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(3)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**4*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(3)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) - 2048*ms1**6*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(3)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) + 1024*ms1**6*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(4)*Nc*Co*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 512*ms1**2*s**(-2) + 512*ms1**2*
     +    s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-3)*t1*u1**(-1) - 512*
     +    ms1**4*s**(-3)*t1*(t1+u1)**(-1) + 512*ms1**4*s**(-3) + 512*
     +    ms1**4*s**(-2)*u1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) + 
     +    512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) - 128*s**(-1)*t1*
     +    (t1+u1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(4)*Nc*Ck*Pi**4*alphas**3 * ( 320*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 512*ms1**2*s**(-2)*t1*s4**(-1) + 192*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) + 320*ms1**2*s**(-2) - 64*
     +    ms1**2*s**(-1)*t1**(-1)*s4*(s+t1)**(-1) - 448*ms1**2*s**(-1)*
     +    t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1) - 768*ms1**2*s**(-1)*s4**(-1) - 1024*
     +    ms1**4*s**(-3)*t1**(-1)*u1 - 1536*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 512*ms1**4*s**(-3)*t1*s4**(-1) - 2560*ms1**4*s**(-3) + 512
     +    *ms1**4*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 640*ms1**4*s**(-2)
     +    *t1**(-1) - 128*ms1**4*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 640
     +    *ms1**4*s**(-2)*u1**(-1) + 1024*ms1**4*s**(-2)*s4**(-1) - 640
     +    *ms1**4*s**(-1)*t1**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 128*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) - 512*
     +    ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 2048*ms1**6*s**(-4) - 1024
     +    *ms1**6*s**(-3)*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(4)*Nc*Ck*Pi**4*alphas**3 * ( -1024*ms1**6*
     +    s**(-3)*u1**(-1) + 1024*ms1**6*s**(-2)*u1**(-1)*s4**(-1) - 
     +    128*s**(-1)*t1**(-1)*u1 + 128*s**(-1)*t1*s4**(-1) - 128*
     +    s**(-1)*s4*(s+t1)**(-1) + 128*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(4)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 768*ms1**2*s**(-1)*t1**(-1) - 512*
     +    ms1**2*s**(-1)*s4**(-1) - 768*ms1**2*t1**(-1)*s4**(-1) + 512*
     +    ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 1024*ms1**4*s**(-3) - 1024*ms1**4*s**(-2)*t1**(-1) - 512*
     +    ms1**4*s**(-2)*u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 1536*
     +    ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 512*ms1**4*s**(-1)*
     +    u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-4) + 1024*ms1**6*s**(-3)
     +    *t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*
     +    s**(-2)*t1**(-1)*s4**(-1) - 1024*ms1**6*s**(-2)*u1**(-1)*
     +    s4**(-1) + 128*s**(-1)*t1**(-1)*u1 + 128*s*t1**(-1)*s4**(-1)
     +     - 128*t1**(-1) + 128*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(5)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(5)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(5)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(6)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**4*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(6)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) + 2048*ms1**6*s**(-2)*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(6)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) - 1024*ms1**6*s**(-2)*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(7)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**4*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(7)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) - 2048*ms1**6*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(7)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) + 1024*ms1**6*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(8)*Nc*Co*Pi**4*alphas**3 * (  -512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) + 512*ms1**2*s**(-1)*(t1+u1)**(-1)
     +     + 512*ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*
     +    (t1+u1)**(-1) + 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-2)*(t1+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)
     +     - 512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 128*s**(-1)*t1
     +    *(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(8)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 512*ms1**2*s**(-2)*t1*s4**(-1) + 256*
     +    ms1**2*s**(-2)*s4*(s+u1)**(-1) - 256*ms1**2*s**(-2) - 256*
     +    ms1**2*s**(-1)*t1**(-1)*s4*(s+u1)**(-1) + 256*ms1**2*s**(-1)*
     +    t1**(-1) - 512*ms1**2*s**(-1)*u1**(-1) - 256*ms1**2*s**(-1)*
     +    s4**(-1) - 1536*ms1**4*s**(-3)*t1**(-1)*u1 - 1024*ms1**4*
     +    s**(-3)*t1*u1**(-1) - 512*ms1**4*s**(-3)*t1*s4**(-1) - 2048*
     +    ms1**4*s**(-3) + 512*ms1**4*s**(-2)*t1**(-1)*s4*(s+u1)**(-1)
     +     + 512*ms1**4*s**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 512*ms1**4*
     +    s**(-2)*s4**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) - 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*
     +    s4**(-1) - 2048*ms1**6*s**(-4) - 1024*ms1**6*s**(-3)*t1**(-1)
     +     - 1024*ms1**6*s**(-3)*u1**(-1) + 1024*ms1**6*s**(-2)*
     +    t1**(-1)*s4**(-1) - 128*s**(-1)*t1*u1**(-1) - 128*s**(-1)*t1*
     +    s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(8)*Nc*Ck*Pi**4*alphas**3 * ( -128*s**(-1)*
     +    s4*(s+u1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(8)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 768*ms1**2*s**(-1)*u1**(-1) - 512*
     +    ms1**2*s**(-1)*s4**(-1) - 768*ms1**2*u1**(-1)*s4**(-1) + 512*
     +    ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 1024*ms1**4*s**(-3) - 512*ms1**4*s**(-2)*t1**(-1) - 1024*
     +    ms1**4*s**(-2)*u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 512*
     +    ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 1536*ms1**4*s**(-1)*
     +    u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-4) + 1024*ms1**6*s**(-3)
     +    *t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*
     +    s**(-2)*t1**(-1)*s4**(-1) - 1024*ms1**6*s**(-2)*u1**(-1)*
     +    s4**(-1) + 128*s**(-1)*t1*u1**(-1) + 128*s*u1**(-1)*s4**(-1)
     +     - 128*u1**(-1) + 128*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(9)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-4) )
      LQ_GGH = LQ_GGH + ANG4(9)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-4) )
      LQ_GGH = LQ_GGH + ANG4(10)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(10)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(11)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(12)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-4)*t1*(t1+u1)**(-1) + 1024*ms1**2*s**(-4) + 1024*ms1**2
     +    *s**(-3)*(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(12)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1*s4**(-1) - 1024*ms1**2*s**(-4) - 256*ms1**2*
     +    s**(-3)*t1**(-1) + 256*ms1**2*s**(-3)*u1**(-1) + 512*ms1**2*
     +    s**(-3)*s4**(-1) + 512*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 512
     +    *ms1**2*s**(-2)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) - 
     +    128*s**(-3)*t1**(-1)*u1 + 128*s**(-3)*t1*u1**(-1) - 512*
     +    s**(-3)*t1*s4**(-1) + 256*s**(-3) + 128*s**(-2)*t1**(-1) - 
     +    128*s**(-2)*u1**(-1) - 256*s**(-2)*s4**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) + 128*s**(-1)*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(13)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-4) )
      LQ_GGH = LQ_GGH + ANG4(14)*Nc*Co*Pi**4*alphas**3 * ( -2048*ms1**2
     +    *s**(-4)*u1 - 1024*ms1**2*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(15)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(16)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1*s4**(-1) - 1024*ms1**2*s**(-4)*t1*(t1+u1)**(-1) - 
     +    256*ms1**2*s**(-3)*t1**(-1) + 256*ms1**2*s**(-3)*u1**(-1) + 
     +    512*ms1**2*s**(-3)*s4**(-1) + 1024*ms1**2*s**(-3)*
     +    (t1+u1)**(-1) + 512*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 512*
     +    ms1**2*s**(-2)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) - 
     +    128*s**(-3)*t1**(-1)*u1 + 128*s**(-3)*t1*u1**(-1) - 512*
     +    s**(-3)*t1*s4**(-1) + 256*s**(-3) + 128*s**(-2)*t1**(-1) - 
     +    128*s**(-2)*u1**(-1) - 256*s**(-2)*s4**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) + 128*s**(-1)*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(17)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1 + 512*ms1**2*s**(-2)*t1*u1**(-1) - 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1)
     +     + 512*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) + 1024*ms1**2*
     +    s**(-1)*t1*u1**(-2) + 512*ms1**2*s**(-1)*u1**(-1) + 512*
     +    ms1**2*s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-3)*t1*
     +    (t1+u1)**(-1) - 512*ms1**4*s**(-3) - 512*ms1**4*s**(-2)*
     +    t1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) + 512*ms1**4*
     +    s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*
     +    t1**(-2) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-1)*(t1+u1)**(-1) - 384*s**(-3)*t1*u1 - 512*
     +    s**(-3)*t1**2 - 256*s**(-3)*t1**3*u1**(-1) - 128*s**(-3)*
     +    u1**2 - 128*s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*t1*s4*
     +    (s+u1)**(-1) - 1152*s**(-2)*t1 - 256*s**(-2)*t1**2*u1**(-1)*
     +    s4*(s+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(17)*Nc*Co*Pi**4*alphas**3 * ( -768*s**(-2)
     +    *t1**2*u1**(-1) - 768*s**(-2)*u1 - 128*s**(-1)*t1**(-1)*u1 - 
     +    512*s**(-1)*t1*u1**(-1) + 128*s**(-1)*t1*(t1+u1)**(-1) + 128*
     +    s**(-1)*s4*(s+u1)**(-1) - 512*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(18)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*u1 + 512*ms1**2*s**(-2)*t1**(-1)*u1 + 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1)
     +     + 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 512*ms1**2*s**(-1)*
     +    t1**(-1) + 256*ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1) + 512*ms1**2*s**(-1)*(t1+u1)**(-1) - 
     +    512*ms1**4*s**(-3)*t1*(t1+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) - 1024*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-1)*u1**(-2) + 512*ms1**4*
     +    s**(-1)*u1**(-1)*(t1+u1)**(-1) - 256*s**(-3)*t1**(-1)*u1**3
     +     - 384*s**(-3)*t1*u1 - 128*s**(-3)*t1**2 - 512*s**(-3)*u1**2
     +     - 256*s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) - 768*s**(-2)*
     +    t1**(-1)*u1**2 - 768*s**(-2)*t1 - 128*s**(-2)*t1**2*u1**(-1)
     +     - 256*s**(-2)*u1*s4*(s+t1)**(-1) - 1152*s**(-2)*u1 - 512*
     +    s**(-1)*t1**(-1)*u1 )
      LQ_GGH = LQ_GGH + ANG4(18)*Nc*Co*Pi**4*alphas**3 * ( -128*s**(-1)
     +    *t1*u1**(-1) - 128*s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*
     +    (s+t1)**(-1) - 384*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(19)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 256*ms1**2*s**(-2)*t1*u1**(-1) + 256*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) + 256*ms1**2*s**(-2)*s4*
     +    (s+u1)**(-1) + 1024*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 512*ms1**2*s**(-1)*t1**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 512*ms1**2*s**(-1)*
     +    u1**(-1) + 1024*ms1**4*s**(-3)*t1**(-1)*u1 + 1024*ms1**4*
     +    s**(-3)*t1*u1**(-1) + 2048*ms1**4*s**(-3) - 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 1024*ms1**4*s**(-2)*t1**(-1) + 512
     +    *ms1**4*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 512*ms1**4*s**(-2)
     +    *u1**(-1)*s4*(s+u1)**(-1) + 1024*ms1**4*s**(-2)*u1**(-1) + 
     +    512*ms1**4*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*
     +    s**(-1)*t1**(-2) + 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-1)*u1**(-2) + 2048*ms1**6*
     +    s**(-4) )
      LQ_GGH = LQ_GGH + ANG4(19)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**6*
     +    s**(-3)*t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) + 128*s**(-1)
     +    *t1**(-1)*u1 + 128*s**(-1)*t1*u1**(-1) + 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) + 256*s**(-1) + 
     +    128*t1**(-1) + 128*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(19)*Cqed*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) - 768*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*
     +    s**(-1)*u1**(-1) - 768*ms1**2*t1**(-1)*u1**(-1) - 512*ms1**4*
     +    s**(-3)*t1**(-1)*u1 - 512*ms1**4*s**(-3)*t1*u1**(-1) - 1024*
     +    ms1**4*s**(-3) - 1536*ms1**4*s**(-2)*t1**(-1) - 1536*ms1**4*
     +    s**(-2)*u1**(-1) - 1536*ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 
     +    1024*ms1**6*s**(-4) - 1024*ms1**6*s**(-3)*t1**(-1) - 1024*
     +    ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-1) - 128*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*t1*u1**(-1)
     +     - 256*s**(-1) - 128*s*t1**(-1)*u1**(-1) - 256*t1**(-1) - 256
     +    *u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(20)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*u1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) + 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) + 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1*u1**(-1)
     +     + 128*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*s**(-2)*
     +    t1**(-1) + 128*s**(-1)*t1**(-1)*u1**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(20)*Cqed*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    256*s**(-2)*t1**(-1) - 128*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(21)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) + 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) + 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1)*s4**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1**(-1)*u1
     +     - 128*s**(-3)*t1*s4**(-1) - 128*s**(-3) + 256*s**(-2)*
     +    u1**(-1) - 128*s**(-2)*s4**(-1) + 128*s**(-1)*t1**(-1)*
     +    u1**(-1) - 128*s**(-1)*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(21)*Cqed*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    128*s**(-2)*t1**(-1) - 256*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(36)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 1024*ms1**4*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(36)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1024*ms1**4*s**(-3) )
      LQ_GGH = LQ_GGH + ANG4(36)*Cqed*Pi**4*alphas**3 * (  -256*ms1**2*
     +    s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(37)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-3)*t1*(t1+u1)**(-1) - 512*ms1**2*s**(-3) + 1024*ms1**2*
     +    s**(-2)*(t1+u1)**(-1) - 1024*ms1**4*s**(-3)*(t1+u1)**(-1) + 
     +    256*s**(-3)*t1 - 512*s**(-3)*t1**2*(t1+u1)**(-1) - 256*
     +    s**(-3)*u1 )
      LQ_GGH = LQ_GGH + ANG4(37)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1**(-1)*u1 - 256*ms1**2*s**(-3)*t1*u1**(-1) + 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3) + 512*ms1**2*
     +    s**(-2)*t1**(-1) + 768*ms1**2*s**(-2)*u1**(-1) - 2560*ms1**2*
     +    s**(-2)*s4**(-1) - 256*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 768
     +    *ms1**2*s**(-1)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1) - 512*ms1**4*s**(-3)*u1**(-1) + 4096*ms1**4*s**(-3)*
     +    s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 1024*ms1**4
     +    *s**(-2)*u1**(-1)*s4**(-1) + 128*s**(-2)*t1*u1**(-1) - 256*
     +    s**(-2)*t1*s4**(-1) - 128*s**(-2) - 128*s**(-1)*u1**(-1) + 
     +    256*s**(-1)*s4**(-1) + 128*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(37)*Cqed*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1**(-1) + 256*ms1**2*s**(-2)*u1**(-1) - 512*ms1**2*
     +    s**(-2)*s4**(-1) - 512*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 512
     +    *ms1**2*s**(-1)*u1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 
     +    128*s**(-2)*t1**(-1)*u1 + 128*s**(-2)*t1*u1**(-1) - 128*
     +    s**(-1)*t1**(-1) - 128*s**(-1)*u1**(-1) + 256*s**(-1)*
     +    s4**(-1) + 128*t1**(-1)*s4**(-1) + 128*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(38)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-4)*u1**2 - 1024*ms1**2*s**(-3)*u1 - 3072*ms1**2*s**(-2)
     +     )
      LQ_GGH = LQ_GGH + ANG4(39)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1 - 1024*ms1**2*s**(-4)*t1**2*s4**(-1) - 1024*ms1**2
     +    *s**(-4)*u1 + 256*ms1**2*s**(-3)*t1*u1**(-1) - 1024*ms1**2*
     +    s**(-3)*t1*s4**(-1) - 512*ms1**2*s**(-3)*t1*(t1+u1)**(-1) - 
     +    1280*ms1**2*s**(-3) - 256*ms1**2*s**(-2)*u1**(-1) - 1536*
     +    ms1**2*s**(-2)*s4**(-1) + 1024*ms1**2*s**(-2)*(t1+u1)**(-1)
     +     - 512*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**2*s**(-1)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1) + 1024*ms1**4
     +    *s**(-3)*s4**(-1) - 1024*ms1**4*s**(-3)*(t1+u1)**(-1) + 512*
     +    ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-1) + 128*s**(-3)*t1**(-1)*u1**2 + 384*s**(-3)*
     +    t1 + 256*s**(-3)*t1**2*u1**(-1) - 512*s**(-3)*t1**2*s4**(-1)
     +     - 512*s**(-3)*t1**2*(t1+u1)**(-1) - 512*s**(-3)*u1 - 512*
     +    s**(-2)*t1*s4**(-1) + 256*s**(-2) - 256*s**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(40)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*u1**(-1) - 512*ms1**6*s**(-2)*
     +    u1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(40)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1536*ms1**4*s**(-2)*u1**(-1) + 1536*ms1**6*s**(-2)*
     +    u1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(40)*Cqed*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*u1**(-1) - 512*ms1**6*s**(-2)*
     +    u1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(41)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-2)*s4*(s+t1)**(-1) - 128*s**(-2)*t1*u1**(-1) - 256*
     +    s**(-2)*s4*(s+t1)**(-1) - 128*s**(-1)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(41)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1*u1**(-1) + 256*ms1**2*s**(-3)*t1*s4**(-1) - 512*
     +    ms1**2*s**(-3) + 512*ms1**2*s**(-2)*t1**(-1) + 512*ms1**2*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 768*ms1**2*s**(-2)*
     +    s4**(-1) + 768*ms1**2*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**2*
     +    s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*u1**(-1) - 512
     +    *ms1**4*s**(-3)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1) + 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-2)*u1**(-2)*s4*(s+t1)**(-1) + 1024*ms1**4*s**(-2)*
     +    u1**(-2) + 1536*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-1)*s4**(-1) + 2048*ms1**6*s**(-2)*u1**(-2)*
     +    s4**(-1) - 256*s**(-2)*t1**(-1)*u1 - 256*s**(-2)*t1*s4**(-1)
     +     + 256*s**(-2)*s4*(s+t1)**(-1) + 128*s**(-1)*u1**(-1) - 256*
     +    s**(-1)*s4**(-1) + 128*t1**(-1)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(41)*Cqed*Pi**4*alphas**3 * ( -1536*ms1**2*
     +    s**(-2)*t1**(-1) - 768*ms1**2*s**(-2)*u1**(-1) + 256*ms1**2*
     +    s**(-2)*s4**(-1) - 1024*ms1**2*s**(-1)*t1**(-1)*u1**(-1) + 
     +    768*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 1024*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-1) - 1536*ms1**4*s**(-2)*t1**(-1)*s4**(-1) - 
     +    512*ms1**4*s**(-2)*u1**(-2) - 1024*ms1**4*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    1024*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 1024*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-1) - 256*s**(-2)*t1**(-1)*u1 - 128*
     +    s**(-2)*t1*u1**(-1) - 256*s**(-2) - 256*s**(-1)*t1**(-1) - 
     +    384*s**(-1)*u1**(-1) - 128*s**(-1)*s4**(-1) - 256*t1**(-1)*
     +    u1**(-1) - 128*t1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(43)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**6*s**(-2)*
     +    t1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(43)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1536*ms1**4*s**(-2)*t1**(-1) + 1536*ms1**6*s**(-2)*
     +    t1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(43)*Cqed*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**6*s**(-2)*
     +    t1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(44)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*t1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 128*s**(-2)*t1**(-1)*u1 - 256*
     +    s**(-2)*s4*(s+u1)**(-1) - 128*s**(-1)*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(44)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1**(-1)*u1 - 256*ms1**2*s**(-3)*t1*s4**(-1) - 256*
     +    ms1**2*s**(-3) + 512*ms1**2*s**(-2)*t1**(-1)*s4*(s+u1)**(-1)
     +     + 512*ms1**2*s**(-2)*u1**(-1) + 512*ms1**2*s**(-2)*s4**(-1)
     +     + 768*ms1**2*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**2*s**(-1)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1) - 512*ms1**4*
     +    s**(-3)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 1024*ms1**4*s**(-2)*t1**(-2) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1) + 1536*ms1**4*s**(-2)*t1**(-1)*
     +    s4**(-1) + 1024*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) + 2048*ms1**6*s**(-2)*
     +    t1**(-2)*s4**(-1) + 1024*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*
     +    s4**(-1) - 256*s**(-2)*t1*u1**(-1) + 256*s**(-2)*t1*s4**(-1)
     +     + 256*s**(-2)*s4*(s+u1)**(-1) - 256*s**(-2) + 128*s**(-1)*
     +    t1**(-1) + 128*t1**(-1)*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(44)*Cqed*Pi**4*alphas**3 * ( -768*ms1**2*
     +    s**(-2)*t1**(-1) - 1536*ms1**2*s**(-2)*u1**(-1) + 256*ms1**2*
     +    s**(-2)*s4**(-1) - 1024*ms1**2*s**(-1)*t1**(-1)*u1**(-1) + 
     +    768*ms1**2*s**(-1)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-2)*
     +    t1**(-2) - 1024*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 1024*
     +    ms1**4*s**(-2)*t1**(-1)*s4**(-1) - 1536*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)*
     +    s4**(-1) - 1024*ms1**6*s**(-2)*t1**(-2)*s4**(-1) - 1024*
     +    ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-2)*
     +    t1**(-1)*u1 - 256*s**(-2)*t1*u1**(-1) - 256*s**(-2) - 384*
     +    s**(-1)*t1**(-1) - 256*s**(-1)*u1**(-1) - 128*s**(-1)*
     +    s4**(-1) - 256*t1**(-1)*u1**(-1) - 128*u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(48)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) - 256*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) - 256*ms1**2*s**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**2*s**(-2) - 256*ms1**2*s**(-1)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) - 256*
     +    ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*ms1**2*s**(-1)*
     +    u1**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) + 512*
     +    ms1**4*s**(-1)*t1**(-2) - 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) - 512*s**(-3)*
     +    t1**(-1)*u1**3 - 1536*s**(-3)*t1*u1 - 1024*s**(-3)*t1**2 - 
     +    512*s**(-3)*t1**3*u1**(-1) - 1024*s**(-3)*u1**2 + 256*s**(-2)
     +    *t1**(-1)*u1**2*s4*(s+t1)**(-1) - 768*s**(-2)*t1**(-1)*u1**2
     +     - 256*s**(-2)*t1*s4*(s+u1)**(-1) - 1536*s**(-2)*t1 + 256*
     +    s**(-2)*t1**2*u1**(-1)*s4*(s+u1)**(-1) - 768*s**(-2)*t1**2*
     +    u1**(-1) - 256*s**(-2)*u1*s4*(s+t1)**(-1) - 1536*s**(-2)*u1
     +     - 384*s**(-1)*t1**(-1)*u1 )
      LQ_GGH = LQ_GGH + ANG4(48)*Nc*Co*Pi**4*alphas**3 * ( -384*s**(-1)
     +    *t1*u1**(-1) - 128*s**(-1)*s4*(s+t1)**(-1) - 128*s**(-1)*s4*
     +    (s+u1)**(-1) - 768*s**(-1) - 128*t1**(-1) - 128*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(49)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*u1 - 256*ms1**2*s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2
     +    *s**(-1)*(t1+u1)**(-1) - 512*ms1**4*s**(-3)*t1**(-1)*u1 - 512
     +    *ms1**4*s**(-3) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*u1**(-1)*
     +    (t1+u1)**(-1) - 128*s**(-3)*t1*u1 + 128*s**(-3)*t1**2 - 256*
     +    s**(-3)*t1**3*(t1+u1)**(-1) - 256*s**(-2)*t1**2*(t1+u1)**(-1)
     +     - 128*s**(-1)*t1*(t1+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(49)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*s4*(s+t1)**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 512*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-1) - 512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) + 512*
     +    ms1**4*s**(-1)*u1**(-2) + 128*s**(-2)*t1**2*u1**(-1) + 128*
     +    s**(-2)*u1 + 128*s**(-1)*t1*u1**(-1) - 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(50)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1 + 256*ms1**2*s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2
     +    *s**(-2) - 256*ms1**2*s**(-1)*(t1+u1)**(-1) - 512*ms1**4*
     +    s**(-3)*t1*u1**(-1) - 512*ms1**4*s**(-3) - 512*ms1**4*s**(-2)
     +    *u1**(-1) - 512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 128*
     +    s**(-3)*t1*u1 - 256*s**(-3)*t1**2 + 256*s**(-3)*t1**3*
     +    (t1+u1)**(-1) - 128*s**(-3)*u1**2 + 256*s**(-2)*t1 - 256*
     +    s**(-2)*t1**2*(t1+u1)**(-1) - 256*s**(-2)*u1 + 128*s**(-1)*t1
     +    *(t1+u1)**(-1) - 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(50)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*s4*(s+u1)**(-1) - 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 512*ms1**2*s**(-1)*t1**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+u1)**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) + 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-2)*t1**(-1)*u1**2 + 128*
     +    s**(-2)*t1 + 128*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*s4*
     +    (s+u1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(51)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +     )
      LQ_GGH = LQ_GGH + ANG4(52)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(53)*Nc*Co*Pi**4*alphas**3 * ( -2048*ms1**2
     +    *s**(-1)*t1*u1**(-1) - 1024*ms1**2*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(54)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 1024*ms1**2*s**(-2)*t1*u1**(-1) - 256*
     +    ms1**2*s**(-2)*t1*s4**(-1) - 256*ms1**2*s**(-2)*t1*
     +    (t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) - 2304*
     +    ms1**2*s**(-2) - 256*ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*
     +    s**(-1)*t1*u1**(-2) + 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) - 1792*ms1**2*s**(-1)*u1**(-1) - 256*ms1**2*
     +    s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)
     +     + 512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-2) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) + 512
     +    *ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 512*s**(-3)*t1**(-1)
     +    *u1**3 + 2048*s**(-3)*t1*u1 + 2048*s**(-3)*t1**2 + 1024*
     +    s**(-3)*t1**3*u1**(-1) - 256*s**(-3)*t1**3*s4**(-1) - 256*
     +    s**(-3)*t1**3*(t1+u1)**(-1) + 1536*s**(-3)*u1**2 - 256*
     +    s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) + 512*s**(-2)*t1**(-1)
     +    *u1**2 )
      LQ_GGH = LQ_GGH + ANG4(54)*Nc*Co*Pi**4*alphas**3 * (2048*s**(-2)*
     +    t1 + 1536*s**(-2)*t1**2*u1**(-1) - 512*s**(-2)*t1**2*s4**(-1)
     +     - 256*s**(-2)*t1**2*(t1+u1)**(-1) - 256*s**(-2)*u1*s4*
     +    (s+t1)**(-1) + 1280*s**(-2)*u1 + 128*s**(-1)*t1**(-1)*u1 + 
     +    512*s**(-1)*t1*u1**(-1) - 384*s**(-1)*t1*s4**(-1) - 128*
     +    s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*(s+t1)**(-1) + 384*
     +    s**(-1) - 128*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(55)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +     )
      LQ_GGH = LQ_GGH + ANG4(56)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(57)*Nc*Co*Pi**4*alphas**3 * ( -2048*ms1**2
     +    *s**(-1)*t1**(-1)*u1 - 1024*ms1**2*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(58)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) + 256*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 256*ms1**2*s**(-2)*t1*
     +    (t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) - 2816*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 256*ms1**2
     +    *s**(-1)*t1**(-1)*s4*(s+u1)**(-1) - 1792*ms1**2*s**(-1)*
     +    t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1) + 256*ms1**2*s**(-1)*
     +    s4**(-1) - 256*ms1**2*s**(-1)*(t1+u1)**(-1) + 512*ms1**4*
     +    s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*
     +    t1**(-2) + 1024*ms1**4*s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**4*s**(-1)*u1**(-1)*
     +    (t1+u1)**(-1) + 1024*s**(-3)*t1**(-1)*u1**3 + 2560*s**(-3)*t1
     +    *u1 + 1024*s**(-3)*t1**2 + 512*s**(-3)*t1**3*u1**(-1) + 256*
     +    s**(-3)*t1**3*s4**(-1) + 256*s**(-3)*t1**3*(t1+u1)**(-1) + 
     +    1536*s**(-3)*u1**2 + 1536*s**(-2)*t1**(-1)*u1**2 - 256*
     +    s**(-2)*t1*s4*(s+u1)**(-1) )
      LQ_GGH = LQ_GGH + ANG4(58)*Nc*Co*Pi**4*alphas**3 * (1536*s**(-2)*
     +    t1 - 256*s**(-2)*t1**2*u1**(-1)*s4*(s+u1)**(-1) + 512*s**(-2)
     +    *t1**2*u1**(-1) + 256*s**(-2)*t1**2*s4**(-1) - 256*s**(-2)*
     +    t1**2*(t1+u1)**(-1) + 1536*s**(-2)*u1 + 512*s**(-1)*t1**(-1)*
     +    u1 + 128*s**(-1)*t1*u1**(-1) + 128*s**(-1)*t1*s4**(-1) + 128*
     +    s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) + 128*
     +    s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(59)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*t1**2 )
      LQ_GGH = LQ_GGH + ANG4(59)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**2 )
      LQ_GGH = LQ_GGH + ANG4(60)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*t1 - 1024*ms1**4*s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(60)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1 + 1024*ms1**4*s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(61)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-1)*t1*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(61)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**2*u1**(-1) + 1024*ms1**2*s**(-1)*t1*u1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(62)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1 - 256*ms1**2*s**(-3)*u1 - 512*ms1**2*s**(-2)*t1*
     +    u1**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*
     +    s**(-2) - 256*ms1**2*s**(-1)*t1**(-1)*s4*(s+u1)**(-1) + 256*
     +    ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*s**(-1)*t1*u1**(-2) - 
     +    512*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*s**(-3)*t1**(-1)*u1
     +     + 1024*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*s**(-1)*t1**(-2)
     +    *s4*(s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) + 1024*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-3)*t1*u1 + 256*s**(-3)*
     +    t1**2 + 256*s**(-3)*t1**3*u1**(-1) - 256*s**(-2)*t1*s4*
     +    (s+u1)**(-1) + 640*s**(-2)*t1 + 256*s**(-2)*t1**2*u1**(-1)*s4
     +    *(s+u1)**(-1) + 768*s**(-2)*t1**2*u1**(-1) + 512*s**(-1)*t1*
     +    u1**(-1) - 128*s**(-1)*s4*(s+u1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(62)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) + 
     +    768*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 256*ms1**2*s**(-1)*u1**(-1) + 256*ms1**2*
     +    s**(-1)*s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-2)*t1**(-1) + 512*ms1**4*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 1536*ms1**4*s**(-2)*
     +    u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) - 1024*ms1**4*s**(-1)*
     +    t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 
     +    512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-2) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 384
     +    *s**(-2)*t1 - 512*s**(-2)*t1**2*u1**(-1) + 128*s**(-2)*t1**2*
     +    s4**(-1) - 128*s**(-2)*u1 - 512*s**(-1)*t1*u1**(-1) + 128*
     +    s**(-1)*t1*s4**(-1) + 128*s**(-1)*s4*(s+t1)**(-1) - 128*
     +    s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(63)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*u1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) - 512*ms1**4*
     +    s**(-3)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1*u1**(-1) + 128*
     +    s**(-3)*t1*s4**(-1) - 256*s**(-3) - 128*s**(-2)*u1**(-1) + 
     +    128*s**(-2)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(63)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    256*s**(-2)*t1**(-1) - 128*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(64)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*u1**2 )
      LQ_GGH = LQ_GGH + ANG4(64)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*u1**2 )
      LQ_GGH = LQ_GGH + ANG4(65)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*u1 - 1024*ms1**4*s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(65)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*u1 + 1024*ms1**4*s**(-2) )
      LQ_GGH = LQ_GGH + ANG4(66)*Nc*Co*Pi**4*alphas**3 * ( -1024*ms1**2
     +    *s**(-1)*t1**(-1)*u1 )
      LQ_GGH = LQ_GGH + ANG4(66)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**(-1)*u1**2 + 1024*ms1**2*s**(-1)*t1**(-1)*u1 )
      LQ_GGH = LQ_GGH + ANG4(67)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1 - 256*ms1**2*s**(-3)*u1 - 512*ms1**2*s**(-2)*
     +    t1**(-1)*u1 - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) - 1024*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-2)*u1 - 512*ms1**2
     +    *s**(-1)*t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 256*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*
     +    s**(-3)*t1*u1**(-1) + 1024*ms1**4*s**(-2)*u1**(-1) + 1024*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) + 256*
     +    s**(-3)*t1**(-1)*u1**3 + 128*s**(-3)*t1*u1 + 256*s**(-3)*
     +    u1**2 + 256*s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) + 768*
     +    s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*u1*s4*(s+t1)**(-1) + 640
     +    *s**(-2)*u1 + 512*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(67)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) + 
     +    768*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) + 256*ms1**2*
     +    s**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 1536*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-2)*u1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 512*ms1**4*s**(-1)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*t1**(-2) - 1024
     +    *ms1**4*s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 
     +    512*s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*t1 + 128*s**(-2)*
     +    t1**2*s4**(-1) - 256*s**(-2)*u1 - 512*s**(-1)*t1**(-1)*u1 + 
     +    128*s**(-1)*t1*s4**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) - 128*
     +    s**(-1) )
      LQ_GGH = LQ_GGH + ANG4(68)*Nc*Co*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-3)*t1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) - 512*ms1**4*
     +    s**(-3)*t1**(-1)*s4**(-1) - 128*s**(-3)*t1**(-1)*u1 - 128*
     +    s**(-3)*t1*s4**(-1) - 128*s**(-3) - 128*s**(-2)*t1**(-1) )
      LQ_GGH = LQ_GGH + ANG4(68)*Nc*Ck*Pi**4*alphas**3 * ( -256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    128*s**(-2)*t1**(-1) - 256*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      LQ_GGH = LQ_GGH + ANG4(70)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*t1**2*u1**(-2) - 1024*ms1**2*s**(-1)*t1*u1**(-2) - 
     +    512*ms1**2*u1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(70)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**2*u1**(-2) + 1024*ms1**2*s**(-1)*t1*u1**(-2) + 
     +    512*ms1**2*u1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(71)*Nc*Co*Pi**4*alphas**3 * ( -512*ms1**2*
     +    s**(-2)*t1**(-2)*u1**2 - 1024*ms1**2*s**(-1)*t1**(-2)*u1 - 
     +    512*ms1**2*t1**(-2) )
      LQ_GGH = LQ_GGH + ANG4(71)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**(-2)*u1**2 + 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 
     +    512*ms1**2*t1**(-2) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-4)*t1**(-2)*u1**2 - 4096*ms1**2*s**(-4)*t1*s4**(-1) + 
     +    2048*ms1**2*s**(-4)*t1**2*u1**(-2) + 4096*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 6144*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 2048*ms1**2*s**(-3)*t1**(-2)*u1 - 14336*
     +    ms1**2*s**(-3)*t1**(-1) - 2048*ms1**2*s**(-3)*t1*u1**(-2) + 
     +    4096*ms1**2*s**(-3)*t1*s4**(-2) - 4096*ms1**2*s**(-3)*t1**2*
     +    u1**(-3) - 14336*ms1**2*s**(-3)*u1**(-1) + 6144*ms1**2*
     +    s**(-3)*s4**(-1) - 8192*ms1**2*s**(-2)*t1**(-3)*u1 - 4096*
     +    ms1**2*s**(-2)*t1**(-2)*s4*(s+u1)**(-1) + 1024*ms1**2*s**(-2)
     +    *t1**(-2)*s4**2*(s+u1)**(-2) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 16384*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1) + 8192*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 8192*
     +    ms1**2*s**(-2)*t1*u1**(-3) - 4096*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*u1**(-2)*s4**2*(s+t1)**(-2) + 8192*ms1**2*s**(-2)*
     +    u1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*s4**(-2) - 6144*
     +    ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**2*(s+t1)**(-2) + 4096*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 6144*ms1**2*s**(-1)*u1**(-3) - 2048*
     +    ms1**2*t1**(-3)*u1**(-1) - 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    4096*ms1**4*s**(-3)*t1**(-3)*u1 - 12288*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*t1*u1**(-3) - 12288*
     +    ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 8192*ms1**4*s**(-3)*
     +    s4**(-2) + 4096*ms1**4*s**(-2)*t1**(-4)*u1 + 2048*ms1**4*
     +    s**(-2)*t1**(-3)*s4*(s+u1)**(-1) - 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 8192*ms1**4*s**(-2)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 4096*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2) - 16384*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 
     +    4096*ms1**4*s**(-2)*t1*u1**(-4) + 2048*ms1**4*s**(-2)*
     +    u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*s**(-2)*u1**(-3) + 
     +    2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 8192*ms1**4*s**(-1)*t1**(-4) + 6144*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1) + 4096*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-2) - 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*
     +    s4**(-1) + 6144*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3) - 2048*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*
     +    ms1**4*s*t1**(-2)*u1**(-4) + 6144*ms1**4*t1**(-4)*u1**(-1) - 
     +    2048*ms1**4*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 2048*ms1**4*
     +    t1**(-3)*u1**(-2)*s4**2*(s+u1)**(-2) + 2048*ms1**4*t1**(-3)*
     +    u1**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 
     +    2048*ms1**4*t1**(-2)*u1**(-3)*s4**2*(s+t1)**(-2) + 2048*
     +    ms1**4*t1**(-2)*u1**(-3) + 6144*ms1**4*t1**(-1)*u1**(-4) - 
     +    4096*ms1**6*s**(-2)*t1**(-4)*s4*(s+u1)**(-1) + 2048*ms1**6*
     +    s**(-2)*t1**(-4)*s4**2*(s+u1)**(-2) + 6144*ms1**6*s**(-2)*
     +    t1**(-4) + 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1) + 4096*
     +    ms1**6*s**(-2)*t1**(-2)*u1**(-2) - 8192*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( -4096*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-3) - 8192*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2)*s4**(-1) - 4096*ms1**6*s**(-2)*u1**(-4)*s4*
     +    (s+t1)**(-1) + 2048*ms1**6*s**(-2)*u1**(-4)*s4**2*
     +    (s+t1)**(-2) + 6144*ms1**6*s**(-2)*u1**(-4) + 4096*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*t1**(-4)*
     +    u1**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2) + 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*
     +    u1**(-4) + 2048*ms1**6*t1**(-4)*u1**(-2) + 2048*ms1**6*
     +    t1**(-2)*u1**(-4) + 2048*s**(-4)*t1**(-2)*u1**3 + 2048*
     +    s**(-4)*t1**(-1)*u1**2 + 2048*s**(-4)*t1 + 2048*s**(-4)*t1**2
     +    *u1**(-1) + 4096*s**(-4)*t1**2*s4**(-1) + 2048*s**(-4)*t1**3*
     +    u1**(-2) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * (6144*s**(-4)*
     +    u1 + 4096*s**(-3)*t1**(-2)*u1**2 + 4096*s**(-3)*t1*s4**(-1)
     +     + 4096*s**(-3)*t1**2*u1**(-2) + 3072*s**(-2)*t1**(-2)*u1 + 
     +    2048*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) - 1024*s**(-2)*t1**(-1)
     +    *s4*(s+u1)**(-1) + 1024*s**(-2)*t1**(-1)*s4**2*(s+u1)**(-2)
     +     - 1024*s**(-2)*t1**(-1) + 3072*s**(-2)*t1*u1**(-2) - 1024*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 2048*s**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 
     +    1024*s**(-2)*u1**(-1) + 2048*s**(-2)*s4**(-1) + 1024*s**(-1)*
     +    t1**(-2) + 1024*s**(-1)*u1**(-2) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-2)*t1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*s**(-2)*
     +    t1**(-2)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-2)*t1**(-2) + 
     +    4096*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 4096*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 1024*ms1**2*s**(-2)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**2*s**(-2)*u1**(-2) - 4096*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 2048*ms1**2*s**(-2)*s4**(-2) + 
     +    2048*ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1) - 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2) + 2048*
     +    ms1**2*s**(-1)*u1**(-3) + 2048*ms1**2*t1**(-3)*u1**(-1) + 
     +    2048*ms1**2*t1**(-1)*u1**(-3) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**4
     +    *s**(-2)*t1**(-3)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) - 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-2) - 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    2048*ms1**4*s**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-2)*u1**(-3) - 2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 
     +    4096*ms1**4*s**(-2)*u1**(-1)*s4**(-2) - 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) + 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1) - 4096*ms1**4*s**(-1)*t1**(-2)*u1**(-2) + 
     +    2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) - 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4**2*(s+t1)**(-2) + 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3) + 2048*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**(-1) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**4
     +    *s*t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048
     +    *ms1**4*t1**(-4)*u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2)*s4**2*
     +    (s+u1)**(-2) - 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*t1**(-2)*
     +    u1**(-3)*s4**2*(s+t1)**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)
     +     - 2048*ms1**4*t1**(-1)*u1**(-4) + 4096*ms1**6*s**(-2)*
     +    t1**(-4)*s4*(s+u1)**(-1) - 2048*ms1**6*s**(-2)*t1**(-4)*s4**2
     +    *(s+u1)**(-2) - 2048*ms1**6*s**(-2)*t1**(-4) - 4096*ms1**6*
     +    s**(-2)*t1**(-2)*u1**(-2) + 12288*ms1**6*s**(-2)*t1**(-2)*
     +    u1**(-1)*s4**(-1) - 4096*ms1**6*s**(-2)*t1**(-2)*s4**(-2) + 
     +    12288*ms1**6*s**(-2)*t1**(-1)*u1**(-2)*s4**(-1) - 8192*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 4096*ms1**6*s**(-2)*
     +    u1**(-4)*s4*(s+t1)**(-1) - 2048*ms1**6*s**(-2)*u1**(-4)*s4**2
     +    *(s+t1)**(-2) )
      LQ_GGH = LQ_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( -2048*ms1**6
     +    *s**(-2)*u1**(-4) - 4096*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 
     +    4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 4096*
     +    ms1**6*s**(-1)*t1**(-3)*u1**(-2) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3) + 4096*ms1**6*s**(-1)*t1**(-2)*u1**(-2)*
     +    s4**(-1) - 2048*ms1**6*t1**(-4)*u1**(-2) - 2048*ms1**6*
     +    t1**(-2)*u1**(-4) - 1024*s**(-2)*t1**(-2)*u1 + 1024*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) - 1024*s**(-2)*t1**(-1)*s4**2*
     +    (s+u1)**(-2) - 1024*s**(-2)*t1**(-1) - 1024*s**(-2)*t1*
     +    u1**(-2) + 1024*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 1024*
     +    s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 1024*s**(-2)*u1**(-1)
     +     - 2048*s**(-2)*s4**(-1) - 1024*s**(-1)*t1**(-2) - 1024*
     +    s**(-1)*u1**(-2) )

      LQ_GGH = fac * LQ_GGH 

      end







