c --------------------------------------------------------------------
      real*8 function TB_GGB(s,t1,ms1)

      implicit none 

      real*8 Pi,Nc,Co,Ck,alphas,fac 
      real*8 s,t1,u1,ms1

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = 24.D0
      Ck = 8.D0/3.D0
      alphas = 1.D0

      u1 = - s - t1 

      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)
      
      TB_GGB =
     +  + Co*Pi**2*alphas**2 * ( 128*ms1**2*s**(-3) - 64*ms1**2*s**(-1)
     +    *t1**(-1)*u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 
     +    64*ms1**4*t1**(-2)*u1**(-2) - 64*s**(-4)*t1*u1 + 32*s**(-2) )
      TB_GGB=TB_GGB + Ck*Pi**2*alphas**2 * ( 64*ms1**2*s**(-1)*t1**(-1)
     +    *u1**(-1) - 64*ms1**4*t1**(-2)*u1**(-2) - 32*s**(-2) )

      TB_GGB = fac * TB_GGB 
ctp      TB_GGB = fac * 389379660.D0 * TB_GGB 

      end

c --------------------------------------------------------------------
ctp  Nf number of SM quarks in the running of alpha_s
      real*8 function TB_GG1(s,t1,ms1,sca)

      implicit none 

      real*8 Pi,Nc,Nf,alphas 
      real*8 s,t1,u1,ms1,sca 
      real*8 conalp,consof,TB_GGB
      real*8 P1,P2

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Nf = 6.D0
      alphas = 1.D0
      
      u1 = - s - t1 

      P1 = -2.D0 * Nc * log(-t1/ms1**2)
     &     + ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0) )/2.D0
      P2 = -2.D0 * Nc * log(-u1/ms1**2)
     &     + ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0) )/2.D0

      consof = -alphas/2.D0/Pi * TB_GGB(s,t1,ms1)
     &         * ( P1 + P2 ) * 2.0*log(sca/ms1) 

      conalp = alphas/2.D0/Pi * TB_GGB(s,t1,ms1)
     &    * ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0)) * 2.0*log(sca/ms1)

      TB_GG1 = conalp + consof 

      end


c --------------------------------------------------------------------
      real*8 function TB_GG2(s,t1,s4,ms1,del,s4max,sca)

      implicit none 

      real*8 Pi,Nc,alphas
      real*8 s,t1,s4,del,s4max,ms1,sca 
      real*8 dldel1,TB_GGB
      real*8 P1

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      alphas = 1.D0
      
      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 

      P1 = 2.D0*Nc*dldel1 

      TB_GG2 = -alphas/Pi*TB_GGB(s,t1,ms1)*P1 * 2.0*log(sca/ms1)

      end

c --------------------------------------------------------------------
      real*8 function TB_GG3(s,t1,s4,ms1,sca)

      implicit none 

      real*8 Pi,Nc,Co,Ck,alphas,fac 
      real*8 s,t1,u1,s4,ms1,sca 
      real*8 COLO1(9)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      alphas = 1.D0
      
      u1 = s4 - s - t1 

      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /(Nc**2-1.D0)**2
      
      COLO1(9) = -2.0*log(sca/ms1)

      TB_GG3 = 0.D0

      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-4)*t1**(-2)*u1**2 - 4096*ms1**2*s**(-4)*t1*s4**(-1) + 
     +    2048*ms1**2*s**(-4)*t1**2*u1**(-2) + 4096*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 6144*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 2048*ms1**2*s**(-3)*t1**(-2)*u1 - 14336*
     +    ms1**2*s**(-3)*t1**(-1) - 2048*ms1**2*s**(-3)*t1*u1**(-2) + 
     +    4096*ms1**2*s**(-3)*t1*s4**(-2) - 4096*ms1**2*s**(-3)*t1**2*
     +    u1**(-3) - 14336*ms1**2*s**(-3)*u1**(-1) + 6144*ms1**2*
     +    s**(-3)*s4**(-1) - 8192*ms1**2*s**(-2)*t1**(-3)*u1 - 4096*
     +    ms1**2*s**(-2)*t1**(-2)*s4*(s+u1)**(-1) + 1024*ms1**2*s**(-2)
     +    *t1**(-2)*s4**2*(s+u1)**(-2) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 16384*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1) + 8192*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 8192*
     +    ms1**2*s**(-2)*t1*u1**(-3) - 4096*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*u1**(-2)*s4**2*(s+t1)**(-2) + 8192*ms1**2*s**(-2)*
     +    u1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*s4**(-2) - 6144*
     +    ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**2*(s+t1)**(-2) + 4096*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 6144*ms1**2*s**(-1)*u1**(-3) - 2048*
     +    ms1**2*t1**(-3)*u1**(-1) - 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    4096*ms1**4*s**(-3)*t1**(-3)*u1 - 12288*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*t1*u1**(-3) - 12288*
     +    ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 8192*ms1**4*s**(-3)*
     +    s4**(-2) + 4096*ms1**4*s**(-2)*t1**(-4)*u1 + 2048*ms1**4*
     +    s**(-2)*t1**(-3)*s4*(s+u1)**(-1) - 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 8192*ms1**4*s**(-2)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 4096*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2) - 16384*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 
     +    4096*ms1**4*s**(-2)*t1*u1**(-4) + 2048*ms1**4*s**(-2)*
     +    u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*s**(-2)*u1**(-3) + 
     +    2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 8192*ms1**4*s**(-1)*t1**(-4) + 6144*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1) + 4096*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-2) - 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*
     +    s4**(-1) + 6144*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3) - 2048*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*
     +    ms1**4*s*t1**(-2)*u1**(-4) + 6144*ms1**4*t1**(-4)*u1**(-1) - 
     +    2048*ms1**4*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 2048*ms1**4*
     +    t1**(-3)*u1**(-2)*s4**2*(s+u1)**(-2) + 2048*ms1**4*t1**(-3)*
     +    u1**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 
     +    2048*ms1**4*t1**(-2)*u1**(-3)*s4**2*(s+t1)**(-2) + 2048*
     +    ms1**4*t1**(-2)*u1**(-3) + 6144*ms1**4*t1**(-1)*u1**(-4) - 
     +    4096*ms1**6*s**(-2)*t1**(-4)*s4*(s+u1)**(-1) + 2048*ms1**6*
     +    s**(-2)*t1**(-4)*s4**2*(s+u1)**(-2) + 6144*ms1**6*s**(-2)*
     +    t1**(-4) + 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1) + 4096*
     +    ms1**6*s**(-2)*t1**(-2)*u1**(-2) - 8192*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * (  - 4096*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-3) - 8192*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2)*s4**(-1) - 4096*ms1**6*s**(-2)*u1**(-4)*s4*
     +    (s+t1)**(-1) + 2048*ms1**6*s**(-2)*u1**(-4)*s4**2*
     +    (s+t1)**(-2) + 6144*ms1**6*s**(-2)*u1**(-4) + 4096*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*t1**(-4)*
     +    u1**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2) + 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*
     +    u1**(-4) + 2048*ms1**6*t1**(-4)*u1**(-2) + 2048*ms1**6*
     +    t1**(-2)*u1**(-4) + 2048*s**(-4)*t1**(-2)*u1**3 + 2048*
     +    s**(-4)*t1**(-1)*u1**2 + 2048*s**(-4)*t1 + 2048*s**(-4)*t1**2
     +    *u1**(-1) + 4096*s**(-4)*t1**2*s4**(-1) + 2048*s**(-4)*t1**3*
     +    u1**(-2) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 6144*s**(-4)*
     +    u1 + 4096*s**(-3)*t1**(-2)*u1**2 + 4096*s**(-3)*t1*s4**(-1)
     +     + 4096*s**(-3)*t1**2*u1**(-2) + 3072*s**(-2)*t1**(-2)*u1 + 
     +    2048*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) - 1024*s**(-2)*t1**(-1)
     +    *s4*(s+u1)**(-1) + 1024*s**(-2)*t1**(-1)*s4**2*(s+u1)**(-2)
     +     - 1024*s**(-2)*t1**(-1) + 3072*s**(-2)*t1*u1**(-2) - 1024*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 2048*s**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 
     +    1024*s**(-2)*u1**(-1) + 2048*s**(-2)*s4**(-1) + 1024*s**(-1)*
     +    t1**(-2) + 1024*s**(-1)*u1**(-2) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-2)*t1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*s**(-2)*
     +    t1**(-2)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-2)*t1**(-2) + 
     +    4096*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 4096*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 1024*ms1**2*s**(-2)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**2*s**(-2)*u1**(-2) - 4096*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 2048*ms1**2*s**(-2)*s4**(-2) + 
     +    2048*ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1) - 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2) + 2048*
     +    ms1**2*s**(-1)*u1**(-3) + 2048*ms1**2*t1**(-3)*u1**(-1) + 
     +    2048*ms1**2*t1**(-1)*u1**(-3) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**4
     +    *s**(-2)*t1**(-3)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) - 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-2) - 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    2048*ms1**4*s**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-2)*u1**(-3) - 2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 
     +    4096*ms1**4*s**(-2)*u1**(-1)*s4**(-2) - 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) + 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1) - 4096*ms1**4*s**(-1)*t1**(-2)*u1**(-2) + 
     +    2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) - 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4**2*(s+t1)**(-2) + 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3) + 2048*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**(-1) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**4
     +    *s*t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048
     +    *ms1**4*t1**(-4)*u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2)*s4**2*
     +    (s+u1)**(-2) - 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*t1**(-2)*
     +    u1**(-3)*s4**2*(s+t1)**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)
     +     - 2048*ms1**4*t1**(-1)*u1**(-4) + 4096*ms1**6*s**(-2)*
     +    t1**(-4)*s4*(s+u1)**(-1) - 2048*ms1**6*s**(-2)*t1**(-4)*s4**2
     +    *(s+u1)**(-2) - 2048*ms1**6*s**(-2)*t1**(-4) - 4096*ms1**6*
     +    s**(-2)*t1**(-2)*u1**(-2) + 12288*ms1**6*s**(-2)*t1**(-2)*
     +    u1**(-1)*s4**(-1) - 4096*ms1**6*s**(-2)*t1**(-2)*s4**(-2) + 
     +    12288*ms1**6*s**(-2)*t1**(-1)*u1**(-2)*s4**(-1) - 8192*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 4096*ms1**6*s**(-2)*
     +    u1**(-4)*s4*(s+t1)**(-1) - 2048*ms1**6*s**(-2)*u1**(-4)*s4**2
     +    *(s+t1)**(-2) )
      TB_GG3=TB_GG3 + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**6
     +    *s**(-2)*u1**(-4) - 4096*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 
     +    4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 4096*
     +    ms1**6*s**(-1)*t1**(-3)*u1**(-2) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3) + 4096*ms1**6*s**(-1)*t1**(-2)*u1**(-2)*
     +    s4**(-1) - 2048*ms1**6*t1**(-4)*u1**(-2) - 2048*ms1**6*
     +    t1**(-2)*u1**(-4) - 1024*s**(-2)*t1**(-2)*u1 + 1024*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) - 1024*s**(-2)*t1**(-1)*s4**2*
     +    (s+u1)**(-2) - 1024*s**(-2)*t1**(-1) - 1024*s**(-2)*t1*
     +    u1**(-2) + 1024*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 1024*
     +    s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 1024*s**(-2)*u1**(-1)
     +     - 2048*s**(-2)*s4**(-1) - 1024*s**(-1)*t1**(-2) - 1024*
     +    s**(-1)*u1**(-2) )

      TB_GG3 = fac * TB_GG3
ctp      TB_GG3 = fac * 389379660.D0 * TB_GG3

      end

c --------------------------------------------------------------------
      real*8 function TB_GGD(s,t1,s4,ms1,del,s4max)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,alphas,fac 
      real*8 s,t1,u1,ms1,s4,del,s4max,t,u,ms12 
      real*8 xw,COLO1(9),dldel1,dldel2 
      real*8 m2(5)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      alphas = 1.D0

      u1 = - s - t1 
      t = t1 + ms1**2 
      u = u1 + ms1**2 
      ms12 = ms1**2 
      xw = sqrt(1.D0-4.D0*ms1**2/s)

      m2(1) = s 
      m2(2) = t1 
      m2(3) = u1 
      m2(4) = s4
      m2(5) = ms1**2 

      call LOGAS_LQ(m2,COLO1)

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 
      dldel2 = log(s4max/ms1**2)**2 
     &       - 2.D0* ( s4max - del )/s4 * log(s4/ms1**2)

      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)
      
      TB_GGD =
     +  + Nc*Co*Pi*alphas**3*dldel1 * ( 136*ms1**2*s**(-3)*t**(-1)*t1
     +     - 136*ms1**2*s**(-3)*u**(-1)*t1 - 308*ms1**2*s**(-3) + 324*
     +    ms1**2*s**(-2)*t**(-1) + 188*ms1**2*s**(-2)*u**(-1) - 274*
     +    ms1**2*s**(-2)*t1**(-1) - 274*ms1**2*s**(-2)*u1**(-1) + 128*
     +    ms1**2*s**(-1)*t**(-1)*t1**(-1) + 128*ms1**2*s**(-1)*u**(-1)*
     +    u1**(-1) - 86*ms1**2*s**(-1)*t1**(-2) - 86*ms1**2*s**(-1)*
     +    u1**(-2) + 130*ms1**4*s**(-3)*t**(-1) + 130*ms1**4*s**(-3)*
     +    u**(-1) - 40*ms1**4*s**(-3)*t1**(-1) - 40*ms1**4*s**(-3)*
     +    u1**(-1) + 306*ms1**4*s**(-2)*t**(-1)*t1**(-1) + 306*ms1**4*
     +    s**(-2)*u**(-1)*u1**(-1) - 160*ms1**4*s**(-2)*t1**(-2) - 160*
     +    ms1**4*s**(-2)*u1**(-2) + 130*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     +     + 130*ms1**4*s**(-1)*u**(-1)*u1**(-2) - 44*ms1**4*s**(-1)*
     +    t1**(-3) - 44*ms1**4*s**(-1)*u1**(-3) + 40*ms1**6*s**(-3)*
     +    t**(-1)*t1**(-1) + 40*ms1**6*s**(-3)*u**(-1)*u1**(-1) + 96*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-2) + 96*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) )
      TB_GGD=TB_GGD + Nc*Co*Pi*alphas**3*dldel1 * ( 44*ms1**6*s**(-1)*
     +    t**(-1)*t1**(-3) + 44*ms1**6*s**(-1)*u**(-1)*u1**(-3) - 64*
     +    s**(-4)*t1**2 + 46*s**(-3)*t**(-1)*t1**2 + 46*s**(-3)*u**(-1)
     +    *t1**2 - 64*s**(-3)*t1 + 114*s**(-2)*t**(-1)*t1 - 22*s**(-2)*
     +    u**(-1)*t1 - 214*s**(-2) + 42*s**(-1)*t**(-1) - 26*s**(-1)*
     +    u**(-1) - 42*s**(-1)*t1**(-1) - 42*s**(-1)*u1**(-1) )
      TB_GGD=TB_GGD + Nc*Co*Pi*alphas**3*dldel2 * ( 256*ms1**2*s**(-3)
     +     + 128*ms1**2*s**(-2)*t1**(-1) + 128*ms1**2*s**(-2)*u1**(-1)
     +     + 128*ms1**4*s**(-2)*t1**(-2) + 128*ms1**4*s**(-2)*u1**(-2)
     +     + 128*s**(-4)*t1**2 + 128*s**(-3)*t1 + 64*s**(-2) )
      TB_GGD=TB_GGD + Nc*Ck*Pi*alphas**3*dldel1 * ( 112*ms1**2*s**(-3)
     +     + 88*ms1**2*s**(-2)*t**(-1) + 88*ms1**2*s**(-2)*u**(-1) - 52
     +    *ms1**2*s**(-2)*t1**(-1) - 52*ms1**2*s**(-2)*u1**(-1) - 64*
     +    ms1**2*s**(-1)*t**(-1)*t1**(-1) - 96*ms1**2*s**(-1)*t**(-1)*
     +    u1**(-1) - 96*ms1**2*s**(-1)*u**(-1)*t1**(-1) - 64*ms1**2*
     +    s**(-1)*u**(-1)*u1**(-1) + 40*ms1**2*s**(-1)*t1**(-2) + 40*
     +    ms1**2*s**(-1)*u1**(-2) + 40*ms1**4*s**(-3)*t**(-1) + 40*
     +    ms1**4*s**(-3)*u**(-1) - 32*ms1**4*s**(-3)*t1**(-1) - 32*
     +    ms1**4*s**(-3)*u1**(-1) + 436*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     +     + 192*ms1**4*s**(-2)*t**(-1)*u1**(-1) + 192*ms1**4*s**(-2)*
     +    u**(-1)*t1**(-1) + 436*ms1**4*s**(-2)*u**(-1)*u1**(-1) - 80*
     +    ms1**4*s**(-2)*t1**(-2) + 32*ms1**4*s**(-2)*t1**(-1)*u1**(-1)
     +     - 80*ms1**4*s**(-2)*u1**(-2) - 56*ms1**4*s**(-1)*t**(-1)*
     +    t1**(-2) - 56*ms1**4*s**(-1)*u**(-1)*u1**(-2) + 16*ms1**4*
     +    s**(-1)*t1**(-3) + 16*ms1**4*s**(-1)*u1**(-3) + 32*ms1**6*
     +    s**(-3)*t**(-1)*t1**(-1) )
      TB_GGD=TB_GGD + Nc*Ck*Pi*alphas**3*dldel1 * ( 32*ms1**6*s**(-3)*
     +    u**(-1)*u1**(-1) + 400*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 176*
     +    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) + 176*ms1**6*s**(-2)
     +    *u**(-1)*t1**(-1)*u1**(-1) + 400*ms1**6*s**(-2)*u**(-1)*
     +    u1**(-2) - 128*ms1**6*s**(-2)*t1**(-3) - 64*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1) - 64*ms1**6*s**(-2)*t1**(-1)*u1**(-2) - 128
     +    *ms1**6*s**(-2)*u1**(-3) - 16*ms1**6*s**(-1)*t**(-1)*t1**(-3)
     +     - 16*ms1**6*s**(-1)*u**(-1)*u1**(-3) + 128*ms1**8*s**(-2)*
     +    t**(-1)*t1**(-3) + 64*ms1**8*s**(-2)*t**(-1)*t1**(-2)*
     +    u1**(-1) + 64*ms1**8*s**(-2)*u**(-1)*t1**(-1)*u1**(-2) + 128*
     +    ms1**8*s**(-2)*u**(-1)*u1**(-3) + 64*s**(-4)*t1**2 - 8*
     +    s**(-3)*t**(-1)*t1**2 - 8*s**(-3)*u**(-1)*t1**2 + 64*s**(-3)*
     +    t1 + 4*s**(-2)*t**(-1)*t1 - 20*s**(-2)*u**(-1)*t1 + 80*
     +    s**(-2) - 8*s**(-1)*t**(-1) - 20*s**(-1)*u**(-1) + 40*s**(-1)
     +    *t1**(-1) + 40*s**(-1)*u1**(-1) + 16*t**(-1)*u1**(-1) + 16*
     +    u**(-1)*t1**(-1) )
      TB_GGD=TB_GGD + Nc*Ck*Pi*alphas**3*dldel2 * (  - 128*ms1**2*
     +    s**(-2)*t1**(-1) - 128*ms1**2*s**(-2)*u1**(-1) - 128*ms1**4*
     +    s**(-2)*t1**(-2) - 256*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 128
     +    *ms1**4*s**(-2)*u1**(-2) - 64*s**(-2) )
      TB_GGD=TB_GGD + Cqed*Pi*alphas**3*dldel1 * ( 24*ms1**2*s**(-2)*
     +    t1**(-1) + 24*ms1**2*s**(-2)*u1**(-1) + 16*ms1**2*s**(-1)*
     +    t**(-1)*t1**(-1) + 48*ms1**2*s**(-1)*t**(-1)*u1**(-1) + 48*
     +    ms1**2*s**(-1)*u**(-1)*t1**(-1) + 16*ms1**2*s**(-1)*u**(-1)*
     +    u1**(-1) - 8*ms1**2*s**(-1)*t1**(-2) - 8*ms1**2*s**(-1)*
     +    u1**(-2) - 160*ms1**4*s**(-2)*t**(-1)*t1**(-1) - 120*ms1**4*
     +    s**(-2)*t**(-1)*u1**(-1) - 120*ms1**4*s**(-2)*u**(-1)*
     +    t1**(-1) - 160*ms1**4*s**(-2)*u**(-1)*u1**(-1) + 48*ms1**4*
     +    s**(-2)*t1**(-2) + 32*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 48*
     +    ms1**4*s**(-2)*u1**(-2) + 8*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     +     + 8*ms1**4*s**(-1)*u**(-1)*u1**(-2) - 176*ms1**6*s**(-2)*
     +    t**(-1)*t1**(-2) - 144*ms1**6*s**(-2)*t**(-1)*t1**(-1)*
     +    u1**(-1) - 144*ms1**6*s**(-2)*u**(-1)*t1**(-1)*u1**(-1) - 176
     +    *ms1**6*s**(-2)*u**(-1)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3)
     +     + 64*ms1**6*s**(-2)*t1**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-2) )
      TB_GGD=TB_GGD + Cqed*Pi*alphas**3*dldel1 * ( 64*ms1**6*s**(-2)*
     +    u1**(-3) - 64*ms1**8*s**(-2)*t**(-1)*t1**(-3) - 64*ms1**8*
     +    s**(-2)*t**(-1)*t1**(-2)*u1**(-1) - 64*ms1**8*s**(-2)*u**(-1)
     +    *t1**(-1)*u1**(-2) - 64*ms1**8*s**(-2)*u**(-1)*u1**(-3) + 8*
     +    s**(-2)*t**(-1)*t1 - 8*s**(-2)*u**(-1)*t1 - 48*s**(-2) - 8*
     +    s**(-1)*u**(-1) - 16*s**(-1)*t1**(-1) - 16*s**(-1)*u1**(-1)
     +     - 8*t**(-1)*u1**(-1) - 8*u**(-1)*t1**(-1) )
      TB_GGD=TB_GGD + COLO1(1)*Nc*Ck*Pi*alphas**3*dldel1 * (  - 384*
     +    (s-4*ms12)**(-1)*ms1**2*s**(-4)*t1**2*xw**(-1) - 384*
     +    (s-4*ms12)**(-1)*ms1**2*s**(-3)*t1*xw**(-1) - 160*
     +    (s-4*ms12)**(-1)*ms1**2*s**(-2)*xw**(-1) - 16*
     +    (s-4*ms12)**(-1)*ms1**2*s**(-1)*t1**(-1)*xw**(-1) - 16*
     +    (s-4*ms12)**(-1)*ms1**2*s**(-1)*u1**(-1)*xw**(-1) + 512*
     +    (s-4*ms12)**(-1)*ms1**4*s**(-5)*t1**2*xw**(-1) + 512*
     +    (s-4*ms12)**(-1)*ms1**4*s**(-4)*t1*xw**(-1) + 512*
     +    (s-4*ms12)**(-1)*ms1**4*s**(-3)*xw**(-1) + 96*
     +    (s-4*ms12)**(-1)*ms1**4*s**(-2)*t1**(-1)*xw**(-1) + 96*
     +    (s-4*ms12)**(-1)*ms1**4*s**(-2)*u1**(-1)*xw**(-1) - 512*
     +    (s-4*ms12)**(-1)*ms1**6*s**(-4)*xw**(-1) - 128*
     +    (s-4*ms12)**(-1)*ms1**6*s**(-3)*t1**(-1)*xw**(-1) - 128*
     +    (s-4*ms12)**(-1)*ms1**6*s**(-3)*u1**(-1)*xw**(-1) + 64*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2*xw**(-1) + 64*(s-4*ms12)**(-1)
     +    *s**(-2)*t1*xw**(-1) )
      TB_GGD=TB_GGD + COLO1(1)*Nc*Ck*Pi*alphas**3*dldel1 * ( 16*
     +    (s-4*ms12)**(-1)*s**(-1)*xw**(-1) + 160*ms1**2*s**(-3)*
     +    xw**(-1) + 80*ms1**2*s**(-2)*t1**(-1)*xw**(-1) + 80*ms1**2*
     +    s**(-2)*u1**(-1)*xw**(-1) - 384*ms1**4*s**(-4)*xw**(-1) - 160
     +    *ms1**4*s**(-3)*t1**(-1)*xw**(-1) - 160*ms1**4*s**(-3)*
     +    u1**(-1)*xw**(-1) + 64*ms1**4*s**(-2)*t1**(-2)*xw**(-1) + 64*
     +    ms1**4*s**(-2)*u1**(-2)*xw**(-1) - 128*ms1**6*s**(-3)*
     +    t1**(-2)*xw**(-1) - 128*ms1**6*s**(-3)*u1**(-2)*xw**(-1) + 16
     +    *s**(-2)*xw**(-1) )
      TB_GGD=TB_GGD + COLO1(1)*Cqed*Pi*alphas**3*dldel1 * ( 64*ms1**2*
     +    s**(-3)*xw**(-1) - 64*ms1**2*s**(-2)*t1**(-1)*xw**(-1) - 64*
     +    ms1**2*s**(-2)*u1**(-1)*xw**(-1) - 128*ms1**4*s**(-3)*
     +    t1**(-1)*xw**(-1) - 128*ms1**4*s**(-3)*u1**(-1)*xw**(-1) - 64
     +    *ms1**4*s**(-2)*t1**(-2)*xw**(-1) - 384*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-1)*xw**(-1) - 64*ms1**4*s**(-2)*u1**(-2)*
     +    xw**(-1) + 128*ms1**6*s**(-3)*t1**(-2)*xw**(-1) + 256*ms1**6*
     +    s**(-3)*t1**(-1)*u1**(-1)*xw**(-1) + 128*ms1**6*s**(-3)*
     +    u1**(-2)*xw**(-1) - 32*s**(-2)*xw**(-1) )
      TB_GGD=TB_GGD + COLO1(3)*Nc*Co*Pi*alphas**3*dldel1 * ( 128*ms1**2
     +    *s**(-3) + 64*ms1**2*s**(-2)*t1**(-1) + 64*ms1**2*s**(-2)*
     +    u1**(-1) + 64*ms1**4*s**(-2)*t1**(-2) + 64*ms1**4*s**(-2)*
     +    u1**(-2) + 64*s**(-4)*t1**2 + 64*s**(-3)*t1 + 32*s**(-2) )
      TB_GGD=TB_GGD + COLO1(4)*Nc*Co*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-3) - 128*ms1**2*s**(-2)*u1**(-1) - 128*ms1**4*
     +    s**(-2)*u1**(-2) - 64*s**(-4)*t1**2 )
      TB_GGD=TB_GGD + COLO1(8)*Nc*Co*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-3) - 128*ms1**2*s**(-2)*t1**(-1) - 128*ms1**4*
     +    s**(-2)*t1**(-2) - 64*s**(-4)*t1**2 - 128*s**(-3)*t1 - 64*
     +    s**(-2) )

      TB_GGD = fac * TB_GGD 
ctp      TB_GGD = fac * 389379660.D0 * TB_GGD 

      end 

c --------------------------------------------------------------------
      real*8 function TB_GGV(s,t1,ms1,mg,mt,ms,ms2,mx1,mx2,
     &                       s2t,c2t,c2b,susy)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,Nf,Ns,alphas,fac,susy
      real*8 s,t1,u1,ms1,mg,mt,ms,ms2,s2t,c2t,t,u,ms12,mx1,mx2
      real*8 m2(2,8),softin(4),c2b
      real*8 SK3B0A(7),SK3B0B(8),SK3B0C(3),SK3B0D(3,2),SK3BP(4) 
      real*8 SK3C0A(10),SK3C0B(6),SK3C0C(8,2),SK3D0(11,2)
      real*8 SOF1(8)
      real*8 mur,dec,TB_GGB,STGGV

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      Nf = 6.D0
      Ns = 6.D0
      alphas = 1.D0

      u1 = - s - t1 
      t = t1 + ms1**2 
      u = u1 + ms1**2 
      ms12 = ms1**2 
      fac = 1.D0/(64*Pi*(Nc**2-1.D0)**2)

      m2(1,1) = s 
      m2(1,2) = t1 + ms1**2  
      m2(1,3) = u1 + ms1**2 
      m2(1,4) = t1
      m2(1,5) = u1
      m2(2,1) = ms1**2 
      m2(2,2) = ms2**2 
      m2(2,3) = ms**2 
      m2(2,4) = mg**2 
      m2(2,5) = mt**2 
      m2(2,6) = ms1**2 
      m2(2,7) = mx1**2
      m2(2,8) = mx2**2

      call SCALAR_ARRAY_TB_B_GS(m2,SK3B0A,SK3B0B,SK3B0C,SK3B0D,SK3BP)
      call SCALAR_ARRAY_TB_C_GS(m2,SK3C0A,SK3C0B,SK3C0C,SK3D0)
      
      softin(1) = s
      softin(2) = t1 
      softin(3) = u1 
      softin(4) = ms1**2 

      call SOFT_ARRAY_LQ(softin,SOF1)

      mur = ms1
      
      dec = 2.D0*alphas/Pi * TB_GGB(s,t1,ms1)*
     &      (  (Ns-2.D0)/12.D0 * susy * log(mur**2/ms**2)
     &       + 1.D0/24.D0             * log(mur**2/ms1**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/ms2**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/mx1**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/mx2**2)
     &       + 1.D0/6.D0              * log(mur**2/mt**2) 
     &       + Nc/6.D0         * susy * log(mur**2/mg**2)   )

      STGGV =
     &  + Cqed*Pi*alphas**3 * ( 4*ms1**2*s**(-2)*t**(-1) + 4*ms1**2*
     &    s**(-2)*u**(-1) - 12*ms1**2*s**(-2)*t1**(-1) - 12*ms1**2*
     &    s**(-2)*u1**(-1) + 4*ms1**2*s**(-1)*t**(-1)*t1**(-1) + 4*
     &    ms1**2*s**(-1)*t**(-1)*u1**(-1) + 4*ms1**2*s**(-1)*u**(-1)*
     &    t1**(-1) + 4*ms1**2*s**(-1)*u**(-1)*u1**(-1) - 4*ms1**2*
     &    s**(-1)*t1**(-2) - 4*ms1**2*s**(-1)*u1**(-2) + 40*ms1**4*
     &    s**(-2)*t**(-1)*t1**(-1) + 20*ms1**4*s**(-2)*t**(-1)*u1**(-1)
     &     + 20*ms1**4*s**(-2)*u**(-1)*t1**(-1) + 40*ms1**4*s**(-2)*
     &    u**(-1)*u1**(-1) - 40*ms1**4*s**(-2)*t1**(-2) - 48*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) - 40*ms1**4*s**(-2)*u1**(-2) + 4*
     &    ms1**4*s**(-1)*t**(-1)*t1**(-2) + 4*ms1**4*s**(-1)*u**(-1)*
     &    u1**(-2) + 72*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 56*ms1**6*
     &    s**(-2)*t**(-1)*t1**(-1)*u1**(-1) + 56*ms1**6*s**(-2)*u**(-1)
     &    *t1**(-1)*u1**(-1) + 72*ms1**6*s**(-2)*u**(-1)*u1**(-2) - 32*
     &    ms1**6*s**(-2)*t1**(-3) - 32*ms1**6*s**(-2)*t1**(-2)*u1**(-1)
     &     - 32*ms1**6*s**(-2)*t1**(-1)*u1**(-2) )
      STGGV = STGGV + Cqed*Pi*alphas**3 * (  - 32*ms1**6*s**(-2)*
     &    u1**(-3) + 32*ms1**8*s**(-2)*t**(-1)*t1**(-3) + 32*ms1**8*
     &    s**(-2)*t**(-1)*t1**(-2)*u1**(-1) + 32*ms1**8*s**(-2)*u**(-1)
     &    *t1**(-1)*u1**(-2) + 32*ms1**8*s**(-2)*u**(-1)*u1**(-3) )
      STGGV = STGGV + Cqed*s2t**2*Pi*alphas**3 * ( 8*ms1**2*s**(-2)*
     &    t1**(-1) + 8*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Ck*Pi*alphas**3 * ( 16*ms1**2*s**(-2)*t1**(-1) + 
     &    16*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Ck*s2t**2*Pi*alphas**3 * (  - 16*ms1**2*s**(-2)*
     &    t1**(-1) - 16*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Co*Pi*alphas**3 * ( 16./3.*ms1**2*s**(-3) - 8./3.
     &    *ms1**2*s**(-2)*t1**(-1) - 8./3.*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Co*s2t**2*Pi*alphas**3 * ( 4*ms1**2*s**(-2)*
     &    t1**(-1) + 4*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Co*(Nf-1)*Pi*alphas**3 * ( 32./3.*ms1**2*s**(-3)
     &     + 8./3.*ms1**2*s**(-2)*t1**(-1) + 8./3.*ms1**2*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + Nc*Ck*Pi*alphas**3 * (  - 4*ms1**2*s**(-3)*
     &    t**(-1)*t1 + 4*ms1**2*s**(-3)*u**(-1)*t1 + 8*ms1**2*s**(-3)
     &     + 6*ms1**2*s**(-2)*t**(-1) + 10*ms1**2*s**(-2)*u**(-1) - 30*
     &    ms1**2*s**(-2)*t1**(-1) - 30*ms1**2*s**(-2)*u1**(-1) - 12*
     &    ms1**2*s**(-1)*t**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*t**(-1)*
     &    u1**(-1) - 16*ms1**2*s**(-1)*u**(-1)*t1**(-1) - 12*ms1**2*
     &    s**(-1)*u**(-1)*u1**(-1) + 12*ms1**2*s**(-1)*t1**(-2) + 12*
     &    ms1**2*s**(-1)*u1**(-2) - 20*ms1**4*s**(-3)*t**(-1) - 20*
     &    ms1**4*s**(-3)*u**(-1) + 16*ms1**4*s**(-3)*t1**(-1) + 16*
     &    ms1**4*s**(-3)*u1**(-1) - 18*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     &     + 24*ms1**4*s**(-2)*t**(-1)*u1**(-1) + 24*ms1**4*s**(-2)*
     &    u**(-1)*t1**(-1) - 18*ms1**4*s**(-2)*u**(-1)*u1**(-1) + 40*
     &    ms1**4*s**(-2)*t1**(-2) - 16*ms1**4*s**(-2)*t1**(-1)*u1**(-1)
     &     + 40*ms1**4*s**(-2)*u1**(-2) - 20*ms1**4*s**(-1)*t**(-1)*
     &    t1**(-2) - 20*ms1**4*s**(-1)*u**(-1)*u1**(-2) + 8*ms1**4*
     &    s**(-1)*t1**(-3) )
      STGGV = STGGV + Nc*Ck*Pi*alphas**3 * ( 8*ms1**4*s**(-1)*u1**(-3)
     &     - 16*ms1**6*s**(-3)*t**(-1)*t1**(-1) - 16*ms1**6*s**(-3)*
     &    u**(-1)*u1**(-1) - 104*ms1**6*s**(-2)*t**(-1)*t1**(-2) - 24*
     &    ms1**6*s**(-2)*t**(-1)*t1**(-1)*u1**(-1) - 24*ms1**6*s**(-2)*
     &    u**(-1)*t1**(-1)*u1**(-1) - 104*ms1**6*s**(-2)*u**(-1)*
     &    u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3) + 32*ms1**6*s**(-2)*
     &    t1**(-2)*u1**(-1) + 32*ms1**6*s**(-2)*t1**(-1)*u1**(-2) + 64*
     &    ms1**6*s**(-2)*u1**(-3) - 8*ms1**6*s**(-1)*t**(-1)*t1**(-3)
     &     - 8*ms1**6*s**(-1)*u**(-1)*u1**(-3) - 64*ms1**8*s**(-2)*
     &    t**(-1)*t1**(-3) - 32*ms1**8*s**(-2)*t**(-1)*t1**(-2)*
     &    u1**(-1) - 32*ms1**8*s**(-2)*u**(-1)*t1**(-1)*u1**(-2) - 64*
     &    ms1**8*s**(-2)*u**(-1)*u1**(-3) )
      STGGV = STGGV + Nc*Ck*s2t**2*Pi*alphas**3 * (  - 4*ms1**2*s**(-2)
     &    *t1**(-1) - 4*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + Nc*Co*Pi*alphas**3 * ( ms1**2*s**(-3)*t**(-1)*t1
     &     - ms1**2*s**(-3)*u**(-1)*t1 - 38./3.*ms1**2*s**(-3) + 3*
     &    ms1**2*s**(-2)*t**(-1) + 2*ms1**2*s**(-2)*u**(-1) - 41./3.*
     &    ms1**2*s**(-2)*t1**(-1) - 41./3.*ms1**2*s**(-2)*u1**(-1) + 5*
     &    ms1**2*s**(-1)*t**(-1)*t1**(-1) + 5*ms1**2*s**(-1)*u**(-1)*
     &    u1**(-1) - 5*ms1**2*s**(-1)*t1**(-2) - 5*ms1**2*s**(-1)*
     &    u1**(-2) + 5*ms1**4*s**(-3)*t**(-1) + 5*ms1**4*s**(-3)*
     &    u**(-1) - 4*ms1**4*s**(-3)*t1**(-1) - 4*ms1**4*s**(-3)*
     &    u1**(-1) + 3*ms1**4*s**(-2)*t**(-1)*t1**(-1) + 3*ms1**4*
     &    s**(-2)*u**(-1)*u1**(-1) + 11*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     &     + 11*ms1**4*s**(-1)*u**(-1)*u1**(-2) - 6*ms1**4*s**(-1)*
     &    t1**(-3) - 6*ms1**4*s**(-1)*u1**(-3) + 4*ms1**6*s**(-3)*
     &    t**(-1)*t1**(-1) + 4*ms1**6*s**(-3)*u**(-1)*u1**(-1) + 6*
     &    ms1**6*s**(-1)*t**(-1)*t1**(-3) + 6*ms1**6*s**(-1)*u**(-1)*
     &    u1**(-3) )
      STGGV = STGGV + susy*Cqed*Pi*alphas**3 * ( 16*ms1**2*s**(-2)*
     &    t1**(-1) + 16*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Cqed*s2t**2*Pi*alphas**3 * (  - 8*ms1**2*
     &    s**(-2)*t1**(-1) - 8*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Ck*Pi*alphas**3 * (  - 16*ms1**2*s**(-2)*
     &    t1**(-1) - 16*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Ck*s2t**2*Pi*alphas**3 * ( 16*ms1**2*s**(-2)
     &    *t1**(-1) + 16*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Co*Pi*alphas**3 * (  - 16*ms1**2*s**(-3) )
      STGGV = STGGV + susy*Co*s2t**2*Pi*alphas**3 * (  - 4*ms1**2*
     &    s**(-2)*t1**(-1) - 4*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Co*(Ns-2)*Pi*alphas**3 * (  - 32./3.*ms1**2*
     &    s**(-3) - 8./3.*ms1**2*s**(-2)*t1**(-1) - 8./3.*ms1**2*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Nc*Ck*Pi*alphas**3 * (  - 8*ms1**2*s**(-2)*
     &    t1**(-1) - 8*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Nc*Ck*s2t**2*Pi*alphas**3 * ( 4*ms1**2*
     &    s**(-2)*t1**(-1) + 4*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + susy*Nc*Co*Pi*alphas**3 * ( 8*(s-4*ms12)**(-1)*
     &    mt**2*ms1**(-2)*s**(-1) - 4*(s-4*ms12)**(-1)*mt**2*ms1**(-2)*
     &    t1**(-1) - 4*(s-4*ms12)**(-1)*mt**2*ms1**(-2)*u1**(-1) - 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) + 16*(s-4*ms12)**(-1)*mt**2*
     &    s**(-1)*t1**(-1) + 16*(s-4*ms12)**(-1)*mt**2*s**(-1)*u1**(-1)
     &     - 8*(s-4*ms12)**(-1)*mg**2*ms1**(-2)*s**(-1) + 4*
     &    (s-4*ms12)**(-1)*mg**2*ms1**(-2)*t1**(-1) + 4*
     &    (s-4*ms12)**(-1)*mg**2*ms1**(-2)*u1**(-1) + 32*
     &    (s-4*ms12)**(-1)*mg**2*s**(-2) - 16*(s-4*ms12)**(-1)*mg**2*
     &    s**(-1)*t1**(-1) - 16*(s-4*ms12)**(-1)*mg**2*s**(-1)*u1**(-1)
     &     + 32./3.*ms1**2*s**(-3) + 32./3.*ms1**2*s**(-2)*t1**(-1) + 
     &    32./3.*ms1**2*s**(-2)*u1**(-1) - 8*mt**2*ms1**(-2)*s**(-2) + 
     &    4*mt**2*ms1**(-2)*s**(-1)*t1**(-1) + 4*mt**2*ms1**(-2)*
     &    s**(-1)*u1**(-1) + 16*mt**2*s**(-3)*t**(-1)*t1 - 16*mt**2*
     &    s**(-3)*u**(-1)*t1 - 32*mt**2*s**(-3) + 40*mt**2*s**(-2)*
     &    t**(-1) )
      STGGV = STGGV + susy*Nc*Co*Pi*alphas**3 * ( 24*mt**2*s**(-2)*
     &    u**(-1) - 40*mt**2*s**(-2)*t1**(-1) - 40*mt**2*s**(-2)*
     &    u1**(-1) + 16*mt**2*s**(-1)*t**(-1)*t1**(-1) + 16*mt**2*
     &    s**(-1)*u**(-1)*u1**(-1) - 16*mt**2*s**(-1)*t1**(-2) - 16*
     &    mt**2*s**(-1)*u1**(-2) + 32*mt**2*ms1**2*s**(-3)*t**(-1) + 32
     &    *mt**2*ms1**2*s**(-3)*u**(-1) - 16*mt**2*ms1**2*s**(-3)*
     &    t1**(-1) - 16*mt**2*ms1**2*s**(-3)*u1**(-1) + 72*mt**2*ms1**2
     &    *s**(-2)*t**(-1)*t1**(-1) + 72*mt**2*ms1**2*s**(-2)*u**(-1)*
     &    u1**(-1) - 32*mt**2*ms1**2*s**(-2)*t1**(-2) - 32*mt**2*ms1**2
     &    *s**(-2)*u1**(-2) + 32*mt**2*ms1**2*s**(-1)*t**(-1)*t1**(-2)
     &     + 32*mt**2*ms1**2*s**(-1)*u**(-1)*u1**(-2) - 16*mt**2*ms1**2
     &    *s**(-1)*t1**(-3) - 16*mt**2*ms1**2*s**(-1)*u1**(-3) + 16*
     &    mt**2*ms1**4*s**(-3)*t**(-1)*t1**(-1) + 16*mt**2*ms1**4*
     &    s**(-3)*u**(-1)*u1**(-1) + 32*mt**2*ms1**4*s**(-2)*t**(-1)*
     &    t1**(-2) + 32*mt**2*ms1**4*s**(-2)*u**(-1)*u1**(-2) + 16*
     &    mt**2*ms1**4*s**(-1)*t**(-1)*t1**(-3) )
      STGGV = STGGV + susy*Nc*Co*Pi*alphas**3 * ( 16*mt**2*ms1**4*
     &    s**(-1)*u**(-1)*u1**(-3) + 8*mg**2*ms1**(-2)*s**(-2) - 4*
     &    mg**2*ms1**(-2)*s**(-1)*t1**(-1) - 4*mg**2*ms1**(-2)*s**(-1)*
     &    u1**(-1) - 16*mg**2*s**(-3)*t**(-1)*t1 + 16*mg**2*s**(-3)*
     &    u**(-1)*t1 + 32*mg**2*s**(-3) - 40*mg**2*s**(-2)*t**(-1) - 24
     &    *mg**2*s**(-2)*u**(-1) + 40*mg**2*s**(-2)*t1**(-1) + 40*mg**2
     &    *s**(-2)*u1**(-1) - 16*mg**2*s**(-1)*t**(-1)*t1**(-1) - 16*
     &    mg**2*s**(-1)*u**(-1)*u1**(-1) + 16*mg**2*s**(-1)*t1**(-2) + 
     &    16*mg**2*s**(-1)*u1**(-2) - 32*mg**2*ms1**2*s**(-3)*t**(-1)
     &     - 32*mg**2*ms1**2*s**(-3)*u**(-1) + 16*mg**2*ms1**2*s**(-3)*
     &    t1**(-1) + 16*mg**2*ms1**2*s**(-3)*u1**(-1) - 72*mg**2*ms1**2
     &    *s**(-2)*t**(-1)*t1**(-1) - 72*mg**2*ms1**2*s**(-2)*u**(-1)*
     &    u1**(-1) + 32*mg**2*ms1**2*s**(-2)*t1**(-2) + 32*mg**2*ms1**2
     &    *s**(-2)*u1**(-2) - 32*mg**2*ms1**2*s**(-1)*t**(-1)*t1**(-2)
     &     - 32*mg**2*ms1**2*s**(-1)*u**(-1)*u1**(-2) + 16*mg**2*ms1**2
     &    *s**(-1)*t1**(-3) )
      STGGV = STGGV + susy*Nc*Co*Pi*alphas**3 * ( 16*mg**2*ms1**2*
     &    s**(-1)*u1**(-3) - 16*mg**2*ms1**4*s**(-3)*t**(-1)*t1**(-1)
     &     - 16*mg**2*ms1**4*s**(-3)*u**(-1)*u1**(-1) - 32*mg**2*ms1**4
     &    *s**(-2)*t**(-1)*t1**(-2) - 32*mg**2*ms1**4*s**(-2)*u**(-1)*
     &    u1**(-2) - 16*mg**2*ms1**4*s**(-1)*t**(-1)*t1**(-3) - 16*
     &    mg**2*ms1**4*s**(-1)*u**(-1)*u1**(-3) )
      STGGV = STGGV + SK3B0A(1)*susy*Nc*Ck*Pi*alphas**3 * ( 32./3.*
     &    s**(-2) + 64./3.*ms1**2*s**(-2)*t1**(-1) + 64./3.*ms1**2*
     &    s**(-2)*u1**(-1) + 64./3.*ms1**4*s**(-2)*t1**(-2) + 128./3.*
     &    ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 64./3.*ms1**4*s**(-2)*
     &    u1**(-2) )
      STGGV = STGGV + SK3B0A(1)*susy*Nc*Co*Pi*alphas**3 * (  - 8*
     &    (s-4*ms12)**(-1)*mg**2*ms1**(-2)*s**(-1) + 4*(s-4*ms12)**(-1)
     &    *mg**2*ms1**(-2)*t1**(-1) + 4*(s-4*ms12)**(-1)*mg**2*
     &    ms1**(-2)*u1**(-1) + 32*(s-4*ms12)**(-1)*mg**2*s**(-2) - 16*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1)*t1**(-1) - 16*(s-4*ms12)**(-1)
     &    *mg**2*s**(-1)*u1**(-1) - 64./3.*s**(-4)*t1**2 - 64./3.*
     &    s**(-3)*t1 - 32./3.*s**(-2) - 128./3.*ms1**2*s**(-3) - 64./3.
     &    *ms1**2*s**(-2)*t1**(-1) - 64./3.*ms1**2*s**(-2)*u1**(-1) - 
     &    64./3.*ms1**4*s**(-2)*t1**(-2) - 64./3.*ms1**4*s**(-2)*
     &    u1**(-2) + 8*mg**2*ms1**(-2)*s**(-2) - 4*mg**2*ms1**(-2)*
     &    s**(-1)*t1**(-1) - 4*mg**2*ms1**(-2)*s**(-1)*u1**(-1) - 16*
     &    mg**2*s**(-3)*t**(-1)*t1 + 16*mg**2*s**(-3)*u**(-1)*t1 + 32*
     &    mg**2*s**(-3) - 40*mg**2*s**(-2)*t**(-1) - 24*mg**2*s**(-2)*
     &    u**(-1) + 40*mg**2*s**(-2)*t1**(-1) + 40*mg**2*s**(-2)*
     &    u1**(-1) - 16*mg**2*s**(-1)*t**(-1)*t1**(-1) - 16*mg**2*
     &    s**(-1)*u**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0A(1)*susy*Nc*Co*Pi*alphas**3 * ( 16*mg**2*
     &    s**(-1)*t1**(-2) + 16*mg**2*s**(-1)*u1**(-2) - 128*mg**2*
     &    ms1**2*s**(-4) - 32*mg**2*ms1**2*s**(-3)*t**(-1) - 32*mg**2*
     &    ms1**2*s**(-3)*u**(-1) - 80./3.*mg**2*ms1**2*s**(-3)*t1**(-1)
     &     - 80./3.*mg**2*ms1**2*s**(-3)*u1**(-1) - 72*mg**2*ms1**2*
     &    s**(-2)*t**(-1)*t1**(-1) - 72*mg**2*ms1**2*s**(-2)*u**(-1)*
     &    u1**(-1) + 32*mg**2*ms1**2*s**(-2)*t1**(-2) - 32./3.*mg**2*
     &    ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 32*mg**2*ms1**2*s**(-2)*
     &    u1**(-2) - 32*mg**2*ms1**2*s**(-1)*t**(-1)*t1**(-2) - 32*
     &    mg**2*ms1**2*s**(-1)*u**(-1)*u1**(-2) + 16*mg**2*ms1**2*
     &    s**(-1)*t1**(-3) + 16*mg**2*ms1**2*s**(-1)*u1**(-3) - 16*
     &    mg**2*ms1**4*s**(-3)*t**(-1)*t1**(-1) - 16*mg**2*ms1**4*
     &    s**(-3)*u**(-1)*u1**(-1) - 32*mg**2*ms1**4*s**(-2)*t**(-1)*
     &    t1**(-2) - 32*mg**2*ms1**4*s**(-2)*u**(-1)*u1**(-2) - 16*
     &    mg**2*ms1**4*s**(-1)*t**(-1)*t1**(-3) - 16*mg**2*ms1**4*
     &    s**(-1)*u**(-1)*u1**(-3) )
      STGGV = STGGV + SK3B0A(2)*Ck*Pi*alphas**3 * ( 32./3.*s**(-2) + 64.
     &    /3.*ms1**2*s**(-2)*t1**(-1) + 64./3.*ms1**2*s**(-2)*u1**(-1)
     &     + 64./3.*ms1**4*s**(-2)*t1**(-2) + 128./3.*ms1**4*s**(-2)*
     &    t1**(-1)*u1**(-1) + 64./3.*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0A(2)*Co*Pi*alphas**3 * (  - 64./3.*s**(-4)*
     &    t1**2 - 64./3.*s**(-3)*t1 - 32./3.*s**(-2) - 128./3.*ms1**2*
     &    s**(-3) - 64./3.*ms1**2*s**(-2)*t1**(-1) - 64./3.*ms1**2*
     &    s**(-2)*u1**(-1) - 64./3.*ms1**4*s**(-2)*t1**(-2) - 64./3.*
     &    ms1**4*s**(-2)*u1**(-2) - 128*mt**2*ms1**2*s**(-4) - 128./3.*
     &    mt**2*ms1**2*s**(-3)*t1**(-1) - 128./3.*mt**2*ms1**2*s**(-3)*
     &    u1**(-1) - 32./3.*mt**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0A(2)*susy*Nc*Co*Pi*alphas**3 * ( 8*
     &    (s-4*ms12)**(-1)*mt**2*ms1**(-2)*s**(-1) - 4*(s-4*ms12)**(-1)
     &    *mt**2*ms1**(-2)*t1**(-1) - 4*(s-4*ms12)**(-1)*mt**2*
     &    ms1**(-2)*u1**(-1) - 32*(s-4*ms12)**(-1)*mt**2*s**(-2) + 16*
     &    (s-4*ms12)**(-1)*mt**2*s**(-1)*t1**(-1) + 16*(s-4*ms12)**(-1)
     &    *mt**2*s**(-1)*u1**(-1) - 8*mt**2*ms1**(-2)*s**(-2) + 4*mt**2
     &    *ms1**(-2)*s**(-1)*t1**(-1) + 4*mt**2*ms1**(-2)*s**(-1)*
     &    u1**(-1) + 16*mt**2*s**(-3)*t**(-1)*t1 - 16*mt**2*s**(-3)*
     &    u**(-1)*t1 - 32*mt**2*s**(-3) + 40*mt**2*s**(-2)*t**(-1) + 24
     &    *mt**2*s**(-2)*u**(-1) - 40*mt**2*s**(-2)*t1**(-1) - 40*mt**2
     &    *s**(-2)*u1**(-1) + 16*mt**2*s**(-1)*t**(-1)*t1**(-1) + 16*
     &    mt**2*s**(-1)*u**(-1)*u1**(-1) - 16*mt**2*s**(-1)*t1**(-2) - 
     &    16*mt**2*s**(-1)*u1**(-2) + 32*mt**2*ms1**2*s**(-3)*t**(-1)
     &     + 32*mt**2*ms1**2*s**(-3)*u**(-1) - 16*mt**2*ms1**2*s**(-3)*
     &    t1**(-1) - 16*mt**2*ms1**2*s**(-3)*u1**(-1) + 72*mt**2*ms1**2
     &    *s**(-2)*t**(-1)*t1**(-1) )
      STGGV = STGGV + SK3B0A(2)*susy*Nc*Co*Pi*alphas**3 * ( 72*mt**2*
     &    ms1**2*s**(-2)*u**(-1)*u1**(-1) - 32*mt**2*ms1**2*s**(-2)*
     &    t1**(-2) - 32*mt**2*ms1**2*s**(-2)*u1**(-2) + 32*mt**2*ms1**2
     &    *s**(-1)*t**(-1)*t1**(-2) + 32*mt**2*ms1**2*s**(-1)*u**(-1)*
     &    u1**(-2) - 16*mt**2*ms1**2*s**(-1)*t1**(-3) - 16*mt**2*ms1**2
     &    *s**(-1)*u1**(-3) + 16*mt**2*ms1**4*s**(-3)*t**(-1)*t1**(-1)
     &     + 16*mt**2*ms1**4*s**(-3)*u**(-1)*u1**(-1) + 32*mt**2*ms1**4
     &    *s**(-2)*t**(-1)*t1**(-2) + 32*mt**2*ms1**4*s**(-2)*u**(-1)*
     &    u1**(-2) + 16*mt**2*ms1**4*s**(-1)*t**(-1)*t1**(-3) + 16*
     &    mt**2*ms1**4*s**(-1)*u**(-1)*u1**(-3) )
      STGGV = STGGV + SK3B0A(4)*susy*Ck*(Ns-2)*Pi*alphas**3 * ( 16./3.*
     &    s**(-2) + 32./3.*ms1**2*s**(-2)*t1**(-1) + 32./3.*ms1**2*
     &    s**(-2)*u1**(-1) + 32./3.*ms1**4*s**(-2)*t1**(-2) + 64./3.*
     &    ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 32./3.*ms1**4*s**(-2)*
     &    u1**(-2) )
      STGGV = STGGV + SK3B0A(4)*susy*Co*(Ns-2)*Pi*alphas**3 * (  - 32./
     &    3.*s**(-4)*t1**2 - 32./3.*s**(-3)*t1 - 16./3.*s**(-2) - 64./3.
     &    *ms1**2*s**(-3) - 32./3.*ms1**2*s**(-2)*t1**(-1) - 32./3.*
     &    ms1**2*s**(-2)*u1**(-1) - 32./3.*ms1**4*s**(-2)*t1**(-2) - 32.
     &    /3.*ms1**4*s**(-2)*u1**(-2) + 128*ms**2*ms1**2*s**(-4) + 128./
     &    3.*ms**2*ms1**2*s**(-3)*t1**(-1) + 128./3.*ms**2*ms1**2*
     &    s**(-3)*u1**(-1) + 32./3.*ms**2*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) )
      STGGV = STGGV + SK3B0A(5)*susy*Ck*Pi*alphas**3 * ( 8./3.*s**(-2)
     &     + 16./3.*ms1**2*s**(-2)*t1**(-1) + 16./3.*ms1**2*s**(-2)*
     &    u1**(-1) + 16./3.*ms1**4*s**(-2)*t1**(-2) + 32./3.*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) + 16./3.*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0A(5)*susy*Co*Pi*alphas**3 * (  - 16./3.*
     &    s**(-4)*t1**2 - 16./3.*s**(-3)*t1 - 8./3.*s**(-2) - 32./3.*
     &    ms1**2*s**(-3) - 16./3.*ms1**2*s**(-2)*t1**(-1) - 16./3.*
     &    ms1**2*s**(-2)*u1**(-1) - 16./3.*ms1**4*s**(-2)*t1**(-2) - 16.
     &    /3.*ms1**4*s**(-2)*u1**(-2) + 64*ms2**2*ms1**2*s**(-4) + 64./
     &    3.*ms2**2*ms1**2*s**(-3)*t1**(-1) + 64./3.*ms2**2*ms1**2*
     &    s**(-3)*u1**(-1) + 16./3.*ms2**2*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) )
      STGGV = STGGV + SK3B0A(6)*susy*Ck*Pi*alphas**3 * ( 8./3.*s**(-2)
     &     + 16./3.*ms1**2*s**(-2)*t1**(-1) + 16./3.*ms1**2*s**(-2)*
     &    u1**(-1) + 16./3.*ms1**4*s**(-2)*t1**(-2) + 32./3.*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) + 16./3.*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0A(6)*susy*Co*Pi*alphas**3 * (  - 16./3.*
     &    s**(-4)*t1**2 - 16./3.*s**(-3)*t1 - 8./3.*s**(-2) - 32./3.*
     &    ms1**2*s**(-3) - 16./3.*ms1**2*s**(-2)*t1**(-1) - 16./3.*
     &    ms1**2*s**(-2)*u1**(-1) + 64*ms1**2*mx1**2*s**(-4) + 64./3.*
     &    ms1**2*mx1**2*s**(-3)*t1**(-1) + 64./3.*ms1**2*mx1**2*s**(-3)
     &    *u1**(-1) + 16./3.*ms1**2*mx1**2*s**(-2)*t1**(-1)*u1**(-1) - 
     &    16./3.*ms1**4*s**(-2)*t1**(-2) - 16./3.*ms1**4*s**(-2)*
     &    u1**(-2) )
      STGGV = STGGV + SK3B0A(7)*susy*Ck*Pi*alphas**3 * ( 8./3.*s**(-2)
     &     + 16./3.*ms1**2*s**(-2)*t1**(-1) + 16./3.*ms1**2*s**(-2)*
     &    u1**(-1) + 16./3.*ms1**4*s**(-2)*t1**(-2) + 32./3.*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) + 16./3.*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0A(7)*susy*Co*Pi*alphas**3 * (  - 16./3.*
     &    s**(-4)*t1**2 - 16./3.*s**(-3)*t1 - 8./3.*s**(-2) - 32./3.*
     &    ms1**2*s**(-3) - 16./3.*ms1**2*s**(-2)*t1**(-1) - 16./3.*
     &    ms1**2*s**(-2)*u1**(-1) - 16./3.*ms1**4*s**(-2)*t1**(-2) - 16.
     &    /3.*ms1**4*s**(-2)*u1**(-2) + 64*mx2**2*ms1**2*s**(-4) + 64./
     &    3.*mx2**2*ms1**2*s**(-3)*t1**(-1) + 64./3.*mx2**2*ms1**2*
     &    s**(-3)*u1**(-1) + 16./3.*mx2**2*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) )
      STGGV = STGGV + SK3B0B(1)*Nc*Co*Pi*alphas**3 * (  - 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 2*(s-4*ms12)**(-1)*
     &    t1**(-1) - 2*(s-4*ms12)**(-1)*u1**(-1) - 32*s**(-4)*t1**2 - 
     &    32*s**(-3)*t1 + 2*s**(-1)*t1**(-1) + 2*s**(-1)*u1**(-1) - 32*
     &    ms1**2*s**(-3) - 8*ms1**2*s**(-2)*t1**(-1) - 8*ms1**2*s**(-2)
     &    *u1**(-1) )
      STGGV = STGGV + SK3B0B(2)*Co*Pi*alphas**3 * (  - 64*ms1**4*
     &    s**(-4) - 64./3.*ms1**4*s**(-3)*t1**(-1) - 64./3.*ms1**4*
     &    s**(-3)*u1**(-1) - 16./3.*ms1**4*s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(2)*Nc*Ck*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 2*(s-4*ms12)**(-1)*
     &    t1**(-1) + 2*(s-4*ms12)**(-1)*u1**(-1) + 32*s**(-4)*t1**2 + 
     &    32*s**(-3)*t1 - 2*s**(-1)*t1**(-1) - 2*s**(-1)*u1**(-1) + 32*
     &    ms1**2*s**(-3) + 8*ms1**2*s**(-2)*t1**(-1) + 8*ms1**2*s**(-2)
     &    *u1**(-1) )
      STGGV = STGGV + SK3B0B(3)*susy*Nc*Co*Pi*alphas**3 * ( 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 8*(s-4*ms12)**(-1)*s**(-1) + (s-4*ms12)**(-1)*t1**(-1)
     &     + (s-4*ms12)**(-1)*u1**(-1) + 64*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 + 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) + 4*(s-4*ms12)**(-1)*mt**2*
     &    s**(-1)*t1**(-1) + 4*(s-4*ms12)**(-1)*mt**2*s**(-1)*u1**(-1)
     &     + 64*(s-4*ms12)**(-1)*mg**2*s**(-4)*t1**2 + 64*
     &    (s-4*ms12)**(-1)*mg**2*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mg**2
     &    *s**(-2) + 4*(s-4*ms12)**(-1)*mg**2*s**(-1)*t1**(-1) + 4*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1)*u1**(-1) + 16*s**(-4)*t1**2 + 
     &    16*s**(-3)*t1 - s**(-1)*t1**(-1) - s**(-1)*u1**(-1) + 16*
     &    ms1**2*s**(-3) + 4*ms1**2*s**(-2)*t1**(-1) + 4*ms1**2*s**(-2)
     &    *u1**(-1) - 16*mt**2*s**(-3) - 4*mt**2*s**(-2)*t1**(-1) - 4*
     &    mt**2*s**(-2)*u1**(-1) - 16*mg**2*s**(-3) - 4*mg**2*s**(-2)*
     &    t1**(-1) )
      STGGV = STGGV + SK3B0B(3)*susy*Nc*Co*Pi*alphas**3 * (  - 4*mg**2*
     &    s**(-2)*u1**(-1) + 128*mg**2*ms1**2*s**(-4) + 128./3.*mg**2*
     &    ms1**2*s**(-3)*t1**(-1) + 128./3.*mg**2*ms1**2*s**(-3)*
     &    u1**(-1) + 32./3.*mg**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(3)*susy*Nc*Co*s2t*Pi*alphas**3 * (  - 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 - 128*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg*mt*s**(-2) - 8*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-1)*t1**(-1) - 8*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-1)*u1**(-1) + 32*mg*mt*s**(-3) + 8*mg*mt*s**(-2)*
     &    t1**(-1) + 8*mg*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0B(4)*Co*Pi*alphas**3 * ( 128*mt**2*ms1**2*
     &    s**(-4) + 128./3.*mt**2*ms1**2*s**(-3)*t1**(-1) + 128./3.*
     &    mt**2*ms1**2*s**(-3)*u1**(-1) + 32./3.*mt**2*ms1**2*s**(-2)*
     &    t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(4)*susy*Nc*Ck*Pi*alphas**3 * (  - 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 8*(s-4*ms12)**(-1)*s**(-1) - (s-4*ms12)**(-1)*t1**(-1)
     &     - (s-4*ms12)**(-1)*u1**(-1) - 64*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) - 4*(s-4*ms12)**(-1)*mt**2*
     &    s**(-1)*t1**(-1) - 4*(s-4*ms12)**(-1)*mt**2*s**(-1)*u1**(-1)
     &     - 64*(s-4*ms12)**(-1)*mg**2*s**(-4)*t1**2 - 64*
     &    (s-4*ms12)**(-1)*mg**2*s**(-3)*t1 - 32*(s-4*ms12)**(-1)*mg**2
     &    *s**(-2) - 4*(s-4*ms12)**(-1)*mg**2*s**(-1)*t1**(-1) - 4*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1)*u1**(-1) - 16*s**(-4)*t1**2 - 
     &    16*s**(-3)*t1 + s**(-1)*t1**(-1) + s**(-1)*u1**(-1) - 16*
     &    ms1**2*s**(-3) - 4*ms1**2*s**(-2)*t1**(-1) - 4*ms1**2*s**(-2)
     &    *u1**(-1) + 16*mt**2*s**(-3) + 4*mt**2*s**(-2)*t1**(-1) + 4*
     &    mt**2*s**(-2)*u1**(-1) + 16*mg**2*s**(-3) + 4*mg**2*s**(-2)*
     &    t1**(-1) )
      STGGV = STGGV + SK3B0B(4)*susy*Nc*Ck*Pi*alphas**3 * ( 4*mg**2*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0B(4)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 + 128*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 + 64*(s-4*ms12)**(-1)*mg*mt*s**(-2) + 8*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-1)*t1**(-1) + 8*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-1)*u1**(-1) - 32*mg*mt*s**(-3) - 8*mg*mt*s**(-2)*
     &    t1**(-1) - 8*mg*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0B(5)*susy*Co*(Ns-2)*Pi*alphas**3 * (  - 128*
     &    ms**2*ms1**2*s**(-4) - 128./3.*ms**2*ms1**2*s**(-3)*t1**(-1)
     &     - 128./3.*ms**2*ms1**2*s**(-3)*u1**(-1) - 32./3.*ms**2*
     &    ms1**2*s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(6)*susy*Co*Pi*alphas**3 * (  - 64*ms2**2*
     &    ms1**2*s**(-4) - 64./3.*ms2**2*ms1**2*s**(-3)*t1**(-1) - 64./
     &    3.*ms2**2*ms1**2*s**(-3)*u1**(-1) - 16./3.*ms2**2*ms1**2*
     &    s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(7)*susy*Co*Pi*alphas**3 * (  - 64*ms1**2*
     &    mx1**2*s**(-4) - 64./3.*ms1**2*mx1**2*s**(-3)*t1**(-1) - 64./
     &    3.*ms1**2*mx1**2*s**(-3)*u1**(-1) - 16./3.*ms1**2*mx1**2*
     &    s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0B(8)*susy*Co*Pi*alphas**3 * (  - 64*mx2**2*
     &    ms1**2*s**(-4) - 64./3.*mx2**2*ms1**2*s**(-3)*t1**(-1) - 64./
     &    3.*mx2**2*ms1**2*s**(-3)*u1**(-1) - 16./3.*mx2**2*ms1**2*
     &    s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0C(1)*Cqed*Pi*alphas**3 * ( 32*s**(-2) + 64*
     &    ms1**2*s**(-2)*t1**(-1) + 64*ms1**2*s**(-2)*u1**(-1) + 96*
     &    ms1**4*s**(-2)*t1**(-2) + 128*ms1**4*s**(-2)*t1**(-1)*
     &    u1**(-1) + 96*ms1**4*s**(-2)*u1**(-2) + 64*ms1**6*s**(-2)*
     &    t1**(-3) + 64*ms1**6*s**(-2)*t1**(-2)*u1**(-1) + 64*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-2) + 64*ms1**6*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(1)*Nc*Ck*Pi*alphas**3 * (  - 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 2*(s-4*ms12)**(-1)*
     &    t1**(-1) - 2*(s-4*ms12)**(-1)*u1**(-1) - 32*s**(-4)*t1**2 - 
     &    32*s**(-3)*t1 - 80*s**(-2) + 2*s**(-1)*t1**(-1) + 2*s**(-1)*
     &    u1**(-1) - 96*ms1**2*s**(-3) - 184*ms1**2*s**(-2)*t1**(-1) - 
     &    184*ms1**2*s**(-2)*u1**(-1) - 32*ms1**4*s**(-3)*t1**(-1) - 32
     &    *ms1**4*s**(-3)*u1**(-1) - 288*ms1**4*s**(-2)*t1**(-2) - 256*
     &    ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 288*ms1**4*s**(-2)*
     &    u1**(-2) - 192*ms1**6*s**(-2)*t1**(-3) - 128*ms1**6*s**(-2)*
     &    t1**(-2)*u1**(-1) - 128*ms1**6*s**(-2)*t1**(-1)*u1**(-2) - 
     &    192*ms1**6*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(1)*Nc*Co*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 2*(s-4*ms12)**(-1)*
     &    t1**(-1) + 2*(s-4*ms12)**(-1)*u1**(-1) + 32*s**(-4)*t1**2 + 
     &    32*s**(-3)*t1 + 16*s**(-2) - 2*s**(-1)*t1**(-1) - 2*s**(-1)*
     &    u1**(-1) + 96*ms1**2*s**(-3) + 56*ms1**2*s**(-2)*t1**(-1) + 
     &    56*ms1**2*s**(-2)*u1**(-1) + 32*ms1**4*s**(-3)*t1**(-1) + 32*
     &    ms1**4*s**(-3)*u1**(-1) + 96*ms1**4*s**(-2)*t1**(-2) + 96*
     &    ms1**4*s**(-2)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-3) + 64*
     &    ms1**6*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Cqed*Pi*alphas**3 * (  - 16*
     &    s**(-2) - 32*ms1**2*s**(-2)*t1**(-1) - 32*ms1**2*s**(-2)*
     &    u1**(-1) - 48*ms1**4*s**(-2)*t1**(-2) - 64*ms1**4*s**(-2)*
     &    t1**(-1)*u1**(-1) - 48*ms1**4*s**(-2)*u1**(-2) - 32*ms1**6*
     &    s**(-2)*t1**(-3) - 32*ms1**6*s**(-2)*t1**(-2)*u1**(-1) - 32*
     &    ms1**6*s**(-2)*t1**(-1)*u1**(-2) - 32*ms1**6*s**(-2)*u1**(-3)
     &     + 16*mt**2*s**(-2)*t1**(-1) + 16*mt**2*s**(-2)*u1**(-1) + 48
     &    *mt**2*ms1**2*s**(-2)*t1**(-2) + 64*mt**2*ms1**2*s**(-2)*
     &    t1**(-1)*u1**(-1) + 48*mt**2*ms1**2*s**(-2)*u1**(-2) + 32*
     &    mt**2*ms1**4*s**(-2)*t1**(-3) + 32*mt**2*ms1**4*s**(-2)*
     &    t1**(-2)*u1**(-1) + 32*mt**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2)
     &     + 32*mt**2*ms1**4*s**(-2)*u1**(-3) + 16*mg**2*s**(-2)*
     &    t1**(-1) + 16*mg**2*s**(-2)*u1**(-1) + 48*mg**2*ms1**2*
     &    s**(-2)*t1**(-2) + 64*mg**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1)
     &     + 48*mg**2*ms1**2*s**(-2)*u1**(-2) + 32*mg**2*ms1**4*s**(-2)
     &    *t1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Cqed*Pi*alphas**3 * ( 32*mg**2*
     &    ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 32*mg**2*ms1**4*s**(-2)*
     &    t1**(-1)*u1**(-2) + 32*mg**2*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Cqed*s2t*Pi*alphas**3 * (  - 32*mg
     &    *mt*s**(-2)*t1**(-1) - 32*mg*mt*s**(-2)*u1**(-1) - 96*mg*mt*
     &    ms1**2*s**(-2)*t1**(-2) - 128*mg*mt*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) - 96*mg*mt*ms1**2*s**(-2)*u1**(-2) - 64*mg*mt*ms1**4
     &    *s**(-2)*t1**(-3) - 64*mg*mt*ms1**4*s**(-2)*t1**(-2)*u1**(-1)
     &     - 64*mg*mt*ms1**4*s**(-2)*t1**(-1)*u1**(-2) - 64*mg*mt*
     &    ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Ck*Pi*alphas**3 * ( 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 8*(s-4*ms12)**(-1)*s**(-1) + (s-4*ms12)**(-1)*t1**(-1)
     &     + (s-4*ms12)**(-1)*u1**(-1) + 64*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 + 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) + 4*(s-4*ms12)**(-1)*mt**2*
     &    s**(-1)*t1**(-1) + 4*(s-4*ms12)**(-1)*mt**2*s**(-1)*u1**(-1)
     &     + 64*(s-4*ms12)**(-1)*mg**2*s**(-4)*t1**2 + 64*
     &    (s-4*ms12)**(-1)*mg**2*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mg**2
     &    *s**(-2) + 4*(s-4*ms12)**(-1)*mg**2*s**(-1)*t1**(-1) + 4*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1)*u1**(-1) + 16*s**(-4)*t1**2 + 
     &    16*s**(-3)*t1 + 40*s**(-2) - s**(-1)*t1**(-1) - s**(-1)*
     &    u1**(-1) + 48*ms1**2*s**(-3) + 92*ms1**2*s**(-2)*t1**(-1) + 
     &    92*ms1**2*s**(-2)*u1**(-1) + 16*ms1**4*s**(-3)*t1**(-1) + 16*
     &    ms1**4*s**(-3)*u1**(-1) + 144*ms1**4*s**(-2)*t1**(-2) + 128*
     &    ms1**4*s**(-2)*t1**(-1)*u1**(-1) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Ck*Pi*alphas**3 * ( 144*ms1**4*
     &    s**(-2)*u1**(-2) + 96*ms1**6*s**(-2)*t1**(-3) + 64*ms1**6*
     &    s**(-2)*t1**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*t1**(-1)*
     &    u1**(-2) + 96*ms1**6*s**(-2)*u1**(-3) - 48*mt**2*s**(-3) - 52
     &    *mt**2*s**(-2)*t1**(-1) - 52*mt**2*s**(-2)*u1**(-1) - 16*
     &    mt**2*ms1**2*s**(-3)*t1**(-1) - 16*mt**2*ms1**2*s**(-3)*
     &    u1**(-1) - 144*mt**2*ms1**2*s**(-2)*t1**(-2) - 128*mt**2*
     &    ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 144*mt**2*ms1**2*s**(-2)*
     &    u1**(-2) - 96*mt**2*ms1**4*s**(-2)*t1**(-3) - 64*mt**2*ms1**4
     &    *s**(-2)*t1**(-2)*u1**(-1) - 64*mt**2*ms1**4*s**(-2)*t1**(-1)
     &    *u1**(-2) - 96*mt**2*ms1**4*s**(-2)*u1**(-3) - 48*mg**2*
     &    s**(-3) - 52*mg**2*s**(-2)*t1**(-1) - 52*mg**2*s**(-2)*
     &    u1**(-1) - 16*mg**2*ms1**2*s**(-3)*t1**(-1) - 16*mg**2*ms1**2
     &    *s**(-3)*u1**(-1) - 144*mg**2*ms1**2*s**(-2)*t1**(-2) - 128*
     &    mg**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 144*mg**2*ms1**2*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Ck*Pi*alphas**3 * (  - 96*mg**2
     &    *ms1**4*s**(-2)*t1**(-3) - 64*mg**2*ms1**4*s**(-2)*t1**(-2)*
     &    u1**(-1) - 64*mg**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2) - 96*
     &    mg**2*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 - 128*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg*mt*s**(-2) - 8*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-1)*t1**(-1) - 8*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-1)*u1**(-1) + 96*mg*mt*s**(-3) + 104*mg*mt*s**(-2)
     &    *t1**(-1) + 104*mg*mt*s**(-2)*u1**(-1) + 32*mg*mt*ms1**2*
     &    s**(-3)*t1**(-1) + 32*mg*mt*ms1**2*s**(-3)*u1**(-1) + 288*mg*
     &    mt*ms1**2*s**(-2)*t1**(-2) + 256*mg*mt*ms1**2*s**(-2)*
     &    t1**(-1)*u1**(-1) + 288*mg*mt*ms1**2*s**(-2)*u1**(-2) + 192*
     &    mg*mt*ms1**4*s**(-2)*t1**(-3) + 128*mg*mt*ms1**4*s**(-2)*
     &    t1**(-2)*u1**(-1) + 128*mg*mt*ms1**4*s**(-2)*t1**(-1)*
     &    u1**(-2) + 192*mg*mt*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Co*Pi*alphas**3 * (  - 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 8*(s-4*ms12)**(-1)*s**(-1) - (s-4*ms12)**(-1)*t1**(-1)
     &     - (s-4*ms12)**(-1)*u1**(-1) - 8*(s-4*ms12)**(-1)*mt**2*
     &    ms1**(-2)*s**(-1) + 4*(s-4*ms12)**(-1)*mt**2*ms1**(-2)*
     &    t1**(-1) + 4*(s-4*ms12)**(-1)*mt**2*ms1**(-2)*u1**(-1) - 64*
     &    (s-4*ms12)**(-1)*mt**2*s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*
     &    mt**2*s**(-3)*t1 - 20*(s-4*ms12)**(-1)*mt**2*s**(-1)*t1**(-1)
     &     - 20*(s-4*ms12)**(-1)*mt**2*s**(-1)*u1**(-1) + 8*
     &    (s-4*ms12)**(-1)*mg**2*ms1**(-2)*s**(-1) - 4*(s-4*ms12)**(-1)
     &    *mg**2*ms1**(-2)*t1**(-1) - 4*(s-4*ms12)**(-1)*mg**2*
     &    ms1**(-2)*u1**(-1) - 64*(s-4*ms12)**(-1)*mg**2*s**(-4)*t1**2
     &     - 64*(s-4*ms12)**(-1)*mg**2*s**(-3)*t1 - 64*(s-4*ms12)**(-1)
     &    *mg**2*s**(-2) + 12*(s-4*ms12)**(-1)*mg**2*s**(-1)*t1**(-1)
     &     + 12*(s-4*ms12)**(-1)*mg**2*s**(-1)*u1**(-1) - 16*s**(-4)*
     &    t1**2 )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Co*Pi*alphas**3 * (  - 16*
     &    s**(-3)*t1 - 8*s**(-2) + s**(-1)*t1**(-1) + s**(-1)*u1**(-1)
     &     - 48*ms1**2*s**(-3) - 28*ms1**2*s**(-2)*t1**(-1) - 28*ms1**2
     &    *s**(-2)*u1**(-1) - 16*ms1**4*s**(-3)*t1**(-1) - 16*ms1**4*
     &    s**(-3)*u1**(-1) - 48*ms1**4*s**(-2)*t1**(-2) - 48*ms1**4*
     &    s**(-2)*u1**(-2) - 32*ms1**6*s**(-2)*t1**(-3) - 32*ms1**6*
     &    s**(-2)*u1**(-3) + 8*mt**2*ms1**(-2)*s**(-2) - 4*mt**2*
     &    ms1**(-2)*s**(-1)*t1**(-1) - 4*mt**2*ms1**(-2)*s**(-1)*
     &    u1**(-1) + 48*mt**2*s**(-3) + 20*mt**2*s**(-2)*t1**(-1) + 20*
     &    mt**2*s**(-2)*u1**(-1) + 16*mt**2*ms1**2*s**(-3)*t1**(-1) + 
     &    16*mt**2*ms1**2*s**(-3)*u1**(-1) + 48*mt**2*ms1**2*s**(-2)*
     &    t1**(-2) + 48*mt**2*ms1**2*s**(-2)*u1**(-2) + 32*mt**2*ms1**4
     &    *s**(-2)*t1**(-3) + 32*mt**2*ms1**4*s**(-2)*u1**(-3) - 8*
     &    mg**2*ms1**(-2)*s**(-2) + 4*mg**2*ms1**(-2)*s**(-1)*t1**(-1)
     &     + 4*mg**2*ms1**(-2)*s**(-1)*u1**(-1) + 48*mg**2*s**(-3) + 20
     &    *mg**2*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Co*Pi*alphas**3 * ( 20*mg**2*
     &    s**(-2)*u1**(-1) + 16*mg**2*ms1**2*s**(-3)*t1**(-1) + 16*
     &    mg**2*ms1**2*s**(-3)*u1**(-1) + 48*mg**2*ms1**2*s**(-2)*
     &    t1**(-2) + 48*mg**2*ms1**2*s**(-2)*u1**(-2) + 32*mg**2*ms1**4
     &    *s**(-2)*t1**(-3) + 32*mg**2*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0C(2)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 + 128*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 + 64*(s-4*ms12)**(-1)*mg*mt*s**(-2) + 8*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-1)*t1**(-1) + 8*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-1)*u1**(-1) - 96*mg*mt*s**(-3) - 40*mg*mt*s**(-2)*
     &    t1**(-1) - 40*mg*mt*s**(-2)*u1**(-1) - 32*mg*mt*ms1**2*
     &    s**(-3)*t1**(-1) - 32*mg*mt*ms1**2*s**(-3)*u1**(-1) - 96*mg*
     &    mt*ms1**2*s**(-2)*t1**(-2) - 96*mg*mt*ms1**2*s**(-2)*u1**(-2)
     &     - 64*mg*mt*ms1**4*s**(-2)*t1**(-3) - 64*mg*mt*ms1**4*s**(-2)
     &    *u1**(-3) )
      STGGV = STGGV + SK3B0D(1,1)*Cqed*Pi*alphas**3 * ( 4*s**(-2)*
     &    t**(-1)*t1 - 20*s**(-2) - 4*s**(-1)*t1**(-1) - 4*s**(-1)*
     &    u1**(-1) - 4*t**(-1)*u1**(-1) - 4*ms1**2*s**(-2)*t**(-1) - 24
     &    *ms1**2*s**(-2)*t1**(-1) + 4*ms1**2*s**(-1)*t**(-1)*t1**(-1)
     &     + 20*ms1**2*s**(-1)*t**(-1)*u1**(-1) - 120*ms1**4*s**(-2)*
     &    t**(-1)*t1**(-1) - 80*ms1**4*s**(-2)*t**(-1)*u1**(-1) - 160*
     &    ms1**6*s**(-2)*t**(-1)*t1**(-2) - 128*ms1**6*s**(-2)*t**(-1)*
     &    t1**(-1)*u1**(-1) - 64*ms1**8*s**(-2)*t**(-1)*t1**(-3) - 64*
     &    ms1**8*s**(-2)*t**(-1)*t1**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0D(1,1)*Nc*Ck*Pi*alphas**3 * (  - 4*s**(-3)*
     &    t**(-1)*t1**2 + 20*s**(-3)*t1 + 2*s**(-2)*t**(-1)*t1 + 46*
     &    s**(-2) - 4*s**(-1)*t**(-1) + 12*s**(-1)*t1**(-1) + 8*s**(-1)
     &    *u1**(-1) + 8*t**(-1)*u1**(-1) + 4*ms1**2*s**(-3)*t**(-1)*t1
     &     + 24*ms1**2*s**(-3) + 38*ms1**2*s**(-2)*t**(-1) + 84*ms1**2*
     &    s**(-2)*t1**(-1) + 8*ms1**2*s**(-2)*u1**(-1) - 20*ms1**2*
     &    s**(-1)*t**(-1)*t1**(-1) - 32*ms1**2*s**(-1)*t**(-1)*u1**(-1)
     &     + 8*ms1**2*s**(-1)*t1**(-2) + 40*ms1**4*s**(-3)*t**(-1) + 
     &    236*ms1**4*s**(-2)*t**(-1)*t1**(-1) + 72*ms1**4*s**(-2)*
     &    t**(-1)*u1**(-1) + 112*ms1**4*s**(-2)*t1**(-2) + 80*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) - 8*ms1**4*s**(-1)*t**(-1)*t1**(-2)
     &     + 32*ms1**6*s**(-3)*t**(-1)*t1**(-1) + 304*ms1**6*s**(-2)*
     &    t**(-1)*t1**(-2) + 112*ms1**6*s**(-2)*t**(-1)*t1**(-1)*
     &    u1**(-1) + 64*ms1**6*s**(-2)*t1**(-3) + 64*ms1**6*s**(-2)*
     &    t1**(-2)*u1**(-1) + 128*ms1**8*s**(-2)*t**(-1)*t1**(-3) + 64*
     &    ms1**8*s**(-2)*t**(-1)*t1**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0D(1,1)*Nc*Co*Pi*alphas**3 * ( 7*s**(-3)*
     &    t**(-1)*t1**2 - 23*s**(-3)*t1 + 17*s**(-2)*t**(-1)*t1 - 33*
     &    s**(-2) + 5*s**(-1)*t**(-1) - 5*s**(-1)*t1**(-1) + 19*ms1**2*
     &    s**(-3)*t**(-1)*t1 - 44*ms1**2*s**(-3) + 47*ms1**2*s**(-2)*
     &    t**(-1) - 78*ms1**2*s**(-2)*t1**(-1) + 11*ms1**2*s**(-1)*
     &    t**(-1)*t1**(-1) - 6*ms1**2*s**(-1)*t1**(-2) + 12*ms1**4*
     &    s**(-3)*t**(-1) - 32*ms1**4*s**(-3)*t1**(-1) + 46*ms1**4*
     &    s**(-2)*t**(-1)*t1**(-1) - 112*ms1**4*s**(-2)*t1**(-2) + 6*
     &    ms1**4*s**(-1)*t**(-1)*t1**(-2) + 16*ms1**6*s**(-2)*t**(-1)*
     &    t1**(-2) - 64*ms1**6*s**(-2)*t1**(-3) )
      STGGV = STGGV + SK3B0D(1,2)*Cqed*Pi*alphas**3 * (  - 4*s**(-2)*
     &    u**(-1)*t1 - 20*s**(-2) - 4*s**(-1)*u**(-1) - 4*s**(-1)*
     &    t1**(-1) - 4*s**(-1)*u1**(-1) - 4*u**(-1)*t1**(-1) - 4*ms1**2
     &    *s**(-2)*u**(-1) - 24*ms1**2*s**(-2)*u1**(-1) + 20*ms1**2*
     &    s**(-1)*u**(-1)*t1**(-1) + 4*ms1**2*s**(-1)*u**(-1)*u1**(-1)
     &     - 80*ms1**4*s**(-2)*u**(-1)*t1**(-1) - 120*ms1**4*s**(-2)*
     &    u**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u**(-1)*t1**(-1)*
     &    u1**(-1) - 160*ms1**6*s**(-2)*u**(-1)*u1**(-2) - 64*ms1**8*
     &    s**(-2)*u**(-1)*t1**(-1)*u1**(-2) - 64*ms1**8*s**(-2)*u**(-1)
     &    *u1**(-3) )
      STGGV = STGGV + SK3B0D(1,2)*Nc*Ck*Pi*alphas**3 * (  - 4*s**(-3)*
     &    u**(-1)*t1**2 - 20*s**(-3)*t1 - 10*s**(-2)*u**(-1)*t1 + 26*
     &    s**(-2) - 10*s**(-1)*u**(-1) + 8*s**(-1)*t1**(-1) + 12*
     &    s**(-1)*u1**(-1) + 8*u**(-1)*t1**(-1) - 4*ms1**2*s**(-3)*
     &    u**(-1)*t1 + 24*ms1**2*s**(-3) + 34*ms1**2*s**(-2)*u**(-1) + 
     &    8*ms1**2*s**(-2)*t1**(-1) + 84*ms1**2*s**(-2)*u1**(-1) - 32*
     &    ms1**2*s**(-1)*u**(-1)*t1**(-1) - 20*ms1**2*s**(-1)*u**(-1)*
     &    u1**(-1) + 8*ms1**2*s**(-1)*u1**(-2) + 40*ms1**4*s**(-3)*
     &    u**(-1) + 72*ms1**4*s**(-2)*u**(-1)*t1**(-1) + 236*ms1**4*
     &    s**(-2)*u**(-1)*u1**(-1) + 80*ms1**4*s**(-2)*t1**(-1)*
     &    u1**(-1) + 112*ms1**4*s**(-2)*u1**(-2) - 8*ms1**4*s**(-1)*
     &    u**(-1)*u1**(-2) + 32*ms1**6*s**(-3)*u**(-1)*u1**(-1) + 112*
     &    ms1**6*s**(-2)*u**(-1)*t1**(-1)*u1**(-1) + 304*ms1**6*s**(-2)
     &    *u**(-1)*u1**(-2) + 64*ms1**6*s**(-2)*t1**(-1)*u1**(-2) + 64*
     &    ms1**6*s**(-2)*u1**(-3) + 64*ms1**8*s**(-2)*u**(-1)*t1**(-1)*
     &    u1**(-2) )
      STGGV = STGGV + SK3B0D(1,2)*Nc*Ck*Pi*alphas**3 * ( 128*ms1**8*
     &    s**(-2)*u**(-1)*u1**(-3) )
      STGGV = STGGV + SK3B0D(1,2)*Nc*Co*Pi*alphas**3 * ( 7*s**(-3)*
     &    u**(-1)*t1**2 + 23*s**(-3)*t1 - 3*s**(-2)*u**(-1)*t1 - 10*
     &    s**(-2) - 5*s**(-1)*u**(-1) - 5*s**(-1)*u1**(-1) - 19*ms1**2*
     &    s**(-3)*u**(-1)*t1 - 44*ms1**2*s**(-3) + 28*ms1**2*s**(-2)*
     &    u**(-1) - 78*ms1**2*s**(-2)*u1**(-1) + 11*ms1**2*s**(-1)*
     &    u**(-1)*u1**(-1) - 6*ms1**2*s**(-1)*u1**(-2) + 12*ms1**4*
     &    s**(-3)*u**(-1) - 32*ms1**4*s**(-3)*u1**(-1) + 46*ms1**4*
     &    s**(-2)*u**(-1)*u1**(-1) - 112*ms1**4*s**(-2)*u1**(-2) + 6*
     &    ms1**4*s**(-1)*u**(-1)*u1**(-2) + 16*ms1**6*s**(-2)*u**(-1)*
     &    u1**(-2) - 64*ms1**6*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0D(2,1)*susy*Cqed*Pi*alphas**3 * ( 8*s**(-2)
     &     + 24*ms1**2*s**(-2)*t1**(-1) + 8*ms1**2*s**(-2)*u1**(-1) + 
     &    48*ms1**4*s**(-2)*t1**(-2) + 32*ms1**4*s**(-2)*t1**(-1)*
     &    u1**(-1) + 32*ms1**6*s**(-2)*t1**(-3) + 32*ms1**6*s**(-2)*
     &    t1**(-2)*u1**(-1) - 16*mt**2*s**(-2)*t1**(-1) - 48*mt**2*
     &    ms1**2*s**(-2)*t1**(-2) - 32*mt**2*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) - 32*mt**2*ms1**4*s**(-2)*t1**(-3) - 32*mt**2*ms1**4
     &    *s**(-2)*t1**(-2)*u1**(-1) - 16*mg**2*s**(-2)*t1**(-1) - 48*
     &    mg**2*ms1**2*s**(-2)*t1**(-2) - 32*mg**2*ms1**2*s**(-2)*
     &    t1**(-1)*u1**(-1) - 32*mg**2*ms1**4*s**(-2)*t1**(-3) - 32*
     &    mg**2*ms1**4*s**(-2)*t1**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0D(2,1)*susy*Cqed*s2t*Pi*alphas**3 * ( 32*mg*
     &    mt*s**(-2)*t1**(-1) + 96*mg*mt*ms1**2*s**(-2)*t1**(-2) + 64*
     &    mg*mt*ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 64*mg*mt*ms1**4*
     &    s**(-2)*t1**(-3) + 64*mg*mt*ms1**4*s**(-2)*t1**(-2)*u1**(-1)
     &     )
      STGGV = STGGV + SK3B0D(2,1)*susy*Nc*Ck*Pi*alphas**3 * (  - 8*
     &    s**(-3)*t1 - 24*s**(-2) - 16*ms1**2*s**(-3) - 72*ms1**2*
     &    s**(-2)*t1**(-1) - 16*ms1**2*s**(-2)*u1**(-1) - 16*ms1**4*
     &    s**(-3)*t1**(-1) - 144*ms1**4*s**(-2)*t1**(-2) - 64*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-1) - 96*ms1**6*s**(-2)*t1**(-3) - 64*
     &    ms1**6*s**(-2)*t1**(-2)*u1**(-1) + 16*mt**2*s**(-3) + 48*
     &    mt**2*s**(-2)*t1**(-1) + 16*mt**2*ms1**2*s**(-3)*t1**(-1) + 
     &    144*mt**2*ms1**2*s**(-2)*t1**(-2) + 64*mt**2*ms1**2*s**(-2)*
     &    t1**(-1)*u1**(-1) + 96*mt**2*ms1**4*s**(-2)*t1**(-3) + 64*
     &    mt**2*ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 16*mg**2*s**(-3) + 
     &    48*mg**2*s**(-2)*t1**(-1) + 16*mg**2*ms1**2*s**(-3)*t1**(-1)
     &     + 144*mg**2*ms1**2*s**(-2)*t1**(-2) + 64*mg**2*ms1**2*
     &    s**(-2)*t1**(-1)*u1**(-1) + 96*mg**2*ms1**4*s**(-2)*t1**(-3)
     &     + 64*mg**2*ms1**4*s**(-2)*t1**(-2)*u1**(-1) )
      STGGV = STGGV + SK3B0D(2,1)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*s**(-3) - 96*mg*mt*s**(-2)*t1**(-1) - 32*mg*mt*ms1**2*
     &    s**(-3)*t1**(-1) - 288*mg*mt*ms1**2*s**(-2)*t1**(-2) - 128*mg
     &    *mt*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 192*mg*mt*ms1**4*
     &    s**(-2)*t1**(-3) - 128*mg*mt*ms1**4*s**(-2)*t1**(-2)*u1**(-1)
     &     )
      STGGV = STGGV + SK3B0D(2,1)*susy*Nc*Co*Pi*alphas**3 * ( 16*
     &    s**(-3)*t**(-1)*t1**2 - 8*s**(-3)*t1 + 40*s**(-2)*t**(-1)*t1
     &     - 32*s**(-2) + 16*s**(-1)*t**(-1) - 16*s**(-1)*t1**(-1) + 48
     &    *ms1**2*s**(-3)*t**(-1)*t1 - 16*ms1**2*s**(-3) + 112*ms1**2*
     &    s**(-2)*t**(-1) - 48*ms1**2*s**(-2)*t1**(-1) + 48*ms1**2*
     &    s**(-1)*t**(-1)*t1**(-1) - 32*ms1**2*s**(-1)*t1**(-2) + 48*
     &    ms1**4*s**(-3)*t**(-1) + 104*ms1**4*s**(-2)*t**(-1)*t1**(-1)
     &     + 16*ms1**4*s**(-2)*t1**(-2) + 48*ms1**4*s**(-1)*t**(-1)*
     &    t1**(-2) - 16*ms1**4*s**(-1)*t1**(-3) + 16*ms1**6*s**(-3)*
     &    t**(-1)*t1**(-1) + 32*ms1**6*s**(-2)*t**(-1)*t1**(-2) + 32*
     &    ms1**6*s**(-2)*t1**(-3) + 16*ms1**6*s**(-1)*t**(-1)*t1**(-3)
     &     - 16*mt**2*s**(-3)*t**(-1)*t1 - 40*mt**2*s**(-2)*t**(-1) + 
     &    24*mt**2*s**(-2)*t1**(-1) - 16*mt**2*s**(-1)*t**(-1)*t1**(-1)
     &     + 16*mt**2*s**(-1)*t1**(-2) - 32*mt**2*ms1**2*s**(-3)*
     &    t**(-1) - 72*mt**2*ms1**2*s**(-2)*t**(-1)*t1**(-1) - 16*mt**2
     &    *ms1**2*s**(-2)*t1**(-2) )
      STGGV = STGGV + SK3B0D(2,1)*susy*Nc*Co*Pi*alphas**3 * (  - 32*
     &    mt**2*ms1**2*s**(-1)*t**(-1)*t1**(-2) + 16*mt**2*ms1**2*
     &    s**(-1)*t1**(-3) - 16*mt**2*ms1**4*s**(-3)*t**(-1)*t1**(-1)
     &     - 32*mt**2*ms1**4*s**(-2)*t**(-1)*t1**(-2) - 32*mt**2*ms1**4
     &    *s**(-2)*t1**(-3) - 16*mt**2*ms1**4*s**(-1)*t**(-1)*t1**(-3)
     &     + 16*mg**2*s**(-3)*t**(-1)*t1 - 32*mg**2*s**(-3) + 40*mg**2*
     &    s**(-2)*t**(-1) - 56*mg**2*s**(-2)*t1**(-1) + 16*mg**2*
     &    s**(-1)*t**(-1)*t1**(-1) - 16*mg**2*s**(-1)*t1**(-2) + 32*
     &    mg**2*ms1**2*s**(-3)*t**(-1) - 32*mg**2*ms1**2*s**(-3)*
     &    t1**(-1) + 72*mg**2*ms1**2*s**(-2)*t**(-1)*t1**(-1) - 80*
     &    mg**2*ms1**2*s**(-2)*t1**(-2) + 32*mg**2*ms1**2*s**(-1)*
     &    t**(-1)*t1**(-2) - 16*mg**2*ms1**2*s**(-1)*t1**(-3) + 16*
     &    mg**2*ms1**4*s**(-3)*t**(-1)*t1**(-1) + 32*mg**2*ms1**4*
     &    s**(-2)*t**(-1)*t1**(-2) - 32*mg**2*ms1**4*s**(-2)*t1**(-3)
     &     + 16*mg**2*ms1**4*s**(-1)*t**(-1)*t1**(-3) )
      STGGV = STGGV + SK3B0D(2,1)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 32*mg
     &    *mt*s**(-3) + 32*mg*mt*s**(-2)*t1**(-1) + 32*mg*mt*ms1**2*
     &    s**(-3)*t1**(-1) + 96*mg*mt*ms1**2*s**(-2)*t1**(-2) + 64*mg*
     &    mt*ms1**4*s**(-2)*t1**(-3) )
      STGGV = STGGV + SK3B0D(2,2)*susy*Cqed*Pi*alphas**3 * ( 8*s**(-2)
     &     + 8*ms1**2*s**(-2)*t1**(-1) + 24*ms1**2*s**(-2)*u1**(-1) + 
     &    32*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 48*ms1**4*s**(-2)*
     &    u1**(-2) + 32*ms1**6*s**(-2)*t1**(-1)*u1**(-2) + 32*ms1**6*
     &    s**(-2)*u1**(-3) - 16*mt**2*s**(-2)*u1**(-1) - 32*mt**2*
     &    ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 48*mt**2*ms1**2*s**(-2)*
     &    u1**(-2) - 32*mt**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2) - 32*
     &    mt**2*ms1**4*s**(-2)*u1**(-3) - 16*mg**2*s**(-2)*u1**(-1) - 
     &    32*mg**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 48*mg**2*ms1**2*
     &    s**(-2)*u1**(-2) - 32*mg**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2)
     &     - 32*mg**2*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0D(2,2)*susy*Cqed*s2t*Pi*alphas**3 * ( 32*mg*
     &    mt*s**(-2)*u1**(-1) + 64*mg*mt*ms1**2*s**(-2)*t1**(-1)*
     &    u1**(-1) + 96*mg*mt*ms1**2*s**(-2)*u1**(-2) + 64*mg*mt*ms1**4
     &    *s**(-2)*t1**(-1)*u1**(-2) + 64*mg*mt*ms1**4*s**(-2)*u1**(-3)
     &     )
      STGGV = STGGV + SK3B0D(2,2)*susy*Nc*Ck*Pi*alphas**3 * ( 8*s**(-3)
     &    *t1 - 16*s**(-2) - 16*ms1**2*s**(-3) - 16*ms1**2*s**(-2)*
     &    t1**(-1) - 72*ms1**2*s**(-2)*u1**(-1) - 16*ms1**4*s**(-3)*
     &    u1**(-1) - 64*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 144*ms1**4*
     &    s**(-2)*u1**(-2) - 64*ms1**6*s**(-2)*t1**(-1)*u1**(-2) - 96*
     &    ms1**6*s**(-2)*u1**(-3) + 16*mt**2*s**(-3) + 48*mt**2*s**(-2)
     &    *u1**(-1) + 16*mt**2*ms1**2*s**(-3)*u1**(-1) + 64*mt**2*
     &    ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 144*mt**2*ms1**2*s**(-2)*
     &    u1**(-2) + 64*mt**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2) + 96*
     &    mt**2*ms1**4*s**(-2)*u1**(-3) + 16*mg**2*s**(-3) + 48*mg**2*
     &    s**(-2)*u1**(-1) + 16*mg**2*ms1**2*s**(-3)*u1**(-1) + 64*
     &    mg**2*ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 144*mg**2*ms1**2*
     &    s**(-2)*u1**(-2) + 64*mg**2*ms1**4*s**(-2)*t1**(-1)*u1**(-2)
     &     + 96*mg**2*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3B0D(2,2)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*s**(-3) - 96*mg*mt*s**(-2)*u1**(-1) - 32*mg*mt*ms1**2*
     &    s**(-3)*u1**(-1) - 128*mg*mt*ms1**2*s**(-2)*t1**(-1)*u1**(-1)
     &     - 288*mg*mt*ms1**2*s**(-2)*u1**(-2) - 128*mg*mt*ms1**4*
     &    s**(-2)*t1**(-1)*u1**(-2) - 192*mg*mt*ms1**4*s**(-2)*u1**(-3)
     &     )
      STGGV = STGGV + SK3B0D(2,2)*susy*Nc*Co*Pi*alphas**3 * ( 16*
     &    s**(-3)*u**(-1)*t1**2 + 8*s**(-3)*t1 - 8*s**(-2)*u**(-1)*t1
     &     - 24*s**(-2) - 8*s**(-1)*u**(-1) - 16*s**(-1)*u1**(-1) - 48*
     &    ms1**2*s**(-3)*u**(-1)*t1 - 16*ms1**2*s**(-3) + 64*ms1**2*
     &    s**(-2)*u**(-1) - 48*ms1**2*s**(-2)*u1**(-1) + 48*ms1**2*
     &    s**(-1)*u**(-1)*u1**(-1) - 32*ms1**2*s**(-1)*u1**(-2) + 48*
     &    ms1**4*s**(-3)*u**(-1) + 104*ms1**4*s**(-2)*u**(-1)*u1**(-1)
     &     + 16*ms1**4*s**(-2)*u1**(-2) + 48*ms1**4*s**(-1)*u**(-1)*
     &    u1**(-2) - 16*ms1**4*s**(-1)*u1**(-3) + 16*ms1**6*s**(-3)*
     &    u**(-1)*u1**(-1) + 32*ms1**6*s**(-2)*u**(-1)*u1**(-2) + 32*
     &    ms1**6*s**(-2)*u1**(-3) + 16*ms1**6*s**(-1)*u**(-1)*u1**(-3)
     &     + 16*mt**2*s**(-3)*u**(-1)*t1 - 24*mt**2*s**(-2)*u**(-1) + 
     &    24*mt**2*s**(-2)*u1**(-1) - 16*mt**2*s**(-1)*u**(-1)*u1**(-1)
     &     + 16*mt**2*s**(-1)*u1**(-2) - 32*mt**2*ms1**2*s**(-3)*
     &    u**(-1) - 72*mt**2*ms1**2*s**(-2)*u**(-1)*u1**(-1) - 16*mt**2
     &    *ms1**2*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3B0D(2,2)*susy*Nc*Co*Pi*alphas**3 * (  - 32*
     &    mt**2*ms1**2*s**(-1)*u**(-1)*u1**(-2) + 16*mt**2*ms1**2*
     &    s**(-1)*u1**(-3) - 16*mt**2*ms1**4*s**(-3)*u**(-1)*u1**(-1)
     &     - 32*mt**2*ms1**4*s**(-2)*u**(-1)*u1**(-2) - 32*mt**2*ms1**4
     &    *s**(-2)*u1**(-3) - 16*mt**2*ms1**4*s**(-1)*u**(-1)*u1**(-3)
     &     - 16*mg**2*s**(-3)*u**(-1)*t1 - 32*mg**2*s**(-3) + 24*mg**2*
     &    s**(-2)*u**(-1) - 56*mg**2*s**(-2)*u1**(-1) + 16*mg**2*
     &    s**(-1)*u**(-1)*u1**(-1) - 16*mg**2*s**(-1)*u1**(-2) + 32*
     &    mg**2*ms1**2*s**(-3)*u**(-1) - 32*mg**2*ms1**2*s**(-3)*
     &    u1**(-1) + 72*mg**2*ms1**2*s**(-2)*u**(-1)*u1**(-1) - 80*
     &    mg**2*ms1**2*s**(-2)*u1**(-2) + 32*mg**2*ms1**2*s**(-1)*
     &    u**(-1)*u1**(-2) - 16*mg**2*ms1**2*s**(-1)*u1**(-3) + 16*
     &    mg**2*ms1**4*s**(-3)*u**(-1)*u1**(-1) + 32*mg**2*ms1**4*
     &    s**(-2)*u**(-1)*u1**(-2) - 32*mg**2*ms1**4*s**(-2)*u1**(-3)
     &     + 16*mg**2*ms1**4*s**(-1)*u**(-1)*u1**(-3) )
      STGGV = STGGV + SK3B0D(2,2)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 32*mg
     &    *mt*s**(-3) + 32*mg*mt*s**(-2)*u1**(-1) + 32*mg*mt*ms1**2*
     &    s**(-3)*u1**(-1) + 96*mg*mt*ms1**2*s**(-2)*u1**(-2) + 64*mg*
     &    mt*ms1**4*s**(-2)*u1**(-3) )
      STGGV = STGGV + SK3BP(1)*Cqed*Pi*alphas**3 * ( 32*ms1**2*s**(-2)
     &     + 64*ms1**4*s**(-2)*t1**(-1) + 64*ms1**4*s**(-2)*u1**(-1) + 
     &    64*ms1**6*s**(-2)*t1**(-2) + 128*ms1**6*s**(-2)*t1**(-1)*
     &    u1**(-1) + 64*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(1)*Nc*Ck*Pi*alphas**3 * (  - 64*ms1**2*
     &    s**(-4)*t1**2 - 64*ms1**2*s**(-3)*t1 - 96*ms1**2*s**(-2) - 
     &    128*ms1**4*s**(-3) - 192*ms1**4*s**(-2)*t1**(-1) - 192*ms1**4
     &    *s**(-2)*u1**(-1) - 192*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-1) - 192*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(1)*Nc*Co*Pi*alphas**3 * ( 64*ms1**2*s**(-4)
     &    *t1**2 + 64*ms1**2*s**(-3)*t1 + 32*ms1**2*s**(-2) + 128*
     &    ms1**4*s**(-3) + 64*ms1**4*s**(-2)*t1**(-1) + 64*ms1**4*
     &    s**(-2)*u1**(-1) + 64*ms1**6*s**(-2)*t1**(-2) + 64*ms1**6*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Cqed*Pi*alphas**3 * (  - 16*ms1**2*
     &    s**(-2) - 32*ms1**4*s**(-2)*t1**(-1) - 32*ms1**4*s**(-2)*
     &    u1**(-1) - 32*ms1**6*s**(-2)*t1**(-2) - 64*ms1**6*s**(-2)*
     &    t1**(-1)*u1**(-1) - 32*ms1**6*s**(-2)*u1**(-2) + 16*mt**2*
     &    s**(-2) + 32*mt**2*ms1**2*s**(-2)*t1**(-1) + 32*mt**2*ms1**2*
     &    s**(-2)*u1**(-1) + 32*mt**2*ms1**4*s**(-2)*t1**(-2) + 64*
     &    mt**2*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 32*mt**2*ms1**4*
     &    s**(-2)*u1**(-2) + 16*mg**2*s**(-2) + 32*mg**2*ms1**2*s**(-2)
     &    *t1**(-1) + 32*mg**2*ms1**2*s**(-2)*u1**(-1) + 32*mg**2*
     &    ms1**4*s**(-2)*t1**(-2) + 64*mg**2*ms1**4*s**(-2)*t1**(-1)*
     &    u1**(-1) + 32*mg**2*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Cqed*s2t*Pi*alphas**3 * (  - 32*mg*
     &    mt*s**(-2) - 64*mg*mt*ms1**2*s**(-2)*t1**(-1) - 64*mg*mt*
     &    ms1**2*s**(-2)*u1**(-1) - 64*mg*mt*ms1**4*s**(-2)*t1**(-2) - 
     &    128*mg*mt*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 64*mg*mt*ms1**4*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Nc*Ck*Pi*alphas**3 * ( 32*ms1**2*
     &    s**(-4)*t1**2 + 32*ms1**2*s**(-3)*t1 + 48*ms1**2*s**(-2) + 64
     &    *ms1**4*s**(-3) + 96*ms1**4*s**(-2)*t1**(-1) + 96*ms1**4*
     &    s**(-2)*u1**(-1) + 96*ms1**6*s**(-2)*t1**(-2) + 128*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-1) + 96*ms1**6*s**(-2)*u1**(-2) - 32*
     &    mt**2*s**(-4)*t1**2 - 32*mt**2*s**(-3)*t1 - 48*mt**2*s**(-2)
     &     - 64*mt**2*ms1**2*s**(-3) - 96*mt**2*ms1**2*s**(-2)*t1**(-1)
     &     - 96*mt**2*ms1**2*s**(-2)*u1**(-1) - 96*mt**2*ms1**4*s**(-2)
     &    *t1**(-2) - 128*mt**2*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 96*
     &    mt**2*ms1**4*s**(-2)*u1**(-2) - 32*mg**2*s**(-4)*t1**2 - 32*
     &    mg**2*s**(-3)*t1 - 48*mg**2*s**(-2) - 64*mg**2*ms1**2*s**(-3)
     &     - 96*mg**2*ms1**2*s**(-2)*t1**(-1) - 96*mg**2*ms1**2*s**(-2)
     &    *u1**(-1) - 96*mg**2*ms1**4*s**(-2)*t1**(-2) - 128*mg**2*
     &    ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 96*mg**2*ms1**4*s**(-2)*
     &    u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 64*mg*mt
     &    *s**(-4)*t1**2 + 64*mg*mt*s**(-3)*t1 + 96*mg*mt*s**(-2) + 128
     &    *mg*mt*ms1**2*s**(-3) + 192*mg*mt*ms1**2*s**(-2)*t1**(-1) + 
     &    192*mg*mt*ms1**2*s**(-2)*u1**(-1) + 192*mg*mt*ms1**4*s**(-2)*
     &    t1**(-2) + 256*mg*mt*ms1**4*s**(-2)*t1**(-1)*u1**(-1) + 192*
     &    mg*mt*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Nc*Co*Pi*alphas**3 * (  - 32*ms1**2
     &    *s**(-4)*t1**2 - 32*ms1**2*s**(-3)*t1 - 16*ms1**2*s**(-2) - 
     &    64*ms1**4*s**(-3) - 32*ms1**4*s**(-2)*t1**(-1) - 32*ms1**4*
     &    s**(-2)*u1**(-1) - 32*ms1**6*s**(-2)*t1**(-2) - 32*ms1**6*
     &    s**(-2)*u1**(-2) + 32*mt**2*s**(-4)*t1**2 + 32*mt**2*s**(-3)*
     &    t1 + 16*mt**2*s**(-2) + 64*mt**2*ms1**2*s**(-3) + 32*mt**2*
     &    ms1**2*s**(-2)*t1**(-1) + 32*mt**2*ms1**2*s**(-2)*u1**(-1) + 
     &    32*mt**2*ms1**4*s**(-2)*t1**(-2) + 32*mt**2*ms1**4*s**(-2)*
     &    u1**(-2) + 32*mg**2*s**(-4)*t1**2 + 32*mg**2*s**(-3)*t1 + 16*
     &    mg**2*s**(-2) + 64*mg**2*ms1**2*s**(-3) + 32*mg**2*ms1**2*
     &    s**(-2)*t1**(-1) + 32*mg**2*ms1**2*s**(-2)*u1**(-1) + 32*
     &    mg**2*ms1**4*s**(-2)*t1**(-2) + 32*mg**2*ms1**4*s**(-2)*
     &    u1**(-2) )
      STGGV = STGGV + SK3BP(2)*susy*Nc*Co*s2t*Pi*alphas**3 * (  - 64*mg
     &    *mt*s**(-4)*t1**2 - 64*mg*mt*s**(-3)*t1 - 32*mg*mt*s**(-2) - 
     &    128*mg*mt*ms1**2*s**(-3) - 64*mg*mt*ms1**2*s**(-2)*t1**(-1)
     &     - 64*mg*mt*ms1**2*s**(-2)*u1**(-1) - 64*mg*mt*ms1**4*s**(-2)
     &    *t1**(-2) - 64*mg*mt*ms1**4*s**(-2)*u1**(-2) )
      STGGV = STGGV + SK3C0A(1)*Nc*Co*Pi*alphas**3 * (  - 32*ms1**2*
     &    s**(-2) - 16*ms1**2*s**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Cqed*Pi*alphas**3 * (  - 8*t1**(-1) - 8
     &    *u1**(-1) + 48*ms1**2*s**(-1)*t1**(-1) + 48*ms1**2*s**(-1)*
     &    u1**(-1) - 96*ms1**4*s**(-2)*t1**(-1) - 96*ms1**4*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Cqed*s2t**2*Pi*alphas**3 * ( 16*ms1**4*
     &    s**(-2)*t1**(-1) + 16*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Ck*Pi*alphas**3 * ( 32*ms1**4*s**(-2)*
     &    t1**(-1) + 32*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Ck*s2t**2*Pi*alphas**3 * (  - 32*ms1**4
     &    *s**(-2)*t1**(-1) - 32*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Co*Pi*alphas**3 * (  - 32*ms1**4*
     &    s**(-3) - 16*ms1**4*s**(-2)*t1**(-1) - 16*ms1**4*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Co*s2t**2*Pi*alphas**3 * ( 8*ms1**4*
     &    s**(-2)*t1**(-1) + 8*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Nc*Ck*Pi*alphas**3 * (  - 16*s**(-1) + 
     &    32*ms1**2*s**(-2) - 16*ms1**2*s**(-1)*t1**(-1) - 16*ms1**2*
     &    s**(-1)*u1**(-1) + 48*ms1**4*s**(-2)*t1**(-1) + 48*ms1**4*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(2)*Nc*Ck*s2t**2*Pi*alphas**3 * (  - 8*
     &    ms1**4*s**(-2)*t1**(-1) - 8*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(3)*susy*Nc*Co*Pi*alphas**3 * (  - 4*
     &    s**(-1) + 16*ms1**2*s**(-2) + 8*ms1**4*s**(-2)*t1**(-1) + 8*
     &    ms1**4*s**(-2)*u1**(-1) - 16*mt**2*s**(-2) + 4*mt**2*s**(-1)*
     &    t1**(-1) + 4*mt**2*s**(-1)*u1**(-1) - 16*mt**2*ms1**2*s**(-2)
     &    *t1**(-1) - 16*mt**2*ms1**2*s**(-2)*u1**(-1) + 8*mt**4*
     &    s**(-2)*t1**(-1) + 8*mt**4*s**(-2)*u1**(-1) - 16*mg**2*
     &    s**(-2) - 4*mg**2*s**(-1)*t1**(-1) - 4*mg**2*s**(-1)*u1**(-1)
     &     + 64*mg**2*ms1**2*s**(-3) + 32*mg**2*ms1**2*s**(-2)*t1**(-1)
     &     + 32*mg**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**4*s**(-2)*
     &    t1**(-1) - 8*mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(3)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 32*mg*
     &    mt*s**(-2) + 16*mg*mt*ms1**2*s**(-2)*t1**(-1) + 16*mg*mt*
     &    ms1**2*s**(-2)*u1**(-1) - 16*mg*mt**3*s**(-2)*t1**(-1) - 16*
     &    mg*mt**3*s**(-2)*u1**(-1) + 16*mg**3*mt*s**(-2)*t1**(-1) + 16
     &    *mg**3*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(4)*Co*Pi*alphas**3 * ( 64*mt**2*ms1**2*
     &    s**(-3) + 16*mt**2*ms1**2*s**(-2)*t1**(-1) + 16*mt**2*ms1**2*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(4)*susy*Cqed*Pi*alphas**3 * ( 8*s**(-1) + 
     &    4*t1**(-1) + 4*u1**(-1) - 8*ms1**2*s**(-1)*t1**(-1) - 8*
     &    ms1**2*s**(-1)*u1**(-1) + 16*ms1**4*s**(-2)*t1**(-1) + 16*
     &    ms1**4*s**(-2)*u1**(-1) + 32*mt**2*ms1**2*s**(-2)*t1**(-1) + 
     &    32*mt**2*ms1**2*s**(-2)*u1**(-1) - 16*mt**4*s**(-2)*t1**(-1)
     &     - 16*mt**4*s**(-2)*u1**(-1) + 16*mg**2*s**(-1)*t1**(-1) + 16
     &    *mg**2*s**(-1)*u1**(-1) - 32*mg**2*ms1**2*s**(-2)*t1**(-1) - 
     &    32*mg**2*ms1**2*s**(-2)*u1**(-1) + 16*mg**4*s**(-2)*t1**(-1)
     &     + 16*mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(4)*susy*Cqed*s2t*Pi*alphas**3 * (  - 16*mg
     &    *mt*s**(-1)*t1**(-1) - 16*mg*mt*s**(-1)*u1**(-1) + 32*mg*mt*
     &    ms1**2*s**(-2)*t1**(-1) + 32*mg*mt*ms1**2*s**(-2)*u1**(-1) + 
     &    32*mg*mt**3*s**(-2)*t1**(-1) + 32*mg*mt**3*s**(-2)*u1**(-1)
     &     - 32*mg**3*mt*s**(-2)*t1**(-1) - 32*mg**3*mt*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(4)*susy*Nc*Ck*Pi*alphas**3 * ( 4*s**(-1)
     &     - 16*ms1**2*s**(-2) - 8*ms1**4*s**(-2)*t1**(-1) - 8*ms1**4*
     &    s**(-2)*u1**(-1) + 16*mt**2*s**(-2) + 4*mt**2*s**(-1)*
     &    t1**(-1) + 4*mt**2*s**(-1)*u1**(-1) - 16*mt**2*ms1**2*s**(-2)
     &    *t1**(-1) - 16*mt**2*ms1**2*s**(-2)*u1**(-1) + 8*mt**4*
     &    s**(-2)*t1**(-1) + 8*mt**4*s**(-2)*u1**(-1) + 16*mg**2*
     &    s**(-2) - 4*mg**2*s**(-1)*t1**(-1) - 4*mg**2*s**(-1)*u1**(-1)
     &     + 16*mg**2*ms1**2*s**(-2)*t1**(-1) + 16*mg**2*ms1**2*s**(-2)
     &    *u1**(-1) - 8*mg**4*s**(-2)*t1**(-1) - 8*mg**4*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(4)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32*
     &    mg*mt*s**(-2) - 16*mg*mt*ms1**2*s**(-2)*t1**(-1) - 16*mg*mt*
     &    ms1**2*s**(-2)*u1**(-1) - 16*mg*mt**3*s**(-2)*t1**(-1) - 16*
     &    mg*mt**3*s**(-2)*u1**(-1) + 16*mg**3*mt*s**(-2)*t1**(-1) + 16
     &    *mg**3*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(7)*susy*Co*(Ns-2)*Pi*alphas**3 * (  - 64*
     &    ms**2*ms1**2*s**(-3) - 16*ms**2*ms1**2*s**(-2)*t1**(-1) - 16*
     &    ms**2*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(8)*susy*Cqed*s2t**2*Pi*alphas**3 * (  - 16
     &    *ms2**2*ms1**2*s**(-2)*t1**(-1) - 16*ms2**2*ms1**2*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(8)*susy*Ck*Pi*alphas**3 * (  - 32*ms2**2*
     &    ms1**2*s**(-2)*t1**(-1) - 32*ms2**2*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(8)*susy*Ck*s2t**2*Pi*alphas**3 * ( 32*
     &    ms2**2*ms1**2*s**(-2)*t1**(-1) + 32*ms2**2*ms1**2*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(8)*susy*Co*Pi*alphas**3 * (  - 32*ms2**2*
     &    ms1**2*s**(-3) )
      STGGV = STGGV + SK3C0A(8)*susy*Co*s2t**2*Pi*alphas**3 * (  - 8*
     &    ms2**2*ms1**2*s**(-2)*t1**(-1) - 8*ms2**2*ms1**2*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(8)*susy*Nc*Ck*s2t**2*Pi*alphas**3 * ( 8*
     &    ms2**2*ms1**2*s**(-2)*t1**(-1) + 8*ms2**2*ms1**2*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0A(9)*susy*Ck*c2t*Pi*alphas**3 * ( 32*ms1**2*
     &    mx1**2*s**(-2)*t1**(-1)*c2b + 32*ms1**2*mx1**2*s**(-2)*
     &    u1**(-1)*c2b )
      STGGV = STGGV + SK3C0A(9)*susy*Co*Pi*alphas**3 * (  - 32*ms1**2*
     &    mx1**2*s**(-3) - 8*ms1**2*mx1**2*s**(-2)*t1**(-1) - 8*ms1**2*
     &    mx1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(9)*susy*Co*c2t*Pi*alphas**3 * (  - 8*
     &    ms1**2*mx1**2*s**(-2)*t1**(-1)*c2b - 8*ms1**2*mx1**2*s**(-2)*
     &    u1**(-1)*c2b )
      STGGV = STGGV + SK3C0A(10)*susy*Ck*c2t*Pi*alphas**3 * (  - 32*
     &    mx2**2*ms1**2*s**(-2)*t1**(-1)*c2b - 32*mx2**2*ms1**2*s**(-2)
     &    *u1**(-1)*c2b )
      STGGV = STGGV + SK3C0A(10)*susy*Co*Pi*alphas**3 * (  - 32*mx2**2*
     &    ms1**2*s**(-3) - 8*mx2**2*ms1**2*s**(-2)*t1**(-1) - 8*mx2**2*
     &    ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0A(10)*susy*Co*c2t*Pi*alphas**3 * ( 8*mx2**2*
     &    ms1**2*s**(-2)*t1**(-1)*c2b + 8*mx2**2*ms1**2*s**(-2)*
     &    u1**(-1)*c2b )
      STGGV = STGGV + SK3C0B(1)*Cqed*Pi*alphas**3 * (  - 16*s**(-1) - 8
     &    *t1**(-1) - 8*u1**(-1) + 32*ms1**2*s**(-2) + 32*ms1**2*
     &    s**(-1)*t1**(-1) + 32*ms1**2*s**(-1)*u1**(-1) - 32*ms1**4*
     &    s**(-2)*t1**(-1) - 32*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(1)*Nc*Ck*Pi*alphas**3 * ( 32*s**(-3)*t1**2
     &     + 32*s**(-2)*t1 - 64*ms1**2*s**(-4)*t1**2 - 64*ms1**2*
     &    s**(-3)*t1 + 96*ms1**2*s**(-2) + 16*ms1**2*s**(-1)*t1**(-1)
     &     + 16*ms1**2*s**(-1)*u1**(-1) - 192*ms1**4*s**(-3) - 32*
     &    ms1**4*s**(-2)*t1**(-1) - 32*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(2)*Nc*Co*Pi*alphas**3 * (  - 16*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 - 16*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 + (s-4*ms12)**(-1)*t1**(-1)*u1 - 6*(s-4*ms12)**(-1) + 
     &    (s-4*ms12)**(-1)*t1*u1**(-1) + 48*s**(-3)*t1**2 + 48*s**(-2)*
     &    t1 + 24*s**(-1) + t1**(-1) + u1**(-1) + 32*ms1**2*s**(-2) + 
     &    20*ms1**2*s**(-1)*t1**(-1) + 20*ms1**2*s**(-1)*u1**(-1) - 16*
     &    ms1**4*s**(-2)*t1**(-1) - 16*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(3)*susy*Nc*Co*Pi*alphas**3 * ( 4*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 + 4*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 - 1./4.*(s-4*ms12)**(-1)*t1**(-1)*u1 + 3./2.*
     &    (s-4*ms12)**(-1) - 1./4.*(s-4*ms12)**(-1)*t1*u1**(-1) + 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*
     &    mt**2*s**(-2)*t1 + 16*(s-4*ms12)**(-1)*mt**2*s**(-1) + 2*
     &    (s-4*ms12)**(-1)*mt**2*t1**(-1) + 2*(s-4*ms12)**(-1)*mt**2*
     &    u1**(-1) + 64*(s-4*ms12)**(-1)*mt**4*s**(-4)*t1**2 + 64*
     &    (s-4*ms12)**(-1)*mt**4*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mt**4
     &    *s**(-2) + 4*(s-4*ms12)**(-1)*mt**4*s**(-1)*t1**(-1) + 4*
     &    (s-4*ms12)**(-1)*mt**4*s**(-1)*u1**(-1) - 64*(s-4*ms12)**(-1)
     &    *mg**4*s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*mg**4*s**(-3)*t1
     &     - 32*(s-4*ms12)**(-1)*mg**4*s**(-2) - 4*(s-4*ms12)**(-1)*
     &    mg**4*s**(-1)*t1**(-1) - 4*(s-4*ms12)**(-1)*mg**4*s**(-1)*
     &    u1**(-1) - 4*s**(-3)*t1**2 - 4*s**(-2)*t1 - 6*s**(-1) - 1./4.
     &    *t1**(-1) )
      STGGV = STGGV + SK3C0B(3)*susy*Nc*Co*Pi*alphas**3 * (  - 1./4.*
     &    u1**(-1) - 16*ms1**2*s**(-4)*t1**2 - 16*ms1**2*s**(-3)*t1 + 
     &    16*ms1**2*s**(-2) - ms1**2*s**(-1)*t1**(-1) - ms1**2*s**(-1)*
     &    u1**(-1) - 48*ms1**4*s**(-3) - 4*ms1**4*s**(-2)*t1**(-1) - 4*
     &    ms1**4*s**(-2)*u1**(-1) + 32*mt**2*s**(-4)*t1**2 + 32*mt**2*
     &    s**(-3)*t1 - 24*mt**2*s**(-2) - 6*mt**2*s**(-1)*t1**(-1) - 6*
     &    mt**2*s**(-1)*u1**(-1) + 96*mt**2*ms1**2*s**(-3) + 16*mt**2*
     &    ms1**2*s**(-2)*t1**(-1) + 16*mt**2*ms1**2*s**(-2)*u1**(-1) - 
     &    48*mt**4*s**(-3) - 12*mt**4*s**(-2)*t1**(-1) - 12*mt**4*
     &    s**(-2)*u1**(-1) + 8*mg**2*s**(-2) + 4*mg**2*s**(-1)*t1**(-1)
     &     + 4*mg**2*s**(-1)*u1**(-1) - 8*mg**2*ms1**2*s**(-2)*t1**(-1)
     &     - 8*mg**2*ms1**2*s**(-2)*u1**(-1) + 48*mg**4*s**(-3) + 12*
     &    mg**4*s**(-2)*t1**(-1) + 12*mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(3)*susy*Nc*Co*s2t*Pi*alphas**3 * (  - 32*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*mg
     &    *mt*s**(-2)*t1 - 16*(s-4*ms12)**(-1)*mg*mt*s**(-1) - 2*
     &    (s-4*ms12)**(-1)*mg*mt*t1**(-1) - 2*(s-4*ms12)**(-1)*mg*mt*
     &    u1**(-1) - 128*(s-4*ms12)**(-1)*mg*mt**3*s**(-4)*t1**2 - 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg
     &    *mt**3*s**(-2) - 8*(s-4*ms12)**(-1)*mg*mt**3*s**(-1)*t1**(-1)
     &     - 8*(s-4*ms12)**(-1)*mg*mt**3*s**(-1)*u1**(-1) + 128*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-4)*t1**2 + 128*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-3)*t1 + 64*(s-4*ms12)**(-1)*
     &    mg**3*mt*s**(-2) + 8*(s-4*ms12)**(-1)*mg**3*mt*s**(-1)*
     &    t1**(-1) + 8*(s-4*ms12)**(-1)*mg**3*mt*s**(-1)*u1**(-1) - 32*
     &    mg*mt*s**(-4)*t1**2 - 32*mg*mt*s**(-3)*t1 + 16*mg*mt*s**(-2)
     &     + 2*mg*mt*s**(-1)*t1**(-1) + 2*mg*mt*s**(-1)*u1**(-1) - 96*
     &    mg*mt*ms1**2*s**(-3) - 8*mg*mt*ms1**2*s**(-2)*t1**(-1) - 8*mg
     &    *mt*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(3)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 96*mg*
     &    mt**3*s**(-3) + 24*mg*mt**3*s**(-2)*t1**(-1) + 24*mg*mt**3*
     &    s**(-2)*u1**(-1) - 96*mg**3*mt*s**(-3) - 24*mg**3*mt*s**(-2)*
     &    t1**(-1) - 24*mg**3*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Cqed*Pi*alphas**3 * ( 8*s**(-1) + 
     &    4*t1**(-1) + 4*u1**(-1) - 16*ms1**2*s**(-2) - 16*ms1**2*
     &    s**(-1)*t1**(-1) - 16*ms1**2*s**(-1)*u1**(-1) + 16*ms1**4*
     &    s**(-2)*t1**(-1) + 16*ms1**4*s**(-2)*u1**(-1) + 16*mt**2*
     &    s**(-2) + 8*mt**2*s**(-1)*t1**(-1) + 8*mt**2*s**(-1)*u1**(-1)
     &     - 16*mt**2*ms1**2*s**(-2)*t1**(-1) - 16*mt**2*ms1**2*s**(-2)
     &    *u1**(-1) + 16*mg**2*s**(-2) + 8*mg**2*s**(-1)*t1**(-1) + 8*
     &    mg**2*s**(-1)*u1**(-1) - 16*mg**2*ms1**2*s**(-2)*t1**(-1) - 
     &    16*mg**2*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Cqed*s2t*Pi*alphas**3 * (  - 32*mg
     &    *mt*s**(-2) - 16*mg*mt*s**(-1)*t1**(-1) - 16*mg*mt*s**(-1)*
     &    u1**(-1) + 32*mg*mt*ms1**2*s**(-2)*t1**(-1) + 32*mg*mt*ms1**2
     &    *s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Nc*Ck*Pi*alphas**3 * (  - 4*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 - 4*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 + 1./4.*(s-4*ms12)**(-1)*t1**(-1)*u1 - 3./2.*
     &    (s-4*ms12)**(-1) + 1./4.*(s-4*ms12)**(-1)*t1*u1**(-1) + 64*
     &    (s-4*ms12)**(-1)*mt**4*s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*
     &    mt**4*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mt**4*s**(-2) + 4*
     &    (s-4*ms12)**(-1)*mt**4*s**(-1)*t1**(-1) + 4*(s-4*ms12)**(-1)*
     &    mt**4*s**(-1)*u1**(-1) - 32*(s-4*ms12)**(-1)*mg**2*s**(-3)*
     &    t1**2 - 32*(s-4*ms12)**(-1)*mg**2*s**(-2)*t1 - 16*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1) - 2*(s-4*ms12)**(-1)*mg**2*
     &    t1**(-1) - 2*(s-4*ms12)**(-1)*mg**2*u1**(-1) - 64*
     &    (s-4*ms12)**(-1)*mg**4*s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*
     &    mg**4*s**(-3)*t1 - 32*(s-4*ms12)**(-1)*mg**4*s**(-2) - 4*
     &    (s-4*ms12)**(-1)*mg**4*s**(-1)*t1**(-1) - 4*(s-4*ms12)**(-1)*
     &    mg**4*s**(-1)*u1**(-1) + 4*s**(-3)*t1**2 + 4*s**(-2)*t1 + 6*
     &    s**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Nc*Ck*Pi*alphas**3 * ( 1./4.*
     &    t1**(-1) + 1./4.*u1**(-1) + 16*ms1**2*s**(-4)*t1**2 + 16*
     &    ms1**2*s**(-3)*t1 - 16*ms1**2*s**(-2) + ms1**2*s**(-1)*
     &    t1**(-1) + ms1**2*s**(-1)*u1**(-1) + 48*ms1**4*s**(-3) + 4*
     &    ms1**4*s**(-2)*t1**(-1) + 4*ms1**4*s**(-2)*u1**(-1) - 8*mt**2
     &    *s**(-2) - 4*mt**2*s**(-1)*t1**(-1) - 4*mt**2*s**(-1)*
     &    u1**(-1) + 8*mt**2*ms1**2*s**(-2)*t1**(-1) + 8*mt**2*ms1**2*
     &    s**(-2)*u1**(-1) - 48*mt**4*s**(-3) - 12*mt**4*s**(-2)*
     &    t1**(-1) - 12*mt**4*s**(-2)*u1**(-1) - 32*mg**2*s**(-4)*t1**2
     &     - 32*mg**2*s**(-3)*t1 + 24*mg**2*s**(-2) + 6*mg**2*s**(-1)*
     &    t1**(-1) + 6*mg**2*s**(-1)*u1**(-1) - 96*mg**2*ms1**2*s**(-3)
     &     - 16*mg**2*ms1**2*s**(-2)*t1**(-1) - 16*mg**2*ms1**2*s**(-2)
     &    *u1**(-1) + 48*mg**4*s**(-3) + 12*mg**4*s**(-2)*t1**(-1) + 12
     &    *mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*mg
     &    *mt*s**(-2)*t1 + 16*(s-4*ms12)**(-1)*mg*mt*s**(-1) + 2*
     &    (s-4*ms12)**(-1)*mg*mt*t1**(-1) + 2*(s-4*ms12)**(-1)*mg*mt*
     &    u1**(-1) - 128*(s-4*ms12)**(-1)*mg*mt**3*s**(-4)*t1**2 - 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg
     &    *mt**3*s**(-2) - 8*(s-4*ms12)**(-1)*mg*mt**3*s**(-1)*t1**(-1)
     &     - 8*(s-4*ms12)**(-1)*mg*mt**3*s**(-1)*u1**(-1) + 128*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-4)*t1**2 + 128*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-3)*t1 + 64*(s-4*ms12)**(-1)*
     &    mg**3*mt*s**(-2) + 8*(s-4*ms12)**(-1)*mg**3*mt*s**(-1)*
     &    t1**(-1) + 8*(s-4*ms12)**(-1)*mg**3*mt*s**(-1)*u1**(-1) + 32*
     &    mg*mt*s**(-4)*t1**2 + 32*mg*mt*s**(-3)*t1 - 16*mg*mt*s**(-2)
     &     - 2*mg*mt*s**(-1)*t1**(-1) - 2*mg*mt*s**(-1)*u1**(-1) + 96*
     &    mg*mt*ms1**2*s**(-3) + 8*mg*mt*ms1**2*s**(-2)*t1**(-1) + 8*mg
     &    *mt*ms1**2*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0B(4)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 96*mg*
     &    mt**3*s**(-3) + 24*mg*mt**3*s**(-2)*t1**(-1) + 24*mg*mt**3*
     &    s**(-2)*u1**(-1) - 96*mg**3*mt*s**(-3) - 24*mg**3*mt*s**(-2)*
     &    t1**(-1) - 24*mg**3*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(1,1)*Nc*Ck*Pi*alphas**3 * ( 16*s**(-2)*t1
     &     - 32*ms1**2*s**(-1)*u1**(-1) + 64*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(1,1)*Nc*Co*Pi*alphas**3 * (  - 32*s**(-3)*
     &    t1**2 - 16*s**(-2)*t1 - 32*ms1**2*s**(-3)*t1 - 32*ms1**2*
     &    s**(-2) )
      STGGV = STGGV + SK3C0C(1,2)*Nc*Ck*Pi*alphas**3 * (  - 16*s**(-2)*
     &    t1 - 16*s**(-1) - 32*ms1**2*s**(-1)*t1**(-1) + 64*ms1**4*
     &    s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(1,2)*Nc*Co*Pi*alphas**3 * (  - 32*s**(-3)*
     &    t1**2 - 48*s**(-2)*t1 - 16*s**(-1) + 32*ms1**2*s**(-3)*t1 )
      STGGV = STGGV + SK3C0C(3,1)*Cqed*Pi*alphas**3 * ( 16*s**(-1) + 16
     &    *u1**(-1) - 32*ms1**2*s**(-2) - 64*ms1**2*s**(-1)*u1**(-1) + 
     &    64*ms1**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(3,1)*Nc*Ck*Pi*alphas**3 * (  - 32*s**(-2)*
     &    t1 + 32*ms1**2*s**(-3)*t1 - 32*ms1**2*s**(-2) + 32*ms1**2*
     &    s**(-1)*u1**(-1) + 64*ms1**4*s**(-3) )
      STGGV = STGGV + SK3C0C(3,2)*Cqed*Pi*alphas**3 * ( 16*s**(-1) + 16
     &    *t1**(-1) - 32*ms1**2*s**(-2) - 64*ms1**2*s**(-1)*t1**(-1) + 
     &    64*ms1**4*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(3,2)*Nc*Ck*Pi*alphas**3 * ( 32*s**(-2)*t1
     &     + 32*s**(-1) - 32*ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) + 32
     &    *ms1**2*s**(-1)*t1**(-1) + 64*ms1**4*s**(-3) )
      STGGV = STGGV + SK3C0C(4,1)*susy*Nc*Ck*Pi*alphas**3 * (  - 16*
     &    ms1**4*s**(-2)*u1**(-1) + 8*mt**2*s**(-1)*u1**(-1) + 16*mt**4
     &    *s**(-2)*u1**(-1) - 8*mg**2*s**(-1)*u1**(-1) + 32*mg**2*
     &    ms1**2*s**(-2)*u1**(-1) - 16*mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(4,1)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*ms1**2*s**(-2)*u1**(-1) - 32*mg*mt**3*s**(-2)*u1**(-1)
     &     + 32*mg**3*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(4,1)*susy*Nc*Co*Pi*alphas**3 * ( 8*s**(-3)
     &    *t1**2 + 16*ms1**2*s**(-3)*t1 + 16*ms1**4*s**(-3) - 16*mt**2*
     &    s**(-3)*t1 + 8*mt**2*s**(-2) - 32*mt**2*ms1**2*s**(-3) + 16*
     &    mt**4*s**(-3) - 16*mg**2*s**(-3)*t1 - 8*mg**2*s**(-2) - 16*
     &    mg**4*s**(-3) )
      STGGV = STGGV + SK3C0C(4,1)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 32*mg
     &    *mt*s**(-3)*t1 + 32*mg*mt*ms1**2*s**(-3) - 32*mg*mt**3*
     &    s**(-3) + 32*mg**3*mt*s**(-3) )
      STGGV = STGGV + SK3C0C(4,2)*susy*Nc*Ck*Pi*alphas**3 * (  - 16*
     &    ms1**4*s**(-2)*t1**(-1) + 8*mt**2*s**(-1)*t1**(-1) + 16*mt**4
     &    *s**(-2)*t1**(-1) - 8*mg**2*s**(-1)*t1**(-1) + 32*mg**2*
     &    ms1**2*s**(-2)*t1**(-1) - 16*mg**4*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(4,2)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*ms1**2*s**(-2)*t1**(-1) - 32*mg*mt**3*s**(-2)*t1**(-1)
     &     + 32*mg**3*mt*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(4,2)*susy*Nc*Co*Pi*alphas**3 * ( 8*s**(-3)
     &    *t1**2 + 16*s**(-2)*t1 + 8*s**(-1) - 16*ms1**2*s**(-3)*t1 - 
     &    16*ms1**2*s**(-2) + 16*ms1**4*s**(-3) + 16*mt**2*s**(-3)*t1
     &     + 24*mt**2*s**(-2) - 32*mt**2*ms1**2*s**(-3) + 16*mt**4*
     &    s**(-3) + 16*mg**2*s**(-3)*t1 + 8*mg**2*s**(-2) - 16*mg**4*
     &    s**(-3) )
      STGGV = STGGV + SK3C0C(4,2)*susy*Nc*Co*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*s**(-3)*t1 - 32*mg*mt*s**(-2) + 32*mg*mt*ms1**2*
     &    s**(-3) - 32*mg*mt**3*s**(-3) + 32*mg**3*mt*s**(-3) )
      STGGV = STGGV + SK3C0C(5,1)*susy*Cqed*Pi*alphas**3 * ( 8*s**(-2)*
     &    t1 - 8*s**(-1) - 8*u1**(-1) + 16*ms1**2*s**(-2) + 16*ms1**2*
     &    s**(-1)*u1**(-1) - 16*ms1**4*s**(-2)*u1**(-1) - 16*mt**2*
     &    s**(-2) - 8*mt**2*s**(-1)*u1**(-1) + 16*mt**4*s**(-2)*
     &    u1**(-1) - 16*mg**2*s**(-2) - 24*mg**2*s**(-1)*u1**(-1) + 32*
     &    mg**2*ms1**2*s**(-2)*u1**(-1) - 16*mg**4*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(5,1)*susy*Cqed*s2t*Pi*alphas**3 * ( 32*mg*
     &    mt*s**(-2) + 32*mg*mt*s**(-1)*u1**(-1) - 32*mg*mt*ms1**2*
     &    s**(-2)*u1**(-1) - 32*mg*mt**3*s**(-2)*u1**(-1) + 32*mg**3*mt
     &    *s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(5,1)*susy*Nc*Ck*Pi*alphas**3 * (  - 8*
     &    s**(-3)*t1**2 - 16*ms1**2*s**(-3)*t1 - 16*ms1**4*s**(-3) - 16
     &    *ms1**4*s**(-2)*u1**(-1) + 16*mt**2*s**(-3)*t1 + 8*mt**2*
     &    s**(-2) - 8*mt**2*s**(-1)*u1**(-1) + 32*mt**2*ms1**2*s**(-2)*
     &    u1**(-1) + 16*mt**4*s**(-3) - 16*mt**4*s**(-2)*u1**(-1) + 16*
     &    mg**2*s**(-3)*t1 - 8*mg**2*s**(-2) + 8*mg**2*s**(-1)*u1**(-1)
     &     + 32*mg**2*ms1**2*s**(-3) - 16*mg**4*s**(-3) + 16*mg**4*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3C0C(5,1)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 32
     &    *mg*mt*s**(-3)*t1 - 32*mg*mt*ms1**2*s**(-3) - 32*mg*mt*ms1**2
     &    *s**(-2)*u1**(-1) - 32*mg*mt**3*s**(-3) + 32*mg*mt**3*s**(-2)
     &    *u1**(-1) + 32*mg**3*mt*s**(-3) - 32*mg**3*mt*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3C0C(5,2)*susy*Cqed*Pi*alphas**3 * (  - 8*
     &    s**(-2)*t1 - 16*s**(-1) - 8*t1**(-1) + 16*ms1**2*s**(-2) + 16
     &    *ms1**2*s**(-1)*t1**(-1) - 16*ms1**4*s**(-2)*t1**(-1) - 16*
     &    mt**2*s**(-2) - 8*mt**2*s**(-1)*t1**(-1) + 16*mt**4*s**(-2)*
     &    t1**(-1) - 16*mg**2*s**(-2) - 24*mg**2*s**(-1)*t1**(-1) + 32*
     &    mg**2*ms1**2*s**(-2)*t1**(-1) - 16*mg**4*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(5,2)*susy*Cqed*s2t*Pi*alphas**3 * ( 32*mg*
     &    mt*s**(-2) + 32*mg*mt*s**(-1)*t1**(-1) - 32*mg*mt*ms1**2*
     &    s**(-2)*t1**(-1) - 32*mg*mt**3*s**(-2)*t1**(-1) + 32*mg**3*mt
     &    *s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3C0C(5,2)*susy*Nc*Ck*Pi*alphas**3 * (  - 8*
     &    s**(-3)*t1**2 - 16*s**(-2)*t1 - 8*s**(-1) + 16*ms1**2*s**(-3)
     &    *t1 + 16*ms1**2*s**(-2) - 16*ms1**4*s**(-3) - 16*ms1**4*
     &    s**(-2)*t1**(-1) - 16*mt**2*s**(-3)*t1 - 8*mt**2*s**(-2) - 8*
     &    mt**2*s**(-1)*t1**(-1) + 32*mt**2*ms1**2*s**(-2)*t1**(-1) + 
     &    16*mt**4*s**(-3) - 16*mt**4*s**(-2)*t1**(-1) - 16*mg**2*
     &    s**(-3)*t1 - 24*mg**2*s**(-2) + 8*mg**2*s**(-1)*t1**(-1) + 32
     &    *mg**2*ms1**2*s**(-3) - 16*mg**4*s**(-3) + 16*mg**4*s**(-2)*
     &    t1**(-1) )
      STGGV = STGGV + SK3C0C(5,2)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 32*mg
     &    *mt*s**(-3)*t1 + 32*mg*mt*s**(-2) - 32*mg*mt*ms1**2*s**(-3)
     &     - 32*mg*mt*ms1**2*s**(-2)*t1**(-1) - 32*mg*mt**3*s**(-3) + 
     &    32*mg*mt**3*s**(-2)*t1**(-1) + 32*mg**3*mt*s**(-3) - 32*mg**3
     &    *mt*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(1,1)*Nc*Co*Pi*alphas**3 * (  - 16*s**(-3)*
     &    t1**3 - 16*s**(-2)*t1**2 - 8*s**(-1)*t1 - 16*ms1**2*s**(-2)*
     &    t1 - 16*ms1**2*s**(-1) - 32*ms1**4*s**(-1)*t1**(-1) )
      STGGV = STGGV + SK3D0(1,2)*Nc*Co*Pi*alphas**3 * ( 8 + 16*s**(-3)*
     &    t1**3 + 32*s**(-2)*t1**2 + 24*s**(-1)*t1 + 16*ms1**2*s**(-2)*
     &    t1 - 32*ms1**4*s**(-1)*u1**(-1) )
      STGGV = STGGV + SK3D0(2,1)*Cqed*Pi*alphas**3 * ( 8*t1*u1**(-1) + 
     &    32*ms1**2*s**(-1) + 48*ms1**2*u1**(-1) - 32*ms1**4*s**(-2) - 
     &    32*ms1**4*s**(-1)*t1**(-1) - 96*ms1**4*s**(-1)*u1**(-1) + 64*
     &    ms1**6*s**(-2)*t1**(-1) + 64*ms1**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(2,1)*Nc*Ck*Pi*alphas**3 * ( 8*s**(-1)*t1 - 
     &    32*ms1**2*s**(-2)*t1 + 16*ms1**2*s**(-1) + 32*ms1**4*s**(-3)*
     &    t1 - 32*ms1**4*s**(-2) + 32*ms1**4*s**(-1)*t1**(-1) - 64*
     &    ms1**6*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(2,2)*Cqed*Pi*alphas**3 * ( 8*t1**(-1)*u1 + 
     &    32*ms1**2*s**(-1) + 48*ms1**2*t1**(-1) - 32*ms1**4*s**(-2) - 
     &    96*ms1**4*s**(-1)*t1**(-1) - 32*ms1**4*s**(-1)*u1**(-1) + 64*
     &    ms1**6*s**(-2)*t1**(-1) + 64*ms1**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(2,2)*Nc*Ck*Pi*alphas**3 * (  - 8 - 8*
     &    s**(-1)*t1 + 32*ms1**2*s**(-2)*t1 + 48*ms1**2*s**(-1) - 32*
     &    ms1**4*s**(-3)*t1 - 64*ms1**4*s**(-2) + 32*ms1**4*s**(-1)*
     &    u1**(-1) - 64*ms1**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(3,1)*Nc*Ck*Pi*alphas**3 * (  - 8*s**(-2)*
     &    t1**2 - 8*s**(-1)*t1 - 16*ms1**2*s**(-1) - 32*ms1**4*s**(-2)
     &     - 32*ms1**4*s**(-1)*t1**(-1) - 32*ms1**4*s**(-1)*u1**(-1) )
      STGGV = STGGV + SK3D0(3,2)*Nc*Ck*Pi*alphas**3 * (  - 8*s**(-2)*
     &    t1**2 - 8*s**(-1)*t1 - 16*ms1**2*s**(-1) - 32*ms1**4*s**(-2)
     &     - 32*ms1**4*s**(-1)*t1**(-1) - 32*ms1**4*s**(-1)*u1**(-1) )
      STGGV = STGGV + SK3D0(4,1)*susy*Cqed*Pi*alphas**3 * (  - 4*
     &    s**(-1)*t1 - 4*t1*u1**(-1) - 12*ms1**2*s**(-1) - 12*ms1**2*
     &    u1**(-1) + 16*ms1**4*s**(-1)*u1**(-1) - 8*ms1**6*s**(-2)*
     &    t1**(-1) - 8*ms1**6*s**(-2)*u1**(-1) - 4*mt**2*s**(-1) + 16*
     &    mt**2*ms1**2*s**(-2) - 4*mt**2*ms1**2*s**(-1)*t1**(-1) - 4*
     &    mt**2*ms1**2*s**(-1)*u1**(-1) - 8*mt**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mt**2*ms1**4*s**(-2)*u1**(-1) - 16*mt**4*s**(-2)
     &     + 4*mt**4*s**(-1)*t1**(-1) - 12*mt**4*s**(-1)*u1**(-1) + 8*
     &    mt**4*ms1**2*s**(-2)*t1**(-1) + 8*mt**4*ms1**2*s**(-2)*
     &    u1**(-1) + 8*mt**6*s**(-2)*t1**(-1) + 8*mt**6*s**(-2)*
     &    u1**(-1) + 12*mg**2*s**(-1) + 16*mg**2*u1**(-1) - 4*mg**2*
     &    ms1**2*s**(-1)*t1**(-1) - 36*mg**2*ms1**2*s**(-1)*u1**(-1) + 
     &    24*mg**2*ms1**4*s**(-2)*t1**(-1) + 24*mg**2*ms1**4*s**(-2)*
     &    u1**(-1) - 16*mg**2*mt**2*s**(-2) - 8*mg**2*mt**2*s**(-1)*
     &    t1**(-1) - 8*mg**2*mt**2*s**(-1)*u1**(-1) + 16*mg**2*mt**2*
     &    ms1**2*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(4,1)*susy*Cqed*Pi*alphas**3 * ( 16*mg**2*
     &    mt**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**2*mt**4*s**(-2)*
     &    t1**(-1) - 8*mg**2*mt**4*s**(-2)*u1**(-1) + 4*mg**4*s**(-1)*
     &    t1**(-1) + 20*mg**4*s**(-1)*u1**(-1) - 24*mg**4*ms1**2*
     &    s**(-2)*t1**(-1) - 24*mg**4*ms1**2*s**(-2)*u1**(-1) - 8*mg**4
     &    *mt**2*s**(-2)*t1**(-1) - 8*mg**4*mt**2*s**(-2)*u1**(-1) + 8*
     &    mg**6*s**(-2)*t1**(-1) + 8*mg**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(4,1)*susy*Cqed*s2t*Pi*alphas**3 * (  - 16*
     &    mg*mt*s**(-1) - 16*mg*mt*u1**(-1) + 8*mg*mt*ms1**2*s**(-1)*
     &    t1**(-1) + 40*mg*mt*ms1**2*s**(-1)*u1**(-1) - 16*mg*mt*ms1**4
     &    *s**(-2)*t1**(-1) - 16*mg*mt*ms1**4*s**(-2)*u1**(-1) + 32*mg*
     &    mt**3*s**(-2) + 32*mg*mt**3*s**(-1)*u1**(-1) - 32*mg*mt**3*
     &    ms1**2*s**(-2)*t1**(-1) - 32*mg*mt**3*ms1**2*s**(-2)*u1**(-1)
     &     - 16*mg*mt**5*s**(-2)*t1**(-1) - 16*mg*mt**5*s**(-2)*
     &    u1**(-1) - 32*mg**3*mt*s**(-1)*u1**(-1) + 32*mg**3*mt*ms1**2*
     &    s**(-2)*t1**(-1) + 32*mg**3*mt*ms1**2*s**(-2)*u1**(-1) + 32*
     &    mg**3*mt**3*s**(-2)*t1**(-1) + 32*mg**3*mt**3*s**(-2)*
     &    u1**(-1) - 16*mg**5*mt*s**(-2)*t1**(-1) - 16*mg**5*mt*s**(-2)
     &    *u1**(-1) )
      STGGV = STGGV + SK3D0(4,1)*susy*Nc*Ck*Pi*alphas**3 * ( 4*s**(-2)*
     &    t1**2 + 12*ms1**2*s**(-2)*t1 + 16*ms1**4*s**(-2) + 8*ms1**6*
     &    s**(-2)*t1**(-1) + 4*mt**2*s**(-2)*t1 + 4*mt**2*s**(-1) - 16*
     &    mt**2*ms1**2*s**(-3)*t1 - 16*mt**2*ms1**2*s**(-2) + 4*mt**2*
     &    ms1**2*s**(-1)*t1**(-1) + 8*mt**2*ms1**4*s**(-2)*t1**(-1) + 
     &    16*mt**4*s**(-3)*t1 - 4*mt**4*s**(-1)*t1**(-1) - 8*mt**4*
     &    ms1**2*s**(-2)*t1**(-1) - 8*mt**6*s**(-2)*t1**(-1) - 12*mg**2
     &    *s**(-2)*t1 + 4*mg**2*s**(-1) - 32*mg**2*ms1**2*s**(-2) + 4*
     &    mg**2*ms1**2*s**(-1)*t1**(-1) - 24*mg**2*ms1**4*s**(-2)*
     &    t1**(-1) + 16*mg**2*mt**2*s**(-3)*t1 + 16*mg**2*mt**2*s**(-2)
     &     + 8*mg**2*mt**2*s**(-1)*t1**(-1) - 16*mg**2*mt**2*ms1**2*
     &    s**(-2)*t1**(-1) + 8*mg**2*mt**4*s**(-2)*t1**(-1) + 16*mg**4*
     &    s**(-2) - 4*mg**4*s**(-1)*t1**(-1) + 24*mg**4*ms1**2*s**(-2)*
     &    t1**(-1) + 8*mg**4*mt**2*s**(-2)*t1**(-1) - 8*mg**6*s**(-2)*
     &    t1**(-1) )
      STGGV = STGGV + SK3D0(4,1)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 16*mg*
     &    mt*s**(-2)*t1 + 32*mg*mt*ms1**2*s**(-2) - 8*mg*mt*ms1**2*
     &    s**(-1)*t1**(-1) + 16*mg*mt*ms1**4*s**(-2)*t1**(-1) - 32*mg*
     &    mt**3*s**(-3)*t1 + 32*mg*mt**3*ms1**2*s**(-2)*t1**(-1) + 16*
     &    mg*mt**5*s**(-2)*t1**(-1) - 32*mg**3*mt*s**(-2) - 32*mg**3*mt
     &    *ms1**2*s**(-2)*t1**(-1) - 32*mg**3*mt**3*s**(-2)*t1**(-1) + 
     &    16*mg**5*mt*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(4,2)*susy*Cqed*Pi*alphas**3 * ( 4 + 4*
     &    s**(-1)*t1 - 4*t1**(-1)*u1 - 12*ms1**2*s**(-1) - 12*ms1**2*
     &    t1**(-1) + 16*ms1**4*s**(-1)*t1**(-1) - 8*ms1**6*s**(-2)*
     &    t1**(-1) - 8*ms1**6*s**(-2)*u1**(-1) - 4*mt**2*s**(-1) + 16*
     &    mt**2*ms1**2*s**(-2) - 4*mt**2*ms1**2*s**(-1)*t1**(-1) - 4*
     &    mt**2*ms1**2*s**(-1)*u1**(-1) - 8*mt**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mt**2*ms1**4*s**(-2)*u1**(-1) - 16*mt**4*s**(-2)
     &     - 12*mt**4*s**(-1)*t1**(-1) + 4*mt**4*s**(-1)*u1**(-1) + 8*
     &    mt**4*ms1**2*s**(-2)*t1**(-1) + 8*mt**4*ms1**2*s**(-2)*
     &    u1**(-1) + 8*mt**6*s**(-2)*t1**(-1) + 8*mt**6*s**(-2)*
     &    u1**(-1) + 12*mg**2*s**(-1) + 16*mg**2*t1**(-1) - 36*mg**2*
     &    ms1**2*s**(-1)*t1**(-1) - 4*mg**2*ms1**2*s**(-1)*u1**(-1) + 
     &    24*mg**2*ms1**4*s**(-2)*t1**(-1) + 24*mg**2*ms1**4*s**(-2)*
     &    u1**(-1) - 16*mg**2*mt**2*s**(-2) - 8*mg**2*mt**2*s**(-1)*
     &    t1**(-1) - 8*mg**2*mt**2*s**(-1)*u1**(-1) + 16*mg**2*mt**2*
     &    ms1**2*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(4,2)*susy*Cqed*Pi*alphas**3 * ( 16*mg**2*
     &    mt**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**2*mt**4*s**(-2)*
     &    t1**(-1) - 8*mg**2*mt**4*s**(-2)*u1**(-1) + 20*mg**4*s**(-1)*
     &    t1**(-1) + 4*mg**4*s**(-1)*u1**(-1) - 24*mg**4*ms1**2*s**(-2)
     &    *t1**(-1) - 24*mg**4*ms1**2*s**(-2)*u1**(-1) - 8*mg**4*mt**2*
     &    s**(-2)*t1**(-1) - 8*mg**4*mt**2*s**(-2)*u1**(-1) + 8*mg**6*
     &    s**(-2)*t1**(-1) + 8*mg**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(4,2)*susy*Cqed*s2t*Pi*alphas**3 * (  - 16*
     &    mg*mt*s**(-1) - 16*mg*mt*t1**(-1) + 40*mg*mt*ms1**2*s**(-1)*
     &    t1**(-1) + 8*mg*mt*ms1**2*s**(-1)*u1**(-1) - 16*mg*mt*ms1**4*
     &    s**(-2)*t1**(-1) - 16*mg*mt*ms1**4*s**(-2)*u1**(-1) + 32*mg*
     &    mt**3*s**(-2) + 32*mg*mt**3*s**(-1)*t1**(-1) - 32*mg*mt**3*
     &    ms1**2*s**(-2)*t1**(-1) - 32*mg*mt**3*ms1**2*s**(-2)*u1**(-1)
     &     - 16*mg*mt**5*s**(-2)*t1**(-1) - 16*mg*mt**5*s**(-2)*
     &    u1**(-1) - 32*mg**3*mt*s**(-1)*t1**(-1) + 32*mg**3*mt*ms1**2*
     &    s**(-2)*t1**(-1) + 32*mg**3*mt*ms1**2*s**(-2)*u1**(-1) + 32*
     &    mg**3*mt**3*s**(-2)*t1**(-1) + 32*mg**3*mt**3*s**(-2)*
     &    u1**(-1) - 16*mg**5*mt*s**(-2)*t1**(-1) - 16*mg**5*mt*s**(-2)
     &    *u1**(-1) )
      STGGV = STGGV + SK3D0(4,2)*susy*Nc*Ck*Pi*alphas**3 * ( 4 + 4*
     &    s**(-2)*t1**2 + 8*s**(-1)*t1 - 12*ms1**2*s**(-2)*t1 - 12*
     &    ms1**2*s**(-1) + 16*ms1**4*s**(-2) + 8*ms1**6*s**(-2)*
     &    u1**(-1) - 4*mt**2*s**(-2)*t1 + 16*mt**2*ms1**2*s**(-3)*t1 + 
     &    4*mt**2*ms1**2*s**(-1)*u1**(-1) + 8*mt**2*ms1**4*s**(-2)*
     &    u1**(-1) - 16*mt**4*s**(-3)*t1 - 16*mt**4*s**(-2) - 4*mt**4*
     &    s**(-1)*u1**(-1) - 8*mt**4*ms1**2*s**(-2)*u1**(-1) - 8*mt**6*
     &    s**(-2)*u1**(-1) + 12*mg**2*s**(-2)*t1 + 16*mg**2*s**(-1) - 
     &    32*mg**2*ms1**2*s**(-2) + 4*mg**2*ms1**2*s**(-1)*u1**(-1) - 
     &    24*mg**2*ms1**4*s**(-2)*u1**(-1) - 16*mg**2*mt**2*s**(-3)*t1
     &     + 8*mg**2*mt**2*s**(-1)*u1**(-1) - 16*mg**2*mt**2*ms1**2*
     &    s**(-2)*u1**(-1) + 8*mg**2*mt**4*s**(-2)*u1**(-1) + 16*mg**4*
     &    s**(-2) - 4*mg**4*s**(-1)*u1**(-1) + 24*mg**4*ms1**2*s**(-2)*
     &    u1**(-1) + 8*mg**4*mt**2*s**(-2)*u1**(-1) - 8*mg**6*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3D0(4,2)*susy*Nc*Ck*s2t*Pi*alphas**3 * (  - 16*
     &    mg*mt*s**(-2)*t1 - 16*mg*mt*s**(-1) + 32*mg*mt*ms1**2*s**(-2)
     &     - 8*mg*mt*ms1**2*s**(-1)*u1**(-1) + 16*mg*mt*ms1**4*s**(-2)*
     &    u1**(-1) + 32*mg*mt**3*s**(-3)*t1 + 32*mg*mt**3*s**(-2) + 32*
     &    mg*mt**3*ms1**2*s**(-2)*u1**(-1) + 16*mg*mt**5*s**(-2)*
     &    u1**(-1) - 32*mg**3*mt*s**(-2) - 32*mg**3*mt*ms1**2*s**(-2)*
     &    u1**(-1) - 32*mg**3*mt**3*s**(-2)*u1**(-1) + 16*mg**5*mt*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(5,1)*susy*Nc*Co*Pi*alphas**3 * (  - 4*
     &    s**(-2)*t1**2 - 12*ms1**2*s**(-2)*t1 - 16*ms1**4*s**(-2) - 8*
     &    ms1**6*s**(-2)*t1**(-1) + 12*mt**2*s**(-2)*t1 - 4*mt**2*
     &    s**(-1) + 32*mt**2*ms1**2*s**(-2) - 4*mt**2*ms1**2*s**(-1)*
     &    t1**(-1) + 24*mt**2*ms1**4*s**(-2)*t1**(-1) - 16*mt**4*
     &    s**(-2) + 4*mt**4*s**(-1)*t1**(-1) - 24*mt**4*ms1**2*s**(-2)*
     &    t1**(-1) + 8*mt**6*s**(-2)*t1**(-1) - 4*mg**2*s**(-2)*t1 - 4*
     &    mg**2*s**(-1) + 16*mg**2*ms1**2*s**(-3)*t1 + 16*mg**2*ms1**2*
     &    s**(-2) - 4*mg**2*ms1**2*s**(-1)*t1**(-1) - 8*mg**2*ms1**4*
     &    s**(-2)*t1**(-1) - 16*mg**2*mt**2*s**(-3)*t1 - 16*mg**2*mt**2
     &    *s**(-2) - 8*mg**2*mt**2*s**(-1)*t1**(-1) + 16*mg**2*mt**2*
     &    ms1**2*s**(-2)*t1**(-1) - 8*mg**2*mt**4*s**(-2)*t1**(-1) - 16
     &    *mg**4*s**(-3)*t1 + 4*mg**4*s**(-1)*t1**(-1) + 8*mg**4*ms1**2
     &    *s**(-2)*t1**(-1) - 8*mg**4*mt**2*s**(-2)*t1**(-1) + 8*mg**6*
     &    s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(5,1)*susy*Nc*Co*s2t*Pi*alphas**3 * (  - 16*
     &    mg*mt*s**(-2)*t1 - 32*mg*mt*ms1**2*s**(-2) + 8*mg*mt*ms1**2*
     &    s**(-1)*t1**(-1) - 16*mg*mt*ms1**4*s**(-2)*t1**(-1) + 32*mg*
     &    mt**3*s**(-2) + 32*mg*mt**3*ms1**2*s**(-2)*t1**(-1) - 16*mg*
     &    mt**5*s**(-2)*t1**(-1) + 32*mg**3*mt*s**(-3)*t1 - 32*mg**3*mt
     &    *ms1**2*s**(-2)*t1**(-1) + 32*mg**3*mt**3*s**(-2)*t1**(-1) - 
     &    16*mg**5*mt*s**(-2)*t1**(-1) )
      STGGV = STGGV + SK3D0(5,2)*susy*Nc*Co*Pi*alphas**3 * (  - 4 - 4*
     &    s**(-2)*t1**2 - 8*s**(-1)*t1 + 12*ms1**2*s**(-2)*t1 + 12*
     &    ms1**2*s**(-1) - 16*ms1**4*s**(-2) - 8*ms1**6*s**(-2)*
     &    u1**(-1) - 12*mt**2*s**(-2)*t1 - 16*mt**2*s**(-1) + 32*mt**2*
     &    ms1**2*s**(-2) - 4*mt**2*ms1**2*s**(-1)*u1**(-1) + 24*mt**2*
     &    ms1**4*s**(-2)*u1**(-1) - 16*mt**4*s**(-2) + 4*mt**4*s**(-1)*
     &    u1**(-1) - 24*mt**4*ms1**2*s**(-2)*u1**(-1) + 8*mt**6*s**(-2)
     &    *u1**(-1) + 4*mg**2*s**(-2)*t1 - 16*mg**2*ms1**2*s**(-3)*t1
     &     - 4*mg**2*ms1**2*s**(-1)*u1**(-1) - 8*mg**2*ms1**4*s**(-2)*
     &    u1**(-1) + 16*mg**2*mt**2*s**(-3)*t1 - 8*mg**2*mt**2*s**(-1)*
     &    u1**(-1) + 16*mg**2*mt**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**2*
     &    mt**4*s**(-2)*u1**(-1) + 16*mg**4*s**(-3)*t1 + 16*mg**4*
     &    s**(-2) + 4*mg**4*s**(-1)*u1**(-1) + 8*mg**4*ms1**2*s**(-2)*
     &    u1**(-1) - 8*mg**4*mt**2*s**(-2)*u1**(-1) + 8*mg**6*s**(-2)*
     &    u1**(-1) )
      STGGV = STGGV + SK3D0(5,2)*susy*Nc*Co*s2t*Pi*alphas**3 * ( 16*mg*
     &    mt*s**(-2)*t1 + 16*mg*mt*s**(-1) - 32*mg*mt*ms1**2*s**(-2) + 
     &    8*mg*mt*ms1**2*s**(-1)*u1**(-1) - 16*mg*mt*ms1**4*s**(-2)*
     &    u1**(-1) + 32*mg*mt**3*s**(-2) + 32*mg*mt**3*ms1**2*s**(-2)*
     &    u1**(-1) - 16*mg*mt**5*s**(-2)*u1**(-1) - 32*mg**3*mt*s**(-3)
     &    *t1 - 32*mg**3*mt*s**(-2) - 32*mg**3*mt*ms1**2*s**(-2)*
     &    u1**(-1) + 32*mg**3*mt**3*s**(-2)*u1**(-1) - 16*mg**5*mt*
     &    s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(6,1)*susy*Nc*Ck*Pi*alphas**3 * ( 8*ms1**4*
     &    s**(-2) + 8*ms1**6*s**(-2)*t1**(-1) + 8*ms1**6*s**(-2)*
     &    u1**(-1) - 4*mt**2*s**(-1) - 4*mt**2*ms1**2*s**(-1)*t1**(-1)
     &     - 4*mt**2*ms1**2*s**(-1)*u1**(-1) - 8*mt**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mt**2*ms1**4*s**(-2)*u1**(-1) - 8*mt**4*s**(-2)
     &     + 4*mt**4*s**(-1)*t1**(-1) + 4*mt**4*s**(-1)*u1**(-1) - 8*
     &    mt**4*ms1**2*s**(-2)*t1**(-1) - 8*mt**4*ms1**2*s**(-2)*
     &    u1**(-1) + 8*mt**6*s**(-2)*t1**(-1) + 8*mt**6*s**(-2)*
     &    u1**(-1) - 4*mg**2*s**(-1) - 4*mg**2*ms1**2*s**(-1)*t1**(-1)
     &     - 4*mg**2*ms1**2*s**(-1)*u1**(-1) - 8*mg**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mg**2*ms1**4*s**(-2)*u1**(-1) - 16*mg**2*mt**2*
     &    s**(-2) - 8*mg**2*mt**2*s**(-1)*t1**(-1) - 8*mg**2*mt**2*
     &    s**(-1)*u1**(-1) + 16*mg**2*mt**2*ms1**2*s**(-2)*t1**(-1) + 
     &    16*mg**2*mt**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**2*mt**4*
     &    s**(-2)*t1**(-1) - 8*mg**2*mt**4*s**(-2)*u1**(-1) - 8*mg**4*
     &    s**(-2) )
      STGGV = STGGV + SK3D0(6,1)*susy*Nc*Ck*Pi*alphas**3 * ( 4*mg**4*
     &    s**(-1)*t1**(-1) + 4*mg**4*s**(-1)*u1**(-1) - 8*mg**4*ms1**2*
     &    s**(-2)*t1**(-1) - 8*mg**4*ms1**2*s**(-2)*u1**(-1) - 8*mg**4*
     &    mt**2*s**(-2)*t1**(-1) - 8*mg**4*mt**2*s**(-2)*u1**(-1) + 8*
     &    mg**6*s**(-2)*t1**(-1) + 8*mg**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(6,1)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 16*mg*
     &    mt*ms1**2*s**(-2) + 8*mg*mt*ms1**2*s**(-1)*t1**(-1) + 8*mg*mt
     &    *ms1**2*s**(-1)*u1**(-1) + 16*mg*mt*ms1**4*s**(-2)*t1**(-1)
     &     + 16*mg*mt*ms1**4*s**(-2)*u1**(-1) + 16*mg*mt**3*s**(-2) - 
     &    16*mg*mt**5*s**(-2)*t1**(-1) - 16*mg*mt**5*s**(-2)*u1**(-1)
     &     + 16*mg**3*mt*s**(-2) + 32*mg**3*mt**3*s**(-2)*t1**(-1) + 32
     &    *mg**3*mt**3*s**(-2)*u1**(-1) - 16*mg**5*mt*s**(-2)*t1**(-1)
     &     - 16*mg**5*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(6,2)*susy*Nc*Ck*Pi*alphas**3 * ( 8*ms1**4*
     &    s**(-2) + 8*ms1**6*s**(-2)*t1**(-1) + 8*ms1**6*s**(-2)*
     &    u1**(-1) - 4*mt**2*s**(-1) - 4*mt**2*ms1**2*s**(-1)*t1**(-1)
     &     - 4*mt**2*ms1**2*s**(-1)*u1**(-1) - 8*mt**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mt**2*ms1**4*s**(-2)*u1**(-1) - 8*mt**4*s**(-2)
     &     + 4*mt**4*s**(-1)*t1**(-1) + 4*mt**4*s**(-1)*u1**(-1) - 8*
     &    mt**4*ms1**2*s**(-2)*t1**(-1) - 8*mt**4*ms1**2*s**(-2)*
     &    u1**(-1) + 8*mt**6*s**(-2)*t1**(-1) + 8*mt**6*s**(-2)*
     &    u1**(-1) - 4*mg**2*s**(-1) - 4*mg**2*ms1**2*s**(-1)*t1**(-1)
     &     - 4*mg**2*ms1**2*s**(-1)*u1**(-1) - 8*mg**2*ms1**4*s**(-2)*
     &    t1**(-1) - 8*mg**2*ms1**4*s**(-2)*u1**(-1) - 16*mg**2*mt**2*
     &    s**(-2) - 8*mg**2*mt**2*s**(-1)*t1**(-1) - 8*mg**2*mt**2*
     &    s**(-1)*u1**(-1) + 16*mg**2*mt**2*ms1**2*s**(-2)*t1**(-1) + 
     &    16*mg**2*mt**2*ms1**2*s**(-2)*u1**(-1) - 8*mg**2*mt**4*
     &    s**(-2)*t1**(-1) - 8*mg**2*mt**4*s**(-2)*u1**(-1) - 8*mg**4*
     &    s**(-2) )
      STGGV = STGGV + SK3D0(6,2)*susy*Nc*Ck*Pi*alphas**3 * ( 4*mg**4*
     &    s**(-1)*t1**(-1) + 4*mg**4*s**(-1)*u1**(-1) - 8*mg**4*ms1**2*
     &    s**(-2)*t1**(-1) - 8*mg**4*ms1**2*s**(-2)*u1**(-1) - 8*mg**4*
     &    mt**2*s**(-2)*t1**(-1) - 8*mg**4*mt**2*s**(-2)*u1**(-1) + 8*
     &    mg**6*s**(-2)*t1**(-1) + 8*mg**6*s**(-2)*u1**(-1) )
      STGGV = STGGV + SK3D0(6,2)*susy*Nc*Ck*s2t*Pi*alphas**3 * ( 16*mg*
     &    mt*ms1**2*s**(-2) + 8*mg*mt*ms1**2*s**(-1)*t1**(-1) + 8*mg*mt
     &    *ms1**2*s**(-1)*u1**(-1) + 16*mg*mt*ms1**4*s**(-2)*t1**(-1)
     &     + 16*mg*mt*ms1**4*s**(-2)*u1**(-1) + 16*mg*mt**3*s**(-2) - 
     &    16*mg*mt**5*s**(-2)*t1**(-1) - 16*mg*mt**5*s**(-2)*u1**(-1)
     &     + 16*mg**3*mt*s**(-2) + 32*mg**3*mt**3*s**(-2)*t1**(-1) + 32
     &    *mg**3*mt**3*s**(-2)*u1**(-1) - 16*mg**5*mt*s**(-2)*t1**(-1)
     &     - 16*mg**5*mt*s**(-2)*u1**(-1) )
      STGGV = STGGV + SOF1(1)*Cqed*Pi*alphas**3 * ( 64*s**(-1) - 128*
     &    ms1**2*s**(-2) + 128*ms1**2*s**(-1)*t1**(-1) + 128*ms1**2*
     &    s**(-1)*u1**(-1) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     &    s**(-2)*u1**(-1) + 128*ms1**4*s**(-1)*t1**(-2) + 128*ms1**4*
     &    s**(-1)*u1**(-2) - 256*ms1**6*s**(-2)*t1**(-2) - 512*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(1)*Nc*Ck*Pi*alphas**3 * (  - 128*s**(-3)*
     &    t1**2 - 128*s**(-2)*t1 - 64*s**(-1) + 256*ms1**2*s**(-4)*
     &    t1**2 + 256*ms1**2*s**(-3)*t1 - 128*ms1**2*s**(-2) - 128*
     &    ms1**2*s**(-1)*t1**(-1) - 128*ms1**2*s**(-1)*u1**(-1) + 512*
     &    ms1**4*s**(-3) + 256*ms1**4*s**(-2)*t1**(-1) + 256*ms1**4*
     &    s**(-2)*u1**(-1) - 128*ms1**4*s**(-1)*t1**(-2) - 128*ms1**4*
     &    s**(-1)*u1**(-2) + 256*ms1**6*s**(-2)*t1**(-2) + 256*ms1**6*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(2)*Cqed*Pi*alphas**3 * (  - 64*ms1**2*
     &    s**(-2) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     &    u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*s**(-2)*
     &    t1**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(2)*Nc*Ck*Pi*alphas**3 * ( 128*ms1**2*s**(-4)
     &    *t1**2 + 128*ms1**2*s**(-3)*t1 + 192*ms1**2*s**(-2) + 256*
     &    ms1**4*s**(-3) + 384*ms1**4*s**(-2)*t1**(-1) + 384*ms1**4*
     &    s**(-2)*u1**(-1) + 384*ms1**6*s**(-2)*t1**(-2) + 512*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-1) + 384*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(2)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     &    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) - 
     &    256*ms1**4*s**(-3) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4
     &    *s**(-2)*u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 128*ms1**6*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(3)*Cqed*Pi*alphas**3 * (  - 64*ms1**2*
     &    s**(-2) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4*s**(-2)*
     &    u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 256*ms1**6*s**(-2)*
     &    t1**(-1)*u1**(-1) - 128*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(3)*Nc*Ck*Pi*alphas**3 * ( 128*ms1**2*s**(-4)
     &    *t1**2 + 128*ms1**2*s**(-3)*t1 + 192*ms1**2*s**(-2) + 256*
     &    ms1**4*s**(-3) + 384*ms1**4*s**(-2)*t1**(-1) + 384*ms1**4*
     &    s**(-2)*u1**(-1) + 384*ms1**6*s**(-2)*t1**(-2) + 512*ms1**6*
     &    s**(-2)*t1**(-1)*u1**(-1) + 384*ms1**6*s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(3)*Nc*Co*Pi*alphas**3 * (  - 128*ms1**2*
     &    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) - 
     &    256*ms1**4*s**(-3) - 128*ms1**4*s**(-2)*t1**(-1) - 128*ms1**4
     &    *s**(-2)*u1**(-1) - 128*ms1**6*s**(-2)*t1**(-2) - 128*ms1**6*
     &    s**(-2)*u1**(-2) )
      STGGV = STGGV + SOF1(4)*Nc*Ck*Pi*alphas**3 * ( 64*s**(-2)*t1 + 64
     &    *s**(-1) + 128*ms1**2*s**(-1)*t1**(-1) - 128*ms1**4*s**(-2)*
     &    t1**(-1) - 128*ms1**4*s**(-2)*u1**(-1) + 128*ms1**4*s**(-1)*
     &    t1**(-2) )
      STGGV = STGGV + SOF1(4)*Nc*Co*Pi*alphas**3 * (  - 64*s**(-4)*
     &    t1**3 - 64*s**(-3)*t1**2 - 128*ms1**2*s**(-3)*t1 + 128*ms1**4
     &    *s**(-2)*u1**(-1) )
      STGGV = STGGV + SOF1(5)*Nc*Ck*Pi*alphas**3 * (  - 64*s**(-2)*t1
     &     + 128*ms1**2*s**(-1)*u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1)
     &     - 128*ms1**4*s**(-2)*u1**(-1) + 128*ms1**4*s**(-1)*u1**(-2)
     &     )
      STGGV = STGGV + SOF1(5)*Nc*Co*Pi*alphas**3 * ( 64*s**(-4)*t1**3
     &     + 128*s**(-3)*t1**2 + 64*s**(-2)*t1 + 128*ms1**2*s**(-3)*t1
     &     + 128*ms1**2*s**(-2) + 128*ms1**4*s**(-2)*t1**(-1) )
      STGGV = STGGV + SOF1(6)*Nc*Ck*Pi*alphas**3 * (  - 64*s**(-2)*t1
     &     + 128*ms1**2*s**(-1)*u1**(-1) - 128*ms1**4*s**(-2)*t1**(-1)
     &     - 128*ms1**4*s**(-2)*u1**(-1) + 128*ms1**4*s**(-1)*u1**(-2)
     &     )
      STGGV = STGGV + SOF1(6)*Nc*Co*Pi*alphas**3 * ( 64*s**(-4)*t1**3
     &     + 128*s**(-3)*t1**2 + 64*s**(-2)*t1 + 128*ms1**2*s**(-3)*t1
     &     + 128*ms1**2*s**(-2) + 128*ms1**4*s**(-2)*t1**(-1) )
      STGGV = STGGV + SOF1(7)*Nc*Ck*Pi*alphas**3 * ( 64*s**(-2)*t1 + 64
     &    *s**(-1) + 128*ms1**2*s**(-1)*t1**(-1) - 128*ms1**4*s**(-2)*
     &    t1**(-1) - 128*ms1**4*s**(-2)*u1**(-1) + 128*ms1**4*s**(-1)*
     &    t1**(-2) )
      STGGV = STGGV + SOF1(7)*Nc*Co*Pi*alphas**3 * (  - 64*s**(-4)*
     &    t1**3 - 64*s**(-3)*t1**2 - 128*ms1**2*s**(-3)*t1 + 128*ms1**4
     &    *s**(-2)*u1**(-1) )
      STGGV = STGGV + SOF1(8)*Nc*Co*Pi*alphas**3 * ( 128*s**(-3)*t1**2
     &     + 128*s**(-2)*t1 + 64*s**(-1) + 256*ms1**2*s**(-2) + 128*
     &    ms1**2*s**(-1)*t1**(-1) + 128*ms1**2*s**(-1)*u1**(-1) + 128*
     &    ms1**4*s**(-1)*t1**(-2) + 128*ms1**4*s**(-1)*u1**(-2) )

      TB_GGV = fac * STGGV  + dec

      end

c --------------------------------------------------------------------
      real*8 function TB_GGH(s,t1,s4,ms1)

      implicit none 

      real*8 Pi,Nc,Co,Ck,Cqed,alphas,fac 
      real*8 s,t1,u1,ms1,s4
      real*8 hardin(5)
      real*8 ANG4(71),COLO1(9)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Co = Nc*(Nc**2-1.D0)
      Ck = (Nc**2-1.D0)/Nc 
      Cqed = Nc**2 - 1/Nc**2 
      alphas = 1.D0

      u1 = s4 - s - t1 
      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /(Nc**2-1.D0)**2

      hardin(1) = s
      hardin(2) = t1 
      hardin(3) = u1 
      hardin(4) = s4 
      hardin(5) = ms1**2 

      call LOGAS_LQ(hardin,COLO1)
      call ANGULAR_ARRAY_TB_GS(hardin,ANG4)

      TB_GGH =
     +  + Nc*Co*Pi**4*alphas**3 * ( 4608*ms1**2*s**(-4)*t1*s4**(-1) - 
     +    2560*ms1**2*s**(-4)*t1*(t1+u1)**(-1) - 2048*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 1024*ms1**2*s**(-4)*t1**2*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 4608*ms1**2*s**(-3)*t1**(-2)*u1 + 512*ms1**2
     +    *s**(-3)*t1**(-1)*s4*(s+t1)**(-1) - 4096*ms1**2*s**(-3)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 8192*ms1**2*s**(-3)*t1**(-1) - 
     +    4608*ms1**2*s**(-3)*t1*u1**(-2) - 3584*ms1**2*s**(-3)*t1*
     +    s4**(-2) + 5120*ms1**2*s**(-3)*t1*s4**(-1)*(t1+u1)**(-1) - 
     +    4096*ms1**2*s**(-3)*t1**2*u1**(-3) - 1024*ms1**2*s**(-3)*
     +    t1**2*s4**(-2)*(t1+u1)**(-1) - 4096*ms1**2*s**(-3)*u1**(-1)*
     +    s4*(s+t1)**(-1) + 512*ms1**2*s**(-3)*u1**(-1)*s4*(s+u1)**(-1)
     +     + 8704*ms1**2*s**(-3)*u1**(-1) + 2560*ms1**2*s**(-3)*
     +    s4**(-1) - 3584*ms1**2*s**(-3)*(t1+u1)**(-1) - 8192*ms1**2*
     +    s**(-2)*t1**(-3)*u1 + 512*ms1**2*s**(-2)*t1**(-2)*s4*
     +    (s+t1)**(-1) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * ( 5632*ms1**2*s**(-2)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 10240*ms1**2*s**(-2)*t1**(-2) - 
     +    4608*ms1**2*s**(-2)*t1**(-1)*u1**(-1)*s4*(s+t1)**(-1) - 4608*
     +    ms1**2*s**(-2)*t1**(-1)*u1**(-1)*s4*(s+u1)**(-1) + 9216*
     +    ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 9728*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) - 1536*ms1**2*s**(-2)*t1**(-1)*
     +    (t1+u1)**(-1) - 8192*ms1**2*s**(-2)*t1*u1**(-3) - 2560*ms1**2
     +    *s**(-2)*t1*s4**(-2)*(t1+u1)**(-1) + 5632*ms1**2*s**(-2)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 10240*ms1**2*s**(-2)*u1**(-2) - 12288*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 3072*ms1**2*s**(-2)*s4**(-2) + 
     +    6144*ms1**2*s**(-2)*s4**(-1)*(t1+u1)**(-1) - 1024*ms1**2*
     +    s**(-1)*t1**(-3)*s4*(s+u1)**(-1) - 5120*ms1**2*s**(-1)*
     +    t1**(-3) - 512*ms1**2*s**(-1)*t1**(-2)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 6144*ms1**2*s**(-1)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * (  - 7680*ms1**2*s**(-1)*
     +    t1**(-2)*u1**(-1) + 512*ms1**2*s**(-1)*t1**(-2)*s4**(-1) + 
     +    6144*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*
     +    ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*(s+u1)**(-1) - 7680*
     +    ms1**2*s**(-1)*t1**(-1)*u1**(-2) - 12288*ms1**2*s**(-1)*
     +    t1**(-1)*u1**(-1)*s4**(-1) + 1024*ms1**2*s**(-1)*t1**(-1)*
     +    s4**(-2) + 2560*ms1**2*s**(-1)*t1**(-1)*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*ms1**2*s**(-1)*u1**(-3)*s4*(s+t1)**(-1)
     +     - 5120*ms1**2*s**(-1)*u1**(-3) + 512*ms1**2*s**(-1)*u1**(-2)
     +    *s4**(-1) + 2048*ms1**2*s**(-1)*u1**(-1)*s4**(-2) - 2560*
     +    ms1**2*s**(-1)*s4**(-2)*(t1+u1)**(-1) - 1024*ms1**2*t1**(-3)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 1024*ms1**2*t1**(-3)*u1**(-1) + 
     +    512*ms1**2*t1**(-2)*u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**2*
     +    t1**(-2)*u1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*t1**(-2)*
     +    u1**(-2) + 512*ms1**2*t1**(-2)*u1**(-1)*s4**(-1) - 1024*
     +    ms1**2*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2*t1**(-1)
     +    *u1**(-3) + 512*ms1**2*t1**(-1)*u1**(-2)*s4**(-1) + 2048*
     +    ms1**2*t1**(-1)*u1**(-1)*s4**(-2) - 1024*ms1**2*t1**(-1)*
     +    s4**(-2)*(t1+u1)**(-1) - 4096*ms1**4*s**(-3)*t1**(-3)*u1 - 
     +    4096*ms1**4*s**(-3)*t1*u1**(-3) + 1024*ms1**4*s**(-3)*
     +    u1**(-1)*s4**(-1) - 2048*ms1**4*s**(-3)*s4**(-2) + 4096*
     +    ms1**4*s**(-2)*t1**(-4)*u1 - 1024*ms1**4*s**(-2)*t1**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 4096*
     +    ms1**4*s**(-2)*t1*u1**(-4) - 1024*ms1**4*s**(-2)*u1**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-2)*u1**(-1)*s4**(-2) + 8192*
     +    ms1**4*s**(-1)*t1**(-4) + 2048*ms1**4*s**(-1)*t1**(-3)*
     +    s4**(-1) + 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) + 
     +    2048*ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) + 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s**(-1)*u1**(-3)*s4**(-1) + 
     +    2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*ms1**4*s*t1**(-2)*
     +    u1**(-4) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * ( 6144*ms1**4*t1**(-4)*
     +    u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-3)*u1**(-1)*s4**(-1) + 2048*ms1**4*t1**(-2)*u1**(-3) + 
     +    6144*ms1**4*t1**(-1)*u1**(-4) + 2048*ms1**4*t1**(-1)*u1**(-3)
     +    *s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-4) - 1024*ms1**6*
     +    s**(-2)*t1**(-2)*s4**(-2) + 4096*ms1**6*s**(-2)*u1**(-4) - 
     +    1024*ms1**6*s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*
     +    t1**(-4)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-1)*
     +    s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*u1**(-3)*s4**(-1) + 
     +    4096*ms1**6*s**(-1)*u1**(-4)*s4**(-1) + 2048*ms1**6*t1**(-4)*
     +    u1**(-2) + 4096*ms1**6*t1**(-4)*u1**(-1)*s4**(-1) + 2048*
     +    ms1**6*t1**(-2)*u1**(-4) + 4096*ms1**6*t1**(-1)*u1**(-4)*
     +    s4**(-1) - 1024*s**(-4)*t1**2*s4**(-1) + 1024*s**(-4)*t1**2*
     +    (t1+u1)**(-1) - 512*s**(-3)*t1**(-2)*u1**2 + 512*s**(-3)*
     +    t1**(-1)*u1*s4*(s+t1)**(-1) + 3328*s**(-3)*t1**(-1)*u1 + 512*
     +    s**(-3)*t1*u1**(-1)*s4*(s+u1)**(-1) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * ( 3584*s**(-3)*t1*
     +    u1**(-1) - 3072*s**(-3)*t1*s4**(-1) + 2560*s**(-3)*t1*
     +    (t1+u1)**(-1) - 512*s**(-3)*t1**2*u1**(-2) - 1024*s**(-3)*
     +    t1**2*s4**(-1)*(t1+u1)**(-1) - 3584*s**(-3)*s4*(s+t1)**(-1)
     +     - 3584*s**(-3)*s4*(s+u1)**(-1) + 7680*s**(-3) + 512*s**(-2)*
     +    t1**(-2)*u1*s4*(s+t1)**(-1) - 512*s**(-2)*t1**(-2)*u1 - 3584*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 1024*s**(-2)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 1792*s**(-2)*t1**(-1) + 512*s**(-2)*t1*
     +    u1**(-2)*s4*(s+u1)**(-1) - 512*s**(-2)*t1*u1**(-2) - 2560*
     +    s**(-2)*t1*s4**(-1)*(t1+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4*
     +    (s+t1)**(-1) - 3584*s**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 1536*
     +    s**(-2)*u1**(-1) - 2304*s**(-2)*s4**(-1) + 2560*s**(-2)*
     +    (t1+u1)**(-1) - 1024*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) + 1024*
     +    s**(-1)*t1**(-2) + 1024*s**(-1)*t1**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 1024*s**(-1)*t1**(-1)*u1**(-1)*s4*(s+u1)**(-1)
     +     - 2048*s**(-1)*t1**(-1)*u1**(-1) )
      TB_GGH=TB_GGH + Nc*Co*Pi**4*alphas**3 * ( 1024*s**(-1)*t1**(-1)*
     +    s4**(-1) + 1024*s**(-1)*t1**(-1)*(t1+u1)**(-1) - 1024*s**(-1)
     +    *u1**(-2)*s4*(s+t1)**(-1) + 1024*s**(-1)*u1**(-2) + 2304*
     +    s**(-1)*u1**(-1)*s4**(-1) - 2560*s**(-1)*s4**(-1)*
     +    (t1+u1)**(-1) - 1024*t1**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 1024
     +    *t1**(-2)*u1**(-1) - 1024*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1)
     +     + 1024*t1**(-1)*u1**(-2) + 2048*t1**(-1)*u1**(-1)*s4**(-1)
     +     - 1024*t1**(-1)*s4**(-1)*(t1+u1)**(-1) )
      TB_GGH=TB_GGH + Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**2*s**(-4)*
     +    t1*s4**(-1) + 1024*ms1**2*s**(-4)*t1**2*s4**(-2) + 1024*
     +    ms1**2*s**(-4) - 512*ms1**2*s**(-3)*t1**(-1) + 1024*ms1**2*
     +    s**(-3)*t1*s4**(-2) - 1024*ms1**2*s**(-3)*u1**(-1) + 1024*
     +    ms1**2*s**(-3)*s4**(-1) + 1536*ms1**2*s**(-2)*t1**(-2) + 3072
     +    *ms1**2*s**(-2)*t1**(-1)*u1**(-1) + 1536*ms1**2*s**(-2)*
     +    u1**(-2) + 1024*ms1**2*s**(-2)*u1**(-1)*s4**(-1) + 1536*
     +    ms1**2*s**(-2)*s4**(-2) + 2048*ms1**2*s**(-1)*t1**(-3) + 2048
     +    *ms1**2*s**(-1)*t1**(-2)*u1**(-1) + 2048*ms1**2*s**(-1)*
     +    t1**(-1)*u1**(-2) + 2048*ms1**2*s**(-1)*u1**(-3) + 2048*
     +    ms1**2*t1**(-3)*u1**(-1) + 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    1024*ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 2048*ms1**4*s**(-3)*
     +    s4**(-2) + 3072*ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*
     +    ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) + 3072*ms1**4*
     +    s**(-2)*t1**(-1)*s4**(-2) + 3072*ms1**4*s**(-2)*u1**(-2)*
     +    s4**(-1) )
      TB_GGH=TB_GGH + Nc*Ck*Pi**4*alphas**3 * ( 3072*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 4096*ms1**4*s**(-1)*t1**(-3)*u1**(-1) - 
     +    2048*ms1**4*s**(-1)*t1**(-3)*s4**(-1) - 2048*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-3) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) - 
     +    2048*ms1**4*s**(-1)*u1**(-3)*s4**(-1) - 2048*ms1**4*s*
     +    t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048*
     +    ms1**4*t1**(-4)*u1**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2) - 
     +    2048*ms1**4*t1**(-3)*u1**(-1)*s4**(-1) - 2048*ms1**4*t1**(-2)
     +    *u1**(-3) - 2048*ms1**4*t1**(-1)*u1**(-4) - 2048*ms1**4*
     +    t1**(-1)*u1**(-3)*s4**(-1) + 3072*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 
     +    3072*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 2048*ms1**6*t1**(-4)*
     +    u1**(-2) - 2048*ms1**6*t1**(-2)*u1**(-4) - 256*s**(-3)*
     +    t1**(-1)*u1 - 512*s**(-3)*t1*u1**(-1) + 512*s**(-3)*t1*
     +    s4**(-1) )
      TB_GGH=TB_GGH + Nc*Ck*Pi**4*alphas**3 * (  - 512*s**(-3) + 768*
     +    s**(-2)*t1**(-1) + 1024*s**(-2)*u1**(-1) - 256*s**(-2)*
     +    s4**(-1) + 1024*s**(-1)*t1**(-1)*u1**(-1) - 256*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + Cqed*Pi**4*alphas**3 * (  - 512*ms1**2*s**(-2)*
     +    t1**(-2) - 1536*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 512*ms1**2
     +    *s**(-2)*u1**(-2) - 512*ms1**2*s**(-2)*s4**(-2) - 1024*ms1**4
     +    *s**(-2)*t1**(-2)*s4**(-1) - 2048*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    1024*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 1024*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) - 1024*ms1**6*s**(-2)*t1**(-2)*s4**(-2) - 
     +    2048*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) - 1024*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) - 512*s**(-2)*t1**(-1) - 512*
     +    s**(-2)*u1**(-1) - 512*s**(-1)*t1**(-1)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(1)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(1)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(1)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(2)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(2)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) + 2048*ms1**6*s**(-2)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(2)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) - 1024*ms1**6*s**(-2)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(3)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(3)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) - 2048*ms1**6*s**(-3) )
      TB_GGH=TB_GGH + ANG4(3)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) + 1024*ms1**6*s**(-3) )
      TB_GGH=TB_GGH + ANG4(4)*Nc*Co*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 512*ms1**2*s**(-2) + 512*ms1**2*
     +    s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-3)*t1*u1**(-1) - 512*
     +    ms1**4*s**(-3)*t1*(t1+u1)**(-1) + 512*ms1**4*s**(-3) + 512*
     +    ms1**4*s**(-2)*u1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) + 
     +    512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) - 128*s**(-1)*t1*
     +    (t1+u1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(4)*Nc*Ck*Pi**4*alphas**3 * ( 320*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 512*ms1**2*s**(-2)*t1*s4**(-1) + 192*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) + 320*ms1**2*s**(-2) - 64*
     +    ms1**2*s**(-1)*t1**(-1)*s4*(s+t1)**(-1) - 448*ms1**2*s**(-1)*
     +    t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1) - 768*ms1**2*s**(-1)*s4**(-1) - 1024*
     +    ms1**4*s**(-3)*t1**(-1)*u1 - 1536*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 512*ms1**4*s**(-3)*t1*s4**(-1) - 2560*ms1**4*s**(-3) + 512
     +    *ms1**4*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 640*ms1**4*s**(-2)
     +    *t1**(-1) - 128*ms1**4*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 640
     +    *ms1**4*s**(-2)*u1**(-1) + 1024*ms1**4*s**(-2)*s4**(-1) - 640
     +    *ms1**4*s**(-1)*t1**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 128*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) - 512*
     +    ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 2048*ms1**6*s**(-4) - 1024
     +    *ms1**6*s**(-3)*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(4)*Nc*Ck*Pi**4*alphas**3 * (  - 1024*ms1**6*
     +    s**(-3)*u1**(-1) + 1024*ms1**6*s**(-2)*u1**(-1)*s4**(-1) - 
     +    128*s**(-1)*t1**(-1)*u1 + 128*s**(-1)*t1*s4**(-1) - 128*
     +    s**(-1)*s4*(s+t1)**(-1) + 128*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(4)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 768*ms1**2*s**(-1)*t1**(-1) - 512*
     +    ms1**2*s**(-1)*s4**(-1) - 768*ms1**2*t1**(-1)*s4**(-1) + 512*
     +    ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 1024*ms1**4*s**(-3) - 1024*ms1**4*s**(-2)*t1**(-1) - 512*
     +    ms1**4*s**(-2)*u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 1536*
     +    ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 512*ms1**4*s**(-1)*
     +    u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-4) + 1024*ms1**6*s**(-3)
     +    *t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*
     +    s**(-2)*t1**(-1)*s4**(-1) - 1024*ms1**6*s**(-2)*u1**(-1)*
     +    s4**(-1) + 128*s**(-1)*t1**(-1)*u1 + 128*s*t1**(-1)*s4**(-1)
     +     - 128*t1**(-1) + 128*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(5)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(5)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(5)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**6*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(6)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(6)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) + 2048*ms1**6*s**(-2)*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(6)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) - 1024*ms1**6*s**(-2)*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(7)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(7)*Nc*Ck*Pi**4*alphas**3 * ( 1536*ms1**4*
     +    s**(-2) - 2048*ms1**6*s**(-3) )
      TB_GGH=TB_GGH + ANG4(7)*Cqed*Pi**4*alphas**3 * (  - 512*ms1**4*
     +    s**(-2) + 1024*ms1**6*s**(-3) )
      TB_GGH=TB_GGH + ANG4(8)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) + 512*ms1**2*s**(-1)*(t1+u1)**(-1)
     +     + 512*ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*
     +    (t1+u1)**(-1) + 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-2)*(t1+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)
     +     - 512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 128*s**(-1)*t1
     +    *(t1+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(8)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 512*ms1**2*s**(-2)*t1*s4**(-1) + 256*
     +    ms1**2*s**(-2)*s4*(s+u1)**(-1) - 256*ms1**2*s**(-2) - 256*
     +    ms1**2*s**(-1)*t1**(-1)*s4*(s+u1)**(-1) + 256*ms1**2*s**(-1)*
     +    t1**(-1) - 512*ms1**2*s**(-1)*u1**(-1) - 256*ms1**2*s**(-1)*
     +    s4**(-1) - 1536*ms1**4*s**(-3)*t1**(-1)*u1 - 1024*ms1**4*
     +    s**(-3)*t1*u1**(-1) - 512*ms1**4*s**(-3)*t1*s4**(-1) - 2048*
     +    ms1**4*s**(-3) + 512*ms1**4*s**(-2)*t1**(-1)*s4*(s+u1)**(-1)
     +     + 512*ms1**4*s**(-2)*u1**(-1)*s4*(s+u1)**(-1) + 512*ms1**4*
     +    s**(-2)*s4**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) - 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*
     +    s4**(-1) - 2048*ms1**6*s**(-4) - 1024*ms1**6*s**(-3)*t1**(-1)
     +     - 1024*ms1**6*s**(-3)*u1**(-1) + 1024*ms1**6*s**(-2)*
     +    t1**(-1)*s4**(-1) - 128*s**(-1)*t1*u1**(-1) - 128*s**(-1)*t1*
     +    s4**(-1) )
      TB_GGH=TB_GGH + ANG4(8)*Nc*Ck*Pi**4*alphas**3 * (  - 128*s**(-1)*
     +    s4*(s+u1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(8)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 768*ms1**2*s**(-1)*u1**(-1) - 512*
     +    ms1**2*s**(-1)*s4**(-1) - 768*ms1**2*u1**(-1)*s4**(-1) + 512*
     +    ms1**4*s**(-3)*t1**(-1)*u1 + 512*ms1**4*s**(-3)*t1*u1**(-1)
     +     + 1024*ms1**4*s**(-3) - 512*ms1**4*s**(-2)*t1**(-1) - 1024*
     +    ms1**4*s**(-2)*u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 512*
     +    ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 1536*ms1**4*s**(-1)*
     +    u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-4) + 1024*ms1**6*s**(-3)
     +    *t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*
     +    s**(-2)*t1**(-1)*s4**(-1) - 1024*ms1**6*s**(-2)*u1**(-1)*
     +    s4**(-1) + 128*s**(-1)*t1*u1**(-1) + 128*s*u1**(-1)*s4**(-1)
     +     - 128*u1**(-1) + 128*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(9)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-4) )
      TB_GGH=TB_GGH + ANG4(9)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-4) )
      TB_GGH=TB_GGH + ANG4(10)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-3) )
      TB_GGH=TB_GGH + ANG4(10)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-3) )
      TB_GGH=TB_GGH + ANG4(11)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*(t1+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(12)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-4)*t1*(t1+u1)**(-1) + 1024*ms1**2*s**(-4) + 1024*ms1**2
     +    *s**(-3)*(t1+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(12)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1*s4**(-1) - 1024*ms1**2*s**(-4) - 256*ms1**2*
     +    s**(-3)*t1**(-1) + 256*ms1**2*s**(-3)*u1**(-1) + 512*ms1**2*
     +    s**(-3)*s4**(-1) + 512*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 512
     +    *ms1**2*s**(-2)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) - 
     +    128*s**(-3)*t1**(-1)*u1 + 128*s**(-3)*t1*u1**(-1) - 512*
     +    s**(-3)*t1*s4**(-1) + 256*s**(-3) + 128*s**(-2)*t1**(-1) - 
     +    128*s**(-2)*u1**(-1) - 256*s**(-2)*s4**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) + 128*s**(-1)*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(13)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-4) )
      TB_GGH=TB_GGH + ANG4(14)*Nc*Co*Pi**4*alphas**3 * (  - 2048*ms1**2
     +    *s**(-4)*u1 - 1024*ms1**2*s**(-3) )
      TB_GGH=TB_GGH + ANG4(15)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*(t1+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(16)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1*s4**(-1) - 1024*ms1**2*s**(-4)*t1*(t1+u1)**(-1) - 
     +    256*ms1**2*s**(-3)*t1**(-1) + 256*ms1**2*s**(-3)*u1**(-1) + 
     +    512*ms1**2*s**(-3)*s4**(-1) + 1024*ms1**2*s**(-3)*
     +    (t1+u1)**(-1) + 512*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 512*
     +    ms1**2*s**(-2)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) - 
     +    128*s**(-3)*t1**(-1)*u1 + 128*s**(-3)*t1*u1**(-1) - 512*
     +    s**(-3)*t1*s4**(-1) + 256*s**(-3) + 128*s**(-2)*t1**(-1) - 
     +    128*s**(-2)*u1**(-1) - 256*s**(-2)*s4**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) + 128*s**(-1)*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(17)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1 + 512*ms1**2*s**(-2)*t1*u1**(-1) - 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1)
     +     + 512*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) + 1024*ms1**2*
     +    s**(-1)*t1*u1**(-2) + 512*ms1**2*s**(-1)*u1**(-1) + 512*
     +    ms1**2*s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-3)*t1*
     +    (t1+u1)**(-1) - 512*ms1**4*s**(-3) - 512*ms1**4*s**(-2)*
     +    t1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) + 512*ms1**4*
     +    s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*
     +    t1**(-2) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-1)*(t1+u1)**(-1) - 384*s**(-3)*t1*u1 - 512*
     +    s**(-3)*t1**2 - 256*s**(-3)*t1**3*u1**(-1) - 128*s**(-3)*
     +    u1**2 - 128*s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*t1*s4*
     +    (s+u1)**(-1) - 1152*s**(-2)*t1 - 256*s**(-2)*t1**2*u1**(-1)*
     +    s4*(s+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(17)*Nc*Co*Pi**4*alphas**3 * (  - 768*s**(-2)
     +    *t1**2*u1**(-1) - 768*s**(-2)*u1 - 128*s**(-1)*t1**(-1)*u1 - 
     +    512*s**(-1)*t1*u1**(-1) + 128*s**(-1)*t1*(t1+u1)**(-1) + 128*
     +    s**(-1)*s4*(s+u1)**(-1) - 512*s**(-1) )
      TB_GGH=TB_GGH + ANG4(18)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*u1 + 512*ms1**2*s**(-2)*t1**(-1)*u1 + 512*ms1**2*
     +    s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1)
     +     + 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 512*ms1**2*s**(-1)*
     +    t1**(-1) + 256*ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1) + 512*ms1**2*s**(-1)*(t1+u1)**(-1) - 
     +    512*ms1**4*s**(-3)*t1*(t1+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-1) - 512*ms1**4*s**(-2)*(t1+u1)**(-1) - 1024*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-1)*u1**(-2) + 512*ms1**4*
     +    s**(-1)*u1**(-1)*(t1+u1)**(-1) - 256*s**(-3)*t1**(-1)*u1**3
     +     - 384*s**(-3)*t1*u1 - 128*s**(-3)*t1**2 - 512*s**(-3)*u1**2
     +     - 256*s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) - 768*s**(-2)*
     +    t1**(-1)*u1**2 - 768*s**(-2)*t1 - 128*s**(-2)*t1**2*u1**(-1)
     +     - 256*s**(-2)*u1*s4*(s+t1)**(-1) - 1152*s**(-2)*u1 - 512*
     +    s**(-1)*t1**(-1)*u1 )
      TB_GGH=TB_GGH + ANG4(18)*Nc*Co*Pi**4*alphas**3 * (  - 128*s**(-1)
     +    *t1*u1**(-1) - 128*s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*
     +    (s+t1)**(-1) - 384*s**(-1) )
      TB_GGH=TB_GGH + ANG4(19)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 256*ms1**2*s**(-2)*t1*u1**(-1) + 256*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) + 256*ms1**2*s**(-2)*s4*
     +    (s+u1)**(-1) + 1024*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 512*ms1**2*s**(-1)*t1**(-1) + 256*
     +    ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 512*ms1**2*s**(-1)*
     +    u1**(-1) + 1024*ms1**4*s**(-3)*t1**(-1)*u1 + 1024*ms1**4*
     +    s**(-3)*t1*u1**(-1) + 2048*ms1**4*s**(-3) - 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 1024*ms1**4*s**(-2)*t1**(-1) + 512
     +    *ms1**4*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 512*ms1**4*s**(-2)
     +    *u1**(-1)*s4*(s+u1)**(-1) + 1024*ms1**4*s**(-2)*u1**(-1) + 
     +    512*ms1**4*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*
     +    s**(-1)*t1**(-2) + 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-1)*u1**(-2) + 2048*ms1**6*
     +    s**(-4) )
      TB_GGH=TB_GGH + ANG4(19)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**6*
     +    s**(-3)*t1**(-1) + 1024*ms1**6*s**(-3)*u1**(-1) + 128*s**(-1)
     +    *t1**(-1)*u1 + 128*s**(-1)*t1*u1**(-1) + 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) + 256*s**(-1) + 
     +    128*t1**(-1) + 128*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(19)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) - 768*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*
     +    s**(-1)*u1**(-1) - 768*ms1**2*t1**(-1)*u1**(-1) - 512*ms1**4*
     +    s**(-3)*t1**(-1)*u1 - 512*ms1**4*s**(-3)*t1*u1**(-1) - 1024*
     +    ms1**4*s**(-3) - 1536*ms1**4*s**(-2)*t1**(-1) - 1536*ms1**4*
     +    s**(-2)*u1**(-1) - 1536*ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 
     +    1024*ms1**6*s**(-4) - 1024*ms1**6*s**(-3)*t1**(-1) - 1024*
     +    ms1**6*s**(-3)*u1**(-1) - 1024*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-1) - 128*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*t1*u1**(-1)
     +     - 256*s**(-1) - 128*s*t1**(-1)*u1**(-1) - 256*t1**(-1) - 256
     +    *u1**(-1) )
      TB_GGH=TB_GGH + ANG4(20)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*u1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) + 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) + 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1*u1**(-1)
     +     + 128*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*s**(-2)*
     +    t1**(-1) + 128*s**(-1)*t1**(-1)*u1**(-1) - 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(20)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    256*s**(-2)*t1**(-1) - 128*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(21)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) + 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) + 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1)*s4**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1**(-1)*u1
     +     - 128*s**(-3)*t1*s4**(-1) - 128*s**(-3) + 256*s**(-2)*
     +    u1**(-1) - 128*s**(-2)*s4**(-1) + 128*s**(-1)*t1**(-1)*
     +    u1**(-1) - 128*s**(-1)*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(21)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    128*s**(-2)*t1**(-1) - 256*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(36)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) - 1024*ms1**4*s**(-3) )
      TB_GGH=TB_GGH + ANG4(36)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1024*ms1**4*s**(-3) )
      TB_GGH=TB_GGH + ANG4(36)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) )
      TB_GGH=TB_GGH + ANG4(37)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-3)*t1*(t1+u1)**(-1) - 512*ms1**2*s**(-3) + 1024*ms1**2*
     +    s**(-2)*(t1+u1)**(-1) - 1024*ms1**4*s**(-3)*(t1+u1)**(-1) + 
     +    256*s**(-3)*t1 - 512*s**(-3)*t1**2*(t1+u1)**(-1) - 256*
     +    s**(-3)*u1 )
      TB_GGH=TB_GGH + ANG4(37)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1**(-1)*u1 - 256*ms1**2*s**(-3)*t1*u1**(-1) + 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3) + 512*ms1**2*
     +    s**(-2)*t1**(-1) + 768*ms1**2*s**(-2)*u1**(-1) - 2560*ms1**2*
     +    s**(-2)*s4**(-1) - 256*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 768
     +    *ms1**2*s**(-1)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*
     +    t1**(-1) - 512*ms1**4*s**(-3)*u1**(-1) + 4096*ms1**4*s**(-3)*
     +    s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 1024*ms1**4
     +    *s**(-2)*u1**(-1)*s4**(-1) + 128*s**(-2)*t1*u1**(-1) - 256*
     +    s**(-2)*t1*s4**(-1) - 128*s**(-2) - 128*s**(-1)*u1**(-1) + 
     +    256*s**(-1)*s4**(-1) + 128*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(37)*Cqed*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*t1**(-1) + 256*ms1**2*s**(-2)*u1**(-1) - 512*ms1**2*
     +    s**(-2)*s4**(-1) - 512*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 512
     +    *ms1**2*s**(-1)*u1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 
     +    128*s**(-2)*t1**(-1)*u1 + 128*s**(-2)*t1*u1**(-1) - 128*
     +    s**(-1)*t1**(-1) - 128*s**(-1)*u1**(-1) + 256*s**(-1)*
     +    s4**(-1) + 128*t1**(-1)*s4**(-1) + 128*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(38)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-4)*u1**2 - 1024*ms1**2*s**(-3)*u1 - 3072*ms1**2*s**(-2)
     +     )
      TB_GGH=TB_GGH + ANG4(39)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4)*t1 - 1024*ms1**2*s**(-4)*t1**2*s4**(-1) - 1024*ms1**2
     +    *s**(-4)*u1 + 256*ms1**2*s**(-3)*t1*u1**(-1) - 1024*ms1**2*
     +    s**(-3)*t1*s4**(-1) - 512*ms1**2*s**(-3)*t1*(t1+u1)**(-1) - 
     +    1280*ms1**2*s**(-3) - 256*ms1**2*s**(-2)*u1**(-1) - 1536*
     +    ms1**2*s**(-2)*s4**(-1) + 1024*ms1**2*s**(-2)*(t1+u1)**(-1)
     +     - 512*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**2*s**(-1)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1) + 1024*ms1**4
     +    *s**(-3)*s4**(-1) - 1024*ms1**4*s**(-3)*(t1+u1)**(-1) + 512*
     +    ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-1) + 128*s**(-3)*t1**(-1)*u1**2 + 384*s**(-3)*
     +    t1 + 256*s**(-3)*t1**2*u1**(-1) - 512*s**(-3)*t1**2*s4**(-1)
     +     - 512*s**(-3)*t1**2*(t1+u1)**(-1) - 512*s**(-3)*u1 - 512*
     +    s**(-2)*t1*s4**(-1) + 256*s**(-2) - 256*s**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(40)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*u1**(-1) - 512*ms1**6*s**(-2)*
     +    u1**(-2) )
      TB_GGH=TB_GGH + ANG4(40)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1536*ms1**4*s**(-2)*u1**(-1) + 1536*ms1**6*s**(-2)*
     +    u1**(-2) )
      TB_GGH=TB_GGH + ANG4(40)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*u1**(-1) - 512*ms1**6*s**(-2)*
     +    u1**(-2) )
      TB_GGH=TB_GGH + ANG4(41)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-2)*s4*(s+t1)**(-1) - 128*s**(-2)*t1*u1**(-1) - 256*
     +    s**(-2)*s4*(s+t1)**(-1) - 128*s**(-1)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(41)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1*u1**(-1) + 256*ms1**2*s**(-3)*t1*s4**(-1) - 512*
     +    ms1**2*s**(-3) + 512*ms1**2*s**(-2)*t1**(-1) + 512*ms1**2*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 768*ms1**2*s**(-2)*
     +    s4**(-1) + 768*ms1**2*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**2*
     +    s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*u1**(-1) - 512
     +    *ms1**4*s**(-3)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1) + 1024*ms1**4*s**(-2)*t1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-2)*u1**(-2)*s4*(s+t1)**(-1) + 1024*ms1**4*s**(-2)*
     +    u1**(-2) + 1536*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) + 1024*ms1**6*s**(-2)*
     +    t1**(-1)*u1**(-1)*s4**(-1) + 2048*ms1**6*s**(-2)*u1**(-2)*
     +    s4**(-1) - 256*s**(-2)*t1**(-1)*u1 - 256*s**(-2)*t1*s4**(-1)
     +     + 256*s**(-2)*s4*(s+t1)**(-1) + 128*s**(-1)*u1**(-1) - 256*
     +    s**(-1)*s4**(-1) + 128*t1**(-1)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(41)*Cqed*Pi**4*alphas**3 * (  - 1536*ms1**2*
     +    s**(-2)*t1**(-1) - 768*ms1**2*s**(-2)*u1**(-1) + 256*ms1**2*
     +    s**(-2)*s4**(-1) - 1024*ms1**2*s**(-1)*t1**(-1)*u1**(-1) + 
     +    768*ms1**2*s**(-1)*t1**(-1)*s4**(-1) - 1024*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-1) - 1536*ms1**4*s**(-2)*t1**(-1)*s4**(-1) - 
     +    512*ms1**4*s**(-2)*u1**(-2) - 1024*ms1**4*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    1024*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 1024*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-1) - 256*s**(-2)*t1**(-1)*u1 - 128*
     +    s**(-2)*t1*u1**(-1) - 256*s**(-2) - 256*s**(-1)*t1**(-1) - 
     +    384*s**(-1)*u1**(-1) - 128*s**(-1)*s4**(-1) - 256*t1**(-1)*
     +    u1**(-1) - 128*t1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(43)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**6*s**(-2)*
     +    t1**(-2) )
      TB_GGH=TB_GGH + ANG4(43)*Nc*Ck*Pi**4*alphas**3 * ( 768*ms1**2*
     +    s**(-2) + 1536*ms1**4*s**(-2)*t1**(-1) + 1536*ms1**6*s**(-2)*
     +    t1**(-2) )
      TB_GGH=TB_GGH + ANG4(43)*Cqed*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**6*s**(-2)*
     +    t1**(-2) )
      TB_GGH=TB_GGH + ANG4(44)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 128*s**(-2)*t1**(-1)*u1 - 256*
     +    s**(-2)*s4*(s+u1)**(-1) - 128*s**(-1)*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(44)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1**(-1)*u1 - 256*ms1**2*s**(-3)*t1*s4**(-1) - 256*
     +    ms1**2*s**(-3) + 512*ms1**2*s**(-2)*t1**(-1)*s4*(s+u1)**(-1)
     +     + 512*ms1**2*s**(-2)*u1**(-1) + 512*ms1**2*s**(-2)*s4**(-1)
     +     + 768*ms1**2*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**2*s**(-1)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-3)*t1**(-1) - 512*ms1**4*
     +    s**(-3)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 1024*ms1**4*s**(-2)*t1**(-2) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-1) + 1536*ms1**4*s**(-2)*t1**(-1)*
     +    s4**(-1) + 1024*ms1**4*s**(-2)*u1**(-1)*s4**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*u1**(-1)*s4**(-1) + 2048*ms1**6*s**(-2)*
     +    t1**(-2)*s4**(-1) + 1024*ms1**6*s**(-2)*t1**(-1)*u1**(-1)*
     +    s4**(-1) - 256*s**(-2)*t1*u1**(-1) + 256*s**(-2)*t1*s4**(-1)
     +     + 256*s**(-2)*s4*(s+u1)**(-1) - 256*s**(-2) + 128*s**(-1)*
     +    t1**(-1) + 128*t1**(-1)*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(44)*Cqed*Pi**4*alphas**3 * (  - 768*ms1**2*
     +    s**(-2)*t1**(-1) - 1536*ms1**2*s**(-2)*u1**(-1) + 256*ms1**2*
     +    s**(-2)*s4**(-1) - 1024*ms1**2*s**(-1)*t1**(-1)*u1**(-1) + 
     +    768*ms1**2*s**(-1)*u1**(-1)*s4**(-1) - 512*ms1**4*s**(-2)*
     +    t1**(-2) - 1024*ms1**4*s**(-2)*t1**(-1)*u1**(-1) - 1024*
     +    ms1**4*s**(-2)*t1**(-1)*s4**(-1) - 1536*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-1) - 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)*
     +    s4**(-1) - 1024*ms1**6*s**(-2)*t1**(-2)*s4**(-1) - 1024*
     +    ms1**6*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 128*s**(-2)*
     +    t1**(-1)*u1 - 256*s**(-2)*t1*u1**(-1) - 256*s**(-2) - 384*
     +    s**(-1)*t1**(-1) - 256*s**(-1)*u1**(-1) - 128*s**(-1)*
     +    s4**(-1) - 256*t1**(-1)*u1**(-1) - 128*u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(48)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) - 256*
     +    ms1**2*s**(-2)*s4*(s+t1)**(-1) - 256*ms1**2*s**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**2*s**(-2) - 256*ms1**2*s**(-1)*
     +    t1**(-1)*s4*(s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) - 256*
     +    ms1**2*s**(-1)*u1**(-1)*s4*(s+t1)**(-1) + 256*ms1**2*s**(-1)*
     +    u1**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*(s+u1)**(-1) + 512*
     +    ms1**4*s**(-1)*t1**(-2) - 512*ms1**4*s**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) - 512*s**(-3)*
     +    t1**(-1)*u1**3 - 1536*s**(-3)*t1*u1 - 1024*s**(-3)*t1**2 - 
     +    512*s**(-3)*t1**3*u1**(-1) - 1024*s**(-3)*u1**2 + 256*s**(-2)
     +    *t1**(-1)*u1**2*s4*(s+t1)**(-1) - 768*s**(-2)*t1**(-1)*u1**2
     +     - 256*s**(-2)*t1*s4*(s+u1)**(-1) - 1536*s**(-2)*t1 + 256*
     +    s**(-2)*t1**2*u1**(-1)*s4*(s+u1)**(-1) - 768*s**(-2)*t1**2*
     +    u1**(-1) - 256*s**(-2)*u1*s4*(s+t1)**(-1) - 1536*s**(-2)*u1
     +     - 384*s**(-1)*t1**(-1)*u1 )
      TB_GGH=TB_GGH + ANG4(48)*Nc*Co*Pi**4*alphas**3 * (  - 384*s**(-1)
     +    *t1*u1**(-1) - 128*s**(-1)*s4*(s+t1)**(-1) - 128*s**(-1)*s4*
     +    (s+u1)**(-1) - 768*s**(-1) - 128*t1**(-1) - 128*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(49)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*u1 - 256*ms1**2*s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2
     +    *s**(-1)*(t1+u1)**(-1) - 512*ms1**4*s**(-3)*t1**(-1)*u1 - 512
     +    *ms1**4*s**(-3) - 512*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*u1**(-1)*
     +    (t1+u1)**(-1) - 128*s**(-3)*t1*u1 + 128*s**(-3)*t1**2 - 256*
     +    s**(-3)*t1**3*(t1+u1)**(-1) - 256*s**(-2)*t1**2*(t1+u1)**(-1)
     +     - 128*s**(-1)*t1*(t1+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(49)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*s4*(s+t1)**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 512*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-1) - 512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) + 512*
     +    ms1**4*s**(-1)*u1**(-2) + 128*s**(-2)*t1**2*u1**(-1) + 128*
     +    s**(-2)*u1 + 128*s**(-1)*t1*u1**(-1) - 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(50)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1 + 256*ms1**2*s**(-2)*t1*(t1+u1)**(-1) - 256*ms1**2
     +    *s**(-2) - 256*ms1**2*s**(-1)*(t1+u1)**(-1) - 512*ms1**4*
     +    s**(-3)*t1*u1**(-1) - 512*ms1**4*s**(-3) - 512*ms1**4*s**(-2)
     +    *u1**(-1) - 512*ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 128*
     +    s**(-3)*t1*u1 - 256*s**(-3)*t1**2 + 256*s**(-3)*t1**3*
     +    (t1+u1)**(-1) - 128*s**(-3)*u1**2 + 256*s**(-2)*t1 - 256*
     +    s**(-2)*t1**2*(t1+u1)**(-1) - 256*s**(-2)*u1 + 128*s**(-1)*t1
     +    *(t1+u1)**(-1) - 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(50)*Nc*Ck*Pi**4*alphas**3 * ( 256*ms1**2*
     +    s**(-2)*s4*(s+u1)**(-1) - 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 512*ms1**2*s**(-1)*t1**(-1) + 512*ms1**4*
     +    s**(-2)*t1**(-1)*s4*(s+u1)**(-1) + 512*ms1**4*s**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*t1**(-2)*s4*
     +    (s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) + 512*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-2)*t1**(-1)*u1**2 + 128*
     +    s**(-2)*t1 + 128*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*s4*
     +    (s+u1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(51)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +     )
      TB_GGH=TB_GGH + ANG4(52)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-1) )
      TB_GGH=TB_GGH + ANG4(53)*Nc*Co*Pi**4*alphas**3 * (  - 2048*ms1**2
     +    *s**(-1)*t1*u1**(-1) - 1024*ms1**2*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(54)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1 - 1024*ms1**2*s**(-2)*t1*u1**(-1) - 256*
     +    ms1**2*s**(-2)*t1*s4**(-1) - 256*ms1**2*s**(-2)*t1*
     +    (t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) - 2304*
     +    ms1**2*s**(-2) - 256*ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*
     +    s**(-1)*t1*u1**(-2) + 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) - 1792*ms1**2*s**(-1)*u1**(-1) - 256*ms1**2*
     +    s**(-1)*(t1+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*u1**(-1)
     +     + 512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-2) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) + 512
     +    *ms1**4*s**(-1)*u1**(-1)*(t1+u1)**(-1) + 512*s**(-3)*t1**(-1)
     +    *u1**3 + 2048*s**(-3)*t1*u1 + 2048*s**(-3)*t1**2 + 1024*
     +    s**(-3)*t1**3*u1**(-1) - 256*s**(-3)*t1**3*s4**(-1) - 256*
     +    s**(-3)*t1**3*(t1+u1)**(-1) + 1536*s**(-3)*u1**2 - 256*
     +    s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) + 512*s**(-2)*t1**(-1)
     +    *u1**2 )
      TB_GGH=TB_GGH + ANG4(54)*Nc*Co*Pi**4*alphas**3 * ( 2048*s**(-2)*
     +    t1 + 1536*s**(-2)*t1**2*u1**(-1) - 512*s**(-2)*t1**2*s4**(-1)
     +     - 256*s**(-2)*t1**2*(t1+u1)**(-1) - 256*s**(-2)*u1*s4*
     +    (s+t1)**(-1) + 1280*s**(-2)*u1 + 128*s**(-1)*t1**(-1)*u1 + 
     +    512*s**(-1)*t1*u1**(-1) - 384*s**(-1)*t1*s4**(-1) - 128*
     +    s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*(s+t1)**(-1) + 384*
     +    s**(-1) - 128*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(55)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +     )
      TB_GGH=TB_GGH + ANG4(56)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-1) )
      TB_GGH=TB_GGH + ANG4(57)*Nc*Co*Pi**4*alphas**3 * (  - 2048*ms1**2
     +    *s**(-1)*t1**(-1)*u1 - 1024*ms1**2*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(58)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-2)*t1**(-1)*u1 - 256*ms1**2*s**(-2)*t1*u1**(-1) + 256*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 256*ms1**2*s**(-2)*t1*
     +    (t1+u1)**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) - 2816*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 256*ms1**2
     +    *s**(-1)*t1**(-1)*s4*(s+u1)**(-1) - 1792*ms1**2*s**(-1)*
     +    t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1) + 256*ms1**2*s**(-1)*
     +    s4**(-1) - 256*ms1**2*s**(-1)*(t1+u1)**(-1) + 512*ms1**4*
     +    s**(-1)*t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*
     +    t1**(-2) + 1024*ms1**4*s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4
     +    *s**(-1)*t1**(-1)*s4**(-1) - 512*ms1**4*s**(-1)*u1**(-1)*
     +    (t1+u1)**(-1) + 1024*s**(-3)*t1**(-1)*u1**3 + 2560*s**(-3)*t1
     +    *u1 + 1024*s**(-3)*t1**2 + 512*s**(-3)*t1**3*u1**(-1) + 256*
     +    s**(-3)*t1**3*s4**(-1) + 256*s**(-3)*t1**3*(t1+u1)**(-1) + 
     +    1536*s**(-3)*u1**2 + 1536*s**(-2)*t1**(-1)*u1**2 - 256*
     +    s**(-2)*t1*s4*(s+u1)**(-1) )
      TB_GGH=TB_GGH + ANG4(58)*Nc*Co*Pi**4*alphas**3 * ( 1536*s**(-2)*
     +    t1 - 256*s**(-2)*t1**2*u1**(-1)*s4*(s+u1)**(-1) + 512*s**(-2)
     +    *t1**2*u1**(-1) + 256*s**(-2)*t1**2*s4**(-1) - 256*s**(-2)*
     +    t1**2*(t1+u1)**(-1) + 1536*s**(-2)*u1 + 512*s**(-1)*t1**(-1)*
     +    u1 + 128*s**(-1)*t1*u1**(-1) + 128*s**(-1)*t1*s4**(-1) + 128*
     +    s**(-1)*t1*(t1+u1)**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) + 128*
     +    s**(-1) )
      TB_GGH=TB_GGH + ANG4(59)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1**2 )
      TB_GGH=TB_GGH + ANG4(59)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**2 )
      TB_GGH=TB_GGH + ANG4(60)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1 - 1024*ms1**4*s**(-2) )
      TB_GGH=TB_GGH + ANG4(60)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1 + 1024*ms1**4*s**(-2) )
      TB_GGH=TB_GGH + ANG4(61)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-1)*t1*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(61)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**2*u1**(-1) + 1024*ms1**2*s**(-1)*t1*u1**(-1) )
      TB_GGH=TB_GGH + ANG4(62)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1 - 256*ms1**2*s**(-3)*u1 - 512*ms1**2*s**(-2)*t1*
     +    u1**(-1) - 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*
     +    s**(-2) - 256*ms1**2*s**(-1)*t1**(-1)*s4*(s+u1)**(-1) + 256*
     +    ms1**2*s**(-1)*t1**(-1) - 1024*ms1**2*s**(-1)*t1*u1**(-2) - 
     +    512*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*s**(-3)*t1**(-1)*u1
     +     + 1024*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*s**(-1)*t1**(-2)
     +    *s4*(s+u1)**(-1) + 512*ms1**4*s**(-1)*t1**(-2) + 1024*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-3)*t1*u1 + 256*s**(-3)*
     +    t1**2 + 256*s**(-3)*t1**3*u1**(-1) - 256*s**(-2)*t1*s4*
     +    (s+u1)**(-1) + 640*s**(-2)*t1 + 256*s**(-2)*t1**2*u1**(-1)*s4
     +    *(s+u1)**(-1) + 768*s**(-2)*t1**2*u1**(-1) + 512*s**(-1)*t1*
     +    u1**(-1) - 128*s**(-1)*s4*(s+u1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(62)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1*u1**(-1) + 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) + 
     +    768*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 256*ms1**2*s**(-1)*u1**(-1) + 256*ms1**2*
     +    s**(-1)*s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*s4*
     +    (s+t1)**(-1) - 512*ms1**4*s**(-2)*t1**(-1) + 512*ms1**4*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 1536*ms1**4*s**(-2)*
     +    u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) - 1024*ms1**4*s**(-1)*
     +    t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*t1**(-1)*s4**(-1) + 
     +    512*ms1**4*s**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 512*ms1**4*
     +    s**(-1)*u1**(-2) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 384
     +    *s**(-2)*t1 - 512*s**(-2)*t1**2*u1**(-1) + 128*s**(-2)*t1**2*
     +    s4**(-1) - 128*s**(-2)*u1 - 512*s**(-1)*t1*u1**(-1) + 128*
     +    s**(-1)*t1*s4**(-1) + 128*s**(-1)*s4*(s+t1)**(-1) - 128*
     +    s**(-1) )
      TB_GGH=TB_GGH + ANG4(63)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*u1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) - 512*ms1**4*
     +    s**(-3)*u1**(-1)*s4**(-1) - 128*s**(-3)*t1*u1**(-1) + 128*
     +    s**(-3)*t1*s4**(-1) - 256*s**(-3) - 128*s**(-2)*u1**(-1) + 
     +    128*s**(-2)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(63)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*t1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    256*s**(-2)*t1**(-1) - 128*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    t1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(64)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*u1**2 )
      TB_GGH=TB_GGH + ANG4(64)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*u1**2 )
      TB_GGH=TB_GGH + ANG4(65)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*u1 - 1024*ms1**4*s**(-2) )
      TB_GGH=TB_GGH + ANG4(65)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*u1 + 1024*ms1**4*s**(-2) )
      TB_GGH=TB_GGH + ANG4(66)*Nc*Co*Pi**4*alphas**3 * (  - 1024*ms1**2
     +    *s**(-1)*t1**(-1)*u1 )
      TB_GGH=TB_GGH + ANG4(66)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**(-1)*u1**2 + 1024*ms1**2*s**(-1)*t1**(-1)*u1 )
      TB_GGH=TB_GGH + ANG4(67)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1 - 256*ms1**2*s**(-3)*u1 - 512*ms1**2*s**(-2)*
     +    t1**(-1)*u1 - 256*ms1**2*s**(-2)*s4*(s+t1)**(-1) - 1024*
     +    ms1**2*s**(-2) - 1024*ms1**2*s**(-1)*t1**(-2)*u1 - 512*ms1**2
     +    *s**(-1)*t1**(-1) - 256*ms1**2*s**(-1)*u1**(-1)*s4*
     +    (s+t1)**(-1) + 256*ms1**2*s**(-1)*u1**(-1) + 512*ms1**4*
     +    s**(-3)*t1*u1**(-1) + 1024*ms1**4*s**(-2)*u1**(-1) + 1024*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-1) - 512*ms1**4*s**(-1)*
     +    u1**(-2)*s4*(s+t1)**(-1) + 512*ms1**4*s**(-1)*u1**(-2) + 256*
     +    s**(-3)*t1**(-1)*u1**3 + 128*s**(-3)*t1*u1 + 256*s**(-3)*
     +    u1**2 + 256*s**(-2)*t1**(-1)*u1**2*s4*(s+t1)**(-1) + 768*
     +    s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*u1*s4*(s+t1)**(-1) + 640
     +    *s**(-2)*u1 + 512*s**(-1)*t1**(-1)*u1 - 128*s**(-1)*s4*
     +    (s+t1)**(-1) + 128*s**(-1) )
      TB_GGH=TB_GGH + ANG4(67)*Nc*Ck*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*t1**(-1)*u1 + 256*ms1**2*s**(-2)*s4*(s+u1)**(-1) + 
     +    768*ms1**2*s**(-2) + 256*ms1**2*s**(-1)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 256*ms1**2*s**(-1)*t1**(-1) + 256*ms1**2*
     +    s**(-1)*s4**(-1) + 512*ms1**4*s**(-2)*t1**(-1)*s4*
     +    (s+u1)**(-1) + 1536*ms1**4*s**(-2)*t1**(-1) - 512*ms1**4*
     +    s**(-2)*u1**(-1)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-2)*
     +    u1**(-1) + 512*ms1**4*s**(-2)*s4**(-1) + 512*ms1**4*s**(-1)*
     +    t1**(-2)*s4*(s+u1)**(-1) - 512*ms1**4*s**(-1)*t1**(-2) - 1024
     +    *ms1**4*s**(-1)*t1**(-1)*u1**(-1) + 512*ms1**4*s**(-1)*
     +    t1**(-1)*s4**(-1) + 512*ms1**4*s**(-1)*u1**(-1)*s4**(-1) - 
     +    512*s**(-2)*t1**(-1)*u1**2 - 256*s**(-2)*t1 + 128*s**(-2)*
     +    t1**2*s4**(-1) - 256*s**(-2)*u1 - 512*s**(-1)*t1**(-1)*u1 + 
     +    128*s**(-1)*t1*s4**(-1) + 128*s**(-1)*s4*(s+u1)**(-1) - 128*
     +    s**(-1) )
      TB_GGH=TB_GGH + ANG4(68)*Nc*Co*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-3)*t1**(-1) - 256*ms1**2*s**(-3)*s4**(-1) - 512*ms1**4*
     +    s**(-3)*t1**(-1)*s4**(-1) - 128*s**(-3)*t1**(-1)*u1 - 128*
     +    s**(-3)*t1*s4**(-1) - 128*s**(-3) - 128*s**(-2)*t1**(-1) )
      TB_GGH=TB_GGH + ANG4(68)*Nc*Ck*Pi**4*alphas**3 * (  - 256*ms1**2*
     +    s**(-2)*t1**(-1)*u1**(-1) - 256*ms1**2*s**(-2)*u1**(-1)*
     +    s4**(-1) - 512*ms1**4*s**(-2)*t1**(-1)*u1**(-1)*s4**(-1) - 
     +    128*s**(-2)*t1**(-1) - 256*s**(-2)*u1**(-1) + 128*s**(-2)*
     +    s4**(-1) - 128*s**(-1)*t1**(-1)*u1**(-1) + 128*s**(-1)*
     +    u1**(-1)*s4**(-1) )
      TB_GGH=TB_GGH + ANG4(70)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1**2*u1**(-2) - 1024*ms1**2*s**(-1)*t1*u1**(-2) - 
     +    512*ms1**2*u1**(-2) )
      TB_GGH=TB_GGH + ANG4(70)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**2*u1**(-2) + 1024*ms1**2*s**(-1)*t1*u1**(-2) + 
     +    512*ms1**2*u1**(-2) )
      TB_GGH=TB_GGH + ANG4(71)*Nc*Co*Pi**4*alphas**3 * (  - 512*ms1**2*
     +    s**(-2)*t1**(-2)*u1**2 - 1024*ms1**2*s**(-1)*t1**(-2)*u1 - 
     +    512*ms1**2*t1**(-2) )
      TB_GGH=TB_GGH + ANG4(71)*Nc*Ck*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2)*t1**(-2)*u1**2 + 1024*ms1**2*s**(-1)*t1**(-2)*u1 + 
     +    512*ms1**2*t1**(-2) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-4)*t1**(-2)*u1**2 - 4096*ms1**2*s**(-4)*t1*s4**(-1) + 
     +    2048*ms1**2*s**(-4)*t1**2*u1**(-2) + 4096*ms1**2*s**(-4)*
     +    t1**2*s4**(-2) + 6144*ms1**2*s**(-4) - 4096*ms1**2*s**(-3)*
     +    t1**(-3)*u1**2 - 2048*ms1**2*s**(-3)*t1**(-2)*u1 - 14336*
     +    ms1**2*s**(-3)*t1**(-1) - 2048*ms1**2*s**(-3)*t1*u1**(-2) + 
     +    4096*ms1**2*s**(-3)*t1*s4**(-2) - 4096*ms1**2*s**(-3)*t1**2*
     +    u1**(-3) - 14336*ms1**2*s**(-3)*u1**(-1) + 6144*ms1**2*
     +    s**(-3)*s4**(-1) - 8192*ms1**2*s**(-2)*t1**(-3)*u1 - 4096*
     +    ms1**2*s**(-2)*t1**(-2)*s4*(s+u1)**(-1) + 1024*ms1**2*s**(-2)
     +    *t1**(-2)*s4**2*(s+u1)**(-2) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+t1)**(-1) + 6144*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4*(s+u1)**(-1) - 16384*ms1**2*s**(-2)*t1**(-1)*
     +    u1**(-1) + 8192*ms1**2*s**(-2)*t1**(-1)*s4**(-1) - 8192*
     +    ms1**2*s**(-2)*t1*u1**(-3) - 4096*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-2)*u1**(-2)*s4**2*(s+t1)**(-2) + 8192*ms1**2*s**(-2)*
     +    u1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*s4**(-2) - 6144*
     +    ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**2*(s+t1)**(-2) + 4096*ms1**2*s**(-1)*t1**(-1)*
     +    u1**(-1)*s4**(-1) - 6144*ms1**2*s**(-1)*u1**(-3) - 2048*
     +    ms1**2*t1**(-3)*u1**(-1) - 2048*ms1**2*t1**(-1)*u1**(-3) - 
     +    4096*ms1**4*s**(-3)*t1**(-3)*u1 - 12288*ms1**4*s**(-3)*
     +    t1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*t1*u1**(-3) - 12288*
     +    ms1**4*s**(-3)*u1**(-1)*s4**(-1) + 8192*ms1**4*s**(-3)*
     +    s4**(-2) + 4096*ms1**4*s**(-2)*t1**(-4)*u1 + 2048*ms1**4*
     +    s**(-2)*t1**(-3)*s4*(s+u1)**(-1) - 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 8192*ms1**4*s**(-2)*t1**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) + 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2)*s4*(s+t1)**(-1) - 4096*ms1**4*
     +    s**(-2)*t1**(-1)*u1**(-2) - 16384*ms1**4*s**(-2)*t1**(-1)*
     +    u1**(-1)*s4**(-1) + 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) + 
     +    4096*ms1**4*s**(-2)*t1*u1**(-4) + 2048*ms1**4*s**(-2)*
     +    u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*s**(-2)*u1**(-3) + 
     +    2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    u1**(-1)*s4**(-2) + 8192*ms1**4*s**(-1)*t1**(-4) + 6144*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) - 2048*
     +    ms1**4*s**(-1)*t1**(-3)*u1**(-1) + 4096*ms1**4*s**(-1)*
     +    t1**(-2)*u1**(-2) - 2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*
     +    s4**(-1) + 6144*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**4*s**(-1)*t1**(-1)*u1**(-3) - 2048*
     +    ms1**4*s**(-1)*t1**(-1)*u1**(-2)*s4**(-1) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 8192*ms1**4*
     +    s**(-1)*u1**(-4) + 2048*ms1**4*s*t1**(-4)*u1**(-2) + 2048*
     +    ms1**4*s*t1**(-2)*u1**(-4) + 6144*ms1**4*t1**(-4)*u1**(-1) - 
     +    2048*ms1**4*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 2048*ms1**4*
     +    t1**(-3)*u1**(-2)*s4**2*(s+u1)**(-2) + 2048*ms1**4*t1**(-3)*
     +    u1**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 
     +    2048*ms1**4*t1**(-2)*u1**(-3)*s4**2*(s+t1)**(-2) + 2048*
     +    ms1**4*t1**(-2)*u1**(-3) + 6144*ms1**4*t1**(-1)*u1**(-4) - 
     +    4096*ms1**6*s**(-2)*t1**(-4)*s4*(s+u1)**(-1) + 2048*ms1**6*
     +    s**(-2)*t1**(-4)*s4**2*(s+u1)**(-2) + 6144*ms1**6*s**(-2)*
     +    t1**(-4) + 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-2)*t1**(-3)*u1**(-1) + 4096*
     +    ms1**6*s**(-2)*t1**(-2)*u1**(-2) - 8192*ms1**6*s**(-2)*
     +    t1**(-2)*u1**(-1)*s4**(-1) + 4096*ms1**6*s**(-2)*t1**(-2)*
     +    s4**(-2) + 4096*ms1**6*s**(-2)*t1**(-1)*u1**(-3)*s4*
     +    (s+t1)**(-1) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * (  - 4096*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-3) - 8192*ms1**6*s**(-2)*t1**(-1)*
     +    u1**(-2)*s4**(-1) - 4096*ms1**6*s**(-2)*u1**(-4)*s4*
     +    (s+t1)**(-1) + 2048*ms1**6*s**(-2)*u1**(-4)*s4**2*
     +    (s+t1)**(-2) + 6144*ms1**6*s**(-2)*u1**(-4) + 4096*ms1**6*
     +    s**(-2)*u1**(-2)*s4**(-2) + 4096*ms1**6*s**(-1)*t1**(-4)*
     +    u1**(-1) + 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2) + 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 4096*
     +    ms1**6*s**(-1)*t1**(-2)*u1**(-3) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-2)*s4**(-1) + 4096*ms1**6*s**(-1)*t1**(-1)*
     +    u1**(-4) + 2048*ms1**6*t1**(-4)*u1**(-2) + 2048*ms1**6*
     +    t1**(-2)*u1**(-4) + 2048*s**(-4)*t1**(-2)*u1**3 + 2048*
     +    s**(-4)*t1**(-1)*u1**2 + 2048*s**(-4)*t1 + 2048*s**(-4)*t1**2
     +    *u1**(-1) + 4096*s**(-4)*t1**2*s4**(-1) + 2048*s**(-4)*t1**3*
     +    u1**(-2) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Co*Pi**4*alphas**3 * ( 6144*s**(-4)*
     +    u1 + 4096*s**(-3)*t1**(-2)*u1**2 + 4096*s**(-3)*t1*s4**(-1)
     +     + 4096*s**(-3)*t1**2*u1**(-2) + 3072*s**(-2)*t1**(-2)*u1 + 
     +    2048*s**(-2)*t1**(-1)*s4*(s+t1)**(-1) - 1024*s**(-2)*t1**(-1)
     +    *s4*(s+u1)**(-1) + 1024*s**(-2)*t1**(-1)*s4**2*(s+u1)**(-2)
     +     - 1024*s**(-2)*t1**(-1) + 3072*s**(-2)*t1*u1**(-2) - 1024*
     +    s**(-2)*u1**(-1)*s4*(s+t1)**(-1) + 2048*s**(-2)*u1**(-1)*s4*
     +    (s+u1)**(-1) + 1024*s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 
     +    1024*s**(-2)*u1**(-1) + 2048*s**(-2)*s4**(-1) + 1024*s**(-1)*
     +    t1**(-2) + 1024*s**(-1)*u1**(-2) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * ( 2048*ms1**2*
     +    s**(-2)*t1**(-2)*s4*(s+u1)**(-1) - 1024*ms1**2*s**(-2)*
     +    t1**(-2)*s4**2*(s+u1)**(-2) - 2048*ms1**2*s**(-2)*t1**(-2) + 
     +    4096*ms1**2*s**(-2)*t1**(-1)*u1**(-1) - 4096*ms1**2*s**(-2)*
     +    t1**(-1)*s4**(-1) + 2048*ms1**2*s**(-2)*u1**(-2)*s4*
     +    (s+t1)**(-1) - 1024*ms1**2*s**(-2)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) - 2048*ms1**2*s**(-2)*u1**(-2) - 4096*ms1**2*
     +    s**(-2)*u1**(-1)*s4**(-1) - 2048*ms1**2*s**(-2)*s4**(-2) + 
     +    2048*ms1**2*s**(-1)*t1**(-3) - 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1)*s4**2*(s+u1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-2)*
     +    u1**(-1) - 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4*
     +    (s+t1)**(-1) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2)*s4**2*
     +    (s+t1)**(-2) + 2048*ms1**2*s**(-1)*t1**(-1)*u1**(-2) + 2048*
     +    ms1**2*s**(-1)*u1**(-3) + 2048*ms1**2*t1**(-3)*u1**(-1) + 
     +    2048*ms1**2*t1**(-1)*u1**(-3) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**4
     +    *s**(-2)*t1**(-3)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-2)*
     +    t1**(-3) + 4096*ms1**4*s**(-2)*t1**(-2)*u1**(-1) - 2048*
     +    ms1**4*s**(-2)*t1**(-2)*s4**(-1) + 4096*ms1**4*s**(-2)*
     +    t1**(-1)*u1**(-2) - 4096*ms1**4*s**(-2)*t1**(-1)*s4**(-2) - 
     +    2048*ms1**4*s**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-2)*u1**(-3) - 2048*ms1**4*s**(-2)*u1**(-2)*s4**(-1) - 
     +    4096*ms1**4*s**(-2)*u1**(-1)*s4**(-2) - 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4*(s+u1)**(-1) + 2048*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1)*s4**2*(s+u1)**(-2) + 6144*ms1**4*s**(-1)*
     +    t1**(-3)*u1**(-1) - 4096*ms1**4*s**(-1)*t1**(-2)*u1**(-2) + 
     +    2048*ms1**4*s**(-1)*t1**(-2)*u1**(-1)*s4**(-1) - 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4*(s+t1)**(-1) + 2048*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3)*s4**2*(s+t1)**(-2) + 6144*ms1**4*
     +    s**(-1)*t1**(-1)*u1**(-3) + 2048*ms1**4*s**(-1)*t1**(-1)*
     +    u1**(-2)*s4**(-1) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**4
     +    *s*t1**(-4)*u1**(-2) - 2048*ms1**4*s*t1**(-2)*u1**(-4) - 2048
     +    *ms1**4*t1**(-4)*u1**(-1) + 2048*ms1**4*t1**(-3)*u1**(-2)*s4*
     +    (s+u1)**(-1) - 2048*ms1**4*t1**(-3)*u1**(-2)*s4**2*
     +    (s+u1)**(-2) - 2048*ms1**4*t1**(-3)*u1**(-2) + 2048*ms1**4*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) - 2048*ms1**4*t1**(-2)*
     +    u1**(-3)*s4**2*(s+t1)**(-2) - 2048*ms1**4*t1**(-2)*u1**(-3)
     +     - 2048*ms1**4*t1**(-1)*u1**(-4) + 4096*ms1**6*s**(-2)*
     +    t1**(-4)*s4*(s+u1)**(-1) - 2048*ms1**6*s**(-2)*t1**(-4)*s4**2
     +    *(s+u1)**(-2) - 2048*ms1**6*s**(-2)*t1**(-4) - 4096*ms1**6*
     +    s**(-2)*t1**(-2)*u1**(-2) + 12288*ms1**6*s**(-2)*t1**(-2)*
     +    u1**(-1)*s4**(-1) - 4096*ms1**6*s**(-2)*t1**(-2)*s4**(-2) + 
     +    12288*ms1**6*s**(-2)*t1**(-1)*u1**(-2)*s4**(-1) - 8192*ms1**6
     +    *s**(-2)*t1**(-1)*u1**(-1)*s4**(-2) + 4096*ms1**6*s**(-2)*
     +    u1**(-4)*s4*(s+t1)**(-1) - 2048*ms1**6*s**(-2)*u1**(-4)*s4**2
     +    *(s+t1)**(-2) )
      TB_GGH=TB_GGH + COLO1(9)*Nc*Ck*Pi**4*alphas**3 * (  - 2048*ms1**6
     +    *s**(-2)*u1**(-4) - 4096*ms1**6*s**(-2)*u1**(-2)*s4**(-2) - 
     +    4096*ms1**6*s**(-1)*t1**(-3)*u1**(-2)*s4*(s+u1)**(-1) + 4096*
     +    ms1**6*s**(-1)*t1**(-3)*u1**(-2) - 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3)*s4*(s+t1)**(-1) + 4096*ms1**6*s**(-1)*
     +    t1**(-2)*u1**(-3) + 4096*ms1**6*s**(-1)*t1**(-2)*u1**(-2)*
     +    s4**(-1) - 2048*ms1**6*t1**(-4)*u1**(-2) - 2048*ms1**6*
     +    t1**(-2)*u1**(-4) - 1024*s**(-2)*t1**(-2)*u1 + 1024*s**(-2)*
     +    t1**(-1)*s4*(s+u1)**(-1) - 1024*s**(-2)*t1**(-1)*s4**2*
     +    (s+u1)**(-2) - 1024*s**(-2)*t1**(-1) - 1024*s**(-2)*t1*
     +    u1**(-2) + 1024*s**(-2)*u1**(-1)*s4*(s+t1)**(-1) - 1024*
     +    s**(-2)*u1**(-1)*s4**2*(s+t1)**(-2) - 1024*s**(-2)*u1**(-1)
     +     - 2048*s**(-2)*s4**(-1) - 1024*s**(-1)*t1**(-2) - 1024*
     +    s**(-1)*u1**(-2) )


      TB_GGH = fac * TB_GGH 
ctp      TB_GGH = fac * 389379660.D0 * TB_GGH 

      end







