cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c     THE SCALING FUNCTIONS                                            c
c                                                                      c
c     HT_QGH(MASSIN,C)                                                 c
c                                                                      c
c     INPUT :                                                          c
c                                                                      c
c       MASSIN(1)  = s                                                 c
c       MASSIN(2)  = t2                                                c
c       MASSIN(3)  = s4                                                c
c       MASSIN(6)  = m1                                                c
c       MASSIN(7)  = m2                                                c
c       MASSIN(9)  = mt                                                c
c       MASSIN(11) = ms                                                c
c       MASSIN(12) = qr                                                c
c       MASSIN(13) = qf                                                c
c       MASSIN(4-5,8,10,13-30) not needed                              c
c                                                                      c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c --------------------------------------------------------------------
      real*8 function HT_QGH(massin,h_l,h_r,lumi)

      implicit none 

      real*8     massin(1:30),lumi(1:3),Pi,Nc,Cf,h_l,h_r,h_l2,h_r2
     &          ,qf,log_qf,log_all,s,s4,m1,m2,m12,t2,u2,t2t,u2t
     &          ,hardfac,mjs2,alphas
     &          ,MM_real_4,ANG_fin(0:9,0:9,-2:2,-2:2)

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0 
      Cf = 4.D0/3.D0

      h_l2 = h_l**2
      h_r2 = h_r**2

      s   = massin(1)
      t2  = massin(2)
      s4  = massin(3)
      m1  = massin(6)
      m2  = massin(7)

c               real kinematics built in
      u2  = s4 - s - t2 - m2**2 + m1**2 

      m12 = m1**2
      t2t = t2 + m2**2 - m1**2 
      u2t = u2 + m2**2 - m1**2 

      hardfac = 1.D0
      mjs2 = m2**2 - m1**2

c               the angular functions 
      call ANGULAR_ARRAY_HT_QG(massin,ANG_fin)

c               the factorization/renormalization scale 
      qf = massin(13) 
      log_qf  = log(qf**2/m1**2)
      log_all = log_qf - log(s4/m1**2) + log(1.D0+m1**2/s4)

c               gs**2=4*pi*alpha_s is cut, re-appears as nlo later 
      alphas = 1.D0

      MM_real_4 = 0.D0

      MM_real_4 =
     +  + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*Pi**3*alphas**2*
     + hardfac*log_all * (  - 128*(s+u2)**(-2)*s**(-1)*t2*u2**2 - 128*
     +    (s+u2)**(-2)*s*t2 - 256*(s+u2)**(-2)*t2*u2 - 256*(s+u2)**(-1)
     +    *(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s*t2*u2 - 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s**2*t2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**4*s*u2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**4*s**2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s*t2**2*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s**2*t2**2 + 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*m2**2*s*u2 + 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*m2**2*s**2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s*t2*u2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s**2*t2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**6*s*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**6*s**2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s*t2**2*u2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * ( 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*t2**2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**4*s*t2*u2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**4*s**2*t2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**6*s*u2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**6*s**2 + 384*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s + 384*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*u2 + 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s*t2 + 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2*u2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*s - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*u2 - 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*s*t2 - 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*t2*u2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*s )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * (  - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*s*t2**2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*t2**2*u2 + 256*(s+u2)**(-1)*m1**2*
     +    s**(-1)*u2 + 256*(s+u2)**(-1)*m1**2 - 256*(s+u2)**(-1)*m2**2*
     +    s**(-1)*u2 - 256*(s+u2)**(-1)*m2**2 + 64*(s+u2)**(-1)*s**(-1)
     +    *t2*u2 + 64*(s+u2)**(-1)*t2 + 256*(t2*u2-mjs2*s)**(-2)*m1**2*
     +    m2**2*s*t2 + 384*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s*u2**2*
     +    t2t**(-1) + 384*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s**2*u2*
     +    t2t**(-1) + 128*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s**3*
     +    t2t**(-1) + 256*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*t2*u2 + 128*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*u2**3*t2t**(-1) + 128*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**4*s + 128*(t2*u2-mjs2*s)**(-2)
     +    *m1**2*m2**4*u2 + 192*(t2*u2-mjs2*s)**(-2)*m1**2*s*t2*u2**2*
     +    t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * ( 64*(t2*u2-mjs2*s)**(-2)*
     +    m1**2*s*t2**2 - 64*(t2*u2-mjs2*s)**(-2)*m1**2*s*u2**2 + 192*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s**2*t2*u2*t2t**(-1) - 128*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s**2*u2 + 64*(t2*u2-mjs2*s)**(-2)*
     +    m1**2*s**3*t2*t2t**(-1) - 64*(t2*u2-mjs2*s)**(-2)*m1**2*s**3
     +     + 64*(t2*u2-mjs2*s)**(-2)*m1**2*t2*u2**3*t2t**(-1) + 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*t2**2*u2 - 256*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*m2**2*s - 256*(t2*u2-mjs2*s)**(-2)
     +    *m1**4*m2**2*u2 - 192*(t2*u2-mjs2*s)**(-2)*m1**4*s*t2 - 384*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s*u2**2*t2t**(-1) - 384*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s**2*u2*t2t**(-1) - 128*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s**3*t2t**(-1) - 192*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*t2*u2 - 128*(t2*u2-mjs2*s)**(-2)*
     +    m1**4*u2**3*t2t**(-1) + 128*(t2*u2-mjs2*s)**(-2)*m1**6*s + 
     +    128*(t2*u2-mjs2*s)**(-2)*m1**6*u2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * (  - 192*(t2*u2-mjs2*s)**(-2)*
     +    m2**2*s*t2*u2**2*t2t**(-1) - 64*(t2*u2-mjs2*s)**(-2)*m2**2*s*
     +    t2**2 + 64*(t2*u2-mjs2*s)**(-2)*m2**2*s*u2**2 - 192*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*t2*u2*t2t**(-1) + 128*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*u2 - 64*(t2*u2-mjs2*s)**(-2)*
     +    m2**2*s**3*t2*t2t**(-1) + 64*(t2*u2-mjs2*s)**(-2)*m2**2*s**3
     +     - 64*(t2*u2-mjs2*s)**(-2)*m2**2*t2*u2**3*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*t2**2*u2 - 64*(t2*u2-mjs2*s)**(-2)
     +    *m2**4*s*t2 - 64*(t2*u2-mjs2*s)**(-2)*m2**4*t2*u2 + 256*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s**(-1)*u2 + 256*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s**(-1)*u2**3*t2t**(-2) + 
     +    768*(t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s*u2*t2t**(-2) + 256*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s**2*t2t**(-2) + 768*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*u2**2*t2t**(-2) + 256*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * (  - 128*(t2*u2-mjs2*s)**(-1)*
     +    m1**2*s**(-1)*t2*u2 - 128*(t2*u2-mjs2*s)**(-1)*m1**2*s**(-1)*
     +    t2*u2**3*t2t**(-2) - 384*(t2*u2-mjs2*s)**(-1)*m1**2*s*t2*u2*
     +    t2t**(-2) + 384*(t2*u2-mjs2*s)**(-1)*m1**2*s*u2*t2t**(-1) - 
     +    128*(t2*u2-mjs2*s)**(-1)*m1**2*s**2*t2*t2t**(-2) + 192*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s**2*t2t**(-1) - 384*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2*u2**2*t2t**(-2) - 128*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2 + 192*(t2*u2-mjs2*s)**(-1)*
     +    m1**2*u2**2*t2t**(-1) - 128*(t2*u2-mjs2*s)**(-1)*m1**4*
     +    s**(-1)*u2 - 128*(t2*u2-mjs2*s)**(-1)*m1**4*s**(-1)*u2**3*
     +    t2t**(-2) - 384*(t2*u2-mjs2*s)**(-1)*m1**4*s*u2*t2t**(-2) - 
     +    128*(t2*u2-mjs2*s)**(-1)*m1**4*s**2*t2t**(-2) - 384*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*u2**2*t2t**(-2) - 128*
     +    (t2*u2-mjs2*s)**(-1)*m1**4 + 128*(t2*u2-mjs2*s)**(-1)*m2**2*
     +    s**(-1)*t2*u2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * ( 128*(t2*u2-mjs2*s)**(-1)*
     +    m2**2*s**(-1)*t2*u2**3*t2t**(-2) + 384*(t2*u2-mjs2*s)**(-1)*
     +    m2**2*s*t2*u2*t2t**(-2) - 384*(t2*u2-mjs2*s)**(-1)*m2**2*s*u2
     +    *t2t**(-1) + 128*(t2*u2-mjs2*s)**(-1)*m2**2*s**2*t2*t2t**(-2)
     +     - 192*(t2*u2-mjs2*s)**(-1)*m2**2*s**2*t2t**(-1) + 384*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*t2*u2**2*t2t**(-2) + 128*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*t2 - 192*(t2*u2-mjs2*s)**(-1)*
     +    m2**2*u2**2*t2t**(-1) - 128*(t2*u2-mjs2*s)**(-1)*m2**4*
     +    s**(-1)*u2 - 128*(t2*u2-mjs2*s)**(-1)*m2**4*s**(-1)*u2**3*
     +    t2t**(-2) - 384*(t2*u2-mjs2*s)**(-1)*m2**4*s*u2*t2t**(-2) - 
     +    128*(t2*u2-mjs2*s)**(-1)*m2**4*s**2*t2t**(-2) - 384*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*u2**2*t2t**(-2) - 128*
     +    (t2*u2-mjs2*s)**(-1)*m2**4 - 128*(t2*u2-mjs2*s)**(-1)*s*t2*u2
     +    *t2t**(-1) - 64*(t2*u2-mjs2*s)**(-1)*s**2*t2*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-1)*t2*u2**2*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * ( 256*m1**2*s**(-1)*u2**2*
     +    t2t**(-2) + 128*m1**2*s*t2t**(-2) + 384*m1**2*u2*t2t**(-2) - 
     +    256*m2**2*s**(-1)*u2**2*t2t**(-2) - 128*m2**2*s*t2t**(-2) - 
     +    384*m2**2*u2*t2t**(-2) - 64*s**(-1)*t2*u2**2*t2t**(-2) + 64*s
     +    *t2*t2t**(-2) - 128*s*t2t**(-1) - 128*u2*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac * (  - 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s*t2*u2 - 256*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s**2*t2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**4*s*u2 - 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**4*s**2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s*t2**2*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s**2*t2**2 + 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*m2**2*s*u2 + 192*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*m2**2*s**2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s*t2*u2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s**2*t2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**6*s*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m1**6*s**2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s*t2**2*u2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*t2**2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac * ( 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**4*s*t2*u2 + 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**4*s**2*t2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**6*s*u2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-2)*m2**6*s**2 - 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*s - 128*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*u2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*s + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*u2 + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*s + 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*u2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*s*t2**2 - 64*(s+u2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*t2**2*u2 - 64*(s+u2)**(-1)*s**(-1)*t2*u2
     +     - 64*(s+u2)**(-1)*t2 + 128*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*
     +    s*t2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac * ( 128*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2
     +    *t2*u2 + 192*(t2*u2-mjs2*s)**(-2)*m1**2*s*t2*u2**2*t2t**(-1)
     +     + 64*(t2*u2-mjs2*s)**(-2)*m1**2*s*t2**2 - 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*s*u2**2 + 192*(t2*u2-mjs2*s)**(-2)
     +    *m1**2*s**2*t2*u2*t2t**(-1) - 128*(t2*u2-mjs2*s)**(-2)*m1**2*
     +    s**2*u2 + 64*(t2*u2-mjs2*s)**(-2)*m1**2*s**3*t2*t2t**(-1) - 
     +    64*(t2*u2-mjs2*s)**(-2)*m1**2*s**3 + 64*(t2*u2-mjs2*s)**(-2)*
     +    m1**2*t2*u2**3*t2t**(-1) + 64*(t2*u2-mjs2*s)**(-2)*m1**2*
     +    t2**2*u2 - 64*(t2*u2-mjs2*s)**(-2)*m1**4*s*t2 - 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*t2*u2 - 192*(t2*u2-mjs2*s)**(-2)*
     +    m2**2*s*t2*u2**2*t2t**(-1) - 64*(t2*u2-mjs2*s)**(-2)*m2**2*s*
     +    t2**2 + 64*(t2*u2-mjs2*s)**(-2)*m2**2*s*u2**2 - 192*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*t2*u2*t2t**(-1) + 128*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*s**2*u2 - 64*(t2*u2-mjs2*s)**(-2)*
     +    m2**2*s**3*t2*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc*Cf**2*s4**(-1)*
     + Pi**3*alphas**2*hardfac * ( 64*(t2*u2-mjs2*s)**(-2)*m2**2*s**3
     +     - 64*(t2*u2-mjs2*s)**(-2)*m2**2*t2*u2**3*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-2)*m2**2*t2**2*u2 - 64*(t2*u2-mjs2*s)**(-2)
     +    *m2**4*s*t2 - 64*(t2*u2-mjs2*s)**(-2)*m2**4*t2*u2 - 128*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s*u2*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s**2*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*u2**2*t2t**(-1) + 128*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*s*u2*t2t**(-1) + 64*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*s**2*t2t**(-1) + 64*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*u2**2*t2t**(-1) - 128*
     +    (t2*u2-mjs2*s)**(-1)*s*t2*u2*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-1)*s**2*t2*t2t**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-1)*t2*u2**2*t2t**(-1) - 64*s**(-1)*t2*u2**2
     +    *t2t**(-2) - 64*s*t2*t2t**(-2) - 128*t2*u2*t2t**(-2) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac*log_all * (  - 256*(s+t2)**(-1)*m1**2*s*
     +    t2*u2t**(-2) - 128*(s+t2)**(-1)*m1**2*s**2*u2t**(-2) - 128*
     +    (s+t2)**(-1)*m1**2*t2**2*u2t**(-2) + 256*(s+t2)**(-1)*m2**2*s
     +    *t2*u2t**(-2) + 128*(s+t2)**(-1)*m2**2*s**2*u2t**(-2) + 128*
     +    (s+t2)**(-1)*m2**2*t2**2*u2t**(-2) - 128*(s+t2)**(-1)*s*t2*
     +    u2t**(-1) - 128*(s+t2)**(-1)*t2**2*u2t**(-1) - 512*m1**2*
     +    m2**2*s**(-1)*t2**2*u2t**(-3) - 256*m1**2*m2**2*s*u2t**(-3)
     +     - 768*m1**2*m2**2*t2*u2t**(-3) + 256*m1**2*s**(-1)*t2**2*
     +    u2t**(-2) + 128*m1**2*s*u2t**(-2) + 384*m1**2*t2*u2t**(-2) + 
     +    256*m1**4*s**(-1)*t2**2*u2t**(-3) + 256*m1**4*t2*u2t**(-3) - 
     +    256*m2**2*s**(-1)*t2**2*u2t**(-2) - 128*m2**2*s*u2t**(-2) - 
     +    384*m2**2*t2*u2t**(-2) + 256*m2**4*s**(-1)*t2**2*u2t**(-3) + 
     +    256*m2**4*s*u2t**(-3) + 512*m2**4*t2*u2t**(-3) + 128*s**(-1)*
     +    t2**2*u2t**(-1) + 128*t2*u2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac * (  - 64 + 64*(s+t2)**(-3)*m1**2*m2**2*
     +    s*t2*u2t**(-1) + 64*(s+t2)**(-3)*m1**2*m2**2*s**2*u2t**(-1)
     +     - 64*(s+t2)**(-3)*m1**2*s*t2*u2*u2t**(-1) - 64*(s+t2)**(-3)*
     +    m1**2*t2**2*u2*u2t**(-1) - 32*(s+t2)**(-3)*m1**4*s*t2*
     +    u2t**(-1) - 32*(s+t2)**(-3)*m1**4*s**2*u2t**(-1) + 64*
     +    (s+t2)**(-3)*m2**2*s*t2*u2*u2t**(-1) + 64*(s+t2)**(-3)*m2**2*
     +    t2**2*u2*u2t**(-1) - 32*(s+t2)**(-3)*m2**4*s*t2*u2t**(-1) - 
     +    32*(s+t2)**(-3)*m2**4*s**2*u2t**(-1) - 32*(s+t2)**(-3)*
     +    s**(-1)*t2**3*u2**2*u2t**(-1) - 32*(s+t2)**(-3)*t2**2*u2**2*
     +    u2t**(-1) - 256*(s+t2)**(-2)*m1**2*m2**2*s*u2t**(-1) - 256*
     +    (s+t2)**(-2)*m1**2*m2**2*t2*u2t**(-1) + 128*(s+t2)**(-2)*
     +    m1**2*s**(-1)*t2**2*u2*u2t**(-1) - 120*(s+t2)**(-2)*m1**2*s*
     +    t2*u2t**(-1) + 40*(s+t2)**(-2)*m1**2*s*t2**2*u2t**(-2) - 64*
     +    (s+t2)**(-2)*m1**2*s*u2*u2t**(-1) - 48*(s+t2)**(-2)*m1**2*s
     +     + 80*(s+t2)**(-2)*m1**2*s**2*t2*u2t**(-2) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac * (  - 40*(s+t2)**(-2)*m1**2*s**2*
     +    u2t**(-1) + 40*(s+t2)**(-2)*m1**2*s**3*u2t**(-2) + 64*
     +    (s+t2)**(-2)*m1**2*t2*u2*u2t**(-1) - 48*(s+t2)**(-2)*m1**2*t2
     +     - 80*(s+t2)**(-2)*m1**2*t2**2*u2t**(-1) + 128*(s+t2)**(-2)*
     +    m1**4*s*u2t**(-1) + 128*(s+t2)**(-2)*m1**4*t2*u2t**(-1) - 128
     +    *(s+t2)**(-2)*m2**2*s**(-1)*t2**2*u2*u2t**(-1) + 120*
     +    (s+t2)**(-2)*m2**2*s*t2*u2t**(-1) - 40*(s+t2)**(-2)*m2**2*s*
     +    t2**2*u2t**(-2) + 64*(s+t2)**(-2)*m2**2*s*u2*u2t**(-1) + 48*
     +    (s+t2)**(-2)*m2**2*s - 80*(s+t2)**(-2)*m2**2*s**2*t2*
     +    u2t**(-2) + 40*(s+t2)**(-2)*m2**2*s**2*u2t**(-1) - 40*
     +    (s+t2)**(-2)*m2**2*s**3*u2t**(-2) - 64*(s+t2)**(-2)*m2**2*t2*
     +    u2*u2t**(-1) + 48*(s+t2)**(-2)*m2**2*t2 + 80*(s+t2)**(-2)*
     +    m2**2*t2**2*u2t**(-1) + 128*(s+t2)**(-2)*m2**4*s*u2t**(-1) + 
     +    128*(s+t2)**(-2)*m2**4*t2*u2t**(-1) - 48*(s+t2)**(-2)*s**(-1)
     +    *t2**2*u2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac * (  - 64*(s+t2)**(-2)*s**(-1)*t2**2*
     +    u2**2*u2t**(-1) - 80*(s+t2)**(-2)*s**(-1)*t2**3*u2*u2t**(-1)
     +     - 40*(s+t2)**(-2)*s*t2*u2*u2t**(-1) + 80*(s+t2)**(-2)*s*
     +    t2**2*u2*u2t**(-2) + 40*(s+t2)**(-2)*s**2*t2*u2*u2t**(-2) - 
     +    48*(s+t2)**(-2)*t2*u2 - 64*(s+t2)**(-2)*t2*u2**2*u2t**(-1) - 
     +    120*(s+t2)**(-2)*t2**2*u2*u2t**(-1) + 40*(s+t2)**(-2)*t2**3*
     +    u2*u2t**(-2) + 256*(s+t2)**(-1)*m1**2*m2**2*s**(-1)*t2*
     +    u2t**(-1) + 256*(s+t2)**(-1)*m1**2*m2**2*u2t**(-1) + 128*
     +    (s+t2)**(-1)*m1**2*s**(-1)*t2*u2*u2t**(-1) + 96*(s+t2)**(-1)*
     +    m1**2*s**(-1)*t2 + 160*(s+t2)**(-1)*m1**2*s**(-1)*t2**2*
     +    u2t**(-1) - 416*(s+t2)**(-1)*m1**2*s*t2*u2t**(-2) + 80*
     +    (s+t2)**(-1)*m1**2*s*u2t**(-1) - 208*(s+t2)**(-1)*m1**2*s**2*
     +    u2t**(-2) + 240*(s+t2)**(-1)*m1**2*t2*u2t**(-1) - 208*
     +    (s+t2)**(-1)*m1**2*t2**2*u2t**(-2) + 128*(s+t2)**(-1)*m1**2*
     +    u2*u2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac * ( 96*(s+t2)**(-1)*m1**2 - 128*
     +    (s+t2)**(-1)*m1**4*s**(-1)*t2*u2t**(-1) - 128*(s+t2)**(-1)*
     +    m1**4*u2t**(-1) - 128*(s+t2)**(-1)*m2**2*s**(-1)*t2*u2*
     +    u2t**(-1) - 96*(s+t2)**(-1)*m2**2*s**(-1)*t2 - 160*
     +    (s+t2)**(-1)*m2**2*s**(-1)*t2**2*u2t**(-1) + 416*(s+t2)**(-1)
     +    *m2**2*s*t2*u2t**(-2) - 80*(s+t2)**(-1)*m2**2*s*u2t**(-1) + 
     +    208*(s+t2)**(-1)*m2**2*s**2*u2t**(-2) - 240*(s+t2)**(-1)*
     +    m2**2*t2*u2t**(-1) + 208*(s+t2)**(-1)*m2**2*t2**2*u2t**(-2)
     +     - 128*(s+t2)**(-1)*m2**2*u2*u2t**(-1) - 96*(s+t2)**(-1)*
     +    m2**2 - 128*(s+t2)**(-1)*m2**4*s**(-1)*t2*u2t**(-1) - 128*
     +    (s+t2)**(-1)*m2**4*u2t**(-1) - 48*(s+t2)**(-1)*s**(-1)*t2*u2
     +     - 32*(s+t2)**(-1)*s**(-1)*t2*u2**2*u2t**(-1) - 80*
     +    (s+t2)**(-1)*s**(-1)*t2**2*u2*u2t**(-1) - 64*(s+t2)**(-1)*
     +    s**(-1)*t2**2 - 32*(s+t2)**(-1)*s**(-1)*t2**3*u2t**(-1) + 80*
     +    (s+t2)**(-1)*s*t2*u2*u2t**(-2) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*s4**(-1)*
     + Pi**3*alphas**2*hardfac * ( 40*(s+t2)**(-1)*s*t2*u2t**(-1) + 264
     +    *(s+t2)**(-1)*s*t2**2*u2t**(-2) - 40*(s+t2)**(-1)*s*u2*
     +    u2t**(-1) + 104*(s+t2)**(-1)*s + 288*(s+t2)**(-1)*s**2*t2*
     +    u2t**(-2) + 40*(s+t2)**(-1)*s**2*u2*u2t**(-2) + 112*
     +    (s+t2)**(-1)*s**2*u2t**(-1) + 104*(s+t2)**(-1)*s**3*u2t**(-2)
     +     - 120*(s+t2)**(-1)*t2*u2*u2t**(-1) - 24*(s+t2)**(-1)*t2 + 40
     +    *(s+t2)**(-1)*t2**2*u2*u2t**(-2) - 104*(s+t2)**(-1)*t2**2*
     +    u2t**(-1) + 80*(s+t2)**(-1)*t2**3*u2t**(-2) - 48*(s+t2)**(-1)
     +    *u2 - 32*(s+t2)**(-1)*u2**2*u2t**(-1) + 128*m1**2*s*u2t**(-2)
     +     + 128*m1**2*t2*u2t**(-2) - 128*m2**2*s*u2t**(-2) - 128*m2**2
     +    *t2*u2t**(-2) + 96*s**(-1)*t2 + 64*s**(-1)*t2**2*u2t**(-1) - 
     +    48*s*t2*u2t**(-2) + 24*s*u2t**(-1) - 8*s**2*u2t**(-2) + 152*
     +    t2*u2t**(-1) - 40*t2**2*u2t**(-2) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac*log_all * ( 128*(s+t2)**(-3)*m1**2*s - 128*
     +    (s+t2)**(-3)*m2**2*s + 128*(s+t2)**(-3)*t2*u2 - 256*
     +    (s+t2)**(-2)*m1**2*m2**2*u2t**(-1) + 128*(s+t2)**(-2)*m1**2*
     +    s**(-1)*t2 + 128*(s+t2)**(-2)*m1**2*s*u2t**(-1) + 128*
     +    (s+t2)**(-2)*m1**2*t2*u2t**(-1) + 128*(s+t2)**(-2)*m1**2 + 
     +    256*(s+t2)**(-2)*m1**4*u2t**(-1) - 128*(s+t2)**(-2)*m2**2*
     +    s**(-1)*t2 - 128*(s+t2)**(-2)*m2**2*s*u2t**(-1) - 128*
     +    (s+t2)**(-2)*m2**2*t2*u2t**(-1) - 128*(s+t2)**(-2)*m2**2 + 
     +    128*(s+t2)**(-2)*s**(-1)*t2*u2 + 128*(s+t2)**(-2)*t2 + 256*
     +    (s+t2)**(-2)*u2 + 512*(s+t2)**(-1)*m1**2*m2**2*s**(-1)*
     +    u2t**(-1) - 256*(s+t2)**(-1)*m1**2*m2**2*u2t**(-2) + 256*
     +    (s+t2)**(-1)*m1**2*s**(-1)*t2*u2t**(-1) - 256*(s+t2)**(-1)*
     +    m1**2*s**(-1) + 256*(s+t2)**(-1)*m1**2*s*u2t**(-2) + 256*
     +    (s+t2)**(-1)*m1**2*t2*u2t**(-2) + 384*(s+t2)**(-1)*m1**2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac*log_all * (  - 256*(s+t2)**(-1)*m1**4*s**(-1)*
     +    u2t**(-1) + 256*(s+t2)**(-1)*m1**4*u2t**(-2) - 256*
     +    (s+t2)**(-1)*m2**2*s**(-1)*t2*u2t**(-1) + 256*(s+t2)**(-1)*
     +    m2**2*s**(-1) - 256*(s+t2)**(-1)*m2**2*s*u2t**(-2) - 256*
     +    (s+t2)**(-1)*m2**2*t2*u2t**(-2) - 384*(s+t2)**(-1)*m2**2*
     +    u2t**(-1) - 256*(s+t2)**(-1)*m2**4*s**(-1)*u2t**(-1) + 128*
     +    (s+t2)**(-1)*s**(-1)*t2 - 256*(s+t2)**(-1)*s**(-1)*u2 + 256*
     +    (s+t2)**(-1)*t2*u2t**(-1) + 256*(s+t2)**(-1) + 1024*m1**2*
     +    m2**2*s**(-1)*t2*u2t**(-3) + 512*m1**2*m2**2*s**(-1)*t2**2*
     +    u2t**(-4) + 512*m1**2*m2**2*s**(-1)*u2t**(-2) + 256*m1**2*
     +    m2**2*s*u2t**(-4) + 768*m1**2*m2**2*t2*u2t**(-4) + 512*m1**2*
     +    m2**2*u2t**(-3) - 512*m1**2*s**(-1)*t2*u2t**(-2) - 256*m1**2*
     +    s**(-1)*t2**2*u2t**(-3) - 512*m1**2*s**(-1)*u2t**(-1) - 256*
     +    m1**2*t2*u2t**(-3) - 256*m1**2*u2t**(-2) - 512*m1**4*s**(-1)*
     +    t2*u2t**(-3) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac*log_all * (  - 256*m1**4*s**(-1)*t2**2*
     +    u2t**(-4) - 256*m1**4*s**(-1)*u2t**(-2) - 256*m1**4*t2*
     +    u2t**(-4) + 512*m2**2*s**(-1)*t2*u2t**(-2) + 256*m2**2*
     +    s**(-1)*t2**2*u2t**(-3) + 512*m2**2*s**(-1)*u2t**(-1) + 256*
     +    m2**2*t2*u2t**(-3) + 256*m2**2*u2t**(-2) - 512*m2**4*s**(-1)*
     +    t2*u2t**(-3) - 256*m2**4*s**(-1)*t2**2*u2t**(-4) - 256*m2**4*
     +    s**(-1)*u2t**(-2) - 256*m2**4*s*u2t**(-4) - 512*m2**4*t2*
     +    u2t**(-4) - 512*m2**4*u2t**(-3) - 256*s**(-1)*t2*u2t**(-1) - 
     +    128*s**(-1)*t2**2*u2t**(-2) - 256*s**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * (  - 128*(s+t2)**(-3)*m1**2*m2**2*s*
     +    u2t**(-1) + 64*(s+t2)**(-3)*m1**2*s + 128*(s+t2)**(-3)*m1**2*
     +    t2*u2*u2t**(-1) + 64*(s+t2)**(-3)*m1**4*s*u2t**(-1) - 64*
     +    (s+t2)**(-3)*m2**2*s - 128*(s+t2)**(-3)*m2**2*t2*u2*u2t**(-1)
     +     + 64*(s+t2)**(-3)*m2**4*s*u2t**(-1) + 64*(s+t2)**(-3)*
     +    s**(-1)*t2**2*u2**2*u2t**(-1) + 64*(s+t2)**(-3)*t2*u2 + 512*
     +    (s+t2)**(-2)*m1**2*m2**2*u2t**(-1) - 256*(s+t2)**(-2)*m1**2*
     +    s**(-1)*t2*u2*u2t**(-1) + 128*(s+t2)**(-2)*m1**2*s**(-1)*t2
     +     - 40*(s+t2)**(-2)*m1**2*s*t2*u2t**(-2) + 176*(s+t2)**(-2)*
     +    m1**2*s*u2t**(-1) - 40*(s+t2)**(-2)*m1**2*s**2*u2t**(-2) + 
     +    304*(s+t2)**(-2)*m1**2*t2*u2t**(-1) + 128*(s+t2)**(-2)*m1**2*
     +    u2*u2t**(-1) - 128*(s+t2)**(-2)*m1**2 - 256*(s+t2)**(-2)*
     +    m1**4*u2t**(-1) + 256*(s+t2)**(-2)*m2**2*s**(-1)*t2*u2*
     +    u2t**(-1) - 128*(s+t2)**(-2)*m2**2*s**(-1)*t2 + 40*
     +    (s+t2)**(-2)*m2**2*s*t2*u2t**(-2) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * (  - 176*(s+t2)**(-2)*m2**2*s*u2t**(-1) + 40
     +    *(s+t2)**(-2)*m2**2*s**2*u2t**(-2) - 304*(s+t2)**(-2)*m2**2*
     +    t2*u2t**(-1) - 128*(s+t2)**(-2)*m2**2*u2*u2t**(-1) + 128*
     +    (s+t2)**(-2)*m2**2 - 256*(s+t2)**(-2)*m2**4*u2t**(-1) - 256*
     +    (s+t2)**(-2)*s**(-1)*t2*u2 + 128*(s+t2)**(-2)*s**(-1)*t2*
     +    u2**2*u2t**(-1) + 176*(s+t2)**(-2)*s**(-1)*t2**2*u2*u2t**(-1)
     +     - 40*(s+t2)**(-2)*s*t2*u2*u2t**(-2) + 32*(s+t2)**(-2)*s + 48
     +    *(s+t2)**(-2)*t2*u2*u2t**(-1) + 128*(s+t2)**(-2)*t2 - 40*
     +    (s+t2)**(-2)*t2**2*u2*u2t**(-2) - 64*(s+t2)**(-2)*u2 - 64*
     +    (s+t2)**(-1)*(t2*u2-mjs2*s)**(-1)*m1**2*m2**2 - 160*
     +    (s+t2)**(-1)*(t2*u2-mjs2*s)**(-1)*m1**2*s - 64*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2 - 64*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*u2 + 32*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m1**4 + 160*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*s )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * ( 64*(s+t2)**(-1)*(t2*u2-mjs2*s)**(-1)*m2**2
     +    *t2 + 64*(s+t2)**(-1)*(t2*u2-mjs2*s)**(-1)*m2**2*u2 + 32*
     +    (s+t2)**(-1)*(t2*u2-mjs2*s)**(-1)*m2**4 + 160*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*s*t2 + 160*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*s*u2 + 160*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*s**2 + 64*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*t2*u2 + 32*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*t2**2 + 32*(s+t2)**(-1)*
     +    (t2*u2-mjs2*s)**(-1)*u2**2 - 576*(s+t2)**(-1)*m1**2*m2**2*
     +    s**(-1)*u2t**(-1) - 544*(s+t2)**(-1)*m1**2*s**(-1)*t2*
     +    u2t**(-1) - 320*(s+t2)**(-1)*m1**2*s**(-1)*u2*u2t**(-1) + 128
     +    *(s+t2)**(-1)*m1**2*s**(-1) + 208*(s+t2)**(-1)*m1**2*s*
     +    u2t**(-2) + 208*(s+t2)**(-1)*m1**2*t2*u2t**(-2) - 320*
     +    (s+t2)**(-1)*m1**2*u2t**(-1) + 288*(s+t2)**(-1)*m1**4*s**(-1)
     +    *u2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * ( 544*(s+t2)**(-1)*m2**2*s**(-1)*t2*
     +    u2t**(-1) + 320*(s+t2)**(-1)*m2**2*s**(-1)*u2*u2t**(-1) - 128
     +    *(s+t2)**(-1)*m2**2*s**(-1) - 208*(s+t2)**(-1)*m2**2*s*
     +    u2t**(-2) - 208*(s+t2)**(-1)*m2**2*t2*u2t**(-2) + 320*
     +    (s+t2)**(-1)*m2**2*u2t**(-1) + 288*(s+t2)**(-1)*m2**4*s**(-1)
     +    *u2t**(-1) + 368*(s+t2)**(-1)*s**(-1)*t2*u2*u2t**(-1) - 288*
     +    (s+t2)**(-1)*s**(-1)*t2 + 96*(s+t2)**(-1)*s**(-1)*t2**2*
     +    u2t**(-1) + 96*(s+t2)**(-1)*s**(-1)*u2**2*u2t**(-1) - 184*
     +    (s+t2)**(-1)*s*t2*u2t**(-2) - 40*(s+t2)**(-1)*s*u2*u2t**(-2)
     +     - 72*(s+t2)**(-1)*s*u2t**(-1) - 104*(s+t2)**(-1)*s**2*
     +    u2t**(-2) - 40*(s+t2)**(-1)*t2*u2*u2t**(-2) + 88*(s+t2)**(-1)
     +    *t2*u2t**(-1) - 80*(s+t2)**(-1)*t2**2*u2t**(-2) + 144*
     +    (s+t2)**(-1)*u2*u2t**(-1) + 32*(s+t2)**(-1) - 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s - 64*(t2*u2-mjs2*s)**(-2)*
     +    m1**2*m2**2*u2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * (  - 64*(t2*u2-mjs2*s)**(-2)*m1**2*s*u2 - 64
     +    *(t2*u2-mjs2*s)**(-2)*m1**2*u2**2 + 64*(t2*u2-mjs2*s)**(-2)*
     +    m1**4*s + 64*(t2*u2-mjs2*s)**(-2)*m1**4*u2 - 64*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*m2**2*t2**(-1) + 96*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s*t2**(-1) - 48*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s*u2t**(-1) - 32*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2**(-1)*u2 + 32*
     +    (t2*u2-mjs2*s)**(-1)*m1**4*t2**(-1) - 32*(t2*u2-mjs2*s)**(-1)
     +    *m2**2*s*t2**(-1) + 48*(t2*u2-mjs2*s)**(-1)*m2**2*s*u2t**(-1)
     +     + 32*(t2*u2-mjs2*s)**(-1)*m2**2*t2**(-1)*u2 + 32*
     +    (t2*u2-mjs2*s)**(-1)*m2**4*t2**(-1) + 16*(t2*u2-mjs2*s)**(-1)
     +    *s*u2*u2t**(-1) - 112*(t2*u2-mjs2*s)**(-1)*s - 64*
     +    (t2*u2-mjs2*s)**(-1)*t2*u2*u2t**(-1) + 32*
     +    (t2*u2-mjs2*s)**(-1)*t2 - 64*(t2*u2-mjs2*s)**(-1)*u2 - 64*
     +    m1**2*m2**2*s**(-1)*t2**(-1)*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * ( 896*m1**2*m2**2*s**(-1)*t2*u2*u2t**(-4) - 
     +    384*m1**2*m2**2*s**(-1)*t2**2*u2t**(-4) - 640*m1**2*m2**2*s*
     +    u2t**(-4) - 1024*m1**2*m2**2*t2*u2t**(-4) + 128*m1**2*m2**2*
     +    u2*u2t**(-4) - 512*m1**2*m2**4*u2t**(-4) - 32*m1**2*s**(-1)*
     +    t2**(-1)*u2*t2t**(-1) - 192*m1**2*s**(-1)*t2*u2*u2t**(-3) + 
     +    640*m1**2*s**(-1)*t2*u2**2*u2t**(-4) - 128*m1**2*s**(-1)*t2*
     +    u2t**(-2) - 16*m1**2*s**(-1)*t2*u2t**(-1)*t2t**(-1) + 256*
     +    m1**2*s**(-1)*t2**2*u2*u2t**(-4) + 192*m1**2*s**(-1)*t2**2*
     +    u2t**(-3) + 64*m1**2*s**(-1)*u2*t2t**(-2) - 64*m1**2*s**(-1)*
     +    u2t**(-1) - 64*m1**2*s**(-1)*t2t**(-1) + 96*m1**2*t2**(-1)*
     +    t2t**(-1) + 256*m1**2*t2*u2*u2t**(-4) + 192*m1**2*t2*
     +    u2t**(-3) - 192*m1**2*u2*u2t**(-3) + 384*m1**2*u2**2*
     +    u2t**(-4) - 344*m1**2*u2t**(-2) - 16*m1**2*u2t**(-1)*
     +    t2t**(-1) + 64*m1**2*t2t**(-2) + 256*m1**4*m2**2*u2t**(-4) + 
     +    32*m1**4*s**(-1)*t2**(-1)*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * (  - 448*m1**4*s**(-1)*t2*u2*u2t**(-4) + 192
     +    *m1**4*s**(-1)*t2**2*u2t**(-4) + 192*m1**4*t2*u2t**(-4) - 192
     +    *m1**4*u2*u2t**(-4) + 32*m2**2*s**(-1)*t2**(-1)*u2*t2t**(-1)
     +     + 192*m2**2*s**(-1)*t2*u2*u2t**(-3) - 640*m2**2*s**(-1)*t2*
     +    u2**2*u2t**(-4) + 128*m2**2*s**(-1)*t2*u2t**(-2) + 16*m2**2*
     +    s**(-1)*t2*u2t**(-1)*t2t**(-1) - 256*m2**2*s**(-1)*t2**2*u2*
     +    u2t**(-4) - 192*m2**2*s**(-1)*t2**2*u2t**(-3) - 64*m2**2*
     +    s**(-1)*u2*t2t**(-2) + 64*m2**2*s**(-1)*u2t**(-1) + 64*m2**2*
     +    s**(-1)*t2t**(-1) + 384*m2**2*s*u2*u2t**(-4) - 384*m2**2*s*
     +    u2t**(-3) - 32*m2**2*t2**(-1)*t2t**(-1) + 128*m2**2*t2*u2*
     +    u2t**(-4) - 576*m2**2*t2*u2t**(-3) + 192*m2**2*u2*u2t**(-3)
     +     - 384*m2**2*u2**2*u2t**(-4) + 344*m2**2*u2t**(-2) + 16*m2**2
     +    *u2t**(-1)*t2t**(-1) - 64*m2**2*t2t**(-2) + 32*m2**4*s**(-1)*
     +    t2**(-1)*t2t**(-1) - 448*m2**4*s**(-1)*t2*u2*u2t**(-4) + 192*
     +    m2**4*s**(-1)*t2**2*u2t**(-4) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Nc**2*Cf*Pi**3*
     + alphas**2*hardfac * ( 640*m2**4*s*u2t**(-4) + 832*m2**4*t2*
     +    u2t**(-4) + 64*m2**4*u2*u2t**(-4) + 256*m2**6*u2t**(-4) + 128
     +    *s**(-1)*t2*u2*u2t**(-2) - 16*s**(-1)*t2*u2*u2t**(-1)*
     +    t2t**(-1) + 192*s**(-1)*t2*u2**2*u2t**(-3) - 192*s**(-1)*t2*
     +    u2**3*u2t**(-4) - 288*s**(-1)*t2*u2t**(-1) + 48*s**(-1)*t2*
     +    t2t**(-1) + 192*s**(-1)*t2**2*u2*u2t**(-3) - 192*s**(-1)*
     +    t2**2*u2**2*u2t**(-4) + 32*s**(-1)*t2**2*u2t**(-1)*t2t**(-1)
     +     + 64*s**(-1)*u2*u2t**(-1) + 32*s**(-1)*u2*t2t**(-1) - 128*
     +    s**(-1) + 8*s*u2t**(-2) + 192*t2*u2*u2t**(-3) - 192*t2*u2**2*
     +    u2t**(-4) + 40*t2*u2t**(-2) + 216*u2*u2t**(-2) + 16*u2*
     +    u2t**(-1)*t2t**(-1) + 192*u2**2*u2t**(-3) - 192*u2**3*
     +    u2t**(-4) - 152*u2t**(-1) + 16*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Cf*s4**(-1)*Pi**3*
     + alphas**2*hardfac * (  - 32*(t2*u2-mjs2*s)**(-1)*s**(-1)*t2**2*
     +    u2 - 32*(t2*u2-mjs2*s)**(-1)*s*t2*u2*u2t**(-1) - 32*
     +    (t2*u2-mjs2*s)**(-1)*s*t2 - 32*(t2*u2-mjs2*s)**(-1)*s*t2**2*
     +    u2t**(-1) - 32*(t2*u2-mjs2*s)**(-1)*s**2*t2*u2t**(-1) - 32*
     +    (t2*u2-mjs2*s)**(-1)*t2*u2 - 32*(t2*u2-mjs2*s)**(-1)*t2**2*u2
     +    *u2t**(-1) - 32*(t2*u2-mjs2*s)**(-1)*t2**2 + 32*s**(-1)*t2*u2
     +    *t2t**(-1) + 32*s*t2*u2t**(-1)*t2t**(-1) + 32*t2*u2*u2t**(-1)
     +    *t2t**(-1) + 32*t2*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Cf*Pi**3*alphas**2
     + *hardfac * (  - 32*(s+u2)**(-1)*s**(-1)*u2 - 32*(s+u2)**(-1)*s*
     +    u2t**(-1) - 32*(s+u2)**(-1)*u2*u2t**(-1) - 32*(s+u2)**(-1) + 
     +    64*(t2*u2-mjs2*s)**(-2)*m1**2*m2**2*s + 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**2*m2**2*u2 + 64*(t2*u2-mjs2*s)**(-2)
     +    *m1**2*s*u2 + 64*(t2*u2-mjs2*s)**(-2)*m1**2*u2**2 - 64*
     +    (t2*u2-mjs2*s)**(-2)*m1**4*s - 64*(t2*u2-mjs2*s)**(-2)*m1**4*
     +    u2 + 64*(t2*u2-mjs2*s)**(-1)*m1**2*m2**2*t2**(-1) + 32*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s**(-1)*u2 - 96*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*s*t2**(-1) + 32*
     +    (t2*u2-mjs2*s)**(-1)*m1**2*t2**(-1)*u2 + 96*
     +    (t2*u2-mjs2*s)**(-1)*m1**2 - 32*(t2*u2-mjs2*s)**(-1)*m1**4*
     +    t2**(-1) - 32*(t2*u2-mjs2*s)**(-1)*m2**2*s**(-1)*u2 + 32*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*s*t2**(-1) - 32*
     +    (t2*u2-mjs2*s)**(-1)*m2**2*t2**(-1)*u2 - 96*
     +    (t2*u2-mjs2*s)**(-1)*m2**2 )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Cf*Pi**3*alphas**2
     + *hardfac * (  - 32*(t2*u2-mjs2*s)**(-1)*m2**4*t2**(-1) + 32*
     +    (t2*u2-mjs2*s)**(-1)*s**(-1)*t2*u2 - 32*(t2*u2-mjs2*s)**(-1)*
     +    s**(-1)*u2**2 + 32*(t2*u2-mjs2*s)**(-1)*s*t2*u2t**(-1) + 32*
     +    (t2*u2-mjs2*s)**(-1)*s*u2*u2t**(-1) - 96*(t2*u2-mjs2*s)**(-1)
     +    *s + 96*(t2*u2-mjs2*s)**(-1)*t2*u2*u2t**(-1) - 32*
     +    (t2*u2-mjs2*s)**(-1)*t2 - 96*(t2*u2-mjs2*s)**(-1)*u2 + 64*
     +    m1**2*m2**2*s**(-1)*t2**(-1)*t2t**(-1) + 32*m1**2*s**(-1)*
     +    t2**(-1)*u2*t2t**(-1) - 64*m1**2*s**(-1)*u2*t2t**(-2) + 32*
     +    m1**2*s**(-1)*t2t**(-1) - 96*m1**2*t2**(-1)*t2t**(-1) - 64*
     +    m1**2*t2t**(-2) - 32*m1**4*s**(-1)*t2**(-1)*t2t**(-1) - 32*
     +    m2**2*s**(-1)*t2**(-1)*u2*t2t**(-1) + 64*m2**2*s**(-1)*u2*
     +    t2t**(-2) - 32*m2**2*s**(-1)*t2t**(-1) + 32*m2**2*t2**(-1)*
     +    t2t**(-1) + 64*m2**2*t2t**(-2) - 32*m2**4*s**(-1)*t2**(-1)*
     +    t2t**(-1) - 32*s**(-1)*t2*t2t**(-1) - 32*s**(-1)*u2*t2t**(-1)
     +     - 32*t2*u2t**(-1)*t2t**(-1) )
      MM_real_4 = MM_real_4 + (1+m12/s4)*(h_r2+h_l2)*Cf*Pi**3*alphas**2
     + *hardfac * (  - 32*t2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-2)*Pi**2*alphas**2*hardfac * ( 64*m1**2*m2**2*s**(-1)*t2*
     +    u2t**(-1) + 64*m1**2*m2**4*s**(-1)*u2t**(-1) - 32*m1**2*
     +    s**(-1)*t2 - 32*m1**2*s*t2*u2t**(-2) - 64*m1**2*s*u2t**(-1)
     +     - 32*m1**2*s**2*u2t**(-2) - 64*m1**2*t2*u2t**(-1) - 32*m1**2
     +     - 128*m1**4*m2**2*s**(-1)*u2t**(-1) - 64*m1**4*m2**2*
     +    u2t**(-2) - 64*m1**4*s**(-1)*t2*u2t**(-1) - 64*m1**4*s*
     +    u2t**(-2) - 64*m1**4*t2*u2t**(-2) - 64*m1**4*u2t**(-1) + 64*
     +    m1**6*s**(-1)*u2t**(-1) + 64*m1**6*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 32 - 64*m1**2*m2**2*
     +    s**(-1)*u2t**(-1) - 64*m1**2*m2**2*u2t**(-2) - 64*m1**2*
     +    s**(-1)*t2*u2t**(-1) - 64*m1**2*s**(-1)*u2*u2t**(-1) - 16*
     +    m1**2*s**(-1) + 20*m1**2*s*u2t**(-2) - 12*m1**2*t2*u2t**(-2)
     +     + 16*m1**2*u2*u2t**(-2) - 92*m1**2*u2t**(-1) + 64*m1**4*
     +    s**(-1)*u2t**(-1) + 128*m1**4*u2t**(-2) + 48*m2**2*s**(-1)*t2
     +    *u2t**(-1) + 64*m2**2*s**(-1)*u2*u2t**(-1) + 16*m2**2*s**(-1)
     +     - 52*m2**2*s*u2t**(-2) - 52*m2**2*t2*u2t**(-2) - 16*m2**2*u2
     +    *u2t**(-2) + 76*m2**2*u2t**(-1) + 144*s**(-1)*t2*u2*u2t**(-1)
     +     - 16*s**(-1)*t2 + 48*s**(-1)*t2**2*u2t**(-1) - 16*s**(-1)*u2
     +     + 96*s**(-1)*u2**2*u2t**(-1) - 100*s*t2*u2t**(-2) - 32*s*u2*
     +    u2t**(-2) + 48*s*u2t**(-1) - 48*s**2*u2t**(-2) - 32*t2*u2*
     +    u2t**(-2) + 92*t2*u2t**(-1) - 52*t2**2*u2t**(-2) + 176*u2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 32*(s+t2)**(-1) + 48*m1**2*s**(-1)*
     +    u2t**(-1) + 60*m1**2*u2t**(-2) - 48*m2**2*s**(-1)*u2t**(-1)
     +     + 4*m2**2*u2t**(-2) - 48*s**(-1)*t2*u2t**(-1) - 96*s**(-1)*
     +    u2*u2t**(-1) + 32*s**(-1) + 48*s*u2t**(-2) + 52*t2*u2t**(-2)
     +     + 32*u2*u2t**(-2) - 64*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Cf*s4**(-2)*
     + Pi**2*alphas**2*hardfac * (  - 64*m1**2*m2**2*s**(-1)*t2*
     +    u2t**(-1) - 64*m1**2*m2**4*s**(-1)*u2t**(-1) + 32*m1**2*
     +    s**(-1)*t2 + 32*m1**2*s*t2*u2t**(-2) + 64*m1**2*s*u2t**(-1)
     +     + 32*m1**2*s**2*u2t**(-2) + 64*m1**2*t2*u2t**(-1) + 32*m1**2
     +     + 128*m1**4*m2**2*s**(-1)*u2t**(-1) + 64*m1**4*m2**2*
     +    u2t**(-2) + 64*m1**4*s**(-1)*t2*u2t**(-1) + 64*m1**4*s*
     +    u2t**(-2) + 64*m1**4*t2*u2t**(-2) + 64*m1**4*u2t**(-1) - 64*
     +    m1**6*s**(-1)*u2t**(-1) - 64*m1**6*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Cf*s4**(-1)*
     + Pi**2*alphas**2*hardfac * (  - 16 + 128*m1**2*m2**2*s**(-1)*
     +    u2t**(-1) + 64*m1**2*m2**2*u2t**(-2) + 48*m1**2*s**(-1)*t2*
     +    u2t**(-1) + 64*m1**2*s**(-1)*u2*u2t**(-1) + 48*m1**2*s**(-1)
     +     - 32*m1**2*s*u2t**(-2) - 16*m1**2*u2*u2t**(-2) - 128*m1**4*
     +    s**(-1)*u2t**(-1) - 128*m1**4*u2t**(-2) - 64*m2**2*s**(-1)*u2
     +    *u2t**(-1) - 16*m2**2*s**(-1) + 64*m2**2*s*u2t**(-2) + 64*
     +    m2**2*t2*u2t**(-2) + 16*m2**2*u2*u2t**(-2) + 16*m2**2*
     +    u2t**(-1) - 96*s**(-1)*t2*u2*u2t**(-1) - 16*s**(-1)*u2 - 96*
     +    s**(-1)*u2**2*u2t**(-1) + 48*s*t2*u2t**(-2) + 32*s*u2*
     +    u2t**(-2) - 16*s*u2t**(-1) + 16*s**2*u2t**(-2) + 32*t2*u2*
     +    u2t**(-2) + 32*t2**2*u2t**(-2) - 96*u2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(0,0,0,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 16*m1**2*u2t**(-2) - 32*m2**2*s**(-1)*
     +    u2t**(-1) - 48*m2**2*u2t**(-2) - 32*s**(-1)*t2*u2t**(-1) + 48
     +    *s**(-1) - 16*s*u2t**(-2) - 32*t2*u2t**(-2) - 32*u2*u2t**(-2)
     +     + 32*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,0,-2,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 128*m1**2*s*t2*u2t**(-2) + 8*m1**2*s
     +    *u2t**(-1) + 64*m1**2*s**2*u2t**(-2) + 8*m1**2*t2*u2t**(-1)
     +     + 64*m1**2*t2**2*u2t**(-2) - 128*m2**2*s*t2*u2t**(-2) - 8*
     +    m2**2*s*u2t**(-1) - 64*m2**2*s**2*u2t**(-2) - 8*m2**2*t2*
     +    u2t**(-1) - 64*m2**2*t2**2*u2t**(-2) - 8*s*u2*u2t**(-1) + 8*s
     +     - 8*t2*u2*u2t**(-1) + 8*t2 )
      MM_real_4 = MM_real_4 + ANG_fin(1,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * ( 96*m1**2*m2**2*s**(-1)*t2*
     +    u2t**(-1) + 64*m1**2*m2**2*s**(-1)*u2*u2t**(-1) + 32*m1**2*
     +    m2**2*s**(-1) - 48*m1**2*m2**2*s*u2t**(-2) - 48*m1**2*m2**2*
     +    t2*u2t**(-2) - 16*m1**2*m2**2*u2t**(-1) + 128*m1**2*m2**4*
     +    s**(-1)*u2t**(-1) - 16*m1**2*s**(-1)*t2*u2*u2t**(-1) + 16*
     +    m1**2*s**(-1)*t2 - 16*m1**2*s**(-1)*t2**2*u2t**(-1) + 16*
     +    m1**2*s**(-1)*u2 - 24*m1**2*s*t2*u2t**(-2) - 16*m1**2*s*u2*
     +    u2t**(-2) - 88*m1**2*s*u2t**(-1) - 16*m1**2*s**2*u2t**(-2) - 
     +    16*m1**2*t2*u2*u2t**(-2) - 96*m1**2*t2*u2t**(-1) - 8*m1**2*
     +    t2**2*u2t**(-2) - 32*m1**2*u2*u2t**(-1) - 8*m1**2 - 256*m1**4
     +    *m2**2*s**(-1)*u2t**(-1) - 144*m1**4*s**(-1)*t2*u2t**(-1) - 
     +    64*m1**4*s**(-1)*u2*u2t**(-1) - 48*m1**4*s**(-1) + 48*m1**4*s
     +    *u2t**(-2) + 48*m1**4*t2*u2t**(-2) - 32*m1**4*u2t**(-1) + 128
     +    *m1**6*s**(-1)*u2t**(-1) + 48*m2**2*s**(-1)*t2*u2*u2t**(-1)
     +     + 48*m2**2*s**(-1)*t2 )
      MM_real_4 = MM_real_4 + ANG_fin(1,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * ( 80*m2**2*s**(-1)*t2**2*
     +    u2t**(-1) + 16*m2**2*s**(-1)*u2 - 80*m2**2*s*t2*u2t**(-2) + 
     +    56*m2**2*s*u2t**(-1) - 40*m2**2*s**2*u2t**(-2) + 136*m2**2*t2
     +    *u2t**(-1) - 40*m2**2*t2**2*u2t**(-2) + 48*m2**2*u2*u2t**(-1)
     +     + 32*m2**2 + 48*m2**4*s**(-1)*t2*u2t**(-1) + 16*m2**4*
     +    s**(-1) + 48*m2**4*u2t**(-1) + 16*s**(-1)*t2*u2 + 16*s**(-1)*
     +    t2*u2**2*u2t**(-1) + 48*s**(-1)*t2**2*u2*u2t**(-1) + 16*
     +    s**(-1)*t2**2 + 32*s**(-1)*t2**3*u2t**(-1) - 40*s*t2*u2*
     +    u2t**(-2) - 36*s*t2*u2t**(-1) - 132*s*t2**2*u2t**(-2) + 36*s*
     +    u2*u2t**(-1) - 40*s - 144*s**2*t2*u2t**(-2) - 20*s**2*u2*
     +    u2t**(-2) - 44*s**2*u2t**(-1) - 52*s**3*u2t**(-2) + 84*t2*u2*
     +    u2t**(-1) - 16*t2 - 20*t2**2*u2*u2t**(-2) + 40*t2**2*
     +    u2t**(-1) - 40*t2**3*u2t**(-2) - 8*u2 + 16*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 16 - 64*(s+t2)**(-1)*m1**2*m2**2*
     +    u2t**(-1) + 64*(s+t2)**(-1)*m1**4*u2t**(-1) - 80*(s+t2)**(-1)
     +    *s - 64*(s+t2)**(-1)*t2 + 32*(s+t2)**(-1)*u2 - 32*m1**2*m2**2
     +    *s**(-1)*u2t**(-1) - 80*m1**2*m2**2*u2t**(-2) + 96*m1**2*
     +    s**(-1)*t2*u2t**(-1) + 48*m1**2*s**(-1)*u2*u2t**(-1) - 32*
     +    m1**2*s**(-1) + 80*m1**2*s*u2t**(-2) + 72*m1**2*t2*u2t**(-2)
     +     + 16*m1**2*u2*u2t**(-2) - 24*m1**2*u2t**(-1) + 112*m1**4*
     +    s**(-1)*u2t**(-1) + 80*m1**4*u2t**(-2) - 160*m2**2*s**(-1)*t2
     +    *u2t**(-1) - 80*m2**2*s**(-1)*u2*u2t**(-1) + 32*m2**2*s**(-1)
     +     - 24*m2**2*s*u2t**(-2) - 24*m2**2*t2*u2t**(-2) - 80*m2**4*
     +    s**(-1)*u2t**(-1) - 128*s**(-1)*t2*u2*u2t**(-1) + 96*s**(-1)*
     +    t2 - 48*s**(-1)*t2**2*u2t**(-1) + 32*s**(-1)*u2 - 32*s**(-1)*
     +    u2**2*u2t**(-1) + 92*s*t2*u2t**(-2) + 20*s*u2*u2t**(-2) - 8*s
     +    *u2t**(-1) + 52*s**2*u2t**(-2) + 20*t2*u2*u2t**(-2) + 16*t2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 40*t2**2*u2t**(-2) + 136*u2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,2,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*(s+t2)**(-1)*m1**2*m2**2 + 64*
     +    (s+t2)**(-1)*m1**2*s*u2*u2t**(-1) - 96*(s+t2)**(-1)*m1**2*s
     +     - 32*(s+t2)**(-1)*m1**2*t2 + 16*(s+t2)**(-1)*m1**4 + 32*
     +    (s+t2)**(-1)*m2**2*s + 32*(s+t2)**(-1)*m2**2*t2 + 16*
     +    (s+t2)**(-1)*m2**4 + 32*(s+t2)**(-1)*s*t2 + 32*(s+t2)**(-1)*s
     +    *u2 + 32*(s+t2)**(-1)*s**2 + 16*(s+t2)**(-1)*t2**2 + 16*
     +    (s+t2)**(-1)*u2**2 + 24*m1**2*s*u2t**(-1) + 24*m1**2*t2*
     +    u2t**(-1) + 16*m1**2*u2*u2t**(-1) + 64*m1**2 - 24*m2**2*s*
     +    u2t**(-1) - 24*m2**2*t2*u2t**(-1) - 16*m2**2*u2*u2t**(-1) - 
     +    64*m2**2 - 24*s*u2*u2t**(-1) + 8*s + 8*t2*u2*u2t**(-1) - 24*
     +    t2 - 16*t2**2*u2t**(-1) + 48*u2 - 48*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,5,-2,-2)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 64*m1**2*s**2 - 64*m2**2*s**2 )
      MM_real_4 = MM_real_4 + ANG_fin(1,5,-2,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 32*m1**2*s*t2*u2t**(-1) + 32*m1**2*
     +    s**2*u2t**(-1) - 32*m2**2*s*t2*u2t**(-1) - 32*m2**2*s**2*
     +    u2t**(-1) + 96*s*t2*u2*u2t**(-1) - 96*s*t2 + 96*s**2*u2*
     +    u2t**(-1) - 96*s**2 )
      MM_real_4 = MM_real_4 + ANG_fin(1,5,-1,-2)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 64*m1**2*s - 64*m2**2*s )
      MM_real_4 = MM_real_4 + ANG_fin(1,5,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 32*m1**2*s*t2*u2t**(-1)
     +     - 64*m1**2*s*u2*u2t**(-1) + 32*m1**2*s - 32*m1**2*s**2*
     +    u2t**(-1) + 72*s*t2*u2*u2t**(-1) - 24*s*t2 + 8*s*t2**2*
     +    u2t**(-1) - 16*s*u2 + 24*s*u2**2*u2t**(-1) + 32*s**2*t2*
     +    u2t**(-1) + 48*s**2*u2*u2t**(-1) - 8*s**2 + 24*s**3*u2t**(-1)
     +     - 8*t2*u2 + 24*t2*u2**2*u2t**(-1) + 24*t2**2*u2*u2t**(-1) - 
     +    16*t2**2 - 8*u2**2 )
      MM_real_4 = MM_real_4 + ANG_fin(1,5,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*(s+t2)**(-1)*m1**2*m2**2 - 64*
     +    (s+t2)**(-1)*m1**2*s*u2*u2t**(-1) + 32*(s+t2)**(-1)*m1**2*s
     +     - 32*(s+t2)**(-1)*m1**2*t2 + 16*(s+t2)**(-1)*m1**4 + 32*
     +    (s+t2)**(-1)*m2**2*s + 32*(s+t2)**(-1)*m2**2*t2 + 16*
     +    (s+t2)**(-1)*m2**4 + 32*(s+t2)**(-1)*s*t2 - 32*(s+t2)**(-1)*s
     +    *u2 + 32*(s+t2)**(-1)*s**2 + 16*(s+t2)**(-1)*t2**2 + 16*
     +    (s+t2)**(-1)*u2**2 - 8*m1**2*s*u2t**(-1) - 32*m1**2*t2*
     +    u2t**(-1) + 24*m1**2*u2*u2t**(-1) - 96*m1**2 + 40*m2**2*s*
     +    u2t**(-1) + 32*m2**2*t2*u2t**(-1) - 24*m2**2*u2*u2t**(-1) + 
     +    96*m2**2 - 8*s*t2*u2t**(-1) + 120*s*u2*u2t**(-1) - 168*s - 24
     +    *s**2*u2t**(-1) + 72*t2*u2*u2t**(-1) - 32*t2 + 64*t2**2*
     +    u2t**(-1) - 136*u2 + 208*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,7,-1,1)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 64*m1**2*m2**2*s**(-1)*
     +    u2t**(-1) + 16*m1**2*s**(-1)*t2*u2t**(-1) - 16*m1**2*s**(-1)
     +     + 16*m1**2*s*u2t**(-2) + 16*m1**2*t2*u2t**(-2) + 32*m1**2*
     +    u2t**(-1) + 64*m1**4*s**(-1)*u2t**(-1) - 48*m2**2*s**(-1)*t2*
     +    u2t**(-1) - 16*m2**2*s**(-1) - 48*m2**2*u2t**(-1) - 32*
     +    s**(-1)*t2*u2*u2t**(-1) - 16*s**(-1)*t2 - 48*s**(-1)*t2**2*
     +    u2t**(-1) + 40*s*t2*u2t**(-2) - 12*s*u2t**(-1) + 20*s**2*
     +    u2t**(-2) - 60*t2*u2t**(-1) + 20*t2**2*u2t**(-2) - 32*u2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,7,-1,1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*(s+t2)**(-1) - 48*m1**2*
     +    s**(-1)*u2t**(-1) - 16*m1**2*u2t**(-2) + 80*m2**2*s**(-1)*
     +    u2t**(-1) + 80*s**(-1)*t2*u2t**(-1) + 64*s**(-1)*u2*u2t**(-1)
     +     - 64*s**(-1) - 20*s*u2t**(-2) - 20*t2*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(1,7,-1,2)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * ( 16*s**(-1)*t2*u2t**(-1) + 
     +    16*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(1,7,-1,2)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*s**(-1)*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(2,0,-1,0)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*u2 - 16*m1**2*s
     +    *u2t**(-1) - 16*m1**2*u2*u2t**(-1) - 16*m1**2 )
      MM_real_4 = MM_real_4 + ANG_fin(2,5,-1,-2)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 16*m1**2*s + 16*m2**2*s )
      MM_real_4 = MM_real_4 + ANG_fin(2,5,-1,-2)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 16*m1**2*s - 16*m2**2*s )
      MM_real_4 = MM_real_4 + ANG_fin(2,5,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*m1**2*m2**2*t2**(-1) + 48*
     +    m1**2*s*t2**(-1)*u2*u2t**(-1) + 16*m1**2*s*t2**(-1) - 40*
     +    m1**2*s*u2t**(-1) + 16*m1**2*t2**(-1)*u2 - 24*m1**2*t2*
     +    u2t**(-1) + 32*m1**2*u2*u2t**(-1) - 64*m1**2 + 16*m1**4*
     +    t2**(-1) - 32*m2**2*s*t2**(-1)*u2*u2t**(-1) + 24*m2**2*s*
     +    u2t**(-1) - 16*m2**2*t2**(-1)*u2 + 24*m2**2*t2*u2t**(-1) - 32
     +    *m2**2*u2*u2t**(-1) + 64*m2**2 + 16*m2**4*t2**(-1) + 32*s*
     +    t2**(-1)*u2 - 32*s*t2**(-1)*u2**2*u2t**(-1) + 24*s*u2*
     +    u2t**(-1) - 24*s + 32*t2**(-1)*u2**2 - 32*t2**(-1)*u2**3*
     +    u2t**(-1) - 24*t2*u2*u2t**(-1) + 24*t2 + 16*t2**2*u2t**(-1)
     +     - 32*u2 + 32*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(2,5,-1,-1)*(h_r2+h_l2)*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * ( 16*m1**2*s*u2*u2t**(-1) + 
     +    16*m1**2*s**2*u2t**(-1) - 48*s*t2*u2*u2t**(-1) + 16*s*t2 - 96
     +    *s*u2**2*u2t**(-1) - 16*s**2*t2*u2t**(-1) - 96*s**2*u2*
     +    u2t**(-1) - 32*s**3*u2t**(-1) + 16*t2*u2 - 32*t2*u2**2*
     +    u2t**(-1) - 32*u2**3*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(2,5,-1,-1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 32*m1**2*m2**2*t2**(-1) - 48*m1**2*s*
     +    t2**(-1)*u2*u2t**(-1) - 16*m1**2*s*t2**(-1) - 16*m1**2*
     +    t2**(-1)*u2 - 32*m1**2*u2*u2t**(-1) + 32*m1**2 - 16*m1**4*
     +    t2**(-1) + 32*m2**2*s*t2**(-1)*u2*u2t**(-1) + 16*m2**2*
     +    t2**(-1)*u2 + 32*m2**2*u2*u2t**(-1) - 32*m2**2 - 16*m2**4*
     +    t2**(-1) - 32*s*t2**(-1)*u2 + 32*s*t2**(-1)*u2**2*u2t**(-1)
     +     - 16*s*t2*u2t**(-1) + 96*s*u2*u2t**(-1) - 32*s + 32*s**2*
     +    u2t**(-1) - 32*t2**(-1)*u2**2 + 32*t2**(-1)*u2**3*u2t**(-1)
     +     - 16*t2 - 32*u2 + 64*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(2,6,-1,-2)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 32*m1**2*m2**2 - 32*m1**2*u2 + 64*
     +    m1**2*u2**2*u2t**(-1) - 32*m1**4 )
      MM_real_4 = MM_real_4 + ANG_fin(2,6,-1,-2)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 32*m1**2*m2**2 + 32*m1**2*u2 - 64*m1**2
     +    *u2**2*u2t**(-1) + 32*m1**4 )
      MM_real_4 = MM_real_4 + ANG_fin(2,6,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*(s+t2)**(-1)*m1**2*m2**2 + 64*
     +    (s+t2)**(-1)*m1**2*s*u2*u2t**(-1) - 96*(s+t2)**(-1)*m1**2*s
     +     - 32*(s+t2)**(-1)*m1**2*t2 + 16*(s+t2)**(-1)*m1**4 + 32*
     +    (s+t2)**(-1)*m2**2*s + 32*(s+t2)**(-1)*m2**2*t2 + 16*
     +    (s+t2)**(-1)*m2**4 + 32*(s+t2)**(-1)*s*t2 + 32*(s+t2)**(-1)*s
     +    *u2 + 32*(s+t2)**(-1)*s**2 + 16*(s+t2)**(-1)*t2**2 + 16*
     +    (s+t2)**(-1)*u2**2 - 32*m1**2*m2**2*t2**(-1) + 48*m1**2*s*
     +    t2**(-1)*u2*u2t**(-1) + 16*m1**2*s*t2**(-1) + 16*m1**2*
     +    t2**(-1)*u2 + 64*m1**2*u2*u2t**(-1) + 16*m1**4*t2**(-1) - 32*
     +    m2**2*s*t2**(-1)*u2*u2t**(-1) - 16*m2**2*t2**(-1)*u2 - 48*
     +    m2**2*u2*u2t**(-1) + 16*m2**4*t2**(-1) + 32*s*t2**(-1)*u2 - 
     +    32*s*t2**(-1)*u2**2*u2t**(-1) - 16*s + 32*t2**(-1)*u2**2 - 32
     +    *t2**(-1)*u2**3*u2t**(-1) - 16*t2*u2*u2t**(-1) + 16*u2 - 16*
     +    u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(2,6,-1,-1)*(h_r2+h_l2)*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*t2*u2
     +     - 32*m1**2*s*t2*u2t**(-1) - 96*m1**2*s*u2*u2t**(-1) + 16*
     +    m1**2*s - 32*m1**2*s**2*u2t**(-1) - 32*m1**2*t2*u2*u2t**(-1)
     +     - 16*m1**2*t2 + 16*m1**2*u2 - 64*m1**2*u2**2*u2t**(-1) - 32*
     +    s**(-1)*t2*u2**2 - 16*s**(-1)*t2**2*u2 - 32*s**(-1)*u2**3 - 
     +    16*s*t2*u2*u2t**(-1) - 48*s*t2 - 16*s*t2**2*u2t**(-1) - 96*s*
     +    u2 - 16*s**2*t2*u2t**(-1) - 32*s**2 - 80*t2*u2 - 16*t2**2*u2*
     +    u2t**(-1) - 16*t2**2 - 96*u2**2 )
      MM_real_4 = MM_real_4 + ANG_fin(2,6,-1,-1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 32*m1**2*m2**2*t2**(-1) + 16*m1**2*s**(-1)
     +    *u2 - 48*m1**2*s*t2**(-1)*u2*u2t**(-1) - 16*m1**2*s*t2**(-1)
     +     + 32*m1**2*s*u2t**(-1) - 16*m1**2*t2**(-1)*u2 - 16*m1**2*u2*
     +    u2t**(-1) + 64*m1**2 - 16*m1**4*t2**(-1) - 16*m2**2*s**(-1)*
     +    u2 + 32*m2**2*s*t2**(-1)*u2*u2t**(-1) + 16*m2**2*t2**(-1)*u2
     +     + 32*m2**2*u2*u2t**(-1) - 48*m2**2 - 16*m2**4*t2**(-1) + 16*
     +    s**(-1)*t2*u2 + 16*s**(-1)*u2**2 - 32*s*t2**(-1)*u2 + 32*s*
     +    t2**(-1)*u2**2*u2t**(-1) + 16*s*t2*u2t**(-1) + 16*s - 32*
     +    t2**(-1)*u2**2 + 32*t2**(-1)*u2**3*u2t**(-1) + 32*t2*u2*
     +    u2t**(-1) + 32*u2 )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-2,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*t2 + 32*m1**2 + 
     +    16*m2**2*s**(-1)*t2 - 32*m2**2 )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-2,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 16*m1**2*s**(-1)*t2 - 16*m2**2*s**(-1)*t2
     +     )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*t2*u2*
     +    u2t**(-1) - 32*m1**2*s**(-1)*t2 - 16*m1**2*s**(-1)*t2**2*
     +    u2t**(-1) - 56*m1**2*s*u2t**(-1) - 72*m1**2*t2*u2t**(-1) - 80
     +    *m1**2*u2*u2t**(-1) + 24*m1**2 - 16*s**(-1)*t2*u2 + 64*
     +    s**(-1)*t2*u2**2*u2t**(-1) + 32*s**(-1)*t2**2*u2*u2t**(-1) - 
     +    16*s**(-1)*t2**2 + 32*s**(-1)*u2**3*u2t**(-1) + 64*s*t2*
     +    u2t**(-1) + 160*s*u2*u2t**(-1) + 64*s**2*u2t**(-1) + 144*t2*
     +    u2*u2t**(-1) - 32*t2 + 16*t2**2*u2t**(-1) + 128*u2**2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*m1**2*s**(-1) + 56*m1**2*
     +    u2t**(-1) + 32*m2**2*s**(-1) + 16*s**(-1)*t2*u2*u2t**(-1) + 
     +    16*s**(-1)*t2**2*u2t**(-1) - 16*s**(-1)*u2 - 64*s*u2t**(-1)
     +     - 96*u2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-1,0)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * ( 16*m1**2*s**(-1)*t2*u2*u2t**(-1) + 
     +    32*m1**2*s**(-1)*t2 + 16*m1**2*s**(-1)*t2**2*u2t**(-1) + 80*
     +    m1**2*s*u2t**(-1) + 80*m1**2*t2*u2t**(-1) + 96*m1**2*u2*
     +    u2t**(-1) + 16*s**(-1)*t2*u2 - 64*s**(-1)*t2*u2**2*u2t**(-1)
     +     - 32*s**(-1)*t2**2*u2*u2t**(-1) + 16*s**(-1)*t2**2 - 32*
     +    s**(-1)*u2**3*u2t**(-1) - 64*s*t2*u2t**(-1) - 160*s*u2*
     +    u2t**(-1) - 64*s**2*u2t**(-1) - 144*t2*u2*u2t**(-1) + 32*t2
     +     - 16*t2**2*u2t**(-1) - 128*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,-1,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 16*m1**2*s**(-1)*t2*u2t**(-1) + 16*m1**2*
     +    s**(-1)*u2*u2t**(-1) + 32*m1**2*s**(-1) - 16*m1**2*u2t**(-1)
     +     - 32*m2**2*s**(-1) - 16*s**(-1)*t2*u2*u2t**(-1) - 16*s**(-1)
     +    *t2**2*u2t**(-1) + 16*s**(-1)*u2 + 64*s*u2t**(-1) + 96*u2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*
     +    u2t**(-1) + 16*m1**2*u2t**(-2) + 16*m2**2*s**(-1)*u2t**(-1)
     +     - 16*m2**2*u2t**(-2) + 16*s**(-1)*t2*u2t**(-1) + 32*s**(-1)*
     +    u2*u2t**(-1) - 16*s**(-1) - 16*s*u2t**(-2) - 16*t2*u2t**(-2)
     +     )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 16*s**(-1)*u2t**(-1) + 16*
     +    u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,1,0)*(h_r2+h_l2)*Cf*s4**(-1)*
     + Pi**2*alphas**2*hardfac * ( 16*m1**2*s**(-1)*u2t**(-1) - 16*
     +    m1**2*u2t**(-2) - 16*m2**2*s**(-1)*u2t**(-1) + 16*m2**2*
     +    u2t**(-2) - 32*s**(-1)*u2*u2t**(-1) + 16*s**(-1) + 16*s*
     +    u2t**(-2) + 16*t2*u2t**(-2) + 16*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,0,1,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 16*s**(-1)*u2t**(-1) - 16*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-2,1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1) + 32*m1**2*
     +    u2t**(-1) + 16*m2**2*s**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-2,1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 16*m1**2*s**(-1) - 32*m1**2*u2t**(-1) - 16
     +    *m2**2*s**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * (  - 32*(s+t2)**(-1)*m1**2*m2**2 - 64*
     +    (s+t2)**(-1)*m1**2*s*u2*u2t**(-1) + 32*(s+t2)**(-1)*m1**2*s
     +     - 32*(s+t2)**(-1)*m1**2*t2 + 16*(s+t2)**(-1)*m1**4 + 32*
     +    (s+t2)**(-1)*m2**2*s + 32*(s+t2)**(-1)*m2**2*t2 + 16*
     +    (s+t2)**(-1)*m2**4 + 32*(s+t2)**(-1)*s*t2 - 32*(s+t2)**(-1)*s
     +    *u2 - 8*(s+t2)**(-1)*s**2*t2*u2t**(-1) + 32*(s+t2)**(-1)*s**2
     +     - 8*(s+t2)**(-1)*s**3*u2t**(-1) + 16*(s+t2)**(-1)*t2**2 + 16
     +    *(s+t2)**(-1)*u2**2 + 32*m1**2*m2**2*t2**(-1) - 48*m1**2*s*
     +    t2**(-1)*u2*u2t**(-1) - 16*m1**2*s*t2**(-1) - 32*m1**2*s*
     +    u2t**(-1) - 16*m1**2*t2**(-1)*u2 - 24*m1**2*t2*u2t**(-1) - 24
     +    *m1**2*u2*u2t**(-1) + 16*m1**2 - 16*m1**4*t2**(-1) + 32*m2**2
     +    *s*t2**(-1)*u2*u2t**(-1) + 16*m2**2*s*u2t**(-1) + 16*m2**2*
     +    t2**(-1)*u2 + 8*m2**2*t2*u2t**(-1) + 8*m2**2*u2*u2t**(-1) - 
     +    16*m2**2 - 16*m2**4*t2**(-1) - 32*s*t2**(-1)*u2 + 32*s*
     +    t2**(-1)*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,-1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 16*s*u2*u2t**(-1) - 48*s + 8*s**2*
     +    u2t**(-1) - 32*t2**(-1)*u2**2 + 32*t2**(-1)*u2**3*u2t**(-1)
     +     + 56*t2*u2*u2t**(-1) - 24*t2 + 16*t2**2*u2t**(-1) - 24*u2 + 
     +    72*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,-1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 32*m1**2*m2**2*t2**(-1) + 16*m1**2*
     +    s**(-1)*t2*u2*u2t**(-1) + 16*m1**2*s**(-1)*t2 + 16*m1**2*
     +    s**(-1)*t2**2*u2t**(-1) + 16*m1**2*s**(-1)*u2 + 48*m1**2*s*
     +    t2**(-1)*u2*u2t**(-1) + 16*m1**2*s*t2**(-1) + 32*m1**2*s*
     +    u2t**(-1) + 16*m1**2*t2**(-1)*u2 + 48*m1**2*t2*u2t**(-1) + 
     +    128*m1**2*u2*u2t**(-1) - 32*m1**2 + 16*m1**4*t2**(-1) - 16*
     +    m2**2*s**(-1)*t2 - 16*m2**2*s**(-1)*u2 - 32*m2**2*s*t2**(-1)*
     +    u2*u2t**(-1) - 16*m2**2*s*u2t**(-1) - 16*m2**2*t2**(-1)*u2 - 
     +    16*m2**2*t2*u2t**(-1) - 32*m2**2*u2*u2t**(-1) - 16*m2**2 + 16
     +    *m2**4*t2**(-1) + 16*s**(-1)*t2*u2 - 64*s**(-1)*t2*u2**2*
     +    u2t**(-1) - 48*s**(-1)*t2**2*u2*u2t**(-1) - 16*s**(-1)*t2**3*
     +    u2t**(-1) + 16*s**(-1)*u2**2 - 32*s**(-1)*u2**3*u2t**(-1) + 
     +    32*s*t2**(-1)*u2 - 32*s*t2**(-1)*u2**2*u2t**(-1) - 16*s*u2*
     +    u2t**(-1) + 16*s + 32*t2**(-1)*u2**2 - 32*t2**(-1)*u2**3*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,-1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 64*t2*u2*u2t**(-1) + 32*t2 - 16*t2**2*
     +    u2t**(-1) + 80*u2 - 96*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,1)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * (  - 16*m1**2*s**(-1)*t2*
     +    u2t**(-1) - 16*m1**2*s**(-1)*u2*u2t**(-1) - 32*m1**2*s**(-1)
     +     - 32*m1**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,1)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 32*(s+t2)**(-1) + 16*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,1)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * (  - 48 + 64*m1**2*m2**2*s**(-1)*
     +    u2t**(-1) + 16*m1**2*s**(-1)*u2*u2t**(-1) + 64*m1**2*s**(-1)
     +     - 16*m1**2*u2t**(-1) - 64*m1**4*s**(-1)*u2t**(-1) + 48*m2**2
     +    *s**(-1)*t2*u2t**(-1) + 48*m2**2*u2t**(-1) + 64*s**(-1)*t2*u2
     +    *u2t**(-1) - 16*s**(-1)*t2 + 64*s**(-1)*t2**2*u2t**(-1) - 32*
     +    s**(-1)*u2 - 64*s*t2*u2t**(-2) + 16*s*u2t**(-1) - 32*s**2*
     +    u2t**(-2) + 80*t2*u2t**(-1) - 32*t2**2*u2t**(-2) + 64*u2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,1)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 64*m1**2*s**(-1)*u2t**(-1) - 96*m2**2*
     +    s**(-1)*u2t**(-1) - 112*s**(-1)*t2*u2t**(-1) - 160*s**(-1)*u2
     +    *u2t**(-1) + 96*s**(-1) + 32*s*u2t**(-2) + 32*t2*u2t**(-2) - 
     +    64*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,2)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * ( 16*s**(-1)*t2*u2t**(-1) + 16*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(5,6,-1,2)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 32*s**(-1)*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-2,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 64*m1**2*m2**2*u2t**(-1) + 32*m1**2*
     +    t2*u2t**(-1) + 128*m1**2*u2*u2t**(-1) - 64*m1**2 - 64*m1**4*
     +    m2**2*u2t**(-2) - 64*m1**4*u2t**(-1) + 64*m1**6*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-2,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * (  - 64*m1**2*m2**2*u2t**(-1) - 32*m1**2*t2*
     +    u2t**(-1) - 128*m1**2*u2*u2t**(-1) + 64*m1**2 + 64*m1**4*
     +    m2**2*u2t**(-2) + 64*m1**4*u2t**(-1) - 64*m1**6*u2t**(-2) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 64 - 64*(s+t2)**(-1)*m1**2*m2**2*
     +    u2t**(-1) + 64*(s+t2)**(-1)*m1**4*u2t**(-1) - 80*(s+t2)**(-1)
     +    *s + 32*(s+t2)**(-1)*s**2*t2*u2t**(-2) + 32*(s+t2)**(-1)*s**3
     +    *u2t**(-2) - 64*(s+t2)**(-1)*t2 + 64*(s+t2)**(-1)*u2 - 64*
     +    m1**2*m2**2*u2t**(-2) - 16*m1**2*s*u2t**(-2) - 16*m1**2*t2*
     +    u2t**(-2) + 64*m1**4*u2t**(-2) + 16*m2**2*s*u2t**(-2) + 16*
     +    m2**2*t2*u2t**(-2) + 32*m2**2*u2t**(-1) - 32*s**2*u2t**(-2)
     +     + 32*t2*u2t**(-1) + 80*u2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-1,0)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * ( 96*m1**2*m2**2*s**(-1)*t2*u2t**(-1)
     +     + 128*m1**2*m2**2*s**(-1)*u2*u2t**(-1) + 32*m1**2*m2**2*
     +    s**(-1) + 32*m1**2*m2**2*u2t**(-1) + 64*m1**2*m2**4*s**(-1)*
     +    u2t**(-1) - 32*m1**2*s**(-1)*t2*u2*u2t**(-1) + 64*m1**2*
     +    s**(-1)*t2 - 32*m1**2*s**(-1)*t2**2*u2t**(-1) + 96*m1**2*
     +    s**(-1)*u2 + 64*m1**2*s*t2*u2t**(-2) - 112*m1**2*s*u2t**(-1)
     +     + 32*m1**2*s**2*u2t**(-2) - 144*m1**2*t2*u2t**(-1) + 32*
     +    m1**2*t2**2*u2t**(-2) - 160*m1**2*u2*u2t**(-1) + 128*m1**2 - 
     +    128*m1**4*m2**2*s**(-1)*u2t**(-1) + 128*m1**4*m2**2*u2t**(-2)
     +     - 128*m1**4*s**(-1)*t2*u2t**(-1) - 128*m1**4*s**(-1)*u2*
     +    u2t**(-1) - 32*m1**4*s**(-1) + 128*m1**4*s*u2t**(-2) + 128*
     +    m1**4*t2*u2t**(-2) + 64*m1**4*u2t**(-1) + 64*m1**6*s**(-1)*
     +    u2t**(-1) - 128*m1**6*u2t**(-2) + 96*m2**2*s**(-1)*t2*u2*
     +    u2t**(-1) - 16*m2**2*s**(-1)*t2 + 96*m2**2*s**(-1)*t2**2*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-1,0)*(h_r2+h_l2)*Cf*s4**(-1)
     + *Pi**2*alphas**2*hardfac * (  - 32*m2**2*s**(-1)*u2 - 64*m2**2*s
     +    *t2*u2t**(-2) + 48*m2**2*s*u2t**(-1) - 32*m2**2*s**2*
     +    u2t**(-2) + 144*m2**2*t2*u2t**(-1) - 32*m2**2*t2**2*u2t**(-2)
     +     + 96*m2**2*u2*u2t**(-1) - 48*m2**2 + 32*m2**4*s**(-1)*t2*
     +    u2t**(-1) + 32*m2**4*u2t**(-1) - 128*s**(-1)*t2*u2 + 64*
     +    s**(-1)*t2*u2**2*u2t**(-1) + 128*s**(-1)*t2**2*u2*u2t**(-1)
     +     - 48*s**(-1)*t2**2 + 64*s**(-1)*t2**3*u2t**(-1) - 96*s**(-1)
     +    *u2**2 - 128*s*t2*u2*u2t**(-2) - 16*s*t2*u2t**(-1) - 192*s*
     +    t2**2*u2t**(-2) + 32*s*u2*u2t**(-1) - 128*s - 192*s**2*t2*
     +    u2t**(-2) - 64*s**2*u2*u2t**(-2) - 32*s**2*u2t**(-1) - 64*
     +    s**3*u2t**(-2) + 160*t2*u2*u2t**(-1) - 176*t2 - 64*t2**2*u2*
     +    u2t**(-2) + 80*t2**2*u2t**(-1) - 64*t2**3*u2t**(-2) - 224*u2
     +     + 64*u2**2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(6,0,-1,0)*(h_r2+h_l2)*Cf*Pi**2*
     + alphas**2*hardfac * ( 240 + 32*m1**2*m2**2*s**(-1)*u2t**(-1) + 
     +    64*m1**2*m2**2*u2t**(-2) + 176*m1**2*s**(-1)*t2*u2t**(-1) + 
     +    160*m1**2*s**(-1)*u2*u2t**(-1) - 32*m1**2*s**(-1) - 16*m1**2*
     +    s*u2t**(-2) - 16*m1**2*t2*u2t**(-2) + 208*m1**2*u2t**(-1) + 
     +    32*m1**4*s**(-1)*u2t**(-1) - 192*m1**4*u2t**(-2) - 224*m2**2*
     +    s**(-1)*t2*u2t**(-1) - 224*m2**2*s**(-1)*u2*u2t**(-1) + 32*
     +    m2**2*s**(-1) + 16*m2**2*s*u2t**(-2) + 16*m2**2*t2*u2t**(-2)
     +     - 192*m2**2*u2t**(-1) - 64*m2**4*s**(-1)*u2t**(-1) - 352*
     +    s**(-1)*t2*u2*u2t**(-1) + 224*s**(-1)*t2 - 112*s**(-1)*t2**2*
     +    u2t**(-1) + 224*s**(-1)*u2 - 224*s**(-1)*u2**2*u2t**(-1) + 
     +    128*s*t2*u2t**(-2) + 64*s*u2*u2t**(-2) - 32*s*u2t**(-1) + 64*
     +    s**2*u2t**(-2) + 64*t2*u2*u2t**(-2) - 112*t2*u2t**(-1) + 64*
     +    t2**2*u2t**(-2) - 256*u2*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(7,0,1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + s4**(-1)*Pi**2*alphas**2*hardfac * ( 16*m1**2*u2t**(-2) - 16*
     +    m2**2*u2t**(-2) - 16*s**(-1)*t2*u2t**(-1) - 16*s**(-1) - 16*
     +    u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(7,0,1,0)*(h_r2+h_l2)*Nc**2*Cf*
     + Pi**2*alphas**2*hardfac * ( 32*s**(-1)*u2t**(-1) )
      MM_real_4 = MM_real_4 + ANG_fin(7,0,1,0)*(h_r2+h_l2)*Cf*s4**(-1)*
     + Pi**2*alphas**2*hardfac * (  - 16*m1**2*u2t**(-2) + 16*m2**2*
     +    u2t**(-2) + 16*s**(-1) )

c               the phase space except for 1/s**2 
      HT_QGH = MM_real_4 / ( 16.D0 * pi**2 )**2 / 2.D0 * s4/(s4+m1**2)

c               the averaging factors
      HT_QGH = HT_QGH /4.D0 /Nc /(Nc**2-1.D0)

c               the luminosity
      HT_QGH = HT_QGH *lumi(1)

      return
      end
