C**********************************************************************
C***
C***  THIS ARE THE FUNCTIONS FOR THE STOP-ANTISTOP PROCESS
C***
C**********************************************************************

      REAL*8 FUNCTION DSTGG1(ALPHAS,S,T1,MST1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF VIRTUAL
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,MST1,MG,SCA,PI,BETAL,PGG,DSTGGB,NF
      PI = 4.D0*ATAN(1.D0)
      NF = 5.D0
      U1 = -S -T1
      BETAL = -11.D0 + 2.D0/3.D0*NF
      PGG = 3.D0*(-2.D0*LOG(-T1/MST1**2) -2*LOG(-U1/MST1**2) 
     +            +11.D0/3.D0)  -2.D0/3.D0*NF
      DSTGG1 = DSTGGB(ALPHAS,S,T1,MST1,MG)*
     +     ALPHAS/2.D0/PI*LOG(1.D0/SCA)*( BETAL +PGG)
      RETURN
      END


      REAL*8 FUNCTION DSTGG2(ALPHAS,S,T1,S4,MST1,MG,DEL,S4MAX,SCA)
C***  GIVES THE SCALE DEPENDENCE OF LOG(DEL)
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,S4,S4MAX,MST1,MG,SCA,PI,DSTGGB,DLDEL1,DEL
      PI = 4.D0*ATAN(1.D0)
      DLDEL1 = LOG(S4MAX/MST1**2) -(S4MAX -DEL)/S4
      DSTGG2 = 3.D0*4.D0*DLDEL1*DSTGGB(ALPHAS,S,T1,MST1,MG)
     +     * ALPHAS/2.D0/PI*LOG(1.D0/SCA)
      RETURN
      END


      REAL*8 FUNCTION DSTGG3(ALPHAS,S,T1,S4,MST1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,S4,MST1,MG,PI
      REAL*8 DSTGGB,PGG1,PGG2,SCA,X1,X2
      PI = 4.D0*ATAN(1.D0)
      U1 = S4 -S -T1
      X1 = -U1/(S+T1)
      X2 = -T1/(S+U1)
      PGG1 = 3.D0*( 2.D0/(1.D0 -X1) +2.D0/X1 -4.D0 +2.D0*X1 -2.D0*X1**2)
      PGG2 = 3.D0*( 2.D0/(1.D0 -X2) +2.D0/X2 -4.D0 +2.D0*X2 -2.D0*X2**2)
      DSTGG3 = ALPHAS/2.D0/PI*LOG(1.D0/SCA) *
     +     (-1/U1*DSTGGB(ALPHAS,X1*S,X1*T1,MST1,MG)*PGG1*X1**2
     +      -1/T1*DSTGGB(ALPHAS,X2*S,T1,MST1,MG)*PGG2*X2**2 )
      RETURN
      END

      REAL*8 FUNCTION DSTGGB(ALPHAS,S,T1,MST1,MG)
C***  BORN CROSS SECTIONS FOR G + G -> ST + STB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,MST1,MG,MST12
      REAL*8 CONV,PI,N,CO,CK,AVG
      CONV = 389379660.D0
      PI = 4.D0*ATAN(1.D0)
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2
      U1 = -S -T1
      MST12 = MST1**2
      DSTGGB = ALPHAS**2 * CONV *AVG *PI/S**2 *
     +     ( CO*(1.D0 -2.D0*T1*U1/S**2) -CK ) * 
     +     (2.D0 - 4.D0*S*MST12/T1/U1*(1.D0 -S*MST12/T1/U1) )
      RETURN
      END


      REAL*8 FUNCTION DSTGGV(ALPHAS,S,T1,MST1,MG,MT,MS,MST2,sin2t)
C***  CROSS SECTIONS FOR G + G -> ST + STB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T,T1,U,U1,SB,S1,MS,MG,MT,MS2,MG2,MT2
      REAL*8 MST1,MST2,MST12,MST22
      REAL*8 sin2t
      REAL*8 NF,CONV,PI,ZETA2,N,CO,CK,CQED,AVG,BETA,XS,SPENCE
      REAL*8 SK3B0A(1:5), SK3B0B(1:6), SK3B0C(1:2), SK3B0D(1:2,1:2)
      REAL*8 SK3BP(1:3), SK3C0A(1:8), SK3C0B(1:4)
      REAL*8 SK3C0C(1:5,1:2), SK3D0(1:7,1:2)
      REAL*8 SL3B0A, SL3B0B, SL3B0C, SL3B0D
      REAL*8 SL3BP, SL3C0A, SL3C0B
      REAL*8 SL3C0C, SL3D0
      REAL*8 SOF1(1:8)
      REAL*8 M2GGSV,DSTGGB
      PI = 4.D0*ATAN(1.D0)
      ZETA2 = PI**2/6.D0
      CONV = 389379660.D0

      NF = 5D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2-1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2

      MST12 = MST1**2
      MG2 = MG**2
      MT2 = MT**2
      MST22 = MST2**2
      MS2 = MS**2

      S1 = 4.D0*MST12 - S
      U1 = -S -T1
      T = T1 +MST12
      U = U1 +MST12

      BETA = SQRT(1.D0 - 4.D0*MST12/S)
      XS = (1.D0 -BETA)*(1.D0+BETA)**(-1)
      SB = S*BETA

      SK3B0A(1) = SL3B0A(MST12,mg2,mg2,1)
      SK3B0A(2) = SL3B0A(MST12,mt2,mt2,1)
      SK3B0A(3) = SL3B0A(MST12,mg2,ms2,2)
      SK3B0A(4) = SL3B0A(MST12,ms2,ms2,1)
      SK3B0A(5) = SL3B0A(MST12,mst22,mst22,1)

      SK3B0B(1) = SL3B0B(S,MST12,0D0,1)
      SK3B0B(2) = SL3B0B(S,MST12,MST12,2)
      SK3B0B(3) = SL3B0B(S,MST12,MG2,2)
      SK3B0B(4) = SL3B0B(S,MST12,MT2,2)
      SK3B0B(5) = SL3B0B(S,MST12,MS2,2)
      SK3B0B(6) = SL3B0B(S,MST12,MST22,2)

      SK3B0C(1) = SL3B0C(MST12,0D0,0D0,1)
      SK3B0C(2) = SL3B0C(MST12,MG2,MT2,2)

      SK3B0D(1,1) = SL3B0D(T,MST12,0D0,0D0,1)
      SK3B0D(2,1) = SL3B0D(T,MST12,MG2,MT2,2)

      SK3B0D(1,2) = SL3B0D(U,MST12,0D0,0D0,1)
      SK3B0D(2,2) = SL3B0D(U,MST12,MG2,MT2,2)

      SK3BP(1) = SL3BP(MST12,0D0,0D0,1)
      SK3BP(2) = SL3BP(MST12,Mg2,Mt2,2)
      SK3BP(3) = SL3BP(MST12,Mg2,ms2,3)

      SK3C0A(1) = SL3C0A(S,MST12,0D0,0D0,1)
      SK3C0A(2) = SL3C0A(S,MST12,mst12,mst12,2)
      SK3C0A(3) = SL3C0A(S,MST12,mg2,mg2,2)
      SK3C0A(4) = SL3C0A(S,MST12,mt2,mt2,2)
c$$$      SK3C0A(5) = SL3C0A(S,MST12,ms2,mg2,3)
c$$$      SK3C0A(6) = SL3C0A(S,MST12,mg2,ms2,3)
      SK3C0A(7) = SL3C0A(S,MST12,ms2,ms2,2)
      SK3C0A(8) = SL3C0A(S,MST12,mst22,mst22,2)

      SK3C0B(1) = SL3C0B(S,MST12,0D0,0D0,1)
      SK3C0B(2) = SL3C0B(S,MST12,mst12,mst12,2)
      SK3C0B(3) = SL3C0B(S,MST12,mt2,mg2,3)
      SK3C0B(4) = SL3C0B(S,MST12,mg2,mt2,3)

      SK3C0C(1,1) = SL3C0C(T,MST12,0D0,0D0,0D0,1)
c$$$      SK3C0C(2,1) = SL3C0C(T,MST12,MS2,MG2,MT2,2)
      SK3C0C(3,1) = SL3C0C(T,MST12,0D0,0D0,0D0,3)
      SK3C0C(4,1) = SL3C0C(T,MST12,Mg2,MG2,MT2,2)
      SK3C0C(5,1) = SL3C0C(T,MST12,Mt2,Mt2,Mg2,2)

      SK3C0C(1,2) = SL3C0C(U,MST12,0D0,0D0,0D0,1)
c$$$      SK3C0C(2,2) = SL3C0C(U,MST12,MS2,MG2,MT2,2)
      SK3C0C(3,2) = SL3C0C(U,MST12,0D0,0D0,0D0,3)
      SK3C0C(4,2) = SL3C0C(U,MST12,Mg2,MG2,MT2,2)
      SK3C0C(5,2) = SL3C0C(U,MST12,Mt2,Mt2,Mg2,2)

      SK3D0(1,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,1)
      SK3D0(2,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,2)
      SK3D0(3,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,3)
      SK3D0(4,1) = SL3D0(S,T,U,MST12,mg2,mt2,0D0,4)
      SK3D0(5,1) = SL3D0(S,T,U,MST12,mt2,mg2,0D0,4)
      SK3D0(6,1) = SL3D0(S,T,U,MST12,mg2,mt2,0D0,5)
c$$$      SK3D0(7,1) = SL3D0(S,T,U,MST12,mt2,mg2,ms2,6)

      SK3D0(1,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,1)
      SK3D0(2,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,2)
      SK3D0(3,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,3)
      SK3D0(4,2) = SL3D0(S,U,T,MST12,mg2,mt2,0D0,4)
      SK3D0(5,2) = SL3D0(S,U,T,MST12,mt2,mg2,0D0,4)
      SK3D0(6,2) = SL3D0(S,U,T,MST12,mg2,mt2,0D0,5)
c$$$      SK3D0(7,2) = SL3D0(S,U,T,MST12,mt2,mg2,ms2,6)


      SOF1(1) = 0.125D0/SB * ( +4*SPENCE(XS) +4*SPENCE(-XS) 
     +     +4*LOG(XS)*LOG(1-XS**2)-2*LOG(XS)**2 -2*ZETA2 )
      SOF1(2) = 0.125D0/MST12* (+2*(S -2*MST12)/SB*LOG(XS))
      SOF1(3) = 0.125D0/MST12*(-2)
      SOF1(4) = 0.125D0/U1*(-1.5D0*ZETA2)
      SOF1(5) = 0.125D0/T1*(-1.5D0*ZETA2)
      SOF1(6) = 0.125D0/T1*(-2*LOG(XS)**2 +LOG(XS*U1/T1)**2 
     +     +2*SPENCE(1 -T1/XS/U1) -2*SPENCE(1 -U1/XS/T1) -1.5D0*ZETA2 )
      SOF1(7) = 0.125D0/U1*(-2*LOG(XS)**2 +LOG(XS*T1/U1)**2 
     +     +2*SPENCE(1 -U1/XS/T1) -2*SPENCE(1 -T1/XS/U1) -1.5D0*ZETA2)
      SOF1(8) = 0.125D0/S*(LOG(T1*U1/MST12/S)**2
     +     +2*SPENCE(1 -MST12*S/T1/U1) -3*ZETA2 )

 
      M2GGSV = 0D0
     +  + N*CO * (  - 6.75D+0 + 4.D+0*s**(-2)*t1*u1 - s**(-2)*t1**2 + 
     +    5.D+0*s**(-2)*u1**2 + 1.5D+0*s**(-1)*t**(-1)*t1**(-2)*u1*
     +    mst12**3 + 2.25D+0*s**(-1)*t**(-1)*t1**(-1)*u1*mst12**2 + 
     +    7.5D-1*s**(-1)*t**(-1)*u1*mst12 + 1.5D+0*s**(-1)*u**(-1)*t1*
     +    u1**(-2)*mst12**3 + 2.25D+0*s**(-1)*u**(-1)*t1*u1**(-1)*
     +    mst12**2 + 7.5D-1*s**(-1)*u**(-1)*t1*mst12 - 1.5D+0*s**(-1)*
     +    t1**(-2)*u1*mst12**2 - 3.D+0*s**(-1)*t1**(-1)*u1*mst12 - 
     +    1.5D+0*s**(-1)*t1*u1**(-2)*mst12**2 - 3.D+0*s**(-1)*t1*
     +    u1**(-1)*mst12 - 7.75D+0*s**(-1)*t1 - 1.75D+0*s**(-1)*u1 - 
     +    4.5D+0*s**(-1)*mst12 - 2.25D+0*t1**(-1)*mst12 - 2.25D+0*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + N*CK * ( 1.2D+1 - 8.D+0*s**(-2)*t1*u1 - 4.D+0*
     +    s**(-2)*t1**2 - 4.D+0*s**(-2)*u1**2 - 4.D+0*s**(-1)*t**(-1)*
     +    t1**(-2)*u1*mst12**3 - 6.D+0*s**(-1)*t**(-1)*t1**(-1)*u1*
     +    mst12**2 - 2.D+0*s**(-1)*t**(-1)*u1*mst12 - 4.D+0*s**(-1)*
     +    u**(-1)*t1*u1**(-2)*mst12**3 - 6.D+0*s**(-1)*u**(-1)*t1*
     +    u1**(-1)*mst12**2 - 2.D+0*s**(-1)*u**(-1)*t1*mst12 + 4.D+0*
     +    s**(-1)*t1**(-2)*u1*mst12**2 + 3.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12 + 4.D+0*s**(-1)*t1*u1**(-2)*mst12**2 + 3.D+0*s**(-1)*t1
     +    *u1**(-1)*mst12 + 8.D+0*s**(-1)*t1 + 8.D+0*s**(-1)*u1 + 2.D+0
     +    *s**(-1)*mst12 + t**(-1)*t1**(-2)*mst12**3 - t**(-1)*t1**(-1)
     +    *u1**(-1)*mst12**3 + 1.5D+0*t**(-1)*t1**(-1)*mst12**2 - 
     +    t**(-1)*u1**(-1)*mst12**2 + 5.D-1*t**(-1)*mst12 - u**(-1)*
     +    t1**(-1)*u1**(-1)*mst12**3 - u**(-1)*t1**(-1)*mst12**2 + 
     +    u**(-1)*u1**(-2)*mst12**3 + 1.5D+0*u**(-1)*u1**(-1)*mst12**2
     +     + 5.D-1*u**(-1)*mst12 - t1**(-2)*mst12**2 + 2.D+0*t1**(-1)*
     +    u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + N*CK * ( 5.D-1*t1**(-1)*mst12 - u1**(-2)*
     +    mst12**2 + 5.D-1*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + CQED * (  - 4.D+0 - 4.D+0*s**(-1)*t1 - 4.D+0*
     +    s**(-1)*u1 + 2.D+0*s*t1**(-1)*u1**(-1)*mst12 - 4.D+0*t**(-1)*
     +    t1**(-2)*mst12**3 - 6.D+0*t**(-1)*t1**(-1)*mst12**2 - 2.D+0*
     +    t**(-1)*mst12 - 4.D+0*u**(-1)*u1**(-2)*mst12**3 - 6.D+0*
     +    u**(-1)*u1**(-1)*mst12**2 - 2.D+0*u**(-1)*mst12 + 4.D+0*
     +    t1**(-2)*mst12**2 + 4.D+0*t1**(-1)*mst12 + 4.D+0*u1**(-2)*
     +    mst12**2 + 4.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0A(1)*N*CO * ( 8.D+0*s**(-3)*t1**2*mg2 - 
     +    8.D+0*s**(-3)*u1**2*mg2 + 8.D+0*s**(-2)*t1**(-1)*u1*mg2*mst12
     +     + 8.D+0*s**(-2)*t1*u1**(-1)*mg2*mst12 + 8.D+0*s**(-2)*t1*mg2
     +     - 2.666666666666666D+0*s**(-2)*t1**2 - 8.D+0*s**(-2)*u1*mg2
     +     - 2.666666666666666D+0*s**(-2)*u1**2 - 1.6D+1*s**(-2)*mg2*
     +    mst12 + 5.333333333333333D+0*s**(-1)*t1**(-1)*u1*mst12 + 
     +    5.333333333333333D+0*s**(-1)*t1*u1**(-1)*mst12 - 
     +    5.333333333333333D+0*t1**(-2)*mst12**2 - 5.333333333333333D+0
     +    *u1**(-2)*mst12**2 )
      M2GGSV = M2GGSV + SK3B0A(1)*N*CK * (  - 2.666666666666666D+0*
     +    s**(-1)*t1 - 2.666666666666666D+0*s**(-1)*u1 - 
     +    5.333333333333333D+0*s*t1**(-2)*u1**(-1)*mst12**2 - 
     +    5.333333333333333D+0*s*t1**(-1)*u1**(-2)*mst12**2 + 
     +    5.333333333333333D+0*t1**(-1)*mst12 + 5.333333333333333D+0*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0A(2)*CO * ( 8.D+0*s**(-3)*t1**2*mt2 - 
     +    8.D+0*s**(-3)*u1**2*mt2 + 8.D+0*s**(-2)*t1**(-1)*u1*mt2*mst12
     +     + 8.D+0*s**(-2)*t1*u1**(-1)*mt2*mst12 + 8.D+0*s**(-2)*t1*mt2
     +     - 2.666666666666666D+0*s**(-2)*t1**2 - 8.D+0*s**(-2)*u1*mt2
     +     - 2.666666666666666D+0*s**(-2)*u1**2 - 1.6D+1*s**(-2)*mt2*
     +    mst12 + 5.333333333333333D+0*s**(-1)*t1**(-1)*u1*mst12 + 
     +    5.333333333333333D+0*s**(-1)*t1*u1**(-1)*mst12 - 
     +    5.333333333333333D+0*t1**(-2)*mst12**2 - 5.333333333333333D+0
     +    *u1**(-2)*mst12**2 )
      M2GGSV = M2GGSV + SK3B0A(2)*CK * (  - 2.666666666666666D+0*
     +    s**(-1)*t1 - 2.666666666666666D+0*s**(-1)*u1 - 
     +    5.333333333333333D+0*s*t1**(-2)*u1**(-1)*mst12**2 - 
     +    5.333333333333333D+0*s*t1**(-1)*u1**(-2)*mst12**2 + 
     +    5.333333333333333D+0*t1**(-1)*mst12 + 5.333333333333333D+0*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0A(4)*CO * (  - 8.D+0*s**(-3)*t1**2*nf*ms2
     +     + 8.D+0*s**(-3)*u1**2*nf*ms2 - 8.D+0*s**(-2)*t1**(-1)*u1*nf*
     +    ms2*mst12 - 8.D+0*s**(-2)*t1*u1**(-1)*nf*ms2*mst12 - 8.D+0*
     +    s**(-2)*t1*nf*ms2 - 1.333333333333333D+0*s**(-2)*t1**2*nf + 
     +    8.D+0*s**(-2)*u1*nf*ms2 - 1.333333333333333D+0*s**(-2)*u1**2*
     +    nf + 1.6D+1*s**(-2)*nf*ms2*mst12 + 2.666666666666666D+0*
     +    s**(-1)*t1**(-1)*u1*nf*mst12 + 2.666666666666666D+0*s**(-1)*
     +    t1*u1**(-1)*nf*mst12 - 2.666666666666666D+0*t1**(-2)*nf*
     +    mst12**2 - 2.666666666666666D+0*u1**(-2)*nf*mst12**2 )
      M2GGSV = M2GGSV + SK3B0A(4)*CK * (  - 1.333333333333333D+0*
     +    s**(-1)*t1*nf - 1.333333333333333D+0*s**(-1)*u1*nf - 
     +    2.666666666666666D+0*s*t1**(-2)*u1**(-1)*nf*mst12**2 - 
     +    2.666666666666666D+0*s*t1**(-1)*u1**(-2)*nf*mst12**2 + 
     +    2.666666666666666D+0*t1**(-1)*nf*mst12 + 2.666666666666666D+0
     +    *u1**(-1)*nf*mst12 )
      M2GGSV = M2GGSV + SK3B0A(5)*CO * (  - 4.D+0*s**(-3)*t1**2*mst22
     +     + 4.D+0*s**(-3)*u1**2*mst22 - 4.D+0*s**(-2)*t1**(-1)*u1*
     +    mst12*mst22 - 4.D+0*s**(-2)*t1*u1**(-1)*mst12*mst22 - 4.D+0*
     +    s**(-2)*t1*mst22 - 6.666666666666666D-1*s**(-2)*t1**2 + 4.D+0
     +    *s**(-2)*u1*mst22 - 6.666666666666666D-1*s**(-2)*u1**2 + 
     +    8.D+0*s**(-2)*mst12*mst22 + 1.333333333333333D+0*s**(-1)*
     +    t1**(-1)*u1*mst12 + 1.333333333333333D+0*s**(-1)*t1*u1**(-1)*
     +    mst12 - 1.333333333333333D+0*t1**(-2)*mst12**2 - 
     +    1.333333333333333D+0*u1**(-2)*mst12**2 )
      M2GGSV = M2GGSV + SK3B0A(5)*CK * (  - 6.666666666666666D-1*
     +    s**(-1)*t1 - 6.666666666666666D-1*s**(-1)*u1 - 
     +    1.333333333333333D+0*s*t1**(-2)*u1**(-1)*mst12**2 - 
     +    1.333333333333333D+0*s*t1**(-1)*u1**(-2)*mst12**2 + 
     +    1.333333333333333D+0*t1**(-1)*mst12 + 1.333333333333333D+0*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0B(1)*N*CO * (  - 3.5D+0 + 4.D+0*s**(-2)*t1
     +    *u1 - 3.D+0*s**(-2)*t1**2 - s**(-2)*u1**2 + 1.5D+0*s**(-1)*
     +    t1**(-1)*u1*mst12 + s**(-1)*t1**(-1)*u1**2 + 1.5D+0*s**(-1)*
     +    t1*u1**(-1)*mst12 + 5.D-1*s**(-1)*t1 + s**(-1)*t1**2*u1**(-1)
     +     + 8.D+0*s**(-1)*t1**2*s1**(-1) + 2.5D+0*s**(-1)*u1 - 5.D+0*
     +    s**(-1)*mst12 - s*t1**(-1) - s*u1**(-1) + 8.D+0*t1**(-1)*
     +    s1**(-1)*mst12**2 - 2.5D+0*t1**(-1)*mst12 + 8.D+0*t1*s1**(-1)
     +     + 8.D+0*u1**(-1)*s1**(-1)*mst12**2 - 2.5D+0*u1**(-1)*mst12
     +     + 1.6D+1*s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0B(2)*N*CK * ( 4.25D+0 + 8.D+0*s**(-2)*
     +    t1**2 + 8.5D+0*s**(-1)*t1 + 2.5D-1*s**(-1)*t1**2*u1**(-1) - 
     +    8.D+0*s**(-1)*t1**2*s1**(-1) + 2.5D-1*s**(-1)*u1 + 8.D+0*
     +    s**(-1)*mst12 - 8.D+0*t1**(-1)*s1**(-1)*mst12**2 + 4.D+0*
     +    t1**(-1)*mst12 + 2.5D-1*t1*u1**(-1) - 8.D+0*t1*s1**(-1) - 
     +    8.D+0*u1**(-1)*s1**(-1)*mst12**2 + 4.D+0*u1**(-1)*mst12 - 
     +    1.6D+1*s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0B(2)*CO * ( 4.D+0*s**(-3)*t1**2*mst12 - 
     +    4.D+0*s**(-3)*u1**2*mst12 + 4.D+0*s**(-2)*t1**(-1)*u1*
     +    mst12**2 + 4.D+0*s**(-2)*t1*u1**(-1)*mst12**2 + 4.D+0*s**(-2)
     +    *t1*mst12 - 4.D+0*s**(-2)*u1*mst12 - 8.D+0*s**(-2)*mst12**2 )
      M2GGSV = M2GGSV + SK3B0B(2)*CQED * ( 5.D-1 + 5.D-1*s*u1**(-1) + 
     +    5.D-1*t1*u1**(-1) )
      M2GGSV = M2GGSV + SK3B0B(3)*N*CO * ( 2.D+0 - 8.D+0*s**(-3)*t1**2*
     +    mg2 + 8.D+0*s**(-3)*u1**2*mg2 - 8.D+0*s**(-2)*t1**(-1)*u1*mg2
     +    *mst12 - 8.D+0*s**(-2)*t1*u1**(-1)*mg2*mst12 - 8.D+0*s**(-2)*
     +    t1*mg2 + 3.2D+1*s**(-2)*t1**2*mg*mt*s1**(-1)*sin2t - 1.6D+1*
     +    s**(-2)*t1**2*s1**(-1)*mg2 - 1.6D+1*s**(-2)*t1**2*s1**(-1)*
     +    mt2 + 4.D+0*s**(-2)*t1**2 + 8.D+0*s**(-2)*u1*mg2 + 1.6D+1*
     +    s**(-2)*mg2*mst12 + 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*sin2t - 
     +    1.6D+1*s**(-1)*t1*s1**(-1)*mg2 - 1.6D+1*s**(-1)*t1*s1**(-1)*
     +    mt2 + 4.D+0*s**(-1)*t1 - 4.D+0*s**(-1)*t1**2*s1**(-1) + 8.D+0
     +    *s**(-1)*mg*mt*sin2t - 4.D+0*s**(-1)*mg2 - 4.D+0*s**(-1)*mt2
     +     + 4.D+0*s**(-1)*mst12 + 8.D+0*t1**(-1)*mg*mt*s1**(-1)*mst12*
     +    sin2t - 4.D+0*t1**(-1)*s1**(-1)*mg2*mst12 - 4.D+0*t1**(-1)*
     +    s1**(-1)*mt2*mst12 - 4.D+0*t1**(-1)*s1**(-1)*mst12**2 + 2.D+0
     +    *t1**(-1)*mst12 - 4.D+0*t1*s1**(-1) + 8.D+0*u1**(-1)*mg*mt*
     +    s1**(-1)*mst12*sin2t - 4.D+0*u1**(-1)*s1**(-1)*mg2*mst12 - 
     +    4.D+0*u1**(-1)*s1**(-1)*mt2*mst12 )
      M2GGSV = M2GGSV + SK3B0B(3)*N*CO * (  - 4.D+0*u1**(-1)*s1**(-1)*
     +    mst12**2 + 2.D+0*u1**(-1)*mst12 + 1.6D+1*mg*mt*s1**(-1)*sin2t
     +     - 8.D+0*s1**(-1)*mg2 - 8.D+0*s1**(-1)*mt2 - 8.D+0*s1**(-1)*
     +    mst12 )
      M2GGSV = M2GGSV + SK3B0B(4)*N*CK * (  - 2.D+0 - 3.2D+1*s**(-2)*
     +    t1**2*mg*mt*s1**(-1)*sin2t + 1.6D+1*s**(-2)*t1**2*s1**(-1)*
     +    mg2 + 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2 - 4.D+0*s**(-2)*t1**2
     +     - 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*sin2t + 1.6D+1*s**(-1)*t1
     +    *s1**(-1)*mg2 + 1.6D+1*s**(-1)*t1*s1**(-1)*mt2 - 4.D+0*
     +    s**(-1)*t1 + 4.D+0*s**(-1)*t1**2*s1**(-1) - 8.D+0*s**(-1)*mg*
     +    mt*sin2t + 4.D+0*s**(-1)*mg2 + 4.D+0*s**(-1)*mt2 - 4.D+0*
     +    s**(-1)*mst12 - 8.D+0*t1**(-1)*mg*mt*s1**(-1)*mst12*sin2t + 
     +    4.D+0*t1**(-1)*s1**(-1)*mg2*mst12 + 4.D+0*t1**(-1)*s1**(-1)*
     +    mt2*mst12 + 4.D+0*t1**(-1)*s1**(-1)*mst12**2 - 2.D+0*t1**(-1)
     +    *mst12 + 4.D+0*t1*s1**(-1) - 8.D+0*u1**(-1)*mg*mt*s1**(-1)*
     +    mst12*sin2t + 4.D+0*u1**(-1)*s1**(-1)*mg2*mst12 + 4.D+0*
     +    u1**(-1)*s1**(-1)*mt2*mst12 + 4.D+0*u1**(-1)*s1**(-1)*
     +    mst12**2 - 2.D+0*u1**(-1)*mst12 - 1.6D+1*mg*mt*s1**(-1)*sin2t
     +     + 8.D+0*s1**(-1)*mg2 + 8.D+0*s1**(-1)*mt2 + 8.D+0*s1**(-1)*
     +    mst12 )
      M2GGSV = M2GGSV + SK3B0B(4)*CO * (  - 8.D+0*s**(-3)*t1**2*mt2 + 
     +    8.D+0*s**(-3)*u1**2*mt2 - 8.D+0*s**(-2)*t1**(-1)*u1*mt2*mst12
     +     - 8.D+0*s**(-2)*t1*u1**(-1)*mt2*mst12 - 8.D+0*s**(-2)*t1*mt2
     +     + 8.D+0*s**(-2)*u1*mt2 + 1.6D+1*s**(-2)*mt2*mst12 )
      M2GGSV = M2GGSV + SK3B0B(5)*CO * ( 8.D+0*s**(-3)*t1**2*nf*ms2 - 
     +    8.D+0*s**(-3)*u1**2*nf*ms2 + 8.D+0*s**(-2)*t1**(-1)*u1*nf*ms2
     +    *mst12 + 8.D+0*s**(-2)*t1*u1**(-1)*nf*ms2*mst12 + 8.D+0*
     +    s**(-2)*t1*nf*ms2 - 8.D+0*s**(-2)*u1*nf*ms2 - 1.6D+1*s**(-2)*
     +    nf*ms2*mst12 )
      M2GGSV = M2GGSV + SK3B0B(6)*CO * ( 4.D+0*s**(-3)*t1**2*mst22 - 
     +    4.D+0*s**(-3)*u1**2*mst22 + 4.D+0*s**(-2)*t1**(-1)*u1*mst12*
     +    mst22 + 4.D+0*s**(-2)*t1*u1**(-1)*mst12*mst22 + 4.D+0*s**(-2)
     +    *t1*mst22 - 4.D+0*s**(-2)*u1*mst22 - 8.D+0*s**(-2)*mst12*
     +    mst22 )
      M2GGSV = M2GGSV + SK3B0C(1)*N*CO * ( 4.D+0 + 4.D+0*s**(-2)*t1**2
     +     + 4.D+0*s**(-2)*u1**2 - 4.D+0*s**(-1)*t1**(-2)*u1*mst12**2
     +     - 1.3D+1*s**(-1)*t1**(-1)*u1*mst12 - s**(-1)*t1**(-1)*u1**2
     +     + 4.D+0*s**(-1)*t1**(-1)*mst12**2 - 4.D+0*s**(-1)*t1*
     +    u1**(-2)*mst12**2 - 1.3D+1*s**(-1)*t1*u1**(-1)*mst12 - 3.D+0*
     +    s**(-1)*t1 - s**(-1)*t1**2*u1**(-1) - 8.D+0*s**(-1)*t1**2*
     +    s1**(-1) + 4.D+0*s**(-1)*u1**(-1)*mst12**2 - 3.D+0*s**(-1)*u1
     +     - 2.D+0*s**(-1)*mst12 + s*t1**(-1) + s*u1**(-1) + 1.6D+1*
     +    t1**(-3)*mst12**3 + 2.D+1*t1**(-2)*mst12**2 - 8.D+0*t1**(-1)*
     +    s1**(-1)*mst12**2 + 3.D+0*t1**(-1)*mst12 - 8.D+0*t1*s1**(-1)
     +     + 1.6D+1*u1**(-3)*mst12**3 + 2.D+1*u1**(-2)*mst12**2 - 8.D+0
     +    *u1**(-1)*s1**(-1)*mst12**2 + 3.D+0*u1**(-1)*mst12 - 1.6D+1*
     +    s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0C(1)*N*CK * (  - 1.05D+1 - 4.D+0*s**(-2)*
     +    t1**2 - 4.D+0*s**(-2)*u1**2 + 8.D+0*s**(-1)*t1**(-2)*u1*
     +    mst12**2 + 1.4D+1*s**(-1)*t1**(-1)*u1*mst12 + 8.D+0*s**(-1)*
     +    t1*u1**(-2)*mst12**2 + 1.4D+1*s**(-1)*t1*u1**(-1)*mst12 + 
     +    9.D+0*s**(-1)*t1 - 5.D-1*s**(-1)*t1**2*u1**(-1) + 8.D+0*
     +    s**(-1)*t1**2*s1**(-1) + 9.5D+0*s**(-1)*u1 + 4.D+0*s**(-1)*
     +    mst12 + 3.2D+1*s*t1**(-3)*u1**(-1)*mst12**3 + 3.6D+1*s*
     +    t1**(-2)*u1**(-1)*mst12**2 + 3.2D+1*s*t1**(-1)*u1**(-3)*
     +    mst12**3 + 3.6D+1*s*t1**(-1)*u1**(-2)*mst12**2 + 4.D+0*s*
     +    t1**(-1)*u1**(-1)*mst12 - 1.6D+1*t1**(-3)*mst12**3 - 2.8D+1*
     +    t1**(-2)*mst12**2 + 8.D+0*t1**(-1)*u1**(-1)*mst12**2 + 8.D+0*
     +    t1**(-1)*s1**(-1)*mst12**2 - 3.D+1*t1**(-1)*mst12 - 5.D-1*t1*
     +    u1**(-1) + 8.D+0*t1*s1**(-1) - 1.6D+1*u1**(-3)*mst12**3 - 
     +    2.8D+1*u1**(-2)*mst12**2 + 8.D+0*u1**(-1)*s1**(-1)*mst12**2
     +     - 3.D+1*u1**(-1)*mst12 + 1.6D+1*s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0C(1)*CQED * ( 3.D+0 - 4.D+0*s**(-1)*t1 - 
     +    4.D+0*s**(-1)*u1 - 1.6D+1*s*t1**(-3)*u1**(-1)*mst12**3 - 
     +    1.6D+1*s*t1**(-2)*u1**(-1)*mst12**2 - 1.6D+1*s*t1**(-1)*
     +    u1**(-3)*mst12**3 - 1.6D+1*s*t1**(-1)*u1**(-2)*mst12**2 - s*
     +    u1**(-1) + 8.D+0*t1**(-2)*mst12**2 + 1.6D+1*t1**(-1)*mst12 - 
     +    t1*u1**(-1) + 8.D+0*u1**(-2)*mst12**2 + 1.6D+1*u1**(-1)*mst12
     +     )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CO * (  - 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*sin2t + 1.6D+1*s**(-2)*t1**2*s1**(-1)*mg2 + 
     +    1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2 - 4.D+0*s**(-2)*u1**2 + 
     +    1.6D+1*s**(-1)*t1**(-2)*u1*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*
     +    t1**(-2)*u1*mg2*mst12 - 8.D+0*s**(-1)*t1**(-2)*u1*mt2*mst12
     +     + 8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*sin2t - 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg2 - 4.D+0*s**(-1)*t1**(-1)*u1*mt2 + 8.D+0*
     +    s**(-1)*t1**(-1)*u1*mst12 + 8.D+0*s**(-1)*t1**(-1)*mg*mt*
     +    mst12*sin2t - 4.D+0*s**(-1)*t1**(-1)*mg2*mst12 - 4.D+0*
     +    s**(-1)*t1**(-1)*mt2*mst12 - 4.D+0*s**(-1)*t1**(-1)*mst12**2
     +     + 1.6D+1*s**(-1)*t1*u1**(-2)*mg*mt*mst12*sin2t - 8.D+0*
     +    s**(-1)*t1*u1**(-2)*mg2*mst12 - 8.D+0*s**(-1)*t1*u1**(-2)*mt2
     +    *mst12 + 8.D+0*s**(-1)*t1*u1**(-1)*mg*mt*sin2t - 4.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2 - 4.D+0*s**(-1)*t1*u1**(-1)*mt2 + 
     +    8.D+0*s**(-1)*t1*u1**(-1)*mst12 - 3.2D+1*s**(-1)*t1*mg*mt*
     +    s1**(-1)*sin2t )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CO * ( 1.6D+1*s**(-1)*t1*s1**(-1)*
     +    mg2 + 1.6D+1*s**(-1)*t1*s1**(-1)*mt2 + 4.D+0*s**(-1)*t1 + 
     +    4.D+0*s**(-1)*t1**2*s1**(-1) + 8.D+0*s**(-1)*u1**(-1)*mg*mt*
     +    mst12*sin2t - 4.D+0*s**(-1)*u1**(-1)*mg2*mst12 - 4.D+0*
     +    s**(-1)*u1**(-1)*mt2*mst12 - 4.D+0*s**(-1)*u1**(-1)*mst12**2
     +     - 8.D+0*s**(-1)*mg*mt*sin2t + 4.D+0*s**(-1)*mg2 + 4.D+0*
     +    s**(-1)*mt2 + 4.D+0*s**(-1)*mst12 - 1.6D+1*t1**(-3)*mg*mt*
     +    mst12**2*sin2t + 8.D+0*t1**(-3)*mg2*mst12**2 + 8.D+0*t1**(-3)
     +    *mt2*mst12**2 - 8.D+0*t1**(-3)*mst12**3 - 8.D+0*t1**(-2)*mg*
     +    mt*mst12*sin2t + 4.D+0*t1**(-2)*mg2*mst12 + 4.D+0*t1**(-2)*
     +    mt2*mst12 - 1.2D+1*t1**(-2)*mst12**2 - 8.D+0*t1**(-1)*mg*mt*
     +    s1**(-1)*mst12*sin2t + 4.D+0*t1**(-1)*s1**(-1)*mg2*mst12 + 
     +    4.D+0*t1**(-1)*s1**(-1)*mt2*mst12 + 4.D+0*t1**(-1)*s1**(-1)*
     +    mst12**2 + 4.D+0*t1*s1**(-1) - 1.6D+1*u1**(-3)*mg*mt*mst12**2
     +    *sin2t + 8.D+0*u1**(-3)*mg2*mst12**2 + 8.D+0*u1**(-3)*mt2*
     +    mst12**2 )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CO * (  - 8.D+0*u1**(-3)*mst12**3
     +     - 8.D+0*u1**(-2)*mg*mt*mst12*sin2t + 4.D+0*u1**(-2)*mg2*
     +    mst12 + 4.D+0*u1**(-2)*mt2*mst12 - 1.2D+1*u1**(-2)*mst12**2
     +     - 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mst12*sin2t + 4.D+0*u1**(-1)
     +    *s1**(-1)*mg2*mst12 + 4.D+0*u1**(-1)*s1**(-1)*mt2*mst12 + 
     +    4.D+0*u1**(-1)*s1**(-1)*mst12**2 - 1.6D+1*mg*mt*s1**(-1)*
     +    sin2t + 8.D+0*s1**(-1)*mg2 + 8.D+0*s1**(-1)*mt2 + 8.D+0*
     +    s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CK * ( 3.2D+1*s**(-2)*t1**2*mg*mt*
     +    s1**(-1)*sin2t - 1.6D+1*s**(-2)*t1**2*s1**(-1)*mg2 - 1.6D+1*
     +    s**(-2)*t1**2*s1**(-1)*mt2 + 4.D+0*s**(-2)*u1**2 - 1.6D+1*
     +    s**(-1)*t1**(-2)*u1*mg*mt*mst12*sin2t + 8.D+0*s**(-1)*
     +    t1**(-2)*u1*mg2*mst12 + 8.D+0*s**(-1)*t1**(-2)*u1*mt2*mst12
     +     - 8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*sin2t + 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg2 + 4.D+0*s**(-1)*t1**(-1)*u1*mt2 - 8.D+0*
     +    s**(-1)*t1**(-1)*u1*mst12 - 8.D+0*s**(-1)*t1**(-1)*mg*mt*
     +    mst12*sin2t + 4.D+0*s**(-1)*t1**(-1)*mg2*mst12 + 4.D+0*
     +    s**(-1)*t1**(-1)*mt2*mst12 + 4.D+0*s**(-1)*t1**(-1)*mst12**2
     +     - 1.6D+1*s**(-1)*t1*u1**(-2)*mg*mt*mst12*sin2t + 8.D+0*
     +    s**(-1)*t1*u1**(-2)*mg2*mst12 + 8.D+0*s**(-1)*t1*u1**(-2)*mt2
     +    *mst12 - 8.D+0*s**(-1)*t1*u1**(-1)*mg*mt*sin2t + 4.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2 + 4.D+0*s**(-1)*t1*u1**(-1)*mt2 - 
     +    8.D+0*s**(-1)*t1*u1**(-1)*mst12 + 3.2D+1*s**(-1)*t1*mg*mt*
     +    s1**(-1)*sin2t )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CK * (  - 1.6D+1*s**(-1)*t1*
     +    s1**(-1)*mg2 - 1.6D+1*s**(-1)*t1*s1**(-1)*mt2 - 1.2D+1*
     +    s**(-1)*t1 - 4.D+0*s**(-1)*t1**2*s1**(-1) - 8.D+0*s**(-1)*
     +    u1**(-1)*mg*mt*mst12*sin2t + 4.D+0*s**(-1)*u1**(-1)*mg2*mst12
     +     + 4.D+0*s**(-1)*u1**(-1)*mt2*mst12 + 4.D+0*s**(-1)*u1**(-1)*
     +    mst12**2 - 8.D+0*s**(-1)*u1 + 8.D+0*s**(-1)*mg*mt*sin2t - 
     +    4.D+0*s**(-1)*mg2 - 4.D+0*s**(-1)*mt2 - 4.D+0*s**(-1)*mst12
     +     - 3.2D+1*s*t1**(-3)*u1**(-1)*mg*mt*mst12**2*sin2t + 1.6D+1*s
     +    *t1**(-3)*u1**(-1)*mg2*mst12**2 + 1.6D+1*s*t1**(-3)*u1**(-1)*
     +    mt2*mst12**2 - 1.6D+1*s*t1**(-3)*u1**(-1)*mst12**3 - 1.6D+1*s
     +    *t1**(-2)*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*s*t1**(-2)*
     +    u1**(-1)*mg2*mst12 + 8.D+0*s*t1**(-2)*u1**(-1)*mt2*mst12 - 
     +    2.4D+1*s*t1**(-2)*u1**(-1)*mst12**2 - 3.2D+1*s*t1**(-1)*
     +    u1**(-3)*mg*mt*mst12**2*sin2t + 1.6D+1*s*t1**(-1)*u1**(-3)*
     +    mg2*mst12**2 + 1.6D+1*s*t1**(-1)*u1**(-3)*mt2*mst12**2 - 
     +    1.6D+1*s*t1**(-1)*u1**(-3)*mst12**3 )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CK * (  - 1.6D+1*s*t1**(-1)*
     +    u1**(-2)*mg*mt*mst12*sin2t + 8.D+0*s*t1**(-1)*u1**(-2)*mg2*
     +    mst12 + 8.D+0*s*t1**(-1)*u1**(-2)*mt2*mst12 - 2.4D+1*s*
     +    t1**(-1)*u1**(-2)*mst12**2 + 1.6D+1*t1**(-3)*mg*mt*mst12**2*
     +    sin2t - 8.D+0*t1**(-3)*mg2*mst12**2 - 8.D+0*t1**(-3)*mt2*
     +    mst12**2 + 8.D+0*t1**(-3)*mst12**3 + 4.D+1*t1**(-2)*mg*mt*
     +    mst12*sin2t - 2.D+1*t1**(-2)*mg2*mst12 - 2.D+1*t1**(-2)*mt2*
     +    mst12 + 1.2D+1*t1**(-2)*mst12**2 + 3.2D+1*t1**(-1)*u1**(-1)*
     +    mg*mt*mst12*sin2t - 1.6D+1*t1**(-1)*u1**(-1)*mg2*mst12 - 
     +    1.6D+1*t1**(-1)*u1**(-1)*mt2*mst12 - 1.6D+1*t1**(-1)*u1**(-1)
     +    *mst12**2 + 8.D+0*t1**(-1)*mg*mt*s1**(-1)*mst12*sin2t + 
     +    1.6D+1*t1**(-1)*mg*mt*sin2t - 4.D+0*t1**(-1)*s1**(-1)*mg2*
     +    mst12 - 4.D+0*t1**(-1)*s1**(-1)*mt2*mst12 - 4.D+0*t1**(-1)*
     +    s1**(-1)*mst12**2 - 8.D+0*t1**(-1)*mg2 - 8.D+0*t1**(-1)*mt2
     +     + 1.6D+1*t1**(-1)*mst12 - 4.D+0*t1*s1**(-1) + 1.6D+1*
     +    u1**(-3)*mg*mt*mst12**2*sin2t )
      M2GGSV = M2GGSV + SK3B0C(2)*N*CK * (  - 8.D+0*u1**(-3)*mg2*
     +    mst12**2 - 8.D+0*u1**(-3)*mt2*mst12**2 + 8.D+0*u1**(-3)*
     +    mst12**3 + 4.D+1*u1**(-2)*mg*mt*mst12*sin2t - 2.D+1*u1**(-2)*
     +    mg2*mst12 - 2.D+1*u1**(-2)*mt2*mst12 + 1.2D+1*u1**(-2)*
     +    mst12**2 + 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mst12*sin2t + 1.6D+1
     +    *u1**(-1)*mg*mt*sin2t - 4.D+0*u1**(-1)*s1**(-1)*mg2*mst12 - 
     +    4.D+0*u1**(-1)*s1**(-1)*mt2*mst12 - 4.D+0*u1**(-1)*s1**(-1)*
     +    mst12**2 - 8.D+0*u1**(-1)*mg2 - 8.D+0*u1**(-1)*mt2 + 1.6D+1*
     +    u1**(-1)*mst12 + 1.6D+1*mg*mt*s1**(-1)*sin2t - 8.D+0*s1**(-1)
     +    *mg2 - 8.D+0*s1**(-1)*mt2 - 8.D+0*s1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0C(2)*CQED * ( 4.D+0*s**(-1)*t1 + 4.D+0*
     +    s**(-1)*u1 + 1.6D+1*s*t1**(-3)*u1**(-1)*mg*mt*mst12**2*sin2t
     +     - 8.D+0*s*t1**(-3)*u1**(-1)*mg2*mst12**2 - 8.D+0*s*t1**(-3)*
     +    u1**(-1)*mt2*mst12**2 + 8.D+0*s*t1**(-3)*u1**(-1)*mst12**3 + 
     +    8.D+0*s*t1**(-2)*u1**(-1)*mg*mt*mst12*sin2t - 4.D+0*s*
     +    t1**(-2)*u1**(-1)*mg2*mst12 - 4.D+0*s*t1**(-2)*u1**(-1)*mt2*
     +    mst12 + 1.2D+1*s*t1**(-2)*u1**(-1)*mst12**2 + 1.6D+1*s*
     +    t1**(-1)*u1**(-3)*mg*mt*mst12**2*sin2t - 8.D+0*s*t1**(-1)*
     +    u1**(-3)*mg2*mst12**2 - 8.D+0*s*t1**(-1)*u1**(-3)*mt2*
     +    mst12**2 + 8.D+0*s*t1**(-1)*u1**(-3)*mst12**3 + 8.D+0*s*
     +    t1**(-1)*u1**(-2)*mg*mt*mst12*sin2t - 4.D+0*s*t1**(-1)*
     +    u1**(-2)*mg2*mst12 - 4.D+0*s*t1**(-1)*u1**(-2)*mt2*mst12 + 
     +    1.2D+1*s*t1**(-1)*u1**(-2)*mst12**2 - 1.6D+1*t1**(-2)*mg*mt*
     +    mst12*sin2t + 8.D+0*t1**(-2)*mg2*mst12 + 8.D+0*t1**(-2)*mt2*
     +    mst12 - 1.6D+1*t1**(-1)*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*
     +    t1**(-1)*u1**(-1)*mg2*mst12 )
      M2GGSV = M2GGSV + SK3B0C(2)*CQED * ( 8.D+0*t1**(-1)*u1**(-1)*mt2*
     +    mst12 + 8.D+0*t1**(-1)*u1**(-1)*mst12**2 - 8.D+0*t1**(-1)*mg*
     +    mt*sin2t + 4.D+0*t1**(-1)*mg2 + 4.D+0*t1**(-1)*mt2 - 8.D+0*
     +    t1**(-1)*mst12 - 1.6D+1*u1**(-2)*mg*mt*mst12*sin2t + 8.D+0*
     +    u1**(-2)*mg2*mst12 + 8.D+0*u1**(-2)*mt2*mst12 - 8.D+0*
     +    u1**(-1)*mg*mt*sin2t + 4.D+0*u1**(-1)*mg2 + 4.D+0*u1**(-1)*
     +    mt2 - 8.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,1)*N*CO * (  - 5.D-1*s**(-1)*t**(-1)*
     +    t1**(-2)*u1*mst12**3 - 1.25D+0*s**(-1)*t**(-1)*t1**(-1)*u1*
     +    mst12**2 + 5.D-1*s**(-1)*t**(-1)*t1*mst12 + 1.25D-1*s**(-1)*
     +    t**(-1)*t1**2 - 7.5D-1*s**(-1)*t**(-1)*u1*mst12 + 3.75D-1*
     +    s**(-1)*t**(-1)*mst12**2 + 4.5D+0*s**(-1)*t1**(-2)*u1*
     +    mst12**2 + 7.75D+0*s**(-1)*t1**(-1)*u1*mst12 - 4.D+0*s**(-1)*
     +    t1**(-1)*mst12**2 - 1.25D-1*s**(-1)*t1 + 4.D+0*s**(-1)*u1 - 
     +    1.375D+0*s**(-1)*mst12 - 2.D+0*t**(-1)*t1**(-3)*mst12**4 - 
     +    3.D+0*t**(-1)*t1**(-2)*mst12**3 - t**(-1)*t1**(-1)*mst12**2
     +     - 1.4D+1*t1**(-3)*mst12**3 - 1.9D+1*t1**(-2)*mst12**2 - 
     +    5.D+0*t1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,1)*N*CK * ( 8.D+0 + 2.D+0*s**(-1)*
     +    t**(-1)*t1**(-2)*u1*mst12**3 + 4.D+0*s**(-1)*t**(-1)*t1**(-1)
     +    *u1*mst12**2 + 2.D+0*s**(-1)*t**(-1)*u1*mst12 - 1.D+1*s**(-1)
     +    *t1**(-2)*u1*mst12**2 - 1.4D+1*s**(-1)*t1**(-1)*u1*mst12 - 
     +    4.D+0*s**(-1)*u1 - 4.D+0*s**(-1)*mst12 - 6.D+0*s*t**(-1)*
     +    t1**(-3)*u1**(-1)*mst12**4 - 9.D+0*s*t**(-1)*t1**(-2)*
     +    u1**(-1)*mst12**3 - 3.D+0*s*t**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 - 2.6D+1*s*t1**(-3)*u1**(-1)*mst12**3 - 3.3D+1*s*
     +    t1**(-2)*u1**(-1)*mst12**2 - 6.D+0*s*t1**(-1)*u1**(-1)*mst12
     +     + 4.D+0*t**(-1)*t1**(-3)*mst12**4 + 8.D+0*t**(-1)*t1**(-2)*
     +    mst12**3 + t**(-1)*t1**(-1)*u1**(-1)*mst12**3 + 3.5D+0*
     +    t**(-1)*t1**(-1)*mst12**2 - 2.5D-1*t**(-1)*t1*u1**(-1)*mst12
     +     + 7.5D-1*t**(-1)*u1**(-1)*mst12**2 - 5.D-1*t**(-1)*mst12 + 
     +    1.2D+1*t1**(-3)*mst12**3 + 2.4D+1*t1**(-2)*mst12**2 - 5.D+0*
     +    t1**(-1)*u1**(-1)*mst12**2 + 1.85D+1*t1**(-1)*mst12 + 2.25D+0
     +    *u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,1)*CQED * (  - 4.D+0 + 4.D+0*s*t**(-1)
     +    *t1**(-3)*u1**(-1)*mst12**4 + 6.D+0*s*t**(-1)*t1**(-2)*
     +    u1**(-1)*mst12**3 + 2.D+0*s*t**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 1.2D+1*s*t1**(-3)*u1**(-1)*mst12**3 + 1.4D+1*s*
     +    t1**(-2)*u1**(-1)*mst12**2 + 2.D+0*t**(-1)*t1**(-2)*mst12**3
     +     + 4.D+0*t**(-1)*t1**(-1)*mst12**2 + 2.D+0*t**(-1)*mst12 - 
     +    1.D+1*t1**(-2)*mst12**2 - 1.4D+1*t1**(-1)*mst12 - 4.D+0*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,2)*N*CO * (  - 5.D-1*s**(-1)*u**(-1)*
     +    t1*u1**(-2)*mst12**3 - 1.25D+0*s**(-1)*u**(-1)*t1*u1**(-1)*
     +    mst12**2 - 7.5D-1*s**(-1)*u**(-1)*t1*mst12 + 5.D-1*s**(-1)*
     +    u**(-1)*u1*mst12 + 1.25D-1*s**(-1)*u**(-1)*u1**2 + 3.75D-1*
     +    s**(-1)*u**(-1)*mst12**2 + 4.5D+0*s**(-1)*t1*u1**(-2)*
     +    mst12**2 + 7.75D+0*s**(-1)*t1*u1**(-1)*mst12 + 4.D+0*s**(-1)*
     +    t1 - 4.D+0*s**(-1)*u1**(-1)*mst12**2 - 1.25D-1*s**(-1)*u1 - 
     +    1.375D+0*s**(-1)*mst12 - 2.D+0*u**(-1)*u1**(-3)*mst12**4 - 
     +    3.D+0*u**(-1)*u1**(-2)*mst12**3 - u**(-1)*u1**(-1)*mst12**2
     +     - 1.4D+1*u1**(-3)*mst12**3 - 1.9D+1*u1**(-2)*mst12**2 - 
     +    5.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,2)*N*CK * ( 8.D+0 + 2.D+0*s**(-1)*
     +    u**(-1)*t1*u1**(-2)*mst12**3 + 4.D+0*s**(-1)*u**(-1)*t1*
     +    u1**(-1)*mst12**2 + 2.D+0*s**(-1)*u**(-1)*t1*mst12 - 1.D+1*
     +    s**(-1)*t1*u1**(-2)*mst12**2 - 1.4D+1*s**(-1)*t1*u1**(-1)*
     +    mst12 - 4.D+0*s**(-1)*t1 - 4.D+0*s**(-1)*mst12 - 6.D+0*s*
     +    u**(-1)*t1**(-1)*u1**(-3)*mst12**4 - 9.D+0*s*u**(-1)*t1**(-1)
     +    *u1**(-2)*mst12**3 - 3.D+0*s*u**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 - 2.6D+1*s*t1**(-1)*u1**(-3)*mst12**3 - 3.3D+1*s*
     +    t1**(-1)*u1**(-2)*mst12**2 - 6.D+0*s*t1**(-1)*u1**(-1)*mst12
     +     + u**(-1)*t1**(-1)*u1**(-1)*mst12**3 - 2.5D-1*u**(-1)*
     +    t1**(-1)*u1*mst12 + 7.5D-1*u**(-1)*t1**(-1)*mst12**2 + 4.D+0*
     +    u**(-1)*u1**(-3)*mst12**4 + 8.D+0*u**(-1)*u1**(-2)*mst12**3
     +     + 3.5D+0*u**(-1)*u1**(-1)*mst12**2 - 5.D-1*u**(-1)*mst12 - 
     +    5.D+0*t1**(-1)*u1**(-1)*mst12**2 + 2.25D+0*t1**(-1)*mst12 + 
     +    1.2D+1*u1**(-3)*mst12**3 + 2.4D+1*u1**(-2)*mst12**2 + 1.85D+1
     +    *u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(1,2)*CQED * (  - 4.D+0 + 4.D+0*s*u**(-1)
     +    *t1**(-1)*u1**(-3)*mst12**4 + 6.D+0*s*u**(-1)*t1**(-1)*
     +    u1**(-2)*mst12**3 + 2.D+0*s*u**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 1.2D+1*s*t1**(-1)*u1**(-3)*mst12**3 + 1.4D+1*s*
     +    t1**(-1)*u1**(-2)*mst12**2 + 2.D+0*u**(-1)*u1**(-2)*mst12**3
     +     + 4.D+0*u**(-1)*u1**(-1)*mst12**2 + 2.D+0*u**(-1)*mst12 - 
     +    4.D+0*t1**(-1)*mst12 - 1.D+1*u1**(-2)*mst12**2 - 1.4D+1*
     +    u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,1)*N*CO * (  - 1.6D+1*s**(-1)*t1**(-2)
     +    *u1*mg*mt*mst12*sin2t + 8.D+0*s**(-1)*t1**(-2)*u1*mg2*mst12
     +     + 8.D+0*s**(-1)*t1**(-2)*u1*mt2*mst12 - 8.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*sin2t + 4.D+0*s**(-1)*t1**(-1)*u1*mg2 + 
     +    4.D+0*s**(-1)*t1**(-1)*u1*mt2 - 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12 - 8.D+0*s**(-1)*t1**(-1)*mg*mt*mst12*sin2t + 4.D+0*
     +    s**(-1)*t1**(-1)*mg2*mst12 + 4.D+0*s**(-1)*t1**(-1)*mt2*mst12
     +     + 4.D+0*s**(-1)*t1**(-1)*mst12**2 - 2.D+0*s**(-1)*u1 + 2.D+0
     +    *s**(-1)*mst12 + 1.6D+1*t1**(-3)*mg*mt*mst12**2*sin2t - 8.D+0
     +    *t1**(-3)*mg2*mst12**2 - 8.D+0*t1**(-3)*mt2*mst12**2 + 8.D+0*
     +    t1**(-3)*mst12**3 + 8.D+0*t1**(-2)*mg*mt*mst12*sin2t - 4.D+0*
     +    t1**(-2)*mg2*mst12 - 4.D+0*t1**(-2)*mt2*mst12 + 1.2D+1*
     +    t1**(-2)*mst12**2 + 4.D+0*t1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,1)*N*CK * (  - 4.D+0 + 1.6D+1*s**(-1)*
     +    t1**(-2)*u1*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*t1**(-2)*u1*mg2
     +    *mst12 - 8.D+0*s**(-1)*t1**(-2)*u1*mt2*mst12 + 8.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*sin2t - 4.D+0*s**(-1)*t1**(-1)*u1*mg2 - 
     +    4.D+0*s**(-1)*t1**(-1)*u1*mt2 + 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12 + 8.D+0*s**(-1)*t1**(-1)*mg*mt*mst12*sin2t - 4.D+0*
     +    s**(-1)*t1**(-1)*mg2*mst12 - 4.D+0*s**(-1)*t1**(-1)*mt2*mst12
     +     - 4.D+0*s**(-1)*t1**(-1)*mst12**2 + 2.D+0*s**(-1)*u1 - 2.D+0
     +    *s**(-1)*mst12 + 3.2D+1*s*t1**(-3)*u1**(-1)*mg*mt*mst12**2*
     +    sin2t - 1.6D+1*s*t1**(-3)*u1**(-1)*mg2*mst12**2 - 1.6D+1*s*
     +    t1**(-3)*u1**(-1)*mt2*mst12**2 + 1.6D+1*s*t1**(-3)*u1**(-1)*
     +    mst12**3 + 1.6D+1*s*t1**(-2)*u1**(-1)*mg*mt*mst12*sin2t - 
     +    8.D+0*s*t1**(-2)*u1**(-1)*mg2*mst12 - 8.D+0*s*t1**(-2)*
     +    u1**(-1)*mt2*mst12 + 2.4D+1*s*t1**(-2)*u1**(-1)*mst12**2 + 
     +    8.D+0*s*t1**(-1)*u1**(-1)*mst12 - 1.6D+1*t1**(-3)*mg*mt*
     +    mst12**2*sin2t )
      M2GGSV = M2GGSV + SK3B0D(2,1)*N*CK * ( 8.D+0*t1**(-3)*mg2*
     +    mst12**2 + 8.D+0*t1**(-3)*mt2*mst12**2 - 8.D+0*t1**(-3)*
     +    mst12**3 - 4.D+1*t1**(-2)*mg*mt*mst12*sin2t + 2.D+1*t1**(-2)*
     +    mg2*mst12 + 2.D+1*t1**(-2)*mt2*mst12 - 1.2D+1*t1**(-2)*
     +    mst12**2 - 1.6D+1*t1**(-1)*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0
     +    *t1**(-1)*u1**(-1)*mg2*mst12 + 8.D+0*t1**(-1)*u1**(-1)*mt2*
     +    mst12 + 8.D+0*t1**(-1)*u1**(-1)*mst12**2 - 1.6D+1*t1**(-1)*mg
     +    *mt*sin2t + 8.D+0*t1**(-1)*mg2 + 8.D+0*t1**(-1)*mt2 - 8.D+0*
     +    t1**(-1)*mst12 + 4.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,1)*CQED * ( 2.D+0 - 1.6D+1*s*t1**(-3)*
     +    u1**(-1)*mg*mt*mst12**2*sin2t + 8.D+0*s*t1**(-3)*u1**(-1)*mg2
     +    *mst12**2 + 8.D+0*s*t1**(-3)*u1**(-1)*mt2*mst12**2 - 8.D+0*s*
     +    t1**(-3)*u1**(-1)*mst12**3 - 8.D+0*s*t1**(-2)*u1**(-1)*mg*mt*
     +    mst12*sin2t + 4.D+0*s*t1**(-2)*u1**(-1)*mg2*mst12 + 4.D+0*s*
     +    t1**(-2)*u1**(-1)*mt2*mst12 - 1.2D+1*s*t1**(-2)*u1**(-1)*
     +    mst12**2 - 4.D+0*s*t1**(-1)*u1**(-1)*mst12 + 1.6D+1*t1**(-2)*
     +    mg*mt*mst12*sin2t - 8.D+0*t1**(-2)*mg2*mst12 - 8.D+0*t1**(-2)
     +    *mt2*mst12 + 8.D+0*t1**(-1)*u1**(-1)*mg*mt*mst12*sin2t - 
     +    4.D+0*t1**(-1)*u1**(-1)*mg2*mst12 - 4.D+0*t1**(-1)*u1**(-1)*
     +    mt2*mst12 - 4.D+0*t1**(-1)*u1**(-1)*mst12**2 + 8.D+0*t1**(-1)
     +    *mg*mt*sin2t - 4.D+0*t1**(-1)*mg2 - 4.D+0*t1**(-1)*mt2 + 
     +    2.D+0*t1**(-1)*mst12 - 2.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,2)*N*CO * (  - 1.6D+1*s**(-1)*t1*
     +    u1**(-2)*mg*mt*mst12*sin2t + 8.D+0*s**(-1)*t1*u1**(-2)*mg2*
     +    mst12 + 8.D+0*s**(-1)*t1*u1**(-2)*mt2*mst12 - 8.D+0*s**(-1)*
     +    t1*u1**(-1)*mg*mt*sin2t + 4.D+0*s**(-1)*t1*u1**(-1)*mg2 + 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mt2 - 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mst12 - 2.D+0*s**(-1)*t1 - 8.D+0*s**(-1)*u1**(-1)*mg*mt*mst12
     +    *sin2t + 4.D+0*s**(-1)*u1**(-1)*mg2*mst12 + 4.D+0*s**(-1)*
     +    u1**(-1)*mt2*mst12 + 4.D+0*s**(-1)*u1**(-1)*mst12**2 + 2.D+0*
     +    s**(-1)*mst12 + 1.6D+1*u1**(-3)*mg*mt*mst12**2*sin2t - 8.D+0*
     +    u1**(-3)*mg2*mst12**2 - 8.D+0*u1**(-3)*mt2*mst12**2 + 8.D+0*
     +    u1**(-3)*mst12**3 + 8.D+0*u1**(-2)*mg*mt*mst12*sin2t - 4.D+0*
     +    u1**(-2)*mg2*mst12 - 4.D+0*u1**(-2)*mt2*mst12 + 1.2D+1*
     +    u1**(-2)*mst12**2 + 4.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,2)*N*CK * (  - 4.D+0 + 1.6D+1*s**(-1)*
     +    t1*u1**(-2)*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*t1*u1**(-2)*mg2
     +    *mst12 - 8.D+0*s**(-1)*t1*u1**(-2)*mt2*mst12 + 8.D+0*s**(-1)*
     +    t1*u1**(-1)*mg*mt*sin2t - 4.D+0*s**(-1)*t1*u1**(-1)*mg2 - 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mt2 + 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mst12 + 2.D+0*s**(-1)*t1 + 8.D+0*s**(-1)*u1**(-1)*mg*mt*mst12
     +    *sin2t - 4.D+0*s**(-1)*u1**(-1)*mg2*mst12 - 4.D+0*s**(-1)*
     +    u1**(-1)*mt2*mst12 - 4.D+0*s**(-1)*u1**(-1)*mst12**2 - 2.D+0*
     +    s**(-1)*mst12 + 3.2D+1*s*t1**(-1)*u1**(-3)*mg*mt*mst12**2*
     +    sin2t - 1.6D+1*s*t1**(-1)*u1**(-3)*mg2*mst12**2 - 1.6D+1*s*
     +    t1**(-1)*u1**(-3)*mt2*mst12**2 + 1.6D+1*s*t1**(-1)*u1**(-3)*
     +    mst12**3 + 1.6D+1*s*t1**(-1)*u1**(-2)*mg*mt*mst12*sin2t - 
     +    8.D+0*s*t1**(-1)*u1**(-2)*mg2*mst12 - 8.D+0*s*t1**(-1)*
     +    u1**(-2)*mt2*mst12 + 2.4D+1*s*t1**(-1)*u1**(-2)*mst12**2 + 
     +    8.D+0*s*t1**(-1)*u1**(-1)*mst12 - 1.6D+1*t1**(-1)*u1**(-1)*mg
     +    *mt*mst12*sin2t )
      M2GGSV = M2GGSV + SK3B0D(2,2)*N*CK * ( 8.D+0*t1**(-1)*u1**(-1)*
     +    mg2*mst12 + 8.D+0*t1**(-1)*u1**(-1)*mt2*mst12 + 8.D+0*
     +    t1**(-1)*u1**(-1)*mst12**2 + 4.D+0*t1**(-1)*mst12 - 1.6D+1*
     +    u1**(-3)*mg*mt*mst12**2*sin2t + 8.D+0*u1**(-3)*mg2*mst12**2
     +     + 8.D+0*u1**(-3)*mt2*mst12**2 - 8.D+0*u1**(-3)*mst12**3 - 
     +    4.D+1*u1**(-2)*mg*mt*mst12*sin2t + 2.D+1*u1**(-2)*mg2*mst12
     +     + 2.D+1*u1**(-2)*mt2*mst12 - 1.2D+1*u1**(-2)*mst12**2 - 
     +    1.6D+1*u1**(-1)*mg*mt*sin2t + 8.D+0*u1**(-1)*mg2 + 8.D+0*
     +    u1**(-1)*mt2 - 8.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3B0D(2,2)*CQED * ( 2.D+0 - 1.6D+1*s*t1**(-1)*
     +    u1**(-3)*mg*mt*mst12**2*sin2t + 8.D+0*s*t1**(-1)*u1**(-3)*mg2
     +    *mst12**2 + 8.D+0*s*t1**(-1)*u1**(-3)*mt2*mst12**2 - 8.D+0*s*
     +    t1**(-1)*u1**(-3)*mst12**3 - 8.D+0*s*t1**(-1)*u1**(-2)*mg*mt*
     +    mst12*sin2t + 4.D+0*s*t1**(-1)*u1**(-2)*mg2*mst12 + 4.D+0*s*
     +    t1**(-1)*u1**(-2)*mt2*mst12 - 1.2D+1*s*t1**(-1)*u1**(-2)*
     +    mst12**2 - 4.D+0*s*t1**(-1)*u1**(-1)*mst12 + 8.D+0*t1**(-1)*
     +    u1**(-1)*mg*mt*mst12*sin2t - 4.D+0*t1**(-1)*u1**(-1)*mg2*
     +    mst12 - 4.D+0*t1**(-1)*u1**(-1)*mt2*mst12 - 4.D+0*t1**(-1)*
     +    u1**(-1)*mst12**2 - 2.D+0*t1**(-1)*mst12 + 1.6D+1*u1**(-2)*mg
     +    *mt*mst12*sin2t - 8.D+0*u1**(-2)*mg2*mst12 - 8.D+0*u1**(-2)*
     +    mt2*mst12 + 8.D+0*u1**(-1)*mg*mt*sin2t - 4.D+0*u1**(-1)*mg2
     +     - 4.D+0*u1**(-1)*mt2 + 2.D+0*u1**(-1)*mst12 )
      M2GGSV = M2GGSV + SK3BP(1)*N*CO * ( 8.D+0*s**(-2)*t1**2*mst12 + 
     +    8.D+0*s**(-2)*u1**2*mst12 - 1.6D+1*s**(-1)*t1**(-1)*u1*
     +    mst12**2 - 1.6D+1*s**(-1)*t1*u1**(-1)*mst12**2 + 1.6D+1*
     +    t1**(-2)*mst12**3 + 1.6D+1*u1**(-2)*mst12**3 )
      M2GGSV = M2GGSV + SK3BP(1)*N*CK * (  - 8.D+0*s**(-2)*t1**2*mst12
     +     - 8.D+0*s**(-2)*u1**2*mst12 + 1.6D+1*s**(-1)*t1**(-1)*u1*
     +    mst12**2 + 1.6D+1*s**(-1)*t1*u1**(-1)*mst12**2 + 1.6D+1*
     +    s**(-1)*t1*mst12 + 1.6D+1*s**(-1)*u1*mst12 + 3.2D+1*s*
     +    t1**(-2)*u1**(-1)*mst12**3 + 3.2D+1*s*t1**(-1)*u1**(-2)*
     +    mst12**3 - 1.6D+1*t1**(-2)*mst12**3 - 3.2D+1*t1**(-1)*
     +    mst12**2 - 1.6D+1*u1**(-2)*mst12**3 - 3.2D+1*u1**(-1)*
     +    mst12**2 )
      M2GGSV = M2GGSV + SK3BP(1)*CQED * (  - 8.D+0*s**(-1)*t1*mst12 - 
     +    8.D+0*s**(-1)*u1*mst12 - 1.6D+1*s*t1**(-2)*u1**(-1)*mst12**3
     +     - 1.6D+1*s*t1**(-1)*u1**(-2)*mst12**3 + 1.6D+1*t1**(-1)*
     +    mst12**2 + 1.6D+1*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3BP(2)*N*CO * (  - 8.D+0*s**(-2)*t1**2*mg*mt*
     +    sin2t + 4.D+0*s**(-2)*t1**2*mg2 + 4.D+0*s**(-2)*t1**2*mt2 - 
     +    4.D+0*s**(-2)*t1**2*mst12 - 8.D+0*s**(-2)*u1**2*mg*mt*sin2t
     +     + 4.D+0*s**(-2)*u1**2*mg2 + 4.D+0*s**(-2)*u1**2*mt2 - 4.D+0*
     +    s**(-2)*u1**2*mst12 + 1.6D+1*s**(-1)*t1**(-1)*u1*mg*mt*mst12*
     +    sin2t - 8.D+0*s**(-1)*t1**(-1)*u1*mg2*mst12 - 8.D+0*s**(-1)*
     +    t1**(-1)*u1*mt2*mst12 + 8.D+0*s**(-1)*t1**(-1)*u1*mst12**2 + 
     +    1.6D+1*s**(-1)*t1*u1**(-1)*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*
     +    t1*u1**(-1)*mg2*mst12 - 8.D+0*s**(-1)*t1*u1**(-1)*mt2*mst12
     +     + 8.D+0*s**(-1)*t1*u1**(-1)*mst12**2 - 1.6D+1*t1**(-2)*mg*mt
     +    *mst12**2*sin2t + 8.D+0*t1**(-2)*mg2*mst12**2 + 8.D+0*
     +    t1**(-2)*mt2*mst12**2 - 8.D+0*t1**(-2)*mst12**3 - 1.6D+1*
     +    u1**(-2)*mg*mt*mst12**2*sin2t + 8.D+0*u1**(-2)*mg2*mst12**2
     +     + 8.D+0*u1**(-2)*mt2*mst12**2 - 8.D+0*u1**(-2)*mst12**3 )
      M2GGSV = M2GGSV + SK3BP(2)*N*CK * ( 8.D+0*s**(-2)*t1**2*mg*mt*
     +    sin2t - 4.D+0*s**(-2)*t1**2*mg2 - 4.D+0*s**(-2)*t1**2*mt2 + 
     +    4.D+0*s**(-2)*t1**2*mst12 + 8.D+0*s**(-2)*u1**2*mg*mt*sin2t
     +     - 4.D+0*s**(-2)*u1**2*mg2 - 4.D+0*s**(-2)*u1**2*mt2 + 4.D+0*
     +    s**(-2)*u1**2*mst12 - 1.6D+1*s**(-1)*t1**(-1)*u1*mg*mt*mst12*
     +    sin2t + 8.D+0*s**(-1)*t1**(-1)*u1*mg2*mst12 + 8.D+0*s**(-1)*
     +    t1**(-1)*u1*mt2*mst12 - 8.D+0*s**(-1)*t1**(-1)*u1*mst12**2 - 
     +    1.6D+1*s**(-1)*t1*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*s**(-1)*
     +    t1*u1**(-1)*mg2*mst12 + 8.D+0*s**(-1)*t1*u1**(-1)*mt2*mst12
     +     - 8.D+0*s**(-1)*t1*u1**(-1)*mst12**2 - 1.6D+1*s**(-1)*t1*mg*
     +    mt*sin2t + 8.D+0*s**(-1)*t1*mg2 + 8.D+0*s**(-1)*t1*mt2 - 
     +    8.D+0*s**(-1)*t1*mst12 - 1.6D+1*s**(-1)*u1*mg*mt*sin2t + 
     +    8.D+0*s**(-1)*u1*mg2 + 8.D+0*s**(-1)*u1*mt2 - 8.D+0*s**(-1)*
     +    u1*mst12 - 3.2D+1*s*t1**(-2)*u1**(-1)*mg*mt*mst12**2*sin2t + 
     +    1.6D+1*s*t1**(-2)*u1**(-1)*mg2*mst12**2 + 1.6D+1*s*t1**(-2)*
     +    u1**(-1)*mt2*mst12**2 )
      M2GGSV = M2GGSV + SK3BP(2)*N*CK * (  - 1.6D+1*s*t1**(-2)*u1**(-1)
     +    *mst12**3 - 3.2D+1*s*t1**(-1)*u1**(-2)*mg*mt*mst12**2*sin2t
     +     + 1.6D+1*s*t1**(-1)*u1**(-2)*mg2*mst12**2 + 1.6D+1*s*
     +    t1**(-1)*u1**(-2)*mt2*mst12**2 - 1.6D+1*s*t1**(-1)*u1**(-2)*
     +    mst12**3 + 1.6D+1*t1**(-2)*mg*mt*mst12**2*sin2t - 8.D+0*
     +    t1**(-2)*mg2*mst12**2 - 8.D+0*t1**(-2)*mt2*mst12**2 + 8.D+0*
     +    t1**(-2)*mst12**3 + 3.2D+1*t1**(-1)*mg*mt*mst12*sin2t - 
     +    1.6D+1*t1**(-1)*mg2*mst12 - 1.6D+1*t1**(-1)*mt2*mst12 + 
     +    1.6D+1*t1**(-1)*mst12**2 + 1.6D+1*u1**(-2)*mg*mt*mst12**2*
     +    sin2t - 8.D+0*u1**(-2)*mg2*mst12**2 - 8.D+0*u1**(-2)*mt2*
     +    mst12**2 + 8.D+0*u1**(-2)*mst12**3 + 3.2D+1*u1**(-1)*mg*mt*
     +    mst12*sin2t - 1.6D+1*u1**(-1)*mg2*mst12 - 1.6D+1*u1**(-1)*mt2
     +    *mst12 + 1.6D+1*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3BP(2)*CQED * ( 8.D+0*s**(-1)*t1*mg*mt*sin2t
     +     - 4.D+0*s**(-1)*t1*mg2 - 4.D+0*s**(-1)*t1*mt2 + 4.D+0*
     +    s**(-1)*t1*mst12 + 8.D+0*s**(-1)*u1*mg*mt*sin2t - 4.D+0*
     +    s**(-1)*u1*mg2 - 4.D+0*s**(-1)*u1*mt2 + 4.D+0*s**(-1)*u1*
     +    mst12 + 1.6D+1*s*t1**(-2)*u1**(-1)*mg*mt*mst12**2*sin2t - 
     +    8.D+0*s*t1**(-2)*u1**(-1)*mg2*mst12**2 - 8.D+0*s*t1**(-2)*
     +    u1**(-1)*mt2*mst12**2 + 8.D+0*s*t1**(-2)*u1**(-1)*mst12**3 + 
     +    1.6D+1*s*t1**(-1)*u1**(-2)*mg*mt*mst12**2*sin2t - 8.D+0*s*
     +    t1**(-1)*u1**(-2)*mg2*mst12**2 - 8.D+0*s*t1**(-1)*u1**(-2)*
     +    mt2*mst12**2 + 8.D+0*s*t1**(-1)*u1**(-2)*mst12**3 - 1.6D+1*
     +    t1**(-1)*mg*mt*mst12*sin2t + 8.D+0*t1**(-1)*mg2*mst12 + 8.D+0
     +    *t1**(-1)*mt2*mst12 - 8.D+0*t1**(-1)*mst12**2 - 1.6D+1*
     +    u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*u1**(-1)*mg2*mst12 + 8.D+0
     +    *u1**(-1)*mt2*mst12 - 8.D+0*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0A(1)*N*CO * (  - 6.D+0*s**(-1)*t1**(-1)*
     +    u1**2*mst12 + s**(-1)*t1*u1 - 1.2D+1*s**(-1)*t1*mst12 - 6.D+0
     +    *s**(-1)*t1**2*u1**(-1)*mst12 - s**(-1)*t1**2 - 1.2D+1*
     +    s**(-1)*u1*mst12 + 2.D+0*s**(-1)*u1**2 + 2.5D+0*s*t1**(-1)*
     +    mst12 + 2.5D+0*s*u1**(-1)*mst12 + 5.D-1*t1**(-1)*u1*mst12 + 
     +    5.D-1*t1*u1**(-1)*mst12 - t1 + 2.D+0*u1 - mst12 )
      M2GGSV = M2GGSV + SK3C0A(2)*N*CK * (  - 1.D+1*s**(-1)*t1**(-1)*u1
     +    *mst12**2 - 4.D+0*s**(-1)*t1**(-1)*u1**2*mst12 - 1.D+1*
     +    s**(-1)*t1*u1**(-1)*mst12**2 - 8.D+0*s**(-1)*t1*u1 - 2.D+1*
     +    s**(-1)*t1*mst12 - 4.D+0*s**(-1)*t1**2*u1**(-1)*mst12 - 4.D+0
     +    *s**(-1)*t1**2 - 2.D+1*s**(-1)*u1*mst12 - 4.D+0*s**(-1)*u1**2
     +     - 2.D+1*s**(-1)*mst12**2 - 2.D+0*t1**(-1)*mst12**2*sin2t**2
     +     + 2.D+0*t1**(-1)*mst12**2 - 2.D+0*u1**(-1)*mst12**2*sin2t**2
     +     + 2.D+0*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0A(2)*CO * ( 2.D+0*s**(-2)*t1**2*mst12 - 
     +    2.D+0*s**(-2)*u1**2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12**2 + 2.D+0*s**(-1)*t1*u1**(-1)*mst12**2 + 2.D+0*s**(-1)
     +    *t1*mst12 - 2.D+0*s**(-1)*u1*mst12 - 4.D+0*s**(-1)*mst12**2
     +     + 2.D+0*t1**(-1)*mst12**2*sin2t**2 - 2.D+0*t1**(-1)*mst12**2
     +     + 2.D+0*u1**(-1)*mst12**2*sin2t**2 - 2.D+0*u1**(-1)*mst12**2
     +     )
      M2GGSV = M2GGSV + SK3C0A(2)*CK * ( 8.D+0*s*t1**(-1)*u1**(-1)*
     +    mst12**2*sin2t**2 - 8.D+0*s*t1**(-1)*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0A(2)*CQED * (  - 4.D+0*s*t1**(-1)*u1**(-1)
     +    *mst12**2*sin2t**2 + 4.D+0*s*t1**(-1)*u1**(-1)*mst12**2 - 
     +    1.2D+1*t1**(-1)*u1*mst12 - 2.D+0*t1**(-1)*u1**2 - 2.D+1*
     +    t1**(-1)*mst12**2 - 1.2D+1*t1*u1**(-1)*mst12 - 6.D+0*t1 - 
     +    2.D+0*t1**2*u1**(-1) - 2.D+1*u1**(-1)*mst12**2 - 6.D+0*u1 - 
     +    2.4D+1*mst12 )
      M2GGSV = M2GGSV + SK3C0A(3)*N*CO * (  - 4.D+0*s**(-2)*t1**2*mg2
     +     + 4.D+0*s**(-2)*u1**2*mg2 - 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*
     +    mg2*sin2t + 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mt2*sin2t - 4.D+0
     +    *s**(-1)*t1**(-1)*u1*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*
     +    t1**(-1)*u1*mg2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*mg2**2 + 
     +    4.D+0*s**(-1)*t1**(-1)*u1*mt2*mst12 - 2.D+0*s**(-1)*t1**(-1)*
     +    u1*mt2**2 - 2.D+0*s**(-1)*t1**(-1)*u1*mst12**2 - s**(-1)*
     +    t1**(-1)*u1**2*mg2 + s**(-1)*t1**(-1)*u1**2*mt2 - 4.D+0*
     +    s**(-1)*t1*u1**(-1)*mg*mt*mg2*sin2t + 4.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mt2*sin2t - 4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*
     +    mst12*sin2t - 8.D+0*s**(-1)*t1*u1**(-1)*mg2*mst12 + 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2**2 + 4.D+0*s**(-1)*t1*u1**(-1)*mt2*
     +    mst12 - 2.D+0*s**(-1)*t1*u1**(-1)*mt2**2 - 2.D+0*s**(-1)*t1*
     +    u1**(-1)*mst12**2 - 2.D+0*s**(-1)*t1*u1 - 8.D+0*s**(-1)*t1*mg
     +    *mt*sin2t - 3.D+0*s**(-1)*t1*mg2 + 7.D+0*s**(-1)*t1*mt2 - 
     +    4.D+0*s**(-1)*t1*mst12 )
      M2GGSV = M2GGSV + SK3C0A(3)*N*CO * (  - s**(-1)*t1**2*u1**(-1)*
     +    mg2 + s**(-1)*t1**2*u1**(-1)*mt2 - s**(-1)*t1**2 - 8.D+0*
     +    s**(-1)*u1*mg*mt*sin2t + 5.D+0*s**(-1)*u1*mg2 + 7.D+0*s**(-1)
     +    *u1*mt2 - 4.D+0*s**(-1)*u1*mst12 - s**(-1)*u1**2 - 8.D+0*
     +    s**(-1)*mg*mt*mg2*sin2t + 8.D+0*s**(-1)*mg*mt*mt2*sin2t - 
     +    8.D+0*s**(-1)*mg*mt*mst12*sin2t + 4.D+0*s**(-1)*mg2**2 + 
     +    8.D+0*s**(-1)*mt2*mst12 - 4.D+0*s**(-1)*mt2**2 - 4.D+0*
     +    s**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0A(4)*N*CK * (  - 4.D+0*s**(-1)*t1**(-1)*u1
     +    *mg*mt*mg2*sin2t + 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mt2*sin2t
     +     + 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mst12*sin2t - 4.D+0*
     +    s**(-1)*t1**(-1)*u1*mg2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mg2**2 + 4.D+0*s**(-1)*t1**(-1)*u1*mt2*mst12 - 2.D+0*s**(-1)*
     +    t1**(-1)*u1*mt2**2 + 2.D+0*s**(-1)*t1**(-1)*u1*mst12**2 - 
     +    s**(-1)*t1**(-1)*u1**2*mg2 + s**(-1)*t1**(-1)*u1**2*mt2 - 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2*sin2t + 4.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mt2*sin2t + 4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*
     +    mst12*sin2t - 4.D+0*s**(-1)*t1*u1**(-1)*mg2*mst12 + 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2**2 + 4.D+0*s**(-1)*t1*u1**(-1)*mt2*
     +    mst12 - 2.D+0*s**(-1)*t1*u1**(-1)*mt2**2 + 2.D+0*s**(-1)*t1*
     +    u1**(-1)*mst12**2 + 2.D+0*s**(-1)*t1*u1 + 8.D+0*s**(-1)*t1*mg
     +    *mt*sin2t - 7.D+0*s**(-1)*t1*mg2 - s**(-1)*t1*mt2 + 4.D+0*
     +    s**(-1)*t1*mst12 - s**(-1)*t1**2*u1**(-1)*mg2 + s**(-1)*t1**2
     +    *u1**(-1)*mt2 )
      M2GGSV = M2GGSV + SK3C0A(4)*N*CK * ( s**(-1)*t1**2 + 8.D+0*
     +    s**(-1)*u1*mg*mt*sin2t - 7.D+0*s**(-1)*u1*mg2 - s**(-1)*u1*
     +    mt2 + 4.D+0*s**(-1)*u1*mst12 + s**(-1)*u1**2 - 8.D+0*s**(-1)*
     +    mg*mt*mg2*sin2t + 8.D+0*s**(-1)*mg*mt*mt2*sin2t + 8.D+0*
     +    s**(-1)*mg*mt*mst12*sin2t - 8.D+0*s**(-1)*mg2*mst12 + 4.D+0*
     +    s**(-1)*mg2**2 + 8.D+0*s**(-1)*mt2*mst12 - 4.D+0*s**(-1)*
     +    mt2**2 + 4.D+0*s**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0A(4)*CO * (  - 4.D+0*s**(-2)*t1**2*mt2 + 
     +    4.D+0*s**(-2)*u1**2*mt2 - 4.D+0*s**(-1)*t1**(-1)*u1*mt2*mst12
     +     - 4.D+0*s**(-1)*t1*u1**(-1)*mt2*mst12 - 4.D+0*s**(-1)*t1*mt2
     +     + 4.D+0*s**(-1)*u1*mt2 + 8.D+0*s**(-1)*mt2*mst12 )
      M2GGSV = M2GGSV + SK3C0A(4)*CQED * ( 4.D+0*t1**(-1)*u1*mg*mt*
     +    sin2t - 4.D+0*t1**(-1)*u1*mg2 + 2.D+0*t1**(-1)*u1*mst12 + 
     +    t1**(-1)*u1**2 - 8.D+0*t1**(-1)*mg*mt*mg2*sin2t + 8.D+0*
     +    t1**(-1)*mg*mt*mt2*sin2t + 8.D+0*t1**(-1)*mg*mt*mst12*sin2t
     +     - 8.D+0*t1**(-1)*mg2*mst12 + 4.D+0*t1**(-1)*mg2**2 + 8.D+0*
     +    t1**(-1)*mt2*mst12 - 4.D+0*t1**(-1)*mt2**2 + 4.D+0*t1**(-1)*
     +    mst12**2 + 4.D+0*t1*u1**(-1)*mg*mt*sin2t - 4.D+0*t1*u1**(-1)*
     +    mg2 + 2.D+0*t1*u1**(-1)*mst12 + t1 + t1**2*u1**(-1) - 8.D+0*
     +    u1**(-1)*mg*mt*mg2*sin2t + 8.D+0*u1**(-1)*mg*mt*mt2*sin2t + 
     +    8.D+0*u1**(-1)*mg*mt*mst12*sin2t - 8.D+0*u1**(-1)*mg2*mst12
     +     + 4.D+0*u1**(-1)*mg2**2 + 8.D+0*u1**(-1)*mt2*mst12 - 4.D+0*
     +    u1**(-1)*mt2**2 + 4.D+0*u1**(-1)*mst12**2 + u1 + 8.D+0*mg*mt*
     +    sin2t - 8.D+0*mg2 + 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0A(7)*CO * ( 4.D+0*s**(-2)*t1**2*nf*ms2 - 
     +    4.D+0*s**(-2)*u1**2*nf*ms2 + 4.D+0*s**(-1)*t1**(-1)*u1*nf*ms2
     +    *mst12 + 4.D+0*s**(-1)*t1*u1**(-1)*nf*ms2*mst12 + 4.D+0*
     +    s**(-1)*t1*nf*ms2 - 4.D+0*s**(-1)*u1*nf*ms2 - 8.D+0*s**(-1)*
     +    nf*ms2*mst12 )
      M2GGSV = M2GGSV + SK3C0A(8)*N*CK * ( 2.D+0*t1**(-1)*mst12*mst22*
     +    sin2t**2 + 2.D+0*u1**(-1)*mst12*mst22*sin2t**2 )
      M2GGSV = M2GGSV + SK3C0A(8)*CO * ( 2.D+0*s**(-2)*t1**2*mst22 - 
     +    2.D+0*s**(-2)*u1**2*mst22 + 2.D+0*s**(-1)*t1**(-1)*u1*mst12*
     +    mst22 + 2.D+0*s**(-1)*t1*u1**(-1)*mst12*mst22 + 2.D+0*s**(-1)
     +    *t1*mst22 - 2.D+0*s**(-1)*u1*mst22 - 4.D+0*s**(-1)*mst12*
     +    mst22 - 2.D+0*t1**(-1)*mst12*mst22*sin2t**2 + 2.D+0*t1**(-1)*
     +    mst12*mst22 - 2.D+0*u1**(-1)*mst12*mst22*sin2t**2 + 2.D+0*
     +    u1**(-1)*mst12*mst22 )
      M2GGSV = M2GGSV + SK3C0A(8)*CK * (  - 8.D+0*s*t1**(-1)*u1**(-1)*
     +    mst12*mst22*sin2t**2 + 8.D+0*s*t1**(-1)*u1**(-1)*mst12*mst22
     +     )
      M2GGSV = M2GGSV + SK3C0A(8)*CQED * ( 4.D+0*s*t1**(-1)*u1**(-1)*
     +    mst12*mst22*sin2t**2 )
      M2GGSV = M2GGSV + SK3C0B(1)*N*CK * (  - 1.6D+1*s**(-2)*t1**2*
     +    mst12 + 4.D+0*s**(-1)*t1**(-1)*u1*mst12**2 + 4.D+0*s**(-1)*
     +    t1**(-1)*u1**2*mst12 + 4.D+0*s**(-1)*t1*u1**(-1)*mst12**2 - 
     +    9.75D+0*s**(-1)*t1*u1 - 3.4D+1*s**(-1)*t1*mst12 + s**(-1)*
     +    t1**2*u1**(-1)*mst12 + 3.5D+0*s**(-1)*t1**2 + 2.5D-1*s**(-1)*
     +    t1**3*u1**(-1) - 1.5D+1*s**(-1)*u1*mst12 - 5.D+0*s**(-1)*
     +    u1**2 - 4.D+1*s**(-1)*mst12**2 + 2.D+0*s*t1**(-1)*mst12 - 
     +    2.5D-1*s*t1*u1**(-1) + 2.D+0*s*u1**(-1)*mst12 + 2.75D+0*s + 
     +    2.D+0*t1**(-1)*u1*mst12 - 4.D+0*t1**(-1)*mst12**2 - t1*
     +    u1**(-1)*mst12 + 5.75D+0*t1 - 4.D+0*u1**(-1)*mst12**2 - 
     +    2.25D+0*u1 + mst12 )
      M2GGSV = M2GGSV + SK3C0B(1)*CQED * ( 2.D+0*s*t1**(-1)*mst12 - 
     +    4.D+0*s*u1**(-1)*mst12 - 2.5D+0*s + s**2*t1**(-1) + 5.D-1*
     +    s**2*u1**(-1) - 6.D+0*t1**(-1)*u1*mst12 - 3.D+0*t1**(-1)*
     +    u1**2 - 8.D+0*t1**(-1)*mst12**2 - 1.2D+1*t1*u1**(-1)*mst12 - 
     +    6.5D+0*t1 - 2.5D+0*t1**2*u1**(-1) - 8.D+0*u1**(-1)*mst12**2
     +     - 7.D+0*u1 - 1.D+1*mst12 )
      M2GGSV = M2GGSV + SK3C0B(2)*N*CO * ( 4.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12**2 + 4.D+0*s**(-1)*t1**(-1)*u1**2*mst12 - s**(-1)*
     +    t1**(-1)*u1**3 + 4.D+0*s**(-1)*t1*u1**(-1)*mst12**2 + s**(-1)
     +    *t1*u1 + 8.D+0*s**(-1)*t1*mst12 + 4.D+0*s**(-1)*t1**2*
     +    u1**(-1)*mst12 + 7.5D+0*s**(-1)*t1**2 - s**(-1)*t1**3*
     +    u1**(-1) + 8.D+0*s**(-1)*u1*mst12 + 3.5D+0*s**(-1)*u1**2 + 
     +    8.D+0*s**(-1)*mst12**2 - 3.5D+0*s - s**2*t1**(-1) - s**2*
     +    u1**(-1) + 1.6D+1*t1**(-1)*s1**(-1)*mst12**3 - 4.D+0*t1**(-1)
     +    *mst12**2 + 1.6D+1*t1*s1**(-1)*mst12 + 4.D+0*t1**2*s1**(-1)
     +     + 1.6D+1*u1**(-1)*s1**(-1)*mst12**3 - 4.D+0*u1**(-1)*
     +    mst12**2 + 3.2D+1*s1**(-1)*mst12**2 - 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0B(3)*N*CO * (  - 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*mg2*sin2t + 3.2D+1*s**(-2)*t1**2*mg*mt*s1**(-1)*
     +    mt2*sin2t - 8.D+0*s**(-2)*t1**2*mg*mt*sin2t + 1.6D+1*s**(-2)*
     +    t1**2*s1**(-1)*mg2**2 - 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2**2
     +     + 8.D+0*s**(-2)*t1**2*mt2 - 4.D+0*s**(-2)*t1**2*mst12 + 
     +    4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2*sin2t - 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*mt2*sin2t + 2.D+0*s**(-1)*t1**(-1)*u1*mg2*
     +    mst12 - 2.D+0*s**(-1)*t1**(-1)*u1*mg2**2 - 2.D+0*s**(-1)*
     +    t1**(-1)*u1*mt2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*mt2**2 + 
     +    s**(-1)*t1**(-1)*u1**2*mg2 - s**(-1)*t1**(-1)*u1**2*mt2 + 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2*sin2t - 4.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mt2*sin2t + 2.D+0*s**(-1)*t1*u1**(-1)*mg2*
     +    mst12 - 2.D+0*s**(-1)*t1*u1**(-1)*mg2**2 - 2.D+0*s**(-1)*t1*
     +    u1**(-1)*mt2*mst12 + 2.D+0*s**(-1)*t1*u1**(-1)*mt2**2 - 2.D+0
     +    *s**(-1)*t1*u1 - 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mg2*sin2t
     +     + 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mt2*sin2t )
      M2GGSV = M2GGSV + SK3C0B(3)*N*CO * (  - 1.2D+1*s**(-1)*t1*mg*mt*
     +    sin2t + 1.6D+1*s**(-1)*t1*s1**(-1)*mg2**2 - 1.6D+1*s**(-1)*t1
     +    *s1**(-1)*mt2**2 + s**(-1)*t1*mg2 + 1.1D+1*s**(-1)*t1*mt2 - 
     +    6.D+0*s**(-1)*t1*mst12 + s**(-1)*t1**2*u1**(-1)*mg2 - s**(-1)
     +    *t1**2*u1**(-1)*mt2 + 8.D+0*s**(-1)*t1**2*mg*mt*s1**(-1)*
     +    sin2t - 8.D+0*s**(-1)*t1**2*s1**(-1)*mt2 - 2.D+0*s**(-1)*
     +    t1**2 - 4.D+0*s**(-1)*u1*mg*mt*sin2t + s**(-1)*u1*mg2 + 3.D+0
     +    *s**(-1)*u1*mt2 - 2.D+0*s**(-1)*u1*mst12 - s**(-1)*u1**2 - 
     +    1.6D+1*s**(-1)*mg*mt*mg2*sin2t + 1.6D+1*s**(-1)*mg*mt*mt2*
     +    sin2t - 2.4D+1*s**(-1)*mg*mt*mst12*sin2t + 4.D+0*s**(-1)*mg2*
     +    mst12 + 8.D+0*s**(-1)*mg2**2 + 2.D+1*s**(-1)*mt2*mst12 - 
     +    8.D+0*s**(-1)*mt2**2 - 1.2D+1*s**(-1)*mst12**2 - 8.D+0*
     +    t1**(-1)*mg*mt*s1**(-1)*mg2*mst12*sin2t + 8.D+0*t1**(-1)*mg*
     +    mt*s1**(-1)*mt2*mst12*sin2t + 8.D+0*t1**(-1)*mg*mt*s1**(-1)*
     +    mst12**2*sin2t - 4.D+0*t1**(-1)*mg*mt*mst12*sin2t + 4.D+0*
     +    t1**(-1)*s1**(-1)*mg2**2*mst12 )
      M2GGSV = M2GGSV + SK3C0B(3)*N*CO * (  - 8.D+0*t1**(-1)*s1**(-1)*
     +    mt2*mst12**2 - 4.D+0*t1**(-1)*s1**(-1)*mt2**2*mst12 - 4.D+0*
     +    t1**(-1)*s1**(-1)*mst12**3 + 4.D+0*t1**(-1)*mt2*mst12 + 8.D+0
     +    *t1*mg*mt*s1**(-1)*sin2t - 8.D+0*t1*s1**(-1)*mt2 - 4.D+0*t1*
     +    s1**(-1)*mst12 - t1**2*s1**(-1) - 8.D+0*u1**(-1)*mg*mt*
     +    s1**(-1)*mg2*mst12*sin2t + 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mt2*
     +    mst12*sin2t + 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mst12**2*sin2t - 
     +    4.D+0*u1**(-1)*mg*mt*mst12*sin2t + 4.D+0*u1**(-1)*s1**(-1)*
     +    mg2**2*mst12 - 8.D+0*u1**(-1)*s1**(-1)*mt2*mst12**2 - 4.D+0*
     +    u1**(-1)*s1**(-1)*mt2**2*mst12 - 4.D+0*u1**(-1)*s1**(-1)*
     +    mst12**3 + 4.D+0*u1**(-1)*mt2*mst12 - 1.6D+1*mg*mt*s1**(-1)*
     +    mg2*sin2t + 1.6D+1*mg*mt*s1**(-1)*mt2*sin2t + 1.6D+1*mg*mt*
     +    s1**(-1)*mst12*sin2t - 4.D+0*mg*mt*sin2t + 8.D+0*s1**(-1)*
     +    mg2**2 - 1.6D+1*s1**(-1)*mt2*mst12 - 8.D+0*s1**(-1)*mt2**2 - 
     +    8.D+0*s1**(-1)*mst12**2 + 4.D+0*mt2 + 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0B(4)*N*CK * (  - 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*mg2*sin2t + 3.2D+1*s**(-2)*t1**2*mg*mt*s1**(-1)*
     +    mt2*sin2t + 8.D+0*s**(-2)*t1**2*mg*mt*sin2t + 1.6D+1*s**(-2)*
     +    t1**2*s1**(-1)*mg2**2 - 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2**2
     +     - 8.D+0*s**(-2)*t1**2*mg2 + 4.D+0*s**(-2)*t1**2*mst12 + 
     +    4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2*sin2t - 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*mt2*sin2t + 2.D+0*s**(-1)*t1**(-1)*u1*mg2*
     +    mst12 - 2.D+0*s**(-1)*t1**(-1)*u1*mg2**2 - 2.D+0*s**(-1)*
     +    t1**(-1)*u1*mt2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*mt2**2 + 
     +    s**(-1)*t1**(-1)*u1**2*mg2 - s**(-1)*t1**(-1)*u1**2*mt2 + 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2*sin2t - 4.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mt2*sin2t + 2.D+0*s**(-1)*t1*u1**(-1)*mg2*
     +    mst12 - 2.D+0*s**(-1)*t1*u1**(-1)*mg2**2 - 2.D+0*s**(-1)*t1*
     +    u1**(-1)*mt2*mst12 + 2.D+0*s**(-1)*t1*u1**(-1)*mt2**2 + 2.D+0
     +    *s**(-1)*t1*u1 - 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mg2*sin2t
     +     + 3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mt2*sin2t )
      M2GGSV = M2GGSV + SK3C0B(4)*N*CK * ( 1.2D+1*s**(-1)*t1*mg*mt*
     +    sin2t + 1.6D+1*s**(-1)*t1*s1**(-1)*mg2**2 - 1.6D+1*s**(-1)*t1
     +    *s1**(-1)*mt2**2 - 1.1D+1*s**(-1)*t1*mg2 - s**(-1)*t1*mt2 + 
     +    6.D+0*s**(-1)*t1*mst12 + s**(-1)*t1**2*u1**(-1)*mg2 - s**(-1)
     +    *t1**2*u1**(-1)*mt2 - 8.D+0*s**(-1)*t1**2*mg*mt*s1**(-1)*
     +    sin2t + 8.D+0*s**(-1)*t1**2*s1**(-1)*mg2 + 2.D+0*s**(-1)*
     +    t1**2 + 4.D+0*s**(-1)*u1*mg*mt*sin2t - 3.D+0*s**(-1)*u1*mg2
     +     - s**(-1)*u1*mt2 + 2.D+0*s**(-1)*u1*mst12 + s**(-1)*u1**2 - 
     +    1.6D+1*s**(-1)*mg*mt*mg2*sin2t + 1.6D+1*s**(-1)*mg*mt*mt2*
     +    sin2t + 2.4D+1*s**(-1)*mg*mt*mst12*sin2t - 2.D+1*s**(-1)*mg2*
     +    mst12 + 8.D+0*s**(-1)*mg2**2 - 4.D+0*s**(-1)*mt2*mst12 - 
     +    8.D+0*s**(-1)*mt2**2 + 1.2D+1*s**(-1)*mst12**2 - 8.D+0*
     +    t1**(-1)*mg*mt*s1**(-1)*mg2*mst12*sin2t + 8.D+0*t1**(-1)*mg*
     +    mt*s1**(-1)*mt2*mst12*sin2t - 8.D+0*t1**(-1)*mg*mt*s1**(-1)*
     +    mst12**2*sin2t + 4.D+0*t1**(-1)*mg*mt*mst12*sin2t + 8.D+0*
     +    t1**(-1)*s1**(-1)*mg2*mst12**2 )
      M2GGSV = M2GGSV + SK3C0B(4)*N*CK * ( 4.D+0*t1**(-1)*s1**(-1)*
     +    mg2**2*mst12 - 4.D+0*t1**(-1)*s1**(-1)*mt2**2*mst12 + 4.D+0*
     +    t1**(-1)*s1**(-1)*mst12**3 - 4.D+0*t1**(-1)*mg2*mst12 - 8.D+0
     +    *t1*mg*mt*s1**(-1)*sin2t + 8.D+0*t1*s1**(-1)*mg2 + 4.D+0*t1*
     +    s1**(-1)*mst12 + t1**2*s1**(-1) - 8.D+0*u1**(-1)*mg*mt*
     +    s1**(-1)*mg2*mst12*sin2t + 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mt2*
     +    mst12*sin2t - 8.D+0*u1**(-1)*mg*mt*s1**(-1)*mst12**2*sin2t + 
     +    4.D+0*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*u1**(-1)*s1**(-1)*
     +    mg2*mst12**2 + 4.D+0*u1**(-1)*s1**(-1)*mg2**2*mst12 - 4.D+0*
     +    u1**(-1)*s1**(-1)*mt2**2*mst12 + 4.D+0*u1**(-1)*s1**(-1)*
     +    mst12**3 - 4.D+0*u1**(-1)*mg2*mst12 - 1.6D+1*mg*mt*s1**(-1)*
     +    mg2*sin2t + 1.6D+1*mg*mt*s1**(-1)*mt2*sin2t - 1.6D+1*mg*mt*
     +    s1**(-1)*mst12*sin2t + 4.D+0*mg*mt*sin2t + 1.6D+1*s1**(-1)*
     +    mg2*mst12 + 8.D+0*s1**(-1)*mg2**2 - 8.D+0*s1**(-1)*mt2**2 + 
     +    8.D+0*s1**(-1)*mst12**2 - 4.D+0*mg2 - 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0B(4)*CQED * (  - 2.D+0*s*t1**(-1)*mst12 - 
     +    2.D+0*s*u1**(-1)*mst12 + 4.D+0*t1**(-1)*u1*mg*mt*sin2t - 
     +    2.D+0*t1**(-1)*u1*mg2 - 2.D+0*t1**(-1)*u1*mt2 + 2.D+0*
     +    t1**(-1)*u1*mst12 + t1**(-1)*u1**2 + 8.D+0*t1**(-1)*mg*mt*
     +    mst12*sin2t - 4.D+0*t1**(-1)*mg2*mst12 - 4.D+0*t1**(-1)*mt2*
     +    mst12 + 4.D+0*t1**(-1)*mst12**2 + 4.D+0*t1*u1**(-1)*mg*mt*
     +    sin2t - 2.D+0*t1*u1**(-1)*mg2 - 2.D+0*t1*u1**(-1)*mt2 + 2.D+0
     +    *t1*u1**(-1)*mst12 + t1 + t1**2*u1**(-1) + 8.D+0*u1**(-1)*mg*
     +    mt*mst12*sin2t - 4.D+0*u1**(-1)*mg2*mst12 - 4.D+0*u1**(-1)*
     +    mt2*mst12 + 4.D+0*u1**(-1)*mst12**2 + u1 )
      M2GGSV = M2GGSV + SK3C0C(1,1)*N*CO * (  - 8.D+0*s**(-1)*t1**(-1)*
     +    u1*mst12**2 + 4.D+0*s**(-1)*t1*u1 - 4.D+0*s**(-1)*t1*mst12 - 
     +    4.D+0*s**(-1)*t1**2 + 4.D+0*s**(-1)*u1*mst12 - 8.D+0*s**(-1)*
     +    mst12**2 - 8.D+0*t1**(-1)*mst12**2 - 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(1,1)*N*CK * (  - 8.D+0*s*t1**(-1)*
     +    u1**(-1)*mst12**2 - 4.D+0*s*u1**(-1)*mst12 - 8.D+0*t1**(-1)*
     +    mst12**2 + 4.D+0*t1*u1**(-1)*mst12 + 4.D+0*t1 + 8.D+0*
     +    u1**(-1)*mst12**2 + 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(1,2)*N*CO * (  - 8.D+0*s**(-1)*t1*
     +    u1**(-1)*mst12**2 + 4.D+0*s**(-1)*t1*u1 + 4.D+0*s**(-1)*t1*
     +    mst12 - 4.D+0*s**(-1)*u1*mst12 - 4.D+0*s**(-1)*u1**2 - 8.D+0*
     +    s**(-1)*mst12**2 - 8.D+0*u1**(-1)*mst12**2 - 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(1,2)*N*CK * (  - 8.D+0*s*t1**(-1)*
     +    u1**(-1)*mst12**2 - 4.D+0*s*t1**(-1)*mst12 + 4.D+0*t1**(-1)*
     +    u1*mst12 + 8.D+0*t1**(-1)*mst12**2 - 8.D+0*u1**(-1)*mst12**2
     +     + 4.D+0*u1 + 4.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(3,1)*N*CK * ( 4.D+0*s**(-1)*t1*u1 + 
     +    1.6D+1*s**(-1)*t1*mst12 + 4.D+0*s**(-1)*t1**2 + 8.D+0*s**(-1)
     +    *u1*mst12 + 1.6D+1*s**(-1)*mst12**2 - 8.D+0*t1*u1**(-1)*mst12
     +     - 4.D+0*t1 - 8.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(3,1)*CQED * ( 1.6D+1*t1*u1**(-1)*mst12
     +     + 4.D+0*t1 + 4.D+0*t1**2*u1**(-1) + 1.6D+1*u1**(-1)*mst12**2
     +     + 8.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(3,2)*N*CK * ( 4.D+0*s**(-1)*t1*u1 + 
     +    8.D+0*s**(-1)*t1*mst12 + 1.6D+1*s**(-1)*u1*mst12 + 4.D+0*
     +    s**(-1)*u1**2 + 1.6D+1*s**(-1)*mst12**2 - 8.D+0*t1**(-1)*u1*
     +    mst12 - 4.D+0*u1 - 8.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(3,2)*CQED * ( 1.6D+1*t1**(-1)*u1*mst12
     +     + 4.D+0*t1**(-1)*u1**2 + 1.6D+1*t1**(-1)*mst12**2 + 4.D+0*u1
     +     + 8.D+0*mst12 )
      M2GGSV = M2GGSV + SK3C0C(4,1)*N*CO * ( 8.D+0*s**(-1)*t1*mg*mt*
     +    sin2t - 2.D+0*s**(-1)*t1*mg2 - 6.D+0*s**(-1)*t1*mt2 + 4.D+0*
     +    s**(-1)*t1*mst12 + 2.D+0*s**(-1)*t1**2 + 2.D+0*s**(-1)*u1*mg2
     +     - 2.D+0*s**(-1)*u1*mt2 + 8.D+0*s**(-1)*mg*mt*mg2*sin2t - 
     +    8.D+0*s**(-1)*mg*mt*mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mst12*
     +    sin2t - 4.D+0*s**(-1)*mg2**2 - 8.D+0*s**(-1)*mt2*mst12 + 
     +    4.D+0*s**(-1)*mt2**2 + 4.D+0*s**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0C(4,1)*N*CK * ( 2.D+0*t1*u1**(-1)*mg2 - 
     +    2.D+0*t1*u1**(-1)*mt2 + 8.D+0*u1**(-1)*mg*mt*mg2*sin2t - 
     +    8.D+0*u1**(-1)*mg*mt*mt2*sin2t - 8.D+0*u1**(-1)*mg*mt*mst12*
     +    sin2t + 8.D+0*u1**(-1)*mg2*mst12 - 4.D+0*u1**(-1)*mg2**2 + 
     +    4.D+0*u1**(-1)*mt2**2 - 4.D+0*u1**(-1)*mst12**2 + 2.D+0*mg2
     +     - 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3C0C(4,2)*N*CO * ( 2.D+0*s**(-1)*t1*mg2 - 
     +    2.D+0*s**(-1)*t1*mt2 + 8.D+0*s**(-1)*u1*mg*mt*sin2t - 2.D+0*
     +    s**(-1)*u1*mg2 - 6.D+0*s**(-1)*u1*mt2 + 4.D+0*s**(-1)*u1*
     +    mst12 + 2.D+0*s**(-1)*u1**2 + 8.D+0*s**(-1)*mg*mt*mg2*sin2t
     +     - 8.D+0*s**(-1)*mg*mt*mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mst12*
     +    sin2t - 4.D+0*s**(-1)*mg2**2 - 8.D+0*s**(-1)*mt2*mst12 + 
     +    4.D+0*s**(-1)*mt2**2 + 4.D+0*s**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SK3C0C(4,2)*N*CK * ( 2.D+0*t1**(-1)*u1*mg2 - 
     +    2.D+0*t1**(-1)*u1*mt2 + 8.D+0*t1**(-1)*mg*mt*mg2*sin2t - 
     +    8.D+0*t1**(-1)*mg*mt*mt2*sin2t - 8.D+0*t1**(-1)*mg*mt*mst12*
     +    sin2t + 8.D+0*t1**(-1)*mg2*mst12 - 4.D+0*t1**(-1)*mg2**2 + 
     +    4.D+0*t1**(-1)*mt2**2 - 4.D+0*t1**(-1)*mst12**2 + 2.D+0*mg2
     +     - 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3C0C(5,1)*N*CK * (  - 8.D+0*s**(-1)*t1*mg*mt*
     +    sin2t + 6.D+0*s**(-1)*t1*mg2 + 2.D+0*s**(-1)*t1*mt2 - 4.D+0*
     +    s**(-1)*t1*mst12 - 2.D+0*s**(-1)*t1**2 + 2.D+0*s**(-1)*u1*mg2
     +     - 2.D+0*s**(-1)*u1*mt2 + 8.D+0*s**(-1)*mg*mt*mg2*sin2t - 
     +    8.D+0*s**(-1)*mg*mt*mt2*sin2t - 8.D+0*s**(-1)*mg*mt*mst12*
     +    sin2t + 8.D+0*s**(-1)*mg2*mst12 - 4.D+0*s**(-1)*mg2**2 + 
     +    4.D+0*s**(-1)*mt2**2 - 4.D+0*s**(-1)*mst12**2 - 2.D+0*t1*
     +    u1**(-1)*mg2 + 2.D+0*t1*u1**(-1)*mt2 - 8.D+0*u1**(-1)*mg*mt*
     +    mg2*sin2t + 8.D+0*u1**(-1)*mg*mt*mt2*sin2t - 8.D+0*u1**(-1)*
     +    mg*mt*mst12*sin2t + 4.D+0*u1**(-1)*mg2**2 + 8.D+0*u1**(-1)*
     +    mt2*mst12 - 4.D+0*u1**(-1)*mt2**2 - 4.D+0*u1**(-1)*mst12**2
     +     - 2.D+0*mg2 + 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3C0C(5,1)*CQED * (  - 8.D+0*t1*u1**(-1)*mg*mt
     +    *sin2t + 6.D+0*t1*u1**(-1)*mg2 + 2.D+0*t1*u1**(-1)*mt2 - 
     +    4.D+0*t1*u1**(-1)*mst12 - 2.D+0*t1**2*u1**(-1) + 8.D+0*
     +    u1**(-1)*mg*mt*mg2*sin2t - 8.D+0*u1**(-1)*mg*mt*mt2*sin2t - 
     +    8.D+0*u1**(-1)*mg*mt*mst12*sin2t + 8.D+0*u1**(-1)*mg2*mst12
     +     - 4.D+0*u1**(-1)*mg2**2 + 4.D+0*u1**(-1)*mt2**2 - 4.D+0*
     +    u1**(-1)*mst12**2 + 2.D+0*mg2 - 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3C0C(5,2)*N*CK * ( 2.D+0*s**(-1)*t1*mg2 - 
     +    2.D+0*s**(-1)*t1*mt2 - 8.D+0*s**(-1)*u1*mg*mt*sin2t + 6.D+0*
     +    s**(-1)*u1*mg2 + 2.D+0*s**(-1)*u1*mt2 - 4.D+0*s**(-1)*u1*
     +    mst12 - 2.D+0*s**(-1)*u1**2 + 8.D+0*s**(-1)*mg*mt*mg2*sin2t
     +     - 8.D+0*s**(-1)*mg*mt*mt2*sin2t - 8.D+0*s**(-1)*mg*mt*mst12*
     +    sin2t + 8.D+0*s**(-1)*mg2*mst12 - 4.D+0*s**(-1)*mg2**2 + 
     +    4.D+0*s**(-1)*mt2**2 - 4.D+0*s**(-1)*mst12**2 - 2.D+0*
     +    t1**(-1)*u1*mg2 + 2.D+0*t1**(-1)*u1*mt2 - 8.D+0*t1**(-1)*mg*
     +    mt*mg2*sin2t + 8.D+0*t1**(-1)*mg*mt*mt2*sin2t - 8.D+0*
     +    t1**(-1)*mg*mt*mst12*sin2t + 4.D+0*t1**(-1)*mg2**2 + 8.D+0*
     +    t1**(-1)*mt2*mst12 - 4.D+0*t1**(-1)*mt2**2 - 4.D+0*t1**(-1)*
     +    mst12**2 - 2.D+0*mg2 + 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3C0C(5,2)*CQED * (  - 8.D+0*t1**(-1)*u1*mg*mt
     +    *sin2t + 6.D+0*t1**(-1)*u1*mg2 + 2.D+0*t1**(-1)*u1*mt2 - 
     +    4.D+0*t1**(-1)*u1*mst12 - 2.D+0*t1**(-1)*u1**2 + 8.D+0*
     +    t1**(-1)*mg*mt*mg2*sin2t - 8.D+0*t1**(-1)*mg*mt*mt2*sin2t - 
     +    8.D+0*t1**(-1)*mg*mt*mst12*sin2t + 8.D+0*t1**(-1)*mg2*mst12
     +     - 4.D+0*t1**(-1)*mg2**2 + 4.D+0*t1**(-1)*mt2**2 - 4.D+0*
     +    t1**(-1)*mst12**2 + 2.D+0*mg2 - 2.D+0*mt2 )
      M2GGSV = M2GGSV + SK3D0(1,1)*N*CO * (  - 8.D+0*s**(-1)*t1**(-1)*
     +    u1**2*mst12**2 - 4.D+0*s**(-1)*t1*u1*mst12 - 2.D+0*s**(-1)*t1
     +    *u1**2 - 8.D+0*s**(-1)*t1*mst12**2 - 2.D+0*s**(-1)*t1**3 - 
     +    1.6D+1*s**(-1)*u1*mst12**2 - 4.D+0*s**(-1)*u1**2*mst12 )
      M2GGSV = M2GGSV + SK3D0(1,2)*N*CO * (  - 4.D+0*s**(-1)*t1*u1*
     +    mst12 - 1.6D+1*s**(-1)*t1*mst12**2 - 8.D+0*s**(-1)*t1**2*
     +    u1**(-1)*mst12**2 - 2.D+0*s**(-1)*t1**2*u1 - 4.D+0*s**(-1)*
     +    t1**2*mst12 - 8.D+0*s**(-1)*u1*mst12**2 - 2.D+0*s**(-1)*u1**3
     +     )
      M2GGSV = M2GGSV + SK3D0(2,1)*N*CK * ( 1.6D+1*s**(-1)*t1**(-1)*u1*
     +    mst12**3 + 8.D+0*s**(-1)*t1**(-1)*u1**2*mst12**2 + 1.6D+1*
     +    s**(-1)*t1*u1*mst12 + 2.D+0*s**(-1)*t1*u1**2 + 2.4D+1*s**(-1)
     +    *t1*mst12**2 + 4.D+0*s**(-1)*t1**2*u1 + 1.2D+1*s**(-1)*t1**2*
     +    mst12 + 2.D+0*s**(-1)*t1**3 + 2.4D+1*s**(-1)*u1*mst12**2 + 
     +    4.D+0*s**(-1)*u1**2*mst12 + 1.6D+1*s**(-1)*mst12**3 )
      M2GGSV = M2GGSV + SK3D0(2,1)*CQED * ( 8.D+0*t1**(-1)*u1*mst12**2
     +     + 1.6D+1*t1**(-1)*mst12**3 + 2.4D+1*t1*u1**(-1)*mst12**2 + 
     +    2.D+0*t1*u1 + 1.6D+1*t1*mst12 + 1.2D+1*t1**2*u1**(-1)*mst12
     +     + 4.D+0*t1**2 + 2.D+0*t1**3*u1**(-1) + 1.6D+1*u1**(-1)*
     +    mst12**3 + 4.D+0*u1*mst12 + 2.4D+1*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(2,2)*N*CK * ( 1.6D+1*s**(-1)*t1*u1**(-1)*
     +    mst12**3 + 1.6D+1*s**(-1)*t1*u1*mst12 + 4.D+0*s**(-1)*t1*
     +    u1**2 + 2.4D+1*s**(-1)*t1*mst12**2 + 8.D+0*s**(-1)*t1**2*
     +    u1**(-1)*mst12**2 + 2.D+0*s**(-1)*t1**2*u1 + 4.D+0*s**(-1)*
     +    t1**2*mst12 + 2.4D+1*s**(-1)*u1*mst12**2 + 1.2D+1*s**(-1)*
     +    u1**2*mst12 + 2.D+0*s**(-1)*u1**3 + 1.6D+1*s**(-1)*mst12**3 )
      M2GGSV = M2GGSV + SK3D0(2,2)*CQED * ( 2.4D+1*t1**(-1)*u1*mst12**2
     +     + 1.2D+1*t1**(-1)*u1**2*mst12 + 2.D+0*t1**(-1)*u1**3 + 
     +    1.6D+1*t1**(-1)*mst12**3 + 8.D+0*t1*u1**(-1)*mst12**2 + 2.D+0
     +    *t1*u1 + 4.D+0*t1*mst12 + 1.6D+1*u1**(-1)*mst12**3 + 1.6D+1*
     +    u1*mst12 + 4.D+0*u1**2 + 2.4D+1*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(3,1)*N*CK * ( 8.D+0*t1**(-1)*u1*mst12**2
     +     + 8.D+0*t1*u1**(-1)*mst12**2 + 2.D+0*t1*u1 + 4.D+0*t1*mst12
     +     + 4.D+0*u1*mst12 + 8.D+0*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(3,2)*N*CK * ( 8.D+0*t1**(-1)*u1*mst12**2
     +     + 8.D+0*t1*u1**(-1)*mst12**2 + 2.D+0*t1*u1 + 4.D+0*t1*mst12
     +     + 4.D+0*u1*mst12 + 8.D+0*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(4,1)*N*CK * ( 8.D+0*s**(-1)*t1**(-1)*u1*
     +    mg*mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2*
     +    mst12*sin2t - 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2**2*sin2t - 
     +    8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mt2*mst12*sin2t - 4.D+0*
     +    s**(-1)*t1**(-1)*u1*mg*mt*mt2**2*sin2t - 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*mst12**2*sin2t + 4.D+0*s**(-1)*t1**(-1)*u1*
     +    mg2*mt2*mst12 - 2.D+0*s**(-1)*t1**(-1)*u1*mg2*mt2**2 + 6.D+0*
     +    s**(-1)*t1**(-1)*u1*mg2*mst12**2 - 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mg2**2*mt2 - 6.D+0*s**(-1)*t1**(-1)*u1*mg2**2*mst12 + 2.D+0*
     +    s**(-1)*t1**(-1)*u1*mg2**3 - 2.D+0*s**(-1)*t1**(-1)*u1*mt2*
     +    mst12**2 + 2.D+0*s**(-1)*t1**(-1)*u1*mt2**2*mst12 + 2.D+0*
     +    s**(-1)*t1**(-1)*u1*mt2**3 - 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12**3 - 2.D+0*s**(-1)*t1**(-1)*u1**2*mg*mt*mst12*sin2t + 
     +    2.D+0*s**(-1)*t1**(-1)*u1**2*mg2*mt2 + s**(-1)*t1**(-1)*u1**2
     +    *mg2*mst12 - s**(-1)*t1**(-1)*u1**2*mg2**2 + s**(-1)*t1**(-1)
     +    *u1**2*mt2*mst12 )
      M2GGSV = M2GGSV + SK3D0(4,1)*N*CK * (  - s**(-1)*t1**(-1)*u1**2*
     +    mt2**2 - 4.D+0*s**(-1)*t1*u1*mg*mt*sin2t + 5.D+0*s**(-1)*t1*
     +    u1*mg2 + s**(-1)*t1*u1*mt2 - 3.D+0*s**(-1)*t1*u1*mst12 + 
     +    8.D+0*s**(-1)*t1*mg*mt*mg2*sin2t - 8.D+0*s**(-1)*t1*mg*mt*mt2
     +    *sin2t - 1.D+1*s**(-1)*t1*mg*mt*mst12*sin2t + 2.D+0*s**(-1)*
     +    t1*mg2*mt2 + 9.D+0*s**(-1)*t1*mg2*mst12 - 5.D+0*s**(-1)*t1*
     +    mg2**2 + s**(-1)*t1*mt2*mst12 + 3.D+0*s**(-1)*t1*mt2**2 - 
     +    4.D+0*s**(-1)*t1*mst12**2 - s**(-1)*t1**2*u1 - 4.D+0*s**(-1)*
     +    t1**2*mg*mt*sin2t + 4.D+0*s**(-1)*t1**2*mg2 - 3.D+0*s**(-1)*
     +    t1**2*mst12 - s**(-1)*t1**3 + 8.D+0*s**(-1)*u1*mg*mt*mg2*
     +    sin2t - 1.2D+1*s**(-1)*u1*mg*mt*mst12*sin2t + 1.D+1*s**(-1)*
     +    u1*mg2*mst12 - 6.D+0*s**(-1)*u1*mg2**2 + 6.D+0*s**(-1)*u1*mt2
     +    *mst12 - 2.D+0*s**(-1)*u1*mt2**2 - 4.D+0*s**(-1)*u1*mst12**2
     +     + s**(-1)*u1**2*mg2 + s**(-1)*u1**2*mt2 + 8.D+0*s**(-1)*mg*
     +    mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mg2*mst12*sin2t - 
     +    4.D+0*s**(-1)*mg*mt*mg2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(4,1)*N*CK * (  - 8.D+0*s**(-1)*mg*mt*mt2*
     +    mst12*sin2t - 4.D+0*s**(-1)*mg*mt*mt2**2*sin2t - 4.D+0*
     +    s**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*s**(-1)*mg2*mt2*mst12 - 
     +    2.D+0*s**(-1)*mg2*mt2**2 + 6.D+0*s**(-1)*mg2*mst12**2 - 2.D+0
     +    *s**(-1)*mg2**2*mt2 - 6.D+0*s**(-1)*mg2**2*mst12 + 2.D+0*
     +    s**(-1)*mg2**3 - 2.D+0*s**(-1)*mt2*mst12**2 + 2.D+0*s**(-1)*
     +    mt2**2*mst12 + 2.D+0*s**(-1)*mt2**3 - 2.D+0*s**(-1)*mst12**3
     +     )
      M2GGSV = M2GGSV + SK3D0(4,1)*CQED * (  - 2.D+0*t1**(-1)*u1*mg*mt*
     +    mst12*sin2t + 2.D+0*t1**(-1)*u1*mg2*mt2 + t1**(-1)*u1*mg2*
     +    mst12 - t1**(-1)*u1*mg2**2 + t1**(-1)*u1*mt2*mst12 - t1**(-1)
     +    *u1*mt2**2 + 8.D+0*t1**(-1)*mg*mt*mg2*mt2*sin2t + 8.D+0*
     +    t1**(-1)*mg*mt*mg2*mst12*sin2t - 4.D+0*t1**(-1)*mg*mt*mg2**2*
     +    sin2t - 8.D+0*t1**(-1)*mg*mt*mt2*mst12*sin2t - 4.D+0*t1**(-1)
     +    *mg*mt*mt2**2*sin2t - 4.D+0*t1**(-1)*mg*mt*mst12**2*sin2t + 
     +    4.D+0*t1**(-1)*mg2*mt2*mst12 - 2.D+0*t1**(-1)*mg2*mt2**2 + 
     +    6.D+0*t1**(-1)*mg2*mst12**2 - 2.D+0*t1**(-1)*mg2**2*mt2 - 
     +    6.D+0*t1**(-1)*mg2**2*mst12 + 2.D+0*t1**(-1)*mg2**3 - 2.D+0*
     +    t1**(-1)*mt2*mst12**2 + 2.D+0*t1**(-1)*mt2**2*mst12 + 2.D+0*
     +    t1**(-1)*mt2**3 - 2.D+0*t1**(-1)*mst12**3 + 8.D+0*t1*u1**(-1)
     +    *mg*mt*mg2*sin2t - 8.D+0*t1*u1**(-1)*mg*mt*mt2*sin2t - 1.D+1*
     +    t1*u1**(-1)*mg*mt*mst12*sin2t + 2.D+0*t1*u1**(-1)*mg2*mt2 + 
     +    9.D+0*t1*u1**(-1)*mg2*mst12 - 5.D+0*t1*u1**(-1)*mg2**2 + t1*
     +    u1**(-1)*mt2*mst12 )
      M2GGSV = M2GGSV + SK3D0(4,1)*CQED * ( 3.D+0*t1*u1**(-1)*mt2**2 - 
     +    4.D+0*t1*u1**(-1)*mst12**2 - 4.D+0*t1*mg*mt*sin2t + 5.D+0*t1*
     +    mg2 + t1*mt2 - 3.D+0*t1*mst12 - 4.D+0*t1**2*u1**(-1)*mg*mt*
     +    sin2t + 4.D+0*t1**2*u1**(-1)*mg2 - 3.D+0*t1**2*u1**(-1)*mst12
     +     - t1**2 - t1**3*u1**(-1) + 8.D+0*u1**(-1)*mg*mt*mg2*mt2*
     +    sin2t + 8.D+0*u1**(-1)*mg*mt*mg2*mst12*sin2t - 4.D+0*u1**(-1)
     +    *mg*mt*mg2**2*sin2t - 8.D+0*u1**(-1)*mg*mt*mt2*mst12*sin2t - 
     +    4.D+0*u1**(-1)*mg*mt*mt2**2*sin2t - 4.D+0*u1**(-1)*mg*mt*
     +    mst12**2*sin2t + 4.D+0*u1**(-1)*mg2*mt2*mst12 - 2.D+0*
     +    u1**(-1)*mg2*mt2**2 + 6.D+0*u1**(-1)*mg2*mst12**2 - 2.D+0*
     +    u1**(-1)*mg2**2*mt2 - 6.D+0*u1**(-1)*mg2**2*mst12 + 2.D+0*
     +    u1**(-1)*mg2**3 - 2.D+0*u1**(-1)*mt2*mst12**2 + 2.D+0*
     +    u1**(-1)*mt2**2*mst12 + 2.D+0*u1**(-1)*mt2**3 - 2.D+0*
     +    u1**(-1)*mst12**3 + u1*mg2 + u1*mt2 + 8.D+0*mg*mt*mg2*sin2t
     +     - 1.2D+1*mg*mt*mst12*sin2t + 1.D+1*mg2*mst12 - 6.D+0*mg2**2
     +     + 6.D+0*mt2*mst12 )
      M2GGSV = M2GGSV + SK3D0(4,1)*CQED * (  - 2.D+0*mt2**2 - 4.D+0*
     +    mst12**2 )
      M2GGSV = M2GGSV + SK3D0(4,2)*N*CK * ( 8.D+0*s**(-1)*t1*u1**(-1)*
     +    mg*mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2*
     +    mst12*sin2t - 4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2**2*sin2t - 
     +    8.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mt2*mst12*sin2t - 4.D+0*
     +    s**(-1)*t1*u1**(-1)*mg*mt*mt2**2*sin2t - 4.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*s**(-1)*t1*u1**(-1)*mg2
     +    *mt2*mst12 - 2.D+0*s**(-1)*t1*u1**(-1)*mg2*mt2**2 + 6.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2*mst12**2 - 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mg2**2*mt2 - 6.D+0*s**(-1)*t1*u1**(-1)*mg2**2*mst12 + 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2**3 - 2.D+0*s**(-1)*t1*u1**(-1)*mt2*
     +    mst12**2 + 2.D+0*s**(-1)*t1*u1**(-1)*mt2**2*mst12 + 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mt2**3 - 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mst12**3 - 4.D+0*s**(-1)*t1*u1*mg*mt*sin2t + 5.D+0*s**(-1)*t1
     +    *u1*mg2 + s**(-1)*t1*u1*mt2 - 3.D+0*s**(-1)*t1*u1*mst12 - 
     +    s**(-1)*t1*u1**2 + 8.D+0*s**(-1)*t1*mg*mt*mg2*sin2t - 1.2D+1*
     +    s**(-1)*t1*mg*mt*mst12*sin2t )
      M2GGSV = M2GGSV + SK3D0(4,2)*N*CK * ( 1.D+1*s**(-1)*t1*mg2*mst12
     +     - 6.D+0*s**(-1)*t1*mg2**2 + 6.D+0*s**(-1)*t1*mt2*mst12 - 
     +    2.D+0*s**(-1)*t1*mt2**2 - 4.D+0*s**(-1)*t1*mst12**2 - 2.D+0*
     +    s**(-1)*t1**2*u1**(-1)*mg*mt*mst12*sin2t + 2.D+0*s**(-1)*
     +    t1**2*u1**(-1)*mg2*mt2 + s**(-1)*t1**2*u1**(-1)*mg2*mst12 - 
     +    s**(-1)*t1**2*u1**(-1)*mg2**2 + s**(-1)*t1**2*u1**(-1)*mt2*
     +    mst12 - s**(-1)*t1**2*u1**(-1)*mt2**2 + s**(-1)*t1**2*mg2 + 
     +    s**(-1)*t1**2*mt2 + 8.D+0*s**(-1)*u1*mg*mt*mg2*sin2t - 8.D+0*
     +    s**(-1)*u1*mg*mt*mt2*sin2t - 1.D+1*s**(-1)*u1*mg*mt*mst12*
     +    sin2t + 2.D+0*s**(-1)*u1*mg2*mt2 + 9.D+0*s**(-1)*u1*mg2*mst12
     +     - 5.D+0*s**(-1)*u1*mg2**2 + s**(-1)*u1*mt2*mst12 + 3.D+0*
     +    s**(-1)*u1*mt2**2 - 4.D+0*s**(-1)*u1*mst12**2 - 4.D+0*s**(-1)
     +    *u1**2*mg*mt*sin2t + 4.D+0*s**(-1)*u1**2*mg2 - 3.D+0*s**(-1)*
     +    u1**2*mst12 - s**(-1)*u1**3 + 8.D+0*s**(-1)*mg*mt*mg2*mt2*
     +    sin2t + 8.D+0*s**(-1)*mg*mt*mg2*mst12*sin2t - 4.D+0*s**(-1)*
     +    mg*mt*mg2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(4,2)*N*CK * (  - 8.D+0*s**(-1)*mg*mt*mt2*
     +    mst12*sin2t - 4.D+0*s**(-1)*mg*mt*mt2**2*sin2t - 4.D+0*
     +    s**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*s**(-1)*mg2*mt2*mst12 - 
     +    2.D+0*s**(-1)*mg2*mt2**2 + 6.D+0*s**(-1)*mg2*mst12**2 - 2.D+0
     +    *s**(-1)*mg2**2*mt2 - 6.D+0*s**(-1)*mg2**2*mst12 + 2.D+0*
     +    s**(-1)*mg2**3 - 2.D+0*s**(-1)*mt2*mst12**2 + 2.D+0*s**(-1)*
     +    mt2**2*mst12 + 2.D+0*s**(-1)*mt2**3 - 2.D+0*s**(-1)*mst12**3
     +     )
      M2GGSV = M2GGSV + SK3D0(4,2)*CQED * ( 8.D+0*t1**(-1)*u1*mg*mt*mg2
     +    *sin2t - 8.D+0*t1**(-1)*u1*mg*mt*mt2*sin2t - 1.D+1*t1**(-1)*
     +    u1*mg*mt*mst12*sin2t + 2.D+0*t1**(-1)*u1*mg2*mt2 + 9.D+0*
     +    t1**(-1)*u1*mg2*mst12 - 5.D+0*t1**(-1)*u1*mg2**2 + t1**(-1)*
     +    u1*mt2*mst12 + 3.D+0*t1**(-1)*u1*mt2**2 - 4.D+0*t1**(-1)*u1*
     +    mst12**2 - 4.D+0*t1**(-1)*u1**2*mg*mt*sin2t + 4.D+0*t1**(-1)*
     +    u1**2*mg2 - 3.D+0*t1**(-1)*u1**2*mst12 - t1**(-1)*u1**3 + 
     +    8.D+0*t1**(-1)*mg*mt*mg2*mt2*sin2t + 8.D+0*t1**(-1)*mg*mt*mg2
     +    *mst12*sin2t - 4.D+0*t1**(-1)*mg*mt*mg2**2*sin2t - 8.D+0*
     +    t1**(-1)*mg*mt*mt2*mst12*sin2t - 4.D+0*t1**(-1)*mg*mt*mt2**2*
     +    sin2t - 4.D+0*t1**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*t1**(-1)*
     +    mg2*mt2*mst12 - 2.D+0*t1**(-1)*mg2*mt2**2 + 6.D+0*t1**(-1)*
     +    mg2*mst12**2 - 2.D+0*t1**(-1)*mg2**2*mt2 - 6.D+0*t1**(-1)*
     +    mg2**2*mst12 + 2.D+0*t1**(-1)*mg2**3 - 2.D+0*t1**(-1)*mt2*
     +    mst12**2 + 2.D+0*t1**(-1)*mt2**2*mst12 + 2.D+0*t1**(-1)*
     +    mt2**3 )
      M2GGSV = M2GGSV + SK3D0(4,2)*CQED * (  - 2.D+0*t1**(-1)*mst12**3
     +     - 2.D+0*t1*u1**(-1)*mg*mt*mst12*sin2t + 2.D+0*t1*u1**(-1)*
     +    mg2*mt2 + t1*u1**(-1)*mg2*mst12 - t1*u1**(-1)*mg2**2 + t1*
     +    u1**(-1)*mt2*mst12 - t1*u1**(-1)*mt2**2 + t1*mg2 + t1*mt2 + 
     +    8.D+0*u1**(-1)*mg*mt*mg2*mt2*sin2t + 8.D+0*u1**(-1)*mg*mt*mg2
     +    *mst12*sin2t - 4.D+0*u1**(-1)*mg*mt*mg2**2*sin2t - 8.D+0*
     +    u1**(-1)*mg*mt*mt2*mst12*sin2t - 4.D+0*u1**(-1)*mg*mt*mt2**2*
     +    sin2t - 4.D+0*u1**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*u1**(-1)*
     +    mg2*mt2*mst12 - 2.D+0*u1**(-1)*mg2*mt2**2 + 6.D+0*u1**(-1)*
     +    mg2*mst12**2 - 2.D+0*u1**(-1)*mg2**2*mt2 - 6.D+0*u1**(-1)*
     +    mg2**2*mst12 + 2.D+0*u1**(-1)*mg2**3 - 2.D+0*u1**(-1)*mt2*
     +    mst12**2 + 2.D+0*u1**(-1)*mt2**2*mst12 + 2.D+0*u1**(-1)*
     +    mt2**3 - 2.D+0*u1**(-1)*mst12**3 - 4.D+0*u1*mg*mt*sin2t + 
     +    5.D+0*u1*mg2 + u1*mt2 - 3.D+0*u1*mst12 - u1**2 + 8.D+0*mg*mt*
     +    mg2*sin2t - 1.2D+1*mg*mt*mst12*sin2t + 1.D+1*mg2*mst12 - 
     +    6.D+0*mg2**2 )
      M2GGSV = M2GGSV + SK3D0(4,2)*CQED * ( 6.D+0*mt2*mst12 - 2.D+0*
     +    mt2**2 - 4.D+0*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(5,1)*N*CO * (  - 8.D+0*s**(-1)*t1**(-1)*
     +    u1*mg*mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2*
     +    mst12*sin2t + 4.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mg2**2*sin2t - 
     +    8.D+0*s**(-1)*t1**(-1)*u1*mg*mt*mt2*mst12*sin2t + 4.D+0*
     +    s**(-1)*t1**(-1)*u1*mg*mt*mt2**2*sin2t + 4.D+0*s**(-1)*
     +    t1**(-1)*u1*mg*mt*mst12**2*sin2t - 4.D+0*s**(-1)*t1**(-1)*u1*
     +    mg2*mt2*mst12 + 2.D+0*s**(-1)*t1**(-1)*u1*mg2*mt2**2 + 2.D+0*
     +    s**(-1)*t1**(-1)*u1*mg2*mst12**2 + 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mg2**2*mt2 - 2.D+0*s**(-1)*t1**(-1)*u1*mg2**2*mst12 - 2.D+0*
     +    s**(-1)*t1**(-1)*u1*mg2**3 - 6.D+0*s**(-1)*t1**(-1)*u1*mt2*
     +    mst12**2 + 6.D+0*s**(-1)*t1**(-1)*u1*mt2**2*mst12 - 2.D+0*
     +    s**(-1)*t1**(-1)*u1*mt2**3 + 2.D+0*s**(-1)*t1**(-1)*u1*
     +    mst12**3 + 2.D+0*s**(-1)*t1**(-1)*u1**2*mg*mt*mst12*sin2t - 
     +    2.D+0*s**(-1)*t1**(-1)*u1**2*mg2*mt2 - s**(-1)*t1**(-1)*u1**2
     +    *mg2*mst12 + s**(-1)*t1**(-1)*u1**2*mg2**2 - s**(-1)*t1**(-1)
     +    *u1**2*mt2*mst12 )
      M2GGSV = M2GGSV + SK3D0(5,1)*N*CO * ( s**(-1)*t1**(-1)*u1**2*
     +    mt2**2 + 4.D+0*s**(-1)*t1*u1*mg*mt*sin2t - s**(-1)*t1*u1*mg2
     +     - 5.D+0*s**(-1)*t1*u1*mt2 + 3.D+0*s**(-1)*t1*u1*mst12 + 
     +    8.D+0*s**(-1)*t1*mg*mt*mg2*sin2t - 8.D+0*s**(-1)*t1*mg*mt*mt2
     +    *sin2t + 1.D+1*s**(-1)*t1*mg*mt*mst12*sin2t - 2.D+0*s**(-1)*
     +    t1*mg2*mt2 - s**(-1)*t1*mg2*mst12 - 3.D+0*s**(-1)*t1*mg2**2
     +     - 9.D+0*s**(-1)*t1*mt2*mst12 + 5.D+0*s**(-1)*t1*mt2**2 + 
     +    4.D+0*s**(-1)*t1*mst12**2 + s**(-1)*t1**2*u1 + 4.D+0*s**(-1)*
     +    t1**2*mg*mt*sin2t - 4.D+0*s**(-1)*t1**2*mt2 + 3.D+0*s**(-1)*
     +    t1**2*mst12 + s**(-1)*t1**3 - 8.D+0*s**(-1)*u1*mg*mt*mt2*
     +    sin2t + 1.2D+1*s**(-1)*u1*mg*mt*mst12*sin2t - 6.D+0*s**(-1)*
     +    u1*mg2*mst12 + 2.D+0*s**(-1)*u1*mg2**2 - 1.D+1*s**(-1)*u1*mt2
     +    *mst12 + 6.D+0*s**(-1)*u1*mt2**2 + 4.D+0*s**(-1)*u1*mst12**2
     +     - s**(-1)*u1**2*mg2 - s**(-1)*u1**2*mt2 - 8.D+0*s**(-1)*mg*
     +    mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mg2*mst12*sin2t + 
     +    4.D+0*s**(-1)*mg*mt*mg2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(5,1)*N*CO * (  - 8.D+0*s**(-1)*mg*mt*mt2*
     +    mst12*sin2t + 4.D+0*s**(-1)*mg*mt*mt2**2*sin2t + 4.D+0*
     +    s**(-1)*mg*mt*mst12**2*sin2t - 4.D+0*s**(-1)*mg2*mt2*mst12 + 
     +    2.D+0*s**(-1)*mg2*mt2**2 + 2.D+0*s**(-1)*mg2*mst12**2 + 2.D+0
     +    *s**(-1)*mg2**2*mt2 - 2.D+0*s**(-1)*mg2**2*mst12 - 2.D+0*
     +    s**(-1)*mg2**3 - 6.D+0*s**(-1)*mt2*mst12**2 + 6.D+0*s**(-1)*
     +    mt2**2*mst12 - 2.D+0*s**(-1)*mt2**3 + 2.D+0*s**(-1)*mst12**3
     +     )
      M2GGSV = M2GGSV + SK3D0(5,2)*N*CO * (  - 8.D+0*s**(-1)*t1*
     +    u1**(-1)*mg*mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*t1*u1**(-1)*mg*
     +    mt*mg2*mst12*sin2t + 4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mg2**2*
     +    sin2t - 8.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mt2*mst12*sin2t + 
     +    4.D+0*s**(-1)*t1*u1**(-1)*mg*mt*mt2**2*sin2t + 4.D+0*s**(-1)*
     +    t1*u1**(-1)*mg*mt*mst12**2*sin2t - 4.D+0*s**(-1)*t1*u1**(-1)*
     +    mg2*mt2*mst12 + 2.D+0*s**(-1)*t1*u1**(-1)*mg2*mt2**2 + 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2*mst12**2 + 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mg2**2*mt2 - 2.D+0*s**(-1)*t1*u1**(-1)*mg2**2*mst12 - 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mg2**3 - 6.D+0*s**(-1)*t1*u1**(-1)*mt2*
     +    mst12**2 + 6.D+0*s**(-1)*t1*u1**(-1)*mt2**2*mst12 - 2.D+0*
     +    s**(-1)*t1*u1**(-1)*mt2**3 + 2.D+0*s**(-1)*t1*u1**(-1)*
     +    mst12**3 + 4.D+0*s**(-1)*t1*u1*mg*mt*sin2t - s**(-1)*t1*u1*
     +    mg2 - 5.D+0*s**(-1)*t1*u1*mt2 + 3.D+0*s**(-1)*t1*u1*mst12 + 
     +    s**(-1)*t1*u1**2 - 8.D+0*s**(-1)*t1*mg*mt*mt2*sin2t + 1.2D+1*
     +    s**(-1)*t1*mg*mt*mst12*sin2t )
      M2GGSV = M2GGSV + SK3D0(5,2)*N*CO * (  - 6.D+0*s**(-1)*t1*mg2*
     +    mst12 + 2.D+0*s**(-1)*t1*mg2**2 - 1.D+1*s**(-1)*t1*mt2*mst12
     +     + 6.D+0*s**(-1)*t1*mt2**2 + 4.D+0*s**(-1)*t1*mst12**2 + 
     +    2.D+0*s**(-1)*t1**2*u1**(-1)*mg*mt*mst12*sin2t - 2.D+0*
     +    s**(-1)*t1**2*u1**(-1)*mg2*mt2 - s**(-1)*t1**2*u1**(-1)*mg2*
     +    mst12 + s**(-1)*t1**2*u1**(-1)*mg2**2 - s**(-1)*t1**2*
     +    u1**(-1)*mt2*mst12 + s**(-1)*t1**2*u1**(-1)*mt2**2 - s**(-1)*
     +    t1**2*mg2 - s**(-1)*t1**2*mt2 + 8.D+0*s**(-1)*u1*mg*mt*mg2*
     +    sin2t - 8.D+0*s**(-1)*u1*mg*mt*mt2*sin2t + 1.D+1*s**(-1)*u1*
     +    mg*mt*mst12*sin2t - 2.D+0*s**(-1)*u1*mg2*mt2 - s**(-1)*u1*mg2
     +    *mst12 - 3.D+0*s**(-1)*u1*mg2**2 - 9.D+0*s**(-1)*u1*mt2*mst12
     +     + 5.D+0*s**(-1)*u1*mt2**2 + 4.D+0*s**(-1)*u1*mst12**2 + 
     +    4.D+0*s**(-1)*u1**2*mg*mt*sin2t - 4.D+0*s**(-1)*u1**2*mt2 + 
     +    3.D+0*s**(-1)*u1**2*mst12 + s**(-1)*u1**3 - 8.D+0*s**(-1)*mg*
     +    mt*mg2*mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mg2*mst12*sin2t + 
     +    4.D+0*s**(-1)*mg*mt*mg2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(5,2)*N*CO * (  - 8.D+0*s**(-1)*mg*mt*mt2*
     +    mst12*sin2t + 4.D+0*s**(-1)*mg*mt*mt2**2*sin2t + 4.D+0*
     +    s**(-1)*mg*mt*mst12**2*sin2t - 4.D+0*s**(-1)*mg2*mt2*mst12 + 
     +    2.D+0*s**(-1)*mg2*mt2**2 + 2.D+0*s**(-1)*mg2*mst12**2 + 2.D+0
     +    *s**(-1)*mg2**2*mt2 - 2.D+0*s**(-1)*mg2**2*mst12 - 2.D+0*
     +    s**(-1)*mg2**3 - 6.D+0*s**(-1)*mt2*mst12**2 + 6.D+0*s**(-1)*
     +    mt2**2*mst12 - 2.D+0*s**(-1)*mt2**3 + 2.D+0*s**(-1)*mst12**3
     +     )
      M2GGSV = M2GGSV + SK3D0(6,1)*N*CK * (  - 2.D+0*t1**(-1)*u1*mg*mt*
     +    mst12*sin2t + 2.D+0*t1**(-1)*u1*mg2*mt2 + t1**(-1)*u1*mg2*
     +    mst12 - t1**(-1)*u1*mg2**2 + t1**(-1)*u1*mt2*mst12 - t1**(-1)
     +    *u1*mt2**2 + 8.D+0*t1**(-1)*mg*mt*mg2*mt2*sin2t - 4.D+0*
     +    t1**(-1)*mg*mt*mg2**2*sin2t - 4.D+0*t1**(-1)*mg*mt*mt2**2*
     +    sin2t + 4.D+0*t1**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*t1**(-1)*
     +    mg2*mt2*mst12 - 2.D+0*t1**(-1)*mg2*mt2**2 - 2.D+0*t1**(-1)*
     +    mg2*mst12**2 - 2.D+0*t1**(-1)*mg2**2*mt2 - 2.D+0*t1**(-1)*
     +    mg2**2*mst12 + 2.D+0*t1**(-1)*mg2**3 - 2.D+0*t1**(-1)*mt2*
     +    mst12**2 - 2.D+0*t1**(-1)*mt2**2*mst12 + 2.D+0*t1**(-1)*
     +    mt2**3 + 2.D+0*t1**(-1)*mst12**3 - 2.D+0*t1*u1**(-1)*mg*mt*
     +    mst12*sin2t + 2.D+0*t1*u1**(-1)*mg2*mt2 + t1*u1**(-1)*mg2*
     +    mst12 - t1*u1**(-1)*mg2**2 + t1*u1**(-1)*mt2*mst12 - t1*
     +    u1**(-1)*mt2**2 + t1*mg2 + t1*mt2 + 8.D+0*u1**(-1)*mg*mt*mg2*
     +    mt2*sin2t - 4.D+0*u1**(-1)*mg*mt*mg2**2*sin2t - 4.D+0*
     +    u1**(-1)*mg*mt*mt2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(6,1)*N*CK * ( 4.D+0*u1**(-1)*mg*mt*
     +    mst12**2*sin2t + 4.D+0*u1**(-1)*mg2*mt2*mst12 - 2.D+0*
     +    u1**(-1)*mg2*mt2**2 - 2.D+0*u1**(-1)*mg2*mst12**2 - 2.D+0*
     +    u1**(-1)*mg2**2*mt2 - 2.D+0*u1**(-1)*mg2**2*mst12 + 2.D+0*
     +    u1**(-1)*mg2**3 - 2.D+0*u1**(-1)*mt2*mst12**2 - 2.D+0*
     +    u1**(-1)*mt2**2*mst12 + 2.D+0*u1**(-1)*mt2**3 + 2.D+0*
     +    u1**(-1)*mst12**3 + u1*mg2 + u1*mt2 + 4.D+0*mg*mt*mg2*sin2t
     +     + 4.D+0*mg*mt*mt2*sin2t + 2.D+0*mg2*mst12 - 4.D+0*mg2**2 + 
     +    2.D+0*mt2*mst12 - 4.D+0*mt2**2 + 2.D+0*mst12**2 )
      M2GGSV = M2GGSV + SK3D0(6,2)*N*CK * (  - 2.D+0*t1**(-1)*u1*mg*mt*
     +    mst12*sin2t + 2.D+0*t1**(-1)*u1*mg2*mt2 + t1**(-1)*u1*mg2*
     +    mst12 - t1**(-1)*u1*mg2**2 + t1**(-1)*u1*mt2*mst12 - t1**(-1)
     +    *u1*mt2**2 + 8.D+0*t1**(-1)*mg*mt*mg2*mt2*sin2t - 4.D+0*
     +    t1**(-1)*mg*mt*mg2**2*sin2t - 4.D+0*t1**(-1)*mg*mt*mt2**2*
     +    sin2t + 4.D+0*t1**(-1)*mg*mt*mst12**2*sin2t + 4.D+0*t1**(-1)*
     +    mg2*mt2*mst12 - 2.D+0*t1**(-1)*mg2*mt2**2 - 2.D+0*t1**(-1)*
     +    mg2*mst12**2 - 2.D+0*t1**(-1)*mg2**2*mt2 - 2.D+0*t1**(-1)*
     +    mg2**2*mst12 + 2.D+0*t1**(-1)*mg2**3 - 2.D+0*t1**(-1)*mt2*
     +    mst12**2 - 2.D+0*t1**(-1)*mt2**2*mst12 + 2.D+0*t1**(-1)*
     +    mt2**3 + 2.D+0*t1**(-1)*mst12**3 - 2.D+0*t1*u1**(-1)*mg*mt*
     +    mst12*sin2t + 2.D+0*t1*u1**(-1)*mg2*mt2 + t1*u1**(-1)*mg2*
     +    mst12 - t1*u1**(-1)*mg2**2 + t1*u1**(-1)*mt2*mst12 - t1*
     +    u1**(-1)*mt2**2 + t1*mg2 + t1*mt2 + 8.D+0*u1**(-1)*mg*mt*mg2*
     +    mt2*sin2t - 4.D+0*u1**(-1)*mg*mt*mg2**2*sin2t - 4.D+0*
     +    u1**(-1)*mg*mt*mt2**2*sin2t )
      M2GGSV = M2GGSV + SK3D0(6,2)*N*CK * ( 4.D+0*u1**(-1)*mg*mt*
     +    mst12**2*sin2t + 4.D+0*u1**(-1)*mg2*mt2*mst12 - 2.D+0*
     +    u1**(-1)*mg2*mt2**2 - 2.D+0*u1**(-1)*mg2*mst12**2 - 2.D+0*
     +    u1**(-1)*mg2**2*mt2 - 2.D+0*u1**(-1)*mg2**2*mst12 + 2.D+0*
     +    u1**(-1)*mg2**3 - 2.D+0*u1**(-1)*mt2*mst12**2 - 2.D+0*
     +    u1**(-1)*mt2**2*mst12 + 2.D+0*u1**(-1)*mt2**3 + 2.D+0*
     +    u1**(-1)*mst12**3 + u1*mg2 + u1*mt2 + 4.D+0*mg*mt*mg2*sin2t
     +     + 4.D+0*mg*mt*mt2*sin2t + 2.D+0*mg2*mst12 - 4.D+0*mg2**2 + 
     +    2.D+0*mt2*mst12 - 4.D+0*mt2**2 + 2.D+0*mst12**2 )
      M2GGSV = M2GGSV + SOF1(1)*N*CK * (  - 6.4D+1*s**(-2)*t1*u1*mst12
     +     + 3.2D+1*s**(-1)*t1*u1 + 1.28D+2*s**(-1)*mst12**2 - 1.6D+1*s
     +     + 6.4D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 + 3.2D+1*s**2*
     +    t1**(-1)*u1**(-1)*mst12 - 3.2D+1*s**3*t1**(-2)*u1**(-2)*
     +    mst12**2 - 1.28D+2*t1**(-1)*u1**(-1)*mst12**3 - 3.2D+1*mst12
     +     )
      M2GGSV = M2GGSV + SOF1(1)*CQED * ( 6.4D+1*s*t1**(-1)*u1**(-1)*
     +    mst12**2 + 1.6D+1*s - 6.4D+1*s**2*t1**(-2)*u1**(-2)*mst12**3
     +     - 3.2D+1*s**2*t1**(-1)*u1**(-1)*mst12 + 3.2D+1*s**3*t1**(-2)
     +    *u1**(-2)*mst12**2 - 3.2D+1*mst12 )
      M2GGSV = M2GGSV + SOF1(2)*N*CO * ( 3.2D+1*s**(-2)*t1*u1*mst12 - 
     +    6.4D+1*s**(-1)*mst12**2 + 3.2D+1*s*t1**(-1)*u1**(-1)*mst12**2
     +     - 3.2D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 + 6.4D+1*t1**(-1)*
     +    u1**(-1)*mst12**3 - 1.6D+1*mst12 )
      M2GGSV = M2GGSV + SOF1(2)*N*CK * (  - 3.2D+1*s**(-2)*t1*u1*mst12
     +     + 6.4D+1*s**(-1)*mst12**2 - 9.6D+1*s*t1**(-1)*u1**(-1)*
     +    mst12**2 + 9.6D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 - 6.4D+1*
     +    t1**(-1)*u1**(-1)*mst12**3 + 4.8D+1*mst12 )
      M2GGSV = M2GGSV + SOF1(2)*CQED * ( 3.2D+1*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 3.2D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 - 1.6D+1*
     +    mst12 )
      M2GGSV = M2GGSV + SOF1(3)*N*CO * ( 3.2D+1*s**(-2)*t1*u1*mst12 - 
     +    6.4D+1*s**(-1)*mst12**2 + 3.2D+1*s*t1**(-1)*u1**(-1)*mst12**2
     +     - 3.2D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 + 6.4D+1*t1**(-1)*
     +    u1**(-1)*mst12**3 - 1.6D+1*mst12 )
      M2GGSV = M2GGSV + SOF1(3)*N*CK * (  - 3.2D+1*s**(-2)*t1*u1*mst12
     +     + 6.4D+1*s**(-1)*mst12**2 - 9.6D+1*s*t1**(-1)*u1**(-1)*
     +    mst12**2 + 9.6D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 - 6.4D+1*
     +    t1**(-1)*u1**(-1)*mst12**3 + 4.8D+1*mst12 )
      M2GGSV = M2GGSV + SOF1(3)*CQED * ( 3.2D+1*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 3.2D+1*s**2*t1**(-2)*u1**(-2)*mst12**3 - 1.6D+1*
     +    mst12 )
      M2GGSV = M2GGSV + SOF1(4)*N*CO * ( 1.6D+1*s**(-2)*t1**2*u1 - 
     +    3.2D+1*s**(-1)*t1*mst12 + 3.2D+1*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SOF1(4)*N*CK * ( 3.2D+1*s*t1**(-1)*mst12 - 
     +    3.2D+1*s**2*t1**(-2)*u1**(-1)*mst12**2 - 1.6D+1*u1 )
      M2GGSV = M2GGSV + SOF1(5)*N*CO * ( 1.6D+1*s**(-2)*t1*u1**2 - 
     +    3.2D+1*s**(-1)*u1*mst12 + 3.2D+1*t1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SOF1(5)*N*CK * ( 3.2D+1*s*u1**(-1)*mst12 - 
     +    3.2D+1*s**2*t1**(-1)*u1**(-2)*mst12**2 - 1.6D+1*t1 )
      M2GGSV = M2GGSV + SOF1(6)*N*CO * ( 1.6D+1*s**(-2)*t1*u1**2 - 
     +    3.2D+1*s**(-1)*u1*mst12 + 3.2D+1*t1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SOF1(6)*N*CK * ( 3.2D+1*s*u1**(-1)*mst12 - 
     +    3.2D+1*s**2*t1**(-1)*u1**(-2)*mst12**2 - 1.6D+1*t1 )
      M2GGSV = M2GGSV + SOF1(7)*N*CO * ( 1.6D+1*s**(-2)*t1**2*u1 - 
     +    3.2D+1*s**(-1)*t1*mst12 + 3.2D+1*u1**(-1)*mst12**2 )
      M2GGSV = M2GGSV + SOF1(7)*N*CK * ( 3.2D+1*s*t1**(-1)*mst12 - 
     +    3.2D+1*s**2*t1**(-2)*u1**(-1)*mst12**2 - 1.6D+1*u1 )
      M2GGSV = M2GGSV + SOF1(8)*N*CO * (  - 3.2D+1*s**(-1)*t1*u1 - 
     +    6.4D+1*s*t1**(-1)*u1**(-1)*mst12**2 + 1.6D+1*s - 3.2D+1*s**2*
     +    t1**(-1)*u1**(-1)*mst12 + 3.2D+1*s**3*t1**(-2)*u1**(-2)*
     +    mst12**2 + 6.4D+1*mst12 )


      DSTGGV = 
     +     ALPHAS**3 * AVG * M2GGSV /4.D0 /S**2 *CONV
     +     + ALPHAS/PI*DSTGGB(ALPHAS,S,T1,MST1,MG) * (
     +        + LOG(MG2/MST12)*(-1.D0) 
     +        + LOG(MT2/MST12)*(-1.D0/3.D0)
     +        + LOG(MST22/MST12)*(-1.D0/12.D0)
     +        + LOG(MS2/MST12)*(-2*nf/12.D0) )

C***  CHANGES TO SUBTRACTED MSBAR 
      RETURN
      END



      REAL*8 FUNCTION DSTGGH(ALPHAS,S,T1,S4,MST1,MG)
C***  CROSS SECTIONS FOR G + G -> ST + STB + G
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,U1,MST1,MG,MST12,MG2
      REAL*8 M2GGH
      REAL*8 NS,CONV,N,CO,CK,CQED,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1M1, ABP1P2, A4P2P2, A4P1P2, A4P1P1
      REAL*8 A4M1P2, A4M1P1, A4P0P2, A4P1P0,A4P2M2, A4M2P1,ABP2P2
      REAL*8 ABP2P1, ABP2P0
      REAL*8 ANG4(1:71), COLO1(1:9)
      
      CONV = 389379660.D0
      NS = 6.D0

      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2

      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2

      MST12 = MST1**2
      MG2 = MG**2
      U1 = S4 -S -T1


      ANGDEF(1) = 2.D0*SQRT(S4 +MST12)
      ANGDEF(2) = (S +U1)/ANGDEF(1)
      ANGDEF(3) = (S +T1)/ANGDEF(1)
      ANGDEF(4) = S4/ANGDEF(1)
      ANGDEF(5) = (S4 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(6) = -(T1 +U1 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(7) = SQRT((T1 +U1)**2 -4.D0*MST12*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (T1*S4 -S*(U1+2.D0*MST12))/(S+T1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (U1*S4 -S*(T1+2.D0*MST12))/(S+U1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)

      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)

      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)


      ANG4(1) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(2) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(3) =A4P1P2(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(4) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(5) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(6) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(7) =A4P1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(8) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(9) =A4P2M2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(10) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(11) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(12) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(13) =A4P2M2(ANA(2,2),ANB(2,2),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(15) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(16) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(17) =A4P1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(18) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(19) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(20) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(21) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))

      ANG4(36) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(37) =A4P1P0(ANA(2,1),ANB(2,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(40) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(41) =A4P1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(43) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(44) =A4P1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
      ANG4(49) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(50) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(51) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(53) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))

      ANG4(55) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(57) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))


      ANG4(59) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(60) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(61) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(62) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(63) =ABP1M1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 

      ANG4(64) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5)) 
      ANG4(65) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5)) 
      ANG4(66) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5)) 
      ANG4(67) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5)) 
      ANG4(68) =ABP1M1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5)) 

      ANG4(70) =ABP2P0(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(71) =ABP2P0(ANA(3,4),ANB(3,4),ANA(1,1),ANB(1,1),ANC(1,1))

      COLO1(9) = LOG(S4**2/MST12/(S4+MST12))


      M2GGH = 0D0 

      M2ggh = M2ggh + N*CO*(s4+mst12) * ( 32*s**(-2)*t1**(-2)*u1**3*
     +    s4**(-1) + 80*s**(-2)*t1**(-1)*u1**2*s4**(-1) - 40*s**(-2)*
     +    t1**(-1)*u1**3*s4**(-2) - 8*s**(-2)*t1**(-1)*u1**3*s4**(-1)*
     +    (t1+u1)**(-1) - 96*s**(-2)*t1*u1*s4**(-2) + 128*s**(-2)*t1*
     +    s4**(-1) + 64*s**(-2)*t1**2*u1**(-1)*s4**(-1) - 64*s**(-2)*
     +    t1**2*s4**(-2) + 32*s**(-2)*t1**3*u1**(-2)*s4**(-1) - 32*
     +    s**(-2)*t1**3*u1**(-1)*s4**(-2) + 96*s**(-2)*u1*s4**(-1) - 56
     +    *s**(-2)*u1**2*s4**(-2) + 8*s**(-2)*u1**2*s4**(-1)*
     +    (t1+u1)**(-1) - 128*s**(-1)*t1**(-3)*u1*mst12 + 64*s**(-1)*
     +    t1**(-3)*u1**2*s4**(-1)*mst12 + 64*s**(-1)*t1**(-2)*u1*
     +    s4**(-1)*mst12 + 56*s**(-1)*t1**(-2)*u1**2*s4**(-1) + 72*
     +    s**(-1)*t1**(-1)*u1*s4**(-1) - 48*s**(-1)*t1**(-1)*u1**2*
     +    s4**(-2) - 8*s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+t1)**(-1) - 8
     +    *s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+u1)**(-1) - 8*s**(-1)*
     +    t1**(-1)*u1**2*s4**(-1)*(t1+u1)**(-1) + 16*s**(-1)*t1**(-1)*
     +    u1**3*s4**(-2)*(s+t1)**(-1) )
     +
      M2ggh = M2ggh + N*CO*(s4+mst12) * ( 8*s**(-1)*t1**(-1)*u1**3*
     +    s4**(-2)*(t1+u1)**(-1) - 128*s**(-1)*t1*u1**(-3)*mst12 + 64*
     +    s**(-1)*t1*u1**(-2)*s4**(-1)*mst12 + 64*s**(-1)*t1*u1**(-1)*
     +    s4**(-1) - 8*s**(-1)*t1*u1*s4**(-1)*(s+t1)**(-2) - 8*s**(-1)*
     +    t1*u1*s4**(-1)*(s+u1)**(-2) - 112*s**(-1)*t1*s4**(-2) - 16*
     +    s**(-1)*t1*s4**(-1)*(s+t1)**(-1) - 16*s**(-1)*t1*s4**(-1)*
     +    (s+u1)**(-1) + 64*s**(-1)*t1**2*u1**(-3)*s4**(-1)*mst12 + 56*
     +    s**(-1)*t1**2*u1**(-2)*s4**(-1) - 32*s**(-1)*t1**2*u1**(-1)*
     +    s4**(-2) - 8*s**(-1)*t1**2*u1**(-1)*s4**(-1)*(s+t1)**(-1) - 8
     +    *s**(-1)*t1**2*u1**(-1)*s4**(-1)*(s+u1)**(-1) - 16*s**(-1)*
     +    t1**2*s4**(-2)*(s+u1)**(-1) + 16*s**(-1)*t1**3*u1**(-1)*
     +    s4**(-2)*(s+u1)**(-1) - 80*s**(-1)*u1*s4**(-2) - 8*s**(-1)*u1
     +    *s4**(-1)*(s+t1)**(-1) - 8*s**(-1)*u1*s4**(-1)*(s+u1)**(-1)
     +     - 8*s**(-1)*u1*s4**(-1)*(t1+u1)**(-1) - 24*s**(-1)*u1**2*
     +    s4**(-2)*(s+t1)**(-1) - 8*s**(-1)*u1**2*s4**(-2)*(s+u1)**(-1)
     +     - 8*s**(-1)*u1**2*s4**(-2)*(t1+u1)**(-1) )
     +
      M2ggh = M2ggh + N*CO*(s4+mst12) * ( 72*s**(-1)*s4**(-1) + 64*s*
     +    t1**(-4)*s4**(-1)*mst12**2 + 64*s*t1**(-3)*u1**(-1)*s4**(-1)*
     +    mst12**2 - 64*s*t1**(-3)*u1**(-1)*mst12 - 32*s*t1**(-3)*
     +    s4**(-1)*mst12 + 32*s*t1**(-2)*u1**(-1)*s4**(-1)*mst12 + 16*s
     +    *t1**(-2)*s4**(-1)*(s+u1)**(-1)*mst12 + 16*s*t1**(-2)*
     +    s4**(-1) + 64*s*t1**(-1)*u1**(-3)*s4**(-1)*mst12**2 - 64*s*
     +    t1**(-1)*u1**(-3)*mst12 + 32*s*t1**(-1)*u1**(-2)*s4**(-1)*
     +    mst12 + 64*s*u1**(-4)*s4**(-1)*mst12**2 - 32*s*u1**(-3)*
     +    s4**(-1)*mst12 + 16*s*u1**(-2)*s4**(-1)*(s+t1)**(-1)*mst12 + 
     +    16*s*u1**(-2)*s4**(-1) + 96*s**2*t1**(-4)*u1**(-2)*mst12**2
     +     - 64*s**2*t1**(-3)*u1**(-2)*s4**(-1)*mst12**2 + 32*s**2*
     +    t1**(-3)*u1**(-1)*s4**(-1)*mst12 + 96*s**2*t1**(-2)*u1**(-4)*
     +    mst12**2 - 64*s**2*t1**(-2)*u1**(-3)*s4**(-1)*mst12**2 + 32*
     +    s**2*t1**(-1)*u1**(-3)*s4**(-1)*mst12 - 64*s**3*t1**(-4)*
     +    u1**(-2)*s4**(-1)*mst12**2 - 64*s**3*t1**(-2)*u1**(-4)*
     +    s4**(-1)*mst12**2 )
     +
      M2ggh = M2ggh + N*CO*(s4+mst12) * ( 64*t1**(-4)*mst12**2 + 16*
     +    t1**(-2)*u1*s4**(-1)*(s+u1)**(-1)*mst12 + 48*t1**(-2)*u1*
     +    s4**(-1) + 8*t1**(-2)*u1**2*s4**(-1)*(s+t1)**(-1) - 80*
     +    t1**(-2)*s4**(-1)*mst12 - 8*t1**(-1)*u1*s4**(-2) - 8*t1**(-1)
     +    *u1*s4**(-1)*(s+t1)**(-1) - 8*t1**(-1)*u1*s4**(-1)*
     +    (s+u1)**(-1) - 8*t1**(-1)*u1**2*s4**(-2)*(t1+u1)**(-1) + 16*
     +    t1**(-1)*s4**(-1) + 16*t1*u1**(-2)*s4**(-1)*(s+t1)**(-1)*
     +    mst12 + 48*t1*u1**(-2)*s4**(-1) - 16*t1*u1**(-1)*s4**(-2) - 8
     +    *t1*u1**(-1)*s4**(-1)*(s+t1)**(-1) - 8*t1*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1) + 8*t1*s4**(-1)*(s+u1)**(-2) + 8*t1**2*u1**(-2)*
     +    s4**(-1)*(s+u1)**(-1) + 64*u1**(-4)*mst12**2 - 80*u1**(-2)*
     +    s4**(-1)*mst12 + 16*u1**(-1)*s4**(-1) - 8*u1*s4**(-2)*
     +    (s+t1)**(-1) - 8*u1*s4**(-2)*(s+u1)**(-1) - 8*u1*s4**(-2)*
     +    (t1+u1)**(-1) + 8*u1*s4**(-1)*(s+t1)**(-2) - 24*s4**(-2) + 8*
     +    s4**(-1)*(s+t1)**(-1) + 8*s4**(-1)*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + N*CO * (  - 32*s**(-2)*t1**(-2)*u1**3*s4**(-1)*
     +    mst12 - 32*s**(-2)*t1**(-2)*u1**3 - 64*s**(-2)*t1**(-1)*u1**2
     +    *s4**(-1)*mst12 - 64*s**(-2)*t1**(-1)*u1**2 + 32*s**(-2)*
     +    t1**(-1)*u1**3*s4**(-2)*mst12 + 32*s**(-2)*t1**(-1)*u1**3*
     +    s4**(-1) - 32*s**(-2)*t1*u1**2*s4**(-1)*(s+u1)**(-2)*mst12 - 
     +    32*s**(-2)*t1*u1**2*(s+u1)**(-2) - 64*s**(-2)*t1**2*u1**(-1)*
     +    s4**(-1)*mst12 - 64*s**(-2)*t1**2*u1**(-1) - 32*s**(-2)*t1**2
     +    *u1*s4**(-1)*(s+t1)**(-2)*mst12 - 32*s**(-2)*t1**2*u1*
     +    (s+t1)**(-2) - 32*s**(-2)*t1**2*s4**(-1)*(s+t1)**(-1)*mst12
     +     - 32*s**(-2)*t1**2*(s+t1)**(-1) - 32*s**(-2)*t1**3*u1**(-2)*
     +    s4**(-1)*mst12 - 32*s**(-2)*t1**3*u1**(-2) + 32*s**(-2)*t1**3
     +    *u1**(-1)*s4**(-2)*mst12 + 32*s**(-2)*t1**3*u1**(-1)*s4**(-1)
     +     - 16*s**(-2)*u1**2*s4**(-2)*mst12 - 32*s**(-2)*u1**2*
     +    s4**(-1)*(s+u1)**(-1)*mst12 - 32*s**(-2)*u1**2*(s+u1)**(-1)
     +     - 64*s**(-1)*t1**(-2)*u1**2*s4**(-1)*mst12 - 64*s**(-1)*
     +    t1**(-2)*u1**2 )
     +
      M2ggh = M2ggh + N*CO * (  - 64*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12
     +     - 56*s**(-1)*t1**(-1)*u1 + 64*s**(-1)*t1**(-1)*u1**2*
     +    s4**(-2)*mst12 + 60*s**(-1)*t1**(-1)*u1**2*s4**(-1) + 8*
     +    s**(-1)*t1**(-1)*mst12 - 64*s**(-1)*t1*u1**(-1)*s4**(-1)*
     +    mst12 - 56*s**(-1)*t1*u1**(-1) - 32*s**(-1)*t1*u1*s4**(-1)*
     +    (s+t1)**(-2)*mst12 - 32*s**(-1)*t1*u1*s4**(-1)*(s+u1)**(-2)*
     +    mst12 - 32*s**(-1)*t1*u1*(s+t1)**(-2) - 32*s**(-1)*t1*u1*
     +    (s+u1)**(-2) - 32*s**(-1)*t1*s4**(-1)*(s+t1)**(-1)*mst12 - 32
     +    *s**(-1)*t1*(s+t1)**(-1) - 64*s**(-1)*t1**2*u1**(-2)*s4**(-1)
     +    *mst12 - 64*s**(-1)*t1**2*u1**(-2) + 64*s**(-1)*t1**2*
     +    u1**(-1)*s4**(-2)*mst12 + 64*s**(-1)*t1**2*u1**(-1)*s4**(-1)
     +     + 16*s**(-1)*u1**(-1)*s4**(-1)*mst12**2 + 16*s**(-1)*
     +    u1**(-1)*mst12 - 16*s**(-1)*u1*s4**(-2)*mst12 - 32*s**(-1)*u1
     +    *s4**(-1)*(s+u1)**(-1)*mst12 + 4*s**(-1)*u1*s4**(-1) - 32*
     +    s**(-1)*u1*(s+u1)**(-1) - 32*s**(-1)*s4**(-2)*mst12**2 - 32*
     +    s**(-1)*s4**(-1)*mst12 )
     +
      M2ggh = M2ggh + N*CO * (  - 16*s*t1**(-2)*s4**(-1)*mst12 - 16*s*
     +    t1**(-2) + 16*s*t1**(-1)*s4**(-2)*mst12 + 16*s*t1**(-1)*
     +    s4**(-1) - 16*s*u1**(-2)*s4**(-1)*mst12 - 16*s*u1**(-2) + 16*
     +    s*u1**(-1)*s4**(-2)*mst12 + 16*s*u1**(-1)*s4**(-1) - 48*
     +    t1**(-2)*u1*s4**(-1)*mst12 - 48*t1**(-2)*u1 - 16*t1**(-2)*
     +    s4**(-2)*mst12**3 - 16*t1**(-2)*s4**(-1)*mst12**2 - 8*
     +    t1**(-2)*mst12 + 48*t1**(-1)*u1*s4**(-2)*mst12 + 44*t1**(-1)*
     +    u1*s4**(-1) - 16*t1**(-1)*s4**(-2)*mst12**2 - 32*t1**(-1)*
     +    s4**(-1)*mst12 - 28*t1**(-1) - 48*t1*u1**(-2)*s4**(-1)*mst12
     +     - 48*t1*u1**(-2) + 48*t1*u1**(-1)*s4**(-2)*mst12 + 44*t1*
     +    u1**(-1)*s4**(-1) - 16*t1*s4**(-1)*(s+u1)**(-2)*mst12 - 16*t1
     +    *(s+u1)**(-2) - 16*u1**(-2)*s4**(-2)*mst12**3 - 16*u1**(-2)*
     +    s4**(-1)*mst12**2 - 8*u1**(-2)*mst12 - 16*u1**(-1)*s4**(-2)*
     +    mst12**2 - 48*u1**(-1)*s4**(-1)*mst12 - 28*u1**(-1) - 16*u1*
     +    s4**(-1)*(s+t1)**(-2)*mst12 - 16*u1*(s+t1)**(-2) - 8*s4**(-2)
     +    *mst12 )
     +
      M2ggh = M2ggh + N*CO * (  - 16*s4**(-1)*(s+t1)**(-1)*mst12 - 16*
     +    s4**(-1)*(s+u1)**(-1)*mst12 + 8*s4**(-1) - 16*(s+t1)**(-1) - 
     +    16*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + N*CK*(s4+mst12) * ( 64*s*t1**(-3)*u1**(-1)*mst12
     +     - 32*s*t1**(-3)*s4**(-1)*mst12 - 32*s*t1**(-2)*u1**(-1)*
     +    s4**(-1)*mst12 - 16*s*t1**(-2)*s4**(-1)*(s+u1)**(-1)*mst12 - 
     +    16*s*t1**(-2)*s4**(-1) + 64*s*t1**(-1)*u1**(-3)*mst12 - 32*s*
     +    t1**(-1)*u1**(-2)*s4**(-1)*mst12 - 8*s*t1**(-1)*s4**(-1)*
     +    (s+u1)**(-1) - 32*s*u1**(-3)*s4**(-1)*mst12 - 16*s*u1**(-2)*
     +    s4**(-1)*(s+t1)**(-1)*mst12 - 16*s*u1**(-2)*s4**(-1) - 8*s*
     +    u1**(-1)*s4**(-1)*(s+t1)**(-1) - 96*s**2*t1**(-4)*u1**(-2)*
     +    mst12**2 + 64*s**2*t1**(-4)*u1**(-1)*s4**(-1)*mst12**2 + 64*
     +    s**2*t1**(-3)*u1**(-2)*s4**(-1)*mst12**2 - 32*s**2*t1**(-3)*
     +    u1**(-1)*s4**(-1)*mst12 - 96*s**2*t1**(-2)*u1**(-4)*mst12**2
     +     + 64*s**2*t1**(-2)*u1**(-3)*s4**(-1)*mst12**2 + 64*s**2*
     +    t1**(-1)*u1**(-4)*s4**(-1)*mst12**2 - 32*s**2*t1**(-1)*
     +    u1**(-3)*s4**(-1)*mst12 + 64*s**3*t1**(-4)*u1**(-2)*s4**(-1)*
     +    mst12**2 + 64*s**3*t1**(-2)*u1**(-4)*s4**(-1)*mst12**2 - 16*
     +    t1**(-2)*u1*s4**(-1)*(s+u1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + N*CK*(s4+mst12) * (  - 16*t1**(-2)*u1*s4**(-1) + 
     +    16*t1**(-2)*s4**(-1)*mst12 - 8*t1**(-1)*u1*s4**(-1)*
     +    (s+u1)**(-1) - 8*t1**(-1)*s4**(-1) - 16*t1*u1**(-2)*s4**(-1)*
     +    (s+t1)**(-1)*mst12 - 16*t1*u1**(-2)*s4**(-1) - 8*t1*u1**(-1)*
     +    s4**(-1)*(s+t1)**(-1) + 8*t1*s4**(-2)*(s+u1)**(-1) - 16*t1*
     +    s4**(-1)*(s+u1)**(-2) + 16*u1**(-2)*s4**(-1)*mst12 - 8*
     +    u1**(-1)*s4**(-1) + 8*u1*s4**(-2)*(s+t1)**(-1) - 16*u1*
     +    s4**(-1)*(s+t1)**(-2) - 16*s4**(-2) - 24*s4**(-1)*
     +    (s+t1)**(-1) - 24*s4**(-1)*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + N*CK * ( 64*s**(-2)*t1**(-1)*u1**(-1)*mst12**3 + 
     +    8*s**(-2)*t1**(-1)*u1*mst12 - 8*s**(-2)*t1**(-1)*u1**2*
     +    s4**(-1)*mst12 + 4*s**(-2)*t1**(-1)*u1**2 - 4*s**(-2)*
     +    t1**(-1)*u1**3*s4**(-1) - 64*s**(-2)*t1**(-1)*s4**(-1)*
     +    mst12**3 - 64*s**(-2)*u1**(-1)*s4**(-1)*mst12**3 - 8*s**(-2)*
     +    u1*s4**(-1)*mst12 + 16*s**(-2)*u1**2*s4**(-2)*mst12 - 4*
     +    s**(-2)*u1**2*s4**(-1) - 8*s**(-1)*t1**(-2)*u1*mst12 + 8*
     +    s**(-1)*t1**(-2)*u1**2*s4**(-1)*mst12 + 64*s**(-1)*t1**(-1)*
     +    u1**(-1)*mst12**2 - 16*s**(-1)*t1**(-1)*u1*s4**(-2)*mst12**2
     +     + 8*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12 - 4*s**(-1)*t1**(-1)*
     +    u1 - 4*s**(-1)*t1**(-1)*u1**2*s4**(-1) - 64*s**(-1)*t1**(-1)*
     +    s4**(-2)*mst12**3 - 48*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 - 
     +    16*s**(-1)*t1**(-1)*mst12 - 8*s**(-1)*t1*u1**(-1) - 64*
     +    s**(-1)*u1**(-1)*s4**(-2)*mst12**3 - 80*s**(-1)*u1**(-1)*
     +    s4**(-1)*mst12**2 - 16*s**(-1)*u1**(-1)*mst12 + 16*s**(-1)*u1
     +    *s4**(-2)*mst12 )
     +
      M2ggh = M2ggh + N*CK * (  - 8*s**(-1)*u1*s4**(-1) + 16*s**(-1)*
     +    s4**(-2)*mst12**2 + 40*s**(-1)*s4**(-1)*mst12 + 16*s*t1**(-2)
     +    *s4**(-1)*mst12 + 16*s*t1**(-2) + 16*s*t1**(-1)*u1**(-1) - 16
     +    *s*t1**(-1)*s4**(-2)*mst12 - 16*s*t1**(-1)*s4**(-1) + 16*s*
     +    u1**(-2)*s4**(-1)*mst12 + 16*s*u1**(-2) - 16*s*u1**(-1)*
     +    s4**(-2)*mst12 - 16*s*u1**(-1)*s4**(-1) + 24*t1**(-2)*u1*
     +    s4**(-1)*mst12 + 16*t1**(-2)*u1 + 48*t1**(-2)*s4**(-2)*
     +    mst12**3 + 48*t1**(-2)*s4**(-1)*mst12**2 + 24*t1**(-2)*mst12
     +     + 48*t1**(-1)*u1**(-1)*mst12 - 16*t1**(-1)*u1*s4**(-2)*mst12
     +     - 16*t1**(-1)*u1*s4**(-1) + 32*t1**(-1)*s4**(-2)*mst12**2 + 
     +    40*t1**(-1)*s4**(-1)*mst12 + 44*t1**(-1) + 16*t1*u1**(-2)*
     +    s4**(-1)*mst12 + 16*t1*u1**(-2) - 16*t1*u1**(-1)*s4**(-2)*
     +    mst12 - 12*t1*u1**(-1)*s4**(-1) + 16*t1*s4**(-1)*(s+u1)**(-2)
     +    *mst12 + 16*t1*(s+u1)**(-2) + 48*u1**(-2)*s4**(-2)*mst12**3
     +     + 48*u1**(-2)*s4**(-1)*mst12**2 + 24*u1**(-2)*mst12 + 48*
     +    u1**(-1)*s4**(-2)*mst12**2 )
     +
      M2ggh = M2ggh + N*CK * ( 48*u1**(-1)*s4**(-1)*mst12 + 44*u1**(-1)
     +     + 16*u1*s4**(-1)*(s+t1)**(-2)*mst12 + 16*u1*(s+t1)**(-2) + 
     +    24*s4**(-2)*mst12 + 16*s4**(-1)*(s+t1)**(-1)*mst12 + 16*
     +    s4**(-1)*(s+u1)**(-1)*mst12 - 8*s4**(-1) + 16*(s+t1)**(-1) + 
     +    16*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + CQED * (  - 32*s**(-2)*t1**(-1)*u1**(-1)*mst12**3
     +     + 32*s**(-2)*t1**(-1)*s4**(-1)*mst12**3 + 32*s**(-2)*
     +    u1**(-1)*s4**(-1)*mst12**3 - 32*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 32*s**(-1)*t1**(-1)*s4**(-2)*mst12**3 + 32*s**(-1)
     +    *t1**(-1)*s4**(-1)*mst12**2 + 32*s**(-1)*u1**(-1)*s4**(-2)*
     +    mst12**3 + 32*s**(-1)*u1**(-1)*s4**(-1)*mst12**2 - 8*s*
     +    t1**(-1)*u1**(-1) - 16*t1**(-2)*s4**(-2)*mst12**3 - 16*
     +    t1**(-2)*s4**(-1)*mst12**2 - 8*t1**(-2)*mst12 - 24*t1**(-1)*
     +    u1**(-1)*mst12 - 16*t1**(-1)*s4**(-2)*mst12**2 - 8*t1**(-1)
     +     - 16*u1**(-2)*s4**(-2)*mst12**3 - 16*u1**(-2)*s4**(-1)*
     +    mst12**2 - 8*u1**(-2)*mst12 - 16*u1**(-1)*s4**(-2)*mst12**2
     +     - 8*u1**(-1) - 8*s4**(-2)*mst12 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*s**(-2)*t1**(-2)*u1**3*
     +    s4**(-1)*mst12 + 32*s**(-2)*t1**(-2)*u1**3 + 64*s**(-2)*
     +    t1**(-1)*u1**2*s4**(-1)*mst12 + 64*s**(-2)*t1**(-1)*u1**2 - 
     +    32*s**(-2)*t1**(-1)*u1**3*s4**(-2)*mst12 - 32*s**(-2)*
     +    t1**(-1)*u1**3*s4**(-1) + 32*s**(-2)*t1*u1**2*s4**(-1)*
     +    (s+u1)**(-2)*mst12 + 32*s**(-2)*t1*u1**2*(s+u1)**(-2) + 64*
     +    s**(-2)*t1**2*u1**(-1)*s4**(-1)*mst12 + 64*s**(-2)*t1**2*
     +    u1**(-1) + 32*s**(-2)*t1**2*u1*s4**(-1)*(s+t1)**(-2)*mst12 + 
     +    32*s**(-2)*t1**2*u1*(s+t1)**(-2) + 32*s**(-2)*t1**2*s4**(-1)*
     +    (s+t1)**(-1)*mst12 + 32*s**(-2)*t1**2*(s+t1)**(-1) + 32*
     +    s**(-2)*t1**3*u1**(-2)*s4**(-1)*mst12 + 32*s**(-2)*t1**3*
     +    u1**(-2) - 32*s**(-2)*t1**3*u1**(-1)*s4**(-2)*mst12 - 32*
     +    s**(-2)*t1**3*u1**(-1)*s4**(-1) + 32*s**(-2)*u1**2*s4**(-1)*
     +    (s+u1)**(-1)*mst12 + 32*s**(-2)*u1**2*(s+u1)**(-1) - 64*
     +    s**(-1)*t1**(-3)*u1**2*s4**(-1)*mst12**2 - 64*s**(-1)*
     +    t1**(-3)*u1**2*mst12 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * (  - 128*s**(-1)*t1**(-2)*u1*
     +    s4**(-1)*mst12**2 - 128*s**(-1)*t1**(-2)*u1*mst12 + 64*
     +    s**(-1)*t1**(-2)*u1**2*s4**(-2)*mst12**2 + 128*s**(-1)*
     +    t1**(-2)*u1**2*s4**(-1)*mst12 + 64*s**(-1)*t1**(-2)*u1**2 - 
     +    64*s**(-1)*t1**(-1)*u1*s4**(-1)*(s+u1)**(-1)*mst12**2 + 64*
     +    s**(-1)*t1**(-1)*u1*s4**(-1)*mst12 - 64*s**(-1)*t1**(-1)*u1*
     +    (s+u1)**(-1)*mst12 + 64*s**(-1)*t1**(-1)*u1 - 64*s**(-1)*
     +    t1**(-1)*u1**2*s4**(-2)*mst12 - 64*s**(-1)*t1**(-1)*u1**2*
     +    s4**(-1) - 128*s**(-1)*t1*u1**(-2)*s4**(-1)*mst12**2 - 128*
     +    s**(-1)*t1*u1**(-2)*mst12 - 64*s**(-1)*t1*u1**(-1)*s4**(-1)*
     +    (s+t1)**(-1)*mst12**2 + 64*s**(-1)*t1*u1**(-1)*s4**(-1)*mst12
     +     - 64*s**(-1)*t1*u1**(-1)*(s+t1)**(-1)*mst12 + 64*s**(-1)*t1*
     +    u1**(-1) + 32*s**(-1)*t1*u1*s4**(-1)*(s+t1)**(-2)*mst12 + 32*
     +    s**(-1)*t1*u1*s4**(-1)*(s+u1)**(-2)*mst12 + 32*s**(-1)*t1*u1*
     +    (s+t1)**(-2) + 32*s**(-1)*t1*u1*(s+u1)**(-2) - 64*s**(-1)*t1*
     +    s4**(-1)*(s+t1)**(-2)*mst12**2 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*s**(-1)*t1*s4**(-1)*
     +    (s+t1)**(-1)*mst12 - 64*s**(-1)*t1*(s+t1)**(-2)*mst12 + 32*
     +    s**(-1)*t1*(s+t1)**(-1) - 64*s**(-1)*t1**2*u1**(-3)*s4**(-1)*
     +    mst12**2 - 64*s**(-1)*t1**2*u1**(-3)*mst12 + 64*s**(-1)*t1**2
     +    *u1**(-2)*s4**(-2)*mst12**2 + 128*s**(-1)*t1**2*u1**(-2)*
     +    s4**(-1)*mst12 + 64*s**(-1)*t1**2*u1**(-2) - 64*s**(-1)*t1**2
     +    *u1**(-1)*s4**(-2)*mst12 - 64*s**(-1)*t1**2*u1**(-1)*s4**(-1)
     +     - 64*s**(-1)*u1*s4**(-1)*(s+u1)**(-2)*mst12**2 + 32*s**(-1)*
     +    u1*s4**(-1)*(s+u1)**(-1)*mst12 - 64*s**(-1)*u1*(s+u1)**(-2)*
     +    mst12 + 32*s**(-1)*u1*(s+u1)**(-1) + 128*s*t1**(-4)*s4**(-1)*
     +    mst12**3 + 128*s*t1**(-4)*mst12**2 + 128*s*t1**(-3)*u1**(-1)*
     +    s4**(-1)*mst12**3 + 128*s*t1**(-3)*u1**(-1)*mst12**2 - 128*s*
     +    t1**(-3)*s4**(-2)*mst12**3 - 224*s*t1**(-3)*s4**(-1)*mst12**2
     +     - 96*s*t1**(-3)*mst12 + 64*s*t1**(-2)*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1)*mst12**3 - 64*s*t1**(-2)*u1**(-1)*s4**(-1)*
     +    mst12**2 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 64*s*t1**(-2)*u1**(-1)*
     +    (s+u1)**(-1)*mst12**2 - 64*s*t1**(-2)*u1**(-1)*mst12 + 96*s*
     +    t1**(-2)*s4**(-2)*mst12**2 + 112*s*t1**(-2)*s4**(-1)*mst12 + 
     +    16*s*t1**(-2) + 128*s*t1**(-1)*u1**(-3)*s4**(-1)*mst12**3 + 
     +    128*s*t1**(-1)*u1**(-3)*mst12**2 + 64*s*t1**(-1)*u1**(-2)*
     +    s4**(-1)*(s+t1)**(-1)*mst12**3 - 64*s*t1**(-1)*u1**(-2)*
     +    s4**(-1)*mst12**2 + 64*s*t1**(-1)*u1**(-2)*(s+t1)**(-1)*
     +    mst12**2 - 64*s*t1**(-1)*u1**(-2)*mst12 + 64*s*t1**(-1)*
     +    u1**(-1)*s4**(-1)*(s+t1)**(-2)*mst12**3 - 32*s*t1**(-1)*
     +    u1**(-1)*s4**(-1)*(s+t1)**(-1)*mst12**2 + 64*s*t1**(-1)*
     +    u1**(-1)*s4**(-1)*(s+u1)**(-2)*mst12**3 - 32*s*t1**(-1)*
     +    u1**(-1)*s4**(-1)*(s+u1)**(-1)*mst12**2 + 64*s*t1**(-1)*
     +    u1**(-1)*(s+t1)**(-2)*mst12**2 - 32*s*t1**(-1)*u1**(-1)*
     +    (s+t1)**(-1)*mst12 + 64*s*t1**(-1)*u1**(-1)*(s+u1)**(-2)*
     +    mst12**2 - 32*s*t1**(-1)*u1**(-1)*(s+u1)**(-1)*mst12 - 16*s*
     +    t1**(-1)*s4**(-2)*mst12 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * (  - 32*s*t1**(-1)*s4**(-1)*
     +    (s+t1)**(-2)*mst12**2 - 16*s*t1**(-1)*s4**(-1) - 32*s*
     +    t1**(-1)*(s+t1)**(-2)*mst12 + 128*s*u1**(-4)*s4**(-1)*
     +    mst12**3 + 128*s*u1**(-4)*mst12**2 - 128*s*u1**(-3)*s4**(-2)*
     +    mst12**3 - 224*s*u1**(-3)*s4**(-1)*mst12**2 - 96*s*u1**(-3)*
     +    mst12 + 96*s*u1**(-2)*s4**(-2)*mst12**2 + 112*s*u1**(-2)*
     +    s4**(-1)*mst12 + 16*s*u1**(-2) - 16*s*u1**(-1)*s4**(-2)*mst12
     +     - 32*s*u1**(-1)*s4**(-1)*(s+u1)**(-2)*mst12**2 - 16*s*
     +    u1**(-1)*s4**(-1) - 32*s*u1**(-1)*(s+u1)**(-2)*mst12 + 96*
     +    s**2*t1**(-4)*u1**(-1)*s4**(-1)*mst12**3 + 96*s**2*t1**(-4)*
     +    u1**(-1)*mst12**2 + 64*s**2*t1**(-3)*u1**(-2)*s4**(-1)*
     +    mst12**3 + 64*s**2*t1**(-3)*u1**(-2)*mst12**2 - 96*s**2*
     +    t1**(-3)*u1**(-1)*s4**(-2)*mst12**3 - 128*s**2*t1**(-3)*
     +    u1**(-1)*s4**(-1)*mst12**2 - 32*s**2*t1**(-3)*u1**(-1)*mst12
     +     + 64*s**2*t1**(-2)*u1**(-3)*s4**(-1)*mst12**3 + 64*s**2*
     +    t1**(-2)*u1**(-3)*mst12**2 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*s**2*t1**(-2)*u1**(-2)*
     +    s4**(-1)*(s+t1)**(-1)*mst12**3 + 32*s**2*t1**(-2)*u1**(-2)*
     +    s4**(-1)*(s+u1)**(-1)*mst12**3 + 32*s**2*t1**(-2)*u1**(-2)*
     +    (s+t1)**(-1)*mst12**2 + 32*s**2*t1**(-2)*u1**(-2)*
     +    (s+u1)**(-1)*mst12**2 + 32*s**2*t1**(-2)*u1**(-1)*s4**(-2)*
     +    mst12**2 + 32*s**2*t1**(-2)*u1**(-1)*s4**(-1)*(s+t1)**(-2)*
     +    mst12**3 + 32*s**2*t1**(-2)*u1**(-1)*s4**(-1)*mst12 + 32*s**2
     +    *t1**(-2)*u1**(-1)*(s+t1)**(-2)*mst12**2 + 96*s**2*t1**(-1)*
     +    u1**(-4)*s4**(-1)*mst12**3 + 96*s**2*t1**(-1)*u1**(-4)*
     +    mst12**2 - 96*s**2*t1**(-1)*u1**(-3)*s4**(-2)*mst12**3 - 128*
     +    s**2*t1**(-1)*u1**(-3)*s4**(-1)*mst12**2 - 32*s**2*t1**(-1)*
     +    u1**(-3)*mst12 + 32*s**2*t1**(-1)*u1**(-2)*s4**(-2)*mst12**2
     +     + 32*s**2*t1**(-1)*u1**(-2)*s4**(-1)*(s+u1)**(-2)*mst12**3
     +     + 32*s**2*t1**(-1)*u1**(-2)*s4**(-1)*mst12 + 32*s**2*
     +    t1**(-1)*u1**(-2)*(s+u1)**(-2)*mst12**2 + 32*s**3*t1**(-4)*
     +    u1**(-2)*s4**(-1)*mst12**3 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*s**3*t1**(-4)*u1**(-2)*
     +    mst12**2 - 32*s**3*t1**(-3)*u1**(-2)*s4**(-2)*mst12**3 - 32*
     +    s**3*t1**(-3)*u1**(-2)*s4**(-1)*mst12**2 + 32*s**3*t1**(-2)*
     +    u1**(-4)*s4**(-1)*mst12**3 + 32*s**3*t1**(-2)*u1**(-4)*
     +    mst12**2 - 32*s**3*t1**(-2)*u1**(-3)*s4**(-2)*mst12**3 - 32*
     +    s**3*t1**(-2)*u1**(-3)*s4**(-1)*mst12**2 + 64*t1**(-4)*u1*
     +    s4**(-1)*mst12**3 + 64*t1**(-4)*u1*mst12**2 - 64*t1**(-3)*u1*
     +    s4**(-2)*mst12**3 - 192*t1**(-3)*u1*s4**(-1)*mst12**2 - 128*
     +    t1**(-3)*u1*mst12 + 128*t1**(-3)*s4**(-1)*mst12**3 + 128*
     +    t1**(-3)*mst12**2 + 128*t1**(-2)*u1*s4**(-2)*mst12**2 + 176*
     +    t1**(-2)*u1*s4**(-1)*mst12 + 48*t1**(-2)*u1 + 64*t1**(-2)*
     +    s4**(-1)*(s+u1)**(-1)*mst12**3 - 128*t1**(-2)*s4**(-1)*
     +    mst12**2 + 64*t1**(-2)*(s+u1)**(-1)*mst12**2 - 128*t1**(-2)*
     +    mst12 - 48*t1**(-1)*u1*s4**(-2)*mst12 - 48*t1**(-1)*u1*
     +    s4**(-1) + 64*t1**(-1)*s4**(-1)*(s+u1)**(-2)*mst12**3 - 64*
     +    t1**(-1)*s4**(-1)*(s+u1)**(-1)*mst12**2 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*t1**(-1)*s4**(-1)*mst12 + 64
     +    *t1**(-1)*(s+u1)**(-2)*mst12**2 - 64*t1**(-1)*(s+u1)**(-1)*
     +    mst12 + 32*t1**(-1) + 64*t1*u1**(-4)*s4**(-1)*mst12**3 + 64*
     +    t1*u1**(-4)*mst12**2 - 64*t1*u1**(-3)*s4**(-2)*mst12**3 - 192
     +    *t1*u1**(-3)*s4**(-1)*mst12**2 - 128*t1*u1**(-3)*mst12 + 128*
     +    t1*u1**(-2)*s4**(-2)*mst12**2 + 176*t1*u1**(-2)*s4**(-1)*
     +    mst12 + 48*t1*u1**(-2) - 48*t1*u1**(-1)*s4**(-2)*mst12 - 48*
     +    t1*u1**(-1)*s4**(-1) + 16*t1*s4**(-1)*(s+u1)**(-2)*mst12 + 16
     +    *t1*(s+u1)**(-2) + 128*u1**(-3)*s4**(-1)*mst12**3 + 128*
     +    u1**(-3)*mst12**2 + 64*u1**(-2)*s4**(-1)*(s+t1)**(-1)*
     +    mst12**3 - 128*u1**(-2)*s4**(-1)*mst12**2 + 64*u1**(-2)*
     +    (s+t1)**(-1)*mst12**2 - 128*u1**(-2)*mst12 + 64*u1**(-1)*
     +    s4**(-1)*(s+t1)**(-2)*mst12**3 - 64*u1**(-1)*s4**(-1)*
     +    (s+t1)**(-1)*mst12**2 + 32*u1**(-1)*s4**(-1)*mst12 + 64*
     +    u1**(-1)*(s+t1)**(-2)*mst12**2 - 64*u1**(-1)*(s+t1)**(-1)*
     +    mst12 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CO * ( 32*u1**(-1) + 16*u1*s4**(-1)*
     +    (s+t1)**(-2)*mst12 + 16*u1*(s+t1)**(-2) - 64*s4**(-1)*
     +    (s+t1)**(-2)*mst12**2 + 16*s4**(-1)*(s+t1)**(-1)*mst12 - 64*
     +    s4**(-1)*(s+u1)**(-2)*mst12**2 + 16*s4**(-1)*(s+u1)**(-1)*
     +    mst12 - 64*(s+t1)**(-2)*mst12 + 16*(s+t1)**(-1) - 64*
     +    (s+u1)**(-2)*mst12 + 16*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + COLO1(9)*N*CK * ( 32*s*t1**(-3)*s4**(-1)*mst12**2
     +     + 32*s*t1**(-3)*mst12 + 64*s*t1**(-2)*u1**(-1)*s4**(-1)*
     +    mst12**2 + 64*s*t1**(-2)*u1**(-1)*mst12 - 32*s*t1**(-2)*
     +    s4**(-2)*mst12**2 - 48*s*t1**(-2)*s4**(-1)*mst12 - 16*s*
     +    t1**(-2) + 64*s*t1**(-1)*u1**(-2)*s4**(-1)*mst12**2 + 64*s*
     +    t1**(-1)*u1**(-2)*mst12 + 32*s*t1**(-1)*u1**(-1)*s4**(-1)*
     +    (s+t1)**(-1)*mst12**2 + 32*s*t1**(-1)*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1)*mst12**2 + 32*s*t1**(-1)*u1**(-1)*(s+t1)**(-1)*
     +    mst12 + 32*s*t1**(-1)*u1**(-1)*(s+u1)**(-1)*mst12 + 16*s*
     +    t1**(-1)*s4**(-2)*mst12 + 32*s*t1**(-1)*s4**(-1)*(s+t1)**(-2)
     +    *mst12**2 + 16*s*t1**(-1)*s4**(-1) + 32*s*t1**(-1)*
     +    (s+t1)**(-2)*mst12 + 32*s*u1**(-3)*s4**(-1)*mst12**2 + 32*s*
     +    u1**(-3)*mst12 - 32*s*u1**(-2)*s4**(-2)*mst12**2 - 48*s*
     +    u1**(-2)*s4**(-1)*mst12 - 16*s*u1**(-2) + 16*s*u1**(-1)*
     +    s4**(-2)*mst12 + 32*s*u1**(-1)*s4**(-1)*(s+u1)**(-2)*mst12**2
     +     + 16*s*u1**(-1)*s4**(-1) )
     +
      M2ggh = M2ggh + COLO1(9)*N*CK * ( 32*s*u1**(-1)*(s+u1)**(-2)*
     +    mst12 - 32*s**2*t1**(-4)*u1**(-1)*s4**(-1)*mst12**3 - 32*s**2
     +    *t1**(-4)*u1**(-1)*mst12**2 - 64*s**2*t1**(-3)*u1**(-2)*
     +    s4**(-1)*mst12**3 - 64*s**2*t1**(-3)*u1**(-2)*mst12**2 + 32*
     +    s**2*t1**(-3)*u1**(-1)*s4**(-2)*mst12**3 + 64*s**2*t1**(-3)*
     +    u1**(-1)*s4**(-1)*mst12**2 + 32*s**2*t1**(-3)*u1**(-1)*mst12
     +     - 64*s**2*t1**(-2)*u1**(-3)*s4**(-1)*mst12**3 - 64*s**2*
     +    t1**(-2)*u1**(-3)*mst12**2 - 32*s**2*t1**(-2)*u1**(-2)*
     +    s4**(-1)*(s+t1)**(-1)*mst12**3 - 32*s**2*t1**(-2)*u1**(-2)*
     +    s4**(-1)*(s+u1)**(-1)*mst12**3 - 32*s**2*t1**(-2)*u1**(-2)*
     +    (s+t1)**(-1)*mst12**2 - 32*s**2*t1**(-2)*u1**(-2)*
     +    (s+u1)**(-1)*mst12**2 - 32*s**2*t1**(-2)*u1**(-1)*s4**(-2)*
     +    mst12**2 - 32*s**2*t1**(-2)*u1**(-1)*s4**(-1)*(s+t1)**(-2)*
     +    mst12**3 - 32*s**2*t1**(-2)*u1**(-1)*s4**(-1)*mst12 - 32*s**2
     +    *t1**(-2)*u1**(-1)*(s+t1)**(-2)*mst12**2 - 32*s**2*t1**(-1)*
     +    u1**(-4)*s4**(-1)*mst12**3 )
     +
      M2ggh = M2ggh + COLO1(9)*N*CK * (  - 32*s**2*t1**(-1)*u1**(-4)*
     +    mst12**2 + 32*s**2*t1**(-1)*u1**(-3)*s4**(-2)*mst12**3 + 64*
     +    s**2*t1**(-1)*u1**(-3)*s4**(-1)*mst12**2 + 32*s**2*t1**(-1)*
     +    u1**(-3)*mst12 - 32*s**2*t1**(-1)*u1**(-2)*s4**(-2)*mst12**2
     +     - 32*s**2*t1**(-1)*u1**(-2)*s4**(-1)*(s+u1)**(-2)*mst12**3
     +     - 32*s**2*t1**(-1)*u1**(-2)*s4**(-1)*mst12 - 32*s**2*
     +    t1**(-1)*u1**(-2)*(s+u1)**(-2)*mst12**2 - 32*s**3*t1**(-4)*
     +    u1**(-2)*s4**(-1)*mst12**3 - 32*s**3*t1**(-4)*u1**(-2)*
     +    mst12**2 + 32*s**3*t1**(-3)*u1**(-2)*s4**(-2)*mst12**3 + 32*
     +    s**3*t1**(-3)*u1**(-2)*s4**(-1)*mst12**2 - 32*s**3*t1**(-2)*
     +    u1**(-4)*s4**(-1)*mst12**3 - 32*s**3*t1**(-2)*u1**(-4)*
     +    mst12**2 + 32*s**3*t1**(-2)*u1**(-3)*s4**(-2)*mst12**3 + 32*
     +    s**3*t1**(-2)*u1**(-3)*s4**(-1)*mst12**2 - 16*t1**(-2)*u1*
     +    s4**(-1)*mst12 - 16*t1**(-2)*u1 + 16*t1**(-1)*u1*s4**(-2)*
     +    mst12 + 16*t1**(-1)*u1*s4**(-1) - 32*t1**(-1)*s4**(-1)*mst12
     +     - 32*t1**(-1) )
     +
      M2ggh = M2ggh + COLO1(9)*N*CK * (  - 16*t1*u1**(-2)*s4**(-1)*
     +    mst12 - 16*t1*u1**(-2) + 16*t1*u1**(-1)*s4**(-2)*mst12 + 16*
     +    t1*u1**(-1)*s4**(-1) - 16*t1*s4**(-1)*(s+u1)**(-2)*mst12 - 16
     +    *t1*(s+u1)**(-2) - 32*u1**(-1)*s4**(-1)*mst12 - 32*u1**(-1)
     +     - 16*u1*s4**(-1)*(s+t1)**(-2)*mst12 - 16*u1*(s+t1)**(-2) - 
     +    16*s4**(-1)*(s+t1)**(-1)*mst12 - 16*s4**(-1)*(s+u1)**(-1)*
     +    mst12 - 16*(s+t1)**(-1) - 16*(s+u1)**(-1) )
     +
      M2ggh = M2ggh + ANG4(1)*N*CO * (  - 8*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(1)*N*CK * ( 24*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(1)*CQED * (  - 8*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(2)*N*CO * (  - 8*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(2)*N*CK * ( 32*u1**(-1)*mst12**3 + 24*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(2)*CQED * (  - 16*u1**(-1)*mst12**3 - 8*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(3)*N*CO * (  - 8*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(3)*N*CK * (  - 32*s**(-1)*mst12**3 + 24*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(3)*CQED * ( 16*s**(-1)*mst12**3 - 8*mst12**2
     +     )
     +
      M2ggh = M2ggh + ANG4(4)*N*CO * ( 8*s**(-1)*t1*u1**(-1)*mst12**2
     +     + 8*s**(-1)*u1*(t1+u1)**(-1)*mst12**2 + 8*s*u1**(-1)*
     +    (t1+u1)**(-1)*mst12**2 + 2*s*u1*(t1+u1)**(-1) + 8*s*
     +    (t1+u1)**(-1)*mst12 + 8*u1**(-1)*mst12**2 - 8*u1*
     +    (t1+u1)**(-1)*mst12 - 8*(t1+u1)**(-1)*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(4)*N*CK * (  - 32*s**(-2)*mst12**3 - 16*
     +    s**(-1)*t1**(-1)*u1*mst12**2 - 16*s**(-1)*t1**(-1)*mst12**3
     +     - 24*s**(-1)*t1*u1**(-1)*mst12**2 - 16*s**(-1)*u1**(-1)*
     +    mst12**3 - 8*s**(-1)*u1*s4**(-1)*mst12**2 - 32*s**(-1)*
     +    mst12**2 - 8*s*t1**(-1)*u1**(-1)*mst12**2 - 2*s*t1**(-1)*u1
     +     - 8*s*t1**(-1)*mst12 - 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 - 
     +    2*s*u1*(s+t1)**(-1) - 4*s*(s+t1)**(-1)*mst12 + 8*t1**(-1)*u1*
     +    (s+t1)**(-1)*mst12**2 + 4*t1**(-1)*u1*mst12 + 8*t1**(-1)*
     +    mst12**2 + 8*t1*u1**(-1)*s4**(-1)*mst12**2 + 2*t1*u1*s4**(-1)
     +     + 4*t1*s4**(-1)*mst12 + 16*u1**(-1)*s4**(-1)*mst12**3 + 12*
     +    u1*s4**(-1)*mst12 + 4*u1*(s+t1)**(-1)*mst12 - 2*u1 + 2*u1**2*
     +    s4**(-1) + 16*s4**(-1)*mst12**2 + 8*(s+t1)**(-1)*mst12**2 - 4
     +    *mst12 )
     +
      M2ggh = M2ggh + ANG4(4)*CQED * ( 16*s**(-2)*mst12**3 + 8*s**(-1)*
     +    t1**(-1)*u1*mst12**2 + 16*s**(-1)*t1**(-1)*mst12**3 + 8*
     +    s**(-1)*t1*u1**(-1)*mst12**2 + 16*s**(-1)*u1**(-1)*mst12**3
     +     + 16*s**(-1)*mst12**2 - 24*t1**(-1)*u1*s4**(-1)*mst12**2 + 8
     +    *t1**(-1)*u1*mst12 - 12*t1**(-1)*u1**2*s4**(-1)*mst12 + 2*
     +    t1**(-1)*u1**2 - 2*t1**(-1)*u1**3*s4**(-1) - 16*t1**(-1)*
     +    s4**(-1)*mst12**3 + 8*t1**(-1)*mst12**2 - 8*t1*u1**(-1)*
     +    s4**(-1)*mst12**2 - 2*t1*u1*s4**(-1) - 4*t1*s4**(-1)*mst12 - 
     +    16*u1**(-1)*s4**(-1)*mst12**3 - 16*u1*s4**(-1)*mst12 + 2*u1
     +     - 4*u1**2*s4**(-1) - 24*s4**(-1)*mst12**2 + 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(5)*N*CO * (  - 8*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(5)*N*CK * ( 24*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(5)*CQED * (  - 8*mst12**3 )
     +
      M2ggh = M2ggh + ANG4(6)*N*CO * (  - 8*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(6)*N*CK * ( 32*t1**(-1)*mst12**3 + 24*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(6)*CQED * (  - 16*t1**(-1)*mst12**3 - 8*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(7)*N*CO * (  - 8*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(7)*N*CK * (  - 32*s**(-1)*mst12**3 + 24*
     +    mst12**2 )
     +
      M2ggh = M2ggh + ANG4(7)*CQED * ( 16*s**(-1)*mst12**3 - 8*mst12**2
     +     )
     +
      M2ggh = M2ggh + ANG4(8)*N*CO * ( 8*s**(-1)*t1**(-1)*u1*mst12**2
     +     - 8*s**(-1)*u1*(t1+u1)**(-1)*mst12**2 + 8*s**(-1)*mst12**2
     +     + 8*s*t1**(-1)*u1**(-1)*mst12**2 - 8*s*u1**(-1)*
     +    (t1+u1)**(-1)*mst12**2 - 2*s*u1*(t1+u1)**(-1) + 8*s*
     +    (t1+u1)**(-1)*mst12 + 2*s + 8*t1**(-1)*mst12**2 + 8*u1*
     +    (t1+u1)**(-1)*mst12 - 8*(t1+u1)**(-1)*mst12**2 - 8*mst12 )
     +
      M2ggh = M2ggh + ANG4(8)*N*CK * (  - 32*s**(-2)*mst12**3 - 24*
     +    s**(-1)*t1**(-1)*u1*mst12**2 - 16*s**(-1)*t1**(-1)*mst12**3
     +     - 16*s**(-1)*t1*u1**(-1)*mst12**2 - 16*s**(-1)*u1**(-1)*
     +    mst12**3 + 8*s**(-1)*u1*s4**(-1)*mst12**2 - 40*s**(-1)*
     +    mst12**2 - 8*s*t1**(-1)*u1**(-1)*mst12**2 - 8*s*t1**(-1)*
     +    (s+u1)**(-1)*mst12**2 - 2*s*t1*u1**(-1) - 2*s*t1*(s+u1)**(-1)
     +     - 8*s*u1**(-1)*mst12 - 4*s*(s+u1)**(-1)*mst12 + 8*t1**(-1)*
     +    u1*s4**(-1)*mst12**2 + 16*t1**(-1)*s4**(-1)*mst12**3 + 8*t1*
     +    u1**(-1)*(s+u1)**(-1)*mst12**2 + 4*t1*u1**(-1)*mst12 + 2*t1*
     +    u1*s4**(-1) + 12*t1*s4**(-1)*mst12 + 4*t1*(s+u1)**(-1)*mst12
     +     - 2*t1 + 2*t1**2*s4**(-1) + 8*u1**(-1)*mst12**2 + 4*u1*
     +    s4**(-1)*mst12 + 24*s4**(-1)*mst12**2 + 8*(s+u1)**(-1)*
     +    mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(8)*CQED * ( 16*s**(-2)*mst12**3 + 8*s**(-1)*
     +    t1**(-1)*u1*mst12**2 + 16*s**(-1)*t1**(-1)*mst12**3 + 8*
     +    s**(-1)*t1*u1**(-1)*mst12**2 + 16*s**(-1)*u1**(-1)*mst12**3
     +     + 16*s**(-1)*mst12**2 - 8*t1**(-1)*u1*s4**(-1)*mst12**2 - 16
     +    *t1**(-1)*s4**(-1)*mst12**3 - 24*t1*u1**(-1)*s4**(-1)*
     +    mst12**2 + 8*t1*u1**(-1)*mst12 - 2*t1*u1*s4**(-1) - 16*t1*
     +    s4**(-1)*mst12 + 2*t1 - 12*t1**2*u1**(-1)*s4**(-1)*mst12 + 2*
     +    t1**2*u1**(-1) - 4*t1**2*s4**(-1) - 2*t1**3*u1**(-1)*s4**(-1)
     +     - 16*u1**(-1)*s4**(-1)*mst12**3 + 8*u1**(-1)*mst12**2 - 4*u1
     +    *s4**(-1)*mst12 - 24*s4**(-1)*mst12**2 + 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(9)*N*CO * (  - 8*s**(-2)*mst12 )
     +
      M2ggh = M2ggh + ANG4(9)*N*CK * ( 8*s**(-2)*mst12 )
     +
      M2ggh = M2ggh + ANG4(10)*N*CO * (  - 8*s**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(10)*N*CK * ( 8*s**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(11)*N*CO * ( 16*s**(-2)*(t1+u1)**(-1)*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(12)*N*CO * ( 16*s**(-2)*u1*(t1+u1)**(-1)*
     +    mst12 + 16*s**(-1)*(t1+u1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(12)*N*CK * (  - 4*s**(-2)*t1**(-1)*u1*mst12
     +     + 4*s**(-2)*t1**(-1)*u1**2*s4**(-1)*mst12 - 2*s**(-2)*
     +    t1**(-1)*u1**2 + 2*s**(-2)*t1**(-1)*u1**3*s4**(-1) - 12*
     +    s**(-2)*u1*s4**(-1)*mst12 + 2*s**(-2)*u1**2*s4**(-1) + 4*
     +    s**(-1)*t1**(-2)*u1*mst12 - 4*s**(-1)*t1**(-2)*u1**2*s4**(-1)
     +    *mst12 - 8*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12 - 8*s**(-1)*
     +    t1**(-1)*s4**(-1)*mst12**2 + 4*s**(-1)*t1**(-1)*mst12 + 2*
     +    s**(-1)*t1*u1**(-1) + 8*s**(-1)*u1**(-1)*s4**(-1)*mst12**2 + 
     +    4*s**(-1)*u1**(-1)*mst12 + 6*s**(-1)*u1*s4**(-1) - 16*s**(-1)
     +    *s4**(-1)*mst12 - 4*s**(-1) - 4*t1**(-2)*u1*s4**(-1)*mst12 - 
     +    2*t1*u1**(-1)*s4**(-1) - 8*u1**(-1)*s4**(-1)*mst12 + 4*
     +    s4**(-1) )
     +
      M2ggh = M2ggh + ANG4(13)*N*CO * (  - 16*s**(-2)*mst12 )
     +
      M2ggh = M2ggh + ANG4(14)*N*CO * (  - 32*s**(-2)*u1*mst12 - 16*
     +    s**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(15)*N*CO * ( 16*s**(-2)*(t1+u1)**(-1)*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(16)*N*CO * (  - 16*s**(-2)*u1*s4**(-1)*mst12
     +     + 16*s**(-2)*u1*(t1+u1)**(-1)*mst12 - 8*s**(-1)*t1**(-1)*u1*
     +    s4**(-1)*mst12 - 2*s**(-1)*t1**(-1)*u1**2*s4**(-1) - 8*
     +    s**(-1)*t1**(-1)*s4**(-1)*mst12**2 + 4*s**(-1)*t1**(-1)*mst12
     +     + 2*s**(-1)*t1*u1**(-1) + 8*s**(-1)*u1**(-1)*s4**(-1)*
     +    mst12**2 + 4*s**(-1)*u1**(-1)*mst12 + 6*s**(-1)*u1*s4**(-1)
     +     - 16*s**(-1)*s4**(-1)*mst12 + 16*s**(-1)*(t1+u1)**(-1)*mst12
     +     - 4*s**(-1) - 2*t1*u1**(-1)*s4**(-1) - 8*u1**(-1)*s4**(-1)*
     +    mst12 + 4*s4**(-1) )
     +
      M2ggh = M2ggh + ANG4(17)*N*CO * (  - 6*s**(-1)*t1*u1 - 4*s**(-1)*
     +    t1*mst12 - 8*s**(-1)*t1**2 - 4*s**(-1)*t1**3*u1**(-1) - 8*
     +    s**(-1)*u1*(t1+u1)**(-1)*mst12**2 - 2*s**(-1)*u1**2 - 8*s*
     +    t1**(-1)*u1**(-1)*mst12**2 - 2*s*t1**(-1)*u1 + 8*s*t1**(-1)*
     +    (s+u1)**(-1)*mst12**2 + 8*s*t1**(-1)*mst12 + 16*s*t1*u1**(-2)
     +    *mst12 - 8*s*t1*u1**(-1) + 2*s*t1*(s+u1)**(-1) - 8*s*u1**(-1)
     +    *(t1+u1)**(-1)*mst12**2 + 8*s*u1**(-1)*mst12 - 2*s*u1*
     +    (t1+u1)**(-1) + 4*s*(s+u1)**(-1)*mst12 + 8*s*(t1+u1)**(-1)*
     +    mst12 - 4*s - 2*t1**(-1)*u1**2 - 8*t1**(-1)*mst12**2 + 8*t1*
     +    u1**(-1)*mst12 - 4*t1*(s+u1)**(-1)*mst12 - 22*t1 - 16*t1**2*
     +    u1**(-1) - 4*t1**2*(s+u1)**(-1) - 4*t1**3*u1**(-1)*
     +    (s+u1)**(-1) + 8*u1*(t1+u1)**(-1)*mst12 - 12*u1 - 8*
     +    (t1+u1)**(-1)*mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(18)*N*CO * (  - 4*s**(-1)*t1**(-1)*u1**3 - 6
     +    *s**(-1)*t1*u1 - 2*s**(-1)*t1**2 + 8*s**(-1)*u1*(t1+u1)**(-1)
     +    *mst12**2 - 4*s**(-1)*u1*mst12 - 8*s**(-1)*u1**2 - 8*s**(-1)*
     +    mst12**2 + 16*s*t1**(-2)*u1*mst12 - 16*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 8*s*t1**(-1)*u1 + 8*s*t1**(-1)*mst12 - 2*s*t1*
     +    u1**(-1) + 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 + 8*s*u1**(-1)*
     +    (t1+u1)**(-1)*mst12**2 + 8*s*u1**(-1)*mst12 + 2*s*u1*
     +    (s+t1)**(-1) + 2*s*u1*(t1+u1)**(-1) + 4*s*(s+t1)**(-1)*mst12
     +     + 8*s*(t1+u1)**(-1)*mst12 - 6*s + 8*t1**(-1)*u1*mst12 - 16*
     +    t1**(-1)*u1**2 - 4*t1**(-1)*u1**3*(s+t1)**(-1) - 12*t1 - 2*
     +    t1**2*u1**(-1) - 8*u1**(-1)*mst12**2 - 4*u1*(s+t1)**(-1)*
     +    mst12 - 8*u1*(t1+u1)**(-1)*mst12 - 22*u1 - 4*u1**2*
     +    (s+t1)**(-1) - 8*(t1+u1)**(-1)*mst12**2 + 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(19)*N*CK * ( 32*s**(-2)*mst12**3 + 16*
     +    s**(-1)*t1**(-1)*u1*mst12**2 + 16*s**(-1)*t1**(-1)*mst12**3
     +     + 16*s**(-1)*t1*u1**(-1)*mst12**2 + 16*s**(-1)*u1**(-1)*
     +    mst12**3 + 32*s**(-1)*mst12**2 + 2*s*t1**(-1)*u1 + 8*s*
     +    t1**(-1)*(s+u1)**(-1)*mst12**2 + 12*s*t1**(-1)*mst12 + 2*s*t1
     +    *u1**(-1) + 2*s*t1*(s+u1)**(-1) + 8*s*u1**(-1)*(s+t1)**(-1)*
     +    mst12**2 + 12*s*u1**(-1)*mst12 + 2*s*u1*(s+t1)**(-1) + 4*s*
     +    (s+t1)**(-1)*mst12 + 4*s*(s+u1)**(-1)*mst12 + 8*s + 2*s**2*
     +    t1**(-1) + 2*s**2*u1**(-1) - 8*t1**(-1)*u1*(s+t1)**(-1)*
     +    mst12**2 + 4*t1**(-1)*u1*mst12 + 16*t1**(-1)*mst12**2 - 8*t1*
     +    u1**(-1)*(s+u1)**(-1)*mst12**2 + 4*t1*u1**(-1)*mst12 + 4*t1*
     +    (s+u1)**(-1)*mst12 + 16*u1**(-1)*mst12**2 + 4*u1*(s+t1)**(-1)
     +    *mst12 + 8*(s+t1)**(-1)*mst12**2 + 8*(s+u1)**(-1)*mst12**2 + 
     +    24*mst12 )
     +
      M2ggh = M2ggh + ANG4(19)*CQED * (  - 16*s**(-2)*mst12**3 - 8*
     +    s**(-1)*t1**(-1)*u1*mst12**2 - 16*s**(-1)*t1**(-1)*mst12**3
     +     - 8*s**(-1)*t1*u1**(-1)*mst12**2 - 16*s**(-1)*u1**(-1)*
     +    mst12**3 - 16*s**(-1)*mst12**2 - 24*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 2*s*t1**(-1)*u1 - 16*s*t1**(-1)*mst12 - 2*s*t1*
     +    u1**(-1) - 16*s*u1**(-1)*mst12 - 4*s - 12*s**2*t1**(-1)*
     +    u1**(-1)*mst12 - 4*s**2*t1**(-1) - 4*s**2*u1**(-1) - 2*s**3*
     +    t1**(-1)*u1**(-1) - 16*t1**(-1)*u1**(-1)*mst12**3 - 4*
     +    t1**(-1)*u1*mst12 - 24*t1**(-1)*mst12**2 - 4*t1*u1**(-1)*
     +    mst12 - 24*u1**(-1)*mst12**2 - 12*mst12 )
     +
      M2ggh = M2ggh + ANG4(20)*N*CK * ( 8*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 - 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 - 2*s**(-1)*
     +    t1*u1**(-1) - 16*s**(-1)*u1**(-1)*s4**(-1)*mst12**2 - 4*
     +    s**(-1)*u1**(-1)*mst12 - 2*s**(-1)*u1*s4**(-1) - 4*s**(-1)*
     +    s4**(-1)*mst12 - 2*s**(-1) + 2*s*t1**(-1)*u1**(-1) + 4*
     +    t1**(-1)*u1**(-1)*mst12 + 2*t1**(-1)*u1*s4**(-1) + 4*t1**(-1)
     +    *s4**(-1)*mst12 + 2*t1**(-1) )
     +
      M2ggh = M2ggh + ANG4(20)*CQED * (  - 8*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 + 8*s**(-1)*
     +    u1**(-1)*s4**(-1)*mst12**2 - 2*s*t1**(-1)*u1**(-1) - 4*
     +    t1**(-1)*u1**(-1)*mst12 - 2*t1**(-1)*u1*s4**(-1) - 4*t1**(-1)
     +    *s4**(-1)*mst12 - 2*t1**(-1) - 2*u1**(-1) )
     +
      M2ggh = M2ggh + ANG4(21)*N*CK * ( 8*s**(-1)*t1**(-2)*u1*s4**(-1)*
     +    mst12**2 - 8*s**(-1)*t1**(-2)*mst12**2 + 8*s**(-1)*t1**(-1)*
     +    u1**(-1)*mst12**2 + 4*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12 - 2*
     +    s**(-1)*t1**(-1)*u1 - 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 - 
     +    8*s**(-1)*t1**(-1)*mst12 - 8*s**(-1)*u1**(-1)*s4**(-1)*
     +    mst12**2 + 2*s**(-1)*u1*s4**(-1) - 4*s**(-1) + 2*s*t1**(-1)*
     +    u1**(-1) + 8*t1**(-2)*s4**(-1)*mst12**2 + 4*t1**(-1)*u1**(-1)
     +    *mst12 + 4*t1**(-1)*s4**(-1)*mst12 + 2*t1*u1**(-1)*s4**(-1)
     +     + 4*u1**(-1)*s4**(-1)*mst12 + 2*u1**(-1) + 2*s4**(-1) )
     +
      M2ggh = M2ggh + ANG4(21)*CQED * (  - 8*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 + 8*s**(-1)*
     +    u1**(-1)*s4**(-1)*mst12**2 - 2*s*t1**(-1)*u1**(-1) - 4*
     +    t1**(-1)*u1**(-1)*mst12 - 2*t1**(-1) - 2*t1*u1**(-1)*s4**(-1)
     +     - 4*u1**(-1)*s4**(-1)*mst12 - 2*u1**(-1) )
     +
      M2ggh = M2ggh + ANG4(36)*N*CO * (  - 16*s**(-1)*mst12**2 - 4*
     +    mst12 )
     +
      M2ggh = M2ggh + ANG4(36)*N*CK * ( 16*s**(-1)*mst12**2 + 12*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(36)*CQED * (  - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(37)*N*CO * (  - 4*s**(-1)*t1 + 8*s**(-1)*u1*
     +    (t1+u1)**(-1)*mst12 + 4*s**(-1)*u1 - 8*s**(-1)*u1**2*
     +    (t1+u1)**(-1) - 16*s**(-1)*(t1+u1)**(-1)*mst12**2 - 16*
     +    s**(-1)*mst12 + 16*(t1+u1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(37)*N*CK * (  - 4*s**(-2)*t1**(-1)*u1**2*
     +    mst12 + 4*s**(-2)*t1**(-1)*u1**3*s4**(-1)*mst12 - 2*s**(-2)*
     +    t1**(-1)*u1**3 + 2*s**(-2)*t1**(-1)*u1**4*s4**(-1) + 4*
     +    s**(-2)*u1**2*s4**(-1)*mst12 + 2*s**(-2)*u1**3*s4**(-1) + 4*
     +    s**(-1)*t1**(-2)*u1**2*mst12 - 4*s**(-1)*t1**(-2)*u1**3*
     +    s4**(-1)*mst12 - 16*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12**2 + 4
     +    *s**(-1)*t1**(-1)*u1*mst12 - 8*s**(-1)*t1**(-1)*u1**2*
     +    s4**(-1)*mst12 + 2*s**(-1)*t1**(-1)*u1**3*s4**(-1) + 8*
     +    s**(-1)*t1**(-1)*mst12**2 - 4*s**(-1)*t1*u1**(-1)*mst12 - 8*
     +    s**(-1)*u1**(-1)*mst12**2 - 16*s**(-1)*u1*s4**(-1)*mst12 + 48
     +    *s**(-1)*s4**(-1)*mst12**2 + 16*s**(-1)*mst12 - 4*t1**(-2)*
     +    u1**2*s4**(-1)*mst12 - 4*t1**(-1)*u1*s4**(-1)*mst12 - 8*
     +    t1**(-1)*s4**(-1)*mst12**2 + 4*t1**(-1)*mst12 + 12*t1*
     +    u1**(-1)*s4**(-1)*mst12 - 4*t1*s4**(-1) + 2*t1**2*u1**(-1)*
     +    s4**(-1) + 16*u1**(-1)*s4**(-1)*mst12**2 - 2*u1*s4**(-1) - 32
     +    *s4**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(37)*CQED * ( 8*t1**(-1)*u1*s4**(-1)*mst12 + 
     +    2*t1**(-1)*u1**2*s4**(-1) + 8*t1**(-1)*s4**(-1)*mst12**2 - 4*
     +    t1**(-1)*mst12 + 8*t1*u1**(-1)*s4**(-1)*mst12 + 2*t1*s4**(-1)
     +     + 2*t1**2*u1**(-1)*s4**(-1) + 8*u1**(-1)*s4**(-1)*mst12**2
     +     - 4*u1**(-1)*mst12 + 2*u1*s4**(-1) + 8*s4**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(38)*N*CO * (  - 16*s**(-2)*u1**2*mst12 - 16*
     +    s**(-1)*u1*mst12 - 48*mst12 )
     +
      M2ggh = M2ggh + ANG4(39)*N*CO * (  - 16*s**(-2)*u1**2*s4**(-1)*
     +    mst12 - 8*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12**2 + 4*s**(-1)*
     +    t1**(-1)*u1*mst12 - 4*s**(-1)*t1**(-1)*u1**2*s4**(-1)*mst12
     +     + 4*s**(-1)*t1**(-1)*u1**2 - 2*s**(-1)*t1**(-1)*u1**3*
     +    s4**(-1) + 4*s**(-1)*t1*u1**(-1)*mst12 - 10*s**(-1)*t1 + 4*
     +    s**(-1)*t1**2*u1**(-1) - 20*s**(-1)*u1*s4**(-1)*mst12 + 8*
     +    s**(-1)*u1*(t1+u1)**(-1)*mst12 + 8*s**(-1)*u1 - 10*s**(-1)*
     +    u1**2*s4**(-1) - 8*s**(-1)*u1**2*(t1+u1)**(-1) + 8*s**(-1)*
     +    s4**(-1)*mst12**2 - 16*s**(-1)*(t1+u1)**(-1)*mst12**2 - 28*
     +    s**(-1)*mst12 + 4*t1**(-1)*u1*s4**(-1)*mst12 - 2*t1**(-1)*
     +    u1**2*s4**(-1) - 8*t1**(-1)*mst12 + 8*t1*u1**(-1)*s4**(-1)*
     +    mst12 + 4*t1*s4**(-1) + 8*u1**(-1)*s4**(-1)*mst12**2 - 12*
     +    u1**(-1)*mst12 - 4*u1*s4**(-1) - 8*s4**(-1)*mst12 + 16*
     +    (t1+u1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(40)*N*CO * (  - 8*u1**(-2)*mst12**3 - 8*
     +    u1**(-1)*mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(40)*N*CK * ( 24*u1**(-2)*mst12**3 + 24*
     +    u1**(-1)*mst12**2 + 12*mst12 )
     +
      M2ggh = M2ggh + ANG4(40)*CQED * (  - 8*u1**(-2)*mst12**3 - 8*
     +    u1**(-1)*mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(41)*N*CO * (  - 4 - 2*s*u1**(-1) - 2*t1*
     +    u1**(-1) - 8*u1**(-2)*mst12**2 - 8*u1**(-1)*(s+t1)**(-1)*
     +    mst12**2 - 8*u1**(-1)*mst12 - 4*u1*(s+t1)**(-1) - 8*
     +    (s+t1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(41)*N*CK * ( 16*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**3 - 16*s**(-1)*t1**(-1)*s4**(-1)*mst12**3 - 4*s**(-1)*
     +    t1*u1**(-1)*mst12 - 16*s**(-1)*u1**(-1)*s4**(-1)*mst12**3 - 8
     +    *s**(-1)*u1**(-1)*mst12**2 - 4*s**(-1)*u1*s4**(-1)*mst12 - 8*
     +    s**(-1)*s4**(-1)*mst12**2 - 4*s**(-1)*mst12 + 12*s*t1**(-1)*
     +    u1**(-1)*mst12 + 2*s*u1**(-1) + 2*s**2*t1**(-1)*u1**(-1) + 16
     +    *t1**(-1)*u1**(-1)*mst12**2 + 8*t1**(-1)*u1*s4**(-1)*mst12 - 
     +    4*t1**(-1)*u1 + 8*t1**(-1)*s4**(-1)*mst12**2 + 32*u1**(-2)*
     +    s4**(-1)*mst12**3 + 24*u1**(-2)*mst12**2 + 16*u1**(-1)*
     +    s4**(-1)*mst12**2 + 8*u1**(-1)*(s+t1)**(-1)*mst12**2 + 8*
     +    u1**(-1)*mst12 + 4*u1*s4**(-1) + 4*u1*(s+t1)**(-1) + 16*
     +    s4**(-1)*mst12 + 8*(s+t1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(41)*CQED * (  - 4 - 16*s**(-1)*t1**(-1)*
     +    u1**(-1)*mst12**3 + 16*s**(-1)*t1**(-1)*s4**(-1)*mst12**3 + 
     +    16*s**(-1)*u1**(-1)*s4**(-1)*mst12**3 - 16*s*t1**(-1)*
     +    u1**(-1)*mst12 - 6*s*t1**(-1) - 6*s*u1**(-1) - 4*s**2*
     +    t1**(-1)*u1**(-1) - 24*t1**(-1)*u1**(-1)*mst12**2 - 12*
     +    t1**(-1)*u1*s4**(-1)*mst12 - 2*t1**(-1)*u1 - 2*t1**(-1)*u1**2
     +    *s4**(-1) - 16*t1**(-1)*s4**(-1)*mst12**2 - 12*t1**(-1)*mst12
     +     - 2*t1*u1**(-1) - 16*u1**(-2)*s4**(-1)*mst12**3 - 8*u1**(-2)
     +    *mst12**2 - 8*u1**(-1)*s4**(-1)*mst12**2 - 12*u1**(-1)*mst12
     +     - 2*u1*s4**(-1) - 8*s4**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(43)*N*CO * (  - 8*t1**(-2)*mst12**3 - 8*
     +    t1**(-1)*mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(43)*N*CK * ( 24*t1**(-2)*mst12**3 + 24*
     +    t1**(-1)*mst12**2 + 12*mst12 )
     +
      M2ggh = M2ggh + ANG4(43)*CQED * (  - 8*t1**(-2)*mst12**3 - 8*
     +    t1**(-1)*mst12**2 - 4*mst12 )
     +
      M2ggh = M2ggh + ANG4(44)*N*CO * (  - 4 - 2*s*t1**(-1) - 8*
     +    t1**(-2)*mst12**2 - 2*t1**(-1)*u1 - 8*t1**(-1)*(s+u1)**(-1)*
     +    mst12**2 - 8*t1**(-1)*mst12 - 4*t1*(s+u1)**(-1) - 8*
     +    (s+u1)**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(44)*N*CK * ( 16*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**3 + 8*s**(-1)*t1**(-1)*u1*s4**(-1)*mst12**2 - 4*
     +    s**(-1)*t1**(-1)*u1*mst12 - 16*s**(-1)*t1**(-1)*s4**(-1)*
     +    mst12**3 - 16*s**(-1)*t1**(-1)*mst12**2 - 16*s**(-1)*u1**(-1)
     +    *s4**(-1)*mst12**3 + 4*s**(-1)*u1*s4**(-1)*mst12 - 8*s**(-1)*
     +    mst12 + 12*s*t1**(-1)*u1**(-1)*mst12 + 2*s*t1**(-1) + 2*s**2*
     +    t1**(-1)*u1**(-1) + 32*t1**(-2)*s4**(-1)*mst12**3 + 24*
     +    t1**(-2)*mst12**2 + 16*t1**(-1)*u1**(-1)*mst12**2 + 24*
     +    t1**(-1)*s4**(-1)*mst12**2 + 8*t1**(-1)*(s+u1)**(-1)*mst12**2
     +     + 8*t1**(-1)*mst12 + 8*t1*u1**(-1)*s4**(-1)*mst12 - 4*t1*
     +    u1**(-1) + 4*t1*s4**(-1) + 4*t1*(s+u1)**(-1) + 8*u1**(-1)*
     +    s4**(-1)*mst12**2 + 20*s4**(-1)*mst12 + 8*(s+u1)**(-1)*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(44)*CQED * (  - 4 - 16*s**(-1)*t1**(-1)*
     +    u1**(-1)*mst12**3 + 16*s**(-1)*t1**(-1)*s4**(-1)*mst12**3 + 
     +    16*s**(-1)*u1**(-1)*s4**(-1)*mst12**3 - 16*s*t1**(-1)*
     +    u1**(-1)*mst12 - 6*s*t1**(-1) - 6*s*u1**(-1) - 4*s**2*
     +    t1**(-1)*u1**(-1) - 16*t1**(-2)*s4**(-1)*mst12**3 - 8*
     +    t1**(-2)*mst12**2 - 24*t1**(-1)*u1**(-1)*mst12**2 - 2*
     +    t1**(-1)*u1 - 8*t1**(-1)*s4**(-1)*mst12**2 - 12*t1**(-1)*
     +    mst12 - 12*t1*u1**(-1)*s4**(-1)*mst12 - 2*t1*u1**(-1) - 2*t1*
     +    s4**(-1) - 2*t1**2*u1**(-1)*s4**(-1) - 16*u1**(-1)*s4**(-1)*
     +    mst12**2 - 12*u1**(-1)*mst12 - 8*s4**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(48)*N*CO * (  - 8*s**(-1)*t1**(-1)*u1**3 - 
     +    24*s**(-1)*t1*u1 - 16*s**(-1)*t1**2 - 8*s**(-1)*t1**3*
     +    u1**(-1) - 16*s**(-1)*u1**2 - 6*s*t1**(-1)*u1 - 8*s*t1**(-1)*
     +    (s+u1)**(-1)*mst12**2 - 6*s*t1*u1**(-1) - 2*s*t1*(s+u1)**(-1)
     +     - 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 - 2*s*u1*(s+t1)**(-1)
     +     - 4*s*(s+t1)**(-1)*mst12 - 4*s*(s+u1)**(-1)*mst12 - 16*s - 2
     +    *s**2*t1**(-1) - 2*s**2*u1**(-1) - 4*t1**(-1)*u1*mst12 - 8*
     +    t1**(-1)*u1**2 + 4*t1**(-1)*u1**3*(s+t1)**(-1) - 4*t1*
     +    u1**(-1)*mst12 - 4*t1*(s+u1)**(-1)*mst12 - 28*t1 - 8*t1**2*
     +    u1**(-1) - 4*t1**2*(s+u1)**(-1) + 4*t1**3*u1**(-1)*
     +    (s+u1)**(-1) - 4*u1*(s+t1)**(-1)*mst12 - 28*u1 - 4*u1**2*
     +    (s+t1)**(-1) )
     +
      M2ggh = M2ggh + ANG4(49)*N*CO * (  - 8*s**(-1)*t1**(-1)*u1*
     +    mst12**2 + 2*s**(-1)*t1*u1 - 2*s**(-1)*t1**2 - 4*s**(-1)*u1*
     +    mst12 - 4*s**(-1)*u1**2 + 4*s**(-1)*u1**3*(t1+u1)**(-1) - 8*
     +    s**(-1)*mst12**2 - 8*s*t1**(-1)*u1**(-1)*mst12**2 + 8*s*
     +    u1**(-1)*(t1+u1)**(-1)*mst12**2 + 2*s*u1*(t1+u1)**(-1) - 4*s*
     +    (t1+u1)**(-1)*mst12 - 2*s - 8*t1**(-1)*mst12**2 - 4*t1 + 4*u1
     +    *(t1+u1)**(-1)*mst12 + 4*u1 - 4*u1**2*(t1+u1)**(-1) - 4*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(49)*N*CK * ( 8*s*t1**(-1)*u1**(-1)*mst12**2
     +     + 2*s*t1*u1**(-1) - 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 + 4*s
     +    *u1**(-1)*mst12 - 2*s*u1*(s+t1)**(-1) - 4*s*(s+t1)**(-1)*
     +    mst12 + 8*t1**(-1)*u1*(s+t1)**(-1)*mst12**2 + 8*t1**(-1)*
     +    mst12**2 + 2*t1**2*u1**(-1) + 8*u1**(-1)*mst12**2 + 4*u1*
     +    (s+t1)**(-1)*mst12 + 2*u1 + 8*(s+t1)**(-1)*mst12**2 + 4*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(50)*N*CO * (  - 8*s**(-1)*t1*u1**(-1)*
     +    mst12**2 - 2*s**(-1)*t1*u1 - 4*s**(-1)*t1*mst12 + 2*s**(-1)*
     +    u1**2 - 4*s**(-1)*u1**3*(t1+u1)**(-1) - 8*s**(-1)*mst12**2 - 
     +    8*s*u1**(-1)*(t1+u1)**(-1)*mst12**2 - 2*s*u1*(t1+u1)**(-1) - 
     +    4*s*(t1+u1)**(-1)*mst12 - 8*u1**(-1)*mst12**2 - 4*u1*
     +    (t1+u1)**(-1)*mst12 - 4*u1**2*(t1+u1)**(-1) )
     +
      M2ggh = M2ggh + ANG4(50)*N*CK * ( 8*s*t1**(-1)*u1**(-1)*mst12**2
     +     + 2*s*t1**(-1)*u1 - 8*s*t1**(-1)*(s+u1)**(-1)*mst12**2 + 4*s
     +    *t1**(-1)*mst12 - 2*s*t1*(s+u1)**(-1) - 4*s*(s+u1)**(-1)*
     +    mst12 + 2*t1**(-1)*u1**2 + 8*t1**(-1)*mst12**2 + 8*t1*
     +    u1**(-1)*(s+u1)**(-1)*mst12**2 + 4*t1*(s+u1)**(-1)*mst12 + 2*
     +    t1 + 8*u1**(-1)*mst12**2 + 8*(s+u1)**(-1)*mst12**2 + 4*mst12
     +     )
     +
      M2ggh = M2ggh + ANG4(51)*N*CO * (  - 16*s**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(52)*N*CO * (  - 16*s*mst12 )
     +
      M2ggh = M2ggh + ANG4(53)*N*CO * (  - 32*s*t1*u1**(-1)*mst12 - 16*
     +    s**2*u1**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(54)*N*CO * ( 8*s**(-1)*t1**(-1)*u1**3 + 40*
     +    s**(-1)*t1*u1 + 24*s**(-1)*t1**2 + 16*s**(-1)*t1**3*u1**(-1)
     +     + 16*s**(-1)*u1**2 + 4*s**(-1)*u1**3*s4**(-1) + 4*s**(-1)*
     +    u1**3*(t1+u1)**(-1) + 8*s*t1**(-1)*u1**(-1)*mst12**2 + 2*s*
     +    t1**(-1)*u1 - 4*s*t1**(-1)*mst12 - 16*s*t1*u1**(-2)*mst12 + 8
     +    *s*t1*u1**(-1) + 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 + 8*s*
     +    u1**(-1)*(t1+u1)**(-1)*mst12**2 - 24*s*u1**(-1)*mst12 + 2*s*
     +    u1*(s+t1)**(-1) + 2*s*u1*(t1+u1)**(-1) + 4*s*(s+t1)**(-1)*
     +    mst12 - 4*s*(t1+u1)**(-1)*mst12 + 4*s - 4*t1**(-1)*u1*mst12
     +     + 4*t1**(-1)*u1**2 - 4*t1**(-1)*u1**3*(s+t1)**(-1) - 8*t1*
     +    u1**(-1)*s4**(-1)*mst12**2 - 16*t1*u1**(-1)*mst12 - 2*t1*u1*
     +    s4**(-1) - 4*t1*s4**(-1)*mst12 + 24*t1 + 24*t1**2*u1**(-1) + 
     +    8*u1**(-1)*mst12**2 - 4*u1*(s+t1)**(-1)*mst12 + 4*u1*
     +    (t1+u1)**(-1)*mst12 + 22*u1 + 2*u1**2*s4**(-1) - 4*u1**2*
     +    (s+t1)**(-1) - 4*u1**2*(t1+u1)**(-1) - 8*s4**(-1)*mst12**2 - 
     +    44*mst12 )
     +
      M2ggh = M2ggh + ANG4(55)*N*CO * (  - 16*s**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(56)*N*CO * (  - 16*s*mst12 )
     +
      M2ggh = M2ggh + ANG4(57)*N*CO * (  - 32*s*t1**(-1)*u1*mst12 - 16*
     +    s**2*t1**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(58)*N*CO * ( 16*s**(-1)*t1**(-1)*u1**3 + 32*
     +    s**(-1)*t1*u1 + 24*s**(-1)*t1**2 + 8*s**(-1)*t1**3*u1**(-1)
     +     + 32*s**(-1)*u1**2 - 4*s**(-1)*u1**3*s4**(-1) - 4*s**(-1)*
     +    u1**3*(t1+u1)**(-1) - 16*s*t1**(-2)*u1*mst12 + 16*s*t1**(-1)*
     +    u1**(-1)*mst12**2 + 8*s*t1**(-1)*u1 + 8*s*t1**(-1)*
     +    (s+u1)**(-1)*mst12**2 - 24*s*t1**(-1)*mst12 + 2*s*t1*u1**(-1)
     +     + 2*s*t1*(s+u1)**(-1) - 8*s*u1**(-1)*(t1+u1)**(-1)*mst12**2
     +     - 4*s*u1**(-1)*mst12 - 2*s*u1*(t1+u1)**(-1) + 4*s*
     +    (s+u1)**(-1)*mst12 - 4*s*(t1+u1)**(-1)*mst12 + 6*s - 8*
     +    t1**(-1)*u1*s4**(-1)*mst12**2 - 16*t1**(-1)*u1*mst12 + 24*
     +    t1**(-1)*u1**2 + 8*t1**(-1)*mst12**2 - 4*t1*u1**(-1)*mst12 + 
     +    2*t1*u1*s4**(-1) - 4*t1*(s+u1)**(-1)*mst12 + 18*t1 + 4*t1**2*
     +    u1**(-1) - 2*t1**2*s4**(-1) - 4*t1**2*(s+u1)**(-1) - 4*t1**3*
     +    u1**(-1)*(s+u1)**(-1) - 4*u1*s4**(-1)*mst12 - 4*u1*
     +    (t1+u1)**(-1)*mst12 + 28*u1 - 4*u1**2*s4**(-1) - 4*u1**2*
     +    (t1+u1)**(-1) )
     +
      M2ggh = M2ggh + ANG4(58)*N*CO * (  - 8*s4**(-1)*mst12**2 - 40*
     +    mst12 )
     +
      M2ggh = M2ggh + ANG4(59)*N*CO * (  - 8*t1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(59)*N*CK * ( 8*t1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(60)*N*CO * (  - 8*t1*mst12 - 16*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(60)*N*CK * ( 8*t1*mst12 + 16*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(61)*N*CO * (  - 16*s*t1*u1**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(61)*N*CK * ( 16*s*t1*u1**(-1)*mst12 + 16*
     +    t1**2*u1**(-1)*mst12 )
     +
      M2ggh = M2ggh + ANG4(62)*N*CO * ( 8*s**(-1)*t1**(-1)*u1*mst12**2
     +     + 2*s**(-1)*t1*u1 - 4*s**(-1)*t1*mst12 + 4*s**(-1)*t1**2 + 4
     +    *s**(-1)*t1**3*u1**(-1) - 4*s**(-1)*u1*mst12 + 16*s*t1**(-1)*
     +    u1**(-1)*mst12**2 - 8*s*t1**(-1)*(s+u1)**(-1)*mst12**2 - 16*s
     +    *t1*u1**(-2)*mst12 + 8*s*t1*u1**(-1) - 2*s*t1*(s+u1)**(-1) - 
     +    8*s*u1**(-1)*mst12 - 4*s*(s+u1)**(-1)*mst12 + 16*t1**(-1)*
     +    mst12**2 - 8*t1*u1**(-1)*mst12 - 4*t1*(s+u1)**(-1)*mst12 + 6*
     +    t1 + 16*t1**2*u1**(-1) - 4*t1**2*(s+u1)**(-1) + 4*t1**3*
     +    u1**(-1)*(s+u1)**(-1) - 20*mst12 )
     +
      M2ggh = M2ggh + ANG4(62)*N*CK * (  - 16*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 8*s*t1*u1**(-1) + 8*s*u1**(-1)*(s+t1)**(-1)*
     +    mst12**2 + 8*s*u1**(-1)*mst12 + 2*s*u1*(s+t1)**(-1) + 4*s*
     +    (s+t1)**(-1)*mst12 - 8*t1**(-1)*u1*s4**(-1)*mst12**2 - 8*
     +    t1**(-1)*u1*(s+t1)**(-1)*mst12**2 - 8*t1**(-1)*mst12**2 - 8*
     +    t1*u1**(-1)*s4**(-1)*mst12**2 + 16*t1*u1**(-1)*mst12 - 2*t1*
     +    u1*s4**(-1) - 4*t1*s4**(-1)*mst12 - 4*t1 - 8*t1**2*u1**(-1)
     +     + 40*u1**(-1)*mst12**2 - 4*u1*s4**(-1)*mst12 + 4*u1*
     +    (s+t1)**(-1)*mst12 - 2*u1 - 8*s4**(-1)*mst12**2 + 8*
     +    (s+t1)**(-1)*mst12**2 + 20*mst12 )
     +
      M2ggh = M2ggh + ANG4(63)*N*CO * (  - 2*s**(-1)*t1*u1**(-1) - 8*
     +    s**(-1)*u1**(-1)*s4**(-1)*mst12**2 - 4*s**(-1)*u1**(-1)*mst12
     +     - 2*s**(-1)*u1*s4**(-1) - 4*s**(-1)*s4**(-1)*mst12 - 2*
     +    s**(-1) - 2*u1**(-1) )
     +
      M2ggh = M2ggh + ANG4(63)*N*CK * (  - 8*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 + 8*s**(-1)*
     +    u1**(-1)*s4**(-1)*mst12**2 - 2*s*t1**(-1)*u1**(-1) - 4*
     +    t1**(-1)*u1**(-1)*mst12 - 2*t1**(-1)*u1*s4**(-1) - 4*t1**(-1)
     +    *s4**(-1)*mst12 - 2*t1**(-1) - 2*u1**(-1) )
     +
      M2ggh = M2ggh + ANG4(64)*N*CO * (  - 8*u1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(64)*N*CK * ( 8*u1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(65)*N*CO * (  - 8*u1*mst12 - 16*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(65)*N*CK * ( 8*u1*mst12 + 16*mst12**2 )
     +
      M2ggh = M2ggh + ANG4(66)*N*CO * (  - 16*s*t1**(-1)*u1*mst12 )
     +
      M2ggh = M2ggh + ANG4(66)*N*CK * ( 16*s*t1**(-1)*u1*mst12 + 16*
     +    t1**(-1)*u1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(67)*N*CO * ( 4*s**(-1)*t1**(-1)*u1**3 + 8*
     +    s**(-1)*t1*u1**(-1)*mst12**2 + 2*s**(-1)*t1*u1 - 4*s**(-1)*t1
     +    *mst12 - 4*s**(-1)*u1*mst12 + 4*s**(-1)*u1**2 - 16*s*t1**(-2)
     +    *u1*mst12 + 16*s*t1**(-1)*u1**(-1)*mst12**2 + 8*s*t1**(-1)*u1
     +     - 8*s*t1**(-1)*mst12 - 8*s*u1**(-1)*(s+t1)**(-1)*mst12**2 - 
     +    2*s*u1*(s+t1)**(-1) - 4*s*(s+t1)**(-1)*mst12 - 8*t1**(-1)*u1*
     +    mst12 + 16*t1**(-1)*u1**2 + 4*t1**(-1)*u1**3*(s+t1)**(-1) + 
     +    16*u1**(-1)*mst12**2 - 4*u1*(s+t1)**(-1)*mst12 + 6*u1 - 4*
     +    u1**2*(s+t1)**(-1) - 20*mst12 )
     +
      M2ggh = M2ggh + ANG4(67)*N*CK * (  - 16*s*t1**(-1)*u1**(-1)*
     +    mst12**2 - 8*s*t1**(-1)*u1 + 8*s*t1**(-1)*(s+u1)**(-1)*
     +    mst12**2 + 8*s*t1**(-1)*mst12 + 2*s*t1*(s+u1)**(-1) + 4*s*
     +    (s+u1)**(-1)*mst12 - 8*t1**(-1)*u1*s4**(-1)*mst12**2 + 16*
     +    t1**(-1)*u1*mst12 - 8*t1**(-1)*u1**2 + 40*t1**(-1)*mst12**2
     +     - 8*t1*u1**(-1)*s4**(-1)*mst12**2 - 8*t1*u1**(-1)*
     +    (s+u1)**(-1)*mst12**2 - 2*t1*u1*s4**(-1) - 4*t1*s4**(-1)*
     +    mst12 + 4*t1*(s+u1)**(-1)*mst12 - 2*t1 - 8*u1**(-1)*mst12**2
     +     - 4*u1*s4**(-1)*mst12 - 4*u1 - 8*s4**(-1)*mst12**2 + 8*
     +    (s+u1)**(-1)*mst12**2 + 20*mst12 )
     +
      M2ggh = M2ggh + ANG4(68)*N*CO * (  - 4*s**(-1)*t1**(-1)*u1*
     +    s4**(-1)*mst12 - 2*s**(-1)*t1**(-1)*u1 - 8*s**(-1)*t1**(-1)*
     +    s4**(-1)*mst12**2 + 2*s**(-1)*u1*s4**(-1) - 8*s**(-1)*
     +    s4**(-1)*mst12 - 4*s**(-1) - 4*t1**(-1)*s4**(-1)*mst12 - 2*
     +    t1**(-1) + 2*s4**(-1) )
     +
      M2ggh = M2ggh + ANG4(68)*N*CK * (  - 8*s**(-1)*t1**(-1)*u1**(-1)*
     +    mst12**2 + 8*s**(-1)*t1**(-1)*s4**(-1)*mst12**2 + 8*s**(-1)*
     +    u1**(-1)*s4**(-1)*mst12**2 - 2*s*t1**(-1)*u1**(-1) - 4*
     +    t1**(-1)*u1**(-1)*mst12 - 2*t1**(-1) - 2*t1*u1**(-1)*s4**(-1)
     +     - 4*u1**(-1)*s4**(-1)*mst12 - 2*u1**(-1) )
     +
      M2ggh = M2ggh + ANG4(70)*N*CO * (  - 16*s*t1*u1**(-2)*mst12 - 8*
     +    s**2*u1**(-2)*mst12 - 8*t1**2*u1**(-2)*mst12 )
     +
      M2ggh = M2ggh + ANG4(70)*N*CK * ( 16*s*t1*u1**(-2)*mst12 + 8*s**2
     +    *u1**(-2)*mst12 + 8*t1**2*u1**(-2)*mst12 )
     +
      M2ggh = M2ggh + ANG4(71)*N*CO * (  - 16*s*t1**(-2)*u1*mst12 - 8*
     +    s**2*t1**(-2)*mst12 - 8*t1**(-2)*u1**2*mst12 )
     +
      M2ggh = M2ggh + ANG4(71)*N*CK * ( 16*s*t1**(-2)*u1*mst12 + 8*s**2
     +    *t1**(-2)*mst12 + 8*t1**(-2)*u1**2*mst12 )

      DSTGGH = S4/(S4+MST12)/2.D0 *
     +     ALPHAS**3 * AVG * M2GGH /4.D0 /S**2 *CONV
      RETURN
      END


      REAL*8 FUNCTION DSTGGD(ALPHAS,S,T1,S4,MST1,MG,DEL,S4MAX)
C***  LOG(DEL) PART OF CROSS SECTIONS FOR G +G -> ST + STB +G 
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,SB,MST1,MG,MST12
      REAL*8 M2GGD,CO,CK,CQED
      REAL*8 NS,CONV,N,AVG,BETA,XS,DEL,S4MAX,DLDEL1,DLDEL2
      REAL*8 COLO1(1:9)

      NS = 6.D0
      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2-1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2

      MST12 = MST1**2
      BETA = SQRT(1 -4*MST12/S)
      SB = S*BETA
      XS = (1.D0 -BETA)/(1.D0 +BETA)

      DLDEL1 = 
     +     LOG(S4MAX/MST12) -(S4MAX-DEL)/S4
      DLDEL2 = 
     +     LOG(S4MAX/MST12)**2 -2.D0*(S4MAX -DEL)/S4*LOG(S4/MST12)

      COLO1(1) = LOG(XS)
      COLO1(3) = LOG(S/MST12)
      COLO1(4) = LOG(-T1/MST12)
      COLO1(8) = LOG((S+T1)/MST12)

      M2GGD = 0D0
     +  + N*CO*dldel1 * (  - 8.D+0 - 1.6D+1*s**(-2)*t1**2 - 1.6D+1*
     +    s**(-1)*t1 - 3.2D+1*s**(-1)*mst12 - 1.6D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*mst12 - 1.6D+1*s**2*t1**(-2)*(s+t1)**(-2)*
     +    mst12**2 - 3.2D+1*t1**(-1)*(s+t1)**(-1)*mst12**2 )
      M2GGD = M2GGD + N*CO*dldel2 * ( 1.6D+1 + 3.2D+1*s**(-2)*t1**2 + 
     +    3.2D+1*s**(-1)*t1 + 6.4D+1*s**(-1)*mst12 + 3.2D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*mst12 + 3.2D+1*s**2*t1**(-2)*(s+t1)**(-2)*
     +    mst12**2 + 6.4D+1*t1**(-1)*(s+t1)**(-1)*mst12**2 )
      M2GGD = M2GGD + N*CK*dldel1 * ( 2.4D+1 + 1.6D+1*s**(-2)*t1**2 + 
     +    1.6D+1*s**(-1)*t1 + 3.2D+1*s**(-1)*mst12 + 4.8D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*mst12 + 4.8D+1*s**2*t1**(-2)*(s+t1)**(-2)*
     +    mst12**2 + 3.2D+1*t1**(-1)*(s+t1)**(-1)*mst12**2 )
      M2GGD = M2GGD + N*CK*dldel2 * (  - 1.6D+1 - 3.2D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*mst12 - 3.2D+1*s**2*t1**(-2)*(s+t1)**(-2)*
     +    mst12**2 )
      M2GGD = M2GGD + CQED*dldel1 * (  - 8.D+0 - 1.6D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*mst12 - 1.6D+1*s**2*t1**(-2)*(s+t1)**(-2)*
     +    mst12**2 )
      M2GGD = M2GGD + COLO1(1)*N*CK*dldel1 * (  - 3.2D+1*s**(-2)*t1**2*
     +    sb**(-1)*mst12 - 3.2D+1*s**(-1)*t1*sb**(-1)*mst12 + 1.6D+1*
     +    s**(-1)*t1**2*sb**(-1) - 6.4D+1*s**(-1)*sb**(-1)*mst12**2 + 
     +    8.D+0*s*sb**(-1) - 3.2D+1*s**2*t1**(-2)*(s+t1)**(-2)*sb**(-1)
     +    *mst12**3 + 1.6D+1*s**2*t1**(-1)*(s+t1)**(-1)*sb**(-1)*mst12
     +     + 1.6D+1*s**3*t1**(-2)*(s+t1)**(-2)*sb**(-1)*mst12**2 - 
     +    6.4D+1*t1**(-1)*(s+t1)**(-1)*sb**(-1)*mst12**3 + 1.6D+1*t1*
     +    sb**(-1) + 1.6D+1*sb**(-1)*mst12 )
      M2GGD = M2GGD + COLO1(1)*CQED*dldel1 * ( 3.2D+1*s*t1**(-1)*
     +    (s+t1)**(-1)*sb**(-1)*mst12**2 - 8.D+0*s*sb**(-1) + 3.2D+1*
     +    s**2*t1**(-2)*(s+t1)**(-2)*sb**(-1)*mst12**3 - 1.6D+1*s**2*
     +    t1**(-1)*(s+t1)**(-1)*sb**(-1)*mst12 - 1.6D+1*s**3*t1**(-2)*
     +    (s+t1)**(-2)*sb**(-1)*mst12**2 + 1.6D+1*sb**(-1)*mst12 )
      M2GGD = M2GGD + COLO1(3)*N*CO*dldel1 * ( 8.D+0 + 1.6D+1*s**(-2)*
     +    t1**2 + 1.6D+1*s**(-1)*t1 + 3.2D+1*s**(-1)*mst12 + 1.6D+1*s*
     +    t1**(-1)*(s+t1)**(-1)*mst12 + 1.6D+1*s**2*t1**(-2)*
     +    (s+t1)**(-2)*mst12**2 + 3.2D+1*t1**(-1)*(s+t1)**(-1)*mst12**2
     +     )
      M2GGD = M2GGD + COLO1(4)*N*CO*dldel1 * (  - 1.6D+1*s**(-2)*t1**2
     +     - 3.2D+1*s**(-1)*mst12 - 3.2D+1*s*t1**(-1)*(s+t1)**(-1)*
     +    mst12 + 3.2D+1*t1**(-1)*mst12 - 3.2D+1*(s+t1)**(-2)*mst12**2
     +     )
      M2GGD = M2GGD + COLO1(8)*N*CO*dldel1 * (  - 1.6D+1 - 1.6D+1*
     +    s**(-2)*t1**2 - 3.2D+1*s**(-1)*t1 - 3.2D+1*s**(-1)*mst12 - 
     +    3.2D+1*s**2*t1**(-2)*(s+t1)**(-2)*mst12**2 - 6.4D+1*t1**(-1)*
     +    (s+t1)**(-1)*mst12**2 - 3.2D+1*t1**(-1)*mst12 + 3.2D+1*
     +    (s+t1)**(-2)*mst12**2 )

      DSTGGD = ALPHAS**3 * AVG * M2GGD /4.D0 /S**2 *CONV
      RETURN
      END



      REAL*8 FUNCTION DSTQB1(ALPHAS,S,T1,MST1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF VIRTUAL
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,MST1,MG,SCA,PI,BETAL,PQQ,DSTQBB,NF
      PI = 4.D0*ATAN(1.D0)
      NF = 5.D0
      U1 = -S -T1
      BETAL = -11.D0 + 2.D0/3.D0*NF
      PQQ = 4.D0/3.D0*
     +     (-2.D0*LOG(-T1/MST1**2) -2*LOG(-U1/MST1**2) +3.D0)
      DSTQB1 = DSTQBB(ALPHAS,S,T1,MST1,MG)*
     +     ALPHAS/2.D0/PI*LOG(1.D0/SCA)*( BETAL +PQQ)
      RETURN
      END


      REAL*8 FUNCTION DSTQB2(ALPHAS,S,T1,S4,MST1,MG,DEL,S4MAX,SCA)
C***  GIVES THE SCALE DEPENDENCE OF LOG(DEL)
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,S4,S4MAX,MST1,MG,SCA,PI,DSTQBB,DLDEL1,DEL
      PI = 4.D0*ATAN(1.D0)
      DLDEL1 = LOG(S4MAX/MST1**2) -(S4MAX -DEL)/S4
      DSTQB2 = 16.D0/3.D0*DLDEL1*DSTQBB(ALPHAS,S,T1,MST1,MG)
     +     * ALPHAS/2.D0/PI*LOG(1.D0/SCA)
      RETURN
      END


      REAL*8 FUNCTION DSTQB3(ALPHAS,S,T1,S4,MST1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,S4,MST1,MG,PI
      REAL*8 DSTQBB,PQQ1,PQQ2,SCA,X1,X2
      PI = 4.D0*ATAN(1.D0)
      U1 = S4 -S -T1
      X1 = -U1/(S+T1)
      X2 = -T1/(S+U1)
      PQQ1 = 4.D0/3.D0*(1.D0 +X1**2)/(1.D0 -X1)
      PQQ2 = 4.D0/3.D0*(1.D0 +X2**2)/(1.D0 -X2)
      DSTQB3 = ALPHAS/2.D0/PI*LOG(1.D0/SCA) *
     +     (-1/U1*DSTQBB(ALPHAS,X1*S,X1*T1,MST1,MG)*PQQ1*X1**2
     +      -1/T1*DSTQBB(ALPHAS,X2*S,T1,MST1,MG)*PQQ2*X2**2 )
      RETURN
      END


      REAL*8 FUNCTION DSTQBB(ALPHAS,S,T1,MST1,MG)
C***  BORN CROSS SECTIONS FOR Q + QB -> ST + STB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,MST1,MG,MST12
      REAL*8 M2QBB1
      REAL*8 CONV,PI,N,CF,AVG
      CONV = 389379660.D0
      PI = 4.D0*ATAN(1.D0)
      N = 3.D0
      CF = (N**2 -1.D0)/N/2.D0
      AVG = (1.D0/2.D0)**2 /N**2
      MST12 = MST1**2
      M2QBB1 = N*CF*4.D0/S**2*(T1*(-S-T1) -MST12*S)
      DSTQBB = ALPHAS**2*AVG*M2QBB1 *PI/S**2 *CONV
      RETURN
      END


      REAL*8 FUNCTION DSTQBV(ALPHAS,S,T1,MSt1,MG,MT,ms,mst2,sin2t)
C***  CROSS SECTIONS FOR Q + QB -> ST + STB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T,T1,U,U1,SB,S1,MS,MG,MT,MS2,MG2,MT2
      Real*8 mst1,mst2,mst12,mst22
      REAL*8 sin2t
      REAL*8 NF,CONV,PI,ZETA2,N,CF,AVG,BETA,XS,SPENCE
      REAL*8 SK3B0A(1:5), SK3B0B(1:6), SK3B0C(1:2), SK3B0D(1:2,1:2)
      REAL*8 SK3BP(1:3), SK3C0A(1:8), SK3C0B(1:4)
      REAL*8 SK3C0C(1:5,1:2), SK3D0(1:7,1:2)
      REAL*8 SL3B0A, SL3B0B, SL3B0C, SL3B0D
      REAL*8 SL3BP, SL3C0A, SL3C0B
      REAL*8 SL3C0C, SL3D0
      REAL*8 SOF1(1:8)
      REAL*8 M2QBV1,DSTQBB

      PI = 4.D0*ATAN(1.D0)
      ZETA2 = PI**2/6.D0
      CONV = 389379660.D0

      NF = 5.D0
      N = 3.D0
      CF = (N**2-1.D0)/N/2.D0
      AVG = (1.D0/2.D0)**2 /N**2

      MST12 = MST1**2
      MG2 = MG**2
      MT2 = MT**2
      MST22 = MST2**2
      MS2 = MS**2

      S1 = 4.D0*MST12 - S
      U1 = -S -T1
      T = T1 +MST12
      U = U1 +MST12

      BETA = SQRT(1.D0 - 4.D0*MST12/S)
      XS = (1.D0 -BETA)*(1.D0+BETA)**(-1)
      SB = S*BETA

      SK3B0A(1) = SL3B0A(MST12,mg2,mg2,1)
      SK3B0A(2) = SL3B0A(MST12,mt2,mt2,1)
      SK3B0A(3) = SL3B0A(MST12,mg2,ms2,2)
      SK3B0A(4) = SL3B0A(MST12,ms2,ms2,1)
      SK3B0A(5) = SL3B0A(MST12,mst22,mst22,1)

      SK3B0B(1) = SL3B0B(S,MST12,0D0,1)
      SK3B0B(2) = SL3B0B(S,MST12,MST12,2)
      SK3B0B(3) = SL3B0B(S,MST12,MG2,2)
      SK3B0B(4) = SL3B0B(S,MST12,MT2,2)
      SK3B0B(5) = SL3B0B(S,MST12,MS2,2)
      SK3B0B(6) = SL3B0B(S,MST12,MST22,2)

      SK3B0C(1) = SL3B0C(MST12,0D0,0D0,1)
      SK3B0C(2) = SL3B0C(MST12,MG2,MT2,2)

      SK3B0D(1,1) = SL3B0D(T,MST12,0D0,0D0,1)
      SK3B0D(2,1) = SL3B0D(T,MST12,MG2,MT2,2)

      SK3B0D(1,2) = SL3B0D(U,MST12,0D0,0D0,1)
      SK3B0D(2,2) = SL3B0D(U,MST12,MG2,MT2,2)

      SK3BP(1) = SL3BP(MST12,0D0,0D0,1)
      SK3BP(2) = SL3BP(MST12,Mg2,Mt2,2)
      SK3BP(3) = SL3BP(MST12,Mg2,ms2,3)

      SK3C0A(1) = SL3C0A(S,MST12,0D0,0D0,1)
c$$$      SK3C0A(2) = SL3C0A(S,MST12,mst12,mst12,2)
c$$$      SK3C0A(3) = SL3C0A(S,MST12,mg2,mg2,2)
c$$$      SK3C0A(4) = SL3C0A(S,MST12,mt2,mt2,2)
      SK3C0A(5) = SL3C0A(S,MST12,ms2,mg2,3)
      SK3C0A(6) = SL3C0A(S,MST12,mg2,ms2,3)
c$$$      SK3C0A(7) = SL3C0A(S,MST12,ms2,ms2,2)
c$$$      SK3C0A(8) = SL3C0A(S,MST12,mst22,mst22,2)

      SK3C0B(1) = SL3C0B(S,MST12,0D0,0D0,1)
      SK3C0B(2) = SL3C0B(S,MST12,mst12,mst12,2)
      SK3C0B(3) = SL3C0B(S,MST12,mt2,mg2,3)
      SK3C0B(4) = SL3C0B(S,MST12,mg2,mt2,3)

      SK3C0C(1,1) = SL3C0C(T,MST12,0D0,0D0,0D0,1)
      SK3C0C(2,1) = SL3C0C(T,MST12,MS2,MG2,MT2,2)
c$$$      SK3C0C(3,1) = SL3C0C(T,MST12,0D0,0D0,0D0,3)
c$$$      SK3C0C(4,1) = SL3C0C(T,MST12,Mg2,MG2,MT2,2)
c$$$      SK3C0C(5,1) = SL3C0C(T,MST12,Mt2,Mt2,Mg2,2)

      SK3C0C(1,2) = SL3C0C(U,MST12,0D0,0D0,0D0,1)
      SK3C0C(2,2) = SL3C0C(U,MST12,MS2,MG2,MT2,2)
c$$$      SK3C0C(3,2) = SL3C0C(U,MST12,0D0,0D0,0D0,3)
c$$$      SK3C0C(4,2) = SL3C0C(U,MST12,Mg2,MG2,MT2,2)
c$$$      SK3C0C(5,2) = SL3C0C(U,MST12,Mt2,Mt2,Mg2,2)

      SK3D0(1,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,1)
c$$$      SK3D0(2,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,2)
c$$$      SK3D0(3,1) = SL3D0(S,T,U,MST12,0D0,0D0,0D0,3)
c$$$      SK3D0(4,1) = SL3D0(S,T,U,MST12,mg2,mt2,0D0,4)
c$$$      SK3D0(5,1) = SL3D0(S,T,U,MST12,mt2,mg2,0D0,4)
c$$$      SK3D0(6,1) = SL3D0(S,T,U,MST12,mg2,mt2,0D0,5)
      SK3D0(7,1) = SL3D0(S,T,U,MST12,mt2,mg2,ms2,6)

      SK3D0(1,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,1)
c$$$      SK3D0(2,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,2)
c$$$      SK3D0(3,2) = SL3D0(S,U,T,MST12,0D0,0D0,0D0,3)
c$$$      SK3D0(4,2) = SL3D0(S,U,T,MST12,mg2,mt2,0D0,4)
c$$$      SK3D0(5,2) = SL3D0(S,U,T,MST12,mt2,mg2,0D0,4)
c$$$      SK3D0(6,2) = SL3D0(S,U,T,MST12,mg2,mt2,0D0,5)
      SK3D0(7,2) = SL3D0(S,U,T,MST12,mt2,mg2,ms2,6)


      SOF1(1) = 0.125D0/SB * ( +4*SPENCE(XS) +4*SPENCE(-XS) 
     +     +4*LOG(XS)*LOG(1-XS**2)-2*LOG(XS)**2 -2*ZETA2 )
      SOF1(2) = 0.125D0/MST12* (+2*(S -2*MST12)/SB*LOG(XS))
      SOF1(3) = 0.125D0/MST12*(-2)
      SOF1(4) = 0.125D0/U1*(-1.5D0*ZETA2)
      SOF1(5) = 0.125D0/T1*(-1.5D0*ZETA2)
      SOF1(6) = 0.125D0/T1*(-2*LOG(XS)**2 +LOG(XS*U1/T1)**2 
     +     +2*SPENCE(1 -T1/XS/U1) -2*SPENCE(1 -U1/XS/T1) -1.5D0*ZETA2 )
      SOF1(7) = 0.125D0/U1*(-2*LOG(XS)**2 +LOG(XS*T1/U1)**2 
     +     +2*SPENCE(1 -U1/XS/T1) -2*SPENCE(1 -T1/XS/U1) -1.5D0*ZETA2)
      SOF1(8) = 0.125D0/S*(LOG(T1*U1/MST12/S)**2
     +     +2*SPENCE(1 -MST12*S/T1/U1) -3*ZETA2 )

      M2QBV1 = 0D0
     +  + N*CF**2 * ( 8.D+0*s**(-2)*t1**2 + 8.D+0*s**(-1)*t1 + 8.D+0*
     +    s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + N**2*CF * (  - 2.6666666666666666D+0*s**(-2)*
     +    t1**2 - 2.6666666666666666D+0*s**(-1)*t1 - 
     +    2.6666666666666666D+0*s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0A(1)*N**2*CF * (  - 1.0666666666666666D+1*
     +    s**(-3)*t1**2*mg2 - 1.0666666666666666D+1*s**(-2)*t1*mg2 - 
     +    1.0666666666666666D+1*s**(-2)*mg2*mst12 )
      M2QBV1 = M2QBV1 + SK3B0A(2)*N*CF * (  - 1.0666666666666666D+1*
     +    s**(-3)*t1**2*mt2 - 1.0666666666666666D+1*s**(-2)*t1*mt2 - 
     +    1.0666666666666666D+1*s**(-2)*mt2*mst12 )
      M2QBV1 = M2QBV1 + SK3B0A(3)*N*CF**2 * (  - 1.6D+1*s**(-3)*t1**2*
     +    ms2 + 1.6D+1*s**(-3)*t1**2*mg2 - 1.6D+1*s**(-2)*t1*ms2 + 
     +    1.6D+1*s**(-2)*t1*mg2 + 8.D+0*s**(-2)*t1**2 - 1.6D+1*s**(-2)*
     +    ms2*mst12 + 1.6D+1*s**(-2)*mg2*mst12 + 8.D+0*s**(-1)*t1 + 
     +    8.D+0*s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0A(4)*N*CF * ( 1.0666666666666666D+1*
     +    s**(-3)*t1**2*nf*ms2 + 1.0666666666666666D+1*s**(-2)*t1*nf*
     +    ms2 + 1.0666666666666666D+1*s**(-2)*nf*ms2*mst12 )
      M2QBV1 = M2QBV1 + SK3B0A(5)*N*CF * ( 5.3333333333333333D+0*
     +    s**(-3)*t1**2*mst22 + 5.3333333333333333D+0*s**(-2)*t1*mst22
     +     + 5.3333333333333333D+0*s**(-2)*mst12*mst22 )
      M2QBV1 = M2QBV1 + SK3B0B(1)*N*CF * ( 5.3333333333333333D+0*
     +    s**(-2)*t1**2*nf + 5.3333333333333333D+0*s**(-1)*t1*nf + 
     +    5.3333333333333333D+0*s**(-1)*nf*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(1)*N*CF**2 * ( 2.4D+1*s**(-2)*t1**2 + 
     +    2.4D+1*s**(-1)*t1 + 2.4D+1*s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(1)*N**2*CF * (  - 2.1333333333333333D+1*
     +    s**(-2)*t1**2 - 2.1333333333333333D+1*s**(-1)*t1 - 8.D+0*
     +    s**(-1)*t1**2*s1**(-1) - 2.1333333333333333D+1*s**(-1)*mst12
     +     - 8.D+0*t1*s1**(-1) - 8.D+0*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(2)*N*CF * (  - 5.3333333333333333D+0*
     +    s**(-3)*t1**2*mst12 - 5.3333333333333333D+0*s**(-2)*t1*mst12
     +     + 1.3333333333333333D+0*s**(-2)*t1**2 - 
     +    5.3333333333333333D+0*s**(-2)*mst12**2 + 
     +    1.3333333333333333D+0*s**(-1)*t1 + 1.3333333333333333D+0*
     +    s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(2)*N*CF**2 * ( 1.6D+1*s**(-2)*t1**2 + 
     +    1.6D+1*s**(-1)*t1 - 1.6D+1*s**(-1)*t1**2*s1**(-1) + 1.6D+1*
     +    s**(-1)*mst12 - 1.6D+1*t1*s1**(-1) - 1.6D+1*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(2)*N**2*CF * (  - 8.D+0*s**(-2)*t1**2 - 
     +    8.D+0*s**(-1)*t1 + 8.D+0*s**(-1)*t1**2*s1**(-1) - 8.D+0*
     +    s**(-1)*mst12 + 8.D+0*t1*s1**(-1) + 8.D+0*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(3)*N**2*CF * ( 8.D+0*s**(-3)*t1**2*ms2
     +     + 2.6666666666666666D+0*s**(-3)*t1**2*mg2 + 8.D+0*s**(-2)*t1
     +    *ms2 + 2.6666666666666666D+0*s**(-2)*t1*mg2 - 3.2D+1*s**(-2)*
     +    t1**2*mg*mt*s1**(-1)*sin2t + 1.6D+1*s**(-2)*t1**2*s1**(-1)*
     +    mg2 + 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2 - 
     +    2.6666666666666666D+0*s**(-2)*t1**2 + 8.D+0*s**(-2)*ms2*mst12
     +     + 2.6666666666666666D+0*s**(-2)*mg2*mst12 - 3.2D+1*s**(-1)*
     +    t1*mg*mt*s1**(-1)*sin2t + 1.6D+1*s**(-1)*t1*s1**(-1)*mg2 + 
     +    1.6D+1*s**(-1)*t1*s1**(-1)*mt2 - 2.6666666666666666D+0*
     +    s**(-1)*t1 + 4.D+0*s**(-1)*t1**2*s1**(-1) - 8.D+0*s**(-1)*mg*
     +    mt*sin2t + 4.D+0*s**(-1)*mg2 + 4.D+0*s**(-1)*mt2 - 
     +    2.6666666666666666D+0*s**(-1)*mst12 + 4.D+0*t1*s1**(-1) - 
     +    8.D+0*mg*mt*s1**(-1)*sin2t + 4.D+0*s1**(-1)*mg2 + 4.D+0*
     +    s1**(-1)*mt2 + 4.D+0*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(4)*N*CF * ( 1.0666666666666666D+1*
     +    s**(-3)*t1**2*mt2 + 1.0666666666666666D+1*s**(-2)*t1*mt2 + 
     +    5.3333333333333333D+0*s**(-2)*t1**2 + 1.0666666666666666D+1*
     +    s**(-2)*mt2*mst12 + 5.3333333333333333D+0*s**(-1)*t1 + 
     +    5.3333333333333333D+0*s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(4)*N*CF**2 * (  - 6.4D+1*s**(-2)*t1**2*
     +    mg*mt*s1**(-1)*sin2t + 3.2D+1*s**(-2)*t1**2*s1**(-1)*mg2 + 
     +    3.2D+1*s**(-2)*t1**2*s1**(-1)*mt2 - 8.D+0*s**(-2)*t1**2 - 
     +    6.4D+1*s**(-1)*t1*mg*mt*s1**(-1)*sin2t + 3.2D+1*s**(-1)*t1*
     +    s1**(-1)*mg2 + 3.2D+1*s**(-1)*t1*s1**(-1)*mt2 - 8.D+0*s**(-1)
     +    *t1 + 8.D+0*s**(-1)*t1**2*s1**(-1) - 1.6D+1*s**(-1)*mg*mt*
     +    sin2t + 8.D+0*s**(-1)*mg2 + 8.D+0*s**(-1)*mt2 - 8.D+0*s**(-1)
     +    *mst12 + 8.D+0*t1*s1**(-1) - 1.6D+1*mg*mt*s1**(-1)*sin2t + 
     +    8.D+0*s1**(-1)*mg2 + 8.D+0*s1**(-1)*mt2 + 8.D+0*s1**(-1)*
     +    mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(4)*N**2*CF * ( 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*sin2t - 1.6D+1*s**(-2)*t1**2*s1**(-1)*mg2 - 
     +    1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2 + 4.D+0*s**(-2)*t1**2 + 
     +    3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*sin2t - 1.6D+1*s**(-1)*t1*
     +    s1**(-1)*mg2 - 1.6D+1*s**(-1)*t1*s1**(-1)*mt2 + 4.D+0*s**(-1)
     +    *t1 - 4.D+0*s**(-1)*t1**2*s1**(-1) + 8.D+0*s**(-1)*mg*mt*
     +    sin2t - 4.D+0*s**(-1)*mg2 - 4.D+0*s**(-1)*mt2 + 4.D+0*s**(-1)
     +    *mst12 - 4.D+0*t1*s1**(-1) + 8.D+0*mg*mt*s1**(-1)*sin2t - 
     +    4.D+0*s1**(-1)*mg2 - 4.D+0*s1**(-1)*mt2 - 4.D+0*s1**(-1)*
     +    mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(5)*N*CF * (  - 1.0666666666666666D+1*
     +    s**(-3)*t1**2*nf*ms2 - 1.0666666666666666D+1*s**(-2)*t1*nf*
     +    ms2 + 2.6666666666666666D+0*s**(-2)*t1**2*nf - 
     +    1.0666666666666666D+1*s**(-2)*nf*ms2*mst12 + 
     +    2.6666666666666666D+0*s**(-1)*t1*nf + 2.6666666666666666D+0*
     +    s**(-1)*nf*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(5)*N*CF**2 * ( 1.6D+1*s**(-3)*t1**2*ms2
     +     - 1.6D+1*s**(-3)*t1**2*mg2 + 1.6D+1*s**(-2)*t1*ms2 - 1.6D+1*
     +    s**(-2)*t1*mg2 - 8.D+0*s**(-2)*t1**2 + 1.6D+1*s**(-2)*ms2*
     +    mst12 - 1.6D+1*s**(-2)*mg2*mst12 - 8.D+0*s**(-1)*t1 - 8.D+0*
     +    s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(5)*N**2*CF * (  - 8.D+0*s**(-3)*t1**2*
     +    ms2 + 8.D+0*s**(-3)*t1**2*mg2 - 8.D+0*s**(-2)*t1*ms2 + 8.D+0*
     +    s**(-2)*t1*mg2 + 4.D+0*s**(-2)*t1**2 - 8.D+0*s**(-2)*ms2*
     +    mst12 + 8.D+0*s**(-2)*mg2*mst12 + 4.D+0*s**(-1)*t1 + 4.D+0*
     +    s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0B(6)*N*CF * (  - 5.3333333333333333D+0*
     +    s**(-3)*t1**2*mst22 - 5.3333333333333333D+0*s**(-2)*t1*mst22
     +     + 1.3333333333333333D+0*s**(-2)*t1**2 - 
     +    5.3333333333333333D+0*s**(-2)*mst12*mst22 + 
     +    1.3333333333333333D+0*s**(-1)*t1 + 1.3333333333333333D+0*
     +    s**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0C(1)*N*CF**2 * (  - 1.6D+1*s**(-2)*t1**2
     +     - 1.6D+1*s**(-1)*t1 + 1.6D+1*s**(-1)*t1**2*s1**(-1) - 1.6D+1
     +    *s**(-1)*mst12 + 1.6D+1*t1*s1**(-1) + 1.6D+1*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3B0C(2)*N*CF**2 * ( 6.4D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*sin2t - 3.2D+1*s**(-2)*t1**2*s1**(-1)*mg2 - 
     +    3.2D+1*s**(-2)*t1**2*s1**(-1)*mt2 + 8.D+0*s**(-2)*t1**2 + 
     +    6.4D+1*s**(-1)*t1*mg*mt*s1**(-1)*sin2t - 3.2D+1*s**(-1)*t1*
     +    s1**(-1)*mg2 - 3.2D+1*s**(-1)*t1*s1**(-1)*mt2 + 8.D+0*s**(-1)
     +    *t1 - 8.D+0*s**(-1)*t1**2*s1**(-1) + 1.6D+1*s**(-1)*mg*mt*
     +    sin2t - 8.D+0*s**(-1)*mg2 - 8.D+0*s**(-1)*mt2 + 8.D+0*s**(-1)
     +    *mst12 - 8.D+0*t1*s1**(-1) + 1.6D+1*mg*mt*s1**(-1)*sin2t - 
     +    8.D+0*s1**(-1)*mg2 - 8.D+0*s1**(-1)*mt2 - 8.D+0*s1**(-1)*
     +    mst12 )
      M2QBV1 = M2QBV1 + SK3BP(1)*N*CF**2 * (  - 3.2D+1*s**(-2)*t1**2*
     +    mst12 - 3.2D+1*s**(-1)*t1*mst12 - 3.2D+1*s**(-1)*mst12**2 )
      M2QBV1 = M2QBV1 + SK3BP(2)*N*CF**2 * ( 3.2D+1*s**(-2)*t1**2*mg*mt
     +    *sin2t - 1.6D+1*s**(-2)*t1**2*mg2 - 1.6D+1*s**(-2)*t1**2*mt2
     +     + 1.6D+1*s**(-2)*t1**2*mst12 + 3.2D+1*s**(-1)*t1*mg*mt*sin2t
     +     - 1.6D+1*s**(-1)*t1*mg2 - 1.6D+1*s**(-1)*t1*mt2 + 1.6D+1*
     +    s**(-1)*t1*mst12 + 3.2D+1*s**(-1)*mg*mt*mst12*sin2t - 1.6D+1*
     +    s**(-1)*mg2*mst12 - 1.6D+1*s**(-1)*mt2*mst12 + 1.6D+1*s**(-1)
     +    *mst12**2 )
      M2QBV1 = M2QBV1 + SK3BP(3)*N*CF**2 * (  - 8.D+0*s**(-2)*t1**2*ms2
     +     + 8.D+0*s**(-2)*t1**2*mg2 - 8.D+0*s**(-1)*t1*ms2 + 8.D+0*
     +    s**(-1)*t1*mg2 - 8.D+0*s**(-1)*ms2*mst12 + 8.D+0*s**(-1)*mg2*
     +    mst12 )
      M2QBV1 = M2QBV1 + SK3C0A(1)*N*CF**2 * ( 1.6D+1*s**(-1)*t1**2 + 
     +    1.6D+1*s + 4.8D+1*t1 + 1.6D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0A(1)*N**2*CF * (  - 1.6D+1*s**(-1)*t1**2
     +     - 8.D+0*s - 2.8D+1*t1 - 1.2D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0A(5)*N*CF**2 * ( 3.2D+1*s**(-3)*t1**2*ms2*
     +    mg2 - 1.6D+1*s**(-3)*t1**2*ms2**2 - 1.6D+1*s**(-3)*t1**2*
     +    mg2**2 + 3.2D+1*s**(-2)*t1*ms2*mg2 - 1.6D+1*s**(-2)*t1*ms2**2
     +     - 1.6D+1*s**(-2)*t1*mg2**2 - 1.6D+1*s**(-2)*t1**2*mg2 + 
     +    3.2D+1*s**(-2)*ms2*mg2*mst12 - 1.6D+1*s**(-2)*ms2**2*mst12 - 
     +    1.6D+1*s**(-2)*mg2**2*mst12 - 1.6D+1*s**(-1)*t1*mg2 - 1.6D+1*
     +    s**(-1)*mg2*mst12 )
      M2QBV1 = M2QBV1 + SK3C0A(5)*N**2*CF * (  - 1.6D+1*s**(-3)*t1**2*
     +    ms2*mg2 + 8.D+0*s**(-3)*t1**2*ms2**2 + 8.D+0*s**(-3)*t1**2*
     +    mg2**2 - 1.6D+1*s**(-2)*t1*ms2*mg2 + 8.D+0*s**(-2)*t1*ms2**2
     +     + 8.D+0*s**(-2)*t1*mg2**2 + 8.D+0*s**(-2)*t1**2*mg2 - 1.6D+1
     +    *s**(-2)*ms2*mg2*mst12 + 8.D+0*s**(-2)*ms2**2*mst12 + 8.D+0*
     +    s**(-2)*mg2**2*mst12 + 8.D+0*s**(-1)*t1*mg2 + 8.D+0*s**(-1)*
     +    mg2*mst12 )
      M2QBV1 = M2QBV1 + SK3C0A(6)*N*CF**2 * (  - 8.D+0*s - 1.6D+1*t1 )
      M2QBV1 = M2QBV1 + SK3C0A(6)*N**2*CF * (  - 1.6D+1*s**(-3)*t1**2*
     +    ms2*mg2 + 8.D+0*s**(-3)*t1**2*ms2**2 + 8.D+0*s**(-3)*t1**2*
     +    mg2**2 - 1.6D+1*s**(-2)*t1*ms2*mg2 + 8.D+0*s**(-2)*t1*ms2**2
     +     + 8.D+0*s**(-2)*t1*mg2**2 + 8.D+0*s**(-2)*t1**2*mg2 - 1.6D+1
     +    *s**(-2)*ms2*mg2*mst12 + 8.D+0*s**(-2)*ms2**2*mst12 + 8.D+0*
     +    s**(-2)*mg2**2*mst12 + 8.D+0*s**(-1)*t1*mg2 + 8.D+0*s**(-1)*
     +    mg2*mst12 + 4.D+0*s + 6.D+0*t1 - 4.D+0*mg*mt*sin2t + 2.D+0*
     +    mg2 + 2.D+0*mt2 - 2.D+0*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(1)*N*CF**2 * (  - 3.2D+1*s**(-2)*t1**2*
     +    mst12 - 3.2D+1*s**(-1)*t1*mst12 + 1.6D+1*s**(-1)*t1**2 - 
     +    3.2D+1*s**(-1)*mst12**2 + 1.6D+1*t1 + 1.6D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(1)*N**2*CF * ( 1.6D+1*s**(-2)*t1**2*
     +    mst12 + 1.6D+1*s**(-1)*t1*mst12 - 8.D+0*s**(-1)*t1**2 + 
     +    1.6D+1*s**(-1)*mst12**2 - 8.D+0*t1 - 8.D+0*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(2)*N*CF**2 * (  - 6.4D+1*s**(-1)*t1*
     +    mst12 + 1.6D+1*s + 3.2D+1*t1 - 3.2D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(2)*N**2*CF * ( 2.4D+1*s**(-1)*t1*mst12
     +     - 1.2D+1*s**(-1)*t1**2 - 8.D+0*s - 1.6D+1*t1*s1**(-1)*mst12
     +     - 2.D+1*t1 - 4.D+0*t1**2*s1**(-1) - 1.6D+1*s1**(-1)*mst12**2
     +     + 1.2D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(3)*N*CF**2 * ( 6.4D+1*s**(-1)*t1*mg*mt*
     +    sin2t - 3.2D+1*s**(-1)*t1*mg2 - 3.2D+1*s**(-1)*t1*mt2 + 
     +    3.2D+1*s**(-1)*t1*mst12 - 8.D+0*s - 1.6D+1*t1 + 3.2D+1*mg*mt*
     +    sin2t - 1.6D+1*mg2 - 1.6D+1*mt2 + 1.6D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(3)*N**2*CF * ( 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*mg2*sin2t - 3.2D+1*s**(-2)*t1**2*mg*mt*s1**(-1)*
     +    mt2*sin2t + 8.D+0*s**(-2)*t1**2*mg*mt*sin2t - 1.6D+1*s**(-2)*
     +    t1**2*s1**(-1)*mg2**2 + 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2**2
     +     - 8.D+0*s**(-2)*t1**2*mt2 + 4.D+0*s**(-2)*t1**2*mst12 + 
     +    3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mg2*sin2t - 3.2D+1*s**(-1)*
     +    t1*mg*mt*s1**(-1)*mt2*sin2t - 1.6D+1*s**(-1)*t1*mg*mt*sin2t
     +     - 1.6D+1*s**(-1)*t1*s1**(-1)*mg2**2 + 1.6D+1*s**(-1)*t1*
     +    s1**(-1)*mt2**2 + 1.2D+1*s**(-1)*t1*mg2 + 4.D+0*s**(-1)*t1*
     +    mt2 - 8.D+0*s**(-1)*t1*mst12 - 8.D+0*s**(-1)*t1**2*mg*mt*
     +    s1**(-1)*sin2t + 8.D+0*s**(-1)*t1**2*s1**(-1)*mt2 + s**(-1)*
     +    t1**2 + 8.D+0*s**(-1)*mg*mt*mg2*sin2t - 8.D+0*s**(-1)*mg*mt*
     +    mt2*sin2t + 8.D+0*s**(-1)*mg*mt*mst12*sin2t - 4.D+0*s**(-1)*
     +    mg2**2 - 8.D+0*s**(-1)*mt2*mst12 + 4.D+0*s**(-1)*mt2**2 + 
     +    4.D+0*s**(-1)*mst12**2 + 4.D+0*s - 8.D+0*t1*mg*mt*s1**(-1)*
     +    sin2t )
      M2QBV1 = M2QBV1 + SK3C0B(3)*N**2*CF * ( 8.D+0*t1*s1**(-1)*mt2 + 
     +    4.D+0*t1*s1**(-1)*mst12 + 6.D+0*t1 + t1**2*s1**(-1) + 8.D+0*
     +    mg*mt*s1**(-1)*mg2*sin2t - 8.D+0*mg*mt*s1**(-1)*mt2*sin2t - 
     +    8.D+0*mg*mt*s1**(-1)*mst12*sin2t - 1.2D+1*mg*mt*sin2t - 4.D+0
     +    *s1**(-1)*mg2**2 + 8.D+0*s1**(-1)*mt2*mst12 + 4.D+0*s1**(-1)*
     +    mt2**2 + 4.D+0*s1**(-1)*mst12**2 + 6.D+0*mg2 + 6.D+0*mt2 - 
     +    1.D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(4)*N*CF**2 * (  - 6.4D+1*s**(-2)*t1**2*
     +    mg*mt*s1**(-1)*mg2*sin2t + 6.4D+1*s**(-2)*t1**2*mg*mt*
     +    s1**(-1)*mt2*sin2t + 1.6D+1*s**(-2)*t1**2*mg*mt*sin2t + 
     +    3.2D+1*s**(-2)*t1**2*s1**(-1)*mg2**2 - 3.2D+1*s**(-2)*t1**2*
     +    s1**(-1)*mt2**2 - 1.6D+1*s**(-2)*t1**2*mg2 + 8.D+0*s**(-2)*
     +    t1**2*mst12 - 6.4D+1*s**(-1)*t1*mg*mt*s1**(-1)*mg2*sin2t + 
     +    6.4D+1*s**(-1)*t1*mg*mt*s1**(-1)*mt2*sin2t + 1.6D+1*s**(-1)*
     +    t1*mg*mt*sin2t + 3.2D+1*s**(-1)*t1*s1**(-1)*mg2**2 - 3.2D+1*
     +    s**(-1)*t1*s1**(-1)*mt2**2 - 1.6D+1*s**(-1)*t1*mg2 + 8.D+0*
     +    s**(-1)*t1*mst12 - 1.6D+1*s**(-1)*t1**2*mg*mt*s1**(-1)*sin2t
     +     + 1.6D+1*s**(-1)*t1**2*s1**(-1)*mg2 + 2.D+0*s**(-1)*t1**2 - 
     +    1.6D+1*s**(-1)*mg*mt*mg2*sin2t + 1.6D+1*s**(-1)*mg*mt*mt2*
     +    sin2t + 1.6D+1*s**(-1)*mg*mt*mst12*sin2t - 1.6D+1*s**(-1)*mg2
     +    *mst12 + 8.D+0*s**(-1)*mg2**2 - 8.D+0*s**(-1)*mt2**2 + 8.D+0*
     +    s**(-1)*mst12**2 - 1.6D+1*t1*mg*mt*s1**(-1)*sin2t + 1.6D+1*t1
     +    *s1**(-1)*mg2 )
      M2QBV1 = M2QBV1 + SK3C0B(4)*N*CF**2 * ( 8.D+0*t1*s1**(-1)*mst12
     +     + 2.D+0*t1**2*s1**(-1) - 1.6D+1*mg*mt*s1**(-1)*mg2*sin2t + 
     +    1.6D+1*mg*mt*s1**(-1)*mt2*sin2t - 1.6D+1*mg*mt*s1**(-1)*mst12
     +    *sin2t + 1.6D+1*s1**(-1)*mg2*mst12 + 8.D+0*s1**(-1)*mg2**2 - 
     +    8.D+0*s1**(-1)*mt2**2 + 8.D+0*s1**(-1)*mst12**2 )
      M2QBV1 = M2QBV1 + SK3C0B(4)*N**2*CF * ( 3.2D+1*s**(-2)*t1**2*mg*
     +    mt*s1**(-1)*mg2*sin2t - 3.2D+1*s**(-2)*t1**2*mg*mt*s1**(-1)*
     +    mt2*sin2t - 8.D+0*s**(-2)*t1**2*mg*mt*sin2t - 1.6D+1*s**(-2)*
     +    t1**2*s1**(-1)*mg2**2 + 1.6D+1*s**(-2)*t1**2*s1**(-1)*mt2**2
     +     + 8.D+0*s**(-2)*t1**2*mg2 - 4.D+0*s**(-2)*t1**2*mst12 + 
     +    3.2D+1*s**(-1)*t1*mg*mt*s1**(-1)*mg2*sin2t - 3.2D+1*s**(-1)*
     +    t1*mg*mt*s1**(-1)*mt2*sin2t - 8.D+0*s**(-1)*t1*mg*mt*sin2t - 
     +    1.6D+1*s**(-1)*t1*s1**(-1)*mg2**2 + 1.6D+1*s**(-1)*t1*
     +    s1**(-1)*mt2**2 + 8.D+0*s**(-1)*t1*mg2 - 4.D+0*s**(-1)*t1*
     +    mst12 + 8.D+0*s**(-1)*t1**2*mg*mt*s1**(-1)*sin2t - 8.D+0*
     +    s**(-1)*t1**2*s1**(-1)*mg2 - s**(-1)*t1**2 + 8.D+0*s**(-1)*mg
     +    *mt*mg2*sin2t - 8.D+0*s**(-1)*mg*mt*mt2*sin2t - 8.D+0*s**(-1)
     +    *mg*mt*mst12*sin2t + 8.D+0*s**(-1)*mg2*mst12 - 4.D+0*s**(-1)*
     +    mg2**2 + 4.D+0*s**(-1)*mt2**2 - 4.D+0*s**(-1)*mst12**2 + 
     +    8.D+0*t1*mg*mt*s1**(-1)*sin2t - 8.D+0*t1*s1**(-1)*mg2 - 4.D+0
     +    *t1*s1**(-1)*mst12 )
      M2QBV1 = M2QBV1 + SK3C0B(4)*N**2*CF * (  - t1**2*s1**(-1) + 8.D+0
     +    *mg*mt*s1**(-1)*mg2*sin2t - 8.D+0*mg*mt*s1**(-1)*mt2*sin2t + 
     +    8.D+0*mg*mt*s1**(-1)*mst12*sin2t - 8.D+0*s1**(-1)*mg2*mst12
     +     - 4.D+0*s1**(-1)*mg2**2 + 4.D+0*s1**(-1)*mt2**2 - 4.D+0*
     +    s1**(-1)*mst12**2 )
      M2QBV1 = M2QBV1 + SK3C0C(1,1)*N*CF**2 * ( 3.2D+1*s**(-1)*t1*mst12
     +     + 3.2D+1*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SK3C0C(1,1)*N**2*CF * (  - 8.D+0*s**(-1)*t1*
     +    mst12 - 8.D+0*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SK3C0C(1,2)*N*CF**2 * ( 3.2D+1*s**(-1)*t1*mst12
     +     - 3.2D+1*s**(-1)*t1**2 - 3.2D+1*s - 6.4D+1*t1 + 3.2D+1*mst12
     +     )
      M2QBV1 = M2QBV1 + SK3C0C(1,2)*N**2*CF * (  - 1.6D+1*s**(-1)*t1*
     +    mst12 + 1.6D+1*s**(-1)*t1**2 + 1.6D+1*s + 3.2D+1*t1 - 1.6D+1*
     +    mst12 )
      M2QBV1 = M2QBV1 + SK3C0C(2,1)*N*CF**2 * (  - 3.2D+1*s**(-1)*t1*mg
     +    *mt*sin2t + 1.6D+1*s**(-1)*t1*mg2 + 1.6D+1*s**(-1)*t1*mt2 - 
     +    1.6D+1*s**(-1)*t1*mst12 - 1.6D+1*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SK3C0C(2,1)*N**2*CF * ( 8.D+0*s**(-1)*t1*mg*mt*
     +    sin2t - 4.D+0*s**(-1)*t1*mg2 - 4.D+0*s**(-1)*t1*mt2 + 4.D+0*
     +    s**(-1)*t1*mst12 + 4.D+0*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SK3C0C(2,2)*N*CF**2 * (  - 3.2D+1*s**(-1)*t1*mg
     +    *mt*sin2t + 1.6D+1*s**(-1)*t1*mg2 + 1.6D+1*s**(-1)*t1*mt2 - 
     +    1.6D+1*s**(-1)*t1*mst12 + 1.6D+1*s**(-1)*t1**2 + 1.6D+1*s + 
     +    3.2D+1*t1 - 3.2D+1*mg*mt*sin2t + 1.6D+1*mg2 + 1.6D+1*mt2 - 
     +    1.6D+1*mst12 )
      M2QBV1 = M2QBV1 + SK3C0C(2,2)*N**2*CF * ( 1.6D+1*s**(-1)*t1*mg*mt
     +    *sin2t - 8.D+0*s**(-1)*t1*mg2 - 8.D+0*s**(-1)*t1*mt2 + 8.D+0*
     +    s**(-1)*t1*mst12 - 8.D+0*s**(-1)*t1**2 - 8.D+0*s - 1.6D+1*t1
     +     + 1.6D+1*mg*mt*sin2t - 8.D+0*mg2 - 8.D+0*mt2 + 8.D+0*mst12 )
      M2QBV1 = M2QBV1 + SK3D0(1,1)*N*CF**2 * ( 3.2D+1*s**(-1)*t1**3 + 
     +    1.6D+1*t1*mst12 + 1.6D+1*t1**2 )
      M2QBV1 = M2QBV1 + SK3D0(1,1)*N**2*CF * (  - 8.D+0*s**(-1)*t1**3
     +     - 4.D+0*t1*mst12 - 4.D+0*t1**2 )
      M2QBV1 = M2QBV1 + SK3D0(1,2)*N*CF**2 * ( 3.2D+1*s**(-1)*t1**3 + 
     +    6.4D+1*s*t1 + 1.6D+1*s*mst12 + 1.6D+1*s**2 + 1.6D+1*t1*mst12
     +     + 8.D+1*t1**2 )
      M2QBV1 = M2QBV1 + SK3D0(1,2)*N**2*CF * (  - 1.6D+1*s**(-1)*t1**3
     +     - 3.2D+1*s*t1 - 8.D+0*s*mst12 - 8.D+0*s**2 - 8.D+0*t1*mst12
     +     - 4.D+1*t1**2 )
      M2QBV1 = M2QBV1 + SK3D0(7,1)*N*CF**2 * ( 3.2D+1*s**(-1)*t1*mg*mt*
     +    ms2*sin2t - 3.2D+1*s**(-1)*t1*mg*mt*mg2*sin2t - 1.6D+1*
     +    s**(-1)*t1*ms2*mg2 - 1.6D+1*s**(-1)*t1*ms2*mt2 + 1.6D+1*
     +    s**(-1)*t1*ms2*mst12 + 1.6D+1*s**(-1)*t1*mg2*mt2 - 1.6D+1*
     +    s**(-1)*t1*mg2*mst12 + 1.6D+1*s**(-1)*t1*mg2**2 + 1.6D+1*t1*
     +    mg*mt*sin2t - 8.D+0*t1*ms2 + 8.D+0*t1*mg2 - 1.6D+1*t1*mt2 + 
     +    1.6D+1*t1*mst12 + 8.D+0*t1**2 + 1.6D+1*mg*mt*ms2*sin2t - 
     +    1.6D+1*mg*mt*mt2*sin2t + 1.6D+1*mg*mt*mst12*sin2t - 8.D+0*ms2
     +    *mg2 - 8.D+0*ms2*mt2 - 8.D+0*ms2*mst12 + 8.D+0*mg2*mt2 + 
     +    8.D+0*mg2*mst12 - 1.6D+1*mt2*mst12 + 8.D+0*mt2**2 + 8.D+0*
     +    mst12**2 )
      M2QBV1 = M2QBV1 + SK3D0(7,1)*N**2*CF * (  - 8.D+0*s**(-1)*t1*mg*
     +    mt*ms2*sin2t + 8.D+0*s**(-1)*t1*mg*mt*mg2*sin2t + 4.D+0*
     +    s**(-1)*t1*ms2*mg2 + 4.D+0*s**(-1)*t1*ms2*mt2 - 4.D+0*s**(-1)
     +    *t1*ms2*mst12 - 4.D+0*s**(-1)*t1*mg2*mt2 + 4.D+0*s**(-1)*t1*
     +    mg2*mst12 - 4.D+0*s**(-1)*t1*mg2**2 - 4.D+0*t1*mg*mt*sin2t + 
     +    2.D+0*t1*ms2 - 2.D+0*t1*mg2 + 4.D+0*t1*mt2 - 4.D+0*t1*mst12
     +     - 2.D+0*t1**2 - 4.D+0*mg*mt*ms2*sin2t + 4.D+0*mg*mt*mt2*
     +    sin2t - 4.D+0*mg*mt*mst12*sin2t + 2.D+0*ms2*mg2 + 2.D+0*ms2*
     +    mt2 + 2.D+0*ms2*mst12 - 2.D+0*mg2*mt2 - 2.D+0*mg2*mst12 + 
     +    4.D+0*mt2*mst12 - 2.D+0*mt2**2 - 2.D+0*mst12**2 )
      M2QBV1 = M2QBV1 + SK3D0(7,2)*N*CF**2 * ( 3.2D+1*s**(-1)*t1*mg*mt*
     +    ms2*sin2t - 3.2D+1*s**(-1)*t1*mg*mt*mg2*sin2t - 1.6D+1*
     +    s**(-1)*t1*ms2*mg2 - 1.6D+1*s**(-1)*t1*ms2*mt2 + 1.6D+1*
     +    s**(-1)*t1*ms2*mst12 + 1.6D+1*s**(-1)*t1*mg2*mt2 - 1.6D+1*
     +    s**(-1)*t1*mg2*mst12 + 1.6D+1*s**(-1)*t1*mg2**2 - 1.6D+1*s*t1
     +     + 1.6D+1*s*mg*mt*sin2t - 8.D+0*s*ms2 + 8.D+0*s*mg2 - 1.6D+1*
     +    s*mt2 + 1.6D+1*s*mst12 - 8.D+0*s**2 + 1.6D+1*t1*mg*mt*sin2t
     +     - 8.D+0*t1*ms2 + 8.D+0*t1*mg2 - 1.6D+1*t1*mt2 + 1.6D+1*t1*
     +    mst12 - 8.D+0*t1**2 + 1.6D+1*mg*mt*ms2*sin2t - 3.2D+1*mg*mt*
     +    mg2*sin2t + 1.6D+1*mg*mt*mt2*sin2t - 1.6D+1*mg*mt*mst12*sin2t
     +     - 8.D+0*ms2*mg2 - 8.D+0*ms2*mt2 + 2.4D+1*ms2*mst12 + 8.D+0*
     +    mg2*mt2 - 2.4D+1*mg2*mst12 + 1.6D+1*mg2**2 + 1.6D+1*mt2*mst12
     +     - 8.D+0*mt2**2 - 8.D+0*mst12**2 )
      M2QBV1 = M2QBV1 + SK3D0(7,2)*N**2*CF * (  - 1.6D+1*s**(-1)*t1*mg*
     +    mt*ms2*sin2t + 1.6D+1*s**(-1)*t1*mg*mt*mg2*sin2t + 8.D+0*
     +    s**(-1)*t1*ms2*mg2 + 8.D+0*s**(-1)*t1*ms2*mt2 - 8.D+0*s**(-1)
     +    *t1*ms2*mst12 - 8.D+0*s**(-1)*t1*mg2*mt2 + 8.D+0*s**(-1)*t1*
     +    mg2*mst12 - 8.D+0*s**(-1)*t1*mg2**2 + 8.D+0*s*t1 - 8.D+0*s*mg
     +    *mt*sin2t + 4.D+0*s*ms2 - 4.D+0*s*mg2 + 8.D+0*s*mt2 - 8.D+0*s
     +    *mst12 + 4.D+0*s**2 - 8.D+0*t1*mg*mt*sin2t + 4.D+0*t1*ms2 - 
     +    4.D+0*t1*mg2 + 8.D+0*t1*mt2 - 8.D+0*t1*mst12 + 4.D+0*t1**2 - 
     +    8.D+0*mg*mt*ms2*sin2t + 1.6D+1*mg*mt*mg2*sin2t - 8.D+0*mg*mt*
     +    mt2*sin2t + 8.D+0*mg*mt*mst12*sin2t + 4.D+0*ms2*mg2 + 4.D+0*
     +    ms2*mt2 - 1.2D+1*ms2*mst12 - 4.D+0*mg2*mt2 + 1.2D+1*mg2*mst12
     +     - 8.D+0*mg2**2 - 8.D+0*mt2*mst12 + 4.D+0*mt2**2 + 4.D+0*
     +    mst12**2 )
      M2QBV1 = M2QBV1 + SOF1(1)*N*CF**2 * ( 1.28D+2*s**(-2)*t1**2*mst12
     +     + 1.28D+2*s**(-1)*t1*mst12 - 6.4D+1*s**(-1)*t1**2 + 1.28D+2*
     +    s**(-1)*mst12**2 - 6.4D+1*t1 - 6.4D+1*mst12 )
      M2QBV1 = M2QBV1 + SOF1(1)*N**2*CF * (  - 6.4D+1*s**(-2)*t1**2*
     +    mst12 - 6.4D+1*s**(-1)*t1*mst12 + 3.2D+1*s**(-1)*t1**2 - 
     +    6.4D+1*s**(-1)*mst12**2 + 3.2D+1*t1 + 3.2D+1*mst12 )
      M2QBV1 = M2QBV1 + SOF1(2)*N*CF**2 * ( 6.4D+1*s**(-2)*t1**2*mst12
     +     + 6.4D+1*s**(-1)*t1*mst12 + 6.4D+1*s**(-1)*mst12**2 )
      M2QBV1 = M2QBV1 + SOF1(3)*N*CF**2 * ( 6.4D+1*s**(-2)*t1**2*mst12
     +     + 6.4D+1*s**(-1)*t1*mst12 + 6.4D+1*s**(-1)*mst12**2 )
      M2QBV1 = M2QBV1 + SOF1(4)*N*CF**2 * (  - 1.28D+2*s**(-2)*t1**3 - 
     +    1.28D+2*s**(-1)*t1*mst12 - 2.56D+2*s**(-1)*t1**2 - 1.28D+2*t1
     +     - 1.28D+2*mst12 )
      M2QBV1 = M2QBV1 + SOF1(4)*N**2*CF * ( 6.4D+1*s**(-2)*t1**3 + 
     +    6.4D+1*s**(-1)*t1*mst12 + 1.28D+2*s**(-1)*t1**2 + 6.4D+1*t1
     +     + 6.4D+1*mst12 )
      M2QBV1 = M2QBV1 + SOF1(5)*N*CF**2 * (  - 1.28D+2*s**(-2)*t1**3 - 
     +    1.28D+2*s**(-1)*t1*mst12 - 1.28D+2*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SOF1(5)*N**2*CF * ( 3.2D+1*s**(-2)*t1**3 + 
     +    3.2D+1*s**(-1)*t1*mst12 + 3.2D+1*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SOF1(6)*N*CF**2 * (  - 1.28D+2*s**(-2)*t1**3 - 
     +    1.28D+2*s**(-1)*t1*mst12 - 1.28D+2*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SOF1(6)*N**2*CF * ( 3.2D+1*s**(-2)*t1**3 + 
     +    3.2D+1*s**(-1)*t1*mst12 + 3.2D+1*s**(-1)*t1**2 )
      M2QBV1 = M2QBV1 + SOF1(7)*N*CF**2 * (  - 1.28D+2*s**(-2)*t1**3 - 
     +    1.28D+2*s**(-1)*t1*mst12 - 2.56D+2*s**(-1)*t1**2 - 1.28D+2*t1
     +     - 1.28D+2*mst12 )
      M2QBV1 = M2QBV1 + SOF1(7)*N**2*CF * ( 6.4D+1*s**(-2)*t1**3 + 
     +    6.4D+1*s**(-1)*t1*mst12 + 1.28D+2*s**(-1)*t1**2 + 6.4D+1*t1
     +     + 6.4D+1*mst12 )
      M2QBV1 = M2QBV1 + SOF1(8)*N*CF**2 * (  - 6.4D+1*s**(-1)*t1**2 - 
     +    6.4D+1*t1 - 6.4D+1*mst12 )
      M2QBV1 = M2QBV1 + SOF1(8)*N**2*CF * ( 3.2D+1*s**(-1)*t1**2 + 
     +    3.2D+1*t1 + 3.2D+1*mst12 )

      DSTQBV = 
     +     ALPHAS**3 * AVG * M2QBV1 /4.D0 /S**2 *CONV
     +    + ALPHAS/PI*DSTQBB(ALPHAS,S,T1,MST1,MG) *
     +     ( + LOG(MG2/MST12)*(-1.D0) 
     +       + LOG(MT2/MST12)*(-1.D0/3.D0)
     +       + LOG(Ms2/MST12)*(-2*nf/12.D0) 
     +       + LOG(MsT22/MST12)*(-1D0/12.D0)  )
C***  CHANGES TO SUBTRACTED MSBAR 
      RETURN
      END



      REAL*8 FUNCTION DSTQBH(ALPHAS,S,T1,S4,MST1,MG)
C***  CROSS SECTIONS FOR Q + QB -> ST + STB +G
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,U1,MST1,MG,MST12
      REAL*8 CONV,N,CF,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1P2
      REAL*8 A4M1P2, A4M1P1, A4P0P2, A4P1P0, A4P2M2, A4M2P1
      REAL*8 M2QBH1
      REAL*8 ANG4(1:84), COLO1(1:9)
           
      CONV = 389379660.D0

      N = 3.D0
      CF = (N**2 -1.D0)/N/2.D0

      AVG = (1.D0/2.D0)**2 /N**2

      MST12 = MST1**2
      U1 = S4 -S -T1

      ANGDEF(1) = 2.D0*SQRT(S4 +MST12)
      ANGDEF(2) = (S +U1)/ANGDEF(1)
      ANGDEF(3) = (S +T1)/ANGDEF(1)
      ANGDEF(4) = S4/ANGDEF(1)
      ANGDEF(5) = (S4 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(6) = -(T1 +U1 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(7) = SQRT((T1 +U1)**2 -4.D0*MST12*S)/ANGDEF(1)
      ANGDEF(8) = 
     + (T1*S4 -S*(U1+2.D0*MST12))/(S+T1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     + (U1*S4 -S*(T1+2.D0*MST12))/(S+U1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)


      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)


      ANG4(9) =A4P2M2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(10) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(11) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(12) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(13) =A4P2M2(ANA(2,2),ANB(2,2),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(15) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(16) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))

      ANG4(36) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(37) =A4P1P0(ANA(2,1),ANB(2,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
      ANG4(49) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(50) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))


      COLO1(9) = LOG(S4**2/MST12/(S4+MST12))

      M2QBH1 = 0D0
      M2QBH1 = M2QBH1 + N*CF**2*(s4+mst12) * ( 16*s**(-2)*t1**(-1)*
     +    u1**2*s4**(-1) - 64*s**(-2)*t1*u1*s4**(-2) + 48*s**(-2)*t1*
     +    s4**(-1) + 16*s**(-2)*t1**2*u1**(-1)*s4**(-1) - 32*s**(-2)*
     +    t1**2*s4**(-2) + 48*s**(-2)*u1*s4**(-1) - 32*s**(-2)*u1**2*
     +    s4**(-2) - 16*s**(-1)*t1**(-2)*u1*s4**(-1)*mst12 + 16*s**(-1)
     +    *t1**(-1)*u1*s4**(-1) - 16*s**(-1)*t1**(-1)*s4**(-1)*mst12 - 
     +    16*s**(-1)*t1*u1**(-2)*s4**(-1)*mst12 + 16*s**(-1)*t1*
     +    u1**(-1)*s4**(-1) - 64*s**(-1)*t1*s4**(-2) - 16*s**(-1)*
     +    u1**(-1)*s4**(-1)*mst12 - 64*s**(-1)*u1*s4**(-2) + 32*s**(-1)
     +    *s4**(-1) - 16*t1**(-2)*s4**(-1)*mst12 - 16*u1**(-2)*s4**(-1)
     +    *mst12 - 32*s4**(-2) )
     +
      M2QBH1 = M2QBH1 + N*CF**2 * ( 32*s**(-2)*u1**2*s4**(-2)*mst12 + 
     +    32*s**(-1)*u1*s4**(-2)*mst12 - 16*s**(-1)*u1*s4**(-1) + 32*
     +    s**(-1)*s4**(-2)*mst12**2 + 32*s**(-1)*s4**(-1)*mst12 + 16*
     +    s**(-1) - 16*s4**(-1) )
     +
      M2QBH1 = M2QBH1 + N**2*CF*(s4+mst12) * ( 32*s**(-2)*t1*u1*
     +    s4**(-2) - 16*s**(-2)*t1*s4**(-1) + 16*s**(-2)*t1**2*s4**(-2)
     +     - 16*s**(-2)*u1*s4**(-1) + 16*s**(-2)*u1**2*s4**(-2) + 32*
     +    s**(-1)*t1*s4**(-2) + 32*s**(-1)*u1*s4**(-2) - 16*s**(-1)*
     +    s4**(-1) + 16*s4**(-2) )
     +
      M2QBH1 = M2QBH1 + COLO1(9)*N*CF**2*(s4+mst12) * ( 16*s**(-2)*
     +    t1**(-1)*u1**3*s4**(-2) + 32*s**(-2)*t1*u1*s4**(-2) + 16*
     +    s**(-2)*t1**3*u1**(-1)*s4**(-2) - 16*s**(-1)*t1**(-2)*u1**2*
     +    s4**(-2)*mst12 + 32*s**(-1)*t1**(-1)*u1**2*s4**(-2) - 16*
     +    s**(-1)*t1**2*u1**(-2)*s4**(-2)*mst12 + 32*s**(-1)*t1**2*
     +    u1**(-1)*s4**(-2) - 32*s**(-1)*s4**(-2)*mst12 - 16*s*t1**(-2)
     +    *s4**(-2)*mst12 - 16*s*u1**(-2)*s4**(-2)*mst12 - 32*t1**(-2)*
     +    u1*s4**(-2)*mst12 + 16*t1**(-1)*u1*s4**(-2) - 32*t1*u1**(-2)*
     +    s4**(-2)*mst12 + 16*t1*u1**(-1)*s4**(-2) )
     +
      M2QBH1 = M2QBH1 + ANG4(9)*N*CF**2 * ( 16*s**(-2)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(10)*N*CF**2 * ( 16*s**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(11)*N**2*CF * (  - 16*s**(-2)*
     +    (t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(12)*N*CF**2 * (  - 32*s**(-2)*u1*s4**(-1)*
     +    mst12 + 16*s**(-1)*u1*s4**(-1) - 16*s**(-1)*s4**(-1)*mst12 - 
     +    64*s**(-1)*(t1+u1)**(-1)*mst12 - 8*s**(-1) + 8*s4**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(12)*N**2*CF * ( 16*s**(-2)*u1*s4**(-1)*
     +    mst12 - 16*s**(-2)*u1*(t1+u1)**(-1)*mst12 - 8*s**(-1)*u1*
     +    s4**(-1) + 8*s**(-1)*s4**(-1)*mst12 + 8*s**(-1)*(t1+u1)**(-1)
     +    *mst12 + 4*s**(-1) - 4*s4**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(13)*N**2*CF * ( 16*s**(-2)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(14)*N**2*CF * ( 32*s**(-2)*u1*mst12 + 16*
     +    s**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(15)*N**2*CF * (  - 16*s**(-2)*
     +    (t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(16)*N*CF**2 * (  - 64*s**(-1)*
     +    (t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(16)*N**2*CF * ( 16*s**(-2)*u1*s4**(-1)*
     +    mst12 - 16*s**(-2)*u1*(t1+u1)**(-1)*mst12 - 8*s**(-1)*u1*
     +    s4**(-1) + 8*s**(-1)*s4**(-1)*mst12 + 8*s**(-1)*(t1+u1)**(-1)
     +    *mst12 + 4*s**(-1) - 4*s4**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(36)*N*CF**2 * ( 16*s**(-1)*mst12**2 )
     +
      M2QBH1 = M2QBH1 + ANG4(37)*N*CF**2 * ( 16*s**(-1)*t1 - 16*s**(-1)
     +    *u1*s4**(-1)*mst12 - 16*s**(-1)*u1 + 32*s**(-1)*s4**(-1)*
     +    mst12**2 + 16*s**(-1)*mst12 - 8*t1*s4**(-1) - 32*s4**(-1)*
     +    mst12 - 32*(t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(37)*N**2*CF * (  - 4*s**(-1)*t1 + 8*
     +    s**(-1)*u1*s4**(-1)*mst12 - 8*s**(-1)*u1*(t1+u1)**(-1)*mst12
     +     + 8*s**(-1)*u1**2*(t1+u1)**(-1) - 16*s**(-1)*s4**(-1)*
     +    mst12**2 - 4*s**(-1)*mst12 + 4*t1*s4**(-1) + 16*s4**(-1)*
     +    mst12 + 8*(t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(38)*N*CF**2 * ( 16*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(38)*N**2*CF * ( 16*s**(-2)*u1**2*mst12 + 
     +    16*s**(-1)*u1*mst12 + 8*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(39)*N*CF**2 * (  - 64*s**(-1)*u1*s4**(-1)*
     +    mst12 - 16*t1*s4**(-1) + 16*u1*s4**(-1) - 32*s4**(-1)*mst12
     +     - 32*(t1+u1)**(-1)*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(39)*N**2*CF * ( 16*s**(-2)*u1**2*s4**(-1)*
     +    mst12 + 8*s**(-1)*t1 + 40*s**(-1)*u1*s4**(-1)*mst12 - 8*
     +    s**(-1)*u1*(t1+u1)**(-1)*mst12 - 12*s**(-1)*u1 + 8*s**(-1)*
     +    u1**2*s4**(-1) + 8*s**(-1)*u1**2*(t1+u1)**(-1) + 8*s**(-1)*
     +    mst12 + 4*t1*s4**(-1) + 20*s4**(-1)*mst12 + 8*(t1+u1)**(-1)*
     +    mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(48)*N*CF**2 * (  - 8*s**(-1)*t1**2 - 8*
     +    s**(-1)*u1**2 - 8*t1 - 8*u1 - 16*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(48)*N**2*CF * ( 4*s**(-1)*t1**2 + 4*
     +    s**(-1)*u1**2 + 4*t1 + 4*u1 + 8*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(49)*N*CF**2 * (  - 32*s**(-1)*t1*u1 - 16*
     +    s**(-1)*t1*mst12 + 16*s**(-1)*t1**2 + 32*s**(-1)*u1**2 - 32*
     +    s**(-1)*u1**3*(t1+u1)**(-1) + 16*t1 - 16*u1*(t1+u1)**(-1)*
     +    mst12 - 16*u1 + 16*u1**2*(t1+u1)**(-1) + 16*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(49)*N**2*CF * ( 8*s**(-1)*t1*u1 + 4*
     +    s**(-1)*t1*mst12 - 4*s**(-1)*t1**2 - 8*s**(-1)*u1**2 + 8*
     +    s**(-1)*u1**3*(t1+u1)**(-1) - 4*t1 + 4*u1*(t1+u1)**(-1)*mst12
     +     + 4*u1 - 4*u1**2*(t1+u1)**(-1) - 4*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(50)*N*CF**2 * ( 16*s**(-1)*u1*mst12 + 16*
     +    s**(-1)*u1**2 - 32*s**(-1)*u1**3*(t1+u1)**(-1) - 16*u1*
     +    (t1+u1)**(-1)*mst12 - 16*u1**2*(t1+u1)**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(50)*N**2*CF * (  - 8*s**(-1)*u1*mst12 - 8*
     +    s**(-1)*u1**2 + 16*s**(-1)*u1**3*(t1+u1)**(-1) + 8*u1*
     +    (t1+u1)**(-1)*mst12 + 8*u1**2*(t1+u1)**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(52)*N*CF**2 * ( 8*s*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(54)*N*CF**2 * ( 8*s**(-1)*t1**2 + 8*
     +    s**(-1)*u1**2 + 32*s**(-1)*u1**3*s4**(-1) - 32*s**(-1)*u1**3*
     +    (t1+u1)**(-1) + 8*t1 + 16*u1*s4**(-1)*mst12 - 16*u1*
     +    (t1+u1)**(-1)*mst12 - 16*u1 + 16*u1**2*s4**(-1) + 16*u1**2*
     +    (t1+u1)**(-1) + 8*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(54)*N**2*CF * (  - 4*s**(-1)*t1*u1 + 4*
     +    s**(-1)*u1**2 - 16*s**(-1)*u1**3*s4**(-1) + 8*s**(-1)*u1**3*
     +    (t1+u1)**(-1) - 8*u1*s4**(-1)*mst12 + 4*u1*(t1+u1)**(-1)*
     +    mst12 + 4*u1 - 8*u1**2*s4**(-1) - 4*u1**2*(t1+u1)**(-1) )
     +
      M2QBH1 = M2QBH1 + ANG4(56)*N*CF**2 * ( 8*s*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(58)*N*CF**2 * ( 8*s**(-1)*t1**2 + 8*
     +    s**(-1)*u1**2 + 32*s**(-1)*u1**3*s4**(-1) - 32*s**(-1)*u1**3*
     +    (t1+u1)**(-1) - 32*t1*u1*s4**(-1) - 16*t1*s4**(-1)*mst12 + 16
     +    *t1**2*s4**(-1) - 16*u1*(t1+u1)**(-1)*mst12 + 24*u1 + 32*
     +    u1**2*s4**(-1) - 16*u1**2*(t1+u1)**(-1) + 24*mst12 )
     +
      M2QBH1 = M2QBH1 + ANG4(58)*N**2*CF * ( 4*s**(-1)*t1*u1 - 4*
     +    s**(-1)*t1**2 - 8*s**(-1)*u1**2 - 8*s**(-1)*u1**3*s4**(-1) + 
     +    16*s**(-1)*u1**3*(t1+u1)**(-1) + 8*t1*u1*s4**(-1) + 4*t1*
     +    s4**(-1)*mst12 - 4*t1**2*s4**(-1) + 8*u1*(t1+u1)**(-1)*mst12
     +     - 8*u1 - 8*u1**2*s4**(-1) + 8*u1**2*(t1+u1)**(-1) - 8*mst12
     +     )

      DSTQBH = S4/(S4+MSt12)/2.D0 *
     +     ALPHAS**3 * AVG * M2QBH1 /4.D0 /S**2 *CONV

      RETURN
      END


      REAL*8 FUNCTION DSTQBD(ALPHAS,S,T1,S4,MST1,MG,DEL,S4MAX)
C***  LOG(DEL) PART OF CROSS SECTIONS FOR Q +QB -> ST + STB +G 
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,SB,MST1,MG,MST12,CF
      REAL*8 M2QBD1
      REAL*8 CONV,N,AVG,BETA,XS,DEL,S4MAX,DLDEL1,DLDEL2
      REAL*8 COLO1(1:9)

      CONV = 389379660.D0
      N = 3.D0
      CF = (N**2-1.D0)/N/2.D0
      AVG = (1.D0/2.D0)**2 /N**2

      MST12 = MST1**2
      SB = S*SQRT(1 -4.D0*MST12/S)
      BETA = SQRT(1 -4*MST12/S)
      XS = (1.D0 -BETA)/(1.D0 +BETA)

      DLDEL1 = LOG(S4MAX/MST12) -(S4MAX-DEL)/S4
      DLDEL2 = LOG(S4MAX/MST12)**2 -2.D0*(S4MAX -DEL)/S4*LOG(S4/MST12)

      COLO1(1) = LOG(XS)
      COLO1(3) = LOG(S/MST12)
      COLO1(4) = LOG(-T1/MST12)
      COLO1(8) = LOG((S+T1)/MST12)


      M2QBD1 = 0D0
      M2QBD1 = M2QBD1 + N*CF**2*dldel1 * ( 32*s**(-2)*t1**2 + 32*
     +    s**(-1)*t1 + 32*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + N*CF**2*dldel2 * (  - 32*s**(-2)*t1**2 - 32*
     +    s**(-1)*t1 - 32*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(1)*N*CF**2*dldel1 * (  - 64*s**(-2)*t1**2
     +    *sb**(-1)*mst12 - 64*s**(-1)*t1*sb**(-1)*mst12 + 32*s**(-1)*
     +    t1**2*sb**(-1) - 64*s**(-1)*sb**(-1)*mst12**2 + 32*t1*
     +    sb**(-1) + 32*sb**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(1)*N**2*CF*dldel1 * ( 32*s**(-2)*t1**2*
     +    sb**(-1)*mst12 + 32*s**(-1)*t1*sb**(-1)*mst12 - 16*s**(-1)*
     +    t1**2*sb**(-1) + 32*s**(-1)*sb**(-1)*mst12**2 - 16*t1*
     +    sb**(-1) - 16*sb**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(3)*N*CF**2*dldel1 * (  - 32*s**(-2)*t1**2
     +     - 32*s**(-1)*t1 - 32*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(3)*N**2*CF*dldel1 * ( 16*s**(-2)*t1**2 + 
     +    16*s**(-1)*t1 + 16*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(4)*N*CF**2*dldel1 * (  - 96*s**(-2)*t1**2
     +     - 96*s**(-1)*t1 - 96*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(4)*N**2*CF*dldel1 * ( 32*s**(-2)*t1**2 + 
     +    32*s**(-1)*t1 + 32*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(8)*N*CF**2*dldel1 * ( 160*s**(-2)*t1**2
     +     + 160*s**(-1)*t1 + 160*s**(-1)*mst12 )
     +
      M2QBD1 = M2QBD1 + COLO1(8)*N**2*CF*dldel1 * (  - 64*s**(-2)*t1**2
     +     - 64*s**(-1)*t1 - 64*s**(-1)*mst12 )

      DSTQBD = ALPHAS**3 * AVG * M2QBD1 /4.D0 /S**2 *CONV

      RETURN
      END



      REAL*8 FUNCTION DSTGB3(ALPHAS,S,T1,S4,MSt1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,S4,MSt1,MSt12,MG,SCA,N,CF,NS,CONV,AVG
      REAL*8 M2GB31

      N = 3.D0
      CF = (N**2 -1.D0)/2.D0/N
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)
      CONV = 389379660.D0

      MSt12 = MSt1**2
      U1 = S4 -S -T1

      M2GB31 = 0D0
      M2GB31 = M2GB31 + N*CF**2 * ( 16*s**(-2)*t1**(-1)*u1**2 + 32*
     +    s**(-2)*t1 + 32*s**(-2)*u1 - 16*s**(-1)*t1**(-2)*u1*mst12 + 
     +    16*s**(-1)*t1**(-1)*u1 - 32*s**(-1)*t1**(-1)*mst12 - 32*
     +    s**(-1)*t1*(s+u1)**(-1) - 32*s**(-1)*(s+u1)**(-1)*mst12 - 64*
     +    s*t1**(-1)*u1**(-2)*mst12 - 32*s*t1**(-1)*u1**(-1)*
     +    (s+t1)**(-1)*mst12 - 64*s*u1**(-3)*mst12 + 32*s*u1**(-2) + 64
     +    *s**2*t1**(-2)*u1**(-3)*mst12**2 + 32*s**2*t1**(-2)*u1**(-2)*
     +    (s+t1)**(-1)*mst12**2 + 64*s**2*t1**(-1)*u1**(-4)*mst12**2 - 
     +    64*s**2*t1**(-1)*u1**(-3)*mst12 + 64*s**3*t1**(-2)*u1**(-4)*
     +    mst12**2 - 16*t1**(-2)*mst12 + 32*t1*u1**(-2) + 32*u1**(-1)
     +     + 16*(s+t1)**(-1) )
     +
      M2GB31 = M2GB31 + N**2*CF * ( 16*s**(-2)*t1 + 32*s**(-2)*t1**2*
     +    u1**(-1) + 32*s**(-2)*t1**3*u1**(-2) - 64*s**(-1)*t1*u1**(-2)
     +    *mst12 + 32*s**(-1)*t1*u1**(-1) - 64*s**(-1)*t1**2*u1**(-3)*
     +    mst12 + 64*s**(-1)*t1**2*u1**(-2) - 32*s**(-1)*u1**(-1)*mst12
     +     + 64*s*t1**(-1)*u1**(-3)*mst12**2 + 128*s*u1**(-4)*mst12**2
     +     - 64*s*u1**(-3)*mst12 + 64*s**2*t1**(-1)*u1**(-4)*mst12**2
     +     + 32*t1**(-1)*u1**(-2)*mst12**2 + 64*t1*u1**(-4)*mst12**2 - 
     +    128*t1*u1**(-3)*mst12 + 32*t1*u1**(-2) + 64*u1**(-3)*mst12**2
     +     - 64*u1**(-2)*mst12 )

      DSTGB3 = ALPHAS**3 * AVG *M2GB31 *LOG(1.D0/SCA)/8.D0/S**2  *CONV
      RETURN
      END


      REAL*8 FUNCTION DSTGBH(ALPHAS,S,T1,S4,MST1,MG)
C***  CROSS SECTIONS FOR G + QB -> ST + STB +QB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,U1,MST1,MG,MST12
      REAL*8 CONV,N,CF,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1P2, A4P1P1
      REAL*8 A4M1P2, A4P0P2, A4P1P0, ABP2P2
      REAL*8 ABP2P1, ABP2P0
      REAL*8 M2GBH1
      REAL*8 ANG4(1:84), COLO1(1:9)
           
      CONV = 389379660.D0

      N = 3.D0
      CF = (N**2 -1.D0)/N/2.D0

      AVG = (1.D0/2.D0)**2 /N /(N**2 -1.D0)

      MST12 = MST1**2
      U1 = S4 -S -T1

      ANGDEF(1) = 2.D0*SQRT(S4 +MST12)
      ANGDEF(2) = (S +U1)/ANGDEF(1)
      ANGDEF(3) = (S +T1)/ANGDEF(1)
      ANGDEF(4) = S4/ANGDEF(1)
      ANGDEF(5) = (S4 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(6) = -(T1 +U1 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(7) = SQRT((T1 +U1)**2 -4.D0*MST12*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (T1*S4 -S*(U1+2.D0*MST12))/(S+T1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (U1*S4 -S*(T1+2.D0*MST12))/(S+U1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)

      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)

      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)


      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(17) =A4P1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))

      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(44) =A4P1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))

      ANG4(51) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(53) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(59) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(60) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 

      ANG4(61) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(62) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6)) 
      ANG4(70) =ABP2P0(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))

      COLO1(9) = LOG(S4**2/MST12/(S4+MST12))

      M2GBH1 = 0D0
      M2GBH1 = M2GBH1 + N*(s4+mst12)*CF**2 * (  - 32*s**(-2)*t1*
     +    s4**(-1) - 32*s**(-2)*u1*s4**(-1) + 32*s**(-1)*t1**(-1)*
     +    s4**(-1)*mst12 - 64*s**(-1)*t1*u1**(-1)*s4**(-2)*mst12 + 96*
     +    s**(-1)*t1*u1**(-1)*s4**(-1) + 64*s**(-1)*t1*s4**(-2)*
     +    (s+u1)**(-1)*mst12 - 128*s**(-1)*t1*s4**(-2) + 64*s**(-1)*t1*
     +    s4**(-1)*(s+u1)**(-1) + 64*s**(-1)*t1**2*u1**(-2)*s4**(-1) - 
     +    320*s**(-1)*t1**2*u1**(-1)*s4**(-2) + 64*s**(-1)*t1**2*
     +    u1**(-1)*s4**(-1)*(s+u1)**(-1) + 64*s**(-1)*t1**2*s4**(-2)*
     +    (s+u1)**(-1) - 128*s**(-1)*t1**3*u1**(-1)*s4**(-2)*
     +    (s+u1)**(-1) - 32*s**(-1)*u1**(-1)*s4**(-1)*mst12 + 64*
     +    s**(-1)*s4**(-1)*(s+u1)**(-1)*mst12 - 32*s*t1**(-2)*u1**(-2)*
     +    s4**(-1)*mst12**2 + 128*s*t1**(-1)*u1**(-3)*mst12 - 192*s*
     +    t1**(-1)*u1**(-2)*s4**(-1)*mst12 - 64*s*t1**(-1)*u1**(-1)*
     +    s4**(-1)*(s+t1)**(-1)*mst12 - 192*s*u1**(-3)*s4**(-1)*mst12
     +     - 64*s*u1**(-1)*s4**(-2) + 32*s*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1) )
     +
      M2GBH1 = M2GBH1 + N*(s4+mst12)*CF**2 * (  - 192*s**2*t1**(-2)*
     +    u1**(-4)*mst12**2 + 256*s**2*t1**(-2)*u1**(-3)*s4**(-1)*
     +    mst12**2 + 64*s**2*t1**(-2)*u1**(-2)*s4**(-1)*(s+t1)**(-1)*
     +    mst12**2 + 256*s**2*t1**(-1)*u1**(-4)*s4**(-1)*mst12**2 - 192
     +    *s**2*t1**(-1)*u1**(-3)*s4**(-1)*mst12 + 256*s**3*t1**(-2)*
     +    u1**(-4)*s4**(-1)*mst12**2 + 32*t1**(-1)*u1**(-2)*s4**(-1)*
     +    mst12**2 + 32*t1**(-1)*u1**(-1)*s4**(-1)*mst12 - 256*t1*
     +    u1**(-1)*s4**(-2) + 96*t1*u1**(-1)*s4**(-1)*(s+u1)**(-1) - 64
     +    *t1**2*u1**(-2)*s4**(-1)*(s+u1)**(-1) - 32*u1**(-2)*s4**(-1)*
     +    (s+t1)**(-1)*mst12**2 - 64*u1**(-1)*s4**(-2)*mst12 - 32*
     +    u1**(-1)*s4**(-1)*(s+t1)**(-1)*mst12 + 96*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1)*mst12 + 32*u1**(-1)*s4**(-1) - 64*s4**(-2) + 16*
     +    s4**(-1)*(s+t1)**(-1) + 32*s4**(-1)*(s+u1)**(-1) )
     +
      M2GBH1 = M2GBH1 + N**2*(s4+mst12)*CF * ( 32*s**(-2)*t1*u1*
     +    s4**(-2) - 16*s**(-2)*t1*s4**(-1) - 32*s**(-2)*t1**2*u1**(-1)
     +    *s4**(-1) + 64*s**(-2)*t1**2*s4**(-2) + 32*s**(-2)*t1**3*
     +    u1**(-1)*s4**(-2) + 128*s**(-1)*t1*u1**(-3)*mst12 - 192*
     +    s**(-1)*t1*u1**(-2)*s4**(-1)*mst12 + 32*s**(-1)*t1*u1**(-1)*
     +    s4**(-2)*mst12 - 56*s**(-1)*t1*u1**(-1)*s4**(-1) - 16*s**(-1)
     +    *t1*s4**(-2)*(s+u1)**(-1)*mst12 + 128*s**(-1)*t1*s4**(-2) - 
     +    24*s**(-1)*t1*s4**(-1)*(s+u1)**(-1) - 192*s**(-1)*t1**2*
     +    u1**(-3)*s4**(-1)*mst12 - 16*s**(-1)*t1**2*u1**(-2)*s4**(-1)
     +     + 160*s**(-1)*t1**2*u1**(-1)*s4**(-2) - 16*s**(-1)*t1**2*
     +    u1**(-1)*s4**(-1)*(s+u1)**(-1) - 16*s**(-1)*t1**2*s4**(-2)*
     +    (s+u1)**(-1) + 32*s**(-1)*t1**3*u1**(-1)*s4**(-2)*
     +    (s+u1)**(-1) - 24*s**(-1)*u1**(-1)*s4**(-1)*mst12 + 16*
     +    s**(-1)*u1*s4**(-2) + 16*s**(-1)*s4**(-2)*mst12 - 24*s**(-1)*
     +    s4**(-1)*(s+u1)**(-1)*mst12 - 16*s**(-1)*s4**(-1) + 64*s*
     +    t1**(-1)*u1**(-3)*s4**(-1)*mst12**2 )
     +
      M2GBH1 = M2GBH1 + N**2*(s4+mst12)*CF * ( 192*s*u1**(-4)*s4**(-1)*
     +    mst12**2 - 64*s*u1**(-3)*s4**(-1)*mst12 + 32*s*u1**(-1)*
     +    s4**(-2) - 16*s*u1**(-1)*s4**(-1)*(s+u1)**(-1) + 64*s**2*
     +    t1**(-1)*u1**(-4)*s4**(-1)*mst12**2 + 32*t1**(-1)*u1**(-2)*
     +    s4**(-1)*mst12**2 + 128*t1*u1**(-4)*s4**(-1)*mst12**2 - 256*
     +    t1*u1**(-3)*s4**(-1)*mst12 + 128*t1*u1**(-1)*s4**(-2) - 40*t1
     +    *u1**(-1)*s4**(-1)*(s+u1)**(-1) + 16*t1**2*u1**(-2)*s4**(-1)*
     +    (s+u1)**(-1) - 64*u1**(-4)*mst12**2 + 128*u1**(-3)*s4**(-1)*
     +    mst12**2 - 64*u1**(-2)*s4**(-1)*mst12 + 32*u1**(-1)*s4**(-2)*
     +    mst12 - 40*u1**(-1)*s4**(-1)*(s+u1)**(-1)*mst12 - 16*u1**(-1)
     +    *s4**(-1) + 48*s4**(-2) - 16*s4**(-1)*(s+u1)**(-1) )
     +
      M2GBH1 = M2GBH1 + ANG4(14)*N*CF**2 * (  - 8*s**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(17)*N*CF**2 * ( 64*s**(-1)*t1*u1 + 16*
     +    s**(-1)*t1*mst12 + 80*s**(-1)*t1**2 + 32*s**(-1)*t1**3*
     +    u1**(-1) + 16*s**(-1)*u1*mst12 + 16*s**(-1)*u1**2 - 64*t1*
     +    u1**(-1)*mst12 - 16*t1*(s+u1)**(-1)*mst12 + 32*t1 - 16*t1**2*
     +    (s+u1)**(-1) - 32*t1**3*u1**(-1)*(s+u1)**(-1) + 16*u1 - 32*
     +    mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(17)*N**2*CF * (  - 32*s**(-1)*t1*u1 - 8*
     +    s**(-1)*t1*mst12 - 40*s**(-1)*t1**2 - 16*s**(-1)*t1**3*
     +    u1**(-1) - 8*s**(-1)*u1*mst12 - 8*s**(-1)*u1**2 + 16*s*t1*
     +    u1**(-2)*mst12 - 8*s*t1*u1**(-1) + 8*s*u1**(-1)*mst12 - 4*s
     +     + 32*t1*u1**(-1)*mst12 + 4*t1*(s+u1)**(-1)*mst12 - 32*t1 - 
     +    16*t1**2*u1**(-1) + 4*t1**2*(s+u1)**(-1) + 8*t1**3*u1**(-1)*
     +    (s+u1)**(-1) - 12*u1 + 12*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(38)*N*CF**2 * (  - 8*s**(-1)*u1*mst12 - 8*
     +    mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(38)*N**2*CF * (  - 8*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(39)*N*CF**2 * ( 16*s**(-1)*t1*u1**(-1)*
     +    mst12 + 8*s**(-1)*t1 + 16*s**(-1)*t1**2*u1**(-1) - 32*
     +    u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(39)*N**2*CF * (  - 4*s**(-1)*t1*u1**(-1)*
     +    mst12 - 4*s**(-1)*t1 - 4*s**(-1)*t1**2*u1**(-1) - 4*s**(-1)*
     +    mst12 + 8*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(44)*N*CF**2 * ( 24 + 32*s**(-1)*t1 + 16*
     +    s**(-1)*u1 + 32*s**(-1)*mst12 + 8*s*u1**(-1) + 16*t1*u1**(-1)
     +     + 16*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(44)*N**2*CF * (  - 12 - 16*s**(-1)*t1 - 8*
     +    s**(-1)*u1 - 16*s**(-1)*mst12 - 4*s*u1**(-1) - 8*t1*u1**(-1)
     +     - 8*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(48)*N*CF**2 * ( 64*s*t1*u1**(-1) + 16*s*
     +    u1**(-1)*mst12 + 32*s + 16*s**2*u1**(-1) + 16*t1*u1**(-1)*
     +    mst12 - 16*t1*(s+u1)**(-1)*mst12 + 48*t1 + 80*t1**2*u1**(-1)
     +     - 16*t1**2*(s+u1)**(-1) + 32*t1**3*u1**(-1)*(s+u1)**(-1) + 
     +    16*u1 )
     +
      M2GBH1 = M2GBH1 + ANG4(48)*N**2*CF * (  - 12*s**(-1)*t1*u1 - 16*
     +    s**(-1)*t1**2 - 8*s**(-1)*t1**3*u1**(-1) - 4*s**(-1)*u1**2 - 
     +    32*s*t1*u1**(-1) - 8*s*u1**(-1)*mst12 - 20*s - 8*s**2*
     +    u1**(-1) - 8*t1*u1**(-1)*mst12 + 4*t1*(s+u1)**(-1)*mst12 - 40
     +    *t1 - 40*t1**2*u1**(-1) + 4*t1**2*(s+u1)**(-1) - 8*t1**3*
     +    u1**(-1)*(s+u1)**(-1) - 16*u1 - 4*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(51)*N**2*CF * (  - 16*s**2*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(52)*N**2*CF * (  - 16*s*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(53)*N**2*CF * (  - 32*s*t1*u1**(-1)*mst12
     +     - 16*s**2*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(54)*N*CF**2 * (  - 64*s*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(54)*N**2*CF * ( 16*s**(-1)*t1*u1 + 24*
     +    s**(-1)*t1**2 + 16*s**(-1)*t1**3*u1**(-1) + 4*s**(-1)*u1**2
     +     - 16*s*t1*u1**(-2)*mst12 + 8*s*t1*u1**(-1) + 4*s - 16*t1*
     +    u1**(-1)*mst12 + 24*t1 + 24*t1**2*u1**(-1) + 8*u1 - 8*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(56)*N*CF**2 * ( 8*s*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(58)*N*CF**2 * ( 16*s**(-1)*t1*u1 + 16*
     +    s**(-1)*t1**2 + 8*s**(-1)*u1**2 + 16*t1*u1**(-1)*mst12 - 16*
     +    t1*(s+u1)**(-1)*mst12 - 8*t1 - 16*t1**2*u1**(-1) - 16*t1**2*
     +    (s+u1)**(-1) - 32*t1**3*u1**(-1)*(s+u1)**(-1) + 8*u1 - 16*
     +    mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(58)*N**2*CF * ( 4*s**(-1)*t1*u1 + 8*
     +    s**(-1)*t1**2 + 8*s**(-1)*t1**3*u1**(-1) - 8*t1*u1**(-1)*
     +    mst12 + 4*t1*(s+u1)**(-1)*mst12 + 8*t1 + 8*t1**2*u1**(-1) + 4
     +    *t1**2*(s+u1)**(-1) + 8*t1**3*u1**(-1)*(s+u1)**(-1) )
     +
      M2GBH1 = M2GBH1 + ANG4(59)*N*CF**2 * (  - 16*t1**2*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(60)*N*CF**2 * (  - 16*t1*mst12 - 16*
     +    mst12**2 )
     +
      M2GBH1 = M2GBH1 + ANG4(61)*N*CF**2 * (  - 32*s*t1*u1**(-1)*mst12
     +     - 32*t1**2*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(61)*N**2*CF * ( 16*t1**2*u1**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(62)*N*CF**2 * ( 16*s**(-1)*t1*mst12 - 16*
     +    s**(-1)*t1**2 - 32*s**(-1)*t1**3*u1**(-1) + 16*s*t1*u1**(-1)
     +     - 16*s*u1**(-1)*mst12 + 32*t1*u1**(-1)*mst12 - 16*t1*
     +    (s+u1)**(-1)*mst12 + 8*t1 + 16*t1**2*u1**(-1) - 16*t1**2*
     +    (s+u1)**(-1) + 32*t1**3*u1**(-1)*(s+u1)**(-1) - 32*u1**(-1)*
     +    mst12**2 - 16*mst12 )
     +
      M2GBH1 = M2GBH1 + ANG4(62)*N**2*CF * (  - 8*s**(-1)*t1*mst12 + 8*
     +    s**(-1)*t1**2 + 16*s**(-1)*t1**3*u1**(-1) - 16*s*t1*u1**(-2)*
     +    mst12 - 16*t1*u1**(-1)*mst12 + 4*t1*(s+u1)**(-1)*mst12 + 8*
     +    t1**2*u1**(-1) + 4*t1**2*(s+u1)**(-1) - 8*t1**3*u1**(-1)*
     +    (s+u1)**(-1) + 16*u1**(-1)*mst12**2 )
     +
      M2GBH1 = M2GBH1 + ANG4(70)*N*CF**2 * (  - 32*s*t1*u1**(-2)*mst12
     +     - 16*s**2*u1**(-2)*mst12 - 16*t1**2*u1**(-2)*mst12 )
     +
      M2GBH1 = M2GBH1 + COLO1(9)*N*(s4+mst12)*CF**2 * ( 16*s**(-2)*
     +    t1**(-1)*u1**2*s4**(-1) + 32*s**(-2)*t1*s4**(-1) + 32*s**(-2)
     +    *u1*s4**(-1) - 16*s**(-1)*t1**(-2)*u1*s4**(-1)*mst12 + 16*
     +    s**(-1)*t1**(-1)*u1*s4**(-1) - 32*s**(-1)*t1**(-1)*s4**(-1)*
     +    mst12 + 64*s**(-1)*t1*u1**(-1)*s4**(-2)*mst12 - 96*s**(-1)*t1
     +    *u1**(-1)*s4**(-1) - 64*s**(-1)*t1*s4**(-2)*(s+u1)**(-1)*
     +    mst12 + 192*s**(-1)*t1*s4**(-2) - 64*s**(-1)*t1*s4**(-1)*
     +    (s+u1)**(-1) - 64*s**(-1)*t1**2*u1**(-2)*s4**(-1) + 320*
     +    s**(-1)*t1**2*u1**(-1)*s4**(-2) - 64*s**(-1)*t1**2*u1**(-1)*
     +    s4**(-1)*(s+u1)**(-1) - 64*s**(-1)*t1**2*s4**(-2)*
     +    (s+u1)**(-1) + 128*s**(-1)*t1**3*u1**(-1)*s4**(-2)*
     +    (s+u1)**(-1) + 32*s**(-1)*u1**(-1)*s4**(-1)*mst12 + 64*
     +    s**(-1)*u1*s4**(-2) - 64*s**(-1)*s4**(-1)*(s+u1)**(-1)*mst12
     +     - 64*s**(-1)*s4**(-1) + 32*s*t1**(-2)*u1**(-2)*s4**(-1)*
     +    mst12**2 - 128*s*t1**(-1)*u1**(-3)*mst12 + 64*s*t1**(-1)*
     +    u1**(-2)*s4**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + COLO1(9)*N*(s4+mst12)*CF**2 * ( 64*s*u1**(-3)*
     +    s4**(-1)*mst12 + 32*s*u1**(-2)*s4**(-1) + 64*s*u1**(-1)*
     +    s4**(-2) - 32*s*u1**(-1)*s4**(-1)*(s+u1)**(-1) + 192*s**2*
     +    t1**(-2)*u1**(-4)*mst12**2 - 128*s**2*t1**(-2)*u1**(-3)*
     +    s4**(-1)*mst12**2 - 128*s**2*t1**(-1)*u1**(-4)*s4**(-1)*
     +    mst12**2 + 64*s**2*t1**(-1)*u1**(-3)*s4**(-1)*mst12 - 128*
     +    s**3*t1**(-2)*u1**(-4)*s4**(-1)*mst12**2 - 16*t1**(-2)*
     +    s4**(-1)*mst12 - 32*t1**(-1)*u1**(-2)*s4**(-1)*mst12**2 - 32*
     +    t1**(-1)*u1**(-1)*s4**(-1)*mst12 + 32*t1*u1**(-2)*s4**(-1) + 
     +    256*t1*u1**(-1)*s4**(-2) - 96*t1*u1**(-1)*s4**(-1)*
     +    (s+u1)**(-1) + 64*t1**2*u1**(-2)*s4**(-1)*(s+u1)**(-1) + 32*
     +    u1**(-2)*s4**(-1)*(s+t1)**(-1)*mst12**2 + 64*u1**(-1)*
     +    s4**(-2)*mst12 + 32*u1**(-1)*s4**(-1)*(s+t1)**(-1)*mst12 - 96
     +    *u1**(-1)*s4**(-1)*(s+u1)**(-1)*mst12 + 128*s4**(-2) + 16*
     +    s4**(-1)*(s+t1)**(-1) - 32*s4**(-1)*(s+u1)**(-1) )
     +
      M2GBH1 = M2GBH1 + COLO1(9)*N**2*(s4+mst12)*CF * (  - 48*s**(-2)*
     +    t1*u1*s4**(-2) + 48*s**(-2)*t1*s4**(-1) + 64*s**(-2)*t1**2*
     +    u1**(-1)*s4**(-1) - 64*s**(-2)*t1**2*s4**(-2) + 32*s**(-2)*
     +    t1**3*u1**(-2)*s4**(-1) - 32*s**(-2)*t1**3*u1**(-1)*s4**(-2)
     +     + 16*s**(-2)*u1*s4**(-1) - 16*s**(-2)*u1**2*s4**(-2) - 128*
     +    s**(-1)*t1*u1**(-3)*mst12 + 64*s**(-1)*t1*u1**(-2)*s4**(-1)*
     +    mst12 - 32*s**(-1)*t1*u1**(-1)*s4**(-2)*mst12 + 88*s**(-1)*t1
     +    *u1**(-1)*s4**(-1) + 16*s**(-1)*t1*s4**(-2)*(s+u1)**(-1)*
     +    mst12 - 160*s**(-1)*t1*s4**(-2) + 24*s**(-1)*t1*s4**(-1)*
     +    (s+u1)**(-1) + 64*s**(-1)*t1**2*u1**(-3)*s4**(-1)*mst12 + 80*
     +    s**(-1)*t1**2*u1**(-2)*s4**(-1) - 160*s**(-1)*t1**2*u1**(-1)*
     +    s4**(-2) + 16*s**(-1)*t1**2*u1**(-1)*s4**(-1)*(s+u1)**(-1) + 
     +    16*s**(-1)*t1**2*s4**(-2)*(s+u1)**(-1) - 32*s**(-1)*t1**3*
     +    u1**(-1)*s4**(-2)*(s+u1)**(-1) - 40*s**(-1)*u1**(-1)*s4**(-1)
     +    *mst12 - 64*s**(-1)*u1*s4**(-2) - 16*s**(-1)*s4**(-2)*mst12
     +     + 24*s**(-1)*s4**(-1)*(s+u1)**(-1)*mst12 )
     +
      M2GBH1 = M2GBH1 + COLO1(9)*N**2*(s4+mst12)*CF * ( 48*s**(-1)*
     +    s4**(-1) + 64*s*t1**(-1)*u1**(-3)*s4**(-1)*mst12**2 + 64*s*
     +    u1**(-4)*s4**(-1)*mst12**2 - 64*s*u1**(-3)*s4**(-1)*mst12 - 
     +    32*s*u1**(-1)*s4**(-2) + 16*s*u1**(-1)*s4**(-1)*(s+u1)**(-1)
     +     + 64*s**2*t1**(-1)*u1**(-4)*s4**(-1)*mst12**2 + 32*t1**(-1)*
     +    u1**(-2)*s4**(-1)*mst12**2 + 32*t1*u1**(-2)*s4**(-1) - 128*t1
     +    *u1**(-1)*s4**(-2) + 40*t1*u1**(-1)*s4**(-1)*(s+u1)**(-1) - 
     +    16*t1**2*u1**(-2)*s4**(-1)*(s+u1)**(-1) + 64*u1**(-4)*
     +    mst12**2 - 64*u1**(-2)*s4**(-1)*mst12 - 32*u1**(-1)*s4**(-2)*
     +    mst12 + 40*u1**(-1)*s4**(-1)*(s+u1)**(-1)*mst12 + 16*u1**(-1)
     +    *s4**(-1) - 80*s4**(-2) + 16*s4**(-1)*(s+u1)**(-1) )


      DSTGBH = S4/(S4+MST12)/2.D0 *
     +     ALPHAS**3 * AVG * M2GBH1 /4.D0 /S**2 *CONV

      RETURN
      END


      REAL*8 FUNCTION DSTQG3(ALPHAS,S,T1,S4,MST1,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MST1**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,U1,S4,MST1,MG,MST12,SCA,N,CF,NS,CONV,AVG
      REAL*8 M2QG31

      N = 3.D0
      CF = (N**2 -1.D0)/2.D0/N
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)
      CONV = 389379660.D0

      MST12 = MST1**2
      U1 = S4 -S -T1

      M2QG31 = 0D0
      M2QG31 = M2QG31 + N*CF**2 * ( 32*s**(-2)*t1 + 16*s**(-2)*t1**2*
     +    u1**(-1) + 32*s**(-2)*u1 - 16*s**(-1)*t1*u1**(-2)*mst12 + 16*
     +    s**(-1)*t1*u1**(-1) - 32*s**(-1)*u1**(-1)*mst12 - 32*s**(-1)*
     +    u1*(s+t1)**(-1) - 32*s**(-1)*(s+t1)**(-1)*mst12 - 64*s*
     +    t1**(-3)*mst12 - 64*s*t1**(-2)*u1**(-1)*mst12 + 32*s*t1**(-2)
     +     - 32*s*t1**(-1)*u1**(-1)*(s+u1)**(-1)*mst12 + 64*s**2*
     +    t1**(-4)*u1**(-1)*mst12**2 + 64*s**2*t1**(-3)*u1**(-2)*
     +    mst12**2 - 64*s**2*t1**(-3)*u1**(-1)*mst12 + 32*s**2*t1**(-2)
     +    *u1**(-2)*(s+u1)**(-1)*mst12**2 + 64*s**3*t1**(-4)*u1**(-2)*
     +    mst12**2 + 32*t1**(-2)*u1 + 32*t1**(-1) - 16*u1**(-2)*mst12
     +     + 16*(s+u1)**(-1) )
     +
      M2QG31 = M2QG31 + N**2*CF * ( 32*s**(-2)*t1**(-2)*u1**3 + 32*
     +    s**(-2)*t1**(-1)*u1**2 + 16*s**(-2)*u1 - 64*s**(-1)*t1**(-3)*
     +    u1**2*mst12 - 64*s**(-1)*t1**(-2)*u1*mst12 + 64*s**(-1)*
     +    t1**(-2)*u1**2 + 32*s**(-1)*t1**(-1)*u1 - 32*s**(-1)*t1**(-1)
     +    *mst12 + 128*s*t1**(-4)*mst12**2 + 64*s*t1**(-3)*u1**(-1)*
     +    mst12**2 - 64*s*t1**(-3)*mst12 + 64*s**2*t1**(-4)*u1**(-1)*
     +    mst12**2 + 64*t1**(-4)*u1*mst12**2 - 128*t1**(-3)*u1*mst12 + 
     +    64*t1**(-3)*mst12**2 + 32*t1**(-2)*u1**(-1)*mst12**2 + 32*
     +    t1**(-2)*u1 - 64*t1**(-2)*mst12 )


      DSTQG3 = ALPHAS**3 * AVG *M2QG31 *LOG(1.D0/SCA)/8.D0/S**2  *CONV
      RETURN
      END


      REAL*8 FUNCTION DSTQGH(ALPHAS,S,T1,S4,MST1,MG)
C***  CROSS SECTIONS FOR G + Q -> ST + STB +Q
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,T1,U1,MST1,MST12,MG
      REAL*8 NS,CONV,N,CF,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1P2, A4P1P1
      REAL*8 A4M1P2, A4P0P2, A4P1P0, ABP2P2
      REAL*8 ABP2P1, ABP2P0
      REAL*8 M2QGH1
      REAL*8 ANG4(1:84), COLO1(1:9)
           
      CONV = 389379660.D0
      NS = 6.D0

      N = 3.D0
      CF = (N**2 -1.D0)/N/2.D0

      AVG = (1.D0/2.D0)**2 /N /(N**2 -1.D0)

      MST12 = MST1**2
      U1 = S4 -S -T1

      ANGDEF(1) = 2.D0*SQRT(S4 +MST12)
      ANGDEF(2) = (S +U1)/ANGDEF(1)
      ANGDEF(3) = (S +T1)/ANGDEF(1)
      ANGDEF(4) = S4/ANGDEF(1)
      ANGDEF(5) = (S4 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(6) = -(T1 +U1 +2.D0*MST12)/ANGDEF(1)
      ANGDEF(7) = SQRT((T1 +U1)**2 -4.D0*MST12*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (T1*S4 -S*(U1+2.D0*MST12))/(S+T1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (U1*S4 -S*(T1+2.D0*MST12))/(S+U1)/SQRT((T1+U1)**2-4.D0*MST12*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)

      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MST12
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)


       ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
       ANG4(18) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,2),ANB(1,2),ANC(1,2))
       ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
       ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))
       ANG4(41) =A4P1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
       ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
       ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
       ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
       ANG4(55) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
       ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
       ANG4(57) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
       ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))

       ANG4(64) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
       ANG4(65) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
       ANG4(66) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
       ANG4(67) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))

       ANG4(71) =ABP2P0(ANA(3,4),ANB(3,4),ANA(1,1),ANB(1,1),ANC(1,1))

      COLO1(9) = LOG(S4**2/MST12/(S4+MST12))

      M2QGH1 = 0D0
      M2QGH1 = M2QGH1 + N*CF**2 * (  - 32*s**(-2)*t1*s4**(-1)*
     +    (s4+mst12) - 32*s**(-2)*u1*s4**(-1)*(s4+mst12) - 64*s**(-1)*
     +    t1**(-2)*u1**2*s4**(-1)*(s4+mst12) + 64*s**(-1)*t1**(-1)*u1*
     +    s4**(-2)*mst1**2*(s4+mst12) - 96*s**(-1)*t1**(-1)*u1*s4**(-1)
     +    *(s4+mst12) + 320*s**(-1)*t1**(-1)*u1**2*s4**(-2)*(s4+mst12)
     +     - 64*s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+t1)**(-1)*(s4+mst12)
     +     + 128*s**(-1)*t1**(-1)*u1**3*s4**(-2)*(s+t1)**(-1)*
     +    (s4+mst12) + 32*s**(-1)*t1**(-1)*s4**(-1)*mst1**2*(s4+mst12)
     +     + 32*s**(-1)*u1**(-1)*s4**(-1)*mst1**2*(s4+mst12) - 64*
     +    s**(-1)*u1*s4**(-2)*(s+t1)**(-1)*mst1**2*(s4+mst12) + 128*
     +    s**(-1)*u1*s4**(-2)*(s4+mst12) - 64*s**(-1)*u1**2*s4**(-2)*
     +    (s+t1)**(-1)*(s4+mst12) + 128*s*t1**(-3)*u1**(-1)*mst1**2*
     +    (s4+mst12) - 192*s*t1**(-3)*s4**(-1)*mst1**2*(s4+mst12) - 32*
     +    s*t1**(-2)*u1**(-2)*s4**(-1)*mst1**4*(s4+mst12) - 192*s*
     +    t1**(-2)*u1**(-1)*s4**(-1)*mst1**2*(s4+mst12) - 64*s*t1**(-1)
     +    *u1**(-1)*s4**(-1)*(s+u1)**(-1)*mst1**2*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + N*CF**2 * ( 64*s*t1**(-1)*s4**(-2)*(s4+mst12)
     +     - 32*s*t1**(-1)*s4**(-1)*(s+t1)**(-1)*(s4+mst12) - 192*s**2*
     +    t1**(-4)*u1**(-2)*mst1**4*(s4+mst12) + 256*s**2*t1**(-4)*
     +    u1**(-1)*s4**(-1)*mst1**4*(s4+mst12) + 256*s**2*t1**(-3)*
     +    u1**(-2)*s4**(-1)*mst1**4*(s4+mst12) - 192*s**2*t1**(-3)*
     +    u1**(-1)*s4**(-1)*mst1**2*(s4+mst12) + 64*s**2*t1**(-2)*
     +    u1**(-2)*s4**(-1)*(s+u1)**(-1)*mst1**4*(s4+mst12) + 256*s**3*
     +    t1**(-4)*u1**(-2)*s4**(-1)*mst1**4*(s4+mst12) + 32*t1**(-2)*
     +    u1**(-1)*s4**(-1)*mst1**4*(s4+mst12) + 64*t1**(-2)*u1**2*
     +    s4**(-1)*(s+t1)**(-1)*(s4+mst12) - 32*t1**(-2)*s4**(-1)*
     +    (s+u1)**(-1)*mst1**4*(s4+mst12) + 32*t1**(-1)*u1**(-1)*
     +    s4**(-1)*mst1**2*(s4+mst12) + 256*t1**(-1)*u1*s4**(-2)*
     +    (s4+mst12) - 96*t1**(-1)*u1*s4**(-1)*(s+t1)**(-1)*(s4+mst12)
     +     + 64*t1**(-1)*s4**(-2)*mst1**2*(s4+mst12) - 96*t1**(-1)*
     +    s4**(-1)*(s+t1)**(-1)*mst1**2*(s4+mst12) - 32*t1**(-1)*
     +    s4**(-1)*(s+u1)**(-1)*mst1**2*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + N*CF**2 * (  - 32*t1**(-1)*s4**(-1)*(s4+mst12)
     +     + 64*s4**(-2)*(s4+mst12) - 32*s4**(-1)*(s+t1)**(-1)*
     +    (s4+mst12) + 16*s4**(-1)*(s+u1)**(-1)*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + N**2*CF * (  - 32*s**(-2)*t1**(-1)*u1**2*
     +    s4**(-1)*(s4+mst12) + 32*s**(-2)*t1**(-1)*u1**3*s4**(-2)*
     +    (s4+mst12) + 32*s**(-2)*t1*u1*s4**(-2)*(s4+mst12) - 16*
     +    s**(-2)*u1*s4**(-1)*(s4+mst12) + 64*s**(-2)*u1**2*s4**(-2)*
     +    (s4+mst12) + 128*s**(-1)*t1**(-3)*u1*mst1**2*(s4+mst12) - 192
     +    *s**(-1)*t1**(-3)*u1**2*s4**(-1)*mst1**2*(s4+mst12) - 192*
     +    s**(-1)*t1**(-2)*u1*s4**(-1)*mst1**2*(s4+mst12) + 32*s**(-1)*
     +    t1**(-2)*u1**2*s4**(-1)*(s4+mst12) - 16*s**(-1)*t1**(-1)*u1*
     +    s4**(-2)*mst1**2*(s4+mst12) + 16*s**(-1)*t1**(-1)*u1*s4**(-1)
     +    *(s4+mst12) - 80*s**(-1)*t1**(-1)*u1**2*s4**(-2)*(s4+mst12)
     +     + 32*s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+t1)**(-1)*(s4+mst12)
     +     - 64*s**(-1)*t1**(-1)*u1**3*s4**(-2)*(s+t1)**(-1)*(s4+mst12)
     +     - 48*s**(-1)*t1**(-1)*s4**(-1)*mst1**2*(s4+mst12) + 16*
     +    s**(-1)*t1*s4**(-2)*(s4+mst12) + 32*s**(-1)*u1*s4**(-2)*
     +    (s+t1)**(-1)*mst1**2*(s4+mst12) + 32*s**(-1)*u1*s4**(-2)*
     +    (s4+mst12) )
     +
      M2QGH1 = M2QGH1 + N**2*CF * ( 32*s**(-1)*u1**2*s4**(-2)*
     +    (s+t1)**(-1)*(s4+mst12) + 16*s**(-1)*s4**(-2)*mst1**2*
     +    (s4+mst12) - 16*s**(-1)*s4**(-1)*(s4+mst12) + 192*s*t1**(-4)*
     +    s4**(-1)*mst1**4*(s4+mst12) + 64*s*t1**(-3)*u1**(-1)*s4**(-1)
     +    *mst1**4*(s4+mst12) - 64*s*t1**(-3)*s4**(-1)*mst1**2*
     +    (s4+mst12) - 16*s*t1**(-1)*s4**(-2)*(s4+mst12) + 8*s*t1**(-1)
     +    *s4**(-1)*(s+t1)**(-1)*(s4+mst12) + 64*s**2*t1**(-4)*u1**(-1)
     +    *s4**(-1)*mst1**4*(s4+mst12) + 128*t1**(-4)*u1*s4**(-1)*
     +    mst1**4*(s4+mst12) - 64*t1**(-4)*mst1**4*(s4+mst12) - 256*
     +    t1**(-3)*u1*s4**(-1)*mst1**2*(s4+mst12) + 128*t1**(-3)*
     +    s4**(-1)*mst1**4*(s4+mst12) + 32*t1**(-2)*u1**(-1)*s4**(-1)*
     +    mst1**4*(s4+mst12) - 32*t1**(-2)*u1**2*s4**(-1)*(s+t1)**(-1)*
     +    (s4+mst12) - 64*t1**(-2)*s4**(-1)*mst1**2*(s4+mst12) - 64*
     +    t1**(-1)*u1*s4**(-2)*(s4+mst12) + 32*t1**(-1)*u1*s4**(-1)*
     +    (s+t1)**(-1)*(s4+mst12) - 16*t1**(-1)*s4**(-2)*mst1**2*
     +    (s4+mst12) )
     +
      M2QGH1 = M2QGH1 + N**2*CF * ( 32*t1**(-1)*s4**(-1)*(s+t1)**(-1)*
     +    mst1**2*(s4+mst12) + 8*t1**(-1)*s4**(-1)*(s4+mst12) + 8*
     +    s4**(-1)*(s+t1)**(-1)*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + ANG4(14)*N*CF**2 * ( 8*s**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(18)*N*CF**2 * (  - 32*s**(-1)*t1**(-1)*
     +    u1**3 - 64*s**(-1)*t1*u1 - 16*s**(-1)*t1*mst1**2 - 16*s**(-1)
     +    *t1**2 - 16*s**(-1)*u1*mst1**2 - 80*s**(-1)*u1**2 + 64*
     +    t1**(-1)*u1*mst1**2 + 32*t1**(-1)*u1**3*(s+t1)**(-1) - 16*t1
     +     + 16*u1*(s+t1)**(-1)*mst1**2 - 32*u1 + 16*u1**2*(s+t1)**(-1)
     +     + 32*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(18)*N**2*CF * ( 8*s**(-1)*t1**(-1)*u1**3
     +     + 16*s**(-1)*t1*u1 + 4*s**(-1)*t1*mst1**2 + 4*s**(-1)*t1**2
     +     + 4*s**(-1)*u1*mst1**2 + 20*s**(-1)*u1**2 + 16*s*t1**(-2)*u1
     +    *mst1**2 - 8*s*t1**(-1)*u1 + 8*s*t1**(-1)*mst1**2 - 4*s - 16*
     +    t1**(-1)*u1*mst1**2 - 16*t1**(-1)*u1**2 - 16*t1**(-1)*u1**3*
     +    (s+t1)**(-1) - 8*u1*(s+t1)**(-1)*mst1**2 - 8*u1 - 8*u1**2*
     +    (s+t1)**(-1) - 12*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(38)*N*CF**2 * ( 8*s**(-1)*u1*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(38)*N**2*CF * (  - 8*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(39)*N*CF**2 * (  - 16*s**(-1)*t1**(-1)*u1*
     +    mst1**2 - 16*s**(-1)*t1**(-1)*u1**2 - 24*s**(-1)*u1 - 24*
     +    s**(-1)*mst1**2 + 32*t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(39)*N**2*CF * ( 8*s**(-1)*t1**(-1)*u1*
     +    mst1**2 + 8*s**(-1)*t1**(-1)*u1**2 + 8*s**(-1)*u1 + 8*s**(-1)
     +    *mst1**2 - 16*t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(41)*N*CF**2 * (  - 8 - 16*s**(-1)*t1 - 32*
     +    s**(-1)*u1 - 32*s**(-1)*mst1**2 + 8*s*t1**(-1) + 16*t1**(-1)*
     +    u1 + 16*t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(41)*N**2*CF * ( 4*s**(-1)*t1 + 8*s**(-1)*
     +    u1 + 8*s**(-1)*mst1**2 - 4*s*t1**(-1) - 8*t1**(-1)*u1 - 8*
     +    t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(48)*N*CF**2 * (  - 64*s*t1**(-1)*u1 - 16*s
     +    *t1**(-1)*mst1**2 - 32*s - 16*s**2*t1**(-1) - 16*t1**(-1)*u1*
     +    mst1**2 - 80*t1**(-1)*u1**2 - 32*t1**(-1)*u1**3*(s+t1)**(-1)
     +     - 16*t1 + 16*u1*(s+t1)**(-1)*mst1**2 - 48*u1 + 16*u1**2*
     +    (s+t1)**(-1) )
     +
      M2QGH1 = M2QGH1 + ANG4(48)*N**2*CF * (  - 8*s**(-1)*t1**(-1)*
     +    u1**3 - 12*s**(-1)*t1*u1 - 4*s**(-1)*t1**2 - 16*s**(-1)*u1**2
     +     + 16*s*t1**(-1)*u1 + 4*s*t1**(-1)*mst1**2 + 4*s + 4*s**2*
     +    t1**(-1) + 4*t1**(-1)*u1*mst1**2 + 20*t1**(-1)*u1**2 + 16*
     +    t1**(-1)*u1**3*(s+t1)**(-1) - 4*t1 - 8*u1*(s+t1)**(-1)*
     +    mst1**2 - 4*u1 - 8*u1**2*(s+t1)**(-1) - 4*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(52)*N*CF**2 * ( 8*s*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(54)*N*CF**2 * ( 16*s**(-1)*t1*u1 + 8*
     +    s**(-1)*t1**2 + 16*s**(-1)*u1**2 - 16*t1**(-1)*u1*mst1**2 + 
     +    16*t1**(-1)*u1**2 + 32*t1**(-1)*u1**3*(s+t1)**(-1) + 8*t1 + 
     +    16*u1*(s+t1)**(-1)*mst1**2 + 24*u1 + 16*u1**2*(s+t1)**(-1) - 
     +    16*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(54)*N**2*CF * ( 8*s**(-1)*t1**(-1)*u1**3
     +     + 4*s**(-1)*t1*u1 + 8*s**(-1)*u1**2 + 4*t1**(-1)*u1*mst1**2
     +     - 4*t1**(-1)*u1**2 - 16*t1**(-1)*u1**3*(s+t1)**(-1) - 8*u1*
     +    (s+t1)**(-1)*mst1**2 - 4*u1 - 8*u1**2*(s+t1)**(-1) )
     +
      M2QGH1 = M2QGH1 + ANG4(55)*N**2*CF * (  - 16*s**2*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(56)*N**2*CF * (  - 16*s*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(57)*N**2*CF * (  - 32*s*t1**(-1)*u1*
     +    mst1**2 - 16*s**2*t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(58)*N*CF**2 * ( 64*s*t1**(-1)*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(58)*N**2*CF * ( 16*s**(-1)*t1**(-1)*u1**3
     +     + 16*s**(-1)*t1*u1 + 4*s**(-1)*t1**2 + 24*s**(-1)*u1**2 - 16
     +    *s*t1**(-2)*u1*mst1**2 + 8*s*t1**(-1)*u1 - 48*s*t1**(-1)*
     +    mst1**2 + 4*s - 16*t1**(-1)*u1*mst1**2 + 24*t1**(-1)*u1**2 + 
     +    8*t1 + 24*u1 - 8*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(64)*N*CF**2 * (  - 16*u1**2*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(65)*N*CF**2 * (  - 16*u1*mst1**2 - 16*
     +    mst1**4 )
     +
      M2QGH1 = M2QGH1 + ANG4(66)*N*CF**2 * (  - 32*s*t1**(-1)*u1*
     +    mst1**2 - 32*t1**(-1)*u1**2*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(66)*N**2*CF * ( 16*t1**(-1)*u1**2*mst1**2
     +     )
     +
      M2QGH1 = M2QGH1 + ANG4(67)*N*CF**2 * ( 32*s**(-1)*t1**(-1)*u1**3
     +     - 16*s**(-1)*u1*mst1**2 + 16*s**(-1)*u1**2 + 16*s*t1**(-1)*
     +    u1 - 16*s*t1**(-1)*mst1**2 - 96*t1**(-1)*u1*mst1**2 + 16*
     +    t1**(-1)*u1**2 - 32*t1**(-1)*u1**3*(s+t1)**(-1) - 32*t1**(-1)
     +    *mst1**4 + 16*u1*(s+t1)**(-1)*mst1**2 + 8*u1 + 16*u1**2*
     +    (s+t1)**(-1) - 16*mst1**2 )
     +
      M2QGH1 = M2QGH1 + ANG4(67)*N**2*CF * (  - 8*s**(-1)*t1**(-1)*
     +    u1**3 + 4*s**(-1)*u1*mst1**2 - 4*s**(-1)*u1**2 - 16*s*
     +    t1**(-2)*u1*mst1**2 + 32*t1**(-1)*u1*mst1**2 + 8*t1**(-1)*
     +    u1**2 + 16*t1**(-1)*u1**3*(s+t1)**(-1) + 16*t1**(-1)*mst1**4
     +     - 8*u1*(s+t1)**(-1)*mst1**2 - 8*u1**2*(s+t1)**(-1) )
     +
      M2QGH1 = M2QGH1 + ANG4(71)*N*CF**2 * (  - 32*s*t1**(-2)*u1*
     +    mst1**2 - 16*s**2*t1**(-2)*mst1**2 - 16*t1**(-2)*u1**2*
     +    mst1**2 )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N*CF**2 * ( 32*s**(-2)*t1*s4**(-1)*
     +    (s4+mst12) + 16*s**(-2)*t1**2*u1**(-1)*s4**(-1)*(s4+mst12) + 
     +    32*s**(-2)*u1*s4**(-1)*(s4+mst12) + 64*s**(-1)*t1**(-2)*u1**2
     +    *s4**(-1)*(s4+mst12) - 64*s**(-1)*t1**(-1)*u1*s4**(-2)*
     +    mst1**2*(s4+mst12) + 96*s**(-1)*t1**(-1)*u1*s4**(-1)*
     +    (s4+mst12) - 320*s**(-1)*t1**(-1)*u1**2*s4**(-2)*(s4+mst12)
     +     + 64*s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+t1)**(-1)*(s4+mst12)
     +     - 128*s**(-1)*t1**(-1)*u1**3*s4**(-2)*(s+t1)**(-1)*
     +    (s4+mst12) - 32*s**(-1)*t1**(-1)*s4**(-1)*mst1**2*(s4+mst12)
     +     - 16*s**(-1)*t1*u1**(-2)*s4**(-1)*mst1**2*(s4+mst12) + 16*
     +    s**(-1)*t1*u1**(-1)*s4**(-1)*(s4+mst12) - 64*s**(-1)*t1*
     +    s4**(-2)*(s4+mst12) - 32*s**(-1)*u1**(-1)*s4**(-1)*mst1**2*
     +    (s4+mst12) + 64*s**(-1)*u1*s4**(-2)*(s+t1)**(-1)*mst1**2*
     +    (s4+mst12) - 192*s**(-1)*u1*s4**(-2)*(s4+mst12) + 64*s**(-1)*
     +    u1**2*s4**(-2)*(s+t1)**(-1)*(s4+mst12) + 64*s**(-1)*s4**(-1)*
     +    (s4+mst12) )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N*CF**2 * (  - 128*s*t1**(-3)*u1**(-1)
     +    *mst1**2*(s4+mst12) + 64*s*t1**(-3)*s4**(-1)*mst1**2*
     +    (s4+mst12) + 32*s*t1**(-2)*u1**(-2)*s4**(-1)*mst1**4*
     +    (s4+mst12) + 64*s*t1**(-2)*u1**(-1)*s4**(-1)*mst1**2*
     +    (s4+mst12) + 32*s*t1**(-2)*s4**(-1)*(s4+mst12) - 64*s*
     +    t1**(-1)*s4**(-2)*(s4+mst12) + 32*s*t1**(-1)*s4**(-1)*
     +    (s+t1)**(-1)*(s4+mst12) + 192*s**2*t1**(-4)*u1**(-2)*mst1**4*
     +    (s4+mst12) - 128*s**2*t1**(-4)*u1**(-1)*s4**(-1)*mst1**4*
     +    (s4+mst12) - 128*s**2*t1**(-3)*u1**(-2)*s4**(-1)*mst1**4*
     +    (s4+mst12) + 64*s**2*t1**(-3)*u1**(-1)*s4**(-1)*mst1**2*
     +    (s4+mst12) - 128*s**3*t1**(-4)*u1**(-2)*s4**(-1)*mst1**4*
     +    (s4+mst12) - 32*t1**(-2)*u1**(-1)*s4**(-1)*mst1**4*(s4+mst12)
     +     + 32*t1**(-2)*u1*s4**(-1)*(s4+mst12) - 64*t1**(-2)*u1**2*
     +    s4**(-1)*(s+t1)**(-1)*(s4+mst12) + 32*t1**(-2)*s4**(-1)*
     +    (s+u1)**(-1)*mst1**4*(s4+mst12) - 32*t1**(-1)*u1**(-1)*
     +    s4**(-1)*mst1**2*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N*CF**2 * (  - 256*t1**(-1)*u1*
     +    s4**(-2)*(s4+mst12) + 96*t1**(-1)*u1*s4**(-1)*(s+t1)**(-1)*
     +    (s4+mst12) - 64*t1**(-1)*s4**(-2)*mst1**2*(s4+mst12) + 96*
     +    t1**(-1)*s4**(-1)*(s+t1)**(-1)*mst1**2*(s4+mst12) + 32*
     +    t1**(-1)*s4**(-1)*(s+u1)**(-1)*mst1**2*(s4+mst12) + 64*
     +    t1**(-1)*s4**(-1)*(s4+mst12) - 16*u1**(-2)*s4**(-1)*mst1**2*
     +    (s4+mst12) - 128*s4**(-2)*(s4+mst12) + 32*s4**(-1)*
     +    (s+t1)**(-1)*(s4+mst12) + 16*s4**(-1)*(s+u1)**(-1)*(s4+mst12)
     +     )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N**2*CF * ( 32*s**(-2)*t1**(-2)*u1**3*
     +    s4**(-1)*(s4+mst12) + 64*s**(-2)*t1**(-1)*u1**2*s4**(-1)*
     +    (s4+mst12) - 32*s**(-2)*t1**(-1)*u1**3*s4**(-2)*(s4+mst12) - 
     +    48*s**(-2)*t1*u1*s4**(-2)*(s4+mst12) + 16*s**(-2)*t1*s4**(-1)
     +    *(s4+mst12) - 16*s**(-2)*t1**2*s4**(-2)*(s4+mst12) + 48*
     +    s**(-2)*u1*s4**(-1)*(s4+mst12) - 64*s**(-2)*u1**2*s4**(-2)*
     +    (s4+mst12) - 128*s**(-1)*t1**(-3)*u1*mst1**2*(s4+mst12) + 64*
     +    s**(-1)*t1**(-3)*u1**2*s4**(-1)*mst1**2*(s4+mst12) + 64*
     +    s**(-1)*t1**(-2)*u1*s4**(-1)*mst1**2*(s4+mst12) + 32*s**(-1)*
     +    t1**(-2)*u1**2*s4**(-1)*(s4+mst12) + 16*s**(-1)*t1**(-1)*u1*
     +    s4**(-2)*mst1**2*(s4+mst12) + 16*s**(-1)*t1**(-1)*u1*s4**(-1)
     +    *(s4+mst12) + 80*s**(-1)*t1**(-1)*u1**2*s4**(-2)*(s4+mst12)
     +     - 32*s**(-1)*t1**(-1)*u1**2*s4**(-1)*(s+t1)**(-1)*(s4+mst12)
     +     + 64*s**(-1)*t1**(-1)*u1**3*s4**(-2)*(s+t1)**(-1)*(s4+mst12)
     +     - 16*s**(-1)*t1**(-1)*s4**(-1)*mst1**2*(s4+mst12) - 16*
     +    s**(-1)*t1*s4**(-2)*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N**2*CF * (  - 32*s**(-1)*u1*s4**(-2)*
     +    (s+t1)**(-1)*mst1**2*(s4+mst12) - 16*s**(-1)*u1*s4**(-2)*
     +    (s4+mst12) - 32*s**(-1)*u1**2*s4**(-2)*(s+t1)**(-1)*
     +    (s4+mst12) - 16*s**(-1)*s4**(-2)*mst1**2*(s4+mst12) + 64*s*
     +    t1**(-4)*s4**(-1)*mst1**4*(s4+mst12) + 64*s*t1**(-3)*u1**(-1)
     +    *s4**(-1)*mst1**4*(s4+mst12) - 64*s*t1**(-3)*s4**(-1)*mst1**2
     +    *(s4+mst12) + 16*s*t1**(-1)*s4**(-2)*(s4+mst12) - 8*s*
     +    t1**(-1)*s4**(-1)*(s+t1)**(-1)*(s4+mst12) + 64*s**2*t1**(-4)*
     +    u1**(-1)*s4**(-1)*mst1**4*(s4+mst12) + 64*t1**(-4)*mst1**4*
     +    (s4+mst12) + 32*t1**(-2)*u1**(-1)*s4**(-1)*mst1**4*(s4+mst12)
     +     + 32*t1**(-2)*u1*s4**(-1)*(s4+mst12) + 32*t1**(-2)*u1**2*
     +    s4**(-1)*(s+t1)**(-1)*(s4+mst12) - 64*t1**(-2)*s4**(-1)*
     +    mst1**2*(s4+mst12) + 64*t1**(-1)*u1*s4**(-2)*(s4+mst12) - 32*
     +    t1**(-1)*u1*s4**(-1)*(s+t1)**(-1)*(s4+mst12) + 16*t1**(-1)*
     +    s4**(-2)*mst1**2*(s4+mst12) - 32*t1**(-1)*s4**(-1)*
     +    (s+t1)**(-1)*mst1**2*(s4+mst12) )
     +
      M2QGH1 = M2QGH1 + COLO1(9)*N**2*CF * (  - 8*t1**(-1)*s4**(-1)*
     +    (s4+mst12) + 16*s4**(-2)*(s4+mst12) - 8*s4**(-1)*(s+t1)**(-1)
     +    *(s4+mst12) )


      DSTQGH = S4/(S4+MST12)/2.D0 *
     +     ALPHAS**3 * AVG * M2QGH1 /4.D0 /S**2 *CONV

      RETURN
      END












